align 10h
DebugLoop:
	push	rbx rbp rsi rdi r12 r13 r14 r15 0	; 0 is counter for number of processes
a	=	9			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.DEBUG_EVENT64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	(a+b+d+1) and 1		; align stack 16
	sub	rsp,8*(b+d+e)

	pxor	xmm0,xmm0
	movdqa	dqword [Code_listview_dump_start_address],xmm0	; clear both addresses for code 1st , code 2nd
	movdqa	dqword [Data_listview_dump_start_address],xmm0	; clear both addresses for data 1st , code 2nd
	movdqa	dqword [Stack_listview_dump_start_address-8],xmm0; clear both addresses for data 3rd , stack
	movdqa	dqword [addr_write_bp_after_first_step],xmm0	; clear addr of BP, PID, run flag

;s=(MaxLinesInSysListView32+7) / 8
;t=MaxLinesInSysListView32 and 8
;if num_of_LV_supporting_proc_List_KEYDOWN=6
;rept 3 n:0 { movdqa dqword [ListView_selected_iItem + 8*#n],xmm0 }
;else
;You have to rewrite code here
;end if
;if t<>0
;You have to rewrite code here
;end if
;if s>8
;You have to rewrite code here
;end if
	lea	rdi,[ListView_selected_iItem]
	mov	ecx,num_of_LV_supporting_proc_List_KEYDOWN
	mov	eax,1			; iItem=0 selected (bit 0. of qword is set=1)
	cld
	repz stosq

	lea	rdi,[EditedListView_handle]
if INVALID_HANDLE_VALUE=-1
	or	rax,-1			; we can use neg rax now because rax=1
	stosq				; EditedListView_handle
	stosq				; ListView_Edit_handle
	stosq				; ListView_edit_last_item_and_subitem
	stosq				; ListView_edit_Listview_index
else
	mov	rax,INVALID_HANDLE_VALUE
	stosq
	stosq
	or	rax,-1
	stosq
	stosq
end if

	mov	byte [DbgThrdResumed],1
	call	update_menus_hang_suspend_changed

AMDPad16
DebugLoop_L0:

virtual at rsp+8*(b+d+e)
num_of_processes	dd	?
end virtual

virtual at rsp+8*4
dbg_event	DEBUG_EVENT64
end virtual

; dwMilliseconds, timeout = -1 = neverending
; Specifies the number of milliseconds to wait for a debugging event. If this parameter
; is zero, the function tests for a debugging event and returns immediately. If the parameter
; is INFINITE, the function does not return until a debugging event has occurred.
if INFINITE = 0FFFFFFFFh
	or	edx,INFINITE
else
	mov	edx,INFINITE
end if
	lea	rcx,[dbg_event]		; lpDebugEvent pointer to the DEBUG_EVENT structure
	call	[WaitForDebugEvent]
	or	eax,eax
; If the function succeeds, the return value is nonzero.
	jz	DebugLoop_finish

	mov	rax,qword [dbg_event.dwProcessId]	; get PID and TID
	mov	qword [last_PID_TID],rax
	mov	qword [hung_PID_TID],rax
;	mov	ecx,dword [dbg_event.dwThreadId]
;	mov	eax,dword [dbg_event.dwProcessId]
;	mov	dword [last_TID],ecx
;	mov	dword [last_PID],eax
;	mov	dword [hung_TID],ecx
;	mov	dword [hung_PID],eax

	call	update_menus_hang_suspend_changed
	mov	eax,[last_PID]
	mov	edx,[last_TID]
	call	update_status_window_PID_TID
	call	update_status_window_stopped

	mov	eax,[dbg_event.dwDebugEventCode]
	cmp	eax,number_of_DebugEvents
	jnc	DebugLoop_finish	; latest RIP_EVENT = 9, but we are counting from 0
					; so we have 10 events, event No. 0 is undefined
	lea	rcx,[DebugEvents_procedures]
	jmp	qword [rcx+rax*8]

align 16
ContinueDebug_DBG_CONTINUE:
	mov	r8d,DBG_CONTINUE
ContinueDebug_ContinueStatus:
	mov	edx,[dbg_event.dwThreadId]
	mov	ecx,[dbg_event.dwProcessId]
	call	[ContinueDebugEvent]
; After the ContinueDebugEvent function succeeds, the specified thread continues.
; Depending on the debugging event previously reported by the thread, different actions occur.
; If the continued thread previously reported an EXIT_THREAD_DEBUG_EVENT debugging event,
; ContinueDebugEvent closes the handle the debugger has to the thread. If the continued thread
; previously reported an EXIT_PROCESS_DEBUG_EVENT debugging event, ContinueDebugEvent closes
; the handles the debugger has to the process and to the thread.
	or	eax,eax
; If the function succeeds, the return value is nonzero.
	jz	DebugLoop_finish
	and	qword [hung_PID_TID],0

	call	update_menus_hang_suspend_changed
	mov	eax,[last_PID]
	mov	edx,[last_TID]
	call	update_status_window_PID_TID
	call	update_status_window_running

	cmp	[num_of_processes],0
	jnz	DebugLoop_L0

DebugLoop_finish:
	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed
	call	update_status_window_PID_TID_empty

DebugLoop_epilogue:
	add	rsp,8*(b+d+e+1)		; +1 because push 0 at prologue
	pop	r15 r14 r13 r12 rdi rsi rbp rbx
	ret

proc_EXCEPTION_DEBUG_EVENT:
LogExceptionLevel equ face.var_settings	; only bits 0,1,2 are for log level

;a = exception_TID - exception_PID
;if a <> 4
;Grab PID and TID in 1 instruction requires TID immediately follows PID, rearrange them !
;end if
	mov	rcx,qword [dbg_event.dwProcessId]	; grab dwProcessId and dwThreadId in 1 instruction
	mov	eax,dword [dbg_event.Exception.ExceptionRecord.ExceptionCode]
	mov	qword [exception_PID_TID],rcx		; store both PID and TID in 1 instruction
	lea	rdx,[dbg_event]
	cmp	eax,EXCEPTION_BREAKPOINT
	jz	proc_EXCEPTION_BREAKPOINT
	cmp	eax,EXCEPTION_SINGLE_STEP
	jz	proc_EXCEPTION_SINGLE_STEP
	call	try_rest_from_previous
	test	byte [LogExceptionLevel],log_no_exceptions
	jnz	proc_EXCEPTION_L0
	call	exception2log
proc_EXCEPTION_L0:

	mov	ecx,[dbg_event.dwThreadId]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	sbtlemb0
	call	branches_to_LogEdit_ms_backdoor
sbtlemb0:

	cmp	dword [dbg_event.Exception.dwFirstChance],0
	jz	proc_EXCEPTION_common_end	; ContinueDebug_DBG_CONTINUE
	mov	eax,[dbg_event.Exception.ExceptionRecord.ExceptionCode]
	call	check_exception_in_ignore_list
	jnz	proc_EXCEPTION_common_end
	mov	r8d,DBG_EXCEPTION_NOT_HANDLED
	jmp	ContinueDebug_ContinueStatus

proc_EXCEPTION_BREAKPOINT:
	call	try_rest_from_previous

	call	try_log_our_sw_bp

	test	byte [LogExceptionLevel],log_no_breakpoints
	jnz	proc_EXCEPTION_BREAKPOINT_L0
	call	exception2log
proc_EXCEPTION_BREAKPOINT_L0:

; was it the very first SW_BP at ntdll.DbgBreakPoint ?
; update from version 0023
; it is different location for w2k8 R2:
; 0000000077B111F0	4883EC38	sub rsp,38
; 0000000077B111F4	488364242000	and qword [rsp+20],00
; 0000000077B111FA	41B901000000	mov r9d,00000001
; 0000000077B11200	4C8D442440	lea r8,[rsp+40]
; 0000000077B11205	418D5110	lea edx,[r9+10]		; 11h = ThreadHideFromDebugger
; 0000000077B11209	48C7C1FEFFFFFF	mov rcx,FFFFFFFFFFFFFFFE; current thread
; 0000000077B11210	E8EBEEF9FF	call 0000000077AB0100	; ntdll.NtQueryInformationThread
; 0000000077B11215	85C0		test eax,eax
; 0000000077B11217	780A		js 0000000077B11223
; 0000000077B11219	807C244000	cmp byte [rsp+40],00
; 0000000077B1121E	7503		jnz 0000000077B11223
; 0000000077B11220	CC		int3			; here we go in w2k8 R2, not to ntdll.DbgBreakPoint !!!
; 0000000077B11221	EB00		jmp 0000000077B11223
; 0000000077B11223	4883C438	add rsp,38
; 0000000077B11227	C3		ret 


;	cmp	byte [put_BP_at_exe_entry_and_run],0
;	jz	proc_EXCEPTION_BREAKPOINT_not_ntdll_DbgBreakPoint
;	mov	ecx,[dbg_event.dwProcessId]
;	call	scan_ntdll_DbgBreakPoint
;	jc	proc_EXCEPTION_BREAKPOINT_not_ntdll_DbgBreakPoint
;	cmp	[dbg_event.Exception.ExceptionRecord.ExceptionAddress],rax	; this address points to the start of the instruction (RIP in thread context points after the breakpoint instruction because the exception is trap type so the instrucion is completed and then the exception is generated)
;	jnz	proc_EXCEPTION_BREAKPOINT_not_ntdll_DbgBreakPoint
;	mov	byte [put_BP_at_exe_entry_and_run],0
;; 1. checkbox 'run over ntdll.DbgBreakPoint and halt on exe EntryPoint' is checked.
;; We want to simple continue run till trigger breakpoint at exe entrypoint (SW BP has been set
;; at exe entrypoint in begin of procedure for CREATE_PROCESS_DEBUG_EVENT).
;; After triggering a breakpoint RIP is pointing after the instruction of the breakpoint,
;; so telling the process to run is simple, just ContinueDebugEvent with DBG_CONTINUE flag
;	jmp	ContinueDebug_DBG_CONTINUE
;
;proc_EXCEPTION_BREAKPOINT_not_ntdll_DbgBreakPoint:
;
;
; the new way since version 0023:
; 1. checkbox 'run over ntdll.DbgBreakPoint and halt on exe EntryPoint' is checked.
; We want to simple continue run till trigger breakpoint at exe entrypoint (SW BP has been set
; at exe entrypoint in begin of procedure for CREATE_PROCESS_DEBUG_EVENT).
; After triggering a breakpoint RIP is pointing after the instruction of the breakpoint,
; so telling the process to run is simple, just ContinueDebugEvent with DBG_CONTINUE flag

	cmp	byte [put_BP_at_exe_entry_and_run],0
	jz	proc_EXCEPTION_BREAKPOINT_not_initial_ntdll_int3

;; is it ntdll.dll?
;	mov	rdx,[dbg_event.Exception.ExceptionRecord.ExceptionAddress]
;	mov	ecx,[dbg_event.dwProcessId]
;	call	is_it_ntdll_dll
;	jc	proc_EXCEPTION_BREAKPOINT_not_initial_ntdll_int3
; wrong idea, the above is commented out...
; what if newer versions of OS will place the initial int3 elsewhere than ntdll.dll ?
; so it is better not to check whether it is ntdll.dll

; is it breakpoint put there by fdbg or incompiled breakpoint directly in the code

	mov	rax,[dbg_event.Exception.ExceptionRecord.ExceptionAddress]
	mov	ecx,[dbg_event.dwProcessId]
	call	scan_sw_bp_addr_pid
	jz	proc_EXCEPTION_BREAKPOINT_not_initial_ntdll_int3

; this is int3 in ntdll.dll belonging to PID which wasn't put there by fdbg but it is the part of code of the ntdll.dll
; it should be ntdll.DbgBreakPoint for w2k3 or it should be somewhere like at 0000000077B11220 described few lines above
; or perhaps it appear elsewhere in newer versions of OS (so I today decided not to check whether the address is in ntdll.dll)

; OK we went here and we want not to break here but to continue silently:
	mov	byte [put_BP_at_exe_entry_and_run],0
	jmp	ContinueDebug_DBG_CONTINUE


proc_EXCEPTION_BREAKPOINT_not_initial_ntdll_int3:




	mov	ecx,[dbg_event.dwThreadId]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	sbtlemb1
	call	branches_to_LogEdit_ms_backdoor
sbtlemb1:

; 2. checkbox 'run over ntdll.DbgBreakPoint and halt on exe EntryPoint' is unchecked
; or we went through ntdll.DbgBreakPoint on its first occurrence and another SW BP occured
; (could be on ntdll.DbgBreakPoint again for the second time).
; Note that in case of the first ntdll.DbgBreakPoint occurrance
; user mustn't continue unhandled (DBG_EXCEPTION_NOT_HANDLED). Application exception handler
; can't be installed yet, so app initialization fails and an error message box appears:
; The application failed to initialize properly (0x80000003). Click on OK to terminate the application.

	cmp	dword [dbg_event.Exception.dwFirstChance],0
; If the dwFirstChance member is nonzero, this is the first time the debugger has encountered
; the exception. Debuggers typically handle breakpoint and single-step exceptions when they
; are first encountered. If this member is zero, the debugger has previously encountered
; the exception. This occurs only if, during the search for structured exception handlers,
; either no handler was found or the exception was continued.
	jz	proc_EXCEPTION_BREAKPOINT_L54

; For the exception first chance RIP in thread context is pointing after bp instruction,
; so we grab address from DEBUG_EVENT.Exception.ExceptionRecord.ExceptionAddress

; are we on SW BP put into process by fdbg?
	mov	ecx,dword [dbg_event.dwProcessId]
	mov	rax,qword [dbg_event.Exception.ExceptionRecord.ExceptionAddress]
	call	scan_sw_bp_addr_pid
	jnz	proc_EXCEPTION_BREAKPOINT_L38
; We are at breakpoint put by fdbg into code
	mov	ebx,edx
; ebx = index of SW BP store
	mov	rdi,qword [breakpoints_space_address]
	cmp	byte [rdi+(8+4+1)*MaxNumberOfBreakpoints+rbx*1],SW_BP_flag_temporary
	jnz	proc_EXCEPTION_BREAKPOINT_L1

; temporary breakpoint, remove it
;	mov	ecx,dword [dbg_event.dwProcessId]
; ecx = PID already
;	mov	rax,qword [dbg_event.Exception.ExceptionRecord.ExceptionAddress]
; rax = ExceptionAddress already
	call	remove_SW_BP_from_process_and_clear_its_dbg_store

; restore RIP to begin of breakpoint instruction
	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,qword [dbg_event.Exception.ExceptionRecord.ExceptionAddress]
	mov	qword [ThreadContext.Rip],rax
	call	SetThreadContext_debuggee_CONTEXT_ALL

; now go to common end
	jmp	proc_EXCEPTION_common_end

proc_EXCEPTION_BREAKPOINT_L1:
; ebx = index of SW BP store
; permanent breakpoint, scenario will be:
; 1. wait what user want to do
; 2. when user changed RIP or PID or TID nothing from this scenario happens
; 3. user request for DBG_EXCEPTION_NOT_HANDLED isn't accepted, we use DBG_CONTINUE (see 5. Run)
;    (this is SW BP put by fdbg, no raw opcode incompiled in app because db 0CCh
;    in its source, neither ntdll.DbgBreakPoint) - jmp ContinueDebug_DBG_CONTINUE at the end
; 4. remove breakpoint from process image but without clearing SW BP store
;    save address of just removed breakpoint to set it later with SW_BP_flag_permanent
; 5. request for Run will be done in this way:
;    - make Single Step
;    - set BP again in single step routine
;    - execute run
; 6. request for Single Step will be done in this way
;    - make Single Step
;    - write breakpoint to process image (SW BP store wasn't cleared) in single step routine
; 7. request for Step Over
;    - make Single Step ( = put new SW BP after instruction, then execute run)
;    - write breakpoint to process image (SW BP store wasn't cleared) in step over routine

; 1.
	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,qword [dbg_event.Exception.ExceptionRecord.ExceptionAddress]
	mov	qword [rip_before_bp],rax
	xchg	qword [ThreadContext.Rip],rax	; update this since RIP points after 0CCh instruction
	mov	qword [rip_after_bp],rax
	call	SetThreadContext_debuggee_CONTEXT_ALL

	mov	rax,qword [ThreadContext.Rip]
	mov	rcx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax
	mov	qword [Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,qword [hDbgThread]
	call	SuspendThreadSafe

; we will wait here until user choose Run or Single Step, or Step Over, or ...
; 2.
	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	mov	edx,dword [dbg_event.dwProcessId]
	cmp	dword [last_TID],ecx
	jnz	ContinueDebug_DBG_CONTINUE	; user changed TID, we will simple run
	cmp	dword [last_PID],edx
	jnz	ContinueDebug_DBG_CONTINUE	; user changed PID, we will simple run
; ECX=dbg_event.dwThreadId now
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,qword [ThreadContext.Rip]
	cmp	qword [rip_before_bp],rax
	jnz	ContinueDebug_DBG_CONTINUE	; user changed RIP, we will simple run

; 3.
;	mov	dword [continue_flag_after_resume],DBG_CONTINUE	; user could put
;						; DBG_EXCEPTION_NOT_HANDLED there
; not necessary, we use jmp ContinueDebug_DBG_CONTINUE at the end

; 4.
; ebx = index of SW BP store
	mov	rdx,qword [ThreadContext.Rip]
	mov	rax,qword [breakpoints_space_address]
	mov	ecx,dword [dbg_event.dwProcessId]

	cmp	[rax + rbx*8],rdx
	jnz	ContinueDebug_DBG_CONTINUE	; user deleted permanent breakpoint (or changed it to temporary breakpoint) or changed this breakpoint to another address, we will simple run
	cmp	[rax + 8*MaxNumberOfBreakpoints + rbx*4],ecx
	jnz	ContinueDebug_DBG_CONTINUE	; mismatched PID, we will simple run
	cmp	byte [rax+(8+4+1)*MaxNumberOfBreakpoints+rbx*1],SW_BP_flag_permanent
	jnz	ContinueDebug_DBG_CONTINUE	; user deleted permanent breakpoint (or changed it to temporary breakpoint), we will simple run

	lea	rdx,[rax + (8+4)*MaxNumberOfBreakpoints + rbx*1]
	mov	rax,qword [dbg_event.Exception.ExceptionRecord.ExceptionAddress]
	call	remove_0CCh
	mov	ecx,0
	cmovc	rax,rcx
	mov	qword [addr_write_bp_after_first_step],rax
	mov	edx,dword [dbg_event.dwProcessId]
	mov	dword [PID_write_sw_bp_after_first_step],edx

; 5., 6., 7.
	test	byte [ThreadContext.EFlags+1],1b	; check if user set Single Step
	setz	byte [run_after_first_step_when_write_bp]	; in case user set Run, we run
						; in case user set StepOver, we run and wait until trigger new BP
						; in case Single Step, we wont run after exception Single Step
	mov	ecx,dword [dbg_event.dwThreadId]
	call	set_trap_flag
	jmp	ContinueDebug_DBG_CONTINUE

proc_EXCEPTION_BREAKPOINT_L54:
; For the second chance RIP in thread context is pointing to breakpoint instruction,
; = DEBUG_EVENT.Exception.ExceptionRecord.ExceptionAddress

; is this the right way ?
	jmp	ContinueDebug_DBG_CONTINUE

proc_EXCEPTION_BREAKPOINT_L38:
; Breakpoint occured, but not breakpoint put by fdbg into code.
; This may happen on ntdll.DbgBreakPoint or breakpoint incompiled in the app.
; The app is able to run normally outside a debugger only when it has exception handler
; handling this kind of exception.
; Good trick to quickly run with a debugger into desired part of an application during its
; development: put db 0CCh into its source, recompile it, run under debugger and it stops
; where you put breakpoint.
; when user want to DBG_EXCEPTION_NOT_HANDLED (like debugging exception handler procedure),
; we do now nothing
; if user want single step, step over, run (everything with DBG_CONTINUE), everything cause
; execution of 1 instruction of breakpoint, so we can simulate it by this way:
; (RIP in thread context is pointing after breakpoint instruction, we restore it to
; the begin of the breakpoint instruction. We could use DEC [ThreadContext.Rip],
; but we don't know, whether 0CCh or 0CDh,03h caused breakpoint, so it's better to restore
; ThreadContext.Rip from DEBUG_EVENT.Exception.ExceptionRecord.ExceptionAddress)
; (note that ms incorrectly set DEBUG_EVENT.Exception.ExceptionRecord.ExceptionAddress
; to rip_after_instruction-1 when CD 03 causes breakpoint, RIP is then pointing to byte 03 ! )

;	cmp	dword [dbg_event.Exception.dwFirstChance],0
;; If the dwFirstChance member is nonzero, this is the first time the debugger has encountered
;; the exception. Debuggers typically handle breakpoint and single-step exceptions when they
;; are first encountered. If this member is zero, the debugger has previously encountered
;; the exception. This occurs only if, during the search for structured exception handlers,
;; either no handler was found or the exception was continued.
;	jz	proc_EXCEPTION_BREAKPOINT_L39
; it was checked already cmp dword [dbg_event.Exception.dwFirstChance],0 jz proc_EXCEPTION_BREAKPOINT_L54

	mov	eax,[dbg_event.Exception.ExceptionRecord.ExceptionCode]
	call	check_exception_in_ignore_list
	mov	r8d,DBG_EXCEPTION_NOT_HANDLED
	jz	ContinueDebug_ContinueStatus

proc_EXCEPTION_BREAKPOINT_L39:
	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,qword [dbg_event.Exception.ExceptionRecord.ExceptionAddress]
	mov	qword [rip_before_bp],rax
	xchg	qword [ThreadContext.Rip],rax	; update this since RIP points after 0CCh instruction
	mov	qword [rip_after_bp],rax
	call	SetThreadContext_debuggee_CONTEXT_ALL

	mov	rax,qword [ThreadContext.Rip]
	mov	rcx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax
	mov	qword [Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,qword [hDbgThread]
	call	SuspendThreadSafe

	mov	r8d,dword [continue_flag_after_resume]
	cmp	r8d,DBG_EXCEPTION_NOT_HANDLED
	jz	ContinueDebug_ContinueStatus	; user wanted DBG_EXCEPTION_NOT_HANDLED

; this is simulation of doing one instruction of single step:
; but at first, we must check whether user didn't change RIP
	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,qword [ThreadContext.Rip]
	cmp	qword [rip_before_bp],rax
	jnz	proc_EXCEPTION_common_end_finish; if user changed RIP, then proc_EXCEPTION_common_end_finish

; this is simulation of doing 1 instruction of breakpoint
	mov	rax,qword [rip_after_bp]
	mov	qword [ThreadContext.Rip],rax
; and don't forget to clear Trap Flag
	mov	al,byte [ThreadContext.EFlags+1]
	and	byte [ThreadContext.EFlags+1],not 1	; clear Trap Flag for Single Step
	call	SetThreadContext_debuggee_CONTEXT_ALL
	test	al,1b			; check if user wanted to single step
					; if single step, we are done
					; Step Over uses Single Step method for everything
					; except call, loop, rep...
					; Trap flag is zero when user wanted to run
	jz	ContinueDebug_DBG_CONTINUE	; user wanted to Run
	jmp	proc_EXCEPTION_common_end	; user wanted Single Step (or Step Over which is simulated by Single Step)

;+-+-+-+-+-+-+-+-+-+-+-+-+

proc_EXCEPTION_SINGLE_STEP:
	call	try_rest_from_previous
	btr	dword [run_after_first_step_when_write_bp],0	; test bit 0 only once and then clear it
	jc	ContinueDebug_DBG_CONTINUE	; we continue run because this single step
						; hasn't been set by user
						; fdbg set it for step through permanent SW BP
	test	byte [LogExceptionLevel],log_no_single_steps
	jnz	proc_EXCEPTION_SINGLE_STEP_L0
	call	exception2log
proc_EXCEPTION_SINGLE_STEP_L0:

	mov	ecx,[dbg_event.dwThreadId]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	sbtlemb2
	call	branches_to_LogEdit_ms_backdoor
sbtlemb2:

	mov	ecx,dword [dbg_event.dwThreadId]; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	al,byte [ThreadContext.Dr6]
	test	al,00001111b			; test B0 thru B3
	jz	proc_EXCEPTION_SINGLE_STEP_L9	; no HW BP

; we have 2 possibilities:
; 1. clear debug registers in thread which caused exception
; 2. clear debug registers in every thread
; both have advantages and disadvantages
; we use second way, because we set dr regs in all threads in CREATE_THREAD_DEBUG_EVENT and CREATE_PROCESS_DEBUG_EVENT 
	xor	ebx,ebx				; BP No. index
;	mov	dword [ThreadContext.Dr6],0FFFF0FF0h	; way 1.
	mov	dword [all_thread_dr6],0FFFF0FF0h	; way 2.
proc_EXCEPTION_SINGLE_STEP_L1:
	bt	dword [ThreadContext.Dr6],ebx
	jnc	proc_EXCEPTION_SINGLE_STEP_L8

; check whether we set HW BP as removable or permanent
	lea	rdx,[HW_BP_permanent]
	cmp	byte [rdx+rbx*1],0		; "permanent", ID_Dialog01AutoCheckBox2 BST_UNCHECKED = 0 BST_CHECKED = 1
	jnz	proc_EXCEPTION_SINGLE_STEP_L2

; temporary breakpoint, remove it
;	mov	byte [rdx+rbx*1],0		; clear flag byte (temporary/permanent), not necessary, 0 is there

;	lea	rdx,[ThreadContext.Dr0]		; way 1.
	lea	rdx,[all_thread_dr0]		; way 2.
	and	qword [rdx + rbx*8],0		; clear breakpoint address in DRx (x is 0-3)

; mask for clean RW bits and LEN bits of DR7
	lea	ecx,[rbx*4]			; ECX = (HW_BP_No. * 4)
	mov	eax,11111111111100001111111111111111b
	rol	eax,cl

; mask for clean L and G bit of DR7
	shr	ecx,1				; ECX = HW_BP_No. * 2
	mov	al,11111100b
	rol	al,cl

; clean bits there !
	and	dword [rdx+8*5],eax

;	mov	ecx,[dbg_event.dwThreadId]
;	call	set_debug_registers_in_thread		; way 1.
	call	set_debug_registers_in_all_threads	; way 2.

	jmp	proc_EXCEPTION_SINGLE_STEP_L7

;proc_EXCEPTION_SINGLE_STEP_L2:
;; permanent HW BP
;
;;RFLAGS:
;; RF Resume (bit 16)  Controls the processors response to instruction-breakpoint
;; conditions. When set, this flag temporarily disables debug exceptions
;; (#DB) from being generated for instruction breakpoints (although other
;; exception conditions can cause an exception to be generated). When clear,
;; instruction breakpoints will generate debug exceptions.
;; The primary function of the RF flag is to allow the restarting of an instruction
;; following a debug exception that was caused by an instruction breakpoint
;; condition. Here, debug software must set this flag in the EFLAGS image on
;; the stack just prior to returning to the interrupted program with IRETD (to
;; prevent the instruction breakpoint from causing another debug exception).
;; The processor then automatically clears this flag after the instruction
;; returned to has been successfully executed, enabling instruction breakpoint
;; faults again.
;
;; 1. wait what user want to do
;; 2. when user changed RIP or PID or TID or this debug reg, nothing from this scenario happens
;; 3. user request for DBG_EXCEPTION_NOT_HANDLED -> continue debug loop
;; 4. set RFLAGS.RF bit
;
;; 1.
;	lea	eax,[rbx+'0']
;	mov	byte [msg_hw_bp_perm_No],al
;	lea	rax,[msg_hw_bp_perm]
;	call	msg_to_LogEdit
;
;	mov	rax,qword [ThreadContext.Rip]
;	mov	rcx,qword [ThreadContext.Rsp]
;	mov	qword [Code_listview_dump_start_address],rax
;	mov	qword [rip_at_bp],rax
;	mov	qword [Stack_listview_dump_start_address],rcx
;	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st
;
;	call	code_1st_disassemble_back
;
;	mov	eax,[dbg_event.dwProcessId]
;	mov	edx,[dbg_event.dwThreadId]
;	call	display_regs_memory	; update SysListView32s
;
;	mov	byte [DbgThrdResumed],0
;	call	update_menus_hang_suspend_changed
;
;	mov	rcx,qword [hDbgThread]
;	call	SuspendThreadSafe
;
;; we will wait here until user choose Run or Single Step, or Step Over, or ...
;; 2.
;	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
;	mov	edx,dword [dbg_event.dwProcessId]
;	cmp	dword [last_TID],ecx
;	jnz	ContinueDebug_DBG_CONTINUE	; user changed TID, we will simple run
;	cmp	dword [last_PID],edx
;	jnz	ContinueDebug_DBG_CONTINUE	; user changed PID, we will simple run
;; ECX=dbg_event.dwThreadId now
;	call	GetThreadContext_debuggee_CONTEXT_ALL
;	mov	rax,qword [ThreadContext.Rip]
;	cmp	qword [rip_at_bp],rax
;	jnz	ContinueDebug_DBG_CONTINUE	; user changed RIP, we will simple run
;
;; 3.
;	mov	r8d,dword [continue_flag_after_resume]
;	cmp	r8d,DBG_EXCEPTION_NOT_HANDLED
;	jz	ContinueDebug_ContinueStatus
;
;; 4.
;; ebx = index of HW BP
;	mov	al,11111100b
;	lea	ecx,[rbx + rbx*1]
;	rol	al,cl
;
;; user could change DR in some trick, so it is better to check it
;	mov	cl,byte [ThreadContext.Dr7]
;
;	and	byte [ThreadContext.Dr7],al
;
;	or	byte [ThreadContext.EFlags + 2],1	; set RF bit, bit 16.
;
;	mov	eax,dword [dbg_event.dwThreadId]
;	call	TID2hThread
;	jc	ContinueDebug_DBG_CONTINUE
;	mov	rcx,rdx
;	lea	rdx,[ThreadContext]
;	call	qword [SetThreadContext]
;
;	jmp	ContinueDebug_DBG_CONTINUE
; the above was wrong, rolling back to old way:

proc_EXCEPTION_SINGLE_STEP_L2:
; permanent HW BP, scenario will be:
; 1. wait what user want to do
; 2. when user changed RIP or PID or TID or this debug reg, nothing from this scenario happens
; 3. user request for DBG_EXCEPTION_NOT_HANDLED -> continue debug loop
; 4. remove breakpoint from ThreadContext.Dr7 but without clearing all_thread_dr7
;    save BP No. of just removed breakpoint to set it later with SW_BP_flag_permanent
; 5. request for Run will be done in this way:
;    - make Single Step
;    - set BP again in single step routine
;    - execute run
; 6. request for Single Step or Step Over will be done in this way
;    - make Single Step
;    - write breakpoint to Dr7 in single step routine

; 1.
	lea	eax,[rbx+'0']
	mov	byte [msg_hw_bp_perm_No],al
	lea	rax,[msg_hw_bp_perm]
	call	msg_to_LogEdit

	mov	rax,qword [ThreadContext.Rip]
	mov	rcx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax
	mov	qword [rip_at_bp],rax
	mov	qword [Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,qword [hDbgThread]
	call	SuspendThreadSafe

; we will wait here until user choose Run or Single Step, or Step Over, or ...
; 2.
	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	mov	edx,dword [dbg_event.dwProcessId]
	cmp	dword [last_TID],ecx
	jnz	ContinueDebug_DBG_CONTINUE	; user changed TID, we will simple run
	cmp	dword [last_PID],edx
	jnz	ContinueDebug_DBG_CONTINUE	; user changed PID, we will simple run
; ECX=dbg_event.dwThreadId now
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,qword [ThreadContext.Rip]
	cmp	qword [rip_at_bp],rax
	jnz	ContinueDebug_DBG_CONTINUE	; user changed RIP, we will simple run

; 3.
	mov	r8d,dword [continue_flag_after_resume]
	cmp	r8d,DBG_EXCEPTION_NOT_HANDLED
	jz	ContinueDebug_ContinueStatus

; 4.
; ebx = index of HW BP
	mov	al,11111100b
	lea	ecx,[rbx + rbx*1]
	rol	al,cl

; user could change DR in some trick, so it is better to check it
	mov	cl,byte [ThreadContext.Dr7]

	and	byte [ThreadContext.Dr7],al

	not	al
	and	al,cl
	mov	byte [hw_bp_GL_after_first_step],al
	mov	byte [rest_from_previous_flag],rest_from_permanent_BP_flag_HW
	lea	rdx,[ThreadContext.Dr0]
	mov	rcx,qword [rdx+rbx*8]
	mov	byte [hw_bp_No_after_first_step],bl
	mov	qword [addr_write_bp_after_first_step],rcx

	mov	eax,dword [dbg_event.dwThreadId]
	mov	dword [TID_write_hw_bp_after_first_step],eax

;	mov	eax,dword [dbg_event.dwThreadId]
; eax = dword [dbg_event.dwThreadId] now
	call	TID2hThread
	jc	ContinueDebug_DBG_CONTINUE
	mov	rcx,rdx
	lea	rdx,[ThreadContext]
	call	qword [SetThreadContext]

; 5., 6., 7.
	test	byte [ThreadContext.EFlags+1],1b	; check if user set Single Step
	setz	byte [run_after_first_step_when_write_bp]	; in case user set Run, we run
						; in case user set StepOver, we run and wait until trigger new BP
						; in case Single Step, we wont run after exception Single Step
	mov	ecx,dword [dbg_event.dwThreadId]
	call	set_trap_flag
	jmp	ContinueDebug_DBG_CONTINUE

proc_EXCEPTION_SINGLE_STEP_L7:
	lea	eax,[rbx+'0']
	mov	byte [msg_hw_bp_temp_No],al
	lea	rax,[msg_hw_bp_temp]
	call	msg_to_LogEdit

proc_EXCEPTION_SINGLE_STEP_L8:
	inc	ebx
	cmp	bl,4
	jc	proc_EXCEPTION_SINGLE_STEP_L1
proc_EXCEPTION_SINGLE_STEP_L9:

	cmp	dword [dbg_event.Exception.dwFirstChance],0
	jz	proc_EXCEPTION_common_end

	mov	eax,[dbg_event.Exception.ExceptionRecord.ExceptionCode]
	call	check_exception_in_ignore_list
	mov	r8d,DBG_EXCEPTION_NOT_HANDLED
	jz	ContinueDebug_ContinueStatus

proc_EXCEPTION_common_end:
	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL

	mov	rax,qword [ThreadContext.Rip]
	mov	rcx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax
	mov	qword [Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

proc_EXCEPTION_common_end_2:
	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,qword [hDbgThread]
	call	SuspendThreadSafe

; we will stay here suspended waiting what to do, e.g. single step, pass exception
; to app exception handler, run, ..., we will wait also for continue flag by parent order
; waiting in suspended state has 2 features:
; 1. don't waste CPU time when nothing to do
; 2. the main reason: parent's orders for us to do various things
;    e.g. parent can modify registers, memory, set single step bit in flag register,
;    set/remove breakpoint, switch to another process/thread if any (mutiprocess/thread app)
;    and at the end, parent MUST order us DBG_CONTINUE/DBG_EXCEPTION_NOT_HANDLED flag
;    After complete this, paren must resume thread so debug loop can continue.
;    Note that the first thing after resume is: ContinueDebugEvent complete previously
;    reported debug event. Our desired operation will occur later.
; If the DBG_CONTINUE flag is specified and the thread specified by the dwThreadId parameter
; previously reported an EXCEPTION_DEBUG_EVENT debugging event, the function stops all
; exception processing and continues the thread. For any other debugging event, this flag
; simply continues the thread.
; If the DBG_EXCEPTION_NOT_HANDLED flag is specified for this parameter and the thread
; specified by dwThreadId previously reported an EXCEPTION_DEBUG_EVENT debugging event,
; the function continues exception processing. If this is a first-chance exception event,
; the search and dispatch logic of the structured exception handler is used; otherwise, the
; process is terminated. For any other debugging event, this flag simply continues the thread.

proc_EXCEPTION_common_end_finish:
	mov	r8d,dword [continue_flag_after_resume]
	jmp	ContinueDebug_ContinueStatus

proc_CREATE_THREAD_DEBUG_EVENT:
	mov	eax,dword [dbg_event.dwThreadId]
	mov	rdx,qword [dbg_event.CreateThread.hThread]
	call	store_TID_handle
	mov	eax,dword [dbg_event.dwProcessId]
	mov	edx,dword [dbg_event.dwThreadId]
	call	store_PID_TID_pair
	mov	eax,dword [dbg_event.dwThreadId]
	mov	rdx,qword [dbg_event.CreateThread.lpThreadLocalBase]
	call	store_TID_ThreadLocalBase
; set debug registers in newly created thread to match all other threads
	mov	rcx,qword [dbg_event.CreateThread.hThread]
	call	set_debug_registers_in_thread
; put something into the Log
	mov	eax,dword [dbg_event.dwProcessId]
	lea	rdi,[created_thread_PID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.dwThreadId]
	lea	rdi,[created_thread_TID_hexa]
	call	hexa_32_eax
;	mov	rax,qword [dbg_event.CreateThread.hThread]
;	lea	rdi,[created_thread_thread_handle_hexa]
;	call	hexa_64_rax
	mov	rax,qword [dbg_event.CreateThread.lpThreadLocalBase]
	lea	rdi,[created_thread_local_base_hexa]
	call	hexa_64_rax
	mov	rax,qword [dbg_event.CreateThread.lpStartAddress]
	lea	rdi,[created_thread_start_address_hexa]
	call	hexa_64_rax
	lea	rax,[created_thread_text]
	call	msg_to_LogEdit

	test	[face.break_on],1 shl break_on_CREATE_THREAD_DEBUG_EVENT_bit
	jz	proc_CREATE_THREAD_DEBUG_EVENT_end

	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,[ThreadContext.Rip]
	mov	rcx,[ThreadContext.Rsp]
	mov	[Code_listview_dump_start_address],rax
	mov	[Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,[hDbgThread]
	call	SuspendThreadSafe
; we will wait here until user choose Run or Single Step, or Step Over, or ...

proc_CREATE_THREAD_DEBUG_EVENT_end:
	jmp	ContinueDebug_DBG_CONTINUE

proc_CREATE_PROCESS_DEBUG_EVENT:
	inc	[num_of_processes]
	mov	eax,dword [dbg_event.dwProcessId]
	mov	rdx,qword [dbg_event.CreateProcess.hProcess]
	call	store_PID_handle
	mov	eax,dword [dbg_event.dwThreadId]
	mov	rdx,qword [dbg_event.CreateProcess.hThread]
	call	store_TID_handle
	mov	eax,dword [dbg_event.dwProcessId]
	mov	edx,dword [dbg_event.dwThreadId]
	call	store_PID_TID_pair
	mov	eax,dword [dbg_event.dwThreadId]
	mov	rdx,qword [dbg_event.CreateProcess.lpThreadLocalBase]
	call	store_TID_ThreadLocalBase
	mov	rcx,qword [dbg_event.CreateProcess.hProcess]
	mov	rdx,qword [dbg_event.CreateProcess.lpThreadLocalBase]
	call	extract_PEB
	mov	edx,dword [dbg_event.dwProcessId]
	call	store_PID_PEB	; edx=PID, rax=PEB

; set debug registers in main thread of newly created process to match all other threads
	mov	rcx,qword [dbg_event.CreateProcess.hThread]
	call	set_debug_registers_in_thread

; put something into the Log
	mov	eax,dword [dbg_event.dwProcessId]
	lea	rdi,[created_process_PID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.dwThreadId]
	lea	rdi,[created_process_TID_hexa]
	call	hexa_32_eax
;	mov	rax,qword [dbg_event.CreateProcess.hProcess]
;	lea	rdi,[created_process_process_handle_hexa]
;	call	hexa_64_rax
;	mov	rax,qword [dbg_event.CreateProcess.hThread]
;	lea	rdi,[created_process_thread_handle_hexa]
;	call	hexa_64_rax
	mov	rax,qword [dbg_event.CreateProcess.lpBaseOfImage]
	lea	rdi,[created_process_base_of_image_hexa]
	call	hexa_64_rax

	mov	rdi,qword [module_info_address]
	mov	ecx,MaxNumberOfModulesInfo
	xor	eax,eax
	cld
	repnz scasq
	mov	rax,qword [dbg_event.CreateProcess.lpBaseOfImage]
	jnz	proc_CREATE_PROCESS_DEBUG_EVENT_not_enough_store
	lea	rbx,[rdi-8]			; input parameter of obtain_module_info
	mov	rdx,qword [dbg_event.CreateProcess.hProcess]
	mov	ecx,dword [dbg_event.dwProcessId]

	mov	dword [rbx+24*MaxNumberOfModulesInfo + 4],flag_module_process
	call	obtain_module_info
proc_CREATE_PROCESS_DEBUG_EVENT_not_enough_store:

; dbghelp.dll symbols
	mov	rdx,qword [dbg_event.CreateProcess.hFile]
	sub	rdi,qword [module_info_address]
	shr	edi,3				; edi/8
	lea	ecx,[(rdi-1)+SymbolIndexFirst]	; rdi-1 because rdi was +8 before shr
	call	get_dbghelp_sym

; next MUST be after obtain_module_info because depends on data on [rbx]
	mov	rax,qword [rbx+8*MaxNumberOfModulesInfo]
	lea	rdi,[created_process_base_of_image_end_hexa]
	call	hexa_64_rax
; dwDebugInfoFileOffset
; nDebugInfoSize
	mov	rax,qword [dbg_event.CreateProcess.lpThreadLocalBase]
; lpThreadLocalBase 
; A pointer to a block of data. At offset 0x2C (Feryno comment - offset from win32, not from win64 - here must be qword aligned, not at 2Ch) into this block is another pointer, called ThreadLocalStoragePointer, that points to an array of per-module thread local storage blocks. This gives a debugger access to per-thread data in the threads of the process being debugged using the same algorithms that a compiler would use.
	lea	rdi,[created_process_thread_local_base_hexa]
	call	hexa_64_rax

	mov	rcx,qword [dbg_event.CreateProcess.hFile]
	mov	rdx,qword [dbg_event.CreateProcess.lpBaseOfImage]
	call	Rambo_FirstBlood_find_entrypoint
	jc	proc_CREATE_PROCESS_DEBUG_EVENT_L3		; CF=1 as well when RDX match OptionalHeader.ImageBase
								; then we needn't to update CreateProcess.lpStartAddress
; rax = correct start address
	bt	dword [face.Rambo],IDM_RAMBO_FB - IDM_RAMBO
	jc	proc_CREATE_PROCESS_DEBUG_EVENT_L7

	mov	rdi,rax						; save correct start address
	mov	r9d,MB_YESNO
	lea	r8,[msg_danger]
	lea	rdx,[msg_incorrect_OEP]
	mov	rcx,[hWndParent]
	call	[MessageBoxA]
	cmp	eax,IDNO
	jz	proc_CREATE_PROCESS_DEBUG_EVENT_L3
	cmp	eax,IDYES
	jnz	proc_CREATE_PROCESS_DEBUG_EVENT_L3
	mov	rax,rdi						; restore correct start address
	jmp	proc_CREATE_PROCESS_DEBUG_EVENT_L7

proc_CREATE_PROCESS_DEBUG_EVENT_L3:
	mov	rax,[dbg_event.CreateProcess.lpStartAddress]

proc_CREATE_PROCESS_DEBUG_EVENT_L7:
	mov	[dbg_event.CreateProcess.lpStartAddress],rax
	lea	rdi,[created_process_thread_start_address_hexa]
	call	hexa_64_rax
	lea	rax,[created_process_text]
	call	msg_to_LogEdit

; Rambo is debugger present fight:
	bt	dword [face.Rambo],IDM_RAMBO_IDPF - IDM_RAMBO
	jnc	proc_CREATE_PROCESS_DEBUG_EVENT_L5

;;	mov	rcx,qword [dbg_event.CreateProcess.hProcess]
;;	call	Rambo_IsDebuggerPresent
;;
;; we can use this another way to do it:
;;ThreadLocalBase=000007FFFFFDE000
;; 1. gs mov rax,[dword 30h]
;;    rax = [dbg_event.CreateProcess.lpThreadLocalBase]
;; 2. mov rdx,qword [rax+60h]
;;    rdx = read qword of debuggee memory at rax + 60h
;; 3. mov byte [rdx+2],0			; camouflage for IsDebuggerPresent
;;    write byte 0 into debuggee memory at rdx+2
;; this second way looks better, but doesn't work:
;; since byte=0, operating system doesn't notify debugger about exception at startup
;; and application simple terminates
;; we must clear this byte later for OS handle exception as when process is debugged
;
;	mov	rax,qword [dbg_event.CreateProcess.lpThreadLocalBase]
;
;	lea	rsi,[Rambo_buf]
;	add	rax,60h
;	lea	rdi,[rsi+8]
;	mov	qword [rsi],rax
;	mov	ebx,8
;	mov	ecx,dword [dbg_event.dwProcessId]
;	call	read_debuggee_memory
;	jc	proc_CREATE_PROCESS_DEBUG_EVENT_L4
;
;	add	qword [rdi],2
;	lea	rsi,[rdi]
;	lea	rdi,[rsi+8]
;	mov	bl,1
;	mov	ecx,dword [dbg_event.dwProcessId]
;	mov	byte [rdi],bh		; bh=0
;	call	write_debuggee_memory
;	jnc	proc_CREATE_PROCESS_DEBUG_EVENT_L5
;
;; uglier way
;proc_CREATE_PROCESS_DEBUG_EVENT_L4:
	mov	rcx,qword [dbg_event.CreateProcess.hProcess]
	call	Rambo_IsDebuggerPresent

proc_CREATE_PROCESS_DEBUG_EVENT_L5:

	bt	dword [face.Rambo],IDM_RAMBO_EHP - IDM_RAMBO
	jnc	proc_CREATE_PROCESS_DEBUG_EVENT_L6
	mov	rdx,qword [rbx]			; module begin
	mov	rcx,qword [dbg_event.CreateProcess.hProcess]
	call	proc_set_executable_headers
proc_CREATE_PROCESS_DEBUG_EVENT_L6:

; all registers are read after previous call
	cmp	qword [Code_listview_dump_start_address],0
	jnz	proc_CREATE_PROCESS_DEBUG_EVENT_L9
	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
; we update addresses only for main process, not for children processes
	mov	rax,qword [dbg_event.CreateProcess.lpStartAddress]	;qword [ThreadContext.Rip]
	mov	rcx,qword [dbg_event.CreateProcess.lpBaseOfImage]
	mov	rdx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax	; code 1st
	mov	qword [Code_listview_dump_start_address+8],rax	; code 2nd
	mov	qword [Data_listview_dump_start_address],rcx	; data 1st
	mov	qword [Data_listview_dump_start_address+8*1],rcx; data 2nd
	mov	qword [Data_listview_dump_start_address+8*2],rcx; data 3rd
	mov	qword [Stack_listview_dump_start_address],rdx	; stack
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st
proc_CREATE_PROCESS_DEBUG_EVENT_L9:

; put breakpoint at process entry point
	cmp	byte [put_BP_at_exe_entry_and_run],0	; only for main process
;	cmp	byte [HaltOnChoice],0			; for every process - main as well child
	jz	proc_CREATE_PROCESS_DEBUG_EVENT_L8

	mov	rax,[dbg_event.CreateProcess.lpStartAddress]
	mov	ecx,dword [dbg_event.dwProcessId]
	call	put_temporary_hw_or_sw_bp

proc_CREATE_PROCESS_DEBUG_EVENT_L8:
; we must do it after possible setting of all HW BP
; Rambo Stop on TLS Callback:
	bt	dword [face.Rambo],IDM_RAMBO_TLSC - IDM_RAMBO
	jnc	proc_CREATE_PROCESS_DEBUG_EVENT_close_handle
;;;;;	mov	r8,qword [dbg_event.CreateProcess.hThread]
	mov	rdx,qword [rbx]			; module begin
	mov	rcx,qword [dbg_event.CreateProcess.hProcess]
	call	Rambo_TLSC

proc_CREATE_PROCESS_DEBUG_EVENT_close_handle:
; The debugger should close the handle to the image file by calling the CloseHandle function
	mov	rcx,qword [dbg_event.CreateProcess.hFile]
	call	qword [CloseHandle]

	test	[face.break_on],1 shl break_on_CREATE_PROCESS_DEBUG_EVENT_bit
	jz	proc_CREATE_PROCESS_DEBUG_EVENT_end

;	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
;	call	GetThreadContext_debuggee_CONTEXT_ALL
; the above was already obtained

	mov	rax,[ThreadContext.Rip]
	mov	rcx,[ThreadContext.Rsp]
	mov	[Code_listview_dump_start_address],rax
	mov	[Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,[hDbgThread]
	call	SuspendThreadSafe
; we will wait here until user choose Run or Single Step, or Step Over, or ...

proc_CREATE_PROCESS_DEBUG_EVENT_end:
	jmp	ContinueDebug_DBG_CONTINUE

proc_EXIT_THREAD_DEBUG_EVENT:
; put something into the log
	mov	eax,dword [dbg_event.dwProcessId]
	lea	rdi,[exit_thread_PID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.dwThreadId]
	lea	rdi,[exit_thread_TID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.ExitThread.dwExitCode]
	lea	rdi,[exit_thread_exit_code_hexa]
	call	hexa_32_eax
	lea	rax,[exit_thread_text]
	call	msg_to_LogEdit

; update SysListView32s, especially Code 1st
	mov	ecx,[dbg_event.dwThreadId]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	proc_EXIT_THREAD_DEBUG_EVENT_L0

	mov	rax,qword [ThreadContext.Rip]
	mov	rcx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax
	mov	qword [Stack_listview_dump_start_address],rcx

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	test	[face.break_on],1 shl break_on_EXIT_THREAD_DEBUG_EVENT_bit
	jz	proc_EXIT_THREAD_DEBUG_EVENT_L0

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,[hDbgThread]
	call	SuspendThreadSafe
; we will wait here until user choose Run or Single Step, or Step Over, or ...

proc_EXIT_THREAD_DEBUG_EVENT_L0:
	mov	eax,dword [dbg_event.dwThreadId]
	call	remove_TID_ThreadLocalBase

	mov	eax,dword [dbg_event.dwThreadId]
	call	remove_TID_handle
	mov	eax,dword [dbg_event.dwProcessId]
	mov	edx,dword [dbg_event.dwThreadId]
	call	remove_PID_TID_pair

	call	switch_thread

;winternl.h
;//
;// use the Win32 API instead
;//     GetThreadIOPendingFlag
;//
;NTSTATUS
;NtQueryInformationThread (
;    IN HANDLE ThreadHandle,
;    IN THREADINFOCLASS ThreadInformationClass,
;    OUT PVOID ThreadInformation,
;    IN ULONG ThreadInformationLength,
;    OUT PULONG ReturnLength OPTIONAL
;    );

;00000000`7781fb0a 33c9             xor     ecx,ecx
;ntdll!DbgUiRemoteBreakin+0x3c:
;00000000`7781fb0c e8af96f4ff  call ntdll!RtlExitUserThread (00000000777691c0)
; ntdll!RtlExitUserThread:
;00000000`777691c0 fff3             push    rbx
;00000000`777691c2 4883ec30         sub     rsp,0x30
;00000000`777691c6 33c0             xor     eax,eax
;00000000`777691c8 8bd9             mov     ebx,ecx
;00000000`777691ca 4c8d442448 lea r8,[rsp+0x48] ss:00000000`020aff38=0000000000000000
;00000000`777691cf 448d4804    lea r9d,[rax+0x4] ds:00000000`00000004=????????
;00000000`777691d3 8d500c      lea edx,[rax+0xc] ds:00000000`0000000c=????????
;00000000`777691d6 488d48fe lea rcx,[rax-0x2] ds:ffffffff`fffffffe=????????????????
;00000000`777691da 89442448   mov [rsp+0x48],eax ss:00000000`020aff38=00000000
;00000000`777691de 4889442420 mov [rsp+0x20],rax ss:00000000`020aff10=0000000000000000
;00000000`777691e3 e8d8d60100 call ntdll!ZwQueryInformationThread (00000000777868c0)
;ntdll!ZwQueryInformationThread:
;00000000`777868c0 4c8bd1           mov     r10,rcx
;0:001> r rcx
;rcx=fffffffffffffffe
;0:001> r rdx
;rdx=000000000000000c
;0:001> r r8
;r8=00000000020aff38
;0:001> db r8
;00000000`020aff38  00 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00  ................
;00000000`020aff48  00 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00  ................
;00000000`020aff58  9d 58 63 77 00 00 00 00-00 00 00 00 00 00 00 00  .Xcw............
;00000000`020aff68  00 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00  ................
;0:001> r r9
;r9=0000000000000004
;0:001> p
;ntdll!ZwQueryInformationThread+0x3:
;00000000`777868c3 b822000000       mov     eax,0x22
;0:001> p
;ntdll!ZwQueryInformationThread+0x8:
;00000000`777868c8 0f05             syscall
;0:001> p
;ntdll!ZwQueryInformationThread+0xa:
;00000000`777868ca c3               ret
;0:001> t
;ntdll!RtlExitUserThread+0x28:
;00000000`777691e8 85c0             test    eax,eax
;0:001> db 20aff38
;00000000`020aff38  00 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00  ................
;00000000`020aff48  00 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00  ................
;00000000`020aff58  9d 58 63 77 00 00 00 00-00 00 00 00 00 00 00 00  .Xcw............
;00000000`020aff68  00 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00  ................
;0:001> t
;ntdll!RtlExitUserThread+0x2a:
;00000000`777691ea 7807 js ntdll!RtlExitUserThread+0x33 (00000000777691f3) [br=0]
;0:001> t
;ntdll!RtlExitUserThread+0x2c:
;00000000`777691ec 837c244800 cmp dword ptr [rsp+0x48],0x0 ss:00000000`020aff38=00000000
;0:001> t
;ntdll!RtlExitUserThread+0x31:
;00000000`777691f1 7515 jnz ntdll!RtlExitUserThread+0x48 (0000000077769208) [br=0]


;GetThreadIOPendingFlag
;The GetThreadIOPendingFlag function determines whether a specified thread has any I/O requests pending.
;
;BOOL GetThreadIOPendingFlag(
;  HANDLE hThread,
;  PBOOL lpIOIsPending
;);
;
;Parameters
;hThread 
;[in] Handle to the thread in question. This handle must have been created with the THREAD_QUERY_INFORMATION ;access right. For more information, see Thread Security and Access Rights. 
;lpIOIsPending 
;[in, out] Pointer to a variable which the function sets to TRUE if the specified thread has one or more I/O ;requests pending, or to FALSE otherwise. 
;Return Values
;If the function succeeds, the return value is nonzero. 
;If the function fails, the return value is zero. To get extended error information, call GetLastError.
;
;Remarks
;Keep in mind that the I/O status of the specified thread can change rapidly, and may already have changed by ;the time the function returns. For example, a pending I/O operation could complete between the time the ;function sets lpIOIsPending and the time it returns.





; If the continued thread previously reported an EXIT_THREAD_DEBUG_EVENT debugging event,
; ContinueDebugEvent closes the handle the debugger has to the thread.

	jmp	ContinueDebug_DBG_CONTINUE

proc_EXIT_PROCESS_DEBUG_EVENT:
; put something into the log
	mov	eax,dword [dbg_event.dwProcessId]
	lea	rdi,[exit_process_PID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.dwThreadId]
	lea	rdi,[exit_process_TID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.ExitProcess.dwExitCode]
	lea	rdi,[exit_process_exit_code_hexa]
	call	hexa_32_eax
	lea	rax,[exit_process_text]
	call	msg_to_LogEdit

; update SysListView32s, especially Code 1st
	mov	ecx,[dbg_event.dwThreadId]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	proc_EXIT_PROCESS_DEBUG_EVENT_L0
	mov	rax,qword [ThreadContext.Rip]
	mov	rcx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax
	mov	qword [Stack_listview_dump_start_address],rcx

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	test	[face.break_on],1 shl break_on_EXIT_PROCESS_DEBUG_EVENT_bit
	jz	proc_EXIT_PROCESS_DEBUG_EVENT_L0

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,[hDbgThread]
	call	SuspendThreadSafe
; we will wait here until user choose Run or Single Step, or Step Over, or ...

proc_EXIT_PROCESS_DEBUG_EVENT_L0:
	mov	eax,dword [dbg_event.dwThreadId]
	call	remove_TID_ThreadLocalBase

	mov	eax,dword [dbg_event.dwProcessId]
	call	remove_PID_PEB

; remove software breakpoints:
; we needn't to restore bytes in process, because process is exiting
; so we just clear our breakpoints store...
	mov	r11,qword [breakpoints_space_address]
	mov	ecx,MaxNumberOfBreakpoints
	xor	eax,eax
	lea	edx,[rcx-1]		; the smallest possible opcode, has 3 bytes only...
	lea	rdi,[r11+rcx*8]		; go to PIDs stored after SW BP addresses
	cld
	repnz scasd
	jnz	proc_EXIT_PROCESS_DEBUG_EVENT_L1
	sub	edx,ecx
	mov	qword [r11+rdx*8],rax	; clear address
	mov	dword [rdi-4],eax	; clear PID
	mov	byte [r11+(8+4)*MaxNumberOfBreakpoints+rdx*1],al	; clear store of byte on SW BP address
	mov	byte [r11+(8+4+1)*MaxNumberOfBreakpoints+rdx*1],al	; clear SW BP flag
proc_EXIT_PROCESS_DEBUG_EVENT_L1:

; remove debug symbols
; decommit memory storing module info
	mov	eax,[dbg_event.dwProcessId]
	mov	rcx,flag_module_process*100000000h
	or	rax,rcx			; prepare PID and flag to be checked

	mov	rdi,qword [module_info_address]
	mov	ecx,MaxNumberOfModulesInfo
	add	rdi,24*MaxNumberOfModulesInfo
	cld
proc_EXIT_PROCESS_DEBUG_EVENT_L6:
	repnz scasq
	jnz	proc_EXIT_PROCESS_DEBUG_EVENT_L2
	sub	rdi,24*MaxNumberOfModulesInfo
	mov	rcx,qword [rdi-8+16*MaxNumberOfModulesInfo]	; memory offset, module info
	jrcxz	proc_EXIT_PROCESS_DEBUG_EVENT_L5
	mov	r8d,MEM_DECOMMIT
	mov	edx,dword [rcx]			; size of allocated memory for store module info
	call	qword [VirtualFree]
	xor	ecx,ecx
proc_EXIT_PROCESS_DEBUG_EVENT_L5:
; release module info in module_info_address
	mov	qword [rdi-8],rcx		; clear module base
	mov	qword [rdi-8 + 8*MaxNumberOfModulesInfo],rcx	; clear module end
	mov	qword [rdi-8 +16*MaxNumberOfModulesInfo],rcx	; clear address for store address of allocated memory
	mov	qword [rdi-8 +24*MaxNumberOfModulesInfo],rcx	; clear PID and flag

	sub	rdi,qword [module_info_address]
	shr	edi,3				; edi/8
	lea	ecx,[(rdi-1)+SymbolIndexFirst]	; rdi-1 because rdi was +8 before shr
	call	qword [SymCleanup]		; and cleanup debug info of dbghelp.dll if
						; any (we don't worry if any info or none)

proc_EXIT_PROCESS_DEBUG_EVENT_L2:
	dec	[num_of_processes]
	mov	eax,dword [dbg_event.dwProcessId]
	call	remove_PID_handle
	mov	eax,dword [dbg_event.dwThreadId]
	call	remove_TID_handle
	mov	eax,dword [dbg_event.dwProcessId]
	mov	edx,dword [dbg_event.dwThreadId]
	call	remove_PID_TID_pair

	call	switch_thread

; If the continued thread previously reported an EXIT_PROCESS_DEBUG_EVENT debugging event,
; ContinueDebugEvent closes the handles the debugger has to the process and to the thread.
	jmp	ContinueDebug_DBG_CONTINUE

proc_LOAD_DLL_DEBUG_EVENT:
	mov	eax,dword [dbg_event.dwProcessId]
	lea	rdi,[load_dll_PID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.dwThreadId]
	lea	rdi,[load_dll_TID_hexa]
	call	hexa_32_eax

; find first empty slot in dll_info, 1st is occupied by debuggee process itself
	mov	rdi,qword [module_info_address]
	mov	ecx,MaxNumberOfModulesInfo
	xor	eax,eax
	cld
	repnz scasq
	jnz	proc_LOAD_DLL_DEBUG_EVENT_not_enough_store
	lea	rbx,[rdi-8]			; input parameter of obtain_module_info
	mov	rax,qword [dbg_event.LoadDll.lpBaseOfDll]
	mov	ecx,dword [dbg_event.dwProcessId]
	mov	dword [rbx+24*MaxNumberOfModulesInfo + 4],flag_module_DLL
	call	obtain_module_info

	mov	rdx,qword [dbg_event.LoadDll.hFile]
	sub	rdi,qword [module_info_address]
	shr	edi,3				; edi/8
	lea	ecx,[(rdi-1)+SymbolIndexFirst]	; rdi-1 because rdi was +8 before shr
	call	get_dbghelp_sym

	mov	rax,qword [rbx+0*MaxNumberOfModulesInfo] ; = qword [dbg_event.LoadDll.lpBaseOfDll]
	lea	rdi,[load_dll_base_of_dll_hexa]
	call	hexa_64_rax

	mov	rax,qword [rbx+8*MaxNumberOfModulesInfo]
	lea	rdi,[load_dll_base_of_dll_end_hexa]
	call	hexa_64_rax

;	mov	r8d,512
;	lea	rdx,[load_dll_image_name]
;	mov	rcx,qword [dbg_event.LoadDll.lpBaseOfDll]
;	call	qword [GetModuleFileNameA]
;	lea	rcx,[load_dll_image_name]
;	mov	byte [rcx+rax*1],0	; make 0-terminated string


;	mov	edx,dword [dbg_event.dwProcessId]
;	mov	rax,qword [dbg_event.LoadDll.lpBaseOfDll]
;	call	get_SymIndex
;	jc	proc_LOAD_DLL_DEBUG_EVENT_msg_L5
;
;	lea	r8,[tmp_buf]
;	mov	rdx,qword [dbg_event.LoadDll.lpBaseOfDll]
;	mov	rcx,rax
;	mov	[r8+IMAGEHLP_MODULE64.SizeOfStruct],0CB8h;01D0;0688h;0CB8h;tmp_buf_size
;; 680h;
;; 8h, 40h, 
;	call	qword [SymGetModuleInfoW64]
;proc_LOAD_DLL_DEBUG_EVENT_msg_L5:
;
;SymGetModuleBase64

; everything above is wrong (GetModuleFileNameA search in fdbg.exe itself, not in debuggee)
; this is correct:
	lea	rdi,[load_dll_image_name]
	mov	byte [rdi],0
	mov	ecx,dword [dbg_event.dwProcessId]
	mov	rax,qword [dbg_event.LoadDll.lpBaseOfDll]
	call	baseaddress2dllname

; Kurnik to urobime vdaka noimports64 netreba API:
; bad idea, names are without path
; even worse, there aren't any names there...
;	mov	rsi,qword [dbg_event+10h+8*3]
;mov rsi,[dbg_event.LoadDll.lpImageName]
;	lea	rdi,[load_dll_image_name]
;	or	rsi,rsi
;	jz	procedure_LOAD_DLL_DEBUG_EVENT_L6
;;	lea	rax,[fast_move_string]
;;	lea	rcx,[move_unicode_LogEdit00]
;	cmp	word [dbg_event+10h+8*4],0
;	cmovnz	rax,rcx
;	call	rax
;procedure_LOAD_DLL_DEBUG_EVENT_L6:
;	mov	eax,0A0Dh
;	stosd
;	xor	eax,eax
;	stosb

	xor	eax,eax
	mov	rcx,[dbg_event.LoadDll.hFile]
	call	find_dll_entrypoint
	jc	proc_LOAD_DLL_DEBUG_EVENT_L7
	or	eax,eax			; ntdll.dll has not entrypoint
	jz	proc_LOAD_DLL_DEBUG_EVENT_L7
	add	rax,[dbg_event.LoadDll.lpBaseOfDll]
proc_LOAD_DLL_DEBUG_EVENT_L7:
	lea	rdi,[load_dll_entrypoint_hexa]
	call	hexa_64_rax

	lea	rax,[load_dll_text]
proc_LOAD_DLL_DEBUG_EVENT_msg_end:
	call	msg_to_LogEdit

; hFile When the debugger is finished with this file, it should close the handle using the CloseHandle function.
	mov	rcx,qword [dbg_event.LoadDll.hFile]
	call	qword [CloseHandle]

	test	[face.break_on],1 shl break_on_LOAD_DLL_DEBUG_EVENT_bit
	jz	proc_LOAD_DLL_DEBUG_EVENT_end

	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,[ThreadContext.Rip]
	mov	rcx,[ThreadContext.Rsp]
	mov	[Code_listview_dump_start_address],rax
	mov	[Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,[hDbgThread]
	call	SuspendThreadSafe
; we will wait here until user choose Run or Single Step, or Step Over, or ...

proc_LOAD_DLL_DEBUG_EVENT_end:
	jmp	ContinueDebug_DBG_CONTINUE
proc_LOAD_DLL_DEBUG_EVENT_not_enough_store:
	lea	rax,[msg_proc_LOAD_DLL_DEBUG_EVENT_not_enough_store]
	jmp	proc_LOAD_DLL_DEBUG_EVENT_msg_end

proc_UNLOAD_DLL_DEBUG_EVENT:
	mov	eax,dword [dbg_event.dwProcessId]
	lea	rdi,[unload_dll_PID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.dwThreadId]
	lea	rdi,[unload_dll_TID_hexa]
	call	hexa_32_eax
	mov	rax,qword [dbg_event.UnloadDll.lpBaseOfDll]
	lea	rdi,[unload_dll_base_of_dll_hexa]
	call	hexa_64_rax

	test	[face.break_on],1 shl break_on_UNLOAD_DLL_DEBUG_EVENT_bit
	jz	proc_UNLOAD_DLL_DEBUG_EVENT_L0

	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,[ThreadContext.Rip]
	mov	rcx,[ThreadContext.Rsp]
	mov	[Code_listview_dump_start_address],rax
	mov	[Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,[hDbgThread]
	call	SuspendThreadSafe
; we will wait here until user choose Run or Single Step, or Step Over, or ...

proc_UNLOAD_DLL_DEBUG_EVENT_L0:

; decommit memory storing module info
	mov	edx,dword [dbg_event.dwProcessId]
	mov	rdi,qword [module_info_address]
	mov	ecx,MaxNumberOfModulesInfo
	cld
proc_UNLOAD_DLL_DEBUG_EVENT_L6:
	repnz scasq
	jnz	proc_UNLOAD_DLL_DEBUG_EVENT_L7
if flag_module_DLL = 0
	cmp	qword [rdi-8+24*MaxNumberOfModulesInfo],rdx
	jnz	proc_UNLOAD_DLL_DEBUG_EVENT_L6
else
	cmp	dword [rdi-8+24*MaxNumberOfModulesInfo],edx	; check if DLL info record match process ID (this process loaded the DLL)
	jnz	proc_UNLOAD_DLL_DEBUG_EVENT_L6
	cmp	dword [rdi-8+24*MaxNumberOfModulesInfo + 4],flag_module_DLL
	jnz	proc_UNLOAD_DLL_DEBUG_EVENT_L6
end if
	mov	rcx,qword [rdi-8+16*MaxNumberOfModulesInfo]	; memory offset, module info
	jrcxz	proc_UNLOAD_DLL_DEBUG_EVENT_L5
	mov	r8d,MEM_DECOMMIT
	mov	edx,dword [rcx]			; size of allocated memory for store module info
	call	qword [VirtualFree]
	xor	ecx,ecx
proc_UNLOAD_DLL_DEBUG_EVENT_L5:
; release module info in module_info_address
	mov	qword [rdi-8],rcx		; clear module base
	mov	qword [rdi-8 + 8*MaxNumberOfModulesInfo],rcx	; clear module end
	mov	qword [rdi-8 +16*MaxNumberOfModulesInfo],rcx	; clear address for store address of allocated memory
	mov	qword [rdi-8 +24*MaxNumberOfModulesInfo],rcx	; clear PID and flag

	sub	rdi,qword [module_info_address]
	shr	edi,3				; edi/8
	lea	ecx,[(rdi-1)+SymbolIndexFirst]	; rdi-1 because rdi was +8 before shr
	call	qword [SymCleanup]		; and cleanup debug info of dbghelp.dll if
						; any (we don't worry if any info or none)

proc_UNLOAD_DLL_DEBUG_EVENT_L7:
	lea	rax,[unload_dll_text]
	call	msg_to_LogEdit

	jmp	ContinueDebug_DBG_CONTINUE

proc_OUTPUT_DEBUG_STRING_EVENT:
	mov	eax,dword [dbg_event.dwProcessId]
	lea	rdi,[output_debug_string_PID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.dwThreadId]
	lea	rdi,[output_debug_string_TID_hexa]
	call	hexa_32_eax
	mov	rax,qword [dbg_event.DebugString.lpDebugStringData]
	lea	rdi,[output_debug_string_data_hexa]
	call	hexa_64_rax
;	movzx	eax,[dbg_event.DebugString.fUnicode]
;	movzx	eax,[dbg_event.DebugString.nDebugStringLength]
	lea	rax,[output_debug_string_text]
	call	msg_to_LogEdit

	movzx	ebx,[dbg_event.DebugString.nDebugStringLength]
	mov	eax,tmp_buf_size-4
	mov	ecx,[dbg_event.dwProcessId]
	cmp	eax,ebx
	lea	rsi,[dbg_event.DebugString.lpDebugStringData]
	cmovc	ebx,eax
	lea	rdi,[tmp_buf]
	call	read_debuggee_memory
	jc	proc_OUTPUT_DEBUG_STRING_EVENT_L9

	movzx	ecx,[dbg_event.DebugString.nDebugStringLength]
	lea	rsi,[rdi]			; = tmp_buf
	lea	rax,[rdi]
	cmp	byte [dbg_event.DebugString.fUnicode],0
	jz	proc_OUTPUT_DEBUG_STRING_EVENT_L8
	cld
	push	rcx
proc_OUTPUT_DEBUG_STRING_EVENT_L7:
	movsb
	inc	rsi
	loop	proc_OUTPUT_DEBUG_STRING_EVENT_L7
	mov	byte [rdi],cl			; 0-terminator
	pop	rcx

proc_OUTPUT_DEBUG_STRING_EVENT_L8:
	lea	rdi,[rax+rcx*1]
	mov	byte [rdi],0		; 0-terminator
; change new line at the end from 0Ah to 0Dh,0Ah
	cmp	byte [rdi-1],0Ah
	jz	proc_OUTPUT_DEBUG_STRING_EVENT_L5
	dec	rdi
proc_OUTPUT_DEBUG_STRING_EVENT_L5:
	cmp	byte [rdi-1],0Ah
	jnz	proc_OUTPUT_DEBUG_STRING_EVENT_L9
	cmp	byte [rdi-2],0Dh
	jz	proc_OUTPUT_DEBUG_STRING_EVENT_L9
	mov	dword [rdi-1],00000A0Dh

proc_OUTPUT_DEBUG_STRING_EVENT_L9:
; rax=tmp_buf
	call	msg_to_LogEdit

	test	[face.break_on],1 shl break_on_OUTPUT_DEBUG_STRING_EVENT_bit
	jnz	proc_OUTPUT_DEBUG_STRING_EVENT_end

	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,[ThreadContext.Rip]
	mov	rcx,[ThreadContext.Rsp]
	mov	[Code_listview_dump_start_address],rax
	mov	[Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,[hDbgThread]
	call	SuspendThreadSafe
; we will wait here until user choose Run or Single Step, or Step Over, or ...

proc_OUTPUT_DEBUG_STRING_EVENT_end:
	jmp	ContinueDebug_DBG_CONTINUE

proc_RIP_EVENT:
	mov	eax,dword [dbg_event.dwProcessId]
	lea	rdi,[rip_event_PID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.dwThreadId]
	lea	rdi,[rip_event_TID_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.RipInfo.dwError]
	lea	rdi,[rip_event_error_hexa]
	call	hexa_32_eax
	mov	eax,dword [dbg_event.RipInfo.dwType]
;dwType 
;Any additional information about the type of error that caused the RIP debug event. This member can be one of the following values.Value Meaning 
;SLE_ERROR
;0x00000001 Indicates that invalid data was passed to the function that failed. This caused the application to fail. 
;SLE_MINORERROR
;0x00000002 Indicates that invalid data was passed to the function, but the error probably will not cause the application to fail. 
;SLE_WARNING
;0x00000003 Indicates that potentially invalid data was passed to the function, but the function completed processing. 
;0 Indicates that only dwError was set. 
	lea	rdi,[rip_event_type_hexa]
	call	hexa_32_eax
	lea	rax,[rip_event_text]
	call	msg_to_LogEdit

	test	[face.break_on],1 shl break_on_RIP_EVENT_bit
	jz	proc_RIP_EVENT_end

	mov	ecx,dword [dbg_event.dwThreadId]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,[ThreadContext.Rip]
	mov	rcx,[ThreadContext.Rsp]
	mov	[Code_listview_dump_start_address],rax
	mov	[Stack_listview_dump_start_address],rcx
	mov	qword [ListView_selected_iItem+8*0],1	; select item0 of code 1st

	call	code_1st_disassemble_back

	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	display_regs_memory	; update SysListView32s

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed

	mov	rcx,[hDbgThread]
	call	SuspendThreadSafe
; we will wait here until user choose Run or Single Step, or Step Over, or ...

proc_RIP_EVENT_end:
	jmp	ContinueDebug_DBG_CONTINUE


align 10h
obtain_module_info:
; input:	rax module base
;		rbx	to store module begin at [rbx]
;			to store module end at [rbx+8*MaxNumberOfModulesInfo]
;			to store module info at [rbx+16*MaxNumberOfModulesInfo]
;		ecx PID (process Id) owning module
; output:	fill qword [rbx], qword [rbx+8*...], qword [rbx+16*...], dword [rbx+24*...]
;		note that dword [rbx+24*...+4] holds flag_module_DLL or flag_module_process
; module info structure:
; 0*4	dword size of allocated memory
; 1*4	dword NumberOfFunctions=NumberOfNames
; NumberOfFunctions*4 RVA of Functions
; NumberOfNames*4 RVA of Names
; ModuleName
; NumberOfFunctions times FunctionName

	push	rbp rsi rdi r10 rax rbx rcx rdx r8 r9
	sub	rsp,8*(4+3)

	mov	[rbx],rax			; module begin
	mov	[rbx+24*MaxNumberOfModulesInfo],ecx	; PID

;	mov	byte [rsp+8*(4+2)],1		; assume we failed

; ------ get module size
	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	edx,obtain_module_info_get_size
	xor	ecx,ecx
	call	[VirtualAlloc]
	or	rax,rax
	setz	byte [rsp+8*(4+2)]
	jz	obtain_module_info_end_2

	lea	rsi,[rsp+8*(4+3+5)]		; lpBaseOfImage lpBaseOfDll
	lea	rdi,[rax]			; address of allocated memory
	mov	ebx,obtain_module_info_get_size
	mov	ecx,dword [rsp+8*(4+3+3)]	; grab ECX PID pushed in the stack
	call	read_debuggee_memory		; read rbx bytes from debuggee [rsi] to debugger rdi
	setc	byte [rsp+8*(4+0)]
	jc	obtain_module_info_end_2

	cmp	[rdi+IMAGE_DOS_HEADER.e_magic],IMAGE_DOS_SIGNATURE
	setnz	byte [rsp+8*(4+2)]
	jnz	obtain_module_info_end_2
	mov	eax,[rdi+IMAGE_DOS_HEADER.e_lfanew]
	cmp	[rdi+rax+IMAGE_NT_HEADERS64.Signature],IMAGE_NT_SIGNATURE
	setnz	byte [rsp+8*(4+2)]
	jnz	obtain_module_info_end_2
	cmp	[rdi+rax+IMAGE_NT_HEADERS64.FileHeader.Machine],IMAGE_FILE_MACHINE_AMD64
	setnz	byte [rsp+8*(4+2)]
	jnz	obtain_module_info_end_2
	mov	esi,[rdi+rax+IMAGE_NT_HEADERS64.OptionalHeader.DataDirectory.VirtualAddress]	; export RVA
; note, for i386 dll export RVA is at 78h, instead of 88h for AMD64
	mov	eax,[rdi+rax+IMAGE_NT_HEADERS64.OptionalHeader.SizeOfImage]

	mov	rbx,[rsp+8*(4+3+4)]			; get rbx pushed in the stack
	add	rax,[rbx]				; add module begin address
	mov	[rbx+8*MaxNumberOfModulesInfo],rax	; module end

	mov	r8d,MEM_DECOMMIT
	mov	edx,obtain_module_info_get_size
	mov	rcx,rdi					; address of allocated memory
	call	[VirtualFree]
	or	rax,rax
	setz	byte [rsp+8*(4+2)]
	jz	obtain_module_info_end_2
; ------ got module size

	or	esi,esi					; export RVA
	jz	obtain_module_info_end_2		; process exe hasn't exports, only DLL modules have

; here we go if new dll module loaded
; at the first, we allocate memory for store dll info
	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	rdx,[rbx+8*MaxNumberOfModulesInfo]	; module end
	sub	rdx,[rbx]				; subtract module begin, we get module size
; edx=module size this will be enough, we release some unnecessary memory after done
	xor	ecx,ecx
	call	[VirtualAlloc]
	or	rax,rax
	setz	byte [rsp+8*(4+2)]
	jz	obtain_module_info_end_2
	mov	[rbx+16*MaxNumberOfModulesInfo],rax	; module info
; it is necessary to clear this qword if anything following fails !!!

; we allocate temporary memory for read the whole DLL
	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	rdx,[rbx+8*MaxNumberOfModulesInfo]	; module end
	sub	rdx,[rbx]				; module begin
; edx=module size
	xor	ecx,ecx
	call	[VirtualAlloc]
	or	rax,rax
	setz	byte [rsp+8*(4+2)]
	jz	obtain_module_info_end
	mov	[rsp+8*(4+2)],rax			; store address of temp buffer

	lea	rsi,[rsp+8*(4+3+5)]			; lpBaseOfImage lpBaseOfDll
	lea	rdi,[rax]
	mov	rdx,[rbx+8*MaxNumberOfModulesInfo]	; module end
	sub	rdx,[rbx]				; module begin
	mov	rbx,rdx					; module size
	mov	ecx,[rsp+8*(4+3+3)]			; grab ECX PID pushed in the stack
	call	read_debuggee_memory			; read rbx bytes from debuggee [rsi] to debugger rdi
	setc	byte [rsp+8*(4+2)]
	jc	obtain_module_info_terminate

	mov	rbx,[rsp+8*(4+3+4)]
	mov	rbx,[rbx+16*MaxNumberOfModulesInfo]	; module info

	lea	r8,[rdi]
	cmp	[rdi+IMAGE_DOS_HEADER.e_magic],IMAGE_DOS_SIGNATURE
	setnz	byte [rsp+8*(4+2)]
	jnz	obtain_module_info_terminate
	mov	eax,[rdi+IMAGE_DOS_HEADER.e_lfanew]
	cmp	[rdi+rax*1+IMAGE_NT_HEADERS64.Signature],IMAGE_NT_SIGNATURE
	setnz	byte [rsp+8*(4+2)]
	jnz	obtain_module_info_terminate
	cmp	[rdi+rax*1+IMAGE_NT_HEADERS64.FileHeader.Machine],IMAGE_FILE_MACHINE_AMD64
	setnz	byte [rsp+8*(4+2)]
	jnz	obtain_module_info_terminate
	mov	r9d,[rdi+rax*1+IMAGE_NT_HEADERS64.OptionalHeader.DataDirectory.VirtualAddress]	; export RVA
; note, for i386 dll export RVA is at 78h, instead of 88h for AMD64

; we process DLL exports...
;;; !!!	mov	eax,[r8+r9*1+IMAGE_EXPORT_DIRECTORY.NumberOfFunctions]	; note NumberOfFunctions should be > NumberOfNames
	mov	eax,[r8+r9*1+IMAGE_EXPORT_DIRECTORY.NumberOfNames]	; we grab NumberOfNames instead of NumberOfFunctions
; if it is 0 then we only store DLL name
	mov	[rbx+1*4],eax

; first we store module name:
	mov	esi,[r8+r9*1+IMAGE_EXPORT_DIRECTORY.Name]
	lea	rsi,[r8+rsi*1]
	lea	rdi,[rbx+rax*8+2*4]		; 2*4 is module info header size

	call	fast_move_0_terminated_string_0_terminator
	mov	rbp,rdi				; save rdi
	or	eax,eax				; NumberOfNames (fast_move_0_terminated_string_0_terminator doesn't touch RAX)
	jz	obtain_module_info_finish

	lea	rdx,[rdi]
	sub	rdx,[rbx]

	xor	eax,eax
find_module_function:
	mov	edx,[r8+r9*1+IMAGE_EXPORT_DIRECTORY.AddressOfNameOrdinals]
	or	edx,edx
	setz	byte [rsp+8*(4+2)]
	jz	obtain_module_info_terminate

	lea	rdx,[r8+rdx*1]
	movzx	edx,word [rdx+rax*2]

	mov	ecx,[r8+r9*1+IMAGE_EXPORT_DIRECTORY.AddressOfFunctions]
	or	ecx,ecx
	setz	byte [rsp+8*(4+2)]
	jz	obtain_module_info_terminate

	lea	rcx,[r8+rcx*1]
	mov	ecx,[rcx+rdx*4]
	mov	[rbx+rax*4+2*4],ecx		; 2*4 size of info header

	mov	edx,[r8+r9*1+IMAGE_EXPORT_DIRECTORY.NumberOfNames]	; we grab NumberOfNames instead of NumberOfFunctions
	lea	rdx,[rbx+rdx*4]
	mov	rcx,rbp
	sub	rcx,rbx
	mov	[rdx+rax*4+2*4],ecx		; 2*4 size of info header

	mov	esi,[r8+r9*1+IMAGE_EXPORT_DIRECTORY.AddressOfNames]
	or	esi,esi
	setz	byte [rsp+8*(4+2)]
	jz	obtain_module_info_terminate

	lea	rsi,[r8+rsi*1]
	mov	esi,[rsi+rax*4]
	lea	rsi,[r8+rsi*1]
	mov	rdi,rbp
	call	fast_move_0_terminated_string_0_terminator
	mov	rbp,rdi
	inc	eax
	cmp	eax,[r8+r9*1+IMAGE_EXPORT_DIRECTORY.NumberOfNames]	; check NumberOfNames instead of NumberOfFunctions
	jc	find_module_function

obtain_module_info_finish:
	sub	rbp,rbx
	mov	[rbx],ebp

obtain_module_info_terminate:
	mov	rbx,[rsp+8*(4+3+4)]
; we decommit temporary memory for read the whole DLL
	mov	r8d,MEM_DECOMMIT
	mov	rdx,[rbx+8*MaxNumberOfModulesInfo]	; module end
	sub	rdx,[rbx]			; module begin
	mov	rcx,[rsp+8*(4+2)]		; address of temp memory
	call	[VirtualFree]

obtain_module_info_end:
	mov	rbx,[rsp+8*(4+3+4)]
; decommit unnecessary memory at the end of module info
	mov	edx,[rbx+8*MaxNumberOfModulesInfo]	; module end
	sub	rdx,[rbx]			; module begin
	mov	rcx,[rbx+16*MaxNumberOfModulesInfo]	; address of allocated memory
	mov	eax,[rcx]
;	or	eax,eax
; align size to next memory page
	add	eax,page_size_for_AMD64 - 1
	and	eax,0FFFFFFFFh - (page_size_for_AMD64 - 1)
; we have size aligned to next memory page
	sub	edx,eax
	add	rcx,rax
	mov	r8d,MEM_DECOMMIT
	call	[VirtualFree]

obtain_module_info_end_2:
	mov	rbx,[rsp+8*(4+3+4)]		; thank to Garthower for finding this bug - missed restored RBX
	add	rsp,8*(4+2)
	pop	rcx				; we need "status byte" set by setc setz...
						; now it is in CL register
	xor	eax,eax
	sub	al,cl				; this clear/set CarryFlag, set carry if CL=1
	jnc	obtain_module_info_end_3
	and	qword [rbx+16*MaxNumberOfModulesInfo],0	; module info
; it is necessary to clear this qword if anything failed !!!

obtain_module_info_end_3:
	pop	r9 r8 rdx rcx rbx rax r10 rdi rsi rbp
	ret

align 16
address2ms_symbol:
; in:	rax address
;	ecx PID
;	rdi buffer
; out:	Carry Flag clear if such symbol found + update buffer pointer, CF=1 if no symbol

	push	rax rcx rdx rsi r8 r9 r10 r11
	sub	rsp,8*(4+1)

; microsoft symbols are disabled by default, caused bugs after installing LiveKD - thanx to Krod - another ; solution is to remove _NT_SYMBOL_PATH environment variable (added by LiveKD). Krod reversed SymIntialize, and ; discovered that symsvrClose(void) tried to free a module already freed
; it was caused by calling ntdll.RtlImageNtHeaderEx with RDX=-2 (-2=FFFFFFFFFFFFFFFEh=handle of current thread)
	test	[face.display_symbols],display_allow_microsoft_symbols
	jz	address2ms_symbol_failed

	mov	rdx,qword [module_info_address]
	mov	esi,MaxNumberOfModulesInfo
AMDPad16	;align 16
address2ms_symbol_try_find_base:
	cmp	dword [rdx+24*MaxNumberOfModulesInfo],ecx; check whether PID match
	jnz	address2ms_symbol_try_find_base_end
	cmp	qword [rdx],rax
	jnbe	address2ms_symbol_try_find_base_end
	cmp	qword [rdx+8*MaxNumberOfModulesInfo],rax
	jnc	address2ms_symbol_have_base

address2ms_symbol_try_find_base_end:
	add	rdx,8
	dec	esi
	jnz	address2ms_symbol_try_find_base

address2ms_symbol_failed:
	stc
	jmp	address2ms_symbol_epi

address2ms_symbol_have_base:
	sub	rdx,qword [module_info_address]
	shr	edx,3				; edx/8
	lea	ecx,[rdx+SymbolIndexFirst]

	lea	r9,[sym_buf]
	mov	[r9+SYMBOL_INFO64.SizeOfStruct],sizeof.SYMBOL_INFO64
	mov	[r9+SYMBOL_INFO64.MaxNameLen],MAX_SYM_NAME
	and	[r9+SYMBOL_INFO64.Address],0
	and	[r9+SYMBOL_INFO64.Name],0
	and	[sym_buf.NameLen],0
	lea	r8,[rsp+8*(4+0)]	; displacement, the difference from real address
	mov	rdx,rax			; address
	call	qword [SymFromAddr]
	or	eax,eax
	jz	address2ms_symbol_failed

	movzx	eax,[face.display_symbols]
	and	eax,display_symbols_offset
	lea	rdx,[display_symbols_procedures]
	mov	ecx,dword [rsp+8*(4+0)]	; displacement
	call	qword [rdx+rax*8]

address2ms_symbol_epi:
	lea	rsp,[rsp+8*(4+1)]
	pop	r11 r10 r9 r8 rsi rdx rcx rax
	ret

align 16
display_symbols_procedure00:
; display symbol only when address match exactly (displacement=0)
	or	ecx,ecx
	stc
	jnz	display_symbols_procedure00_ret
	push	rsi
	lea	rsi,[sym_buf.Name]
;	mov	ecx,[sym_buf.NameLen]	; older versions of dbghelp.dll don't fill NameLen
;	cld
;	repz movsb
	call	fast_move_0_terminated_string
	pop	rsi
	mov	byte [rdi],0
	clc				; success
display_symbols_procedure00_ret:
	ret

align 16
display_symbols_procedure01:
; display symbol +difference
	push	rsi
	push	rcx
	lea	rsi,[sym_buf.Name]
;	mov	ecx,[sym_buf.NameLen]	; older versions of dbghelp.dll don't fill NameLen
;	cld
;	repz movsb
	call	fast_move_0_terminated_string
	pop	rax			; displacement
	or	eax,eax
	jz	display_symbols_procedure01_displacement_done
	mov	byte [rdi],'+'
	inc	rdi
	call	hexa_32_eax
	add	rdi,8
display_symbols_procedure01_displacement_done:
	mov	byte [rdi],0		; zero-terminator
	clc				; success
	pop	rsi
	ret

align 16
address2symbol:
; shows exports from DLLs and exports from exe
; input:	rax	address
;		ecx	PID
;		rdi	buffer to store string if any (e.g. ntdll.DbgBreakPoint, kernel32.ExitProcess, ...)
; out:		the same like address2ms_symbol
	push	rax rcx rdx rbx rsi rdi
	or	rax,rax
	jz	address2symbol_failed
	or	rdi,rdi
	jz	address2symbol_failed

	mov	rdx,qword [module_info_address]
	mov	esi,MaxNumberOfModulesInfo
AMDPad16	;align 16
address2symbol_try_find_base:
	cmp	dword [rdx+24*MaxNumberOfModulesInfo],ecx; check whether PID match
	jnz	address2symbol_try_find_base_end
	cmp	qword [rdx],rax
	jz	address2symbol_have_pure_base
;	jnbe	address2symbol_try_find_base_end
; if we checked zero flag, it is enough to check CF without checking ZF again
	jnc	address2symbol_try_find_base_end
	cmp	qword [rdx+8*MaxNumberOfModulesInfo],rax
	jnc	address2symbol_have_base

address2symbol_try_find_base_end:
	add	rdx,8
	dec	esi
	jnz	address2symbol_try_find_base

address2symbol_failed:
	pop	rdi
	stc
	jmp	address2symbol_epilogue

address2symbol_have_base:
	mov	rbx,qword [rdx+16*MaxNumberOfModulesInfo]	; module info
	or	rbx,rbx					; isn't it empty ?
	jz	address2symbol_failed

	sub	rax,qword [rdx]
	mov	ecx,dword [rbx+1*4]		; NumberOfFunctions
	lea	rdi,[rbx+2*4]			; begin of NumberOfFunctions*4 RVA of Functions
	cld
	repnz scasd
	jnz	address2symbol_failed

	mov	ecx,dword [rbx+1*4]		; NumberOfFunctions
	mov	eax,dword [rdi+rcx*4 - 4]
	lea	rdx,[rbx+rax*1]			; API name

	pop	rdi

	mov	eax,dword [rbx+1*4]		; NumberOfFunctions
	lea	rsi,[rbx+rax*8 + 2*4]		; 2*4 info header size

	call	fast_move_dot_terminated_string_dot_terminator

	lea	rsi,[rdx]
	call	fast_move_0_terminated_string

address2symbol_success:
	mov	byte [rdi],0
	clc

address2symbol_epilogue:
	pop	rsi rbx rdx rcx rax
	ret

address2symbol_have_pure_base:
	mov	rbx,qword [rdx+16*MaxNumberOfModulesInfo]	; module info
	or	rbx,rbx					; isn't it empty ?
	jz	address2symbol_failed

	pop	rdi

	mov	eax,dword [rbx+1*4]		; NumberOfFunctions
	lea	rsi,[rbx+rax*8 + 2*4]		; 2*4 info header size

;	call	fast_move_dot_terminated_string
	call	fast_move_0_terminated_string
	jmp	address2symbol_success

align 16
address2symbol_proximus:
; shows exports from DLLs and exports from exe
; input:	rax	address
;		ecx	PID
;		rdi	buffer to store string if any (e.g. ntdll.DbgBreakPoint, kernel32.ExitProcess, ...)
; out:		the same like address2ms_symbol
	push	rax rcx rdx rbx rsi rdi
	or	rax,rax
	jz	address2symbol_proximus_failed
	or	rdi,rdi
	jz	address2symbol_proximus_failed

	mov	rdx,qword [module_info_address]
	mov	esi,MaxNumberOfModulesInfo
AMDPad16	;align 16
address2symbol_proximus_try_find_base:
	cmp	dword [rdx+24*MaxNumberOfModulesInfo],ecx; check whether PID matches
	jnz	address2symbol_proximus_try_find_base_end
	cmp	qword [rdx],rax
;	jz	address2symbol_proximus_have_pure_base
	jz	address2symbol_have_pure_base		; procedure is common for both address2symbol as well address2symbol_proximus
;	jnbe	address2symbol_proximus_try_find_base_end
; if we checked zero flag, it is enough to check CF without checking ZF again
	jnc	address2symbol_proximus_try_find_base_end
	cmp	qword [rdx+8*MaxNumberOfModulesInfo],rax
	jnc	address2symbol_proximus_have_base

address2symbol_proximus_try_find_base_end:
	add	rdx,8
	dec	esi
	jnz	address2symbol_proximus_try_find_base

address2symbol_proximus_failed:
	pop	rdi
	stc
	jmp	address2symbol_proximus_epilogue

address2symbol_proximus_have_base:
	mov	rbx,qword [rdx+16*MaxNumberOfModulesInfo]	; module info
	or	rbx,rbx					; isn't it empty ?
	jz	address2symbol_proximus_failed

	sub	rax,qword [rdx]
	mov	ecx,dword [rbx+1*4]		; NumberOfFunctions
	lea	rdi,[rbx+2*4]			; begin of NumberOfFunctions*4 RVA of Functions

	push	r8 r9
	or	r8d,-1				; maximal possible 32-bit number FFFFFFFF
	mov	rsi,rdi
; speedup loop by aligning the begin
AMDPad16
address2symbol_proximus_L0:
	mov	edx,eax
	sub	edx,[rdi]
;	jc	...skip
; this is faster:
	sbb	r9d,r9d				; r9d=FFFFFFFF if sub edx,eax set carry flag
						; r9d=00000000 if sub edx,eax didn't set carry flag
	or	edx,r9d				; set edx the highest posible 32-bit value if r9d=FFFFFFFF
						; leave edx untouched if r9d=0
	cmp	r8d,edx
	cmovnbe	r8d,edx
	cmovnbe	rsi,rdi	
	add	rdi,4
	loop	address2symbol_proximus_L0
	mov	ecx,r8d

	pop	r9 r8

	cmp	ecx,-1				; nothing found, display module name at least...
	cmovz	ecx,eax				; place back shift into ecx from eax

	mov	edx,dword [rbx+1*4]		; NumberOfFunctions
	mov	eax,dword [rsi+rdx*4]
	lea	rdx,[rbx+rax*1]			; API name

	pop	rdi

	mov	eax,dword [rbx+1*4]		; NumberOfFunctions
	lea	rsi,[rbx+rax*8 + 2*4]		; 2*4 info header size

	jz	address2symbol_proximus_L6	; this jump is a result of far above cmp ecx,-1

	call	fast_move_dot_terminated_string_dot_terminator

	lea	rsi,[rdx]
	call	fast_move_0_terminated_string

	jrcxz	address2symbol_proximus_L5
address2symbol_proximus_L4:
	mov	byte [rdi],'+'
	scasb
	mov	eax,ecx				; put ecx into eax
	call	hexa_32_eax
	scasq					; rdi+8
address2symbol_proximus_L5:

	mov	byte [rdi],0
	clc

address2symbol_proximus_epilogue:
	pop	rsi rbx rdx rcx rax
	ret

address2symbol_proximus_L6:
	call	fast_move_0_terminated_string
	jmp	address2symbol_proximus_L4

align 16
baseaddress2dllname:
; shows name of DLLs only
; input:	rax	base address
;		ecx	PID
;		rdi	buffer to store string if any (e.g. ntdll.dll, kernel32.dll, ...)
; out:		the same like address2ms_symbol
	push	rax rcx rdx rbx rsi rdi

	mov	edx,ecx				; PID
	mov	rdi,qword [module_info_address]
	mov	ecx,MaxNumberOfModulesInfo
	cld
baseaddress2dllname_start:
	jrcxz	baseaddress2dllname_failed
	repnz scasq
	jz	baseaddress2dllname_have_base

baseaddress2dllname_failed:
	pop	rdi
	stc
	jmp	baseaddress2dllname_epilogue

baseaddress2dllname_have_base:
	cmp	dword [rdi-8+24*MaxNumberOfModulesInfo],edx; check whether PID match
	jnz	baseaddress2dllname_start

	mov	rbx,qword [rdi-8+16*MaxNumberOfModulesInfo]	; module info
	or	rbx,rbx				; isn't it empty ?
	jz	baseaddress2dllname_failed

	pop	rdi

	mov	eax,dword [rbx+1*4]		; NumberOfFunctions
	lea	rsi,[rbx+rax*8 + 2*4]		; 2*4 info header size

	call	fast_move_0_terminated_string

	mov	byte [rdi],0
	clc

baseaddress2dllname_epilogue:
	pop	rsi rbx rdx rcx rax
	ret

store_PID_handle:
; input: RAX ProcessID RDX ProcessHandle
	push	rdi rcx rax
	mov	rdi,qword [multiprocess_multithread_support_address]
	xor	eax,eax
	mov	ecx,MaxProcesses
	cld
	repnz scasq
	stc
	jnz	store_PID_handle_end
	mov	rax,qword [rsp+8*0]
	mov	qword [rdi-8],rax
	mov	qword [rdi-8 + MaxProcesses*8],rdx
	clc
store_PID_handle_end:
	pop	rax rcx rdi
	ret

remove_PID_handle:
	push	rdi rcx
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxProcesses
	cld
	repnz scasq
	stc
	jnz	remove_PID_handle_end
	xor	ecx,ecx
	mov	qword [rdi-8],rcx
	mov	qword [rdi-8 + MaxProcesses*8],rcx
	clc
remove_PID_handle_end:
	pop	rcx rdi
	ret

store_TID_handle:
; input: RAX ThreadID RDX ThreadHandle
	push	rdi rcx rax
	mov	rdi,qword [multiprocess_multithread_support_address]
	xor	eax,eax
	add	rdi,MaxProcesses*8*2		; skip first store of PID...hProcess
	mov	ecx,MaxThreads
	cld
	repnz scasq
	stc
	jnz	store_TID_handle_end
	mov	rax,qword [rsp+8*0]
	mov	qword [rdi-8],rax
	mov	qword [rdi-8 + MaxThreads*8],rdx
	clc
store_TID_handle_end:
	pop	rax rcx rdi
	ret

remove_TID_handle:
	push	rdi rcx
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxThreads
	add	rdi,MaxProcesses*8*2		; skip first store of PID...hProcess
	cld
	repnz scasq
	stc
	jnz	remove_TID_handle_end
	xor	ecx,ecx
	mov	qword [rdi-8],rcx
	mov	qword [rdi-8 + MaxThreads*8],rcx
	clc
remove_TID_handle_end:
	pop	rcx rdi
	ret

store_PID_TID_pair:
; input: EAX ProcessID EDX ThreadId
	push	rdi rcx rax
	mov	rdi,qword [multiprocess_multithread_support_address]
	xor	eax,eax
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2	; skip store of PID...hProcess and TID...hThread
a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
	mov	ecx,a
	cld
	repnz scasd
	stc
	jnz	store_PID_TID_pair_end
	mov	eax,dword [rsp+8*0]
	mov	dword [rdi-4],eax
	mov	dword [rdi-4 + a*4],edx
	clc
store_PID_TID_pair_end:
	pop	rax rcx rdi
	ret

remove_PID_TID_pair:
; input: EAX ProcessID EDX ThreadId
; it is easier to scan TIDs because the same PID should have more TIDs, but every TID is unique
	push	rdi rcx
	xchg	edx,eax
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxThreads
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4	; skip store of PID...hProcess and TID...hThread
	cld
	repnz scasd
	stc
	jnz	remove_PID_TID_pair_end
	cmp	dword [rdi-4 - a*4],edx
	stc
	jnz	remove_PID_TID_pair_end
	xor	ecx,ecx
	mov	dword [rdi-4],ecx
	mov	dword [rdi-4 - a*4],ecx
	clc
remove_PID_TID_pair_end:
	xchg	edx,eax
	pop	rcx rdi
	ret

align 16
PID2hProcess:
; in  EAX ProcessId
; out RDX hProcess
; note, this can be done by kernel32.OpenProcess, but then we need extra CloseHandle...
; note, revese operation is kernel32.GetProcessId
	push	rdi rcx
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxProcesses
	cld
	repnz scasq
	stc
	jnz	PID2hProcess_end
	mov	rdx,qword [rdi-8 + MaxProcesses*8]
	clc
PID2hProcess_end:
	pop	rcx rdi
	ret

align 16
TID2hThread:
; in  EAX ThreadId
; out RDX hThread
; note, this can be done by kernel32.OpenThread, but then we need extra CloseHandle...
; note, revese operation is kernel32.GetThreadId
; The GetThreadId function retrieves the thread identifier of the specified thread.
;
; DWORD GetThreadId(
;   HANDLE Thread
; );
;
; Parameters:
; Thread 
; [in] Handle to the thread. The handle must have the THREAD_QUERY_INFORMATION access right. For more ; information about access rights, see Thread Security and Access Rights. 
; Return Values:
; If the function succeeds, the return value is the thread identifier of the specified thread.
; If the function fails, the return value is zero. To get extended error information, call GetLastError.

	push	rdi rcx
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxThreads
	add	rdi,MaxProcesses*8*2		; skip first store of PID...hProcess
	cld
	repnz scasq
	stc
	jnz	TID2hThread_end
	mov	rdx,qword [rdi-8 + MaxThreads*8]
	clc
TID2hThread_end:
	pop	rcx rdi
	ret

store_TID_ThreadLocalBase:
; input: EAX ThreadID RDX ThreadLocalBase=GS_register_value
	push	rdi rcx rax
	mov	rdi,qword [multiprocess_multithread_support_address]
	xor	eax,eax
a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2	; skip store of PID...hProcess and TID...hThread, PID TID pairs
	mov	ecx,MaxProcesses+MaxThreads
	cld
	repnz scasq
	stc
	jnz	store_TID_ThreadLocalBase_end
	mov	eax,dword [rsp+8*0]
	mov	qword [rdi-8],rax
	mov	qword [rdi-8 + (MaxProcesses+MaxThreads)*8],rdx
	clc
store_TID_ThreadLocalBase_end:
	pop	rax rcx rdi
	ret

remove_TID_ThreadLocalBase:
; in:	eax ThreadId
	push	rdi rcx
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxProcesses+MaxThreads
a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2	; skip store of PID...hProcess and TID...hThread, PID TID pairs
	cld
	repnz scasq
	stc
	jnz	remove_TID_ThreadLocalBase_end
	xor	ecx,edx
	mov	qword [rdi-8],rcx
	mov	qword [rdi-8 + (MaxProcesses+MaxThreads)*8],rcx
	clc
remove_TID_ThreadLocalBase_end:
	pop	rcx rdi
	ret

get_ThreadLocalBase_from_TID:
; in:	EAX ThreadID
; out:	RDX ThreadLocalBase=GS_register_value
	push	rdi rcx
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxProcesses+MaxThreads
a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2	; skip store of PID...hProcess and TID...hThread, PID TID pairs
	cld
	repnz scasq
	stc
	jnz	get_ThreadLocalBase_from_TID_end
	mov	rdx,qword [rdi-8 + (MaxProcesses+MaxThreads)*8]
	clc
get_ThreadLocalBase_from_TID_end:
	pop	rcx rdi
	ret

;align 10h
extract_PEB:
; PEB is qword at offset 60h of TEB
; PID is qword at offset 40h of TEB
; TID is qword at offset 48h of TEB
; TEB is qword at offset 30h of TEB (self pointer)
; in:
; rcx = hProcess
; rdx = lpThreadLocalBase = TEB
; out:
; rax = address of PEB (rax=0 means failure)
; destroys: nothing
	push	rcx rdx r8 r9 r10 r11
	sub	rsp,8*(4+2) + 68h

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,68h			; nSize
	lea	r8,[rsp+8*(4+2)]	; lpBuffer
;	mov	rdx,rdx			; lpBaseAddress
;	mov	rcx,rcx			; hProcess
	call	[ReadProcessMemory]
	or	eax,eax
	jz	extract_PEB_epi
	xor	eax,eax
	cmp	dword [rsp+8*(4+1)],68h
	jnz	extract_PEB_epi

; validation:
; offset 30h = self pointer to TEB
	mov	rdx,[rsp + 8*(4+2) + 30h]
	cmp	[rsp+8*(4+2) + 68h + 8*4],rdx	; pushed RDX as input param of this procedure
	jnz	extract_PEB_epi

; get PEB
	mov	rax,[rsp + 8*(4+2) + 60h]

extract_PEB_epi:
	add	rsp,8*(4+2) + 68h
	pop	r11 r10 r9 r8 rdx rcx
	ret

;align 10h
store_PID_PEB:
; in: 
; edx=PID
; rax=PEB
	push	rdi rcx rax

a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if

	mov	rdi,qword [multiprocess_multithread_support_address]
	xor	eax,eax
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2
	mov	ecx,MaxProcesses
	cld
	repnz scasq
	stc
	jnz	store_PID_PEB_end
	mov	rax,[rsp]		; get PEB
	mov	qword [rdi-8],rdx
	mov	qword [rdi-8 + MaxProcesses*8],rax
	clc
store_PID_PEB_end:
	pop	rax rcx rdi
	ret

;align 10h
remove_PID_PEB:
; in:	eax PID
	push	rdi rcx
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxProcesses
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2
	cld
	repnz scasq
	stc
	jnz	remove_PID_PEB_end
	and	qword [rdi-8],0
	and	qword [rdi-8 + MaxProcesses*8],0
; no necessary to do the CLC instruction, because the AND instruction always clears Carry Flag
;	clc
remove_PID_PEB_end:
	pop	rcx rdi
	ret


align 10h
switch_thread:
	push	rdi
	sub	rsp,8*(4+0)

	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ecx,MaxThreads
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4	; skip store of PID...hProcess and TID...hThread
	xor	eax,eax
	cld
	repz scasd
	stc
	jz	switch_thread_end

	mov	edx,dword [rdi-4]		; get TID
	mov	eax,dword [rdi-4 - a*4]		; get PID
	mov	dword [last_TID],edx
	mov	dword [last_PID],eax

	lea	rdi,[sw_to_PT_PID]
	call	hexa_32_eax

	mov	eax,edx
	lea	rdi,[sw_to_PT_TID]
	call	hexa_32_eax

	lea	rax,[sw_to_PT]
	call	msg_to_LogEdit

; determine the state of this thread (Resumed? Suspended?)
	mov	edx,dword [last_TID]
	call	determine_thread_state
	jc	switch_thread_end

	or	eax,eax				; 0=resumed, 1=suspended
	setz	byte [DbgThrdResumed]
	lea	rcx,[msg_tiirs0]
	lea	rax,[msg_tiirs1]
	lea	rdx,[update_status_window_running]
	lea	rdi,[update_status_window_stopped]
	cmovz	rax,rcx
	cmovz	rdi,rdx
	call	msg_to_LogEdit

	call	update_menus_hang_suspend_changed

	mov	eax,[last_PID]
	mov	edx,[last_TID]
	call	update_status_window_PID_TID
	call	rdi

switch_thread_end:
	add	rsp,8*(4+0)
	pop	rdi
	ret

align 16
determine_thread_state:
; This is an ugly way but I don't know any better yet...
; in:	edx TID
; out:	eax=0 resumed state, CF=0
;	eax=1 suspended state, CF=0
;	CF=1 if error

	push	rcx rdx rbx rdi r8 r9 r10 r11
	sub	rsp,8*(4+1)

	mov	eax,edx
	call	TID2hThread
	jc	determine_thread_state_epi

	mov	rdi,rdx
	mov	rcx,rdx
	call	qword [SuspendThread]
; Calling SuspendThread causes the target thread's suspend count to be incremented.
; Attempting to increment past the maximum suspend count
; MAXIMUM_SUSPEND_COUNT=MAXCHAR=7Fh causes an error without incrementing the count.
	cmp	eax,-1
	stc
	jz	determine_thread_state_epi; eax=-1 error occured
					; disadvantage is that we can mistake when
					; suspend count = MAXIMUM_SUSPEND_COUNT
	or	eax,eax			; eax=0 when thread was in resumed state
					; eax>0 and eax<80h when thread was in suspended state
	setnz	bl

; we incremented thread's suspend count by call [SuspendThread] so we have to decrement it
; This doesn't means that thread will be resumed ! If thread was initialy suspended with
; suspend count = 1 then after calling SuspendThread ist suspend count incremented to 2 and
; finally after ResumeThread its suspend count will be 1 so it will stay suspended.
	mov	rcx,rdi
	call	qword [ResumeThread]

; this seems useless for our purposes:
;	mov	rcx,rdi
;	lea	rdx,[rsp+8*(4+0)]
;	call	qword [GetThreadIOPendingFlag]

	movzx	eax,bl
	clc

determine_thread_state_epi:
	lea	rsp,[rsp+8*(4+1)]	; this doesn't change carry flag
	pop	r11 r10 r9 r8 rdi rbx rdx rcx
	ret

align 16
exception2log:
; rdx = dbg_event
	push	rax rcx rdx rsi rdi
	sub	rsp,8*(4+0)
virtual at 0
dbg_ev	DEBUG_EVENT64
end virtual

CopyMovsq_unsafe tmp_buf, exception_text0, exception_text0_size

;	mov	rdx,qword [rsp+8*(4+0+2)]
	mov	eax,dword [rdx + dbg_ev.dwProcessId]
	call	hexa_32_eax
	lea	rdi,[rdi+8]

CopyQwordsNoFlag exception_text1_size

	mov	rdx,qword [rsp+8*(4+0+2)]
	mov	eax,dword [rdx + dbg_ev.dwThreadId]
	call	hexa_32_eax
	lea	rdi,[rdi+8]

CopyQwordsNoFlag exception_text2_size

	mov	rdx,qword [rsp+8*(4+0+2)]
	mov	rax,qword [rdx + dbg_ev.Exception.ExceptionRecord.ExceptionAddress]
	call	hexa_64_rax
	lea	rdi,[rdi+18]
	mov	word [rdi-2],'h='
	lea	rdx,[rdi-1]			; point between 'h' and '='
	call	address2symbol			; transform addr->string, CF=1 if nothing transformed
	cmovc	rdi,rdx				; strip last '=' when no symbol found

CopyQwords exception_text3_size

	mov	rdx,qword [rsp+8*(4+0+2)]
	mov	eax,dword [rdx + dbg_ev.Exception.ExceptionRecord.ExceptionCode]
	call	hexa_32_eax
	mov	byte [rdi+8],'h'
	lea	rsi,[rdi+9]

	mov	ecx,number_of_exception
	lea	rdi,[exception_data_hexa]
	lea	edx,[rcx-1]
	cld
	repnz scasd
	lea	rdi,[rsi]
	jnz	exception2log_L0
	mov	al,'='
	sub	edx,ecx
	stosb
	lea	rax,[addr_exception_data_text]
	mov	rsi,qword [rax+rdx*8]
	call	fast_move_0_terminated_string

exception2log_L0:
	mov	rdx,qword [rsp+8*(4+0+2)]
	lea	rsi,[exception_first_chance]
	lea	rax,[exception_second_chance]
	cmp	dword [rdx + dbg_ev.Exception.dwFirstChance],0
	cmovz	rsi,rax
	call	fast_move_0_terminated_string_0_terminator

	lea	rax,[tmp_buf]
	call	msg_to_LogEdit

	add	rsp,8*(4+0)
	pop	rdi rsi rdx rcx rax
	ret

align 16
try_rest_from_previous:
; input: 3 params in:
; addr_write_bp_after_first_step
; PID_write_sw_bp_after_first_step
; TID_write_hw_bp_after_first_step
; rest_from_permanent_BP_flag
; run_after_first_step_when_write_bp
; output: Zero flag clear (ZF=0) when we have to run (run_after_first_step_when_write_bp)
;         ZF=1 when we needn't to run
	push	rax rcx rdx

	cmp	byte [rest_from_previous_flag],rest_from_run_here
	jz	try_rest_from_run_here
	cmp	byte [rest_from_previous_flag],rest_from_permanent_BP_flag_HW
	jz	try_rest_from_permanent_HW_BP
	cmp	byte [rest_from_previous_flag],rest_from_permanent_BP_flag_SW
	jnz	try_rest_from_previous_end

try_rest_from_permanent_SW_BP:
	mov	rax,qword [addr_write_bp_after_first_step]
	or	rax,rax
	jz	try_rest_from_previous_epi
	mov	ecx,dword [PID_write_sw_bp_after_first_step]
	lea	rdx,[tmp_buf]			; scratch buffer
	call	put_0CCh
	jmp	try_rest_from_previous_end

try_rest_from_permanent_HW_BP:
	mov	eax,dword [TID_write_hw_bp_after_first_step]
	call	TID2hThread
	jc	try_rest_from_previous_end
	mov	rcx,rdx				; hThread
	lea	rdx,[ThreadContext]
	mov	dword [rdx + contxt.ContextFlags],CONTEXT_ALL
	call	qword [GetThreadContext]
	or	eax,eax
	jz	try_rest_from_previous_end
	mov	rax,qword [addr_write_bp_after_first_step]
	movzx	ecx,byte [hw_bp_No_after_first_step]
	lea	rdx,[ThreadContext.Dr0]
	mov	qword [rdx+rcx*8],rax
	mov	al,byte [hw_bp_GL_after_first_step]	; L, G bits
	or	byte [ThreadContext.Dr7],al
	mov	eax,dword [TID_write_hw_bp_after_first_step]
	call	TID2hThread
	mov	rcx,rdx				; hThread
	lea	rdx,[ThreadContext]
	call	qword [SetThreadContext]
; must be here for tell the next turn of try_rest_from_permanent_BP that we did it
	mov	byte [rest_from_previous_flag],rest_from_permanent_BP_flag_SW
	jmp	try_rest_from_previous_end

try_rest_from_run_here:
	mov	rax,qword [addr_write_bp_after_first_step]
	mov	ecx,dword [PID_write_sw_bp_after_first_step]
	call	find_first_empty_slot_put_SW_BP_temporary_flag

try_rest_from_previous_end:
	pxor	xmm0,xmm0
	mov	byte [rest_from_previous_flag],rest_from_permanent_BP_flag_SW
	movdqa	dqword [addr_write_bp_after_first_step],xmm0	; rest_from_permanent_BP_flag_SW + zero address means there is nothing to do

try_rest_from_previous_epi:
	pop	rdx rcx rax
	ret

align 10h
try_log_our_sw_bp:
; in:	rcx = qword [dbg_event.dwProcessId] ECX=dwProcessId , upper dword of RCX=dwThreadId
; lea	rdx,[dbg_event]
	push	rax rcx rdx rbx rdi
	mov	rax,[rdx+DEBUG_EVENT64.Exception.ExceptionRecord.ExceptionAddress]
	call	scan_sw_bp_addr_pid
	jnz	try_log_our_sw_bp_epi
	mov	eax,edx
	mov	rcx,qword [breakpoints_space_address]
	cmp	byte [rcx + MaxNumberOfBreakpoints*(8+4+1) + rdx*1],SW_BP_flag_temporary
	jz	try_log_our_sw_bp_L0
	lea	rdi,[msg_sw_bp_perm_No]
	call	hexa_32_eax
	lea	rax,[msg_sw_bp_perm]
	jmp	try_log_our_sw_bp_L9
try_log_our_sw_bp_L0:
	lea	rdi,[msg_sw_bp_temp_No]
	call	hexa_32_eax
	lea	rax,[msg_sw_bp_temp]
try_log_our_sw_bp_L9:
	call	msg_to_LogEdit
try_log_our_sw_bp_epi:
	pop	rdi rbx rdx rcx rax
	ret


align 16
branches_to_LogEdit_ms_backdoor:
; note, ThreadContext must be read before calling this procedure !
	test	byte [ThreadContext.Dr7 + 1],1		; DR7.LE disabled in this thread ?
	jz	branches_to_LogEdit_ms_backdoor_ret
	push	rdi
	lea	rdi,[msg_LastBranchFromIP]
	mov	rax,[ThreadContext.LastBranchFromRip]
	call	hexa_64_rax
	lea	rdi,[msg_LastBranchToIP]
	mov	rax,[ThreadContext.LastBranchToRip]
	call	hexa_64_rax
	lea	rdi,[msg_LastExceptionFromIP]
	mov	rax,[ThreadContext.LastExceptionFromRip]
	call	hexa_64_rax
	lea	rdi,[msg_LastExceptionToIP]
	mov	rax,[ThreadContext.LastExceptionToRip]
	call	hexa_64_rax
	lea	rax,[msg_branches]
	call	msg_to_LogEdit
	pop	rdi
branches_to_LogEdit_ms_backdoor_ret:
	ret


align 10h
get_dbghelp_sym:
; in	rcx unique index
;	rdx hFile

; microsoft symbols are disabled by default, caused bugs after installing LiveKD - thanx to Krod - another ; solution is to remove _NT_SYMBOL_PATH environment variable (added by LiveKD). Krod reversed SymIntialize, and ; discovered that symsvrClose(void) tried to free a module already freed
; it was caused by calling ntdll.RtlImageNtHeaderEx with RDX=-2 (-2=FFFFFFFFFFFFFFFEh=handle of current thread)
	test	[face.display_symbols],display_allow_microsoft_symbols
	jz	get_dbghelp_sym_ret

	push	rbx rbp
	sub	rsp,8*(4+5)

;	mov	rbx,rcx
	push	rcx
	pop	rbx
;	mov	rbp,rdx
	push	rdx
	pop	rbp

; try to get debug symbols if any...
	mov	ecx,SYMOPT_CASE_INSENSITIVE or SYMOPT_UNDNAME or SYMOPT_LOAD_LINES or SYMOPT_ALLOW_ABSOLUTE_SYMBOLS or SYMOPT_AUTO_PUBLICS or SYMOPT_DEFERRED_LOADS
	call	qword [SymSetOptions]

	xor	r8,r8
	xor	edx,edx
;	mov	rcx,rbx
	push	rbx
	pop	rcx
	call	qword [SymInitialize]
	or	eax,eax
	jz	get_dbghelp_sym_epi

	xor	r9,r9
	xor	r8,r8
	mov	dword [rsp+8*(4+3)],r9d
	mov	qword [rsp+8*(4+2)],r9
	mov	dword [rsp+8*(4+1)],r9d
	mov	qword [rsp+8*(4+0)],r9
;	mov	rdx,rbp			; hFile, ? SymLoadModuleEx uses it to read file ?
	push	rbp
	pop	rdx
;	mov	rcx,rbx			; hProcess, we use unique index instead of hProcess
	push	rbx
	pop	rcx
	call	qword [SymLoadModuleEx]

get_dbghelp_sym_epi:
	add	rsp,8*(4+5)
	pop	rbp rbx
get_dbghelp_sym_ret:
	ret

;get_SymIndex:
;; in:	rax base address
;;	edx PID
;; out:	eax index
;	push	rcx rdi
;	mov	rdi,qword [module_info_address]
;	mov	ecx,MaxNumberOfModulesInfo
;get_SymIndex_L0:
;	jrcxz	get_SymIndex_failed
;	cld
;	repnz scasq
;	jnz	get_SymIndex_failed
;	cmp	dword [rdi-8+24*MaxNumberOfModulesInfo],edx
;	jnz	get_SymIndex_L0
;	mov	eax,SymbolIndexFirst + MaxNumberOfModulesInfo-1
;	sub	eax,ecx			; this certainly clear Carry Flag
;get_SymIndex_epi:
;	pop	rdi rcx
;	ret
;get_SymIndex_failed:
;	stc
;	jmp	get_SymIndex_epi
