; -------- subroutine ----------
ListView_get_item_and_subitem:
; get item and subitem
; input:	RCX	ListView handle
;		R9	Cursor position in ListView
; output:	RAX	item and subitem (EAX=item, high dword of RAX=subitem)
; destroy:	mm0
;		mm1

	push	rcx
	push	rdx
	push	r8
	push	r9
	sub	rsp,8*(4+7)
;	mov	rax,r9
;	shr	rax,16
;	movsx	r9d,r9w
;	movsx	eax,ax
;	mov	dword [rsp + 8*(4+0)],r9d
;	mov	dword [rsp + 8*(4+0) + 4],eax	; position
; faster movzx variant, should be enough, positions in ListView aren't negative values
	movq	xmm0,r9	;qword [rsp + 8*(4+7+0)]	; from r9 pushed in the stack
	pxor	xmm1,xmm1
	punpcklwd	xmm0,xmm1
	movdqa	dqword [rsp + 8*(4+0)],xmm0	; positions
; 3rd possibility:
; lea rcx,[..cursor]
; call User32.GetCursorPos
; lea rdx,[..cursor]
; mov rcx,[handle]
; call User32ScreenToClient

	lea	r9,[rsp + 8*(4+0)]
	xor	r8,r8
	mov	edx,LVM_SUBITEMHITTEST
;	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendMessageA]
; RAX receives the index of the matching item.
	cmp	rax,-1
	stc
	jz	ListView_get_item_and_subitem_end	; fail

	mov	rax,qword [rsp + 8*(4+0) + LV_HITTESTINFO64.iItem]	; item and subitem
	clc

ListView_get_item_and_subitem_end:
	add	rsp,8*(4+7)
	pop	r9
	pop	r8
	pop	rdx
	pop	rcx
	ret
; -------- subroutine end ----------

; -------- subroutine ----------
Kreate_ListView_Edit:
; input:	RCX	parent hWnd
	push	rcx
	push	rdx
	push	r8
	push	r9
	sub	rsp,8*(4+9)

; better is GetClassLongPtrA/GCLP_WNDPROC for EDIT class, put result into [ListView_Edit_NewProc]
; then RegisterClass with new name and procedure at ListView_Edit_NewProc
; but this works too...
	mov	rax,qword [hInstance]
	and	qword [rsp + 8*(4+7)],0		; pointer to window-creation data
	mov	qword [rsp + 8*(4+6)],rax	; hInst  handle to application instance
	mov	qword [rsp + 8*(4+5)],ID_ListViewEditBox	; handle to menu, or child-window identifier
	mov	r9d,dword [ListView_item_and_subitem_rect + RECT64.bottom]
	mov	r8d,dword [ListView_item_and_subitem_rect + RECT64.right]
	mov	edx,dword [ListView_item_and_subitem_rect + RECT64.top]
	mov	eax,dword [ListView_item_and_subitem_rect + RECT64.left]
	mov	qword [rsp + 8*(4+4)],rcx	; handle to parent or owner window
	sub	r9d,edx
	sub	r8d,eax
	mov	dword [rsp + 8*(4+3)],r9d	; height
	mov	dword [rsp + 8*(4+2)],r8d	; width
	mov	dword [rsp + 8*(4+1)],edx	; y
	mov	dword [rsp + 8*(4+0)],eax	; x
	mov	r9d,WS_CHILD or WS_VISIBLE or ES_AUTOHSCROLL or ES_LEFT	; window style
	mov	eax,WS_BORDER or WS_CHILD or WS_VISIBLE or ES_AUTOHSCROLL or ES_LEFT	; window style
	test	byte [face.var_settings],ListEditBorder
	cmovnz	r9d,eax
	xor	r8,r8				; pointer to window name
	lea	rdx,[EditClassName]		; pointer to registered class name
	xor	ecx,ecx				; extended window style
	mov	eax,WS_EX_CLIENTEDGE
	test	byte [face.var_settings],ListEditClientedge
	cmovnz	ecx,eax
	call	qword [CreateWindowExA]
	or	rax,rax
	stc
	jz	Kreate_ListView_Edit_end
	mov	qword [ListView_Edit_handle],rax
	mov	byte [ListView_Edit_exist],1

	lea	r8,[ListView_Edit_NewProc]
	mov	rdx,GWLP_WNDPROC
	mov	rcx,qword [ListView_Edit_handle]
	call	qword [SetWindowLongPtrA]
	or	rax,rax
	stc
	jz	Kreate_ListView_Edit_end
	lea	rdx,[ListView_Edit_NewProc]
	cmp	rdx,rax
	jz	Kreate_ListView_Edit_L5
	mov	qword [ListView_Edit_OldProc],rax
Kreate_ListView_Edit_L5:

	mov	r9,1				; lParam redraw flag
	mov	r8,qword [hFont]		; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,qword [ListView_Edit_handle]
	call	qword [SendMessageA]

	mov	rcx,qword [ListView_Edit_handle]
	call	qword [SetFocus]

Kreate_ListView_Edit_end:
	add	rsp,8*(4+9)
	pop	r9
	pop	r8
	pop	rdx
	pop	rcx
	ret
; -------- subroutine end ----------

; -------- subroutine ----------
;post_WM_COMMAND_EN_KILLFOCUS:
;	push	rax rcx rdx r8 r9
;	sub	rsp,8*4
;	mov	r9,qword [ListView_Edit_handle]	; 4th API param
;	cmp	r9,INVALID_HANDLE_VALUE
;	jz	post_WM_COMMAND_EN_KILLFOCUS_epi
;	mov	rax,qword [ListView_edit_Listview_index]
;	cmp	rax,NumberOfSysListView32
;	jnc	post_WM_COMMAND_EN_KILLFOCUS_epi
;	lea	rdx,[hWndListView]
;	mov	rcx,qword [rdx+rax*8]		; 1st API param, handle of window owning SysListView and List EDIT
;	mov	r8d,EN_KILLFOCUS shl 16 + ID_ListViewEditBox	; 3rd API param
;	mov	edx,WM_COMMAND			; 2nd API param
;	call	qword [PostMessageA]
;post_WM_COMMAND_EN_KILLFOCUS_epi:
;	add	rsp,8*4
;	pop	r9 r8 rdx rcx rax
;post_WM_COMMAND_EN_KILLFOCUS_ret:
;	ret
; -------- subroutine end ----------

; -------- subroutine ----------
ListView_Edit_destroy:
	push	rax
	push	rcx
	push	rdx
	push	r8
	push	r9
	sub	rsp,8*(4+0)
	cmp	byte [ListView_Edit_exist],0
	jz	ListView_Edit_destroy_end
	mov	rcx,qword [ListView_Edit_handle]
	jrcxz	ListView_Edit_destroy_end
	cmp	rcx,INVALID_HANDLE_VALUE
	jz	ListView_Edit_destroy_end
	call	qword [DestroyWindow]
	mov	byte [ListView_Edit_exist],0
	or	qword [ListView_edit_Listview_index],-1
	or	qword [ListView_edit_last_item_and_subitem],-1

if INVALID_HANDLE_VALUE = -1
	or	qword [ListView_Edit_handle],INVALID_HANDLE_VALUE
else
	mov	qword [ListView_Edit_handle],INVALID_HANDLE_VALUE
end if

ListView_Edit_destroy_end:
	add	rsp,8*(4+0)
	pop	r9
	pop	r8
	pop	rdx
	pop	rcx
	pop	rax
	ret
; -------- subroutine end ----------

; -------- subroutine ----------
ListView_edit_allowed_index_item_subitem:
; input:	RDX	ListView index
;		RAX	item in EAX, subitem in high dword of RAX
; output:	clear Carry Flag if edit control at this params allowed
;		else set CF
	push	rax
	push	r10
	lea	r10,[addr_ListView_edit_allowed_index_item_subitem]
	call	qword [r10+rdx*8]
	pop	r10
	pop	rax
	ret

;proc_LVeaiis00:
;proc_LVeaiis01:
;; code 1st, code 2nd
;; subitem 0 allowed, subitem 1 allowed
;	mov	r10,1FFFFFFFFh
;	cmp	r10,rax
;	ret

proc_LVeaiis06:
proc_LVeaiis07:
proc_LVeaiis08:
proc_LVeaiis09:
proc_LVeaiis0A:
; GPR, RIP, xmm, mm/st, flags
; subitem 1 allowed (GPR, RIP, flags)
; subitems 1 2 3 allowed (xmm, mm/st)
	shr	rax,32
	cmp	eax,1
	jnc	proc_LVeaiis00_end	;	jz	proc_LVeaiis00_end
proc_LVeaiis0B:
proc_LVeaiis0C:
proc_LVeaiis0D:
; segment registers, debug registers, floating control
; nothing allowed directly, use:
; Breakpoints -> Hardware BP
	stc
proc_LVeaiis00_end:
	ret

proc_LVeaiis00:
proc_LVeaiis01:
; code 1st, code 2nd
; everything allowed, note that clicking on subitem 3 opens Edit Control for read-only
proc_LVeaiis02:
proc_LVeaiis03:
proc_LVeaiis04:
proc_LVeaiis05:
; data 1st, data 2nd, data 3rd, stack
; everything allowed
	clc
	ret
; -------- subroutine end ----------

; -------- subroutine ----------
get_reg64_addr64:
	or	eax,eax
	jz	get_reg64_addr64_fail
	cmp	eax,3
	jnbe	get_reg64_addr64_L1
; try to check rax rcx rdx rbx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15 rip
	cmp	byte [rsi],'r'
	jz	get_reg64_addr64_L0
	cmp	byte [rsi],'R'
	jnz	get_reg64_addr64_L1

get_reg64_addr64_L0:
; reg64
	mov	ax,word [rsi+1]
	or	ax,2020h			; convert capitals to lowercase
						; for r8 and r9 convert last 0-terminator into 20h (=space) char
	mov	ecx,16+1			; 16 gprs + 1 rip
	lea	rdi,[reg64scan]
	repnz scasw
	jnz	get_reg64_addr64_fail
	mov	esi,16
	sub	esi,ecx

	mov	ecx,dword [last_TID]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	get_reg64_addr64_fail

	lea	rax,[ThreadContext.Rax]		; Rip follows immediatelly after R15
	mov	rdx,[rax+rsi*8]
	jmp	get_reg64_addr64_L2

get_reg64_addr64_L1:
; addr64
;	cmp	eax,16				; ascii2hexa_qword will check this
;	jnbe	proc_LV_edma00_01_end
	call	ascii2hexa_qword		; output in RDX
	jc	get_reg64_addr64_fail

get_reg64_addr64_L2:
;	clc					; we needn't to do it because previous
						; instructions before jump here do it
	ret
get_reg64_addr64_fail:
	stc
	ret
; -------- subroutine end ----------

; -------- subroutines ----------
; eax					text size
; tmp_buf				buffer holding string from Edit Control
; [ListView_edit_last_item_and_subitem]	item and subitem holding Edit control
; edx					ListView index (0=code 1st, 1=code 2nd, 13=floating control)
; [EditedListView_handle]		ListView handle

proc_LV_edma00:
proc_LV_edma01:
; Code 1st, Code 2nd
; rdx = ListView_edit_Listview_index
	push	rax rcx rdx rbx rbp rsi rdi r8 r9
k0ms	=	((InstructionMaxSize+15)/16)*16
	sub	rsp,8*(4+0) + k0ms

	mov	ecx,dword [ListView_edit_last_item_and_subitem+4]	; get iSubItem
	lea	rsi,[tmp_buf]
	or	ecx,ecx
	jnz	proc_LV_edma00_01_L0

proc_LV_edma00_01_item0:
; edit displaying address in subitem 0
	call	get_reg64_addr64
	jc	proc_LV_edma00_01_end
; rdx=address now

	mov	ecx,dword [ListView_edit_last_item_and_subitem]	; grab item				; how much instructions back ?
	jrcxz	proc_LV_edma00_01_item0_subitem0

; eax PID, ecx how much back, rdx end address
	mov	eax,dword [last_PID]
	call	painful_reverze
	jc	proc_LV_edma00_01_end
	sub	rdx,rax				; subtrac number of bytes to go back from the end address

proc_LV_edma00_01_item0_subitem0:
	mov	rcx,qword [rsp + 8*(4+0) + k0ms + 8*6]	; grab RDX = ListView_edit_Listview_index
	lea	rax,[Code_listview_dump_start_address]
	mov	qword [rax + rcx*8],rdx		; update start display position
	jmp	proc_LV_edma00_01_end

proc_LV_edma00_01_L0:
	cmp	ecx,1
	jnz	proc_LV_edma00_01_itemx_subitem2

proc_LV_edma00_01_itemx_subitem1:
; edit raw hexa opcode
if InstructionMaxSize*2 <> 32
	cmp	eax,InstructionMaxSize*2	; *2 because every byte is ascii displayed by 2 nibbles
	jnbe	proc_LV_edma00_01_end
end if
	lea	rdi,[rsp + 8*(4+0)]
	call	ascii2hexa_no_rev		; this will check string size interval 1-32
	jc	proc_LV_edma00_01_end
	mov	ebx,eax

; get address from Label=iSubItem=0
	lea	rsi,[tmp_buf]			; point to buffer
	mov	r8d,dword [ListView_edit_last_item_and_subitem]	; item
	lea	r9,[rsi + 20h]			; point to LV_ITEM64 which will be prepared
	mov	edx,LVM_GETITEMTEXT
	and	dword [r9 + LV_ITEM64.iSubItem],0	; subitem
	mov	qword [r9 + LV_ITEM64.pszText],rsi
	mov	dword [r9 + LV_ITEM64.cchTextMax],16+1	; size of buffer, +1 include 0-terminator
	mov	rcx,qword [EditedListView_handle]
	call	qword [SendMessageA]
; get 0-terminated string, return in RAX its size without 0-terminator
	cmp	eax,16
	jnz	proc_LV_edma00_01_end		; not real address size = qword = 8 bytes = 16 ascii chars
	call	ascii2hexa_qword		; output in RDX, destroys RSI
	jc	proc_LV_edma00_01_end
	shr	ebx,1				; this handle nonparity number of ascii chars
	lea	rsi,[tmp_buf]
	mov	qword [rsi],rdx
	lea	rdi,[rsp + 8*(4+0)]
	mov	ecx,dword [last_PID]

	call	check_sw_bp_patch_when_necessary_before_write_memory

	call	write_debuggee_memory_big_area_without_verification	; must be used for more than 8 bytes
;end if
;	jc	proc_LV_edma00_01_end
	jmp	proc_LV_edma00_01_end

proc_LV_edma00_01_itemx_subitem2:
	cmp	ecx,2
	jnz	proc_LV_edma00_01_itemx_subitem3
; assembler isn't implemented, probably won't be ever, about 1 month of 8 hours daily coding, too much work...
; Edit Control is only for reading and copying of the text in it
	jmp	proc_LV_edma00_01_end


proc_LV_edma00_01_itemx_subitem3:
	cmp	ecx,3
	jnz	proc_LV_edma00_01_end
; comment

; get address from Label=iSubItem=0
	lea	rsi,[tmp_buf + comment_max_size]	; point to buffer
	mov	r8d,dword [ListView_edit_last_item_and_subitem]	; item
	lea	r9,[rsi + 20h]			; point to LV_ITEM64 which will be prepared
	mov	edx,LVM_GETITEMTEXT
	and	dword [r9 + LV_ITEM64.iSubItem],0	; subitem
	mov	[r9 + LV_ITEM64.pszText],rsi
	mov	dword [r9 + LV_ITEM64.cchTextMax],16+1	; size of buffer, +1 include 0-terminator
	mov	rcx,[EditedListView_handle]
	call	[SendMessageA]
; get 0-terminated string, return in RAX its size without 0-terminator
	cmp	eax,16
	jnz	proc_LV_edma00_01_end		; not real address size = qword = 8 bytes = 16 ascii chars
	call	ascii2hexa_qword		; output in RDX, destroys RSI
	jc	proc_LV_edma00_01_end

	mov	r8d,[last_PID]

;  r8 PID
; rdx address
; check whether there is already any comment at the address of such PID
	mov	rax,rdx
	lea	rdi,[comments + max_comments*8]
	mov	ecx,max_comments
	lea	ebx,[rcx-1]
	cld
AMDPad16
proc_LV_edma00_01_itemx_subitem3_L1:
	repnz scasq
	jz	proc_LV_edma00_01_itemx_subitem3_L2
	jmp	proc_LV_edma00_01_itemx_subitem3_L3

proc_LV_edma00_01_itemx_subitem3_L2:
	cmp	[rdi-8 - max_comments*8],r8
	jnz	proc_LV_edma00_01_itemx_subitem3_L1
	jmp	proc_LV_edma00_01_itemx_subitem3_L5

proc_LV_edma00_01_itemx_subitem3_L3:
; find a new one (empty) slot
	xor	eax,eax
	lea	rdi,[comments + max_comments*8]
	mov	ecx,max_comments
;	lea	ebx,[rcx-1]			; no need to do it again
;	cld

AMDPad16
proc_LV_edma00_01_itemx_subitem3_L4:
	repnz scasq
	jnz	proc_LV_edma00_01_end
	cmp	[rdi-8 - max_comments*8],rax
	jnz	proc_LV_edma00_01_itemx_subitem3_L4
	mov	[rdi-8],rdx			; store the address into the slot
	mov	[rdi-8 - max_comments*8],r8	; store PID

proc_LV_edma00_01_itemx_subitem3_L5:
	sub	ebx,ecx
; ebx = index of comment

	lea	rsi,[comments + max_comments*8 + max_comments*8]	; pointer to strings each of comment_max_size bytes long

if comment_max_size = 100h
	shl	ebx,8
else
	imul	ebx,ebx,comment_max_size
end if
	add	rsi,rbx

; qword [rdi-8-max_comments*8] = PID
; qword [rdi-8] = address
; bytes [rsi] = string comment_max_size
	cmp	byte [tmp_buf],0
	jz	proc_LV_edma00_01_itemx_subitem3_L8

	lea	rdi,[rsi]
	lea	rsi,[tmp_buf]
	mov	ecx,comment_max_size
;	cld

AMDPad16
proc_LV_edma00_01_itemx_subitem3_L7:
	movsb
	cmp	byte [rsi-1],0
	loopnz	proc_LV_edma00_01_itemx_subitem3_L7
	xor	eax,eax
	repz stosb
	jmp	proc_LV_edma00_01_itemx_subitem3_L9

proc_LV_edma00_01_itemx_subitem3_L8:
; erase the PID at [rdi-8 - max_comments*8], erase the address at [rdi-8] and erase the whole text for empty input
	xor	eax,eax
	mov	qword [rdi-8 - max_comments*8],rax	; erase PID
	mov	qword [rdi-8],rax			; erase address
	lea	rdi,[rsi]				; erase string
	mov	ecx,comment_max_size / 8
	cld
	repz stosq
proc_LV_edma00_01_itemx_subitem3_L9:

proc_LV_edma00_01_end:
	add	rsp,8*(4+0) + k0ms
	pop	r9 r8 rdi rsi rbp rbx rdx rcx rax
	ret











proc_LV_edma02:
proc_LV_edma03:
proc_LV_edma04:
; Data 1st, Data 2nd, Data 3rd
	push	rax rcx rdx rbx rbp rsi rdi r8 r9
	sub	rsp,8*(4+2)

	mov	ecx,dword [ListView_edit_last_item_and_subitem + 4]	; get subitem
	lea	rsi,[tmp_buf]

	or	ecx,ecx
	jnz	proc_LV_edma02_04_L0

proc_LV_edma02_04_subitem0:
; edit displaying address in subitem 0
	call	get_reg64_addr64
	jc	proc_LV_edma02_04_end
; rdx=address now

	mov	rcx,qword [rsp + 8*(4+2) + 8*6]	; grab RDX = ListView_edit_Listview_index
	lea	rax,[Code_listview_dump_start_address]
	mov	esi,dword [ListView_edit_last_item_and_subitem]	; grab item
	shl	esi,4				; item * 16 because every item displays 16 bytes
	sub	rdx,rsi				; correction for item 0 subitem 0
	mov	qword [rax + rcx*8],rdx		; update start display position
	jmp	proc_LV_edma02_04_end

proc_LV_edma02_04_L0:
	mov	rbp,[ListView_edit_Listview_index]
	lea	rdi,[face.SLV02cs_type - 2]			; -2 because data 1st is indexed as 2 (0=code1st, 1=code2nd, 2=data1st, 3=data2nd, 4=data3rd, ...)
;	mov	ebx,(not data_column_type_reversed) and 0FFh	; remove reverse flag
;	push	(not data_column_type_reversed) and 0FFh	; remove reverse flag
;	pop	rbx
; this is safer, prevents crashes if face.SLV02cs_type, face.SLV03cs_type, face.SLV04cs_type are abnormal:
	push	(data_column_type_qword or data_column_type_dword or data_column_type_word or data_column_type_byte)
	pop	rbx
	and	bl,[rdi+rbp*1]
; now transform
; 0 -> 1+2+1-1	; 1=address, 2=number_of_qwords, 1=ascii
; 1 -> 1+4+1-1	; 1=address, 4=number_of_dwords, 1=ascii
; 2 -> 1+8+1-1	; 1=address, 8=number_of_words, 1=ascii
; 3 -> 1+16+1-1	; 1=address, 16=number_of_bytes, 1=ascii
; -1 because columns are 0-indexed (0 = the first column, 1 = the second column, ...)
	xor	edi,edi
	bts	edi,ebx
	lea	ebp,[rdi+rdi*1+2-1]

	cmp	ecx,ebp				; ASCII column?
	jz	proc_LV_edma02_04_subitem3

proc_LV_edma02_04_subitem12:
; edit hexa data
	mov	cl,data_column_type_byte
	sub	ecx,ebx
; cl = data_column_type_byte - data_column_type
; cl = 3 for qword column
; cl = 2 for dword column
; cl = 1 for word column
; cl = 0 for byte column

	lea	rdi,[rsp + 8*(4+0)]
	call	ascii2hexa_no_rev		; this will check string size interval 1-32
	jc	proc_LV_edma02_04_end
	mov	ebx,eax				; save ascii hexa string size

	mov	rbp,qword [rsp + 8*(4+2+6)]	; grab ListView_edit_Listview_index = procedure input parameter RDX pushed at procedure prologue
	lea	rax,[Code_listview_dump_start_address]
	mov	rdx,qword [rax + rbp*8]		; get displaying start address
	mov	ebp,dword [ListView_edit_last_item_and_subitem]	; get item
	mov	eax,dword [ListView_edit_last_item_and_subitem + 4]	; subitem

; now calculate:
; start_address + item*16 + ((subitem-1) shl cl)	; *16 because every line of data displays 16 bytes, -1 because the first hexa data column has index 1 and we need to index hexa data columns from 0
;      rdx      +  ebp*16 +   ((eax-1) shl cl)

	dec	eax		; subitem-1
	shl	eax,cl		; (subitem-1) shl cl
	shl	ebp,1		; item*2
	lea	ecx,[rax+rbp*8]	; item*16 + ((subitem-1) shl cl)
	add	rdx,rcx		; start_address + item*16 + ((subitem-1) shl cl)

	shr	ebx,1				; this handle nonparity numbers
	mov	[rsi],rdx			; rsi points now to tmp_buf
;	lea	rdi,[rsp + 8*(4+0)]
; not necessary, RDI already points there
	mov	ecx,dword [last_PID]

	call	check_sw_bp_patch_when_necessary_before_write_memory

	call	write_debuggee_memory
;	jc	proc_LV_edma02_04_end
	jmp	proc_LV_edma02_04_end

proc_LV_edma02_04_subitem3:
; edit ascii string
	lea	rdi,[tmp_buf]
	lea	r9,[Code_listview_dump_start_address]
	mov	r8d,dword [ListView_edit_last_item_and_subitem]	; get item
	mov	rcx,qword [r9 + rdx*8]		; start address of item 0
	shl	r8d,1				; item * 2
	lea	rsi,[tmp_buf_for_opcode]	; dummy used for store address now, not for opcode !
	lea	rdx,[rcx+r8*8]			; original start address + item*16
	mov	ebx,eax
	mov	qword [rsi],rdx
	mov	ecx,dword [last_PID]

	call	check_sw_bp_patch_when_necessary_before_write_memory

	call	write_debuggee_memory_big_area_without_verification
;	jc	proc_LV_edma02_04_end

proc_LV_edma02_04_end:
	add	rsp,8*(4+2)
	pop	r9 r8 rdi rsi rbp rbx rdx rcx rax
	ret

proc_LV_edma05:
; Stack
	push	rax rcx rdx rbx rbp rsi rdi r8 r9
	sub	rsp,8*(4+2)

	lea	rsi,[tmp_buf]
	cmp	dword [ListView_edit_last_item_and_subitem + 4],0	; subitem
	jnz	proc_LV_edma05_subitem1

proc_LV_edma05_subitem0:
; edit displaying address in subitem 0
	call	get_reg64_addr64
	jc	proc_LV_edma05_end
; rdx=address now

	mov	eax,dword [ListView_edit_last_item_and_subitem]	; grab item
	shl	eax,3				; item * 8 because every item displays 8 bytes
	sub	rdx,rax				; correction for item 0 subitem 0
	mov	qword [Stack_listview_dump_start_address],rdx		; update start display position
	jmp	proc_LV_edma02_04_end

proc_LV_edma05_subitem1:
; edit hexa data
	call	ascii2hexa_qword		; this will check string size interval 1-16
	jc	proc_LV_edma05_end
	lea	rdi,[rsp + 8*(4+0)]
	mov	ecx,dword [ListView_edit_last_item_and_subitem]	; get item
	mov	rax,qword [Stack_listview_dump_start_address]
	mov	qword [rdi],rdx
	lea	rsi,[tmp_buf]
	lea	rdx,[rax+rcx*8]			; original start address + item*8
	mov	ebx,8
	mov	qword [rsi],rdx
	mov	ecx,dword [last_PID]

	call	check_sw_bp_patch_when_necessary_before_write_memory

	call	write_debuggee_memory
;	jc	proc_LV_edma05_end
;	jmp	proc_LV_edma05_end

proc_LV_edma05_end:
	add	rsp,8*(4+2)
	pop	r9 r8 rdi rsi rbp rbx rdx rcx rax
	ret

proc_LV_edma06:
; GPR
	push	rcx rdx rsi r8 r9
	sub	rsp,8*(4+0)
	lea	rsi,[tmp_buf]
	cmp	dword [ListView_edit_last_item_and_subitem + 4],1	; subitem
	jnz	proc_LV_edma06_end
;	cmp	eax,16				; ascii2hexa_qword will check this
;	jnbe	proc_LV_edma06_end
	call	ascii2hexa_qword		; output in RDX
	jc	proc_LV_edma06_end
	mov	ecx,dword [ListView_edit_last_item_and_subitem]
	lea	rsi,[gpr_transform]		; transform 0->0, 1->3, 2->1, 3->2, 4->4, ...
	movzx	r9d,byte [rsi+rcx*1]
	lea	r8,[ThreadContext.Rax]
	mov	qword [r8 + r9*8],rdx
	mov	ecx,dword [last_TID]
	call	SetThreadContext_debuggee_CONTEXT_ALL
	jc	proc_LV_edma06_end
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
proc_LV_edma06_end:
	add	rsp,8*(4+0)
	pop	r9 r8 rsi rdx rcx
	ret

proc_LV_edma07:
; RIP
	push	rcx rdx rsi r8 r9
	sub	rsp,8*(4+0)
	lea	rsi,[tmp_buf]
	cmp	dword [ListView_edit_last_item_and_subitem + 4],1	; subitem
	jnz	proc_LV_edma07_end
;	cmp	eax,16				; ascii2hexa_qword will check this
;	jnbe	proc_LV_edma07_end
	call	ascii2hexa_qword		; output in RDX
	jc	proc_LV_edma07_end
	mov	qword [ThreadContext.Rip],rdx
	mov	ecx,dword [last_TID]
	call	SetThreadContext_debuggee_CONTEXT_ALL
	jc	proc_LV_edma07_end
	mov	rax,qword [ThreadContext.Rip]
	mov	qword [Code_listview_dump_start_address],rax
	call	code_1st_disassemble_back
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
proc_LV_edma07_end:
	add	rsp,8*(4+0)
	pop	r9 r8 rsi rdx rcx
	ret

proc_LV_edma08:
; XMM
	push	rax rcx rdx rsi r8 r9 r10 r11
	sub	rsp,8*(4+7)
	lea	rsi,[tmp_buf]

	lea	rdx,[ThreadContext.FltSave.XmmRegisters]
	mov	ecx,dword [ListView_edit_last_item_and_subitem]	; get item
	shl	ecx,1				; item*2
	lea	r9,[rdx + rcx*8]		; ThreadContext + 1A0h + item*16
	mov	r11,[pointer_to_AVX]
	test	r11,r11
	jz	@f				; if is is NULL it stays NULL
	lea	r11,[r11+8*rcx]
@@:
	call	get_number_of_decimal_dots	; input string at RSI with size in ECX
						; return number of decimal dots in EDX
	test	edx,1
	jnz	proc_LV_edma08_end		; must have an even number
	push	rcx
	mov	ecx,[AVX_enabled]
	and	cl,1
	shr	edx,cl				; avx doubles the number of numbers
	pop	rcx
	jnz	proc_LV_edma08_floating
proc_LV_edma08_hexa:

	cmp	dword [ListView_edit_last_item_and_subitem + 4],1	; subitem 1 = hexa
	jnz	proc_LV_edma08_end		; mismatch

	cmp	byte[AVX_enabled],0
	jz	proc_LV_edma08_hexa_after_YMM
	test	r11,r11
	jz	proc_LV_edma08_hexa_after_YMM

	lea	rdi,[rsp + 8*(4+0)]
	call	ascii2hexa_avx		
	jc	proc_LV_edma08_end
	movdqa	xmm0,dqword [rsp + 8*(4+0)]
	movdqa	xmm1,dqword [rsp + 8*(6+0)]
	movdqa	dqword [r9],xmm0	
	movdqa	dqword [r11],xmm1	
	jmp	proc_LV_edma08_common_end
	
proc_LV_edma08_hexa_after_YMM:	
	lea	rdi,[rsp + 8*(4+0)]
	call	ascii2hexa		; input: rsi ascii string, rax string size, rdi buffer for output
					; eax must be in interval 1-32, subroutine will check it
	jc	proc_LV_edma08_end
	movdqa	xmm0,dqword [rsp + 8*(4+0)]
	movdqa	dqword [r9],xmm0	
	jmp	proc_LV_edma08_common_end

proc_LV_edma08_floating:
	cmp	edx,2
	jnz	proc_LV_edma08_try_single_precision
proc_LV_edma08_try_double_precision:
	cmp	dword [ListView_edit_last_item_and_subitem + 4],2	; subitem 2 = double precision
	jnz	proc_LV_edma08_end		; mismatch
	emms
	
	cmp	[AVX_enabled],0
	jz	proc_LV_edma08_try_double_precision_after_YMM
	test	r11,r11
	jz	proc_LV_edma08_try_double_precision_after_YMM	
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]		; skip processed value
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]		; skip processed value
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	fstp	qword [r11]
	fstp	qword [r11+8]	
proc_LV_edma08_try_double_precision_after_YMM:	
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]		; skip processed value
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	fstp	qword [r9]
	fstp	qword [r9+8]
	jmp	proc_LV_edma08_common_end

proc_LV_edma08_try_single_precision:
	cmp	edx,4
	jnz	proc_LV_edma08_end
proc_LV_edma08_single_precision:
	cmp	dword [ListView_edit_last_item_and_subitem + 4],3	; subitem 3 = single precision
	jnz	proc_LV_edma08_end		; mismatch
	emms
	
	cmp	[AVX_enabled],0
	jz	proc_LV_edma08_try_single_precision_after_YMM
	test	r11,r11
	jz	proc_LV_edma08_try_single_precision_after_YMM		
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]		; skip processed value
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]		
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]		
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]		
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	fstp	dword [r11]
	fstp	dword [r11+4]
	fstp	dword [r11+8]
	fstp	dword [r11+12]	
	
proc_LV_edma08_try_single_precision_after_YMM:
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]		; skip processed value
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	lea	rsi,[rsi+r10*1]
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma08_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma08_end
	call	ascii2fpu
	jc	proc_LV_edma08_end
	fstp	dword [r9]
	fstp	dword [r9+4]
	fstp	dword [r9+8]
	fstp	dword [r9+12]

proc_LV_edma08_common_end:
	mov	ecx,dword [last_TID]
	call	SetThreadContext_debuggee_CONTEXT_ALL
	jc	proc_LV_edma08_end
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
proc_LV_edma08_end:
	add	rsp,8*(4+7)
	pop	r11 r10 r9 r8 rsi rdx rcx rax
	ret

proc_LV_edma09:
; MM/ST
	push	rax rcx rdx rsi r8 r9
	sub	rsp,8*(4+3)
	lea	rsi,[tmp_buf]

	lea	rdx,[ThreadContext.FltSave.FloatRegisters]
	mov	ecx,dword [ListView_edit_last_item_and_subitem]	; get item
	shl	ecx,1				; item*2
	lea	r9,[rdx + rcx*8]		; ThreadContext + 1A0h + item*16

	call	get_number_of_decimal_dots	; input string at RSI with size in ECX
						; return number of decimal dots in EDX
	or	edx,edx
	jnz	proc_LV_edma09_floating
proc_LV_edma09_hexa:
	cmp	dword [ListView_edit_last_item_and_subitem + 4],2	; subitem 2 = MM hexa
	jnz	proc_LV_edma08_end		; mismatch

	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; eax must be in interval 1-16, subroutine will check it
	jc	proc_LV_edma09_end
	mov	qword [r9],rdx
	jmp	proc_LV_edma09_common_end

proc_LV_edma09_floating:
	cmp	edx,1
	jnz	proc_LV_edma09_try_single_precision
proc_LV_edma09_80_bit:
	cmp	dword [ListView_edit_last_item_and_subitem + 4],1	; subitem 1 = FPU 80-bit floating
	jnz	proc_LV_edma08_end		; mismatch
	emms
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma09_end
	call	ascii2fpu
	jc	proc_LV_edma09_end

	lea	rdx,[ThreadContext.FltSave]
; get the stack top number
	mov	cl,byte [rdx + 3]	; get the high byte of the status word
	and	cl,00111000b		; mask out stack
	shr	cl,3			; adjust

	mov	al,byte [rdx + 4]	; get the tag byte
	ror	al,cl			; adjust so first tag is in low bit

	mov	r8d,dword [ListView_edit_last_item_and_subitem]	; 0-7 st number = item
	bts	eax,r8d
	rol	al,cl
	mov	byte [rdx + 4],al

	shl	r8d,1
	fstp	tbyte [rdx+20h + r8*8]
	jmp	proc_LV_edma09_common_end

proc_LV_edma09_try_single_precision:
	cmp	edx,2
	jnz	proc_LV_edma09_end
proc_LV_edma09_single_precision:
	cmp	dword [ListView_edit_last_item_and_subitem + 4],3	; subitem 3 = MM 2 single precision
	jnz	proc_LV_edma08_end		; mismatch
	emms
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma09_end
	call	ascii2fpu
	jc	proc_LV_edma09_end
	lea	rsi,[rsi+r10*1]
	lodsb
	cmp	al,' '
	jnz	proc_LV_edma09_end
	call	get_floating_ascii_string_size
	or	r10,r10
	jz	proc_LV_edma09_end
	call	ascii2fpu
	jc	proc_LV_edma09_end
	fstp	dword [r9]
	fstp	dword [r9+4]

proc_LV_edma09_common_end:
	mov	ecx,dword [last_TID]
	call	SetThreadContext_debuggee_CONTEXT_ALL
	jc	proc_LV_edma09_end
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
proc_LV_edma09_end:
	add	rsp,8*(4+3)
	pop	r9 r8 rsi rdx rcx rax
	ret

proc_LV_edma0A:
; flags
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	cmp	dword [ListView_edit_last_item_and_subitem + 4],1	; subitem
	jnz	proc_LV_edma0A_end
	cmp	dword [ListView_edit_last_item_and_subitem],7		; hexa ?
	jz	proc_LV_edma0A_flags_hexa
	cmp	eax,1
	jnz	proc_LV_edma0A_end
	movzx	eax,byte [tmp_buf]
	sub	al,'0'
	cmp	al,1
	jnbe	proc_LV_edma0A_end		; only '0' and '1' are allowed
	mov	ecx,dword [ListView_edit_last_item_and_subitem]
	lea	rdx,[flag_bits]
	mov	cl,byte [rdx+rcx*1]
	shl	eax,cl
	btr	dword [ThreadContext.EFlags],ecx; clear flag
	or	dword [ThreadContext.EFlags],eax; set flag or leave it clear
proc_LV_edma0A_set_it:
	mov	ecx,dword [last_TID]
	call	SetThreadContext_debuggee_CONTEXT_ALL
	jc	proc_LV_edma0A_end
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
proc_LV_edma0A_end:
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
;	ret

proc_LV_edma0B:
proc_LV_edma0C:
proc_LV_edma0D:
; segment registers, debug registers, floating control
; nothing to do
	ret

proc_LV_edma0A_flags_hexa:
	cmp	eax,8
	jnbe	proc_LV_edma0A_end
	push	rsi
	lea	rsi,[tmp_buf]
	call	ascii2hexa_qword	; output in RDX
	pop	rsi
	jc	proc_LV_edma07_end
	mov	dword [ThreadContext.EFlags],edx
	jmp	proc_LV_edma0A_set_it
; -------- subroutines end ----------

; -------- subroutine ----------
get_number_of_decimal_dots:
; input:	RSI	string buffer
;		EAX	string size
; output:	EDX	number of dots
	push	rax rcx rdi
	mov	ecx,eax
	lea	rdi,[rsi]
	mov	al,'.'
	xor	edx,edx
get_number_of_decimal_dots_start:
	repnz scasb
	jnz	get_number_of_decimal_dots_done
	inc	edx
	jmp	get_number_of_decimal_dots_start
get_number_of_decimal_dots_done:
	pop	rdi rcx rax
	ret
; -------- subroutine end ----------

; -------- subroutine ----------
get_floating_ascii_string_size:
	push	rax rcx rsi
	mov	ecx,eax
	xor	r10,r10
AMDPad16
get_floating_ascii_string_size_L0:
	lodsb
	cmp	al,0
	jz	get_floating_ascii_string_size_end
	cmp	al,' '
	jz	get_floating_ascii_string_size_end
	inc	r10
	loop	get_floating_ascii_string_size_L0
get_floating_ascii_string_size_end:
	pop	rsi rcx rax
	ret
; -------- subroutine end ----------
