close_debuggee_procedure:
	push	rdi rcx rdx r8 r9
	sub	rsp,8*(4+2)

; terminate all processes
	mov	rax,qword [multiprocess_multithread_support_address]
	lea	rdi,qword [rax + MaxProcesses*8]	; begin of processes handles
close_debuggee_procedure_L0:
	mov	rdx,qword [multiprocess_multithread_support_address]
	lea	rcx,[rdx+MaxProcesses*8+MaxProcesses*8]	; end of processes handles
	sub	rcx,rdi
	jz	close_debuggee_procedure_L1
	shr	rcx,3					; number of slot holding handles
	xor	eax,eax
	cld
	repz scasq
	xor	edx,edx
	mov	rcx,qword [rdi-8]
	jrcxz	close_debuggee_procedure_L1
	call	qword [TerminateProcess]
	jmp	close_debuggee_procedure_L0
close_debuggee_procedure_L1:

; resume thread owning debug loop, it could be suspended !
	mov	dword [continue_flag_after_resume],DBG_CONTINUE
	mov	rcx,qword [hDbgThread]
	call	ResumeThreadSafe

;	call	[SwitchToThread]			; yield execution to another thread
							; allow process(es) being
							; terminated to terminate

close_debuggee_procedure_epi:
	add	rsp,8*(4+2)
	pop	r9 r8 rdx rcx rdi
	ret

; -------- subroutine ----------
align 16
put_temporary_hw_or_sw_bp:
; in: RAX address where to set the breakpoint
;     RCX PID (process ID for setting SW BP)
;             (HW BP are set to every thread, so we needn't TID)
; out: CF=0 if success, CF=1 if failure
; it tries to put HW BP, if there isn't any empty HW BP then it puts SW BP
	push	rax		; only for keeping stack aligned at dqword
	bt	dword [face.Rambo],IDM_RAMBO_CCCD - IDM_RAMBO
	jnc	put_temporary_hw_or_sw_bp_put_sw_bp

; put HW BP breakpoint at the address
	call	find_first_empty_put_HW_BP_temporary_flag
	jnc	put_temporary_hw_or_sw_bp_epi
; fall back to set SW BP in case of find_first_empty_put_HW_BP_temporary_flag failure

put_temporary_hw_or_sw_bp_put_sw_bp:
	call	find_first_empty_slot_put_SW_BP_temporary_flag
; the last procedure clears or setc carry flag in the same way as put_temporary_hw_or_sw_bp procedure

put_temporary_hw_or_sw_bp_epi:
	pop	rax
	ret
; -------- subroutine end ----------

; -------- subroutine ----------
align 16
find_first_empty_put_HW_BP_temporary_flag:
	push	rax rcx rdx r8 r9 rdi
	sub	rsp,8*(4+1)

	mov	cl,byte [all_thread_dr7]	; get DR7
	xor	edx,edx
find_first_empty_put_HW_BP_temporary_flag_L0:
	test	cl,11b
	jz	find_first_empty_put_HW_BP_temporary_flag_empty_HW_BP
	shr	cl,2
	inc	edx
	cmp	dl,4
	jc	find_first_empty_put_HW_BP_temporary_flag_L0
	jmp	find_first_empty_put_HW_BP_temporary_flag_no_empty_HW_BP
find_first_empty_put_HW_BP_temporary_flag_empty_HW_BP:
	lea	rdi,[msg_HW_BP_addr]
	call	hexa_64_rax
	mov	byte [rdi+16],'h'

	lea	rdi,[all_thread_dr0]
	mov	[rdi+rdx*8],rax	; linear address in corresponding DR of DR0-DR3

	lea	eax,[rdx+'0']
	mov	byte [msg_HW_BP_No_ascii],al

	mov	rax,'EveryThr'
	mov	qword [msg_HW_BP_thrd],rax
	mov	byte [msg_HW_BP_thrd+8],'d'

	mov	rax,'execute '
	mov	qword [msg_HW_BP_trigger],rax

	lea	rdi,[msg_HW_BP_trigger+8]
	mov	rax,'size=byt'
	mov	[rdi],rax
	mov	al,'e'
	mov	[rdi+8],al

	movdqu	xmm0,dqword [DlgProc01_msg_flag_temp]
	movdqu	dqword [rdi+9],xmm0

	lea	rdi,[all_thread_dr0]

	mov	byte [rdi-8 + rdx*1],0	; clear HW_BP_permanent byte
					; it means that HW BP is temporary
	lea	ecx,[rdx*4]
	mov	eax,11111111111100001111111111111111b	; prepare clearing LEN, R/W of DR7
	rol	eax,cl
; mask for clean L and G bit of DR7
	shr	ecx,1				; ECX = HW_BP_No. * 2
	mov	al,11111100b
	rol	al,cl
; clean bits there !
	and	[rdi+8*5],eax	; clears bits
; LEN=00b code execution, R/W=00b byte size (only one allowed for code execution type of HW BP)
	bts	[rdi+8*5],ecx	; set corresponding L bit of L0-L3 bits

;	or	byte [rdi + 8*5 + 1],00000100b	; bit 10. is default 1

	call	set_debug_registers_in_all_threads
	jc	find_first_empty_put_HW_BP_temporary_flag_failed_to_write_context

	lea	rax,[msg_HW_BP_text]
	call	msg_to_LogEdit
	clc

find_first_empty_put_HW_BP_temporary_flag_epi:
	lea	rsp,[rsp+8*(4+1)]	; doesn't touch carry flag
	pop	rdi r9 r8 rdx rcx rax
	ret
find_first_empty_put_HW_BP_temporary_flag_no_empty_HW_BP:
	lea	rax,[msg_no_empty_HW_BP_text]
find_first_empty_put_HW_BP_temporary_flag_msg_to_log_failed:
	call	msg_to_LogEdit
find_first_empty_put_HW_BP_temporary_flag_failed:
	stc
	jmp	find_first_empty_put_HW_BP_temporary_flag_epi
find_first_empty_put_HW_BP_temporary_flag_failed_to_write_context:
	lea	rax,[msg_HW_BP_context_write_failed_text]
	jmp	find_first_empty_put_HW_BP_temporary_flag_msg_to_log_failed
; -------- subroutine end ----------

; -------- subroutines ----------
align 16
find_first_empty_slot_put_SW_BP_temporary_flag:
; input:	rax address of the breakpoint
;		ecx process Id
; output:	Carry Flag set if error.
	push	rax rcx rdx rbx rdi
; We needn't sub rsp, because we don't use API directly in this procedure. Stack is dqword aligned now.

; scan if SW BP hasn't been set already:
	call	scan_sw_bp_addr_pid
	jnz	find_first_empty_slot_put_SW_BP_temporary_flag_L0
	mov	ebx,edx			; save index

	mov	rdi,qword [breakpoints_space_address]
	cmp	byte [rdi + (8+4+1)*MaxNumberOfBreakpoints + rbx*1],SW_BP_flag_permanent
	jz	find_first_empty_slot_put_SW_BP_temporary_flag_epilogue
					; if zero, then carry=0 because comparing 2 equals

; was set, we only change it's flag
	mov	byte [rdi + (8+4+1)*MaxNumberOfBreakpoints + rbx*1],SW_BP_flag_temporary

	lea	rax,[msg_sw_bp_pit]
	call	msg_to_LogEdit

	clc					; necessary clearing of carry before epiloguing, we must tell success before return
	jmp	find_first_empty_slot_put_SW_BP_temporary_flag_epilogue

find_first_empty_slot_put_SW_BP_temporary_flag_L0:
; find first empty SW BP slot
	mov	rdi,qword [breakpoints_space_address]
	mov	ecx,MaxNumberOfBreakpoints
	xor	eax,eax
	lea	ebx,[rcx-1]		; the smallest opcode possible, has only 3 bytes
	cld
	repnz scasq
	stc
	jnz	find_first_empty_slot_put_SW_BP_temporary_flag_epilogue
	sub	ebx,ecx
; rbx = index of first empty slot, index value between 0 - (MaxNumberOfBreakpoints-1)

	mov	rdi,qword [breakpoints_space_address]
	mov	rax,qword [rsp+8*4]	; address of SW BP
	mov	ecx,dword [rsp+8*3]	; PID
	lea	rdx,[rdi+(8+4)*MaxNumberOfBreakpoints + rbx*1]	; point to address where to store original byte on breakpoint position
	call	put_0CCh		; in: RAX SW_BP_addr , ECX PID , RDX buffer to store original byte at SW BP position
	jc	find_first_empty_slot_put_SW_BP_temporary_flag_epilogue

; none of next 3 instructions affect Carry flag
;	mov	rax,qword [rsp+8*4]	; address of SW BP
	mov	dword [rdi + 8*MaxNumberOfBreakpoints + rbx*4],ecx	; PID
	mov	byte [rdi + (8+4+1)*MaxNumberOfBreakpoints + rbx*1],SW_BP_flag_temporary
	mov	qword [rdi + 8*rbx],rax

	lea	rdi,[msg_sbtws_addr]
	call	hexa_64_rax
	mov	eax,ecx
	lea	rdi,[msg_sbtws_PID]
	call	hexa_32_eax
	mov	eax,ebx
	lea	rdi,[msg_sbtws_No]
	call	hexa_32_eax

	lea	rax,[msg_sbtws]
	call	msg_to_LogEdit

find_first_empty_slot_put_SW_BP_temporary_flag_epilogue:
	pop	rdi rbx rdx rcx rax
	ret

find_first_empty_slot_put_SW_BP_permanent_flag:
	push	rax rcx rdx rbx rdi

	call	scan_sw_bp_addr_pid
	jnz	find_first_empty_slot_put_SW_BP_permanent_flag_L0
	mov	ebx,edx			; save index

	mov	rdi,qword [breakpoints_space_address]
	cmp	byte [rdi + (8+4+1)*MaxNumberOfBreakpoints + rbx*1],SW_BP_flag_temporary
	jz	find_first_empty_slot_put_SW_BP_permanent_flag_epilogue
					; if zero, then carry=0 because comparing 2 equals

; was set, we only change it's flag
	mov	byte [rdi + (8+4+1)*MaxNumberOfBreakpoints + rbx*1],SW_BP_flag_permanent

	lea	rax,[msg_sw_bp_tit]
	call	msg_to_LogEdit

	clc					; necessary clearing of carry before epiloguing, we must tell success before return
	jmp	find_first_empty_slot_put_SW_BP_permanent_flag_epilogue

find_first_empty_slot_put_SW_BP_permanent_flag_L0:
; find first empty SW BP slot
	mov	rdi,qword [breakpoints_space_address]
	mov	ecx,MaxNumberOfBreakpoints
	xor	eax,eax
	lea	ebx,[rcx-1]
	cld
	repnz scasq
	stc
	jnz	find_first_empty_slot_put_SW_BP_permanent_flag_epilogue
	sub	ebx,ecx
; rbx = index of first empty slot, index value between 0 - (MaxNumberOfBreakpoints-1)

	mov	rdi,qword [breakpoints_space_address]
	mov	rax,qword [rsp+8*4]	; address of SW BP
	mov	ecx,dword [rsp+8*3]	; PID
	lea	rdx,[rdi+(8+4)*MaxNumberOfBreakpoints + rbx*1]	; point to address where to store original byte on breakpoint position
	call	put_0CCh		; in: RAX SW_BP_addr , ECX PID , RDX buffer to store original byte at SW BP position
	jc	find_first_empty_slot_put_SW_BP_permanent_flag_epilogue

	mov	dword [rdi + 8*MaxNumberOfBreakpoints + rbx*4],ecx	; PID
	mov	byte [rdi + (8+4+1)*MaxNumberOfBreakpoints + rbx*1],SW_BP_flag_permanent
	mov	qword [rdi + 8*rbx],rax

	lea	rdi,[msg_sbpws_addr]
	call	hexa_64_rax
	mov	eax,ecx
	lea	rdi,[msg_sbpws_PID]
	call	hexa_32_eax
	mov	eax,ebx
	lea	rdi,[msg_sbpws_No]
	call	hexa_32_eax

	lea	rax,[msg_sbpws]
	call	msg_to_LogEdit

find_first_empty_slot_put_SW_BP_permanent_flag_epilogue:
	pop	rdi rbx rdx rcx rax
	ret

align 16
scan_sw_bp_addr_pid:
; input:	RAX addr
;		ECX PID
; output:	ZF=1 , EDX=index of SW BP if any
;		ZF=0 if none
	push	rcx rbx rsi rdi
	mov	ebx,ecx			; save PID
	mov	rdi,qword [breakpoints_space_address]
	mov	ecx,MaxNumberOfBreakpoints
	lea	rsi,[rdi]
;AMDPad16
scan_sw_bp_addr_pid_L0:
	mov	edx,MaxNumberOfBreakpoints-1
	cld
	repnz scasq
	jnz	scan_sw_bp_addr_pid_end
	sub	edx,ecx
; breakpoint should be at this address, but in another process, so we must check it
	cmp	dword [rsi + 8*MaxNumberOfBreakpoints + rdx*4],ebx
	jnz	scan_sw_bp_addr_pid_L0
; zero flag is set now and EDX=index
scan_sw_bp_addr_pid_end:
	pop	rdi rsi rbx rcx
	ret

align 16
remove_SW_BP_from_iBP_and_clear_its_dbg_store:
; input:	eax breakpoint index (0=1st, ..., MaxNumberOfBreakpoints-1=last)
; output:	Carry Flag set if error.
	push	rax rcx rdx rbx rdi
; We needn't sub rsp, because we don't use API directly in this procedure. Stack is dqword aligned now.
	cmp	eax,MaxNumberOfBreakpoints
	cmc					; complement Carry flag
	jc	remove_SW_BP_from_common_epilogue
	mov	ebx,eax
	jmp	remove_SW_BP_from_common

align 16
remove_SW_BP_from_process_and_clear_its_dbg_store:
; input:	rax address of the breakpoint
;		ecx process ID
; output:	Carry Flag set if error.
	push	rax rcx rdx rbx rdi

; check, if we have this address in our SW BP list
	call	scan_sw_bp_addr_pid
	stc
	jnz	remove_SW_BP_from_common_epilogue
	mov	ebx,edx			; save index
; ebx = index of SW BP slot, index value between 0 - (MaxNumberOfBreakpoints-1)

remove_SW_BP_from_common:
	mov	rdi,qword [breakpoints_space_address]
	mov	rax,qword [rdi+rbx*8]				; address
	mov	ecx,dword [rdi+MaxNumberOfBreakpoints*8+rbx*4]	; PID
	or	rax,rax						; empty slot ?
	jz	remove_SW_BP_from_common_epilogue

;	jrcxz	remove_SW_BP_from_common_epilogue		; empty slot ?
	or	ecx,ecx
	jz	remove_SW_BP_from_common_epilogue		; empty slot ?

	lea	rdx,[rdi+(8+4)*MaxNumberOfBreakpoints + rbx*1]; address where the original byte on the breakpoint position is stored
	call	remove_0CCh		; in: RAX SW_BP_addr , RCX hProcess , RDX buffer with original byte at SW BP position
	jc	remove_SW_BP_from_common_epilogue

	mov	r8,qword [rdi+rbx*8]	; address of breakpoint
	mov	r9d,dword [rdi + 8*MaxNumberOfBreakpoints + rbx*4]	; PID

	lea	rcx,[DlgProc01_msg_flag_temp]
	lea	rax,[rcx + DlgProc01_msg_flag_perm - DlgProc01_msg_flag_temp]
	cmp	byte [rdi + (8+4+1)*MaxNumberOfBreakpoints + rbx*1],SW_BP_flag_temporary
	cmovz	rax,rcx
	movdqu	xmm0,dqword [rax]
	movdqu	dqword [msg_sbwr_flag],xmm0
;if DlgProc01_msg_flag_perm_size <> 16
;Use another way to copy bytes there and change size of reserved space for msg_sbwr_flag!
;end if

	mov	eax,ebx
	lea	rdi,[msg_sbwr_No]
	call	hexa_32_eax

	mov	rax,r8			; addr
	lea	rdi,[msg_sbwr_addr]
	call	hexa_64_rax

	mov	eax,r9d			; PID
	lea	rdi,[msg_sbwr_PID]
	call	hexa_32_eax

	lea	rax,[msg_sbwr]
	call	msg_to_LogEdit

; clear store:
	mov	rdi,qword [breakpoints_space_address]
	xor	eax,eax
	mov	qword [rdi+rbx*8],rax	; address of breakpoint
	mov	dword [rdi + 8*MaxNumberOfBreakpoints + rbx*4],eax	; PID
	mov	byte [rdx],al		; rdx = rdi+(8+4)*MaxNumberOfBreakpoints+rbx*1
	mov	byte [rdi + (8+4+1)*MaxNumberOfBreakpoints + rbx*1],al

remove_SW_BP_from_common_epilogue:
	pop	rdi rbx rdx rcx rax
	ret
; -------- subroutines end ----------

; -------- subroutine ----------
put_0CCh:
; in:	RAX address of SW_BP
;	ECX PID
;	RDX buffer to store original byte at SW BP position
; out:	CF=1 if fail

	push	rax rcx rdx rbx rbp
	sub	rsp,8*(4+4)

; rsp + 8*(4+3)		; dummy values - dummy fprotect flag, dummy byte
; rsp + 8*(4+2)		; ReadMemoryNumberOfBytesRead and WriteMemoryNumberOfBytesWritten
; rsp + 8*(4+1)		; save OldProtect_flag of the VirtualProtectEx
; rsp + 8*(4+0)		; 5th API arg

virtual at rsp+8*(4+1)
put_0CC_old_protect_flag		dq	?
label put_0CC_number_of_bytes_read	at	$
put_0CC_number_of_bytes_written		dq	?
put_0CC_dummy				dq	?
end virtual

	mov	eax,ecx
	call	PID2hProcess
	jc	put_0CCh_fail
	mov	rbp,rdx			; handle

	mov	rdx,qword [rsp+8*(4+4+4)]; lpAddress
	lea	rax,[put_0CC_old_protect_flag]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect 5th param to API
	mov	r9d,PAGE_READWRITE	; flNewProtect
	mov	r8d,1			; dwSize
	mov	rcx,rbp			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	put_0CCh_fail

	lea	rax,[put_0CC_number_of_bytes_read]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,1			; nSize
	mov	r8,qword [rsp+8*(4+4+2)]; lpBuffer
	mov	rdx,qword [rsp+8*(4+4+4)]; lpBaseAddress
	mov	rcx,rbp			; hProcess
	call	qword [ReadProcessMemory]
	or	eax,eax
	jz	put_0CCh_fail
	cmp	dword [put_0CC_number_of_bytes_read],1
	jnz	put_0CCh_fail

	lea	rax,[put_0CC_number_of_bytes_written]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesWritten
	mov	r9d,1			; nSize
	lea	r8,[int03_opcode]	; lpBuffer
	mov	rdx,qword [rsp+8*(4+4+4)]; lpBaseAddress
	mov	rcx,rbp			; hProcess
	call	qword [WriteProcessMemory]
	or	eax,eax
	jz	put_0CCh_fail
	cmp	dword [put_0CC_number_of_bytes_read],1
	jnz	put_0CCh_fail

; Test if 0CCh has been written successfuly... not necessary, above cmp,[...],1 is enough
	lea	rax,[put_0CC_number_of_bytes_read]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,1			; nSize
	lea	r8,[put_0CC_dummy]	; lpBuffer
	mov	rdx,qword [rsp+8*(4+4+4)]; lpBaseAddress
	mov	rcx,rbp			; hProcess
	call	qword [ReadProcessMemory]
	or	eax,eax
	jz	put_0CCh_fail
	cmp	dword [put_0CC_number_of_bytes_read],1
	jnz	put_0CCh_fail
;	mov	al,byte [int03_opcode]
	cmp	byte [put_0CC_dummy],0CCh
	jnz	put_0CCh_fail

	lea	rax,[put_0CC_dummy]	; [Dummy_Protect_flag]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect
	mov	r9d,dword [put_0CC_old_protect_flag]; flNewProtect
; note, r9d must be used, because [] can hold value as FFFFF800000020h
; previous VirtualProtectEx fill only dword, not qword for flags !
; AMD64 zero extends this from 32 bit to 64 bit after move
	mov	r8d,1			; dwSize
	mov	rdx,qword [rsp+8*(4+4+4)]; lpBaseAddress
	mov	rcx,rbp			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	put_0CCh_fail
; one more paranoid check:
; mov eax,[rsp + 8*(4+1)]
; cmp eax,[old_flag_must_be_saved_somewhere_but_we_dont_saved_it_because_we_arent_paranoid]
; jnz put_0CCh_fail
; write hasn't failed, write has been OK, restoring memory access flag has failed

	add	rsp,8*(4+4)
	pop	rbp rbx rdx rcx rax
	clc
	ret

put_0CCh_fail:
	add	rsp,8*(4+4)
	pop	rbp rbx rdx rcx rax
	stc
	ret
; -------- subroutine end ----------

; -------- subroutines ----------
remove_0CCh:
; in:	RAX address of SW_BP
;	ECX PID
;	RDX buffer buffer with original byte at SW BP position
; out:	CF=1 if fail

	push	rax rcx rdx rbx rbp
	sub	rsp,8*(4+4)

; rsp + 8*(4+3)		; dummy values - dummy fprotect flag, dummy byte
; rsp + 8*(4+2)		; ReadMemoryNumberOfBytesRead and WriteMemoryNumberOfBytesWritten
; rsp + 8*(4+1)		; save OldProtect_flag of the VirtualProtectEx
; rsp + 8*(4+0)		; 5th API arg

	mov	eax,ecx
	call	PID2hProcess
	jc	put_0CCh_fail
	mov	rbp,rdx			; handle

	mov	rdx,qword [rsp+8*(4+4+4)]; lpAddress
	lea	rax,[put_0CC_old_protect_flag]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect 5th param to API
	mov	r9d,PAGE_READWRITE	; flNewProtect
	mov	r8d,1			; dwSize
	mov	rcx,rbp			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	remove_0CCh_fail

	lea	rax,[put_0CC_number_of_bytes_written]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesWritten
	mov	r9d,1			; nSize
	mov	r8,qword [rsp+8*(4+4+2)]; lpBuffer
	mov	rdx,qword [rsp+8*(4+4+4)]; lpBaseAddress
	mov	rcx,rbp			; hProcess
	call	qword [WriteProcessMemory]
	or	eax,eax
	jz	remove_0CCh_fail
	cmp	dword [put_0CC_number_of_bytes_read],1
	jnz	remove_0CCh_fail

; Test if byte has been written successfuly... not necessary, above cmp,[...],1 is enough
	lea	rax,[put_0CC_number_of_bytes_read]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,1			; nSize
	lea	r8,[put_0CC_dummy]	; lpBuffer
	mov	rdx,qword [rsp+8*(4+4+4)]; lpBaseAddress
	mov	rcx,rbp			; hProcess
	call	qword [ReadProcessMemory]
	or	eax,eax
	jz	remove_0CCh_fail
	cmp	dword [put_0CC_number_of_bytes_read],1
	jnz	remove_0CCh_fail
	mov	al,byte [put_0CC_dummy]
	mov	rdx,qword [rsp+8*(4+4+2)]
	cmp	byte [rdx],al
	jnz	remove_0CCh_fail

	lea	rax,[put_0CC_dummy]	; [Dummy_Protect_flag]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect
	mov	r9d,dword [put_0CC_old_protect_flag]; flNewProtect
	mov	r8d,1			; dwSize
	mov	rdx,qword [rsp+8*(4+4+4)]; lpBaseAddress
	mov	rcx,rbp			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	remove_0CCh_fail

	add	rsp,8*(4+4)
	pop	rbp rbx rdx rcx rax
	clc
	ret

remove_0CCh_fail:
	add	rsp,8*(4+4)
	pop	rbp rbx rdx rcx rax
	stc
	ret
; -------- subroutine end ----------

; -------- subroutines ----------
align 10h
GetThreadContext_debuggee_CONTEXT_ALL:
; input: ECX dwThreadId
;	 ThreadContext buffer
; output:set Carry Flag if error
	push	rax rcx rdx rbx rbp r8 r9 r10 r11
	sub	rsp,8*(4+2)

	mov	ebx,CONTEXT_ALL
	mov	ebp,ecx				; save thread ID

	and	[pointer_to_AVX],0		; prepare to failure
	and	[size_of_AVX],0			; prepare fo failure

	cmp	[AVX_enabled],0
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8

; Alphonso and tthsqe developped this:
	lea	r9,[rsp+8*(4+1)]		; pointer to the buffer where bytes required will be returned if we have smaller buffer than enough
	mov	dword [r9],sizeof.CONTEXT64EXT
	lea	r8,[rsp+8*(4+0)]		; pointer to buffer where we receive aligned context in case of misalignmented input context buffer
	mov	edx,CONTEXT_ALL or CONTEXT_AVX_I386	; the AVX mask value is 20h which is contradictory with SDK 7.1 where CONTEXT_AVX_AMD64 = 20h

; N.B. the mask may be a bug and may be fixed in the feature, I'm not sure, then change the mask to CONTEXT_AVX_AMD64

	lea	rcx,[ThreadContext]		; buffer for context
	mov	rax,[InitializeContext]		; address of kernel32 exported procedure since win 7.1 (w2k8 R2 SP1), it is 0 in older versions of win
	or	rax,rax
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8
	call	rax
	or	eax,eax
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8
	lea	rcx,[ThreadContext]
	cmp	[rsp+8*(4+0)],rcx
	jnz	GetThreadContext_debuggee_CONTEXT_ALL_L8	; misaligned context, win aligned it, but we have everything shifted higher so hard original offsets are not valid

	xor	r8,r8
	mov	edx,XSTATE_MASK_LEGACY_FLOATING_POINT or XSTATE_MASK_LEGACY_SSE or XSTATE_MASK_GSSE
;	mov	rcx,rcx				; pointer to aligned and initialized context, RCX already set to that
	mov	rax,[SetXStateFeaturesMask]
	or	rax,rax
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8
	call	rax
	or	eax,eax
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8
; the above call seems to set Context.XSaveHeader to XSTATE_MASK_GSSE

	lea	rdx,[rsp+8*(4+0)]
	lea	rcx,[ThreadContext]				; pointer to aligned and initialized context
	mov	rax,[GetXStateFeaturesMask]
	or	rax,rax
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8
	call	rax
	or	eax,eax
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8
	cmp	dword [rsp+8*(4+0)],XSTATE_MASK_LEGACY_FLOATING_POINT or XSTATE_MASK_LEGACY_SSE or XSTATE_MASK_GSSE
	jnz	GetThreadContext_debuggee_CONTEXT_ALL_L8

	lea	r8,[size_of_AVX]				; pointer to a buffer where size of AVX will be obtained
	mov	edx,XSTATE_GSSE
	lea	rcx,[ThreadContext]				; pointer to aligned and initialized context
	mov	rax,[LocateXStateFeature]
	or	rax,rax
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8
	call	rax
	or	rax,rax
	jz	GetThreadContext_debuggee_CONTEXT_ALL_L8
	mov	[pointer_to_AVX],rax				; save pointer to AVX

; success, allow AVX in context flags
	mov	ebx,[ThreadContext.ContextFlags]

GetThreadContext_debuggee_CONTEXT_ALL_L8:
	mov	eax,ebp
	call	TID2hThread
	jc	GetThreadContext_debuggee_CONTEXT_ALL_epilogue
	mov	rcx,rdx
	lea	rdx,[ThreadContext]
;	mov	rdx,[rsp+8*(4+0)]		; aligned context, no need, we already checked whether ThreadContext is at the same address as aligned context

virtual at rdx
ThrdContext	CONTEXT64EXT
end virtual

	mov	[ThrdContext.ContextFlags],ebx
	call	[GetThreadContext]
; If the function succeeds, the return value is nonzero. If the function fails, the return value is zero.
	sub	eax,1				; set Carry flag if API return 0
GetThreadContext_debuggee_CONTEXT_ALL_epilogue:
	lea	rsp,[rsp+8*(4+2)]		; this doesn't touch carry flag instead of ADD
	pop	r11 r10 r9 r8 rbp rbx rdx rcx rax
	ret

align 10h
SetThreadContext_debuggee_CONTEXT_ALL:
; input: ECX dwThreadId
;	 ThreadContext buffer
; output:set Carry Flag if error
	push	rax rcx rdx rbx rbp r8 r9 r10 r11
	sub	rsp,8*(4+2)
	
	mov	ebp,ecx

	mov	eax,ebp
	call	TID2hThread
	jc	SetThreadContext_debuggee_CONTEXT_ALL_epilogue
	mov	rcx,rdx
	lea	rdx,[ThreadContext]
;	mov	rdx,[rsp+8*(4+0)]		; aligned context, no need, we already checked whether ThreadContext is at the same address as aligned context

	call	[SetThreadContext]
; If the function succeeds, the return value is nonzero. If the function fails, the return value is zero.
	sub	eax,1				; set Carry flag if API return 0
SetThreadContext_debuggee_CONTEXT_ALL_epilogue:
	lea	rsp,[rsp+8*(4+2)]		; this doesn't touch carry flag instead of ADD
	pop	r11 r10 r9 r8 rbp rbx rdx rcx rax
	ret
; -------- subroutines end ----------

; -------- subroutine ----------
align 16
set_trap_flag:
; set bit 8 of the flags
; input: ECX dwThreadId
; output:set Carry Flag if error
	sub	rsp,8*(4+1)
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	set_trap_flag_epilogue
	or	byte [ThreadContext.EFlags+1],1
	call	SetThreadContext_debuggee_CONTEXT_ALL
set_trap_flag_epilogue:
	lea	rsp,[rsp+8*(4+1)]		; this doesn't destroy Carry Flag
	ret
; -------- subroutine end ----------

; -------- subroutine ----------
set_debug_registers_in_all_threads:
; if error returns Carry Flag set
	push	rcx
	push	rdx
	push	rbx
	push	rdi
	push	r8
	push	r9
	sub	rsp,8*(4+1)
	mov	rdi,qword [multiprocess_multithread_support_address]
	mov	ebx,MaxThreads
	add	rdi,MaxProcesses*8*2		; skip first store of PID...hProcess
set_allthreads_dr_begin:
	mov	ecx,ebx
	xor	eax,eax
; this xor clears Carry Flag
	jrcxz	set_allthreads_dr_end
	cld
	repz scasq				; find first nonzero qword = valid ThreadId
	mov	ebx,ecx
	cmp	qword [rdi-8],rax		; in case of last repz checked qword returned ZeroFlag=1 and RCX=0
; if zero flag set, carry isn't set
	jz	set_allthreads_dr_end
	mov	rcx,qword [rdi-8 + MaxThreads*8]; hThread
	jrcxz	set_allthreads_dr_begin
	cmp	rcx,INVALID_HANDLE_VALUE
	jz	set_allthreads_dr_begin
	call	set_debug_registers_in_thread
	jnc	set_allthreads_dr_begin
set_allthreads_dr_end:
	add	rsp,8*(4+1)
	pop	r9
	pop	r8
	pop	rdi
	pop	rbx
	pop	rdx
	pop	rcx
	ret

set_debug_registers_in_thread:
; input:	rcx = hThread (thread handle)
	push	rcx
	push	rdx
	push	r8
	push	r9
	sub	rsp,8*(4+1)
	lea	rdx,[ThreadContext]
virtual at 0
contxt	CONTEXT64
end virtual
	mov	dword [rdx + contxt.ContextFlags],CONTEXT_ALL
;	mov	rcx,qword [rsp+8*(4+1+3)]	; hThread
; rcx was set already
	call	qword [GetThreadContext]
	or	rax,rax
	jz	set_debug_registers_in_thread_failed

; transfer debug registers into thread context
	movdqa	xmm0,dqword [all_thread_dr0]	; dr0, dr1
	movdqa	xmm1,dqword [all_thread_dr2]	; dr2, dr3
	movdqa	xmm2,dqword [all_thread_dr6]	; dr6, dr7

	lea	rdx,[ThreadContext]
	movdqu	dqword [rdx + contxt.Dr0],xmm0
	movdqu	dqword [rdx + contxt.Dr2],xmm1
	movdqu	dqword [rdx + contxt.Dr6],xmm2

;	lea	rdx,[ThreadContext]
;	mov	dword [rdx + contxt.ContextFlags],CONTEXT_ALL
; was set already
	mov	rcx,qword [rsp+8*(4+1+3)]	; hThread
	call	qword [SetThreadContext]
	or	rax,rax
	jz	set_debug_registers_in_thread_failed

	add	rsp,8*(4+1)
	clc
	pop	r9
	pop	r8
	pop	rdx
	pop	rcx
	ret

set_debug_registers_in_thread_failed:
	add	rsp,8*(4+1)
	stc
	pop	r9
	pop	r8
	pop	rdx
	pop	rcx
	ret
; -------- subroutine end ----------


; -------- subroutine ----------
align 16
available_debuggee_memory:
; ecx=PID
; qword [rsi] start address in debuggee
; out: rax number of bytes

a=1				; return address from procedure
b=9				; number of pushed registers
d=(sizeof.MEMORY_BASIC_INFORMATION64+7)/8
e=4				; 4 qwords reserved for API
c=(a+b+d+e) and 1		; align stack at dqword
	push	rcx rdx rbx rbp rdi r8 r9 r10 r11
	sub	rsp,8*(c+d+e)

	mov	eax,ecx
	call	PID2hProcess
	xor	eax,eax
	jc	available_debuggee_memory_epilogue
	mov	rbx,rdx

	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[rsp+8*e]
	mov	rdx,[rsi]
	mov	rcx,rbx				; handle of process
	call	[VirtualQueryEx]
	xor	ecx,ecx
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	mov	eax,ecx
	jnz	available_debuggee_memory_epilogue
	cmp	[rsp+8*e+MEMORY_BASIC_INFORMATION64.State],MEM_COMMIT
	jnz	available_debuggee_memory_epilogue

	mov	rdi,[rsp+8*e+MEMORY_BASIC_INFORMATION64.BaseAddress]
	mov	rbp,[rsp+8*e+MEMORY_BASIC_INFORMATION64.RegionSize]

AMDPad16
available_debuggee_memory_scan_end:
; check whether the following page exists
	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[rsp+8*e]
	lea	rdx,[rdi+rbp*1]
	mov	rcx,rbx				; handle of process
	call	[VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	jnz	available_debuggee_memory_found_end
	cmp	[rsp+8*e+MEMORY_BASIC_INFORMATION64.State],MEM_COMMIT
	jnz	available_debuggee_memory_found_end
	add	rbp,[rsp+8*e+MEMORY_BASIC_INFORMATION64.RegionSize]
	jmp	available_debuggee_memory_scan_end

available_debuggee_memory_found_end:
	xor	ecx,ecx
	lea	rax,[rdi+rbp*1]
	sub	rax,[rsi]
	cmovc	rax,rcx

available_debuggee_memory_epilogue:
	add	rsp,8*(c+d+e)
	pop	r11 r10 r9 r8 rdi rbp rbx rdx rcx
	ret
; -------- subroutine end ----------


; -------- subroutine ----------
align 16
read_debuggee_memory:
; read ebx bytes from ecx=PID debuggee from address in qword [rsi] to debugger buffer at rdi
	push	rcx
	sub	rsp,8*(4+8)

	mov	eax,ecx
	call	PID2hProcess
	jc	read_debuggee_memory_epilogue
	mov	rcx,rdx			; hProcess

	lea	rax,[rsp+8*(4+2)]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,ebx			; nSize
	lea	r8,[rdi]		; lpBuffer
	mov	rdx,qword [rsi]		; lpBaseAddress
;	mov	rcx,rcx			; hProcess
	call	qword [ReadProcessMemory]
	or	eax,eax
	jz	read_debuggee_memory_slower_way
	cmp	dword [rsp+8*(4+2)],ebx
	jnz	read_debuggee_memory_slower_way
	clc
read_debuggee_memory_epilogue:
	lea	rsp,[rsp+8*(4+8)]	; this doesn't change carry instead of ADD
	pop	rcx
	ret

read_debuggee_memory_slower_way:
; try to read in memory pages
;	or	ebx,ebx			; only to be sure...
;	stc
;	jz	read_debuggee_memory_slower_way_end

	mov	qword [rsp+8*(4+7)],rdi
	mov	qword [rsp+8*(4+6)],rsi
	mov	qword [rsp+8*(4+5)],rbp
	mov	qword [rsp+8*(4+4)],rbx

	mov	eax,dword [rsp+8*(4+8)]	; grab PID from the stack
	call	PID2hProcess
;	jc	read_debuggee_memory_epilogue	; not necessary, we have checked it already
	mov	rbp,rdx			; hProcess

	mov	rsi,[rsi]		; BaseAddress

read_debuggee_memory_slower_way_begin_loop:
	lea	rax,[rsp + 8*(4+1)]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect
	mov	r9d,PAGE_READONLY	; flNewProtect
	mov	r8d,page_size_for_AMD64	; dwSize
	lea	rdx,[rsi]		; lpAddress
	mov	rcx,rbp			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	stc
	jz	read_debuggee_memory_slower_way_end

	lea	rax,[rsp + 8*(4+2)]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,page_size_for_AMD64	; nSize
	cmp	r9d,ebx
	cmovnbe	r9d,ebx
	lea	r8,[rdi]		; lpBuffer
	lea	rdx,[rsi]		; lpBaseAddress
	mov	rcx,rbp			; hProcess
	call	qword [ReadProcessMemory]
	or	eax,eax
	stc
	jz	read_debuggee_memory_slower_way_end
	mov	ecx,page_size_for_AMD64	; nSize
	cmp	ecx,ebx
	cmovnbe	ecx,ebx
	cmp	dword [rsp + 8*(4+2)],ecx
	stc
	jnz	read_debuggee_memory_slower_way_end

	lea	rax,[rsp + 8*(4+3)]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect
	mov	r9d,dword [rsp + 8*(4+1)]	; flNewProtect
	mov	r8d,page_size_for_AMD64	; dwSize
	lea	rdx,[rsi]		; lpAddress
	mov	rcx,rbp			; hProcess
	call	[VirtualProtectEx]
	or	eax,eax
	stc
	jz	read_debuggee_memory_slower_way_end

	mov	eax,dword [rsp + 8*(4+2)]
	add	rsi,rax
	add	rdi,rax
	sub	ebx,eax			; this must clear carry flag at successful end
	jnbe	read_debuggee_memory_slower_way_begin_loop

;VirtualQueryEx

read_debuggee_memory_slower_way_end:
	mov	rbx,qword [rsp+8*(4+4)]
	mov	rbp,qword [rsp+8*(4+5)]
	mov	rsi,qword [rsp+8*(4+6)]
	mov	rdi,qword [rsp+8*(4+7)]

	jmp	read_debuggee_memory_epilogue

; -------- subroutine end ----------

; -------- subroutines ----------
align 16
write_debuggee_memory:
; write ebx bytes from debugger rdi to ecx=PID debuggee [rsi], then verify them by reading
; ebx is max 8
; verifying doesn't occur when memory wraps into 2 sections
write_debuggee_memory_big_area_without_verification:
; write ebx bytes from debugger rdi to ecx PID debuggee [rsi]
; ebx may be greather than 8

; Note, writing 0 bytes returns success !

	push	rcx rbx rbp rdi r15
	push	qword [rsi]
	sub	rsp,8*(4+4+7)
if sizeof.MEMORY_BASIC_INFORMATION64 > 8*7
Increase stack size for local variables !
end if

; rsp+8*(4+4)		; used for handle
; rsp+8*(4+3)		; dummy values - dummy fprotect flag, dummy byte, for repz cmpsb
; rsp+8*(4+2)		; WriteMemoryNumberOfBytesWritten and ReadMemoryNumberOfBytesRead
; rsp+8*(4+1)		; save OldProtect_flag of the VirtualProtectEx
; rsp+8*(4+0)		; 5th API arg

	mov	eax,ecx
	call	PID2hProcess
	jc	write_debuggee_memory_fail_end
	mov	r15,rdx			; hProcess

	cmp	ebx,1
	jz	write_debuggee_memory_L0	; 1 byte can't be in 2 sections...
	jc	write_debuggee_memory_success	; we needn't to read 0 bytes...

	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64	; dwLenght
	lea	r8,[rsp+8*(4+4)]	; lpBuffer
	mov	rdx,qword [rsi]		; lpAddress
	mov	rcx,r15			; hProcess
	call	qword [VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	jnz	write_debuggee_memory_fail_end

; check whether we are in one section (it means continuous block with the same ProtectFlag)
	mov	rax,[rsp+8*(4+4)+MEMORY_BASIC_INFORMATION64.BaseAddress]
	add	rax,[rsp+8*(4+4)+MEMORY_BASIC_INFORMATION64.RegionSize]
; rax=end of region
	sub	rax,qword [rsi]
; rax=remainder to the end of the section from requested begin of reading
	cmp	rax,rbx
	jc	write_debuggee_memory_more_sections

write_debuggee_memory_L0:
	lea	rax,[rsp+8*(4+1)]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect 5th param to API
	mov	r9d,PAGE_READWRITE	; flNewProtect
	mov	r8d,ebx			; dwSize
	mov	rdx,qword [rsi]		; lpAddress
	mov	rcx,r15			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	write_debuggee_memory_fail_end

	call	write_debuggee_memory_in_one_section
	jc	write_debuggee_memory_fail

	cmp	ebx,8
	jnbe	write_debuggee_memory_L7

; check whether bytes have been successfully written
	lea	rax,[rsp+8*(4+2)]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,ebx			; nSize
	lea	r8,[rsp+8*(4+3)]	; lpBuffer
	mov	rdx,qword [rsi]		; lpBaseAddress
	mov	rcx,r15			; hProcess
	call	qword [ReadProcessMemory]
	or	eax,eax
	jz	write_debuggee_memory_fail
	cmp	dword [rsp+8*(4+2)],ebx
	jnz	write_debuggee_memory_fail

;	lea	rax,[rsi]
;	lea	rdx,[rdi]
	push	rsi rdi
	mov	ecx,ebx
	lea	rsi,[rsp+8*(4+3)]
;	lea	rdi,[rdi]
	cld
	repz cmpsb
	pop	rdi rsi
;	lea	rsi,[rax]
;	lea	rdi,[rdx]
	jnz	write_debuggee_memory_fail

write_debuggee_memory_L7:

	lea	rax,[rsp+8*(4+3)]	; [Dummy_Protect_flag]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect
	mov	r9d,dword [rsp+8*(4+1)]	; flNewProtect
	mov	r8d,ebx			; dwSize
	mov	rdx,qword [rsi]		; lpAddress
	mov	rcx,r15			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	write_debuggee_memory_fail

write_debuggee_memory_success:
	clc
write_debuggee_memory_epilogue:
	lea	rsp,[rsp+8*(4+4+7)]	; this doesn't change carry instead of ADD
	pop	qword [rsi]		; restore begin of memory
	pop	r15 rdi rbp rbx rcx
	ret

write_debuggee_memory_more_sections:
	mov	ebp,ebx			; total size

write_debuggee_memory_more_sections_L0:
	mov	ebx,eax			; size till the end of the section

	lea	rax,[rsp+8*(4+1)]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect 5th param to API
	mov	r9d,PAGE_READWRITE	; flNewProtect
	mov	r8d,ebx			; dwSize
	mov	rdx,qword [rsi]		; lpAddress
	mov	rcx,r15			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	write_debuggee_memory_fail_end

	call	write_debuggee_memory_in_one_section
	jc	write_debuggee_memory_fail

	lea	rax,[rsp+8*(4+3)]	; [Dummy_Protect_flag]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect
	mov	r9d,dword [rsp+8*(4+1)]	; flNewProtect
	mov	r8d,ebx			; dwSize
	mov	rdx,qword [rsi]		; lpAddress
	mov	rcx,r15			; hProcess
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	write_debuggee_memory_fail

	add	qword [rsi],rbx
	add	rdi,rbx
	sub	ebp,ebx
	jz	write_debuggee_memory_success

	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[rsp+8*(4+4)]
	mov	rdx,qword [rsi]
	mov	rcx,r15
	call	qword [VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	jnz	write_debuggee_memory_fail_end

	mov	rax,[rsp+8*(4+4)+MEMORY_BASIC_INFORMATION64.RegionSize]
	cmp	rax,rbp
	cmovnbe	eax,ebp
	jmp	write_debuggee_memory_more_sections_L0

write_debuggee_memory_fail:
	lea	rax,[rsp+8*(4+3)]	; [Dummy_Protect_flag]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect
	mov	r9d,dword [rsp+8*(4+1)]	; flNewProtect
	mov	r8d,ebx			; dwSize
	mov	rdx,qword [rsi]		; lpAddress
	mov	rcx,r15			; hProcess
	call	qword [VirtualProtectEx]
write_debuggee_memory_fail_end:
	stc
	jmp	write_debuggee_memory_epilogue

write_debuggee_memory_in_one_section:
; write ebx bytes from debugger rdi to r15=hProcess debuggee [rsi]
	sub	rsp,8*(4+3)
	lea	rax,[rsp+8*(4+2)]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesWritten
	mov	r9d,ebx			; nSize
	lea	r8,[rdi]		; lpBuffer
	mov	rdx,qword [rsi]		; lpBaseAddress
	mov	rcx,r15			; hProcess
	call	qword [WriteProcessMemory]
	or	eax,eax
	stc
	jz	write_debuggee_memory_in_one_section_epilogue
	cmp	dword [rsp+8*(4+2)],ebx
	stc
	jnz	write_debuggee_memory_in_one_section_epilogue
	clc
write_debuggee_memory_in_one_section_epilogue:
	lea	rsp,[rsp+8*(4+3)]	; this doesn't change carry instead of ADD
	ret
; -------- subroutines end ----------

; -------- subroutines ----------
align 16
fast_move_0_terminated_string_0_terminator:
; input: rsi
; output: rdi
; update: rsi and rdi
	push	rax
	push	rcx
	push	rdi
	xor	eax,eax
fast_move_0_terminated_string_dot_terminator_L0:
; find string size
	lea	rdi,[rsi]
	or	ecx,-1
	cld
	repnz scasb
	not	ecx
	pop	rdi
	mov	al,cl
	shr	ecx,3
	and	al,111b
	repz movsq
	mov	cl,al
	repz movsb
	pop	rcx
	pop	rax
	ret

fast_move_dot_terminated_string_dot_terminator:
;	push	rax
;	push	rcx
;	push	rdi
;	mov	al,'.'
;	jmp	fast_move_0_terminated_string_dot_terminator_L0
	cld
fast_move_dot_terminated_string_dot_terminator_L0:
	cmp	byte [rsi],0
	jz	fast_move_dot_terminated_string_dot_terminator_L1
	movsb
	cmp	byte [rsi-1],'.'
	jnz	fast_move_dot_terminated_string_dot_terminator_L0
fast_move_dot_terminated_string_dot_terminator_L1:
	ret

align 16
fast_move_0_terminated_string:
; input: rsi
; output: rdi
; update: rsi and rdi
	push	rax
	push	rcx
	push	rdi
	xor	eax,eax
fast_move_0_terminated_string_L0:
; find string size
	lea	rdi,[rsi]
	or	ecx,-1
	cld
	repnz scasb
	not	ecx
	dec	ecx
	pop	rdi
	mov	al,cl
	shr	ecx,3
	and	al,111b
	repz movsq
	mov	cl,al
	repz movsb
	pop	rcx
	pop	rax
	ret

fast_move_dot_terminated_string:
	push	rax
	push	rcx
	push	rdi
	mov	al,'.'
	jmp	fast_move_0_terminated_string_L0
; -------- subroutines end ----------

; -------- subroutines ----------
align 16
check_sw_bp_patch_when_necessary_before_write_memory:
; check whether we don't want to overwrite software breakpoints
; if yes, then leave breakpoints untouched there, update byte for restore for SW BP
; in:	ecx=PID
;	ebx=size
;	rdi=debugger_buffer
;	qword [rsi]=debuggee_address

	push	rax rdx r8 r9 r10 r11
	mov	r11d,MaxNumberOfBreakpoints-1	; -1 zero based indexed (0=1st, 1=2nd...)
						; we do it from the back =
						; at the first we process the last SW_BP
	mov	r10,qword [breakpoints_space_address]
	mov	r9,qword [rsi]			; start address in the debuggee
	lea	r8,[r9+rbx*1]			; address after desired range in the debuggee

AMDPad16
csbpwnbwm_L0:
; check whether address of SW_BP match some of bytes between r9, r9+1, r9+2, ... r8-2, r8-1
	mov	rax,qword [r10+r11*8]		; grab address of breakpoint (0=empty)
	cmp	r9,rax
	jnbe	csbpwnbwm_L9			; bp address below begin of the range
	cmp	r8,rax
	jbe	csbpwnbwm_L9			; bp address at/after end of the range

; check PID (whether address of SW_BP belongs to this process or to another process)
	cmp	dword [r10+MaxNumberOfBreakpoints*8+r11*4],ecx
	jnz	csbpwnbwm_L9			; this is SW_BP of another process

; Match! Patch it!
	sub	rax,r9				; relative offset of byte in rdi debugger buf
						; 0=first byte of buf, ebx-1=last byte of buf
	mov	dl,byte [rdi+rax*1]		; original byte from buffer
	mov	byte [r10+MaxNumberOfBreakpoints*(8+4) + r11*1],dl; put it to SW_BP original byte store
	mov	byte [rdi+rax*1],0CCh		; replace original byte in buffer with SW_BP

csbpwnbwm_L9:
	dec	r11d
	jns	csbpwnbwm_L0			; zero based indexed (0=1st, 1=2nd...)

	pop	r11 r10 r9 r8 rdx rax
	ret

align 16
check_sw_bp_patch_when_necessary_after_read_memory:
; check whether we don't read memory holding software breakpoints
; if yes, then restore original byte at breakpoint in buffer (not in debuggee memory)
	push	rax rdx r8 r9 r10 r11
	mov	r11d,MaxNumberOfBreakpoints-1
	mov	r10,qword [breakpoints_space_address]
	mov	r9,qword [rsi]
	lea	r8,[r9+rbx*1]
AMDPad16
csbpwnarm_L0:
	mov	rax,qword [r10+r11*8]
	cmp	r9,rax
	jnbe	csbpwnarm_L9
	cmp	r8,rax
	jbe	csbpwnarm_L9
	cmp	dword [r10+MaxNumberOfBreakpoints*8+r11*4],ecx
	jnz	csbpwnarm_L9
	sub	rax,r9
	mov	dl,byte [r10+MaxNumberOfBreakpoints*(8+4) + r11*1]; get original from SW_BP byte store
	mov	byte [rdi+rax*1],dl		; restore original byte
csbpwnarm_L9:
	dec	r11d
	jns	csbpwnarm_L0
	pop	r11 r10 r9 r8 rdx rax
	ret
; -------- subroutines end ----------


; -------- subroutine ----------
painful_reverze_done_0:
	xor	eax,eax				; doesn't clear carry flag
	clc					; so we must do it...
	ret

align 16
painful_reverze:
; in:	rdx address where to end
;	ecx number of instructions backward rdx
;	eax PID
; out:	eax number of bytes to seek back
;	Carry if error

	jrcxz	painful_reverze_done_0

	push	rcx rdx rbx rsi rdi r8 r9 r10 r11
; rsp is now dqword aligned

a=(8*2 + (MaxLinesInSysListView32+2)*InstructionMaxSize) and 1111b	; remainder when divide by 16
if a<>0
Next structure requires to change
end if

prsf	=	8*2 + (MaxLinesInSysListView32+2)*InstructionMaxSize
				; must be parity number for keep rsp aligned at dqword
				; we don't use any API directly in this routine, only in subroutines
	sub	rsp,prsf

	mov	ebx,MaxLinesInSysListView32
	cmp	ebx,ecx
	jc	painful_reverze_epi

if InstructionMaxSize <> 16
Next instruction needs to change.
end if
	shl	ecx,4
	lea	ebx,[rcx+InstructionMaxSize*2]	; size
	lea	rsi,[rsp]
	lea	rdi,[rsp+8*2]
	sub	rdx,rbx				; start address
	mov	ecx,eax				; PID
	mov	qword [rsi],rdx
painful_reverze_L0:
	call	read_debuggee_memory
; read ebx bytes from ecx=PID debuggee from address in qword [rsi] to debugger buffer at rdi

; this is new simple patch for handle e.g. when we want to start from previous memory page
; not containing code (e.g. PE32+ header end containg zeros - the weakness is because 0000
; is disassembled as one instruction - when we start from memory unaligned 2, we miss start
; start in next memory page, e.g. 400FFD: 0000 add [rax],al 400FFF 004883 add [rax-7D],cl)
	jnc	painful_reverze_read_success
	inc	qword [rsi]			; try to read 1 byte forward
	dec	ebx				; thus size 1 byte less
	jnz	painful_reverze_L0
	xor	eax,eax				; result=0, we are at begin of a block of 
	stc
	jmp	painful_reverze_epi

painful_reverze_read_success:
	cmp	qword [rdi],0			; try to check 4-times repeated 0000
	jnz	painful_reverze_L1
	test	byte [rsi],1			; check address alignment at word boundary
	jz	painful_reverze_L1
painful_reverze_next_byte:
	inc	qword [rsi]			; try to read 1 byte forward
	dec	ebx				; thus size 1 byte less
	jnz	painful_reverze_L0
	xor	eax,eax				; result=0, we are at begin of a block of 
						; allocated memory. Xor doesn't clear carry.
	clc
	jmp	painful_reverze_epi

painful_reverze_L1:
	call	check_sw_bp_patch_when_necessary_after_read_memory
	xor	r11,r11				; counter for byte shift, we will try to
						; disassemble with begins at
						; rsi=[rsp], rsi+1, rsi+2, ... rsi+15
	xor	r10,r10				; counter for circular_buf

painful_reverze_L2:
	lea	rsi,[rsp+8*2+r11*1]
	mov	r9,qword [rsp]
painful_reverze_L3:
	lea	rax,[circular_buf]
	mov	qword [rax+r10*8],r9
	inc	r10
	lea	rdi,[tmp_buf2]
; we don't worry about rbp (input param into disassemble_one_instruction)
; since we need only eax output of disassemble_one_instruction
	call	disassemble_one_instruction
	add	rsi,rax
	add	r9,rax
	cmp	qword [rsp+prsf+8*7],r9		; check whether we match end address
	jz	painful_reverze_L5
	jc	painful_reverze_L4		; over destination address
	xor	eax,eax
	cmp	r10,circular_buf_qwords
	cmovnc	r10,rax
	jmp	painful_reverze_L3

painful_reverze_L4:
	inc	r11
	cmp	r11,InstructionMaxSize
	jc	painful_reverze_L2

; we don't have any matching start, but we have to give something...

painful_reverze_L5:
	sub	r10d,dword [rsp+prsf+8*8]	; subtract ECX from the stack
	lea	edx,[r10+circular_buf_qwords]	; in case of above subtraction overflowed
	cmovc	r10,rdx
	mov	rax,qword [rsp+prsf+8*7]	; end address
	lea	rcx,[circular_buf]
	sub	rax,qword [rcx+r10*8]

painful_reverze_epi:
	lea	rsp,[rsp+prsf]			; this doesn't touch Carry Flag
	pop	r11 r10 r9 r8 rdi rsi rbx rdx rcx
	ret
; -------- subroutine end ----------

; --- procedures begin ---
; change menu when loading new debuggee (Open executable, Attach) or when debuggee exits.
update_main_menu:
; [WeAreDebugging]=1:
; disable: Debuggee->Open Executable, Attach
; enable: everything else in Debuggee, Action, Breakpoint, Explore
	push	rax rcx rdx rbx rbp r8 r9 r10 r11
	sub	rsp,8*(4+0)

if MF_ENABLED = 0
	xor	eax,eax
else
	mov	eax,MF_ENABLED
end if
	mov	ebp,MF_GRAYED
	cmp	[WeAreDebugging],0
	cmovz	ebp,eax

	mov	ebx,IDM_change_0
update_main_menu_L0:
	mov	r8d,ebp
	mov	edx,ebx
	mov	rcx,qword [hMenu01]
	call	qword [EnableMenuItem]	
	inc	ebx
	cmp	ebx,IDM_change_1
	jbe	update_main_menu_L0

	xor	bpl,1

	mov	ebx,IDM_change_2
update_main_menu_L1:
	mov	r8d,ebp
	mov	edx,ebx
	mov	rcx,qword [hMenu01]
	call	qword [EnableMenuItem]	
	inc	ebx
	cmp	ebx,IDM_change_3
	jbe	update_main_menu_L1

	add	rsp,8*(4+0)
	pop	r11 r10 r9 r8 rbp rbx rdx rcx rax
	ret

update_menus_hang_suspend_changed:
; DbgThrdResumed=1 and hung_PID_TID=0 -> PAUSE allowed, everything other disallowed
; DbgThrdResumed=1 and hung_PID_TID<>0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID=0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID<>0 -> impossible choice

	push	rax rcx rdx rbx rbp r8 r9 r10 r11
	sub	rsp,8*(4+0)

MF_ENABLED = 0
MF_GRAYED = 1

	mov	ebp,MF_GRAYED
	movzx	eax,byte [DbgThrdResumed]
	dec	eax
	or	rax,qword [hung_PID_TID]
	cmovz	ebp,eax

	mov	ebx,IDM_change_6
update_menus_hang_suspend_changed_L0:
	mov	r8d,ebp
	mov	edx,ebx
	mov	rcx,qword [hMenu01]
	call	qword [EnableMenuItem]	
	inc	ebx
	cmp	ebx,IDM_change_7
	jbe	update_menus_hang_suspend_changed_L0

	xor	bpl,1

	mov	ebx,IDM_change_4
update_menus_hang_suspend_changed_L1:
	mov	r8d,ebp
	mov	edx,ebx
	mov	rcx,qword [hMenu01]
	call	qword [EnableMenuItem]	
	inc	ebx
	cmp	ebx,IDM_change_5
	jbe	update_menus_hang_suspend_changed_L1

	add	rsp,8*(4+0)
	pop	r11 r10 r9 r8 rbp rbx rdx rcx rax
	ret

update_menus_proc_thrd_switched:
; in:	eax=0 resumed, eax=1 suspended
	push	rax
	mov	rax,qword [last_PID_TID]	; get last_PID and last_TID in once
	cmp	qword [hung_PID_TID],rax
	pop	rax
	jz	update_menus_hang_suspend_changed

;; eax=1 and DebugLoop free qword [hung_PID_TID] = 0 -> we enable everything except Pause
;; eax=0 and DebugLoop free qword [hung_PID_TID] = 0 -> we enable only Pause
;; DebugLoop occupied with another thread qword [hung_PID_TID] <> 0 -> we disable everything
; ? bullshit, correctly after commenting allmost half of the original procedure...
	push	rax rcx rdx rbx rbp r8 r9 r10 r11
	sub	rsp,8*(4+0)

;	cmp	qword [hung_PID_TID],0
	mov	ebp,MF_GRAYED
;	jz	update_menus_proc_thrd_switched_L5
;
;	mov	ebx,IDM_change_4
;update_menus_proc_thrd_switched_L0:
;	mov	r8d,ebp
;	mov	edx,ebx
;	mov	rcx,qword [hMenu01]
;	call	qword [EnableMenuItem]	
;	inc	ebx
;	cmp	ebx,IDM_change_7
;	jbe	update_menus_proc_thrd_switched_L0
;	jmp	update_menus_proc_thrd_switched_epi

update_menus_proc_thrd_switched_L5:
	xor	ebp,eax
	mov	ebx,IDM_change_4
update_menus_proc_thrd_switched_L6:
	mov	r8d,ebp
	mov	edx,ebx
	mov	rcx,qword [hMenu01]
	call	qword [EnableMenuItem]	
	inc	ebx
	cmp	ebx,IDM_change_5
	jbe	update_menus_proc_thrd_switched_L6
	xor	bpl,1
	mov	ebx,IDM_change_6
update_menus_proc_thrd_switched_L7:
	mov	r8d,ebp
	mov	edx,ebx
	mov	rcx,qword [hMenu01]
	call	qword [EnableMenuItem]	
	inc	ebx
	cmp	ebx,IDM_change_7
	jbe	update_menus_proc_thrd_switched_L7

update_menus_proc_thrd_switched_epi:
	add	rsp,8*(4+0)
	pop	r11 r10 r9 r8 rbp rbx rdx rcx rax
	ret
; ++++ procedures end ++++

; --- procedures begin ---
ResumeThreadSafe:
; repeats resuming of the thread until its suspend count=0
; in:	RCX hThread
	push	rcx
	sub	rsp,8*(4+0)

ResumeThreadSafe_L0:
	mov	rcx,qword [rsp+8*(4+0+0)]
	call	qword [ResumeThread]
; The ResumeThread function decrements a thread's suspend count.
; When the suspend count is decremented to zero, the execution of the thread is resumed.
; If the function fails, the return value is (DWORD) -1.
; If the return value is 0, the specified thread was not suspended.
; If the return value is 1, the specified thread was suspended but was restarted.
; If the return value is greater than 1, the specified thread is still suspended.
	cmp	eax,-1
	jz	ResumeThreadSafe_epi
	cmp	eax,1
	jnbe	ResumeThreadSafe_L0

ResumeThreadSafe_epi:
	add	rsp,8*(4+0)
	pop	rcx
	ret

SuspendThreadSafe:
; suspend thread but only to its suspend count=1
; in:	RCX hThread
	push	rcx
	sub	rsp,8*(4+0)

SuspendThreadSafe_L0:
	mov	rcx,qword [rsp+8*(4+0)]
	call	qword [SuspendThread]
; If the function succeeds, the return value is the thread's previous suspend count;
; otherwise, it is (DWORD) -1.
; If the function succeeds, execution of the specified thread is suspended
; and the thread's suspend count is incremented. Suspending a thread causes
; the thread to stop executing user-mode (application) code.
; Each thread has a suspend count (with a maximum value of MAXIMUM_SUSPEND_COUNT).
; MAXIMUM_SUSPEND_COUNT=MAXCHAR=7Fh
; If the suspend count is greater than zero, the thread is suspended; otherwise,
; the thread is not suspended and is eligible for execution. Calling SuspendThread
; causes the target thread's suspend count to be incremented. Attempting to increment
; past the maximum suspend count causes an error without incrementing the count.
	cmp	eax,-1
	jz	SuspendThreadSafe_epi
	or	eax,eax
	jz	SuspendThreadSafe_epi

SuspendThreadSafe_L1:
	mov	rcx,qword [rsp+8*(4+0+0)]
	call	qword [ResumeThread]
	cmp	eax,-1
	jz	SuspendThreadSafe_epi
	cmp	eax,2
	jnbe	SuspendThreadSafe_L0

SuspendThreadSafe_epi:
	add	rsp,8*(4+0)
	pop	rcx
	ret
; ++++ procedures end ++++

rambo_generate_string:
; in:	EAX	random number
;	DL	maximal lenght, must be at least 4
;	RDI	buffer for string
; destroys a lot of registers
	mov	esi,26
	mov	bl,dl

	xor	edx,edx
	div	esi
	add	dl,'A'
	mov	byte [rdi],dl
	inc	rdi
	dec	bl

rambo_generate_string_L0:
	xor	edx,edx
	div	esi
	mov	ecx,eax
	or	ecx,edx
	jz	rambo_generate_string_L9	; eax as well edx are both zeros ?
	add	dl,'a'
	mov	byte [rdi],dl
	inc	rdi
	dec	bl
	jnz	rambo_generate_string_L0

rambo_generate_string_L9:
	mov	byte [rdi],0
	ret

eax2protect:
;PAGE_NOACCESS		= 001h
;PAGE_READONLY		= 002h
;PAGE_READWRITE		= 004h
;PAGE_WRITECOPY		= 008h
;PAGE_EXECUTE		= 010h
;PAGE_EXECUTE_READ	= 020h
;PAGE_EXECUTE_READWRITE	= 040h
;PAGE_EXECUTE_WRITECOPY	= 080h
;PAGE_GUARD		= 100h
;PAGE_NOCACHE		= 200h
	push	rax rcx rdx
	xor	edx,edx
	mov	qword [rdi],rdx
	mov	byte [rdi+8],dl
	mov	ecx,eax
	bsr	eax,eax
	jz	eax2protect_epi
	lea	rdx,[page_access_flags]
	movzx	eax,cl
	mov	cl,0
	bsr	eax,eax
	jz	eax2protect_guard_nochache
	mov	rax,qword [rdx+rax*8]
	mov	qword [rdi],rax
eax2protect_guard_nochache:
	jrcxz	eax2protect_epi
	bsr	eax,ecx
	mov	rax,qword [rdx+rax*8]
	or	qword [rdi],rax
eax2protect_epi:
	pop	rdx rcx rax
	ret

eax2state:
MEM_COMMIT	= 001000h
MEM_RESERVE	= 002000h
MEM_FREE	= 010000h
	push	rax rcx
	xor	ecx,ecx
	mov	byte [rdi],cl
	test	eax,MEM_COMMIT
	jnz	eax2state_do_it
	inc	ecx
	test	eax,MEM_RESERVE
	jnz	eax2state_do_it
	inc	ecx
	test	eax,MEM_FREE
	jz	eax2state_epi
eax2state_do_it:
	lea	rax,[page_state]
	mov	rax,qword [rax+rcx*8]
	mov	qword [rdi],rax
eax2state_epi:
	pop	rcx rax
	ret

eax2type:
MEM_PRIVATE	= 020000h
MEM_MAPPED	= 040000h
MEM_IMAGE	=1000000h
	push	rax rcx
	xor	ecx,ecx
	mov	byte [rdi],cl
	test	eax,MEM_PRIVATE
	jnz	eax2type_do_it
	inc	ecx
	test	eax,MEM_MAPPED
	jnz	eax2type_do_it
	inc	ecx
	test	eax,MEM_IMAGE
	jz	eax2type_epi
eax2type_do_it:
	lea	rax,[page_type]
	mov	rax,qword [rax+rcx*8]
	mov	qword [rdi],rax
eax2type_epi:
	pop	rcx rax
	ret


; new thing according face.code1stdisasmback
; call it usually after updating [Code_listview_dump_start_address]
align 16
code_1st_disassemble_back:
	push	rax rcx rdx

	mov	rdx,[Code_listview_dump_start_address]
	movzx	ecx,[face.code1stdisasmback]
	mov	eax,[last_PID]
	call	painful_reverze
;	rdx address where to end
;	ecx number of instructions backward rdx
;	eax PID
; out:	eax number of bytes to seek back
;	Carry if error
	jc	code_1st_disassemble_back_epi
	sub	[Code_listview_dump_start_address],rax
code_1st_disassemble_back_epi:
	pop	rdx rcx rax
	ret


align 10h
update_data_column_names:
	push	rax rcx rdx rbx rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
	sub	rsp,8*(4+10)

virtual at rsp+8*(4+0)
lv_cl	LV_COLUMN64
end virtual

	xor	ebx,ebx
	mov	[lv_col.iSubItem],ebx
	mov	qword [lv_col.iImage],rbx

if LVCFMT_LEFT = 0
	mov	qword [lv_col.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
;	mov	qword [lv_col.mask],LVCF_FMT or LVCF_TEXT or LVCF_WIDTH	; index of the column is specified in r8 wParam
else
	mov	[lv_col.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
;	mov	[lv_col.mask],LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
	mov	[lv_col.fmt],LVCFMT_LEFT
end if

;	mov	ebx,2				; start at data 3rd (=2, then process Data 2nd (=1), the last Data 1st (=0)
	mov	bl,2

AMDPad16
update_data_column_names_L0:
; we will do it from the back (data 3rd as the first, data 1 st as the last)

; get handle of SysListView
	lea	rax,[hListView]
	mov	rbp,[rax + 8*2 + 8*rbx]

; at first, delete all columns if there is any
	mov	esi,17				; maximal column index, zero based index, so index 17 is for 18th column

AMDPad16
update_data_column_names_L1:
	xor	r9,r9
	mov	r8d,esi
	mov	edx,LVM_DELETECOLUMN
	mov	rcx,rbp
	call	[SendMessageA]

	dec	esi
	jns	update_data_column_names_L1

; now create columns on clean SysListView

; get type of data - showing 16 bytes as qwords/dwords/words/bytes
	lea	rdx,[face.SLV02cs_type]
	movzx	eax,byte [rdx+rbx*1]
	and	al,not data_column_type_reversed	; remove reverse flag
	mov	esi,eax
; esi=3 for byte, 2 for dword, 1 for dword, 0 for qword

	lea	r15,[face.data_column_type_data_qword]
	mov	r14d,1+2+1				; 1=address, 2=number_of_qwords, 1=ascii
	dec	eax
	js	update_data_column_names_L2
	lea	r15,[face.data_column_type_data_dword]
	mov	r14d,1+4+1
	dec	eax
	js	update_data_column_names_L2
	lea	r15,[face.data_column_type_data_word]
	mov	r14d,1+8+1
	dec	eax
	js	update_data_column_names_L2
	lea	r15,[face.data_column_type_data_byte]
	mov	r14d,1+16+1

AMDPad16
update_data_column_names_L2:
	mov	eax,r14d
	imul	eax,ebx				; eax=r14*ebx
	lea	r15,[r15+rax*4]			; every size uses dword
; now r15 points to dwords containing sizes of columns

	mov	eax,[r15]			; grab column size
	lea	rcx,[SLV02cn]			; text
	mov	[lv_cl.cx],eax
	mov	[lv_cl.pszText],rcx
	and	[lv_cl.iSubItem],0
	lea	r9,[lv_cl]
	xor	r8,r8				; iCol
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rbp
	call	qword [SendMessageA]

; 1 column processed:
	add	r15,4
	dec	r14d

; now columns for data displayed in hexa
	mov	ecx,3
	sub	ecx,esi
	xor	r13,r13
	bts	r13,rcx
; r13=1 for byte, 2 for dword, 4 for dword, 8 for qword

	xor	r12,r12				; column counter

AMDPad16
update_data_column_names_L3:
	mov	rdx,r12
	imul	rdx,r13
	lea	rax,[SLV0204cn]			; text
	lea	rcx,[rsp+8*(4+7)]
	movdqu	xmm0,[rax+rdx*2]
	movdqu	[rcx],xmm0
	mov	byte [rcx + r13*2],0		; zero terminator
	mov	eax,[r15]			; grab column size
	mov	[lv_cl.cx],eax
	mov	[lv_cl.pszText],rcx
	inc	[lv_cl.iSubItem]
	lea	r9,[lv_cl]
	lea	r8,[r12+1]			; iCol
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rbp
	call	qword [SendMessageA]

	add	r15,4
	inc	r12
	mov	rax,r14
	sub	rax,r12
	cmp	al,1
	jnbe	update_data_column_names_L3

; now column for ascii string
	mov	eax,[r15]			; grab column size
	lea	rcx,[SLV02cn_ascii]		; text
	mov	[lv_cl.cx],eax
	mov	[lv_cl.pszText],rcx
	inc	[lv_cl.iSubItem]
	lea	r9,[lv_cl]
	lea	r8,[r12+1]			; iCol
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rbp
	call	qword [SendMessageA]

	dec	ebx
	jns	update_data_column_names_L0

	add	rsp,8*(4+10)
	pop	r15 r14 r13 r12 r11 r10 r9 r8 rdi rdi rbp rbx rdx rcx rax
	ret





align 10h
detect_AMD:
; out: CF=0 success, CF=1 error
	push	rbx
	xor	eax,eax
	cpuid
	sub	ebx,'Auth'
	sub	edx,'enti'
	sub	ecx,'cAMD'
	xor	eax,eax
	or	ebx,edx
	or	ebx,ecx
	cmp	eax,ebx
	pop	rbx
	ret


align 10h
detect_intel:
; out: CF=0 success, CF=1 error
	push	rbx
	xor	eax,eax
	cpuid
	sub	ebx,'Genu'
	sub	edx,'ineI'
	sub	ecx,'ntel'
	xor	eax,eax
	or	ebx,edx
	or	ebx,ecx
	cmp	eax,ebx
	pop	rbx
	ret


align 10h
detect_version_windows_2008_server_x64_R2_or_higher:
; major version = 6
; minor version = 1
; build number  = 7600
; windows 2008 server x64 has the same major and minor numbers, but its build is lower, only 7000
; R2 version of server has the build 7600
a = sizeof.OSVERSIONINFO
b = ( a + 7 ) / 8
c = ( b + 1 ) / 2

	sub	rsp,8*(4+b+c)
virtual at 0
osvi	OSVERSIONINFO
end virtual

	lea	rcx,[rsp+8*(4+0)]
	mov	[rcx + osvi.dwOSVersionInfoSize],a
	call	[GetVersionExA]
	mov	ecx,[rsp+8*(4+0) + osvi.dwMajorVersion]
	shl	ecx,16
	mov	cx,word [rsp+8*(4+0) + osvi.dwMinorVersion]
	cmp	ecx,00060001h				; major version must be 6 or higher, minor version must be at least 1 for major version 6
	jc	detect_version_windows_2008_server_x64_R2_or_higher_epi
	cmp	[rsp+8*(4+0) + osvi.dwBuildNumber],7600		; R2 version of windows 2008 server x64 (the same kernel as windows 7) has build number 7600
detect_version_windows_2008_server_x64_R2_or_higher_epi:
	lea	rsp,[rsp+8*(4+b+c)]				; the LEA instruction never alters the RFLAGS register, we must keep the Carry flag untouched !!!
	ret


align 10h
save_comments_breakpoints:
	push	rbx rsi rdi
	sub	rsp,8*(4+4)

	lea	rsi,[ini_file]
	lea	rdi,[tmp_buf]

AMDPad16
save_comments_breakpoints_L0:
	movsb
	cmp	byte [rsi-1],0
	jnz	save_comments_breakpoints_L0
	mov	dword [rdi-4],'fcb'

;	and	qword [rsp+8*(4+2)],0
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL
	mov	dword [rsp+8*(4+0)],CREATE_ALWAYS
	xor	r9,r9
	xor	r8,r8
	mov	edx,GENERIC_WRITE
	lea	rcx,[tmp_buf]
	mov	[rsp+8*(4+2)],r9
	call	[CreateFileA]
	push	rax
	pop	rbx				; save handle

if INVALID_HANDLE_VALUE = -1
	inc	rax
else
	cmp	rax,INVALID_HANDLE_VALUE
end if

	jz	save_comments_breakpoints_L9

	and	qword [rsp+8*(4+0)],0
	lea	r9,[rsp+8*(4+1)]
	mov	r8d,(8+comment_max_size)*max_comments
	lea	rdx,[comments + 8*max_comments]
	push	rbx
	pop	rcx
	call	[WriteFile]
	or	eax,eax
	jz	save_comments_breakpoints_L8
	cmp	dword [rsp+8*(4+1)],(8+comment_max_size)*max_comments
	jnz	save_comments_breakpoints_L8

	and	qword [rsp+8*(4+0)],0
	lea	r9,[rsp+8*(4+1)]
	mov	r8d,(8+4+1+1)*MaxNumberOfBreakpoints
	mov	rdx,[breakpoints_space_address]
	push	rbx
	pop	rcx
	call	[WriteFile]
	or	eax,eax
	jz	save_comments_breakpoints_L8
	cmp	dword [rsp+8*(4+1)],(8+4+1+1)*MaxNumberOfBreakpoints
	jnz	save_comments_breakpoints_L8

save_comments_breakpoints_L8:
	push	rbx
	pop	rcx
	call	[CloseHandle]

save_comments_breakpoints_L9:

	add	rsp,8*(4+4)
	pop	rdi rsi rbx
	ret


align 10h
load_comments_breakpoints:
; ECX = PID
; RDX = hProcess
	push	rbx rsi rdi r12 r13
	sub	rsp,8*(4+4)

	lea	rsi,[ini_file]
	lea	rdi,[tmp_buf]

	mov	r12d,ecx
	mov	r13,rdx

AMDPad16
load_comments_breakpoints_L0:
	movsb
	cmp	byte [rsi-1],0
	jnz	load_comments_breakpoints_L0
	mov	dword [rdi-4],'fcb'

;	and	qword [rsp+8*(4+2)],0
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL or FILE_FLAG_DELETE_ON_CLOSE
	mov	dword [rsp+8*(4+0)],OPEN_EXISTING
	xor	r9,r9
	xor	r8,r8
	mov	edx,GENERIC_READ
	lea	rcx,[tmp_buf]
	mov	[rsp+8*(4+2)],r9
	call	[CreateFileA]
	push	rax
	pop	rbx				; save handle
if INVALID_HANDLE_VALUE = -1
	inc	rax
else
	cmp	rax,INVALID_HANDLE_VALUE
end if

	jz	load_comments_breakpoints_L9

	mov	r9d,FILE_END
	xor	r8,r8
	xor	edx,edx
	push	rbx
	pop	rcx
	call	[SetFilePointer]
	cmp	eax,(8+comment_max_size)*max_comments + (8+4+1+1)*MaxNumberOfBreakpoints
	jnz	load_comments_breakpoints_L8

if FILE_BEGIN = 0
	xor	r9,r9
else
	mov	r9d,FILE_BEGIN
end if
	xor	r8,r8
	xor	edx,edx
	push	rbx
	pop	rcx
	call	[SetFilePointer]
	or	eax,eax
	jnz	load_comments_breakpoints_L8

	xor	r9,r9
	mov	r8d,PAGE_READONLY or SEC_COMMIT
	xor	edx,edx
	push	rbx
	pop	rcx
	mov	[rsp+8*(4+0)],r9d
	mov	[rsp+8*(4+1)],r9
	call	[CreateFileMappingA]

	or	rax,rax
	jz	load_comments_breakpoints_L8

	push	rax
	pop	rsi

	xor	r9,r9
	xor	r8,r8
	mov	edx,FILE_MAP_READ
	push	rsi
	pop	rcx
	mov	[rsp+8*(4+0)],r9
	call	[MapViewOfFile]
	or	rax,rax
	jz	load_comments_breakpoints_L7
	push	rax
	pop	rdi

	mov	edx,r12d			; PID
	lea	rcx,[rax]
	call	reload_comments

	mov	r8,r13				; hProcess
	mov	edx,r12d			; PID
; we can't use PID, we must use hProcess because pairs PID-hProcess are not yet obtained
	lea	rcx,[rdi+(8+comment_max_size)*max_comments]
	call	reload_breakpoints

	push	rdi
	pop	rcx
	call	[UnmapViewOfFile]

load_comments_breakpoints_L7:
	push	rsi
	pop	rcx
	call	[CloseHandle]

load_comments_breakpoints_L8:
	push	rbx
	pop	rcx
	call	[CloseHandle]

; delete file - not necessary, we opened the file with FILE_FLAG_DELETE_ON_CLOSE

load_comments_breakpoints_L9:
	add	rsp,8*(4+4)
	pop	r13 r12 rdi rsi rbx
	ret


align 10h
erase_comments:
	push	rax rcx rdi
	lea	rdi,[comments]
	mov	ecx,(8+8+comment_max_size)*max_comments / 8
	xor	eax,eax
	cld
	repz stosq
	pop	rdi rcx rax
	ret


align 10h
reload_comments:
; rcx = pointer to comments to load (times max_comments dq address, times max_comments rb comment_max_size)
; edx = PID
	push	rsi rdi

	lea	rsi,[rcx]
	lea	rdi,[comments + 8*max_comments]
	lea	r8,[rcx+8*max_comments]
	lea	r9,[rdi+8*max_comments]
	mov	ecx,max_comments
	cld

reload_comments_L0:
	xor	eax,eax
	cmp	[rsi],rax
	cmovnz	eax,edx
	mov	[rdi - 8*max_comments],rax	; PID (or 0 for unused)
	movsq					; address
	jz	reload_comments_next

	mov	eax,max_comments
	sub	eax,ecx
; eax = index of comment

if comment_max_size = 100h
	shl	eax,8
else
	imul	eax,eax,comment_max_size
end if

	CopyMovsq r9+rax*1, r8+rax*1, comment_max_size

reload_comments_next:
	loop	reload_comments_L0

	pop	rdi rsi
	ret


align 10h
reload_breakpoints:
; rcx buffer holding info about breakpoints
; edx PID
; r8  hProcess (to write into the memory of process)
	push	rbx rbp rsi rdi
a=1				; return address from procedure
b=4				; number of pushed registers
d=(sizeof.MEMORY_BASIC_INFORMATION64+7)/8
e=4				; 4 qwords reserved for us
f=4				; 4 qwords reserved for API
c=(a+b+d+e+f) and 1		; align stack at dqword
	sub	rsp,8*(c+d+e+f)
; the stack looks now like:
; a <- the top, return address from procedure
; b number of pushed registers
; c aligning stack at dqword (c is 0 or 1)
; d MEMORY_BASIC_INFORMATION64
; e 4 qwords reserved for API
;   <- current RSP

virtual at rsp+8*(4+1)
rb_sw_bp_old_protect_flag		dq	?
label rb_sw_bp_number_of_bytes	at	$
rb_sw_bp_number_of_bytes_written	dq	?
rb_sw_bp_dummy				dq	?
rb_sw_bp_mbi				MEMORY_BASIC_INFORMATION64
end virtual

	mov	ebx,edx			; PID
	xor	ebp,ebp			; counter
	lea	rsi,[rcx]		; buffer
	mov	rdi,r8			; hProcess
AMDPad16
reload_breakpoints_L0:
	mov	rdx,[rsi + MaxNumberOfBreakpoints* 0 + rbp*8]		; address
	or	rdx,rdx
	jz	reload_breakpoints_L9
	cmp	dword [rsi + MaxNumberOfBreakpoints* 8 + rbp*4],0	; PID
	jz	reload_breakpoints_L9

	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[rb_sw_bp_mbi]
	and	dx,not (page_size_for_AMD64 - 1)
	mov	rcx,rdi							; hProcess
	call	[VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	jnz	reload_breakpoints_L9
	cmp	[rb_sw_bp_mbi.State],MEM_COMMIT
	jnz	reload_breakpoints_L9

	lea	rax,[rb_sw_bp_number_of_bytes]
	mov	[rsp+8*(4+0)],rax					; lpNumberOfBytesRead
	mov	r9d,1							; nSize
	lea	r8,[rb_sw_bp_dummy]					; lpBuffer
	mov	rdx,[rsi + MaxNumberOfBreakpoints* 0 + rbp*8]		; lpBaseAddress
	mov	rcx,rdi							; hProcess
	call	[ReadProcessMemory]
	or	eax,eax
	jz	reload_breakpoints_L9
	cmp	dword [rb_sw_bp_number_of_bytes],1
	jnz	reload_breakpoints_L9
	mov	al,byte [rb_sw_bp_dummy]
	cmp	[rsi + MaxNumberOfBreakpoints*12 + rbp*1],al		; original byte
	jnz	reload_breakpoints_L9
	cmp	al,0CCh
	jz	reload_breakpoints_L9					; int3 already there

	lea	rax,[rb_sw_bp_old_protect_flag]
	mov	[rsp+8*(4+0)],rax					; lpflOldProtect 5th param to API
	mov	r9d,PAGE_READWRITE					; flNewProtect
	mov	r8d,1							; dwSize
	mov	rdx,[rsi + MaxNumberOfBreakpoints* 0 + rbp*8]		; lpAddress
	mov	rcx,rdi							; hProcess
	call	[VirtualProtectEx]
	or	eax,eax
	jz	reload_breakpoints_L9

	lea	rax,[rb_sw_bp_number_of_bytes]
	mov	[rsp+8*(4+0)],rax					; lpNumberOfBytesWritten
	mov	r9d,1							; nSize
	lea	r8,[int03_opcode]					; lpBuffer
	mov	rdx,[rsi + MaxNumberOfBreakpoints* 0 + rbp*8]		; lpBaseAddress
	mov	rcx,rdi							; hProcess
	call	[WriteProcessMemory]
	or	eax,eax
	jz	reload_breakpoints_L8
	cmp	dword [rb_sw_bp_number_of_bytes],1
	jnz	reload_breakpoints_L8

	lea	rax,[rb_sw_bp_number_of_bytes]
	mov	[rsp+8*(4+0)],rax					; lpNumberOfBytesWritten
	mov	r9d,1							; nSize
	lea	r8,[rb_sw_bp_dummy]					; lpBuffer
	mov	rdx,[rsi + MaxNumberOfBreakpoints* 0 + rbp*8]		; lpBaseAddress
	mov	rcx,rdi							; hProcess
	call	[ReadProcessMemory]
	or	eax,eax
	jz	reload_breakpoints_L8
	cmp	dword [rb_sw_bp_number_of_bytes],1
	jnz	reload_breakpoints_L8
	cmp	byte [rb_sw_bp_dummy],0CCh
	jnz	reload_breakpoints_L8

	mov	r11,[breakpoints_space_address]
	mov	al,[rsi + MaxNumberOfBreakpoints*12 + rbp*1]
	mov	cl,[rsi + MaxNumberOfBreakpoints*13 + rbp*1]		; flag
	mov	r8,[rsi + MaxNumberOfBreakpoints* 0 + rbp*8]		; address
	mov	[r11 + MaxNumberOfBreakpoints* 8 + rbp*4],ebx		; PID
	mov	[r11 + MaxNumberOfBreakpoints*12 + rbp*1],al		; original byte
	mov	[r11 + MaxNumberOfBreakpoints*13 + rbp*1],cl		; flag
	mov	[r11 + MaxNumberOfBreakpoints* 0 + rbp*8],r8		; address

reload_breakpoints_L8:
	lea	rax,[rb_sw_bp_dummy]
	mov	[rsp+8*(4+0)],rax					; lpflOldProtect
	mov	r9d,dword [rb_sw_bp_old_protect_flag]			; flNewProtect
; note, r9d must be used, because [] can hold value as FFFFF800000020h
; previous VirtualProtectEx fill only dword, not qword for flags !
; AMD64 zero extends this from 32 bit to 64 bit after move
	mov	r8d,1							; dwSize
	mov	rdx,[rsi + MaxNumberOfBreakpoints* 0 + rbp*8]		; lpBaseAddress
	mov	rcx,rdi							; hProcess
	call	[VirtualProtectEx]
;	or	eax,eax
;	jz	reload_breakpoints_L9
; one more paranoid check:
; mov eax,[rsp + 8*(4+1)]
; cmp eax,[old_flag_must_be_saved_somewhere_but_we_dont_saved_it_because_we_arent_paranoid]
; jnz reload_breakpoints_L9
; write hasn't failed, write has been OK, restoring memory access flag has failed

reload_breakpoints_L9:
	inc	ebp
	cmp	ebp,MaxNumberOfBreakpoints
	jc	reload_breakpoints_L0

	add	rsp,8*(c+d+e+f)
	pop	rdi rsi rbp rbx
	ret

