display_offsets = 0		; set to 1 and recompile for displaying offsets of instructions instead of bare instruction list

; You mustn't use any part of this for commercial projects, you need my permission for it.
; You can use everything for educating purposes.
; http://feryno.host.sk
; or try google for Feryno
;
; thanx to Tomasz Grysztar http://flatassembler.org
; try to look at http://board.flatassembler.net/topic.php?t=3437
; thanx to Jeremy Gordon http://www.jorgon.freeserve.co.uk  www.GoDevTool.com
; thanx to Nite Prowler (Robo Hrebicek)... Where are you, man? I didn't see you 5 years.
; thanx to Uran (Juraj Spl)
; thanx to Michal Ludvig http://www.logix.cz/michal/doc/i386/chp12-02.htm
; thanx to AMD for great AMD64 CPUs
; thanx to Sylvester Stallone for Rambo 1,2,3
; thanx to Arnold Schwarzenegger for Terminator 1,2,3

include	'macro_align.inc'
include	'win64const.inc'
include	'fdbg_constants.inc'

format PE64 GUI at 100000000h on 'nul'
entry start


section '.text' code readable executable

start:	sub	rsp,8*(4+3)

	call	check_lahf_sahf

	call	[GetCommandLineA]
	cld
	xchg	rsi,rax     	; parse shell line parameters
	lea	rdi,[file_name]
	lea	rcx,[rdi + file_name_max_size]
L00:	inc	rsi
	cmp	byte [rsi],' '
	ja	L00
L01:	cmp	byte [rsi],0
	jz	exit
	inc	rsi
	cmp	byte [rsi],' '
	jna	L01
L02:	movsb
	cmp	rdi,rcx
	jnbe	exit		; too long, too many characters on shell line
	cmp	byte [rsi],' '
	ja	L02
	mov	byte [rdi],0

	lea	rax,[file_name]
;	mov	rcx,rdi
;	sub	rcx,rax
	mov	ecx,edi
	sub	ecx,eax
	dec	rdi
	mov	al,'.'
	std
	repnz scasb
	jnz	exit
	cld
	inc	rdi
	inc	rdi

have_file_extension:
	mov	eax,[rdi]
	or	eax,00202020h	; convert capitals to lowercase, e.g. 'ObJ' -> 'obj'
;	cmp	eax,'exe'
;	jnz	exit
; no, we allow to disasm dll, sys, ... too


;zkyp:
;lea rdi,[file_name + 9]



GENERIC_READ			= 80000000h
GENERIC_WRITE			= 40000000h
CREATE_NEW			= 1
CREATE_ALWAYS			= 2
OPEN_EXISTING			= 3
OPEN_ALWAYS			= 4
TRUNCATE_EXISTING		= 5
FILE_ATTRIBUTE_READONLY		= 001h
FILE_ATTRIBUTE_HIDDEN		= 002h
FILE_ATTRIBUTE_SYSTEM		= 004h
FILE_ATTRIBUTE_DIRECTORY	= 010h
FILE_ATTRIBUTE_ARCHIVE		= 020h
FILE_ATTRIBUTE_NORMAL		= 080h
FILE_ATTRIBUTE_TEMPORARY	= 100h
FILE_ATTRIBUTE_COMPRESSED	= 800h
FILE_SHARE_READ			= 1
INVALID_HANDLE_VALUE		= -1

;	mov	qword [rsp+8*(4+2)],0
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL
	mov	dword [rsp+8*(4+0)],OPEN_EXISTING
	xor	r9,r9
;	mov	r8,FILE_SHARE_READ
; this is smaller:
	lea	r8,[r9+FILE_SHARE_READ]
	mov	[rsp+8*(4+2)],r9
	mov	edx,GENERIC_READ
	lea	rcx,[file_name]
	call	[CreateFileA]
	push	rax
	pop	rbx

if INVALID_HANDLE_VALUE = -1
	inc	rax
else
	cmp	rax,INVALID_HANDLE_VALUE
end if
	jz	exit

	mov	dword [rdi],'d64'	; change file extension

	xor	edx,edx
;	mov	rcx,rbx
	push	rbx
	pop	rcx
	call	[GetFileSize]
	cmp	eax,YnBuphpher_syze
	jnbe	exit

	xchg	ebp,eax

;	mov	qword [rsp+8*(4+0)],0
; this is smaller:
;	and	qword [rsp+8*(4+0)],0
	lea	r9,[rsp+8*(4+1)]
; this is even smaller:
	and	qword [r9-8],0
	mov	r8d,ebp
	lea	rdx,[YnBuphpher]
;	mov	rcx,rbx
	push	rbx
	pop	rcx
	call	[ReadFile]

;	mov	rcx,rbx
	push	rbx
	pop	rcx
	call	[CloseHandle]

	cmp	[rsp+8*(4+1)],ebp
	jnz	exit



	lea	rbx,[YnBuphpher]
	cmp	word [rbx],'MZ'		; IMAGE_DOS_HEADER.e_magic = IMAGE_DOS_SIGNATURE
	jnz	exit
	mov	eax,[rbx+3Ch]		; IMAGE_DOS_HEADER.e_lfanew
	lea	rbx,[rbx+rax]
	lea	rsi,[rbx]
;[rsi+30h] entry point !!!
	lodsd
IMAGE_NT_SIGNATURE = 'PE'
	cmp	ax,IMAGE_NT_SIGNATURE
	jnz	exit

IMAGE_FILE_MACHINE_AMD64	= 8664h	; AMD64 (K8)
	lodsw			; Machine
	cmp	ax,IMAGE_FILE_MACHINE_AMD64
	jnz	exit

	lodsw			; NumberOfSections
	movzx	ecx,ax

	lodsd			; TimeDateStamp
	lodsd			; PointerToSymbolTable
	lodsd			; NumberOfSymbols
	lodsw			; SizeOfOptionalHeader
	movzx	edx,ax
	lodsw			; Characteristics

	lodsq			; VirtualAddress
	xchg	rdi,rax
	lodsq			; Size

	lodsq			; section name
	lodsq			; PhysicalAddress
	xchg	rbp,rax
	lodsd			; VirtualSize
;	xchg

	lea	rsi,[rbx+rdx+18h]

; Section characteristics.
;IMAGE_SCN_TYPE_REG                   0x00000000  // Reserved.
;IMAGE_SCN_TYPE_DSECT                 0x00000001  // Reserved.
;IMAGE_SCN_TYPE_NOLOAD                0x00000002  // Reserved.
;IMAGE_SCN_TYPE_GROUP                 0x00000004  // Reserved.
IMAGE_SCN_TYPE_NO_PAD			= 00000008h	; Reserved.
;IMAGE_SCN_TYPE_COPY                  0x00000010  // Reserved.

IMAGE_SCN_CNT_CODE			= 00000020h	; Section contains code.
IMAGE_SCN_CNT_INITIALIZED_DATA		= 00000040h	; Section contains initialized data.
IMAGE_SCN_CNT_UNINITIALIZED_DATA	= 00000080h	; Section contains uninitialized data.

IMAGE_SCN_LNK_OTHER			= 00000100h	; Reserved.
IMAGE_SCN_LNK_INFO			= 00000200h	; Section contains comments or some other type of information.
;IMAGE_SCN_TYPE_OVER                  0x00000400  // Reserved.
IMAGE_SCN_LNK_REMOVE			= 00000800h	; Section contents will not become part of image.
IMAGE_SCN_LNK_COMDAT			= 00001000h	; Section contents comdat.
;                                     0x00002000  // Reserved.
;IMAGE_SCN_MEM_PROTECTED - Obsolete   0x00004000
IMAGE_SCN_NO_DEFER_SPEC_EXC		= 00004000h	; Reset speculative exceptions handling bits in the TLB entries for this section.
IMAGE_SCN_GPREL				= 00008000h	; Section content can be accessed relative to GP
IMAGE_SCN_MEM_FARDATA			= 00008000h
;IMAGE_SCN_MEM_SYSHEAP  - Obsolete    0x00010000
IMAGE_SCN_MEM_PURGEABL			= 00020000h
IMAGE_SCN_MEM_16BIT			= 00020000h
IMAGE_SCN_MEM_LOCKED			= 00040000h
IMAGE_SCN_MEM_PRELOAD			= 00080000h

IMAGE_SCN_ALIGN_1BYTES			= 00100000h
IMAGE_SCN_ALIGN_2BYTES			= 00200000h
IMAGE_SCN_ALIGN_4BYTES			= 00300000h
IMAGE_SCN_ALIGN_8BYTES			= 00400000h
IMAGE_SCN_ALIGN_16BYTES			= 00500000h	; Default alignment if no others are specified.
IMAGE_SCN_ALIGN_32BYTES			= 00600000h
IMAGE_SCN_ALIGN_64BYTES			= 00700000h
IMAGE_SCN_ALIGN_128BYTES		= 00800000h
IMAGE_SCN_ALIGN_256BYTES		= 00900000h
IMAGE_SCN_ALIGN_512BYTES		= 00A00000h
IMAGE_SCN_ALIGN_1024BYTES		= 00B00000h
IMAGE_SCN_ALIGN_2048BYTES		= 00C00000h
IMAGE_SCN_ALIGN_4096BYTES		= 00D00000h
IMAGE_SCN_ALIGN_8192BYTES		= 00E00000h
;Unused                                    0x00F00000
IMAGE_SCN_ALIGN_MASK			= 00F00000h

IMAGE_SCN_LNK_NRELOC_OVFL		= 01000000h	; Section contains extended relocations.
IMAGE_SCN_MEM_DISCARDABLE		= 02000000h	; Section can be discarded.
IMAGE_SCN_MEM_NOT_CACHED		= 04000000h	; Section is not cachable.
IMAGE_SCN_MEM_NOT_PAGED			= 08000000h	; Section is not pageable.
IMAGE_SCN_MEM_SHARED			= 10000000h	; Section is shareable.
IMAGE_SCN_MEM_EXECUTE			= 20000000h	; Section is executable.
IMAGE_SCN_MEM_READ			= 40000000h	; Section is readable.
IMAGE_SCN_MEM_WRITE			= 80000000h	; Section is writeable.

scan_sections:
	lodsq			; Name
	lodsd			; SizeOfRawData
	xchg	edx,eax
	lodsd			; VirtualAddress
;	lea	rdi,[rbp+rax]
; this is smaller:
	lea	rdi,[rax+rbp*1]
	lodsd			; VirtualSize

	lodsd			; PointerToRawData
	mov	r8d,eax
	lodsd			; PointerToRelocations
	lodsd			; PointerToLinenumbers
;	lodsw			; NumberOfRelocations
;	lodsw			; NumberOfLinenumbers
; this is smaller:
	lodsd			; NumberOfRelocations, NumberOfLinenumbers

	lodsd			; Characteristics
;IMAGE_SCN_CNT_CODE=20h
	bt	eax,5
	jnc	dont_have_k0de
	mov	qword [k0de_address],rdi
;	mov	qword [k0de_size],rdx
	mov	dword [k0de_size],edx
	mov	dword [k0de_file_offset],r8d
dont_have_k0de:
	loop	scan_sections

	lea	rdi,[OutBuphpher]

	lea	rsi,[YnBuphpher]
	mov	eax,dword [k0de_file_offset]
	add	rsi,rax
	mov	rbp,qword [k0de_address]

dzsm_L0:

if display_offsets = 1
;	mov	rax,rbp
	push	rbp
	pop	rax
	call	hexa_64_rax
	add	rdi,16
	mov	al,':'
	stosb
	mov	al,09h		; tab char
	stosb
end if

	call	disassemble_one_instruction
	add	rbp,rax
	xchg	eax,edx

	mov	al,0
	or	ecx,-1		; xor eax,eax \ lea ecx,[rax-1] requires 5 bytes also
	repnz scasb
	mov	byte [rdi-1],0Dh
	mov	al,0Ah
	stosb

	add	rsi,rdx
	sub	dword [k0de_size],edx
	jnbe	dzsm_L0

;	mov	qword [rsp+8*(4+2)],0
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL
	mov	dword [rsp+8*(4+0)],CREATE_ALWAYS
	xor	r9,r9
	xor	r8,r8
	mov	qword [rsp+8*(4+2)],r9
	mov	edx,GENERIC_WRITE
	lea	rcx,[file_name]
	call	[CreateFileA]

	xchg	rbx,rax

;	mov	qword [rsp+8*(4+0)],0
	lea	r9,[rsp+8*(4+1)]
	mov	r8,rdi
	and	qword [r9-8],0
	lea	rdx,[OutBuphpher]
	sub	r8,rdx
;	mov	rcx,rbx
	push	rbx
	pop	rcx
	call	[WriteFile]

;	mov	rcx,rbx
	push	rbx
	pop	rcx
	call	[CloseHandle]

exit:	;xor	ecx,ecx
	;call	[ExitProcess]
; this is smaller:
	xor	eax,eax
	add	rsp,8*(4+3)
	ret


include	'fdisasm64_proc.inc'
include	'hexa_proc.inc'


section '.data' data readable writeable

include	'fdisasm64_data.inc'

align 16
include	'hexa_data.inc'

align 16
file_name_max_size	= 512
file_name				rb	file_name_max_size

align 10h
supported_lahf_sahf			db	?
					rb	15	; padding

align 16
disassemble_prefix			dq	?
absolute_RIP_addressing_correction		dq	?
absolute_RIP_addressing_value			dq	?
absolute_RIP_addressing_disassembled_position	dq	?
k0de_address				dq	?
k0de_size				dq	?
k0de_file_offset			dq	?
;post_disasm_mode			dq	?
;post_disasm_address			dq	?
;post_disasm_buffer			dq	?
post_disasm_addr0			dq	?
post_disasm_addr1			dq	?
post_disasm_reg0			dd	?
post_disasm_reg1			dd	?
; these 5 must follow each other in this exact order and the whole size must be 1 qword:
post_disasm_flag			db	?
post_disasm_action			db	?
post_disasm_mul				db	?
post_disasm_prefix			db	?
seg_prefix_not_flushed			db	?
post_disasm_cond_jump_type		db	?	; valid if post_disasm_flag_cond_jump is set in [post_disasm_flag]
					db	?,?

align 16
YnBuphpher_syze	= 32*1024*1024
YnBuphpher	rb	YnBuphpher_syze
OutBuphpher_syze= 128*1024*1024
OutBuphpher	rb	OutBuphpher_syze


section '.idata' import data readable writeable

  dd 0,0,0,RVA kernel_name,RVA kernel_table
  dd 0,0,0,0,0

  kernel_table:
;    ExitProcess dq RVA _ExitProcess
    GetCommandLineA dq RVA _GetCommandLineA
    CreateFileA dq RVA _CreateFileA
    GetFileSize dq RVA _GetFileSize
    ReadFile dq RVA _ReadFile
    WriteFile dq RVA _WriteFile
    CloseHandle dq RVA _CloseHandle
    dq 0

  kernel_name db 'KERNEL32.DLL',0

; kernel32.dll:
;  _ExitProcess dw 0
;    db 'ExitProcess',0
  _GetCommandLineA dw 0
    db 'GetCommandLineA',0
  _CreateFileA dw 0
    db 'CreateFileA',0
  _GetFileSize dw 0
    db 'GetFileSize',0
  _ReadFile dw 0
    db 'ReadFile',0
  _WriteFile dw 0
    db 'WriteFile',0
  _CloseHandle dw 0
    db 'CloseHandle',0
