align 10h

disassemble_table_0:

; 00-05 ADD
		  repeat 6
		dq	process_opcode_add_0
		  end repeat

; 06 PUSH ES undefined in AMD64 long mode
		dq	process_undefined_opcode_push_es

; 07 POP ES undefined in AMD64 long mode
		dq	process_undefined_opcode_pop_es

; 08-0D OR
		  repeat 6
		dq	process_opcode_or_0
		  end repeat

; 0E PUSH CS undefined in AMD64 long mode
		dq	process_undefined_opcode_push_cs

; 0F two byte opcodes... nor finished nor begun
		dq	process_opcode_0F

; 10-15 ADC
		  repeat 6
		dq	process_opcode_adc_0
		  end repeat

; 16 PUSH SS undefined in AMD64 long mode
		dq	process_undefined_opcode_push_ss

; 17 POP SS undefined in AMD64 long mode
		dq	process_undefined_opcode_pop_ss

; 18-1D SBB
		  repeat 6
		dq	process_opcode_sbb_0
		  end repeat

; 1E PUSH DS undefined in AMD64 long mode
		dq	process_undefined_opcode_push_ds

; 1F POP DS undefined in AMD64 long mode
		dq	process_undefined_opcode_pop_ds

; 20-25 AND
		  repeat 6
		dq	process_opcode_and_0
		  end repeat

; 26 ES:
		dq	process_opcode_seg_ES

; 27 DAA undefined in AMD64 long mode
		dq	process_undefined_opcode_daa

; 28-2D SUB
		  repeat 6
		dq	process_opcode_sub_0
		  end repeat

; 2E CS:
		dq	process_opcode_seg_CS

; 2F DAS undefined in AMD64 long mode
		dq	process_undefined_opcode_das

; 30-35 XOR
		  repeat 6
		dq	process_opcode_xor_0
		  end repeat

; 36 SS:
		dq	process_opcode_seg_SS

; 37 AAA undefined in AMD64 long mode
		dq	process_undefined_opcode_aaa

; 38-3D CMP
		  repeat 6
		dq	process_opcode_cmp_0
		  end repeat

; 3E DS:
		dq	process_opcode_seg_DS

; 3F AAS undefined in AMD64 long mode
		dq	process_undefined_opcode_aas


; 40-4F
		  repeat 10h
		dq	process_opcode_REX_prefix
		  end repeat

; 50..57h PUSH rAX..rDI    58..5Fh POP ...
		  repeat 10h
		dq	process_opcode_push_pop_50_5F
		  end repeat

; 60 PUSHA undefined in AMD64 long mode
		dq	process_undefined_opcode_pusha

; 61 POPA undefined in AMD64 long mode
		dq	process_undefined_opcode_popa

; 62 BOUND undefined in AMD64 long mode
		dq	process_undefined_opcode_bound

; 63 MOVSXD
		dq	process_opcode_movsxd

; 64 FS:
		dq	process_opcode_seg_FS_GS

; 65 GS:
		dq	process_opcode_seg_FS_GS

; 66h
		dq	process_opcode_66_prefix
; 67h
		dq	process_opcode_67_prefix

; 68h push dword sign extended
		dq	process_opcode_push_dword

; 69h imul by dword in memory
		dq	process_opcode_imul_69

; 6Ah push byte sign extended
		dq	process_opcode_push_byte

; 6Bh imul by byte in memory
		dq	process_opcode_imul_6B

; 6Ch insb
; 6Dh insd
; 6Eh outsb
; 6Fh outsw
; 66 6D insw
; 66 6F outsw
		  repeat 4h
		dq	process_opcode_insb_outsb
		  end repeat

;70-7F JO JNO JB JNB JZ JNZ JBE JNBE    JS JNS JP JNP JL JNL JLE JNLE
		  repeat 10h
		dq	process_opcode_jump_condition
		  end repeat

; 80-83
		  repeat 4
		dq	process_opcode_80_83
		  end repeat

; 84-87
		  repeat 4
		dq	process_opcode_test_xchg_84_87
		  end repeat

; 88-8B
		  repeat 4h
		dq	process_opcode_mov_88_8B
		  end repeat

; 8C
		dq	process_opcode_mov_8C

; 8D LEA
		dq	process_opcode_lea

; 8E
		dq	process_opcode_mov_8E

; 8F
		dq	process_opcode_pop_8F

; 90h NOP
		dq	process_opcode_90

; 91-97h XCHG r32,eax
		  repeat 7
		dq	process_opcode_91_to_97
		  end repeat

; 98h
		dq	process_opcode_convert_b_w_d_q_o
; 99h
		dq	process_opcode_convert_b_w_d_q_o

; 9A undefined in long mode, 9a070040003300 call 0033:00400007
		dq	process_opcode_undefined_call_far_9A

; 9B
		dq	process_opcode_wait

; 9C PUSHF
		dq	process_opcode_pushf

; 9D POPF
		dq	process_opcode_popf

; 9E SAHF
		dq	process_opcode_sahf

; 9F LAHF
		dq	process_opcode_lahf

; A0-A3
		  repeat 4h
		dq	process_opcode_mov_accumulator_absolute
		  end repeat

; A4-A7   A4 movsb  A5 movsd  A6 cmpsb  A7 cmpsd
		  repeat 4h
		dq	process_opcode_string_operations_0
		  end repeat

; A8-A9
		dq	process_opcode_test_accumulator_A8_A9
		dq	process_opcode_test_accumulator_A8_A9

; AA-AF   AA stosb  AB stosd  AC lodsb  AD lodsd  AE scasb  AF scasd
		  repeat 6h
		dq	process_opcode_string_operations_1
		  end repeat

; B0-B7
		  repeat 8h
		dq	process_opcode_mov_B0_B7
		  end repeat

; B8-BF
		  repeat 8h
		dq	process_opcode_mov_B8_BF
		  end repeat

; C0-C1
		dq	process_opcode_shift_rotate_C0_C1_D0_D3
		dq	process_opcode_shift_rotate_C0_C1_D0_D3

; C2 RET word    C3 RET
		dq	process_opcode_return
		dq	process_opcode_return

; C4-C5 undefined LES... LDS...
		dq	process_undefined_opcode_LES_LDS_C4_C5
		dq	process_undefined_opcode_LES_LDS_C4_C5

; C6-C7
		dq	process_opcode_mov_C6_C7
		dq	process_opcode_mov_C6_C7

; C8 ENTER
		dq	process_opcode_enter

; C9 LEAVE
		dq	process_opcode_leave

; CA RETF word    CB RETF
		dq	process_opcode_return_far
		dq	process_opcode_return_far

; CC  int3
		dq	process_opcode_int3

; CD  int
		dq	process_opcode_int

; CE  INTO     ! Note, AMD64 long mode undefined opcode !
		dq	process_opcode_into

; CF  iret
		dq	process_opcode_iret

; D0-D3
		  repeat 4h
		dq	process_opcode_shift_rotate_C0_C1_D0_D3
		  end repeat

; D4 AAM
		dq	process_undefined_opcode_aam

; D5 AAD
		dq	process_undefined_opcode_aad

; D6 SETALC
		dq	process_undefined_opcode_setalc

; D7 XLAT   67D7 xlat byte [ebx]
		dq	process_opcode_xlat

; D8-DF fpu instructions
		dq	process_opcode_FPU_D8
		dq	process_opcode_FPU_D9
		dq	process_opcode_FPU_DA
		dq	process_opcode_FPU_DB
		dq	process_opcode_FPU_DC
		dq	process_opcode_FPU_DD
		dq	process_opcode_FPU_DE
		dq	process_opcode_FPU_DF

; E0 LOOPNZ
; E1 LOOPZ
; E2 LOOP
		dq	process_opcode_loops
		dq	process_opcode_loops
		dq	process_opcode_loops

; E3 JCXZ/JECXZ/JRCXZ
		dq	process_opcode_jcxz

; E4-E7
		  repeat 4h
		dq	process_opcode_ports_val
		  end repeat

; E8
		dq	process_opcode_call

; E9
		dq	process_opcode_jmp_near

; EA
		dq	process_opcode_jmp_far

; EB
		dq	process_opcode_jmp_short

; EC-EF
		  repeat 4h
		dq	process_opcode_ports_dx
		  end repeat

; F0 LOCK
		dq	process_opcode_lock_F0

; F1 icebp int1
;		dq	process_opcode_icebp
		dq	process_opcode_int1

; F2 repnz
		dq	process_opcode_repnz

; F3 repz
		dq	process_opcode_repz

; F4 hlt
		dq	process_opcode_F4_F5

; F5 cmc
		dq	process_opcode_F4_F5

; F6, F7
		dq	process_opcode_F6_F7
		dq	process_opcode_F6_F7

; F8 clc
		dq	process_opcode_set_flag_F8_FD

; F9 stc
		dq	process_opcode_set_flag_F8_FD

; FA cli
		dq	process_opcode_set_flag_F8_FD

; FB sti
		dq	process_opcode_set_flag_F8_FD

; FC cld
		dq	process_opcode_set_flag_F8_FD

; FD std
		dq	process_opcode_set_flag_F8_FD

; FE inc/dec byte
		dq	process_opcode_inc_dec_FE_byte

; FF
		dq	process_opcode_FF

process_opcode_0F_table:
		dq	process_opcode_0F00
		dq	process_opcode_0F01
		dq	process_opcode_0F02
		dq	process_opcode_0F03
		dq	process_opcode_0F04_0F07
		dq	process_opcode_0F04_0F07
		dq	process_opcode_0F04_0F07
		dq	process_opcode_0F04_0F07
		dq	process_opcode_0F08_0F0C
		dq	process_opcode_0F08_0F0C
		dq	process_opcode_0F08_0F0C
		dq	process_opcode_0F08_0F0C
		dq	process_opcode_0F08_0F0C
		dq	process_opcode_prefetch_0F0D
		dq	process_opcode_femms_0F0E
		dq	process_opcode_3DNow_0F0F

; 0F10
		dq	process_opcode_0F10_0F11
		dq	process_opcode_0F10_0F11
		dq	process_opcode_0F12
		dq	process_opcode_movlps_movlpd_movhps_movhpd_0F13_0F17
		dq	process_opcode_unpcklps_unpcklpd_unpckhps_unpckhpd_0F14_0F15
		dq	process_opcode_unpcklps_unpcklpd_unpckhps_unpckhpd_0F14_0F15
		dq	process_opcode_0F16
		dq	process_opcode_movlps_movlpd_movhps_movhpd_0F13_0F17
		dq	process_opcode_prefetch_0F18
		dq	process_opcode_nop_0F19_0F1F
		dq	process_opcode_nop_0F19_0F1F
		dq	process_opcode_nop_0F19_0F1F
		dq	process_opcode_nop_0F19_0F1F
		dq	process_opcode_nop_0F19_0F1F
		dq	process_opcode_nop_0F19_0F1F
		dq	process_opcode_nop_0F19_0F1F

; 0F20
		  repeat 8
		dq	process_opcode_mov_0F20_0F27
		  end repeat
		dq	process_opcode_movaps_movapd_0F28_0F29
		dq	process_opcode_movaps_movapd_0F28_0F29
		dq	process_opcode_0F2A
		dq	process_opcode_movntps_movntpd_0F2B
		dq	process_opcode_0F2C_0F2D
		dq	process_opcode_0F2C_0F2D
		dq	process_opcode_ucomiss_ucomisd_0F2E
		dq	process_opcode_comiss_comisd_0F2F

; 0F30
		  repeat 7
		dq	process_opcode_0F30_0F36
		  end repeat
		dq	process_opcode_getsec_0F37
		dq	process_opcode_0F38
		dq	process_opcode_0F39
		dq	process_opcode_0F3A
		  repeat 5
		dq	process_opcode_0F3B_0F3F
		  end repeat

; 0F40
		  repeat 10h
		dq	process_opcode_cmov_0F40_0F4F
		  end repeat

; 0F50
		dq	process_opcode_movmskps_movmskpd_0F50
		dq	process_opcode_sqrt_0F51
		dq	process_opcode_rsqrt_0F52
		dq	process_opcode_rcp_0F53
		dq	process_opcode_and_andn_or_xor_0F54_0F57
		dq	process_opcode_and_andn_or_xor_0F54_0F57
		dq	process_opcode_and_andn_or_xor_0F54_0F57
		dq	process_opcode_and_andn_or_xor_0F54_0F57
		dq	process_opcode_0F58_0F59_0F5C_0F5F
		dq	process_opcode_0F58_0F59_0F5C_0F5F
		dq	process_opcode_0F5A
		dq	process_opcode_0F5B
		dq	process_opcode_0F58_0F59_0F5C_0F5F
		dq	process_opcode_0F58_0F59_0F5C_0F5F
		dq	process_opcode_0F58_0F59_0F5C_0F5F
		dq	process_opcode_0F58_0F59_0F5C_0F5F

; 0F60
		dq	process_opcode_0F60_0F62
		dq	process_opcode_0F60_0F62
		dq	process_opcode_0F60_0F62
		dq	process_opcode_0F63_0F67
		dq	process_opcode_0F63_0F67
		dq	process_opcode_0F63_0F67
		dq	process_opcode_0F63_0F67
		dq	process_opcode_0F63_0F67
		dq	process_opcode_0F68_0F6B
		dq	process_opcode_0F68_0F6B
		dq	process_opcode_0F68_0F6B
		dq	process_opcode_0F68_0F6B
		dq	process_opcode_punpcklqdq_0F6C
		dq	process_opcode_punpckhqdq_0F6D
		dq	process_opcode_movd_0F6E
		dq	process_opcode_0F6F

; 0F70
		dq	process_opcode_pshuf_0F70
		dq	process_opcode_pshimw_pshimd_0F71_0F72
		dq	process_opcode_pshimw_pshimd_0F71_0F72
		dq	process_opcode_pshimq_0F73
		dq	process_opcode_pcmpeq_0F74_0F76
		dq	process_opcode_pcmpeq_0F74_0F76
		dq	process_opcode_pcmpeq_0F74_0F76
		dq	process_opcode_emms_0F77
		dq	process_opcode_vmread_0F78
		dq	process_opcode_vmwrite_0F79
		dq	process_opcode_unknown_0F7A_0F7B
		dq	process_opcode_unknown_0F7A_0F7B
		dq	process_opcode_haddp_hsubp_0F7C_0F7D
		dq	process_opcode_haddp_hsubp_0F7C_0F7D
		dq	process_opcode_movq_0F7E
		dq	process_opcode_0F7F

; 0F80
		  repeat 10h
		dq	process_opcode_jump_condition_long_0F80_0F8F
		  end repeat

; 0F90
		  repeat 10h
		dq	process_opcode_set_condition_0F90_0F9F
		  end repeat

; 0FA0
		dq	process_opcode_push_pop_fs_gs_0FA0_0FA1_0FA8_0FA9
		dq	process_opcode_push_pop_fs_gs_0FA0_0FA1_0FA8_0FA9
		dq	process_opcode_cpuid_0FA2
		dq	process_opcode_bt_bts_0FA3_0FAB
		dq	process_opcode_shld_shrd_0FA4_0FA5_0FAC_0FAD
		dq	process_opcode_shld_shrd_0FA4_0FA5_0FAC_0FAD
		dq	process_opcode_unknown_0FA6
		dq	process_opcode_unknown_0FA7
		dq	process_opcode_push_pop_fs_gs_0FA0_0FA1_0FA8_0FA9
		dq	process_opcode_push_pop_fs_gs_0FA0_0FA1_0FA8_0FA9
		dq	process_opcode_rsm_0FAA
		dq	process_opcode_bt_bts_0FA3_0FAB
		dq	process_opcode_shld_shrd_0FA4_0FA5_0FAC_0FAD
		dq	process_opcode_shld_shrd_0FA4_0FA5_0FAC_0FAD
		dq	process_opcode_0FAE
		dq	process_opcode_imul_0FAF

; 0FB0
		dq	process_opcode_cmpxchg_0FB0
		dq	process_opcode_cmpxchg_0FB1
		dq	process_opcode_lss_0FB2
		dq	process_opcode_btr_btc_0FB3_0FBB
		dq	process_opcode_lfs_lgs_0FB4_0FB5
		dq	process_opcode_lfs_lgs_0FB4_0FB5
		dq	process_opcode_movzx_movsx_0FB6_0FB7_0FBE_0FBE
		dq	process_opcode_movzx_movsx_0FB6_0FB7_0FBE_0FBE
		dq	process_opcode_jmpe_popcnt		;dq	process_opcode_unknown_0FB8
		dq	process_opcode_ud2_0FB9
		dq	process_opcode_bit_tests_0FBA
		dq	process_opcode_btr_btc_0FB3_0FBB
		dq	process_opcode_bsf_bsr_0FBC_0FBD
		dq	process_opcode_bsf_bsr_0FBC_0FBD
		dq	process_opcode_movzx_movsx_0FB6_0FB7_0FBE_0FBE
		dq	process_opcode_movzx_movsx_0FB6_0FB7_0FBE_0FBE

; 0FC0
		dq	process_opcode_xadd_0FC0
		dq	process_opcode_xadd_0FC1
		dq	process_opcode_0FC2
		dq	process_opcode_movnti_0FC3
		dq	process_opcode_pinsrw_0FC4
		dq	process_opcode_pextrw_0FC5
		dq	process_opcode_shufp_0FC6
		dq	process_opcode_cmpxchg8b_cmpxchg16b_0FC708_0FC70F
		  repeat 8
		dq	process_opcode_bswap_0FC8_0FCF
		  end repeat

; 0FD0
		dq	process_opcode_addsubp_0FD0
		dq	process_opcode_psrl_0FD1_0FD3
		dq	process_opcode_psrl_0FD1_0FD3
		dq	process_opcode_psrl_0FD1_0FD3
		dq	process_opcode_paddq_0FD4
		dq	process_opcode_pmullw_0FD5
		dq	process_opcode_0FD6
		dq	process_opcode_pmovmskb_0FD7
		  repeat 8
		dq	process_opcode_0FD8_0FDF
		  end repeat

; 0FE0
		  repeat 6
		dq	process_opcode_0FE0_0FE5
		  end repeat
		dq	process_opcode_0FE6
		dq	process_opcode_0FE7
		  repeat 8
		dq	process_opcode_0FE8_0FEF
		  end repeat

; 0FF0
		dq	process_opcode_lddqu_F20FF0
		  repeat 6
		dq	process_opcode_0FF1_0FF6
		  end repeat
		dq	process_opcode_0FF7
		  repeat 7
		dq	process_opcode_0FF8_0FFE
		  end repeat
		dq	process_opcode_ud_0FFF

process_opcode_big_fucking_gun_table:
		dq	process_opcode_big_fucking_gun_mem_reg_b	; e.g. 0000 add [rax],al
		dq	process_opcode_big_fucking_gun_mem_reg_d	; e.g. 0100 add [rax],eax
		dq	process_opcode_big_fucking_gun_reg_mem_b	; e.g. 0200 add al,[rax]
		dq	process_opcode_big_fucking_gun_reg_mem_d	; e.g. 0300 add eax,[rax]

process_opcode_big_fucking_gun_mem_memb_memd_reg_table:
		dq	process_opcode_big_fucking_gun_mem	;0000           add [rax],al
		dq	process_opcode_big_fucking_gun_memb	;004012         add [rax+12],al
		dq	process_opcode_big_fucking_gun_memd	;008065FE0501   add [rax+0105FE65],al
		dq	process_opcode_big_fucking_gun_reg	;00C0           add al,al

process_opcode_big_fucking_gun_mem_memb_memd_reg_table_d:
		dq	process_opcode_big_fucking_gun_mem	;0100           add [rax],eax
		dq	process_opcode_big_fucking_gun_memb	;014012         add [rax+12],eax
		dq	process_opcode_big_fucking_gun_memd	;018065FE0501   add [rax+0105FE65],eax
		dq	process_opcode_big_fucking_gun_reg_d	;01C0           add eax,eax

process_opcode_big_fucking_gun_mem_memb_memd_reg_table_q:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_big_fucking_gun_reg_q

process_opcode_80_83_table:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_80_83_reg

process_opcode_8C_table:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_8C_reg

process_opcode_8F_table:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_8F_reg

process_opcode_FPU_D8_table:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_D8_FPU_register		;D800C1 add st0,st1

process_opcode_F6_F7_table:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_F6_F7_register

process_opcode_big_fucking_gun_mem_memb_memd_reg_table_q_w:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_reg_q_w

process_opcode_big_fucking_gun_mem_memb_memd_reg_table_w:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_big_fucking_gun_reg_w

process_opcode_bit_tests_0FBA_table:
; ??????? realy equal to process_opcode_8C_table ??????????
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_8C_reg

process_opcode_3DNow_table:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_3DNow_reg

process_Wo_subroutines:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_xmm_reg

process_Ed_table:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_reg_32

process_Eq_table:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_opcode_reg_64

process_Qq_subroutines:
		dq	process_opcode_big_fucking_gun_mem
		dq	process_opcode_big_fucking_gun_memb
		dq	process_opcode_big_fucking_gun_memd
		dq	process_Pq

gpr_transform	db	0,3,1,2,4,5,6,7,8,9,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh

mm_transform	db	'0',0
		db	'1',0
		db	'2',0
		db	'3',0
		db	'4',0
		db	'5',0
		db	'6',0
		db	'7',0
		db	'8',0
		db	'9',0
		db	'10'
		db	'11'
		db	'12'
		db	'13'
		db	'14'
		db	'15'

gpr_64	db	'rax',0
	db	'rcx',0
	db	'rdx',0
	db	'rbx',0
	db	'rsp',0
	db	'rbp',0
	db	'rsi',0
	db	'rdi',0
	db	'r8',0,0
	db	'r9',0,0
	db	'r10',0
	db	'r11',0
	db	'r12',0
	db	'r13',0
	db	'r14',0
	db	'r15',0

gpr_32	db	'eax',0
	db	'ecx',0
	db	'edx',0
	db	'ebx',0
	db	'esp',0
	db	'ebp',0
	db	'esi',0
	db	'edi',0
	db	'r8d',0
	db	'r9d',0
	db	'r10d'
	db	'r11d'
	db	'r12d'
	db	'r13d'
	db	'r14d'
	db	'r15d'

gpr_16	db	'ax',0,0
	db	'cx',0,0
	db	'dx',0,0
	db	'bx',0,0
	db	'sp',0,0
	db	'bp',0,0
	db	'si',0,0
	db	'di',0,0
	db	'r8w',0
	db	'r9w',0
	db	'r10w'
	db	'r11w'
	db	'r12w'
	db	'r13w'
	db	'r14w'
	db	'r15w'

gpr_8	db	'al',0,0
	db	'cl',0,0
	db	'dl',0,0
	db	'bl',0,0
	db	'ah',0,0
	db	'ch',0,0
	db	'dh',0,0
	db	'bh',0,0
gpr_8_old_ext:
	db	'al',0,0
	db	'cl',0,0
	db	'dl',0,0
	db	'bl',0,0
	db	'spl',0
	db	'bpl',0
	db	'sil',0
	db	'dil',0
gpr_8_new:
	db	'r8b',0
	db	'r9b',0
	db	'r10b'
	db	'r11b'
	db	'r12b'
	db	'r13b'
	db	'r14b'
	db	'r15b'

segment_registers:
	db	'es'
	db	'cs'
	db	'ss'
	db	'ds'
	db	'fs'
	db	'gs'
	db	'??'
	db	'??'

special_regs:
	db	'cr'
	db	'dr'
	db	'cr'
	db	'dr'
	db	'tr'
	db	'?r'
	db	'tr'
	db	'?r'

process_opcode_add_or_adc_sbb_and_sub_xor_cmp_table:
	db	'add '
	db	'or  '
	db	'adc '
	db	'sbb '
	db	'and '
	db	'sub '
	db	'xor '
	db	'cmp '

instructions_insb_outsb_table:
	db	'insb',0,0,0,0
	db	'insd',0,0,0,0
	db	'outsb',0,0,0
	db	'outsd',0,0,0
	db	'insw',0,0,0,0
	db	'outsw',0,0,0

instructions_jump_conditional_table:
	db	'jo',0,0
	db	'jno',0
	db	'jc',0,0
	db	'jnc',0
	db	'jz',0,0
	db	'jnz',0
	db	'jbe',0
	db	'jnbe'
	db	'js',0,0
	db	'jns',0
	db	'jp',0,0
	db	'jnp',0
	db	'jl',0,0
	db	'jnl',0
	db	'jle',0
	db	'jnle'

instruction_convert_b_w_d_q_o_table:
	db	'cwde'
	db	'cdq',0
	db	'cdqe'
	db	'cqo',0
	db	'cbw',0
	db	'cwd',0

process_opcode_string_operations_table_0:
	db	'movs'
	db	'cmps'
process_opcode_string_operations_table_1:
	db	'stos'
	db	'lods'
	db	'scas'
	dd	0

instructions_shift_rotate:
	db	'rol '
	db	'ror '
	db	'rcl '
	db	'rcr '
	db	'shl '
	db	'shr '
	db	'sal '
	db	'sar '

opcode_FPU_D8_instructions:
	db	'fadd ',0,0,0
	db	'fmul ',0,0,0
	db	'fcom ',0,0,0
	db	'fcomp ',0,0
	db	'fsub ',0,0,0
	db	'fsubr ',0,0
	db	'fdiv ',0,0,0
	db	'fdivr ',0,0

opcode_FPU_D9_instructions:
opcode_FPU_D9_instructions_00_BF:
	db	'fld ',0,0,0,0
	db	'f??? ',0,0,0
	db	'fst ',0,0,0,0
	db	'fstp ',0,0,0
	db	'fldenv ',0
	db	'fldcw ',0,0
	db	'fstenv ',0
	db	'fstcw ',0,0
opcode_FPU_D9_instructions_C0_DF:
	db	'fld ',0,0,0,0
	db	'fxch ',0,0,0
	db	'fnop ',0,0,0
	db	'fstp ',0,0,0
opcode_FPU_D9_instructions_E0_E7:
	db	'fchs ',0,0,0
	db	'fabs ',0,0,0
	db	'f??? ',0,0,0
	db	'f??? ',0,0,0
	db	'ftst ',0,0,0
	db	'fxam ',0,0,0
	db	'ftstp ',0,0
	db	'f??? ',0,0,0
opcode_FPU_D9_instructions_E8_EF:
	db	'fld1 ',0,0,0
	db	'fldl2t ',0
	db	'fldl2e ',0
	db	'fldpi ',0,0
	db	'fldlg2 ',0
	db	'fldln2 ',0
	db	'fldz ',0,0,0
	db	'f??? ',0,0,0
opcode_FPU_D9_instructions_F0_F7:
	db	'f2xm1 ',0,0
	db	'fyl2x ',0,0
	db	'fptan ',0,0
	db	'fpatan ',0
	db	'fxtract '
	db	'fprem1 ',0
	db	'fdecstp '
	db	'fincstp '
opcode_FPU_D9_instructions_F8_FF:
	db	'fprem ',0,0
	db	'fyl2xp1 '
	db	'fsqrt ',0,0
	db	'fsincos '
	db	'frndint '
	db	'fscale ',0
	db	'fsin ',0,0,0
	db	'fcos ',0,0,0

opcode_FPU_DA_instructions:
opcode_FPU_DA_instructions_00_BF:
	db	'fiadd ',0,0
	db	'fimul ',0,0
	db	'ficom ',0,0
	db	'ficomp ',0
	db	'fisub ',0,0
	db	'fisubr ',0
	db	'fidiv ',0,0
	db	'fidivr ',0
opcode_FPU_DA_instructions_C0_DF:
	db	'fcmovb ',0
	db	'fcmove ',0
	db	'fcmovbe '
	db	'fcmovu ',0

opcode_FPU_DB_instructions:
opcode_FPU_DB_instructions_00_BF:
	db	'fild ',0,0,0
	db	'fisttp ',0
	db	'fist ',0,0,0
	db	'fistp ',0,0
	db	'f??? ',0,0,0
	db	'fld ',0,0,0,0
	db	'f??? ',0,0,0
	db	'fstp ',0,0,0
opcode_FPU_DB_instructions_C0_DF:
	db	'fcmovnb',0
	db	'fcmovne',0
	db	'fcmovnbe'
	db	'fcmovnu',0
opcode_FPU_DB_instructions_E0_E7:
	db	'feni ',0,0,0
	db	'fdisi ',0,0
	db	'fclex ',0,0
	db	'finit ',0,0
	db	'fsetpm ',0
	db	'frstpm ',0
	db	'f???',0,0,0,0
	db	'f???',0,0,0,0

opcode_FPU_DC_instructions:
opcode_FPU_DC_instructions_00_BF:
	db	'fadd ',0,0,0
	db	'fmul ',0,0,0
	db	'fcom ',0,0,0
	db	'fcomp ',0,0
	db	'fsub ',0,0,0
	db	'fsubr ',0,0
	db	'fdiv ',0,0,0
	db	'fdivr ',0,0
opcode_FPU_DC_instructions_C0_FF:
	db	'fadd ',0,0,0
	db	'fmul ',0,0,0
	db	'fcom ',0,0,0
	db	'fcomp ',0,0
	db	'fsubr ',0,0
	db	'fsub ',0,0,0
	db	'fdivr ',0,0
	db	'fdiv ',0,0,0

opcode_FPU_DD_instructions:
opcode_FPU_DD_instructions_00_BF:
	db	'fld ',0,0,0,0
	db	'fisttp ',0
	db	'fst ',0,0,0,0
	db	'fstp ',0,0,0
	db	'frstor ',0
	db	'f??? ',0,0,0
	db	'fsave ',0,0
	db	'fstsw ',0,0
opcode_FPU_DD_instructions_C0_FF:
	db	'ffree ',0,0
	db	'fxch ',0,0,0
	db	'fst ',0,0,0,0
	db	'fstp ',0,0,0
	db	'fucom ',0,0
	db	'fucomp ',0
	db	'f???',0,0,0,0
	db	'f???',0,0,0,0	; DDFC frichop Cyrix instruction

opcode_FPU_DE_instructions:
opcode_FPU_DE_instructions_00_BF:
	db	'fiadd ',0,0
	db	'fimul ',0,0
	db	'ficom ',0,0
	db	'ficomp ',0
	db	'fisub ',0,0
	db	'fisubr ',0
	db	'fidiv ',0,0
	db	'fidivr ',0
opcode_FPU_DE_instructions_C0_FF:
	db	'faddp ',0,0
	db	'fmulp ',0,0
	db	'fcomp ',0,0
	db	'fcompp ',0	; only DED9
	db	'fsubrp ',0
	db	'fsubp ',0,0
	db	'fdivrp ',0
	db	'fdivp ',0,0

opcode_FPU_DF_instructions:
opcode_FPU_DF_instructions_00_BF:
	db	'fild ',0,0,0
	db	'fisttp ',0
	db	'fist ',0,0,0
	db	'fistp ',0,0
	db	'fbld ',0,0,0
	db	'fild ',0,0,0
	db	'fbstp ',0,0
	db	'fistp ',0,0
opcode_FPU_DF_instructions_C0_FF:
	db	'ffreep ',0
	db	'fxch ',0,0,0
	db	'fst ',0,0,0,0
	db	'fstp ',0,0,0
	db	'fstsw ax'	; DFE0 only
	db	'fucomip '
	db	'fcomip ',0
	db	'f???',0,0,0,0

process_opcode_loops_table:
	db	'loopnz  '
	db	'loopz  ',0
	db	'loop  ',0,0

process_opcode_jcxz_table:
	db	'jrcxz ',0,0
	db	'jecxz ',0,0

instructions_F4_F5:
	db	'hlt',0		; F4
	db	'cmc',0		; F5
instructions_set_flag_F8_FD:
	db	'clc',0
	db	'stc',0
	db	'cli',0
	db	'sti',0
	db	'cld',0
	db	'std',0
;	dq	0
operand_size_short	db	'bwdq',0,0,0,0	; byte word doubleword quadword


process_undefined_opcode_daa_das_aaa_aas_table:
	db	'daa '
	db	'das '
	db	'aaa '
	db	'aas '

group3_instruction_table:
	db	'test'
	db	'test'
	db	'not',0
	db	'neg',0
	db	'mul',0
	db	'imul'
	db	'div',0
	db	'idiv'

opcode_FF_instruction_table:
	db	'inc',0
	db	'dec',0
	db	'call'
	db	'call'
	db	'jmp',0
	db	'jmp',0
	db	'push'
	db	'???',0

opcode_0F00_instruction_table:
	db	'sldt'
	db	'str',0
	db	'lldt'
	db	'ltr',0
	db	'verr'
	db	'verw'
	db	'???',0
	db	'???',0

opcode_0F01_instruction_table:
	db	'sgdt'
	db	'sidt'
	db	'lgdt'
	db	'lidt'
	db	'smsw'
	db	'smsw'
	db	'lmsw'
	db	'    '

opcode_0F04_0F07_instruction_table:
	db	'???',0,0,0,0,0
	db	'syscall',0
	db	'clts',0,0,0,0
	db	'sysretq',0
opcode_0F08_0F0C_instruction_table:
	db	'invd',0,0,0,0
	db	'wbinvd',0,0
	db	'???',0,0,0,0,0
	db	'ud2',0,0,0,0,0
	db	'???',0,0,0,0,0
	dq	0

opcode_0F0F_3DNow_index:
	db	0Ch
	db	0Dh
	db	1Ch
	db	1Dh
	db	8Ah
	db	8Eh
	db	90h
	db	94h
	db	96h
	db	97h
	db	9Ah
	db	9Eh
	db	0A0h
	db	0A4h
	db	0A6h
	db	0A7h
	db	0AAh
	db	0AEh
	db	0B0h
	db	0B4h
	db	0B6h
	db	0B7h
	db	0BBh
	db	0BFh
opcode_0F0F_3DNow_number_of_opcodes = $ - opcode_0F0F_3DNow_index
	dq	0
opcode_0F0F_3DNow:
	db	'pi2fw',0,0,0
	db	'pi2fd',0,0,0
	db	'pf2iw',0,0,0
	db	'pf2id',0,0,0
	db	'pfnacc',0,0
	db	'pfpnacc',0
	db	'pfcmpge',0
	db	'pfmin',0,0,0
	db	'pfrcp',0,0,0
	db	'pfrsqrt',0
	db	'pfsub',0,0,0
	db	'pfadd',0,0,0
	db	'pfcmpgt',0
	db	'pfmax',0,0,0
	db	'pfrcpit1'
	db	'pfrsqit1'
	db	'pfsubr',0,0
	db	'pfacc',0,0,0
	db	'pfcmpeq',0
	db	'pfmul',0,0,0
	db	'pfrcpit2'
	db	'pmulhrw',0
	db	'pswapd',0,0
	db	'pavgusb',0
	db	'? 3DNow!'
	dq	0

opcode_0F10_0F11_table:
	db	'movups',0,0			; no prefix
	db	'movupd',0,0			; 66 prefix
	db	'movss',0,0,0			; F3 prefix
	db	'movsd',0,0,0			; F2 prefix
	dq	process_Vo_Wo, process_Wo_Vo
	dq	process_Vo_Wo, process_Wo_Vo
	dq	process_Vd_Wd, process_Wd_Vd
	dq	process_Vq_Wq, process_Wq_Vq

opcode_0F12_table:
	db	'movlps',0,0
	db	'movlpd',0,0
	db	'movsldup'
	db	'movddup',0
	dq	process_Vq_Mq
	dq	process_Vq_Mq
	dq	process_Vo_Wo
	dq	process_Vo_Wq

opcode_0F16_table:
	db	'movhps',0,0
	db	'movhpd',0,0
	db	'movshdup'
	db	'??? SSE3'
	dq	process_Vq_Mq
	dq	process_Vq_Mq
	dq	process_Vo_Wo
	dq	process_Vo_Wq

opcode_0F2A_table:
; correct this, good is:
;F3h,0Fh,2Ah	CVTSI2SS Vd,Eq
;F2h,0Fh,2Ah	CVTSI2SD Vq,Eq
	db	'cvtpi2ps'
	db	'cvtpi2pd'
	db	'cvtsi2ss'
	db	'cvtsi2sd'
	dq	process_Vq_Mq_Vq_Pq
	dq	process_Vo_Mq_Vo_Pq
	dq	process_Vd_Ed
	dq	process_Vq_Ed

opcode_0F2C_0F2D_table:
; correct this, good is:
;F3h,0Fh,2Ch	CVTTSS2SI Gq,Wd
;F2h,0Fh,2Ch	CVTTSD2SI Gq,Wq
;F3h,0Fh,2Dh	CVTSS2SI Gq,Wd
;F2h,0Fh,2Dh	CVTSD2SI Gq,Wq
	db	'ps2pi',0,0,0
	db	'pd2pi',0,0,0
	db	'ss2si',0,0,0
	db	'sd2si',0,0,0
	dq	process_Pq_Wq
	dq	process_Pq_Wo
	dq	process_Gd_Wd
	dq	process_Gd_Wq

opcode_0F30_0F3F_instruction_table:
	db	'wrmsr',0,0,0
	db	'rdtsc',0,0,0
	db	'rdmsr',0,0,0
	db	'rdpmc',0,0,0
	db	'???',0,0,0,0,0		; sysenter unsupported by AMD64
	db	'???',0,0,0,0,0		; sysexit unsupported by AMD64
	db	'???',0,0,0,0,0
	db	'???',0,0,0,0,0

opcode_sqrt_0F51_table:
	db	'sqrtps ',0
	db	'sqrtpd ',0
	db	'sqrtss ',0
	db	'sqrtsd ',0
	dq	process_Vo_Wo
	dq	process_Vo_Wo
	dq	process_Vd_Wd
	dq	process_Vq_Wq

opcode_and_andn_or_xor_0F54_0F57_table:
	db	'and',0
	db	'andn'
	db	'or',0,0
	db	'xor',0

opcode_0F58_0F59_0F5C_0F5F_instructions:
	db	'add',0
	db	'mul',0
	dd	0
	dd	0
	db	'sub',0
	db	'min',0
	db	'div',0
	db	'max',0
opcode_0F58_0F59_0F5C_0F5F_table:
	db	'ps',0,0,0,0,0,0
	db	'pd',0,0,0,0,0,0
	db	'ss',0,0,0,0,0,0
	db	'sd',0,0,0,0,0,0
	dq	process_Vo_Wo
	dq	process_Vo_Wo
	dq	process_Vd_Wd
	dq	process_Vq_Wq

opcode_0F5A_table:
	db	'cvtps2pd'
	db	'cvtpd2ps'
	db	'cvtss2sd'
	db	'cvtsd2ss'
	dq	process_Vo_Wq
	dq	process_Vo_Wo
	dq	process_Vq_Wd
	dq	process_Vd_Wq

opcode_0F5B_instructions:
	db	'vtdq2ps',0
	db	'vtps2dq',0
	db	'vttps2dq'
	db	'vt???',0,0,0

opcode_0F60_0F62_instructions:
	db	'unpcklbw'
	db	'unpcklwd'
	db	'unpckldq'

opcode_0F63_0F67_instructions:
	db	'packsswb'
	db	'pcmpgtb',0
	db	'pcmpgtw',0
	db	'pcmpgtd',0
	db	'packuswb'

opcode_0F68_0F6B_instructions:
	db	'unpckhbw'
	db	'unpckhwd'
	db	'unpckhdq'
	db	'ackssdw',0

opcode_0F6F_table:
	db	'movq',0,0,0,0
	db	'movdqa',0,0
	db	'movdqu',0,0
	db	'???',0,0,0,0,0	;'repnz',0,0,0
	dq	process_Pq_Qq
	dq	process_Vo_Wo
	dq	process_Vo_Wo
	dq	process_Vo_Wo	;process_nothing

opcode_pshuf_0F70_table:
	db	'pshufw',0,0
	db	'pshufd',0,0
	db	'pshufhw',0
	db	'pshuflw',0
	dq	process_Pq_Qq
	dq	process_Vo_Wo
	dq	process_Vo_Wo
	dq	process_Vo_Wo

opcode_pshimw_pshimd_0F71_0F72_table:
	db	'???',0
	db	'???',0
	db	'psrl'
	db	'???',0
	db	'psra'
	db	'???',0
	db	'psll'
	db	'???',0

opcode_pshimq_0F73_table:
	db	'??'
	db	'??'
	db	'q',0
	db	'??'
	db	'??'
	db	'??'
	db	'q',0
	db	'??'
opcode_pshimq_660F73_table:
	db	'??'
	db	'??'
	db	'q',0
	db	'dq'
	db	'??'
	db	'??'
	db	'q',0
	db	'dq'

opcode_pcmpeq_0F74_0F76_table:
	db	'pcmpeqb '
	db	'pcmpeqw '
	db	'pcmpeqd '
	dq	0	; dummy, for align 16 only

opcode_haddp_0F7C_instruction:
	db	'???',0,0,0,0,0
	db	'haddpd',0,0
	db	'???',0,0,0,0,0
	db	'haddps',0,0
opcode_hsubp_0F7D_instruction:
	db	'???',0,0,0,0,0
	db	'hsubpd',0,0
	db	'???',0,0,0,0,0
	db	'hsubps',0,0

opcode_movq_0F7E_table:
; correct this, good is:
; 0Fh,7Eh	MOVD Eq,Pq
; 66h,0Fh,7Eh	MOVD Eq,Vq
	db	'movd',0,0,0,0
	db	'movd',0,0,0,0
	db	'movq',0,0,0,0
	db	'???',0,0,0,0,0
	dq	process_Ed_Pd
	dq	process_Ed_Vd
	dq	process_Vo_Mq	; process_Vq_Vq for e.g. 0F7EC0-0F7EFF
	dq	process_Eq_Vq	; 66 REX.W 0F 7E movd reg64,xmm

process_opcode_0F7F_table:
	db	'movq',0,0,0,0
	db	'movdqa',0,0
	db	'movdqu',0,0
	db	'???',0,0,0,0,0
	dq	process_Qq_Pq
	dq	process_Wo_Vo
	dq	process_Wo_Vo
	dq	process_Wo_Vo

opcode_0FAE_instruction_table:
	db	'fxsave',0,0
	db	'fxrstor',0
	db	'ldmxcsr',0
	db	'stmxcsr',0
	db	'     ',0,0,0
	db	'lfence',0,0
	db	'mfence',0,0
	db	'sfence',0,0

opcode_bit_tests_0FBA_table:
	db	'bt',0,0
	db	'bts',0
	db	'btr',0
	db	'btc',0

opcode_0FC2_conditions:
	db	'eq',0,0,0,0,0,0
	db	'lt',0,0,0,0,0,0
	db	'le',0,0,0,0,0,0
	db	'unord',0,0,0
	db	'neq',0,0,0,0,0
	db	'nlt',0,0,0,0,0
	db	'nle',0,0,0,0,0
	db	'ord',0,0,0,0,0

opcode_0FC2_table:
	db	'ps',0,0,0,0,0,0
	db	'pd',0,0,0,0,0,0
	db	'ss',0,0,0,0,0,0
	db	'sd',0,0,0,0,0,0
	dq	process_Vo_Wo
	dq	process_Vo_Wo
	dq	process_Vd_Wd
	dq	process_Vq_Wq

opcode_0FD6_table:
	db	'???',0,0,0,0,0
	db	'movq',0,0,0,0
	db	'movq2dq',0
	db	'movdq2q',0
	dq	process_Vo_Wo		; only dummy, this opcode is invalid
	dq	process_Mq_Vq
	dq	process_Vo_PRq
	dq	process_Pq_VRq

opcode_0FD8_0FDF_instructions:
	db	'psubusb',0
	db	'psubusw',0
	db	'pminub',0,0
	db	'pand',0,0,0,0
	db	'paddusb',0
	db	'paddusw',0
	db	'pmaxub',0,0
	db	'pandn',0,0,0

opcode_0FE0_0FE5_instructions:
	db	'pavgb',0,0,0
	db	'psraw',0,0,0
	db	'psrad',0,0,0
	db	'pavgw',0,0,0
	db	'pmulhuw',0
	db	'pmulhw',0,0

opcode_0FE6_table:
	db	'???',0,0,0,0,0
	db	'vttpd2dq'
	db	'vtdq2pd',0
	db	'vtpd2dq',0
	dq	process_Vo_Wo		; only dummy, this opcode is invalid
	dq	process_Vo_Wo
	dq	process_Vo_Wq
	dq	process_Vo_Wo

opcode_0FE8_0FEF_instructions:
	db	'psubsb',0,0
	db	'psubsw',0,0
	db	'pminsw',0,0
	db	'por',0,0,0,0,0
	db	'paddsb',0,0
	db	'paddsw',0,0
	db	'pmaxsw',0,0
	db	'pxor',0,0,0,0

opcode_0FF1_0FF6_instructions:
	dq	0			; dummy, for align only
	db	'psllw',0,0,0
	db	'pslld',0,0,0
	db	'psllq',0,0,0
	db	'pmuludq',0
	db	'pmaddwd',0
	db	'psadbw',0,0
	dq	0			; dummy, for align only

opcode_0FF8_0FFE_instructions:
	db	'psubb',0,0,0
	db	'psubw',0,0,0
	db	'psubd',0,0,0
	db	'psubq',0,0,0
	db	'paddb',0,0,0
	db	'paddw',0,0,0
	db	'paddd',0,0,0
	dq	0			; dummy, for align only

pacifica_instructions:
	db	'vmrun',0,0,0
	db	'vmmcall',0
	db	'vmload',0,0
	db	'vmsave',0,0
	db	'stgi',0,0,0,0
	db	'clgi',0,0,0,0
	db	'skinit',0,0
	db	'invlpga',0

vanderpol_instructions:
	db	'vmcall',0,0		; 0F01C1
	db	'vmlaunch'		; 0F01C2
	db	'vmresume'		; 0F01C3
	db	'vmxoff',0,0		; 0F01C4

vanderpol_instructions1:
	db	'monitor',0		; 0F01C8
	db	'mwait',0,0,0		; 0F01C9

vanderpol_instructions2:
	db	'xgetbv',0,0		; 0F01D0
	db	'xsetbv',0,0		; 0F01D1

opcode_0F10_0F11_post_disasm_table:
opcode_0F51_post_disasm_table:		; both tables are identical
opcode_0F58_0F59_0F5C_0F5F_post_disasm_table:
	db	post_disasm_xmm_128_sp
	db	post_disasm_xmm_128_dp
	db	post_disasm_mm_64_sp
	db	post_disasm_mm_64_dp

opcode_0F12_post_disasm_table:
	db	post_disasm_mm_64_sp
	db	post_disasm_mm_64_dp
	db	post_disasm_xmm_128_hexa
	db	post_disasm_xmm_128_hexa

opcode_0F16_post_disasm_table:
	db	post_disasm_mm_64_sp
	db	post_disasm_mm_64_dp
	db	post_disasm_xmm_128_sp
	db	post_disasm_nothing

opcode_0F2A_post_disasm_table:
	db	post_disasm_xmm_2_sig_dwords
	db	post_disasm_xmm_2_sig_dwords
	db	post_disasm_fpu_sig_dword
	db	post_disasm_fpu_sig_dword

opcode_0F2C_0F2D_post_disasm_table:
opcode_0F5A_post_disasm_table:		; both are identical
	db	post_disasm_mm_64_sp
	db	post_disasm_xmm_128_dp
	db	post_disasm_fpu_dword
	db	post_disasm_fpu_qword

opcode_0F6F_post_disasm_table:
	db	post_disasm_mm_64_hexa
	db	post_disasm_xmm_128_hexa
	db	post_disasm_xmm_128_hexa
	db	post_disasm_nothing

opcode_0F70_post_disasm_table:
	db	post_disasm_mm_64_hexa
	db	post_disasm_xmm_128_hexa
	db	post_disasm_xmm_128_hexa
	db	post_disasm_xmm_128_hexa

opcode_0FC2_post_disasm_table:
	db	post_disasm_xmm_128_sp
	db	post_disasm_xmm_128_dp
	db	post_disasm_fpu_dword
	db	post_disasm_fpu_qword

opcode_0FD6_post_disasm_table:
	db	post_disasm_nothing
	db	post_disasm_mm_64_hexa
	db	post_disasm_nothing
	db	post_disasm_nothing

opcode_0FE6_post_disasm_table:
	db	post_disasm_nothing
	db	post_disasm_xmm_128_dp
	db	post_disasm_xmm_2_sig_dwords
	db	post_disasm_xmm_128_dp
