align 16
hexa_64_rax_sign_negative:
; store '-' before value if necessary (if it is negative value)
	push	rax
	push	rcx
	mov	byte [rdi],'-'
	mov	rcx,rax
	neg	rcx		; rcx = -1 * rax
	or	rax,rax		; is rax negative value ?
	cmovs	rax,rcx
	sets	cl		; set CL=0 if rax positive, CL=1 if rax negative value
	movzx	ecx,cl
	add	rdi,rcx
	pop	rcx
	jmp	hexa_64_rax_bswap

align 16
hexa_64_rax_sign:
; change '+' on [rdi-1] to '-' if rax holds negative value and negate rax in this case
	push	rax
	push	rcx
	mov	rcx,rax
	neg	rcx		; rcx = -1 * rax
	or	rax,rax		; is rax negative value ?
	cmovs	rax,rcx
	sets	cl		; set CL=0 if rax positive, CL=1 if rax negative value
;	add	byte [rdi-1],cl
;	add	byte [rdi-1],cl	; change '+' to '-' (2Bh to 2Dh)
; faster way:
	shl	cl,1		; CL*2
	add	byte [rdi-1],cl
	pop	rcx
	jmp	hexa_64_rax_bswap

align 16
hexa_64_rax:
; put rax value to ASCII hexadecimal 16 byte buffer at [rdi]
	push	rax
hexa_64_rax_bswap:
	bswap	rax
	movdqa	xmm3,dqword [Sum1]
	movdqa	xmm4,dqword [Comp1]
	movdqa	xmm2,dqword [Mask1]
	movdqa	xmm5,dqword [Num1]
	movq	xmm0,rax
	movdqa	xmm1,xmm0
	psrlq	xmm0,4
	pand	xmm0,xmm2
	pand	xmm1,xmm2
	punpcklbw	xmm0,xmm1
	movdqa	xmm1,xmm0
	pcmpgtb	xmm0,xmm4
	pand	xmm0,xmm5
	paddb	xmm1,xmm3
	paddb	xmm1,xmm0
; we must use movdqu instead of movdqa because we don't know if rdi is aligned 16
	movdqu	dqword [rdi],xmm1
	pop	rax
	ret

align 16
hexa_64_rax_nobswap:
	movdqa	xmm3,dqword [Sum1]
	movdqa	xmm4,dqword [Comp1]
	movdqa	xmm2,dqword [Mask1]
	movdqa	xmm5,dqword [Num1]
	movq	xmm0,rax
	movdqa	xmm1,xmm0
	psrlq	xmm0,4
	pand	xmm0,xmm2
	pand	xmm1,xmm2
	punpcklbw	xmm0,xmm1
	movdqa	xmm1,xmm0
	pcmpgtb	xmm0,xmm4
	pand	xmm0,xmm5
	paddb	xmm1,xmm3
	paddb	xmm1,xmm0
	movdqu	dqword [rdi],xmm1
	ret

align 16
hexa_32_eax:
; put eax value to ASCII hexadecimal 8 byte buffer at [rdi]
	push	rax
	bswap	eax
	movdqa	xmm3,dqword [Sum1]
	movdqa	xmm4,dqword [Comp1]
	movdqa	xmm2,dqword [Mask1]
	movdqa	xmm5,dqword [Num1]
	movq	xmm0,rax
	movdqa	xmm1,xmm0
	psrlq	xmm0,4
	pand	xmm0,xmm2
	pand	xmm1,xmm2
	punpcklbw	xmm0,xmm1
	movdqa	xmm1,xmm0
	pcmpgtb	xmm0,xmm4
	pand	xmm0,xmm5
	paddb	xmm1,xmm3
	paddb	xmm1,xmm0
	movq	qword [rdi],xmm1
 	pop	rax
	ret

ascii2hexa_qword:
; input:  rsi point to ascii string
;         rax string size must be in interval 1-16
; output: rdx hexa number
	push	rax
	push	rcx
	push	rbx
	push	rdi
	or	rax,rax
	jz	ascii2hexa_qword_GetValue_L9
	cmp	rax,16
	jnbe	ascii2hexa_qword_GetValue_L9
	xchg	ecx,eax			; string size to RCX
	xor	edx,edx			; register for count new hexa value
	mov	bl,'A' - ('0' and 11011111b) - 10
ascii2hexa_qword_GetValue_L0:
	xor	edi,edi
	lodsb
	and	al,11011111b		; convert lowercase to Capitals
	sub	al,'0' and 11011111b
	jc	ascii2hexa_qword_GetValue_L9
	cmp	al,10
	cmovnc	edi,ebx
	sub	al,dil
	cmp	al,16
	jnc	ascii2hexa_qword_GetValue_L9
	shl	rdx,4
	or	dl,al
	loop	ascii2hexa_qword_GetValue_L0
	pop	rdi
	pop	rbx
	pop	rcx
	pop	rax
	clc
	ret	
ascii2hexa_qword_GetValue_L9:
	pop	rdi
	pop	rbx
	pop	rcx
	pop	rax
	stc
	ret

ascii2hexa:
; input:  rsi point to ascii string
;         rax string size must be in interval 1-32
;         rdi point to output buffer
; output: fill buffer at rdi
	push	rax
	push	rcx
	push	rdx
	push	rbx
	push	rdi
	or	rax,rax
	jz	ascii2hexa_GetValue_L9
	cmp	rax,32
	jnbe	ascii2hexa_GetValue_L9
	xchg	ecx,eax			; string size to RCX
	xor	eax,eax
	mov	qword [rdi],rax		; prepare to zero value result
	mov	qword [rdi+8],rax	; prepare to zero value result
	mov	bl,'A' - ('0' and 11011111b) - 10
ascii2hexa_GetValue_L0:
	xor	edx,edx
	mov	al,[rsi + rcx - 1]
	and	al,11011111b		; convert lowercase to Capitals
	sub	al,'0' and 11011111b
	jc	ascii2hexa_GetValue_L9
	cmp	al,10
	cmovnc	edx,ebx
	sub	al,dl
	cmp	al,16
	jnc	ascii2hexa_GetValue_L9
	mov	byte [rdi],al
	dec	ecx
	jz	ascii2hexa_GetValue_L8

	xor	edx,edx
	mov	al,[rsi + rcx - 1]
	and	al,11011111b		; convert lowercase to Capitals
	sub	al,'0' and 11011111b
	jc	ascii2hexa_GetValue_L9
	cmp	al,10
	cmovnc	edx,ebx
	sub	al,dl
	cmp	al,16
	jnc	ascii2hexa_GetValue_L9
	shl	al,4
	or	byte [rdi],al
	inc	rdi
	loop	ascii2hexa_GetValue_L0

ascii2hexa_GetValue_L8:
	pop	rdi
	pop	rbx
	pop	rdx
	pop	rcx
	pop	rax
	clc
	ret	
ascii2hexa_GetValue_L9:
	pop	rdi
	pop	rbx
	pop	rdx
	pop	rcx
	pop	rax
	stc
	ret

	
ascii2hexa_avx:
; input:  rsi point to ascii string
;         rax string size must be in interval 1-64
;         rdi point to output buffer
; output: fill buffer at rdi
	push	rax
	push	rcx
	push	rdx
	push	rbx
	push	rdi
	or	rax,rax
	jz	ascii2hexa_avx_GetValue_L9
	cmp	rax,64
	jnbe	ascii2hexa_avx_GetValue_L9
	xchg	ecx,eax			; string size to RCX
	xor	eax,eax
	mov	[rdi+8*0],rax		; prepare to zero value result
	mov	[rdi+8*1],rax		; prepare to zero value result
	mov	[rdi+8*2],rax		; prepare to zero value result
	mov	[rdi+8*3],rax		; prepare to zero value result
	mov	bl,'A' - ('0' and 11011111b) - 10
ascii2hexa_avx_GetValue_L0:
	xor	edx,edx
	mov	al,[rsi + rcx - 1]
	and	al,11011111b		; convert lowercase to Capitals
	sub	al,'0' and 11011111b
	jc	ascii2hexa_avx_GetValue_L9
	cmp	al,10
	cmovnc	edx,ebx
	sub	al,dl
	cmp	al,16
	jnc	ascii2hexa_avx_GetValue_L9
	mov	byte [rdi],al
	dec	ecx
	jz	ascii2hexa_avx_GetValue_L8

	xor	edx,edx
	mov	al,[rsi + rcx - 1]
	and	al,11011111b		; convert lowercase to Capitals
	sub	al,'0' and 11011111b
	jc	ascii2hexa_avx_GetValue_L9
	cmp	al,10
	cmovnc	edx,ebx
	sub	al,dl
	cmp	al,16
	jnc	ascii2hexa_avx_GetValue_L9
	shl	al,4
	or	byte [rdi],al
	inc	rdi
	loop	ascii2hexa_avx_GetValue_L0

ascii2hexa_avx_GetValue_L8:
	pop	rdi
	pop	rbx
	pop	rdx
	pop	rcx
	pop	rax
	clc
	ret	
ascii2hexa_avx_GetValue_L9:
	pop	rdi
	pop	rbx
	pop	rdx
	pop	rcx
	pop	rax
	stc
	ret	
	
ascii2hexa_no_rev:
; input:  rsi point to ascii string
;         rax string size must be in interval 1-32
;         rdi point to output buffer
; output: fill buffer at rdi
	push	rax
	push	rcx
	push	rdx
	push	rbx
	push	rsi
	push	rdi
	or	rax,rax
	jz	ascii2hexa_no_rev_GetValue_L9
	cmp	rax,32
	jnbe	ascii2hexa_no_rev_GetValue_L9
	xchg	ecx,eax			; string size to RCX
	xor	eax,eax
	mov	qword [rdi],rax		; prepare to zero value result
	mov	qword [rdi+8],rax	; prepare to zero value result
	mov	bl,'A' - ('0' and 11011111b) - 10
ascii2hexa_no_rev_GetValue_L0:
	xor	edx,edx
	lodsb
	and	al,11011111b		; convert lowercase to Capitals
	sub	al,'0' and 11011111b
	jc	ascii2hexa_no_rev_GetValue_L9
	cmp	al,10
	cmovnc	edx,ebx
	sub	al,dl
	cmp	al,16
	jnc	ascii2hexa_no_rev_GetValue_L9
	shl	al,4
	mov	byte [rdi],al
	dec	ecx
	jz	ascii2hexa_no_rev_GetValue_L8

	xor	edx,edx
	lodsb
	and	al,11011111b		; convert lowercase to Capitals
	sub	al,'0' and 11011111b
	jc	ascii2hexa_no_rev_GetValue_L9
	cmp	al,10
	cmovnc	edx,ebx
	sub	al,dl
	cmp	al,16
	jnc	ascii2hexa_no_rev_GetValue_L9
	or	byte [rdi],al
	inc	rdi
	loop	ascii2hexa_no_rev_GetValue_L0

ascii2hexa_no_rev_GetValue_L8:
	pop	rdi
	pop	rsi
	pop	rbx
	pop	rdx
	pop	rcx
	pop	rax
	clc
	ret	
ascii2hexa_no_rev_GetValue_L9:
	pop	rdi
	pop	rsi
	pop	rbx
	pop	rdx
	pop	rcx
	pop	rax
	stc
	ret
