align 16
display_regs_memory:
; input:	eax dwProcessId
;		edx dwThreadId
	cmp	byte [WeAreDebugging],0
	jz	display_regs_memory_ret

	push	rax rcx rdx rbx rbp rsi rdi
	sub	rsp,8*(4+0)

	mov	ecx,edx				; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	display_regs_memory_epilogue

	cmp	[face.childwiconized+0],0
	jnz	display_regs_memory_code1st_done
	mov	rax,qword [Code_listview_dump_start_address + 8*0]
	mov	rcx,qword [hChildren+8*0]	; code 1st SysListView32 handle
	mov	edx,dword [rsp+8*(4+0+6)]	; process Id
	mov	r8d,dword [rsp+8*(4+0+4)]	; thread Id
	call	update_code_SysListView32
display_regs_memory_code1st_done:

	cmp	[face.childwiconized+1],0
	jnz	display_regs_memory_code2nd_done
	mov	rax,qword [Code_listview_dump_start_address + 8*1]
	mov	rcx,qword [hChildren+8*1]	; code 2nd SysListView32 handle
	mov	edx,dword [rsp+8*(4+0+6)]	; process Id
	mov	r8d,dword [rsp+8*(4+0+4)]	; thread Id
	call	update_code_SysListView32
display_regs_memory_code2nd_done:

	cmp	[face.childwiconized+2],0
	jnz	display_regs_memory_data1st_done
	mov	rax,qword [Data_listview_dump_start_address + 8*0]
	mov	rcx,qword [hChildren+8*2]	; data 1st SysListView32 handle
	mov	edx,dword [rsp+8*(4+0+6)]	; process Id
	mov	r8b,byte [face.SLV02cs_type]
	call	update_data_SysListView32
display_regs_memory_data1st_done:

	cmp	[face.childwiconized+3],0
	jnz	display_regs_memory_data2nd_done
	mov	rax,qword [Data_listview_dump_start_address + 8*1]
	mov	rcx,qword [hChildren+8*3]	; data 2nd SysListView32 handle
	mov	edx,dword [rsp+8*(4+0+6)]	; process Id
	mov	r8b,byte [face.SLV03cs_type]
	call	update_data_SysListView32
display_regs_memory_data2nd_done:

	cmp	[face.childwiconized+4],0
	jnz	display_regs_memory_data3rd_done
	mov	rax,qword [Data_listview_dump_start_address + 8*2]
	mov	rcx,qword [hChildren+8*4]	; data 3rd SysListView32 handle
	mov	edx,dword [rsp+8*(4+0+6)]	; process Id
	mov	r8b,byte [face.SLV04cs_type]
	call	update_data_SysListView32
display_regs_memory_data3rd_done:

	cmp	[face.childwiconized+5],0
	jnz	display_regs_memory_stack_done
	mov	rax,qword [Stack_listview_dump_start_address + 8*0]
	mov	rcx,qword [hChildren+8*5]	; stack SysListView32 handle
	mov	edx,dword [rsp+8*(4+0+6)]	; process Id
	call	update_stack_SysListView32
display_regs_memory_stack_done:

	call	update_registers_SysListView32s

; now have to update selections in code 1st ... stack because everything was destroyed
; when LVM_DELETEALLITEMS
	call	update_selections

display_regs_memory_epilogue:
	add	rsp,8*(4+0)
	pop	rdi rdi rbp rbx rdx rcx rax
display_regs_memory_ret:
	ret

align 16
update_code_SysListView32:
; input: RCX handle of SysListView32
;	 RAX start address
;	 EDX process Id
;	 R8D thread Id
	cmp	byte [WeAreDebugging],0
	jz	update_code_SysListView32_ret

	push	rax rcx rdx rbx rbp rsi rdi r8 r15
a	=	9			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	(16/8) + 1		; 1st column - address
f	=	2*InstructionMaxSize/8 + 1; 2nd column - hexa opcode
if InstructionMaxSize <> 16
Above e requires change !
end if

g	=	(disasm_buf+7)/8	; 3rd column - disassembled instruction
h	=	(MaxInstructionsToDisplay*InstructionMaxSize + 7) / 8
i	=	(a+b+d+e+f+g+h+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f+g+h+i)

	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_DELETEALLITEMS
;	mov	rcx,rcx
	call	qword [SendMessageA]

virtual at rsp+8*4
lvitem	LV_ITEM64
end virtual

	and	[lvitem.iItem],0

; this is for SysListView32 without WS_VSCROLL style (which hasn't vertical scroll bar)
;	mov	ebx,MaxInstructionsToDisplay*InstructionMaxSize

; this is for SysListView32 with WS_VSCROLL style
	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_GETCOUNTPERPAGE
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]
	mov	ebp,eax
	mov	ebx,MaxInstructionsToDisplay
	cmp	eax,ebx
	cmovc	ebx,eax
	shl	ebx,4			; *16 number of bytes to read from debuggee
	jz	update_code_ListView_epilogue
if InstructionMaxSize <> 16
Above instruction requires adjustement!
end if
	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+i+6)]	; process Id
	lea	rdi,[rsp+8*(b+d+e+f+g)]	; buffer for debuggee code
	lea	rsi,[rsp+8*(b+d+e+f+g+h+i+8)]	; point to rax = start address
	call	available_debuggee_memory
	mov	r15,rax
	cmp	rax,rbx
	cmovc	rbx,rax			; decrement the size of bytes to read if there is less bytes than requested size
	or	rax,rax
;	jz	update_code_ListView_epilogue
;
; no, this is bad for code 2nd when attaching to a process
;
; this is better:
	jz	update_code_ListView_nothing

	pxor	xmm0,xmm0
	movdqu	[rdi],xmm0
if InstructionMaxSize <> 16
Above instruction requires adjustement!
end if

	call	read_debuggee_memory
;	jc	update_code_ListView_epilogue
;
; no, this is bad for code 2nd when attaching to a process
;
; this is better:
	jnc	update_code_ListView_L
;
; determine whether we have blank SysListView32
	lea	r9,[lvitem]
	lea	rdx,[tmp_buf]
	and	[r9+LV_ITEM64.iSubItem],0	; iSubItem=0 for address
	mov	[r9+LV_ITEM64.pszText],rdx
	mov	[r9+LV_ITEM64.cchTextMax],SysListView_cchTextMax
	xor	r8,r8				; iItem=0 for start position
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]
	or	rax,rax				; empty ?
	jnz	update_code_ListView_epilogue

; put desired address there
	mov	rax,qword [rsp+8*(b+d+e+f+g+h+i+8)]	; rax = start address
	lea	rdi,[tmp_buf]
	call	hexa_64_rax
	mov	byte [rdi+16],0

	lea	r9,[lvitem]
	mov	[r9+LV_ITEM64.mask],LVIF_TEXT
	and	[r9+LV_ITEM64.iItem],0
; not necessary to set it again:
;	mov	[r9+LV_ITEM64.pszText],rdi
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

	jmp	update_code_ListView_epilogue

update_code_ListView_L:
	mov	ebx,ebp			; ebx = count of "rows" in code SysListView
	lea	rsi,[rdi]		; buffer with code
	mov	rbp,qword [rsp+8*(b+d+e+f+g+h+i+8)]	; start address

AMDPad16
update_code_ListView_L0:
	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+i+1)]	; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	and	[lvitem.lParam],0		; lParam is used for hold item color

	cmp	[ThreadContext.Rip],rbp		; check whether we are on RIP
if WeAreOn_RIP=0
	setz	byte [lvitem.lParam]
else
	jnz	lParam_done
	bts	[lvitem.lParam],WeAreOn_RIP
lParam_done:
end if

; hexa address
	mov	rax,rbp
	lea	rdi,[rsp+8*(b+d)]
	call	hexa_64_rax
	mov	byte [rdi+16],0

;	mov	rax,rbp; unnecessary again
; patch software breakpoint if any
	cmp	byte [rsi],0CCh
	jnz	update_code_ListView_L1
	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+i+6)]	; process Id
	call	scan_sw_bp_addr_pid
	jnz	update_code_ListView_L1
; patch it !
	mov	rdi,qword [breakpoints_space_address]
	mov	cl,byte [rdi + (8+4)*MaxNumberOfBreakpoints + rdx*1]
	mov	byte [rsi],cl

; and inform SysListView32 about color
if WeAreOn_SW_BP<8
	or	byte [lvitem.lParam],1 shl WeAreOn_SW_BP
else
	or	[lvitem.lParam],1 shl WeAreOn_SW_BP
end if

update_code_ListView_L1:

; check for HW_BP
	lea	rdi,[ThreadContext.Dr7]
	cmp	byte [rdi],00000000b	; 1st quick check in DR7:
					; whether any of DR0-DR3 is enabled
	jz	ch_hw_bp_L2

	mov	al,11000000b		; mask for L and G bits
	mov	edx,11110000000000000000000000000000b; mask for check LEN=byte and R/W=execute
	mov	ecx,4			; we have 4 HW BP
ch_hw_bp_L0:
	cmp	qword [rdi-8*5+(rcx-1)*8],rbp
	jnz	ch_hw_bp_L1
	test	byte [rdi],al		; DR disabled when both L and G bits are 0
	jz	ch_hw_bp_L1
	test	dword [rdi],edx		; check LEN and R/W
	jnz	ch_hw_bp_L1

if WeAreOn_HW_BP<8
	or	byte [lvitem.lParam],1 shl WeAreOn_HW_BP
else
	or	[lvitem.lParam],1 shl WeAreOn_HW_BP
end if

ch_hw_bp_L1:
	shr	al,2
	shr	edx,4
	loop	ch_hw_bp_L0
ch_hw_bp_L2:

; hexa opcode
	mov	rax,qword [rsi]		; grab 8 bytes of opcode
	lea	rdi,[rsp+8*(b+d+e)]
	call	hexa_64_rax_nobswap
	mov	rax,qword [rsi+8]	; grab next 8 bytes of opcode
	lea	rdi,[rsp+8*(b+d+e)+16]
	call	hexa_64_rax_nobswap
if InstructionMaxSize <> 16
Above instructions require adjustements!
end if

	lea	rdi,[rsp+8*(b+d+e+f)]	; buffer

; symbols:
; microsoft symbol
	mov	rax,rbp			; address
	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+i+6)]	; process Id
	call	address2ms_symbol
	jnc	update_code_ListView_symbols_common_end
; our symbols
	mov	rax,rbp			; address
	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+i+6)]	; process Id
	call	address2symbol		; transform addr->string, CF=1 if nothing transformed
	jc	update_code_ListView_L2
update_code_ListView_symbols_common_end:
	mov	ax,': '
	cld
	stosw
update_code_ListView_L2:

; instruction
;	mov	qword [post_disasm_address],0

	call	disassemble_one_instruction
	xor	ecx,ecx
	sub	r15,rax
;	jc	update_code_ListView_epilogue
	jc	update_code_ListView_last_breath

;	cmp	qword [post_disasm_address],0
;	jz	update_code_ListView_L3
;	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+i+6)]	; process Id
;	call	post_disasm_proc	; display something like call qword [1000308C] ; kernel32.CreateFileA
;update_code_ListView_L3:

;	cmp	[ThreadContext.Rip],rbp		; check whether we are on RIP
;	jnz	update_code_ListView_L4
	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+i+6)]	; process Id
	mov	edx,dword [rsp+8*(b+d+e+f+g+h+i+1)]	; thread Id
	call	post_disasm_pro		; display something like [rax+rdx*4+20]=[40315C]=7F854210
;update_code_ListView_L4:

update_code_ListView_last_breath:
	mov	rdi,rbp			; save address
	add	rbp,rax
	add	rsi,rax
	mov	byte [rsp+8*(b+d+e) + rax*2],0	; make 0-terminated string in buffer for display hexa opcode

update_code_ListView_L5:
; column 0, address
	mov	[lvitem.mask],LVIF_TEXT or LVIF_PARAM
	lea	rax,[rsp+8*(b+d)]
	and	[lvitem.iSubItem],0
	mov	[lvitem.pszText],rax
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

; column 1, opcode
	mov	[lvitem.mask],LVIF_TEXT
	lea	rax,[rsp+8*(b+d+e)]
	inc	dword [lvitem.iSubItem]
	mov	[lvitem.pszText],rax
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM		; or LVM_SETITEMTEXT after mov r8d,iSubItem
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

; column 2, disassembled instruction
	lea	rax,[rsp+8*(b+d+e+f)]
	inc	dword [lvitem.iSubItem]
	mov	[lvitem.pszText],rax
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

; column 3, comments
	mov	r8d,[last_PID]
	mov	rax,rdi				; address
	lea	rdi,[comments+max_comments*8]
	mov	ecx,max_comments
	lea	edx,[rcx-1]
	cld
AMDPad16
update_code_ListView_L6:
	repnz scasq				; scan for matching address
	jnz	update_code_ListView_L7		; end reached without finding matching address?
	cmp	[rdi-8-max_comments*8],r8	; scan for matching PID
	jnz	update_code_ListView_L6		; try to scan til the end

	sub	edx,ecx
; edx = index of comment

	lea	rdi,[comments + max_comments*8 + max_comments*8]

if comment_max_size = 100h
	shl	edx,8
else
	imul	edx,edx,comment_max_size
end if
	add	rdi,rdx
	jmp	update_code_ListView_L8

update_code_ListView_L7:
	lea	rdi,[tmp_buf]
	mov	byte [rdi],0

update_code_ListView_L8:
	lea	r9,[lvitem]
	inc	dword [lvitem.iSubItem]
	mov	[lvitem.pszText],rdi
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,[rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	[SendMessageA]

	inc	[lvitem.iItem]
	cmp	[lvitem.iItem],MaxLinesInSysListView32
	jnc	update_code_ListView_epilogue
	or	r15,r15
; if SF=1 or ZF=1 the done
	jz	update_code_ListView_epilogue
	js	update_code_ListView_epilogue
	dec	ebx
	jnz	update_code_ListView_L0

update_code_ListView_epilogue:
	add	rsp,8*(b+d+e+f+g+h+i)
	pop	r15 r8 rdi rsi rbp rbx rdx rcx rax
update_code_SysListView32_ret:
	ret

update_code_ListView_nothing:
; r15=0 now
; hexa address

;	and	[lvitem.iSubItem]		; will be done later
	and	[lvitem.lParam],0		; lParam is used for hold item color

	mov	rax,[rsp+8*(b+d+e+f+g+h+i+8)]	; rax = start address
	lea	rdi,[rsp+8*(b+d)]
	call	hexa_64_rax
	mov	byte [rdi+16],0
	mov	word [rsp+8*(b+d+e)],'?'
	mov	word [rsp+8*(b+d+e+f)],'?'
	jmp	update_code_ListView_L5


;align 16
;post_disasm_proc:
;	cmp	qword [post_disasm_address],0
;	jz	post_disasm_proc_ret
;
;	push	rax rcx rdx rbx rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
;;	mov	eax,dword [post_disasm_mode]
;xor eax,eax ; we have only 1 proc = post_disasm_proc_00
;	lea	rcx,[post_disasm_procedures]
;	mov	rax,qword [rcx + rax*8]
;	mov	qword [rsp-8],rax
;	mov	rcx,qword [rsp+8*13]
;	mov	rax,qword [rsp+8*14]
;	call	qword [rsp-8]
;	pop	r15 r14 r13 r12 r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx rax
;post_disasm_proc_ret:
;	ret
;
;align 16
;post_disasm_proc_00:
;; in:	ECX PID
;	push	rax rcx
;	sub	rsp,8*3			; align stack + reserve 3 qwords
;
;	lea	rsi,[rsp+8*0]
;	mov	rax,qword [post_disasm_address]
;	lea	rdi,[rsp+8*1]
;	mov	qword [rsi],rax
;	mov	ebx,8			; read 8 bytes is enough
;	mov	ecx,[last_PID]
;	call	read_debuggee_memory
;	jc	post_disasm_proc_00_end
;
;	mov	rax,qword [rdi]
;	mov	rdi,qword [post_disasm_buffer]
;; rdi is pointing at 0-terminator of disassembled opcode
;	lea	rdi,[rdi+23]		; space for ' ; []=xxxxxxxxxxxxxxxx='
;	mov	ecx,dword [rsp+8*(3+0)]	; PID
;	call	address2symbol
;	jc	post_disasm_proc_00_end
;	lea	rcx,[rdi]
;	mov	rdi,qword [post_disasm_buffer]
;	mov	rax,' ; []='
;	mov	qword [rdi],rax
;	mov	byte [rdi+22],'='
;	lea	rdi,[rdi+6]
;	mov	rax,qword [rsi+8]
;	call	hexa_64_rax
;	lea	rdi,[rcx]
;
;post_disasm_proc_00_end:
;	add	rsp,8*3
;	pop	rcx rax
;	ret

align 16
post_disasm_pro:
; in: rdi string with disassembled instruction, rbp current value of RIP reg
; rbp = address of instruction
; ecx = PID
; edx = TID
; uses 4 qword buffer at rsp
; rsp+8*0	will be filled with address in process to be read
; rsp+8*1	will be filled with end of string with disassembled instruction
; rsp+8*2	will be filled after read memory of debuggee
;		2 qwords=16 bytes are used in case of xmm
;		2 qwords used if movsq cmpsq: [rsp+8*2] <- qword at RDI , [rsp+8*3] <- qword at RSI
	cmp	byte [post_disasm_action],post_disasm_nothing
	jz	post_disasm_pro_ret
	cmp	byte [post_disasm_flag],0
	jz	post_disasm_pro_ret

	test	byte [post_disasm_flag],post_disasm_flag_rdi or post_disasm_flag_rsi
	jnz	post_disasm_pro_L0	; check whether RIP matches for string operations
	test	byte [post_disasm_flag],post_disasm_flag_reg0 or post_disasm_flag_reg1
	jz	post_disasm_pro_prologue
post_disasm_pro_L0:
	cmp	[ThreadContext.Rip],rbp	; check whether we are on RIP
	jnz	post_disasm_pro_ret	; go out for registers if we aren't on RIP because
					; registers may change after execute instructions
					; (execute instructions changes RIP)

post_disasm_pro_prologue:
	push	rax rcx rdx rbx rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
	sub	rsp,8*4

	mov	ecx,SysListView_cchTextMax
	xor	eax,eax
	cld
	repnz scasb
	dec	rdi			; the end of string
	lea	rsi,[rsp]		; buffer for address in process to be read
	mov	byte [rdi],0		; 0-terminator
	mov	rax,qword [post_disasm_addr0]
	mov	qword [rsi+8],rdi	; end of disassembled string
	mov	qword [rsi],rax

	test	byte [post_disasm_flag],post_disasm_flag_direct
	jnz	post_disasm_pro_go

; get size of memory to read
	lea	rdx,[post_disasm_sizes]
	movzx	ecx,byte [post_disasm_action]
;	jrcxz	post_disasm_pro_epi	; was tested before prologue already
	movzx	ebx,byte [rdx+rcx-1]	; RCX=0 means nothing, RCX=1 is the first
; ebx=size now, see post_disasm_byte...post_disasm_xmm_128_sp in fdbg_constants.inc

	cmp	byte [post_disasm_action],post_disasm_xlat
	jz	post_disasm_pro_xlat
	test	byte [post_disasm_flag],post_disasm_flag_rdi or post_disasm_flag_rsi
	jnz	post_disasm_pro_strings

; do the real work
	xor	edi,edi			; result
	test	byte [post_disasm_flag],post_disasm_flag_reg1
	jz	post_disasm_pro_L1
	mov	edx,dword [post_disasm_reg1]
	lea	rax,[ThreadContext.Rax]
	mov	cl,dl
	and	cl,00010000b
	and	dl,00001111b
	mov	rdi,qword [rax+rdx*8]
	shl	cl,1			; CL=0 for GPR64, CL=32 for GPR32
	or	rdx,-1
	shr	rdx,cl
	and	rdi,rdx			; leave only low dword for GPR32
	mov	cl,byte [post_disasm_mul]
	shl	rdi,cl			; multiply RDI
post_disasm_pro_L1:

	test	byte [post_disasm_flag],post_disasm_flag_reg0
	jz	post_disasm_pro_L2
	mov	edx,dword [post_disasm_reg0]
	lea	rax,[ThreadContext.Rax]
	mov	cl,dl
	and	cl,00010000b
	and	dl,00001111b
	mov	rax,qword [rax+rdx*8]
	shl	cl,1			; CL=0 for GPR64, CL=32 for GPR32
	or	rdx,-1
	shr	rdx,cl
	and	rax,rdx			; leave only low dword for GPR32
	add	rdi,rax
post_disasm_pro_L2:

	test	byte [post_disasm_flag],post_disasm_flag_addr1
	jz	post_disasm_pro_L3
	add	rdi,qword [post_disasm_addr1]
post_disasm_pro_L3:

	test	byte [post_disasm_flag],post_disasm_flag_addr0
	jz	post_disasm_pro_L4
	add	rdi,qword [post_disasm_addr0]
post_disasm_pro_L4:

;	test	byte [post_disasm_prefix],post_disasm_segment_fs
;	jz	post_disasm_pro_L05
;	add	rdi,qword []
;post_disasm_pro_L05:
;
	test	byte [post_disasm_prefix],post_disasm_segment_gs
	jz	post_disasm_pro_L06
	mov	eax,dword [rsp+8*(4+12)]
	call	get_ThreadLocalBase_from_TID
	jc	post_disasm_pro_L06
	add	rdi,rdx
post_disasm_pro_L06:

; rsi is pointing to [rsp], ebx=size
	mov	qword [rsi],rdi		; put address into buffer at rsi
	lea	rdi,[rsi+16]		; buffer to read bytes from process
	mov	ecx,dword [rsp+8*(4+13)]; get PID
	call	read_debuggee_memory
	jc	post_disasm_pro_L9

	mov	rdi,qword [rsi+8]	; end of disassembled string

post_disasm_pro_go:
	mov	eax,' ; '
	cld
	stosd
	dec	rdi
	test	byte [post_disasm_flag],post_disasm_flag_direct
	jnz	post_disasm_pro_L8
;	test	[post_disasm_flag],post_disasm_flag_reg0 or post_disasm_flag_reg1
;	jz	post_disasm_pro_L8
	mov	al,'['
	stosb
	cmp	byte [post_disasm_flag],post_disasm_flag_addr0
	mov	rax,qword [rsi]
	jz	post_disasm_pro_addr_hexa_done
	call	hexa_64_rax
	lea	rdi,[rdi+16]
post_disasm_pro_addr_hexa_done:
	lea	rdx,[rdi]
	inc	rdi
	mov	ecx,dword [rsp+8*(4+13)]; get PID
	call	address2symbol
	jnc	post_disasm_pro_L6
	call	address2ms_symbol
	jc	post_disasm_pro_L7
post_disasm_pro_L6:
	mov	byte [rdx],'='
post_disasm_pro_L7:
	sbb	rdi,0
	mov	al,']'
	stosb
	mov	al,'='
	stosb
post_disasm_pro_L8:
; next must be specific according to byte [post_disasm_action]
	lea	rdx,[post_disasm_action_proc_addr]
	movzx	eax,byte [post_disasm_action]
	call	qword [rdx+(rax-1)*8]

	cmp	[ThreadContext.Rip],rbp	; check whether we are on RIP
	jnz	post_disasm_pro_epi	; don't check conditional jumps if the instruction is not at the current RIP

	test	[post_disasm_flag],post_disasm_flag_cond_jump
	jz	post_disasm_pro_epi

	mov	rax,[rsi+8]
	cmp	byte [rax],0
	cmovz	rdi,rax
	jnz	post_disasm_continue_string
	mov	ax,' ;'
	stosw
post_disasm_continue_string:
	mov	eax,' -> '
	stosd

post_disasm_pro_add_cond_jump_status:
	movzx	eax,[post_disasm_cond_jump_type]
	cmp	al,00001111b
	jnbe	post_disasm_pro_epi		; abnormal value, should never happen...
; al:
; 0000b	JO	OF=1
; 0001b	JNO	OF=0
; 0010b	JC	CF=1
; 0011b	JNC	CF=0
; 0100b	JZ	ZF=1
; 0101b	JNZ	ZF=0
; 0110b	JBE	CF=1 or ZF=1
; 0111b JNBE	CF=0 and ZF=0
; 1000b	JS	SF=1
; 1001b	JNS	SF=0
; 1010b	JP	PF=1
; 1011b	JNP	PF=0
; 1010b	JL	SF<>OF
; 1011b	JNL	SF=OF
; 1010b	JLE	ZF=1 or SF<>OF
; 1011b	JNLE	ZF=0 and SF=OF
	lea	rdx,[post_disasm_cond_jump_proc_addr]
	mov	ecx,[ThreadContext.EFlags]
	call	qword [rdx+rax*8]
; CF=0 if conditions met
; CF=1 if conditions not met
	mov	eax,'YES'
	mov	ecx,'NO'
	cmovc	eax,ecx
	stosd
	jmp	post_disasm_pro_epi

post_disasm_pro_L9:
	mov	rdi,qword [rsi+8]	; end of disassembled string
	mov	eax,' ; ['
	cld
	stosd
	mov	rax,qword [rsi]
	call	hexa_64_rax
	lea	rdi,[rdi+16]
	mov	eax,']=?'
	stosd

post_disasm_pro_epi:
	add	rsp,8*4
	pop	r15 r14 r13 r12 r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx rax
post_disasm_pro_ret:
	ret

post_disasm_pro_xlat:
; xlat
	or	rax,-1
	mov	ecx,eax
	test	byte [post_disasm_prefix],post_disasm_prefix_67
;	setnz	cl
;	shl	cl,3+2			; make cl = 0 or 32
;	shr	rax,cl
; this is smaller than above 3 instructions:
	cmovnz	rax,rcx			; !!! note, cmovnz eax,ecx is mistake !!
	and	rax,qword [ThreadContext.Rbx]
	movzx	ecx,byte [ThreadContext.Rax]
	add	rax,rcx

;	test	byte [post_disasm_prefix],post_disasm_segment_fs
;	jz	post_disasm_pro_xlat_L15
;	add	rax,
;post_disasm_pro_xlat_L15:
;
	test	byte [post_disasm_prefix],post_disasm_segment_gs
	jz	post_disasm_pro_xlat_L16
	mov	eax,dword [rsp+8*(4+12)]
	call	get_ThreadLocalBase_from_TID
	jc	post_disasm_pro_xlat_L16
	add	rax,rdx
post_disasm_pro_xlat_L16:

; rsi is pointing to [rsp], ebx=size
	mov	qword [rsi],rax		; put address into buffer at rsi
	lea	rdi,[rsi+16]		; buffer to read bytes from process
	mov	ecx,dword [rsp+8*(4+13)]; get PID
	mov	ebx,1
	call	read_debuggee_memory
	jc	post_disasm_pro_L9
	mov	rdi,qword [rsi+8]
	mov	eax,' ; '
	cld
	stosd
	dec	rdi
	mov	rax,qword [rsi+16-7]
	call	hexa_64_rax
	lea	rdi,[rdi+rbx*2]
	mov	byte [rdi],0
	jmp	post_disasm_pro_epi

post_disasm_pro_strings:
	test	byte [post_disasm_flag],post_disasm_flag_rdi
	jz	post_disasm_pro_strings_L0
	or	rax,-1
	mov	ecx,eax
	test	byte [post_disasm_prefix],post_disasm_prefix_67
	cmovnz	rax,rcx			; !!! note, cmovnz eax,ecx is mistake !!
	and	rax,qword [ThreadContext.Rdi]
;	test	byte [post_disasm_prefix],post_disasm_segment_fs
;	jz	post_disasm_pro_strings_L25
;	add	rax,qword [regs.user_regs.fs_base]
;post_disasm_pro_strings_L25:
	test	byte [post_disasm_prefix],post_disasm_segment_gs
	jz	post_disasm_pro_strings_L26
	mov	eax,dword [rsp+8*(4+12)]
	call	get_ThreadLocalBase_from_TID
	jc	post_disasm_pro_strings_L26
	add	rax,rdx
post_disasm_pro_strings_L26:

	lea	rdi,[rsi+16]
	mov	qword [rsi],rax
	mov	ecx,dword [rsp+8*(4+13)]; get PID
	call	read_debuggee_memory
	jc	post_disasm_pro_L9
post_disasm_pro_strings_L0:
	test	byte [post_disasm_flag],post_disasm_flag_rsi
	jz	post_disasm_pro_strings_L1
	or	rax,-1
	mov	ecx,eax
	test	byte [post_disasm_prefix],post_disasm_prefix_67
	cmovnz	rax,rcx			; !!! note, cmovnz eax,ecx is mistake !!
	and	rax,[ThreadContext.Rsi]
;	test	byte [post_disasm_prefix],post_disasm_segment_fs
;	jz	post_disasm_pro_strings_L35
;	add	rax,qword [regs.user_regs.fs_base]
;post_disasm_pro_strings_L35:
	test	byte [post_disasm_prefix],post_disasm_segment_gs
	jz	post_disasm_pro_strings_L36
	mov	eax,dword [rsp+8*(4+12)]
	call	get_ThreadLocalBase_from_TID
	jc	post_disasm_pro_strings_L36
	add	rax,rdx
post_disasm_pro_strings_L36:
	lea	rdi,[rsi+24]
	mov	qword [rsi],rax
	mov	ecx,dword [rsp+8*(4+13)]; get PID
	call	read_debuggee_memory
	jc	post_disasm_pro_L9
post_disasm_pro_strings_L1:

; ebx=1=byte ebx=2=word ebx=4=dword ebx=8=qword
	lea	rcx,[rbx-8]	; rcx=-7=byte rcx=-6=word rcx=-4=dword rcx=0=qword

	mov	rdi,qword [rsi+8]	; end of disassembled string
	mov	eax,' ; '
	cld
	stosd
	dec	rdi

	test	byte [post_disasm_flag],post_disasm_flag_rdi
	jz	post_disasm_pro_strings_L2
	mov	rax,'[rdi]='
	mov	rdx,'[edi]='
	test	byte [post_disasm_prefix],post_disasm_prefix_67
	cmovnz	rax,rdx
	stosq
	lea	rdi,[rdi-2]
	cmp	bl,8			; the only choice for for maskmovdqu (0FF7C0-0FF7FF)
	jnbe	post_disasm_pro_maskmovdqu
	mov	rax,qword [rsi+16+rcx*1]
	call	hexa_64_rax
	test	byte [post_disasm_flag],post_disasm_flag_rsi
	jz	post_disasm_pro_strings_L3
	lea	rdi,[rdi+rbx*2]

	mov	al,' '
	stosb

post_disasm_pro_strings_L2:
	test	byte [post_disasm_flag],post_disasm_flag_rsi
	jz	post_disasm_pro_strings_L3
	mov	rax,'[rsi]='
	mov	rdx,'[esi]='
	test	byte [post_disasm_prefix],post_disasm_prefix_67
	cmovnz	rax,rdx
	stosq
	lea	rdi,[rdi-2]
	mov	rax,qword [rsp+24+rcx*1]
	call	hexa_64_rax
post_disasm_pro_strings_L3:
	lea	rdi,[rdi+rbx*2]
	mov	byte [rdi],0
	jmp	post_disasm_pro_epi

post_disasm_pro_maskmovdqu:
	mov	rax,qword [rsp+24]
	call	hexa_64_rax
	lea	rdi,[rdi+16]
	mov	rax,qword [rsp+16]
	call	hexa_64_rax
	lea	rdi,[rdi+16]
	mov	byte [rdi],0
	jmp	post_disasm_pro_epi

post_disasm_action_proc_bwdq:
post_disasm_action_proc_0:
post_disasm_action_proc_1:
post_disasm_action_proc_2:
post_disasm_action_proc_3:
	push	rbx		; only for align stack
; eax=[post_disasm_action] (byte, word, dword, qword)
; ebx=1=byte ebx=2=word ebx=4=dword ebx=8=qword
;	xor	ebx,ebx
;	lea	edx,[rax - post_disasm_byte]
;	bts	ebx,edx		; ebx=1=byte ebx=2=word ebx=4=dword ebx=8=qword
;	lea	rcx,[rbx-8]	; rcx=-7=byte rcx=-6=word rcx=-4=dword rcx=0=qword
;	mov	rax,qword [rsi+16+rcx*1]
	mov	rax,qword [rsi+16+rbx*1-8]	; load word/dword into highest word/dword of RAX
	call	hexa_64_rax
	lea	rdi,[rdi+rbx*2]
	mov	byte [rdi],0		; 0-terminator
	cmp	bl,post_disasm_dword
	jc	post_disasm_action_proc_ret	; we don't process addresses in byte [...] word [...]

	mov	rax,qword [rsi+16]	; in case post_disasm_dword loads dword into low dword of RAX
	mov	ecx,eax
	cmovz	rax,rcx			; cmovz eax,ecx is wrong !!! because destroys upper dword of RAX

post_disasm_action_proc_bwdq_common_begin:
	lea	rdx,[rdi]
	lea	rdi,[rdi+1]		; make room for store '=' if we find symbol
; rax=address
	mov	ecx,dword [last_PID]
	call	address2symbol
	jnc	post_disasm_action_proc_bwdq_L6
post_disasm_action_proc_bwdq_L5:
	call	address2ms_symbol
	jc	post_disasm_action_proc_bwdq_end
post_disasm_action_proc_bwdq_L6:
	mov	byte [rdx],'='
post_disasm_action_proc_bwdq_end:
	sbb	rdi,0			; restore rdi 1 byte back if we didn't find any symbol
post_disasm_action_proc_ret:
	pop	rbx
	ret

post_disasm_action_proc_4:
; fpu_dword
	push	rax
	lea	rax,[rsi+16]
	call	convert_float_32
	pop	rax
	ret

post_disasm_action_proc_5:
; fpu_qword
; mm_64_dp
	push	rax
	lea	rax,[rsi+16]
	call	convert_float_64
	pop	rax
	ret

post_disasm_action_proc_6:
; fpu_tbyte
	push	rax
	lea	rax,[rsi+16]
	call	convert_float_80
	pop	rax
	ret

post_disasm_action_proc_7:
; fpu_sig_word
	push	rax
	movsx	rax,word [rsi+16]
	call	qword_signed_decimal_ascii
	pop	rax
	ret

post_disasm_action_proc_8:
; fpu_sig_dword
	push	rax
	movsxd	rax,dword [rsi+16]
	call	qword_signed_decimal_ascii
	pop	rax
	ret

post_disasm_action_proc_9:
; fpu_sig_qword
	push	rax
	mov	rax,qword [rsi+16]
	call	qword_signed_decimal_ascii
	pop	rax
	ret

post_disasm_action_proc_A:
; fpu_bcd
	push	rax
	movdqa	xmm0,dqword [rsi+16]
	call	bcd2decimalsigned
	pop	rax
	ret

post_disasm_action_proc_B:
; mm_64_hexa	; instead of post_disasm_qword we won't try to translate qword address to symbol
	push	rax
	mov	rax,qword [rsi+16]
	mov	byte [rdi+16],0
	call	hexa_64_rax
	pop	rax
	ret

post_disasm_action_proc_C:
; mm_64_sp
	push	rax
	lea	rax,[rsi+16+4]
	call	convert_float_32	
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+16+0]
	call	convert_float_32	
	pop	rax
	ret

post_disasm_action_proc_D:
; xmm_128_hexa
	push	rax
	mov	rax,qword [rsi+16+8]
	call	hexa_64_rax
	lea	rdi,[rdi+16]
	mov	rax,qword [rsi+16+0]
	mov	byte [rdi+16],0
	call	hexa_64_rax
	pop	rax
	ret

post_disasm_action_proc_E:
; xmm_128_dp
	push	rax
	lea	rax,[rsi+16+8*1]
	call	convert_float_64
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+16+8*0]
	call	convert_float_64
	pop	rax
	ret

post_disasm_action_proc_F:
; xmm_128_sp
	push	rax
	lea	rax,[rsi+16+(4*3)]
	call	convert_float_32
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+16+(4*2)]
	call	convert_float_32
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+16+(4*1)]
	call	convert_float_32
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+16+(4*0)]
	call	convert_float_32
	pop	rax
	ret

post_disasm_action_proc_G:
; 2 signed dwords for cvtpi2ps instruction
	push	rax
	movsxd	rax,dword [rsi+16+4*1]
	call	qword_signed_decimal_ascii
	mov	byte [rdi],' '
	inc	rdi
	movsxd	rax,dword [rsi+16+4*0]
	call	qword_signed_decimal_ascii
	pop	rax
	ret

post_disasm_action_proc_H:
; 4 signed dwords for cvtdq2ps instruction
	push	rax
	movsxd	rax,dword [rsi+16+4*3]
	call	qword_signed_decimal_ascii
	mov	byte [rdi],' '
	inc	rdi
	movsxd	rax,dword [rsi+16+4*2]
	call	qword_signed_decimal_ascii
	mov	byte [rdi],' '
	inc	rdi
	movsxd	rax,dword [rsi+16+4*1]
	call	qword_signed_decimal_ascii
	mov	byte [rdi],' '
	inc	rdi
	movsxd	rax,dword [rsi+16+4*0]
	call	qword_signed_decimal_ascii
	pop	rax
	ret

post_disasm_action_proc_I:
; address
	push	rax
	lea	rdx,[rdi]
	mov	rax,qword [rsi]
; rax=address
	mov	ecx,dword [last_PID]
	call	address2symbol
	jnc	post_disasm_action_proc_F_end
	call	address2ms_symbol
post_disasm_action_proc_F_end:
	mov	al,byte [rdx-3]
	mov	cl,0
	cmovc	eax,ecx
	mov	byte [rdx-3],al		; change ' ; ' to 0,'; ' if we didn't find any symbol
	pop	rax
	ret


align 10h
post_disasm_cond_jump_proc_JO:
; OF=1 (bit 11)
	bt	ecx,11
	cmc
	ret

align 10h
post_disasm_cond_jump_proc_JNO:
; OF=0 (bit 11)
	bt	ecx,11
	ret

align 10h
post_disasm_cond_jump_proc_JC:
; CF=1 (bit 0)
	shr	cl,1
	cmc
	ret

align 10h
post_disasm_cond_jump_proc_JNC:
; CF=0
	shr	cl,1
	ret

align 10h
post_disasm_cond_jump_proc_JZ:
; ZF=1 (bit 6)
	bt	ecx,6
	cmc
	ret

align 10h
post_disasm_cond_jump_proc_JNZ:
; ZF=0 (bit 6)
	bt	ecx,6
	ret

align 10h
post_disasm_cond_jump_proc_JBE:
; CF=1 or ZF=1 (bits 0, 6)
; CF or ZF = 1
	and	cl,(1 shl 0) + (1 shl 6)
	sub	cl,1
	ret

align 10h
post_disasm_cond_jump_proc_JNBE:
; CF=0 and ZF=0 (bits 0, 6)
; CF or ZF = 0
	and	cl,(1 shl 0) + (1 shl 6)
	add	cl,0FFh
	ret

align 10h
post_disasm_cond_jump_proc_JS:
; SF=1 (bit 7)
;	bt	ecx,7
;	cmc
	shl	cl,1
	cmc
	ret

align 10h
post_disasm_cond_jump_proc_JNS:
; SF=0 (bit 7)
;	bt	ecx,7
	shl	cl,1
	ret

align 10h
post_disasm_cond_jump_proc_JP:
; PF=1 (bit 2)
	bt	ecx,2
	cmc
	ret

align 10h
post_disasm_cond_jump_proc_JNP:
; PF=0 (bit 2)
	bt	ecx,2
	ret

align 10h
post_disasm_cond_jump_proc_JL:
; SF<>OF (bits 7, 11)
; SF xor OF = 1
;;	test	cl,1 shl 7
;;	setz	al
;;	test	ch,1 shl (11-8)
;;	setz	ah
;;	xor	al,ah
;;	sub	al,1
;	shr	cl,7
;	test	ch,1 shl (11-8)
;	setz	al
;	xor	al,cl
;	sub	al,1
; the smallest possible:
	and	cx,0000100010000000b
;		       O   S
	shr	cl,4
	xor	cl,ch
	sub	cl,1
	ret

align 10h
post_disasm_cond_jump_proc_JNL:
; SF=OF (bits 7, 11)
; SF xor OF = 0
;;	test	cl,1 shl 7
;;	setz	al
;;	test	ch,1 shl (11-8)
;;	setz	ah
;;	xor	al,ah
;;	add	al,0FFh
;	shr	cl,7
;	test	ch,1 shl (11-8)
;	setz	al
;	xor	al,cl
;	add	al,0FFh
; the smallest possible:
	and	cx,0000100010000000b
;		       O   S
	shr	cl,4
	xor	cl,ch
	add	cl,0FFh
	ret

align 10h
post_disasm_cond_jump_proc_JLE:
; ZF=1 or SF<>OF (bits 6, 7, 11)
; (SF xor OF) or ZF = 1
;;	test	cl,1 shl 7
;;	setz	al
;;	test	ch,1 shl (11-8)
;;	setz	ah
;;	xor	al,ah
;;	and	cl,1 shl 6
;;	or	al,cl
;;	sub	al,1
;	shr	cl,6
;	test	ch,1 shl (11-8)
;	setz	al
;	xor	al,cl
;	sub	al,1
; the smallest possible:
	and	cx,0000100011000000b
;		       O   SZ
	shr	cl,4
	xor	cl,ch
	sub	cl,1
	ret

align 10h
post_disasm_cond_jump_proc_JNLE:
; ZF=0 and SF=OF (bits 6, 7, 11)
; (SF xor OF) or ZF = 0
;	test	cl,1 shl 7
;	setz	al
;	test	ch,1 shl (11-8)
;	setz	ah
;	xor	al,ah
;	and	cl,1 shl 6
;	or	al,cl
;	add	al,0FFh
; the smallest possible:
	and	cx,0000100011000000b
;		       O   SZ
	shr	cl,4
	xor	cl,ch
	add	cl,0FFh
	ret


align 16
update_data_SysListView32:
; input: RCX handle of SysListView32
;	 RAX start address
;	 EDX process Id
;        R8B type of data to show: data_column_type_qword, data_column_type_dword, data_column_type_word, data_column_type_byte, (todo: data_column_type_reversed)
	cmp	byte [WeAreDebugging],0
	jz	update_data_SysListView32_ret

	push	rax rcx rdx rbx rbp rsi rdi r8 r15
a	=	9			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	(16/8) + 2		; 1st column - address
f	=	12			; 2nd...Xth column - hexa data
g	=	(16/8) + 2		; Yth column - ascii data
h	=	(16*MaxLinesInSysListView32)/8	+2; every line displays 16 bytes of data, +2 for appending 2 zeroed extra qwords after data
i	=	(a+b+d+e+f+g+h+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f+g+h+i)

	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_DELETEALLITEMS
;	mov	rcx,rcx
	call	qword [SendMessageA]

; zero terminator
	and	byte [rsp+8*(b+d)+16],0		; address column

	mov	qword [lvitem.mask],LVIF_TEXT	; qword = mask (dword) + zeroing iItem (dword)
; now we don't need to do mov [lvitem.iItem],0
; this is for SysListView32 without WS_VSCROLL style (which hasn't vertical scroll bar)
;	mov	ebx,MaxLinesInSysListView32*16

; this is for SysListView32 with WS_VSCROLL style
	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_GETCOUNTPERPAGE
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]
	mov	ebx,MaxLinesInSysListView32
	cmp	eax,ebx
	cmovc	ebx,eax
	shl	ebx,4			; *16 every line displays 16 bytes of datas
	jz	update_data_ListView_epilogue
	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+i+6)]	; process Id
	lea	rdi,[rsp+8*(b+d+e+f+g)]	; buffer for debuggee data
	lea	rsi,[rsp+8*(b+d+e+f+g+h+i+8)]	; point to rax = start address
	call	available_debuggee_memory
	cmp	rax,rbx
	cmovc	rbx,rax			; decrement the size of bytes to read if there is less bytes than requested size
	or	rbx,rbx
	stc
	jz	update_data_SysListView32_after_reading_debuggee_memory
	call	read_debuggee_memory
update_data_SysListView32_after_reading_debuggee_memory:
;	jc	update_data_ListView_epilogue
; no no, if read memory failed, we will display ????????????????
	jc	update_data_ListView_nothing

	mov	rsi,rdi
	pxor	xmm0,xmm0
	movdqu	[rdi+rbx*1],xmm0	; put 2 zeroed extra qwords after the end of read data

; zero terminator
	and	byte [rsp+8*(b+d+e+f)+16],0	; ascii column

	mov	rbp,qword [rsp+8*(b+d+e+f+g+h+i+8)]	; start address

AMDPad16
update_data_ListView_L0:

; hexa address
	mov	rax,rbp
	lea	rdi,[rsp+8*(b+d)]
	call	hexa_64_rax

; hexa data
	mov	rax,qword [rsi]		; grab 8 bytes of data
	lea	rdi,[rsp+8*(b+d+e+f-4)]
	call	hexa_64_rax_nobswap
	mov	rax,qword [rsi+8]	; grab next 8 bytes of data
	lea	rdi,[rsp+8*(b+d+e+f-2)]
	call	hexa_64_rax_nobswap

; ascii
	lea	rdi,[rsp+8*(b+d+e+f)]
	mov	cl,'.'			; we replace ascii bytes 00-0F by dot "."
	cld

	  repeat 16
	lodsb
	cmp	al,10h
	cmovc	eax,ecx
	stosb
	  end repeat

; hexa data
	movzx	eax,byte [rsp+8*(b+d+e+f+g+h+i+1)]	; r8b input param of procedure
	and	al,not data_column_type_reversed	; remove reverse flag
	mov	ecx,data_column_type_byte
	xor	edx,edx
	sub	ecx,eax
	lea	rdi,[rsp+8*(b+d+e)]	; destination
	lea	eax,[rdx+16]		; process 16 bytes for 1 line of displayed data
	bts	edx,ecx
	lea	rcx,[rdi+8*8]		; source = rsp+8*(b+d+e+f-4)

AMDPad16
update_data_ListView_unpack_ascii:
	movdqu	xmm0,dqword [rcx]
	movdqu	dqword [rdi],xmm0
	lea	rcx,[rcx+rdx*2]
	lea	rdi,[rdi+rdx*2+1]
	mov	byte [rdi-1],ah		; 0-terminator
	sub	al,dl
	jnz	update_data_ListView_unpack_ascii

; put result into SysListView32
; column 0, address
	lea	rax,[rsp+8*(b+d)]
	and	[lvitem.iSubItem],0
	mov	[lvitem.pszText],rax
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

	xor	edi,edi
	lea	r15d,[rdi+16]		; process 16 bytes for 1 line of displayed data

AMDPad16
update_data_ListView_whole_data_of_1_line:
; column 1, first qword/dword/word/byte of data
	movzx	ecx,byte [rsp+8*(b+d+e+f+g+h+i+1)]	; r8b input param of procedure
	and	cl,not data_column_type_reversed
	mov	edx,8*2
	shr	edx,cl
	sub	rax,rdx
	lea	rax,[rsp+8*(b+d+e) + rdi]
	inc	dword [lvitem.iSubItem]
	mov	[lvitem.pszText],rax
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

	movzx	eax,byte [rsp+8*(b+d+e+f+g+h+i+1)]	; r8b input param of procedure
	and	al,not data_column_type_reversed
	mov	ecx,data_column_type_byte
	sub	ecx,eax
	xor	edx,edx
	bts	edx,ecx

	lea	rdi,[rdi+rdx*2 + 1]
	sub	r15d,edx
	jnz	update_data_ListView_whole_data_of_1_line

; column X, ascii 16 bytes of data
	lea	rax,[rsp+8*(b+d+e+f)]
	inc	dword [lvitem.iSubItem]
	mov	[lvitem.pszText],rax
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

	add	rbp,16
	inc	[lvitem.iItem]
	sub	ebx,16
	jnbe	update_data_ListView_L0

update_data_ListView_epilogue:
	add	rsp,8*(b+d+e+f+g+h+i)
	pop	r15 r8 rdi rsi rbp rbx rdx rcx rax
update_data_SysListView32_ret:
	ret

update_data_ListView_nothing:
; hexa address
	mov	rax,qword [rsp+8*(b+d+e+f+g+h+i+8)]	; start address
	lea	rdi,[rsp+8*(b+d)]
	call	hexa_64_rax

	and	[lvitem.iSubItem],0
	mov	[lvitem.pszText],rdi
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

; hexa data
	mov	word [rdi],'?'
	inc	dword [lvitem.iSubItem]
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+i+7)]	; handle of SysListView32
	call	qword [SendMessageA]

	jmp	update_data_ListView_epilogue


align 16
update_stack_SysListView32:
; input: RCX handle of SysListView32
;	 RAX start address
;	 EDX process Id
	cmp	byte [WeAreDebugging],0
	jz	update_stack_SysListView32_ret

	push	rax rcx rdx rbx rbp rsi rdi
a	=	7			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	(16/8) + 2		; 1st column - address
f	=	(16/8) + 2		; 2nd column - hexa data
g	=	(8*MaxLinesInSysListView32)/8 +1	; every line displays 8 bytes of data, +1 for appending 1 zeroed extra qword after data
h	=	(a+b+d+e+f+g+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f+g+h)

	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_DELETEALLITEMS
;	mov	rcx,rcx
	call	qword [SendMessageA]

; zero terminator
	and	byte [rsp+8*(b+d)+16],0		; address column

	mov	qword [lvitem.mask],LVIF_TEXT	; qword = mask (dword) + zeroing iItem (dword)
; now we don't need to do mov [lvitem.iItem],0
; this is for SysListView32 without WS_VSCROLL style (which hasn't vertical scroll bar)
;	mov	ebx,MaxLinesInSysListView32*8

; this is for SysListView32 with WS_VSCROLL style
	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_GETCOUNTPERPAGE
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+5)]	; handle of SysListView32
	call	qword [SendMessageA]
	mov	ebx,MaxLinesInSysListView32
	cmp	eax,ebx
	cmovc	ebx,eax
	shl	ebx,3			; *8 every line displays 8 bytes of datas
	jz	update_stack_ListView_epilogue
	mov	ecx,dword [rsp+8*(b+d+e+f+g+h+4)]	; process Id
	lea	rdi,[rsp+8*(b+d+e+f)]	; buffer for debuggee stack
	lea	rsi,[rsp+8*(b+d+e+f+g+h+6)]	; point to rax = start address
	call	available_debuggee_memory
	cmp	rax,rbx
	cmovc	rbx,rax			; decrement the size of bytes to read if there is less bytes than requested size
	or	rbx,rbx
	stc
	jz	update_stack_SysListView32_after_reading_debuggee_memory
	call	read_debuggee_memory
update_stack_SysListView32_after_reading_debuggee_memory:
;	jc	update_stack_ListView_epilogue
; no no, if read memory failed, we will display ????????????????
	jc	update_stack_ListView_nothing

	mov	rsi,rdi
	and	qword [rdi+rbx*1],0	; put 1 zeroed extra qword after the end of read data

; zero terminator
	and	byte [rsp+8*(b+d+e)+16],0

	mov	rbp,qword [rsp+8*(b+d+e+f+g+h+6)]	; start address

AMDPad16
update_stack_ListView_L0:

; hexa address
	mov	rax,rbp
	lea	rdi,[rsp+8*(b+d)]
	call	hexa_64_rax

; hexa stack data
	mov	rax,qword [rsi]		; grab 8 bytes of stack data
	lea	rdi,[rsp+8*(b+d+e)]
	call	hexa_64_rax

; put result into SysListView32
; column 0, address
	lea	rax,[rsp+8*(b+d)]
	and	[lvitem.iSubItem],0
	mov	[lvitem.pszText],rax
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+5)]	; handle of SysListView32
	call	qword [SendMessageA]

; column 1, first 8 bytes of stack data
	lea	rax,[rsp+8*(b+d+e)]
	inc	dword [lvitem.iSubItem]
	mov	[lvitem.pszText],rax
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+5)]	; handle of SysListView32
	call	qword [SendMessageA]

	add	rbp,8
	add	rsi,8
	inc	[lvitem.iItem]
	sub	ebx,8
	jnbe	update_stack_ListView_L0

update_stack_ListView_epilogue:
	add	rsp,8*(b+d+e+f+g+h)
	pop	rdi rsi rbp rbx rdx rcx rax
update_stack_SysListView32_ret:
	ret

update_stack_ListView_nothing:
	mov	rax,qword [rsp+8*(b+d+e+f+g+h+6)]	; start address
	lea	rdi,[rsp+8*(b+d)]
	call	hexa_64_rax

	and	[lvitem.iSubItem],0
	mov	[lvitem.pszText],rdi
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+5)]	; handle of SysListView32
	call	qword [SendMessageA]

; stack data
	mov	word [rdi],'?'
	inc	dword [lvitem.iSubItem]
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [rsp+8*(b+d+e+f+g+h+5)]	; handle of SysListView32
	call	qword [SendMessageA]

	jmp	update_stack_ListView_epilogue


align 16
update_registers_SysListView32s:
	cmp	byte [WeAreDebugging],0
	jz	update_registers_SysListView32s_ret

; input: ThreadContext
	push	rax			; align stack at dqword
					; we won't use APIs here, only in subroutines
	cmp	[face.childwiconized+6],0
	jnz	update_GPR_SysListView32_done
	call	update_GPR_SysListView32
update_GPR_SysListView32_done:

	cmp	[face.childwiconized+7],0
	jnz	update_IP_SysListView32_done
	call	update_IP_SysListView32
update_IP_SysListView32_done:

	cmp	[face.childwiconized+8],0
	jnz	update_XMM_SysListView32_done
	call	update_XMM_SysListView32
update_XMM_SysListView32_done:

	cmp	[face.childwiconized+9],0
	jnz	update_STMM_SysListView32_done
	call	update_STMM_SysListView32
update_STMM_SysListView32_done:

	cmp	[face.childwiconized+10],0
	jnz	update_Flags_SysListView32_done
	call	update_Flags_SysListView32
update_Flags_SysListView32_done:

	cmp	[face.childwiconized+11],0
	jnz	update_SegmentRegs_SysListView32_done
	call	update_SegmentRegs_SysListView32
update_SegmentRegs_SysListView32_done:

	cmp	[face.childwiconized+12],0
	jnz	update_DebugRegs_SysListView32_done
	call	update_DebugRegs_SysListView32
update_DebugRegs_SysListView32_done:

	cmp	[face.childwiconized+13],0
	jnz	update_FloatingControl_SysListView32_done
	call	update_FloatingControl_SysListView32
update_FloatingControl_SysListView32_done:

	pop	rax
update_registers_SysListView32s_ret:
	ret

align 16
update_GPR_SysListView32:
	cmp	byte [WeAreDebugging],0
	jz	update_GPR_SysListView32_ret

	push	rbx rsi rdi
a	=	3			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	3			; 16 bytes for 64-bit ascii value, 1 byte for 0-terminator
f	=	(a+b+d+e+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f)

	lea	rsi,[ThreadContext.Rax]
	lea	rdi,[rsp+8*(b+d)]
	xor	ebx,ebx			; counter, we have 16 GPRs
	mov	[lvitem.mask],LVIF_TEXT
	mov	[lvitem.iSubItem],1	; update subitems 1
	mov	[lvitem.pszText],rdi
	mov	byte [rdi+16],bl	; prepare 0-terminator

AMDPad16
update_GPR_SysListView32_L0:
	lea	rcx,[GPR_order]		; we are displaying them in order rax rbx rcx rdx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
					; but they are in Context in order rax rcx rdx rbx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
	movzx	edx,byte [rcx+rbx*1]
	mov	rax,qword [rsi+rdx*8]
	call	hexa_64_rax

	mov	[lvitem.iItem],ebx	; update item

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*6]	; GPR SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,16			; 16 GPRS
	jc	update_GPR_SysListView32_L0		

	add	rsp,8*(b+d+e+f)
	pop	rdi rsi rbx
update_GPR_SysListView32_ret:
	ret

align 16
update_IP_SysListView32:
	cmp	byte [WeAreDebugging],0
	jz	update_IP_SysListView32_ret

	push	rdi
a	=	1			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	3			; 16 bytes for 64-bit ascii value, 1 byte for 0-terminator
f	=	(a+b+d+e+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f)
	mov	rax,qword [ThreadContext.Rip]
	lea	rdi,[rsp+8*(b+d)]
	call	hexa_64_rax
	mov	byte [rdi+16],0		; 0-terminator
	mov	qword [lvitem.mask],LVIF_TEXT	; mask LVIF_TEXT, item 0
	mov	[lvitem.iSubItem],1	; subitem 1
	mov	[lvitem.pszText],rdi
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*7]	; RIP SysListView32 handle
	call	qword [SendMessageA]
	add	rsp,8*(b+d+e+f)
	pop	rdi
update_IP_SysListView32_ret:
	ret

align 16
update_XMM_SysListView32:
	cmp	byte [WeAreDebugging],0
	jz	update_XMM_SysListView32_ret

	push	rax rcx rdx rbx rbp rsi rdi r8 r9 r10 r11 r14 r15
a	=	13			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8 		; stack frame in qwords
e	=	33			; 8*9 aren't enough bytes for buffer, XMM single precision needs the most, 71 chars + 0-terminator
f	=	(a+b+d+e+1) and 1	; align stack 16

	sub	rsp,8*(b+d+e+f)

	lea	rdi,[rsp+8*(b+d)]
	mov	[lvitem.mask],LVIF_TEXT
;       mov     dword [lvitem.iSubItem],1       ; update subitems 1
	mov	[lvitem.pszText],rdi
	xor	ebx,ebx 		; counter, we have 16 xmm regs
	lea	rsi,[ThreadContext.FltSave.XmmRegisters]

	mov	r15,[pointer_to_AVX]

;       cmp     byte [face.show_XMM],show_XMM_128hexa
;       jz      update_XMM_SysListView32_hexa
;       cmp     byte [face.show_XMM],show_XMM_double_precision
;       jz      update_XMM_SysListView32_double_precision
;       cmp     byte [face.show_XMM],show_XMM_single_precision
;       jz      update_XMM_SysListView32_single_precision
;
;       stc
;update_XMM_SysListView32_epi:
;       lea     rsp,[rsp+8*(b+d+e+f)]
;       pop     r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx rax
;update_XMM_SysListView32_ret:
;       ret
;
;align 16
;update_XMM_SysListView32_hexa:

update_XMM_SysListView32_L0:
	lea	ebp,[rbx+rbx]		; rbx * 2
	mov	[lvitem.iItem],ebx

	mov	dword [lvitem.iSubItem],1	; update subitem 1
	lea	rdi,[rsp+8*(b+d)]

	cmp	byte[AVX_enabled],0
	je	@f
	test	r15,r15
	je	@f
	mov	rax,qword [r15+rbp*8+8] ; rsi + rbx*16 + 8
	call	hexa_64_rax
	mov	rax,qword [r15+rbp*8]
	add	rdi,16
	call	hexa_64_rax
	add	rdi,16
@@:
	mov	rax,qword [rsi+rbp*8+8] ; rsi + rbx*16 + 8
	call	hexa_64_rax
	mov	rax,qword [rsi+rbp*8]
	add	rdi,16
	call	hexa_64_rax
	mov	byte [rdi+16],0 	; 0-terminator

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*8]
	call	qword [SendMessageA]

;       inc     ebx
;       cmp     bl,16
;       jc      update_XMM_SysListView32_hexa
;
;;      clc                             ; not necessary, above loop clears Carry Flag
;       jmp     update_XMM_SysListView32_epi
;
;align 16
;update_XMM_SysListView32_double_precision:
	mov	dword [lvitem.iSubItem],2	; update subitem 2
	lea	rdi,[rsp+8*(b+d)]
	
	cmp	byte[AVX_enabled],0
	je	@f
	test	r15,r15
	je	@f
	lea	rax,[r15+rbp*8+8]
	call	convert_float_64	; display high
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[r15+rbp*8]
	call	convert_float_64	; display low
	mov	byte [rdi],' '
	inc	rdi	
@@:
	lea	rax,[rsi+rbp*8+8]
	call	convert_float_64	; display high
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+rbp*8]
	call	convert_float_64	; display low
	mov	byte [rdi],0

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*8]
	call	qword [SendMessageA]

;       inc     ebx
;       cmp     bl,16
;       jc      update_XMM_SysListView32_double_precision
;;      clc                             ; not necessary, above loop clears Carry Flag
;       jmp     update_XMM_SysListView32_epi
;
;align 16
;update_XMM_SysListView32_single_precision:
	mov	dword [lvitem.iSubItem],3	; update subitem 3
	lea	rdi,[rsp+8*(b+d)]

	cmp	byte[AVX_enabled],0
	je	@f
	test	r15,r15
	je	@f	
	lea	rax,[r15+rbp*8+4*3]
	call	convert_float_32		; display high
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[r15+rbp*8+4*2]
	call	convert_float_32		; display middle high
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[r15+rbp*8+4*1]
	call	convert_float_32		; display middle low
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[r15+rbp*8+4*0]
	call	convert_float_32		; display low
	mov	byte [rdi],' '	
	inc	rdi	
@@:
	lea	rax,[rsi+rbp*8+4*3]
	call	convert_float_32		; display high
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+rbp*8+4*2]
	call	convert_float_32		; display middle high
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+rbp*8+4*1]
	call	convert_float_32		; display middle low
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+rbp*8+4*0]
	call	convert_float_32		; display low
	mov	byte [rdi],0

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*8]
	call	qword [SendMessageA]

	inc	ebx
	cmp	bl,16
;       jc      update_XMM_SysListView32_single_precision
;;      clc                             ; not necessary, above loop clears Carry Flag
;       jmp     update_XMM_SysListView32_epi

	jc	update_XMM_SysListView32_L0
;       clc                             ; not necessary, above loop clears Carry Flag
update_XMM_SysListView32_epi:
	lea	rsp,[rsp+8*(b+d+e+f)]
	pop	r15 r14 r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx rax
update_XMM_SysListView32_ret:
	ret


align 16
update_STMM_SysListView32:
	cmp	byte [WeAreDebugging],0
	jz	update_STMM_SysListView32_ret

	push	rax rcx rdx rbx rbp rsi rdi r8 r9 r10 r11
	sub	rsp,8*(b+d+e+f)

	lea	rdi,[rsp+8*(b+d)]
	mov	[lvitem.mask],LVIF_TEXT
	mov	[lvitem.pszText],rdi
	xor	ebx,ebx			; counter, we have 8 st/mm regs
	lea	rsi,[ThreadContext.FltSave]

update_STMM_SysListView32_L0:
	lea	ebp,[rbx+rbx]		; rbx * 2
	mov	[lvitem.iItem],ebx

	mov	dword [lvitem.iSubItem],1	; update subitem 1
	lea	rdi,[rsp+8*(b+d)]

; get the stack top number
	mov	cl,byte [rsi+3]		; get the high byte of the status word
	and	cl,00111000b		; mask out stack
	shr	cl,3			; adjust

	mov	al,byte [rsi+4]		; get the tag byte
	ror	al,cl			; adjust so first tag is in low bit

	bt	eax,ebx
	jc	update_STMM_SysListView32_ST_80_convert_floating_floating

align 16
update_STMM_SysListView32_ST_80_convert_floating_empty:
;	cld				; not necessary for only 1 qword
	mov	rax,'Empty'
	stosq
	jmp	update_STMM_SysListView32_ST_80_L0

align 16
update_STMM_SysListView32_ST_80_convert_floating_floating:
; load value
	lea	rax,[rsi+20h + rbp*8]
	call	convert_float_80
	mov	byte [rdi],0

AMDPad16
update_STMM_SysListView32_ST_80_L0:
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*9]
	call	qword [SendMessageA]

	mov	dword [lvitem.iSubItem],2	; update subitem 2
	lea	rdi,[rsp+8*(b+d)]

	mov	rax,[rsi+20h + rbp*8]		; 20h Header size
	call	hexa_64_rax
	mov	byte [rdi+16],0

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*9]
	call	qword [SendMessageA]

	mov	dword [lvitem.iSubItem],3	; update subitem 3
	lea	rdi,[rsp+8*(b+d)]

	lea	rax,[rsi+20h + rbp*8 + 4]
	call	convert_float_32		; display high
	mov	byte [rdi],' '
	inc	rdi
	lea	rax,[rsi+20h + rbp*8 + 0]
	call	convert_float_32		; display low
	mov	byte [rdi],0

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*9]
	call	qword [SendMessageA]

	inc	ebx
	cmp	bl,8

	jc	update_STMM_SysListView32_L0
;	clc				; not necessary, above loop clears Carry Flag
update_STMM_SysListView32_epi:
	lea	rsp,[rsp+8*(b+d+e+f)]	; this doesn't touch carry flag
	pop	r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx rax
update_STMM_SysListView32_ret:
	ret

align 16
update_Flags_SysListView32:
	cmp	byte [WeAreDebugging],0
	jz	update_Flags_SysListView32_ret

	push	rbx rbp rdi
a	=	3			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	2			; 2 qwords are enough for 1 byte for 1-bit ascii value + 1 byte for 0-terminator
					; as well for 32-bit hexa
f	=	(a+b+d+e+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f)

	xor	ebx,ebx
	lea	rdi,[rsp+8*(b+d)]
	mov	ebp,dword [ThreadContext.EFlags]
	mov	byte [rdi+1],bl		; 0-terminator
	mov	dword [lvitem.mask],LVIF_TEXT	; mask LVIF_TEXT
	mov	[lvitem.iSubItem],1	; subitem 1
	mov	[lvitem.pszText],rdi

update_Flags_SysListView32_L0:
	lea	rdx,[flag_bits]
	movzx	ecx,byte [rdx+rbx*1]
	mov	al,'0'
	bt	ebp,ecx
	adc	al,0
	mov	byte [rdi],al

	mov	[lvitem.iItem],ebx

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*10]	; EFlags SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx
	cmp	bl,7			; we display 7 flags
	jc	update_Flags_SysListView32_L0

	xchg	ebp,eax
	call	hexa_32_eax
	mov	byte [rdi+8],0
	mov	[lvitem.iItem],ebx
	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*10]	; EFlags SysListView32 handle
	call	qword [SendMessageA]

update_Flags_SysListView32_ret:
	add	rsp,8*(b+d+e+f)
	pop	rdi rbp rbx
	ret

align 16
update_SegmentRegs_SysListView32:
	cmp	byte [WeAreDebugging],0
	jz	update_SegmentRegs_SysListView32_ret

	push	rbx rsi rdi
a	=	3			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	1			; 2 qwords enough for 8 ascii bytes + 1 zero-terminator
f	=	(a+b+d+e+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f)

	lea	rsi,qword [ThreadContext.SegCs]
	lea	rdi,[rsp+8*(b+d)]
	xor	ebx,ebx			; counter
	lea	rax,[rsp+8*(b+d)+4]
	mov	dword [lvitem.mask],LVIF_TEXT	; mask LVIF_TEXT
	mov	[lvitem.iSubItem],1	; subitem 1
	mov	[lvitem.pszText],rax
	mov	byte [rax+4],bl		; 0-terminator

update_SegmentRegs_SysListView32_L0:
	mov	ax,word [rsi+rbx*2]
	call	hexa_32_eax		; we really need only low word of dword

	mov	[lvitem.iItem],ebx

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*11]	; Segment registers SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx
	cmp	bl,6
	jc	update_SegmentRegs_SysListView32_L0

update_SegmentRegs_SysListView32_ret:
	add	rsp,8*(b+d+e+f)
	pop	rdi rsi rbx
	ret

align 16
update_DebugRegs_SysListView32:
	cmp	byte [WeAreDebugging],0
	jz	update_DebugRegs_SysListView32_ret

	push	rbx rsi rdi
a	=	3			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	3			; 16 bytes for 64-bit ascii value, 1 byte for 0-terminator
f	=	(a+b+d+e+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f)

	lea	rsi,[ThreadContext.Dr0]
	lea	rdi,[rsp+8*(b+d)]
	xor	ebx,ebx			; counter, we have 16 GPRs
	mov	[lvitem.mask],LVIF_TEXT
	mov	[lvitem.iSubItem],1	; update subitems 1
	mov	[lvitem.pszText],rdi
	mov	byte [rdi+16],bl	; prepare 0-terminator

AMDPad16
update_DebugRegs_SysListView32_L0:
	mov	rax,qword [rsi+rbx*8]
	call	hexa_64_rax

	mov	[lvitem.iItem],ebx	; update item

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*12]	; Debug registers SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,6			; 6 DebugRegs
	jc	update_DebugRegs_SysListView32_L0		

	add	rsp,8*(b+d+e+f)
	pop	rdi rsi rbx
update_DebugRegs_SysListView32_ret:
	ret

align 16
update_FloatingControl_SysListView32:
	cmp	byte [WeAreDebugging],0
	jz	update_DebugRegs_SysListView32_ret

	push	rdi
a	=	1			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8			; stack frame in qwords
e	=	2			; 8 bytes for 32-bit ascii value, 1 byte for 0-terminator
f	=	(a+b+d+e+1) and 1	; align stack 16
	sub	rsp,8*(b+d+e+f)

	lea	rdi,[rsp+8*(b+d)]
	mov	qword [lvitem.mask],LVIF_TEXT	; mask=LVIF_TEXT , iItem=0
	mov	[lvitem.iSubItem],1	; update subitems 1
	mov	[lvitem.pszText],rdi

; ControlWord
;	mov	ax,[ThreadContext.FltSave.ControlWord]
;	shl	eax,16
	mov	eax,dword [ThreadContext.FltSave.ControlWord - 2]	; we need Control Word on high word of eax
	call	hexa_32_eax
	mov	byte [rdi+4],0

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*13]	; FPU Control registers SysListView32 handle
	call	qword [SendMessageA]

	inc	[lvitem.iItem]		; increase iItem = next line

; StatusWord
	mov	eax,dword [ThreadContext.FltSave.StatusWord - 2]
	call	hexa_32_eax
	mov	byte [rdi+4],0

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*13]
	call	qword [SendMessageA]

	inc	[lvitem.iItem]

; TagByte, only low BYTE is used on AMD64 platform, but the name TagWord have stayed...
	mov	eax,dword [ThreadContext.FltSave.TagWord - 3]
	call	hexa_32_eax
	mov	byte [rdi+2],0

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*13]
	call	qword [SendMessageA]

	inc	[lvitem.iItem]

; MxCsr
	mov	eax,[ThreadContext.FltSave.MxCsr]
	call	hexa_32_eax
	mov	byte [rdi+8],0

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*13]
	call	qword [SendMessageA]

	inc	[lvitem.iItem]

; MxCsr_Mask
	mov	eax,[ThreadContext.FltSave.MxCsr_Mask]
	call	hexa_32_eax
;	mov	byte [rdi+8],0		; 0 is there from the time of displaying MxCsr

	lea	r9,[lvitem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,qword [hChildren+8*13]
	call	qword [SendMessageA]

	add	rsp,8*(b+d+e+f)
	pop	rdi
update_FloatingControl_SysListView32_ret:
	ret

;align 16
;update_XMM_STMM_column_names:
;	push	rcx rdx r8 r9
;a=1	; return address
;b=4	; number of pushed registers
;d=(sizeof.LV_COLUMN64+7)/8
;e=4	; number of qwords reserved for API
;c=(a+b+d+e) and 1	; alignment at dqword
;	sub	rsp,8*(e+d+c)
;
;virtual at rsp+8*e
;lv_col_upd	LV_COLUMN64
;end virtual
;
;	mov	[lv_col_upd.mask],LVCF_TEXT
;
;	movzx	ecx,byte [face.show_XMM]
;	lea	rdx,[addr_XMM_col_name]
;	mov	rax,qword [rdx+rcx*8]
;	mov	[lv_col_upd.pszText],rax
;
;	lea	r9,[lv_col_upd]
;	mov	r8d,1				; iCol
;	mov	edx,LVM_SETCOLUMN
;	mov	rcx,qword [hListView + 8*8]
;	call	qword [SendMessageA]
;
;	movzx	ecx,byte [face.show_STMM]
;	lea	rdx,[addr_STMM_col_name]
;	mov	rax,qword [rdx+rcx*8]
;	mov	[lv_col_upd.pszText],rax
;
;	lea	r9,[lv_col_upd]
;	mov	r8d,1				; iCol
;	mov	edx,LVM_SETCOLUMN
;	mov	rcx,qword [hListView + 8*9]
;	call	qword [SendMessageA]
;
;	add	rsp,8*(e+d+c)
;	pop	r9 r8 rdx rcx
;	ret

select_iItem:
; in:	EDX	index of SysListView32
;	R9	mouse position in client window received in WM_LBUTTONDOWN WM_RBUTTONDOWN

	cmp	edx,num_of_LV_supporting_proc_List_KEYDOWN
	jnc	select_iItem_ret		; jnc because index is zero based (not jnbe)

a	=	1				; return addres from procedure (1 qword of the stack)
	push	rax rcx rdx r8 r9 r10 r11
b	=	7				; number of pushed 64-bit GPR registers (8 qwords of the stack)
; c will be calculated later for align stack at dqword
d	=	(sizeof.LV_ITEM64 + 7) / 8	; number of qwords for LV_ITEM64 structure
e	=	4				; 4 qwords reserved for API
c	=	(e+d+b+a) and 1			; align stack at dqword

virtual at rsp+8*e
select_lvitem	LV_ITEM64
end virtual

	sub	rsp,8*(e+d+c)

; try to destroy List EDIT if any
	cmp	qword [ListView_edit_last_item_and_subitem],rax
	jz	select_iItem_L0
; we don't need to handle clicking on another window, this automatically sends EN_KILLFOCUS
;	cmp	qword [ListView_edit_Listview_index],rdx
;	jnz	select_iItem_L0
;	call	post_WM_COMMAND_EN_KILLFOCUS
	call	ListView_Edit_destroy
select_iItem_L0:

; select iItem
	lea	rax,[hListView]
	mov	rcx,qword [rax+rdx*8]		; grab SysListView32 handle
	call	ListView_get_item_and_subitem
	jc	select_iItem_epi

	or	eax,eax				; destroy upper dword of RAX (iSubItem)
						; and leave only low dword holding iItem
	xor	r9,r9				; empty selection for 64 iItems (64-bits R9)
	lea	r8,[ListView_selected_iItem]
	bts	r9,rax				; set selection
	mov	qword [r8+rdx*8],r9		; save selection
if MaxLinesInSysListView32 > 64
Above code require to rewrite for handle more than 64 MaxLinesInSysListView32
end if
	mov	[select_lvitem.mask],LVIF_STATE
	mov	qword [select_lvitem.iItem],rax	; since upper dword of RAX is zeroed
						; we can put iItem=eax and iSubItem=0
						; in 1 step, because dword for iSubItem
						; follows immediately dword of iItem
	mov	[select_lvitem.state],LVIS_SELECTED
	mov	[select_lvitem.stateMask],LVIS_SELECTED
	lea	r9,[select_lvitem]
	xor	r8,r8	
	mov	edx,LVM_SETITEM
; rcx=hListView now since mov rcx,qword [rax+rdx*8]
; ListView_get_item_and_subitem doesn't destroy RCX
	call	qword [SendMessageA]

select_iItem_epi:
	add	rsp,8*(e+d+c)
	pop	r11 r10 r9 r8 rdx rcx rax
select_iItem_ret:
	ret

align 16
update_selections:
; call this to update selections in code 1st ... stack after selections destroying when LVM_DELETEALLITEMS
; we have stored selections in ListView_selected_iItem
	push	rdx				; align stack at dqword
	mov	edx,num_of_LV_supporting_proc_List_KEYDOWN-1	; -1 for zero based index
AMDPad16
update_selections_L0:
	call	update_selection
	dec	edx
	jns	update_selections_L0
	pop	rdx
	ret

align 16
update_selection:
; in:	EDX=iList, index of the SysListView32
	push	rax rcx rdx r8 r9 r10 r11

	sub	rsp,8*(e+d+c)

	lea	r9,[select_lvitem]
	lea	rcx,[ListView_selected_iItem]
	mov	[r9+LV_ITEM64.mask],LVIF_STATE
	mov	[r9+LV_ITEM64.state],LVIS_SELECTED
	mov	[r9+LV_ITEM64.stateMask],LVIS_SELECTED
	lea	rax,[hListView]
	bsf	r8,qword [rcx+rdx*8]		; iItem, upper dword of R8 is zero
	mov	rcx,qword [rax+rdx*8]		; handle of SysListView32
	mov	edx,LVM_SETITEMSTATE
	call	qword [SendMessageA]

	add	rsp,8*(e+d+c)
	pop	r11 r10 r9 r8 rdx rcx rax
	ret

align 16
proc_List_KEYDOWN:
; in:	EDX	index of SysListView32, we allow only Code 1st,... Stack (0,1,2,3,4,5)
;	R8	wParam as received in WM_KEYDOWN, important for us is R8b holding VM_KEY
;	R9	lParam as received in WM_KEYDOWN, unimportant for us yet

	cmp	edx,num_of_LV_supporting_proc_List_KEYDOWN
	jnc	proc_List_KEYDOWN_ret

	push	rax rcx rdx

proc_List_KEYDOWN_stack_frame	=	10

if sizeof.LV_ITEM64 > (proc_List_KEYDOWN_stack_frame-2)*8	; check whether LV_ITEM64 and 2 extra qwords are reserved in the stack
Increase stack frame in proc_List_KEYDOWN !
end if
	sub	rsp,8*(4+proc_List_KEYDOWN_stack_frame)
	lea	rax,[hListView]
	mov	rcx,qword [rax+rdx*8]		; grab handle of SysListView32
	cmp	r8b,VK_LEFT
	jz	proc_List_KEYDOWN_LEFT
	cmp	r8b,VK_RIGHT
	jz	proc_List_KEYDOWN_RIGHT
	cmp	r8b,VK_UP
	jz	proc_List_KEYDOWN_UP
	cmp	r8b,VK_DOWN
	jz	proc_List_KEYDOWN_DOWN
	cmp	r8b,VK_PGUP
	jz	proc_List_KEYDOWN_PGUP
	cmp	r8b,VK_PGDN
	jz	proc_List_KEYDOWN_PGDN

proc_List_KEYDOWN_epi:
	add	rsp,8*(4+proc_List_KEYDOWN_stack_frame)
	pop	rdx rcx rax
proc_List_KEYDOWN_ret:
	ret

proc_List_KEYDOWN_LEFT:
	lea	rax,[Code_listview_dump_start_address]
	dec	qword [rax+rdx*8]
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
	jmp	proc_List_KEYDOWN_epi

proc_List_KEYDOWN_RIGHT:
	lea	rax,[Code_listview_dump_start_address]
	inc	qword [rax+rdx*8]
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
	jmp	proc_List_KEYDOWN_epi

proc_List_KEYDOWN_UP:
	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_GETCOUNTPERPAGE
	mov	qword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-1)],rcx	; save SysListView32 handle
	call	qword [SendMessageA]
	or	eax,eax				; is SysListView32 so small that it hasn't any visible iItem ?
	jz	proc_List_KEYDOWN_DOWN_end	; it is safe to jump there with rax=0
	dec	eax				; number of iItems counts from 1, but we need 0-based index, so -1

	mov	edx,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame+0)]	; get EDX = iList from the stack
	lea	rcx,[ListView_selected_iItem]
	bsf	r8,qword [rcx+rdx*8]		; get selected iItem
	cmp	r8,rax				; selection after last displayed iItem ?
	cmovnbe	r8,rax				; set selection at most the last displayed iItem
	or	r8,r8				; selected iItem=0 ?
	jnz	proc_List_KEYDOWN_UP_L9		; just decrease selected iItem, nothing more

; scroll content 1 line up
; we do it in this way:
; - for data sub 16 bytes into displayed start
; - for stack sub 8 bytes into displayed start
; - for code:
; 1. get opcode size of instruction ending at address in iItem0
; 2. sub it into start
	cmp	edx,2
	jc	proc_List_KEYDOWN_UP_L0		; code
	mov	rax,-16				; data
	cmp	edx,5
	jc	proc_List_KEYDOWN_DOWN_L8
	mov	al,-8				; stack
	jmp	proc_List_KEYDOWN_DOWN_L8

proc_List_KEYDOWN_UP_L0:
; code
; we are calling painful_reverze, so we prepare everything for this painful operation
; in:	rdx address where to end
;	ecx number of instructions before rdx
;	eax PID
; out:	eax number of bytes to seek back
	lea	rcx,[Code_listview_dump_start_address]
	mov	rdx,qword [rcx+rdx*8]
	mov	ecx,1				; 1 instruction back
	mov	eax,dword [last_PID]
	call	painful_reverze
	jc	proc_List_KEYDOWN_epi
	neg	rax
	jmp	proc_List_KEYDOWN_DOWN_L8

proc_List_KEYDOWN_UP_L9:
; just decrease selected iItem, nothing more...
	dec	r8
	xor	r9,r9
	bts	r9,r8
	mov	qword [rcx+rdx*8],r9
; we can't use this smaller way, because user could select some iItem at the end
; and then decreased SysListView32 vertical size
;	shr	qword [rcx+rdx*8],1

; we needn't to update text content of SysListView32, it is enough to update only this one
; EDX = index of SysListView, input param for next call
	call	update_selection
	jmp	proc_List_KEYDOWN_epi

proc_List_KEYDOWN_DOWN:
	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_GETCOUNTPERPAGE
	mov	qword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-1)],rcx	; save SysListView32 handle
	call	qword [SendMessageA]
	or	eax,eax				; is SysListView32 so small that it hasn't any visible iItem ?
	jz	proc_List_KEYDOWN_DOWN_end	; it is safe to jump there with rax=0
	mov	ecx,MaxLinesInSysListView32
	cmp	ecx,eax
	cmovc	eax,ecx				; truncate count of Items in SysListView32 to MaxLinesInSysListView32
	dec	eax				; number of iItems counts from 1, but we need 0-based index, so -1

	mov	edx,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame+0)]	; get EDX = iList from the stack
	lea	rcx,[ListView_selected_iItem]
	bsf	r8,qword [rcx+rdx*8]		; get selected iItem
	cmp	r8,rax
	jc	proc_List_KEYDOWN_DOWN_L9	; just increase selected iItem, nothing more

; only for sure, user could select iItem at the end and then decreased SysListView32 vertical size
	xor	r8,r8
	bts	r8,rax
	mov	qword [rcx+rdx*8],r8		; update iItem selection

; scroll content 1 line down
; we do it in this way:
; - for data add 16 bytes into displayed start
; - for stack add 8 bytes into displayed start
; - for code:
; 1. read opcode size in iItem0
; 2. add it into start
	cmp	edx,2
	jc	proc_List_KEYDOWN_L0
	mov	eax,16				; data
	cmp	edx,5
	jc	proc_List_KEYDOWN_DOWN_L8
	mov	al,8				; stack
	jmp	proc_List_KEYDOWN_DOWN_L8

proc_List_KEYDOWN_L0:				; code
	lea	r9,[rsp+8*4]
	lea	rdx,[tmp_buf]
	mov	[r9+LV_ITEM64.iSubItem],1	; iSubItem=1 for hexa opcode
	mov	[r9+LV_ITEM64.pszText],rdx
	mov	[r9+LV_ITEM64.cchTextMax],SysListView_cchTextMax
	xor	r8,r8				; iItem=0 for opcode at start position
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,qword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-1)]	; SysListView32 handle
	call	qword [SendMessageA]
	or	rax,rax				; empty ?
	jz	proc_List_KEYDOWN_DOWN_end
	shr	eax,1				; divide by 2 and check if nonparity
	jc	proc_List_KEYDOWN_DOWN_end
; now we have opcode size at displayed start position in eax

proc_List_KEYDOWN_DOWN_L8:
	mov	edx,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame+0)]	; get EDX = iList from the stack
	lea	rcx,[Code_listview_dump_start_address]
	add	qword [rcx+rdx*8],rax
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
proc_List_KEYDOWN_DOWN_end:
	jmp	proc_List_KEYDOWN_epi

proc_List_KEYDOWN_DOWN_L9:
; just increase selected iItem, nothing more...
;	inc	r8
;	xor	r9,r9
;	bts	r9,r8
;	mov	qword [rcx+rdx*8],r9
; this is smaller, since we compared cmp r8,rax whether r8 is less than rax COUNTPERPAGE:
	shl	qword [rcx+rdx*8],1
; we needn't to update text content of SysListView32, it is enough to update only this one
; EDX = index of SysListView, input param for next call
	call	update_selection
	jmp	proc_List_KEYDOWN_epi

proc_List_KEYDOWN_PGUP:
	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_GETCOUNTPERPAGE
	call	qword [SendMessageA]
	or	eax,eax				; is SysListView32 so small that it hasn't any visible iItem ?
	jz	proc_List_KEYDOWN_PGUP_neg_end	; it is safe to jump there with rax=0

; don't allow more than MaxLinesInSysListView32
	mov	ecx,MaxLinesInSysListView32
	cmp	ecx,eax
	cmovc	eax,ecx

	mov	edx,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame+0)]	; grab EDX from the stack
	cmp	edx,2
	jc	proc_List_KEYDOWN_PGUP_code
	cmp	edx,5
	jc	proc_List_KEYDOWN_PGUP_data
proc_List_KEYDOWN_PGUP_stack:
	shl	eax,3				; every iItem displays 1 qword = 8 bytes
	jmp	proc_List_KEYDOWN_PGUP_neg_end
proc_List_KEYDOWN_PGUP_data:
	shl	eax,4				; every iItem displays 2 qwords = 16 bytes
	jmp	proc_List_KEYDOWN_PGUP_neg_end
proc_List_KEYDOWN_PGUP_code:
; eax=COUNTPERPAGE
; edx=iList
	lea	rcx,[Code_listview_dump_start_address]
	mov	rdx,qword [rcx+rdx*8]
	mov	ecx,eax				; number of instruction to go back
	mov	eax,dword [last_PID]
	call	painful_reverze
	jc	proc_List_KEYDOWN_epi

proc_List_KEYDOWN_PGUP_neg_end:
	neg	rax

proc_List_KEYDOWN_PGUP_PGDN_end:
	mov	edx,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame+0)]	; get EDX = iList from the stack
	lea	rcx,[Code_listview_dump_start_address]
	add	qword [rcx+rdx*8],rax
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory
	jmp	proc_List_KEYDOWN_epi

proc_List_KEYDOWN_PGDN:
	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_GETCOUNTPERPAGE
	mov	qword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-1)],rcx	; save SysListView32 handle
	call	qword [SendMessageA]
	or	eax,eax				; is SysListView32 so small that it hasn't any visible iItem ?
	jz	proc_List_KEYDOWN_PGDN_end	; safe jump with rax=0, it doesn't change start address of displayed content

	mov	ecx,MaxLinesInSysListView32
	cmp	ecx,eax
	cmovc	eax,ecx				; truncate count of Items in SysListView32 to MaxLinesInSysListView32

	mov	edx,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame+0)]	; grab EDX from the stack
	cmp	edx,2
	jc	proc_List_KEYDOWN_PGDN_code
	cmp	edx,5
	jc	proc_List_KEYDOWN_PGDN_data
proc_List_KEYDOWN_PGDN_stack:
	shl	eax,3				; every iItem displays 1 qword = 8 bytes
	jmp	proc_List_KEYDOWN_PGUP_PGDN_end
proc_List_KEYDOWN_PGDN_data:
	shl	eax,4				; every iItem displays 2 qwords = 16 bytes
	jmp	proc_List_KEYDOWN_PGUP_PGDN_end

proc_List_KEYDOWN_PGDN_code:
	dec	eax				; number of iItems counts from 1, but we need 0-based index, so -1
	mov	dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-2)],eax	; save last iItem

proc_List_KEYDOWN_PGDN_L0:
	lea	r9,[rsp+8*4]
	mov	r8d,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-2)]
	lea	rdx,[tmp_buf]
	and	[r9+LV_ITEM64.iSubItem],0	; iSubItem=0 for address column
	mov	[r9+LV_ITEM64.pszText],rdx
	mov	[r9+LV_ITEM64.cchTextMax],SysListView_cchTextMax
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,qword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-1)]	; SysListView32 handle
	call	qword [SendMessageA]
; rax=string size
	or	eax,eax
	jnz	proc_List_KEYDOWN_PGDN_L1
	dec	dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-2)]	; try to find highest iItem holding
	js	proc_List_KEYDOWN_PGDN_end
	jmp	proc_List_KEYDOWN_PGDN_L0

proc_List_KEYDOWN_PGDN_L1:
	lea	rcx,[rsi]			; save RSI
	lea	rsi,[tmp_buf]
	call	ascii2hexa_qword
; rdx=value from address column
	lea	rsi,[rcx]			; restore RSI
	mov	eax,0				; this doesn't change Carry flag (in contrast of xor eax,eax)
	jc	proc_List_KEYDOWN_PGDN_end
	mov	rcx,qword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-1)]	; get SysListView32 handle
	mov	r8d,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-2)]	; get iItem
	mov	qword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-1)],rdx	; save address on the last visible iItem
	lea	r9,[rsp+8*4]
	mov	edx,LVM_GETITEMTEXT
	mov	[r9+LV_ITEM64.iSubItem],1	; iSubItem=1 for hexa opcode column
	call	qword [SendMessageA]
	or	eax,eax
	jz	proc_List_KEYDOWN_PGDN_end	; it is safe to jump there with rax=0
	shr	eax,1				; eax/2, every byte of instruction is displayed as 2 ascii chars
	mov	ecx,0
	cmovc	eax,ecx
	jc	proc_List_KEYDOWN_PGDN_end	; hexa displayed opcode has parity number of bytes everytime
						; so nonparity input for shr eax,1 sets Carry
; add address into opcode size on the last displayed iItem, so we have start address of the
; next page of displayed instructions
	add	rax,qword [rsp+8*(4+proc_List_KEYDOWN_stack_frame-1)]

; and subtract original start address to calculate delta
	mov	edx,dword [rsp+8*(4+proc_List_KEYDOWN_stack_frame+0)]	; get EDX = iList from the stack
	lea	rcx,[Code_listview_dump_start_address]
	sub	rax,qword [rcx+rdx*8]

proc_List_KEYDOWN_PGDN_end:
	jmp	proc_List_KEYDOWN_PGUP_PGDN_end
