struct	WNDCLASSEX64
	cbSize			rd	1
	style			rd	1
	lpfnWndProc		rq	1
	cbClsExtra		rd	1
	cbWndExtra		rd	1
	hInstance		rq	1
	hIcon			rq	1
	hCursor			rq	1
	hbrBackground		rq	1
	lpszMenuName		rq	1
	lpszClassName		rq	1
	hIconSm			rq	1
ends


struct	POINT64
	x			rd	1
	y			rd	1
ends


struct	MSG64
	hwnd			rq	1
	message		rq	1
	wParam			rq	1
	lParam			rq	1
	time			rd	1
				rd	1	; padding
	pt			POINT64
ends


struct	CLIENTCREATESTRUCT64
	hWindowMenu		rq	1
	idFirstChild		rd	1
ends


struct	MDICREATESTRUCT64
	szClass			rq	1
	szTitle			rq	1
	hOwner			rq	1
	x			rd	1
	y			rd	1
	cx			rd	1
	cy			rd	1
	style			rd	1
				rd	1	; padding
	lParam			rq	1
ends


struct	OFN64
	lStructSize		rd	1
				rd	1	; padding
	hwndOwner		rq	1
	hInstance		rq	1
	lpstrFilter		rq	1
	lpstrCustomFilter	rq	1
	nMaxCustFilter		rd	1
	nFilterIndex		rd	1
	lpstrFile		rq	1
	nMaxFile		rd	1
				rd	1	; padding
	lpstrFileTitle		rq	1
	nMaxFileTitle		rd	1
				rd	1	; padding
	lpstrInitialDir		rq	1
	lpstrTitle		rq	1
	Flags			rd	1
	nFileOffset		rw	1
	nFileExtension		rw	1
	lpstrDefExt		rq	1
	lCustData		rq	1
	lpfnHook		rq	1
	lpTemplateName		rq	1
ends


struct	STARTUPINFO64
	cb			rd	1
				rd	1	; padding
	lpReserved		rq	1
	lpDesktop		rq	1
	lpTitle			rq	1
	dwX			rd	1
	dwY			rd	1
	dwXSize			rd	1
	dwYSize			rd	1
	dwXCountChars		rd	1
	dwYCountChars		rd	1
	dwFillAttribute		rd	1
	dwFlags			rd	1
	wShowWindow		rw	1
	cbReserved2		rw	1
				rd	1	; padding
	lpReserved2		rq	1
	hStdInput		rq	1
	hStdOutput		rq	1
	hStdError		rq	1
ends


struct	PROCESS_INFORMATION64
	hProcess		rq	1
	hThread			rq	1
	dwProcessId		rd	1
	dwThreadId		rd	1
ends


EXCEPTION_MAXIMUM_PARAMETERS	=	15
struct	EXCEPTION_RECORD64
	ExceptionCode		rd	1
	ExceptionFlags		rd	1
	EXCEPTION_RECORD	rq	1	; ExceptionRecord, pointer to EXCEPTION_RECORD64
	ExceptionAddress	rq	1
	NumberParameters	rd	1
				rd	1	; padding
	ExceptionInformation	rq	EXCEPTION_MAXIMUM_PARAMETERS
ends


struct	EXCEPTION_DEBUG_INFO64			; sizeof=0A0h
	ExceptionRecord		EXCEPTION_RECORD64
	dwFirstChance		rd	1
				rd	1	; padding, should it be here ?
ends


struct	CREATE_THREAD_DEBUG_INFO64
	hThread			rq	1
	lpThreadLocalBase	rq	1
	lpStartAddress		rq	1
ends


struct	CREATE_PROCESS_DEBUG_INFO64
	hFile			rq	1
	hProcess		rq	1
	hThread			rq	1
	lpBaseOfImage		rq	1
	dwDebugInfoFileOffset	rd	1
	nDebugInfoSize		rd	1
	lpThreadLocalBase	rq	1
	lpStartAddress		rq	1
	lpImageName		rq	1
	fUnicode		rw	1
ends


struct	EXIT_THREAD_DEBUG_INFO64
	dwExitCode		rd	1
ends


struct	EXIT_PROCESS_DEBUG_INFO64
	dwExitCode		rd	1
ends


struct	LOAD_DLL_DEBUG_INFO64
	hFile			rq	1
	lpBaseOfDll		rq	1
	dwDebugInfoFileOffset	rd	1
	nDebugInfoSize		rd	1
	lpImageName		rq	1
	fUnicode		rw	1
ends


struct	UNLOAD_DLL_DEBUG_INFO64
	lpBaseOfDll		rq	1
ends


struct	OUTPUT_DEBUG_STRING_INFO64
	lpDebugStringData	rq	1
	fUnicode		rw	1
	nDebugStringLength	rw	1
ends


struct	RIP_INFO64
	dwError			rd	1
	dwType			rd	1
ends


struct	DEBUG_EVENT64
	dwDebugEventCode	rd	1
	dwProcessId		rd	1
	dwThreadId		rd	1
				rd	1	; padding
; Specifies additional information relating to the debugging event. This union takes on the type
; and value appropriate to the type of debugging event, as described in the dwDebugEventCode member.
	union
	Exception		EXCEPTION_DEBUG_INFO64	; structure with maximal size
	CreateThread		CREATE_THREAD_DEBUG_INFO64
	CreateProcess		CREATE_PROCESS_DEBUG_INFO64
	ExitThread		EXIT_THREAD_DEBUG_INFO64
	ExitProcess		EXIT_PROCESS_DEBUG_INFO64
	LoadDll			LOAD_DLL_DEBUG_INFO64
	UnloadDll		UNLOAD_DLL_DEBUG_INFO64
	DebugString		OUTPUT_DEBUG_STRING_INFO64
	RipInfo			RIP_INFO64
	ends
				rq	1	; why the hell DEBUG_EVENT64.Exception structure requires extra 1 qword ???
ends


struct	XMM_SAVE_AREA32
	ControlWord		rw	1
	StatusWord		rw	1
	TagWord			rb	1
	Reserved1		rb	1
	ErrorOpcode		rw	1
	ErrorOffset		rd	1
	ErrorSelector		rw	1
	Reserved2		rw	1
	DataOffset		rd	1
	DataSelector		rw	1
	Reserved3		rw	1
	MxCsr			rd	1
	MxCsr_Mask		rd	1
	FloatRegisters		rb	8*16	; every 128-bit holds st in low 80-bits or mm in low 64-bits
	XmmRegisters		rb	16*16	; yeah, AMD64 in long mode (64-bit) has 16 xmm registers
	Reserved4		rb	96
ends


struct	CONTEXT64
; Register parameter home addresses.
; N.B. These fields are for convience - they could be used to extend the context record in the future.
	P1Home			rq	1
	P2Home			rq	1
	P3Home			rq	1
	P4Home			rq	1
	P5Home			rq	1
	P6Home			rq	1
; Control flags.
	ContextFlags		rd	1
	MxCsr			rd	1
; Segment Registers and processor flags.
	SegCs			rw	1
	SegDs			rw	1
	SegEs			rw	1
	SegFs			rw	1
	SegGs			rw	1
	SegSs			rw	1
	EFlags			rd	1
; Debug registers.
	Dr0			rq	1
	Dr1			rq	1
	Dr2			rq	1
	Dr3			rq	1
	Dr6			rq	1
	Dr7			rq	1
; Integer registers.
	Rax			rq	1
	Rcx			rq	1
	Rdx			rq	1
	Rbx			rq	1
	Rsp			rq	1
	Rbp			rq	1
	Rsi			rq	1
	Rdi			rq	1
	R8			rq	1
	R9			rq	1
	R10			rq	1
	R11			rq	1
	R12			rq	1
	R13			rq	1
	R14			rq	1
	R15			rq	1
; Program counter.
	Rip			rq	1
; Floating point state.
	FltSave			XMM_SAVE_AREA32
; Vector registers.
	VectorRegister		rb	16*26
	VectorControl		rq	1
; Special debug control registers.
	DebugControl		rq	1
	LastBranchToRip		rq	1
	LastBranchFromRip	rq	1
	LastExceptionToRip	rq	1
	LastExceptionFromRip	rq	1
ends


struct	CONTEXT64EXT
; N.B. the context should be aligned 40h for new extended context. If not then InitializeContext aligns it and returns aligned begin of the structure. This is the reason of adding extra padding bytes at the end of structure.
; Register parameter home addresses.
; N.B. These fields are for convience - they could be used to extend the context record in the future.
	P1Home			rq	1
	P2Home			rq	1
	P3Home			rq	1
	P4Home			rq	1
	P5Home			rq	1
	P6Home			rq	1
; Control flags. Offset 30h
	ContextFlags		rd	1
	MxCsr			rd	1
; Segment Registers and processor flags.
	SegCs			rw	1
	SegDs			rw	1
	SegEs			rw	1
	SegFs			rw	1
	SegGs			rw	1
	SegSs			rw	1
	EFlags			rd	1
; Debug registers. Offset 48h
	Dr0			rq	1
	Dr1			rq	1
	Dr2			rq	1
	Dr3			rq	1
	Dr6			rq	1
	Dr7			rq	1
; Integer registers. Offset 78h
	Rax			rq	1
	Rcx			rq	1
	Rdx			rq	1
	Rbx			rq	1
	Rsp			rq	1
	Rbp			rq	1
	Rsi			rq	1
	Rdi			rq	1
	R8			rq	1
	R9			rq	1
	R10			rq	1
	R11			rq	1
	R12			rq	1
	R13			rq	1
	R14			rq	1
	R15			rq	1
; Program counter. Offset 0F8h
	Rip			rq	1
; Floating point state. Offset 100h
	FltSave			XMM_SAVE_AREA32
; Vector registers. Offset 300h
	VectorRegister		rb	16*26
	VectorControl		rq	1
; Special debug control registers. Offset 4A8h
	DebugControl		rq	1
	LastBranchToRip		rq	1
	LastBranchFromRip	rq	1
	LastExceptionToRip	rq	1
	LastExceptionFromRip	rq	1

; offset 4D0h, end of legacy context
AllOffset			rd	1		; intialized to -4d0h
AllLength			rd	1		; initialized to 540h
LegacyOffset			rd	1		; initialized to -4d0h
LegacyLength			rd	1		; initialized to 4d0h
XStateOffset			rd	1		; initialized to 30h
XStateLength			rd	1		; initialized to 40h
				rd	6		; padding, to keep align 40h of the following

; offset 500h
XSaveHeader			rd	16		; zeroed when initialized (writen 40h zero bytes there)

; offset 540h
YmmHighHalves			rb	16*16

				rb	40h-1		; padding to allow to align the begin of context at 40h
ends


struct	CHOOSEFONT64
	lStructSize		rd	1
				rd	1
	hwndOwner		rq	1
	hDC			rq	1
	lpLogFont		rq	1
	iPointSize		rd	1
	Flags			rd	1
	rgbColors		rd	1
				rd	1
	lCustData		rq	1
	lpfnHook		rq	1
	lpTemplateName		rq	1
	hInstance		rq	1
	lpszStyle		rq	1
	nFontType		rw	1
	___MISSING_ALIGNMENT__	rw	1
	nSizeMin		rd	1
	nSizeMax		rd	1
				rd	1	; Aligning ? Or why the hell it must be here ?
ends


LF_FACESIZE			=	32

struct	LOGFONTA64

	lfHeight		rd	1
	lfWidth			rd	1
	lfEscapement		rd	1
	lfOrientation		rd	1
	lfWeight		rd	1
	lfItalic		rb	1
	lfUnderline		rb	1
	lfStrikeOut		rb	1
	lfCharSet		rb	1
	lfOutPrecision		rb	1
	lfClipPrecision		rb	1
	lfQuality		rb	1
	lfPitchAndFamily	rb	1
	lfFaceName		rb	LF_FACESIZE
ends


struct	OSVERSIONINFOA64
	dwOSVersionInfoSize	rd	1
	dwMajorVersion		rd	1
	dwMinorVersion		rd	1
	dwBuildNumber		rd	1
	dwPlatformId		rd	1
	szCSDVersion		rb	128	; Maintenance string for PSS usage
ends


struct	OSVERSIONINFOEXA64
	dwOSVersionInfoSize	rd	1
	dwMajorVersion		rd	1
	dwMinorVersion		rd	1
	dwBuildNumber		rd	1
	dwPlatformId		rd	1
	szCSDVersion		rb	128	; Maintenance string for PSS usage
	wServicePackMajor	rw	1
	wServicePackMinor	rw	1
	wSuiteMask		rw	1
	wProductType		rb	1
	wReserved		rb	1
ends


struc	WINDOWPOS64
{
	.hwnd			rq	1
	.hwndInsertAfter	rq	1
	.x			rd	1
	.y			rd	1
	.cx			rd	1
	.cy			rd	1
	.flags			rd	1
}


struct	RECT64
	left			rd	1
	top			rd	1
	right			rd	1
	bottom			rd	1
ends


struct	LV_COLUMN64
	mask			rd	1
	fmt			rd	1
	cx			rd	1
				rd	1
	pszText			rq	1
	cchTextMax		rd	1
	iSubItem		rd	1
	iImage			rd	1
	iOrder			rd	1
ends


struct	LV_ITEM64
	mask			rd	1
	iItem			rd	1
	iSubItem		rd	1
	state			rd	1
	stateMask		rd	1
				rd	1
	pszText			rq	1
	cchTextMax		rd	1
	iImage			rd	1
	lParam			rq	1
	iIndent			rd	1
	iGroupId		rd	1
	cColumns		rd	1
	puColumns		rd	1
ends


struct	NMHDR64
	hwndFrom		rq	1
	idFrom			rq	1
	code			rd	1
				rd	1	; padding
ends


struct	NM_LISTVIEW64
	hdr			NMHDR64
	iItem			rd	1
	iSubItem		rd	1
	uNewState		rd	1
	uOldState		rd	1
	uChanged		rd	1
	ptAction		POINT64
	lParam			rq	1
	uKeyFlags		rd	1
ends


struct	NM_ITEMACTIVATE64
	hdr			NMHDR64
	iItem			rd	1
	iSubItem		rd	1
	uNewState		rd	1
	uOldState		rd	1
	uChanged		rd	1
	ptAction		POINT64
	lParam			rq	1
	uKeyFlags		rd	1
ends


struc	DRAWITEMSTRUCT64
{
	.CtlType		rd	1
	.CtlID			rd	1
	.itemID			rd	1
	.itemAction		rd	1
	.itemState		rd	1
				rd	1	; padding
	.hwndItem		rq	1
	.hDC			rq	1
	.rcItem			RECT64
	.itemData		rq	1
}


struc	MEASUREITEMSTRUCT64
{
	.CtlType		rd	1
	.CtlID			rd	1
	.itemID			rd	1
	.itemWidth		rd	1
	.itemHeight		rd	1
				rd	1	; padding
	.itemData		rq	1
}


struct	LV_HITTESTINFO64
	.pt			POINT64
	flags			rd	1
	iItem			rd	1
	iSubItem		rd	1	; valid only for LVM_SUBITEMHITTEST
ends


struct	EXCEPTION_POINTERS64
	PEXCEPTION_RECORD	rq	1	; ExceptionRecord
	PCONTEXT		rq	1	; ContextRecord
ends


struct	LV_FINDINFO64
	flags			rd	1
				rd	1	; padding
	psz			rq	1
	lParam			rq	1
	pt			POINT64
	vkDirection		rd	1
ends


struct	SYMBOL_INFO64
	SizeOfStruct		rd	1
	TypeIndex		rd	1
	Reserved		rq	2
	Index			rd	1
	Size			rd	1
	ModBase			rq	1
	Flags			rd	1
				rd	1
	Value			rq	1
	Address			rq	1
	Register		rd	1
	Scope			rd	1
	Tag			rd	1
	NameLen			rd	1
	MaxNameLen		rd	1
	Name			rb	1	; rb MAX_SYM_NAME is reserved here
						; but isn't encountered into sizeof struct
				rb	3	; padding, !!! MUST BE HERE, SIZEOF=58h !!!

ends


struct	IMAGEHLP_LINE64
	SizeOfStruct		rd	1
				rd	1	; padding
	Key			rq	1
	LineNumber		rd	1
				rd	1	; padding
	FileName		rq	1
	Address			rq	1
ends


struct	MENUITEMINFOA64
	cbSize			rd	1
	fMask			rd	1
	fType			rd	1	; used if MIIM_TYPE (4.0) or MIIM_FTYPE (>4.0)
	fState			rd	1	; used if MIIM_STATE
	wID			rd	1	; used if MIIM_ID
				rd	1	; padding
	hSubMenu		rq	1	; used if MIIM_SUBMENU
	hbmpChecked		rq	1	; used if MIIM_CHECKMARKS
	hbmpUnchecked		rq	1	; used if MIIM_CHECKMARKS
	dwItemData		rd	1	; used if MIIM_DATA
	dwTypeData		rd	1	; used if MIIM_TYPE (4.0) or MIIM_STRING (>4.0)
	cch			rd	1	; used if MIIM_TYPE (4.0) or MIIM_STRING (>4.0)
				rd	1	; padding
	hbmpItem		rq	1	; used if MIIM_BITMAP
ends


struct	SYSTEM_INFO64
	wProcessorArchitecture	rw	1
	wReserved		rw	1
	dwPageSize		rd	1
	lpMinimumApplicationAddress	rq	1
	lpMaximumApplicationAddress	rq	1
	dwActiveProcessorMask	rd	1
	dwNumberOfProcessors	rd	1
	dwProcessorType		rd	1
	dwAllocationGranularity	rd	1
	wProcessorLevel		rw	1
	wProcessorRevision	rw	1
ends


struct	MEMORY_BASIC_INFORMATION64
	BaseAddress		rq	1
	AllocationBase		rq	1
	AllocationProtect	rd	1
				rd	1
	RegionSize		rq	1
	State			rd	1
	Protect			rd	1
	Type			rd	1
				rd	1	; alignment, more MEMORY_BASIC_INFORMATION64 may follow
ends


; symbol type enumeration
; typedef enum {
;    SymNone = 0,
;    SymCoff,
;    SymCv,
;    SymPdb,
;    SymExport,
;    SymDeferred,
;    SymSym,       // .sym file
;    SymDia,
;    SymVirtual,
;    NumSymTypes
;} SYM_TYPE;


struct	IMAGEHLP_MODULE64
	SizeOfStruct		rd	1	; set to sizeof(IMAGEHLP_MODULE64)
				rd	1	; padding
	BaseOfImage		rq	1	; base load address of module
	ImageSize		rd	1	; virtual size of the loaded module
	TimeDateStamp		rd	1	; date/time stamp from pe header
	CheckSum		rd	1	; checksum from the pe header
	NumSyms			rd	1	; number of symbols in the symbol table
	SymType			rd	1	; type of symbols loaded
	ModuleName		rb	32	; module name
	ImageName		rb	256	; image name
; new elements: 07-Jun-2002
;    CHAR                        LoadedImageName[256];   // symbol file name
;    CHAR                        LoadedPdbName[256];     // pdb file name
;    DWORD                       CVSig;                  // Signature of the CV record in the debug directories
;    CHAR			            CVData[MAX_PATH * 3];   // Contents of the CV record
;    DWORD                       PdbSig;                 // Signature of PDB
;    GUID                        PdbSig70;               // Signature of PDB (VC 7 and up)
;	PdbAge			rd	1	; DBI age of pdb
;	PdbUnmatched		rb	1	; loaded an unmatched pdb
;	DbgUnmatched		rb	1	; loaded an unmatched dbg
;	LineNumbers		rb	1	; we have line number information
;	GlobalSymbols		rb	1	; we have internal symbol information
;	TypeInfo		rb	1	; we have type information
ends

