; FPU trick works only on some (perhaps all) AMD processors
; FPU trick doesn't work on Intel CPUs
; trap flag trick works well
; trap flag trick doesn't work on 32-bit emulation (WOW, 32-bit PE) in 64-bit win

format PE64 GUI at 100000000h
entry start


section '.code' code readable executable

start:
        sub     rsp,8*(4+1)

; detecting single step
; you can avoid detecting by setting breakpoint after pushf and then run debuggee
	pushf
	pop	rax
;	bt	eax,8				; test TrapFlag
;	jnc	L0
	test	ah,1
	jz	L0
	call	msg

L0:
; fldz loads a zero into st0 register. Then fnstenv stores the FPU environment
; status in which there is also the pointer to the last FPU instruction that
; was executed. If you trace the code the FPU instruction pointer is destroyed.
; you can beat this trick by putting breakpoint after fnstenv instruction and
; executing run instead of single step
; b 10000008C
; g
; it looks like after certain time CPU destroys FPU instruction pointer when
; switching tasks among threads. Perhaps win64 kernel uses FPU ?
	emms					; use this before FPU instructions
L1:	fldz
	fnstenv [rsp-20h]
	lea	eax,[L1]
	cmp	[rsp-20h+0Ch],eax
	jz	L2
	call	msg

L2:
; this is hacker mode - smallest possible code, assumes that we have enough
; stack space reserved:
	emms
	call	L3
L3:	fldz
	pop	rax
	fnstenv	[rsp-0Ch]
	pop	rdx
	push	rdx
	cmp	edx,eax		; note regs32 must be used, format of FPU
				; instruction pointer is EIP (32 bits)
	jz	L4
	call	msg

L4:
; analogy of the above idea
; please note that fxsave doesn't save really RIP, zero is stored there
	emms
L5:	fldpi
;	db	48h			; REX prefix for 64-bit operand size
;	fxsave	[rsp-200h]
;	lea	rax,[L5]
;	cmp	[rsp-200h+8],rax
	fnsave	[rsp-200h]
	lea	eax,[L5]
	cmp	[rsp-200h+0Ch],eax
	jz	L6
;	mov	ax,cs
;	cmp	[rsp-200h+10h],ax	; not necessary
;	jz	L6
	call	msg

L6:	xor	eax,eax
	add	rsp,8*(4+1)
	ret
;	xor	ecx,ecx
;	call	qword [ExitProcess]

msg:	sub	rsp,8*(4+1)
;if MB_OK = 0h
	xor	r9,r9
;else
;	mov	r9d,MB_OK
;end if
	lea	r8,[Msg_Title2]
	lea	rdx,[Msg_Text2]
	xor	ecx,ecx
	call	qword [MessageBoxA]
	add	rsp,8*(4+1)
	ret


section '.data' data readable writeable
Msg_Title2	db	'Hello, Ace !',0
Msg_Text2	db	'Single Stepping (Trace) detected !',0


section '.idata' import data readable writeable

  dd 0,0,0,RVA user_name,RVA user_table
  dd 0,0,0,0,0

  user_table:
    MessageBoxA dq RVA _MessageBoxA
    dq 0

  user_name db 'USER32.DLL',0

; user32.dll:
  _MessageBoxA dw 0
    db 'MessageBoxA',0
