format PE64 GUI
entry start

include	'exception.inc'


section '.code' code readable executable

start:

	sub	rsp,8*(4+1)

	lea	rdx,[exception_handler_proc]
	xor	ecx,ecx				; FirstHandler. Order in which the handler should be called. If the parameter is nonzero, the handler is the first handler to be called. If the parameter is zero, the handler is the last handler to be called
; mov ecx,1
	call	qword [RtlAddVectoredExceptionHandler]
; If the function succeeds, the return value is a pointer to the exception handler.
; If the function fails, the return value is NULL.
	or	rax,rax
	jz	exit

	db	0CCh				; EXCEPTION_BREAKPOINT

	xor	r9,r9
	lea	r8,[msg_text]
	lea	rdx,[msg_title]
	xor	ecx,ecx
	call	qword [MessageBoxA]

exit:	xor	ecx,ecx
	call	qword [ExitProcess]

align 16
exception_handler_proc:
; in:	RCX	EXCEPTION_POINTERS
; does:		decrypts string for MessageBox
; out:	RAX	EXCEPTION_CONTINUE_EXECUTION
;		EXCEPTION_CONTINUE_SEARCH

; we don't have prologue here as well epilogue at the end of procedure because we don't use API

virtual at 0
except_point	EXCEPTION_POINTERS
end virtual

	mov	rax,qword [rcx + except_point.PCONTEXT]

virtual at 0
context	CONTEXT64
end virtual

; Necessary to skip instruction causing exception. NTDLL.RtlRestoreContext will restore context after return from the exception handler.
; Opcode size is hardcoded here, but we can use routines from fdbg disasm engine to determine opcode size.
	inc	qword [rax + context.Rip]	; db 0CCh has only 1 byte

	mov	rax,magic
	xor	qword [msg_title],rax

; To return control to the point at which the exception occurred, return EXCEPTION_CONTINUE_EXECUTION (0xffffffff). To continue the handler search, return EXCEPTION_CONTINUE_SEARCH (0x0).
;	xor	eax,eax

if EXCEPTION_CONTINUE_EXECUTION=-1
	or	rax,-1				; has less opcode size and gives the same result as mov rax,...
						; if you don't worry about destroing flags register
else
	mov	rax,EXCEPTION_CONTINUE_EXECUTION
end if

	ret


section '.data' data readable writeable

magic				=	'Feryno!'
msg_text			db	'This message is secret, made by antidebug routine:',0
msg_title			dq	'dement!' xor magic


section '.idata' import data readable writeable

				dd	0,0,0,RVA ntdll_name,RVA ntdll_table
				dd	0,0,0,RVA kernel_name,RVA kernel_table
				dd	0,0,0,RVA user_name,RVA user_table
				dd	0,0,0,0,0

ntdll_table:
RtlAddVectoredExceptionHandler	dq	RVA _RtlAddVectoredExceptionHandler
				dq	0
kernel_table:
ExitProcess			dq	RVA _ExitProcess
				dq	0
user_table:
MessageBoxA			dq	RVA _MessageBoxA
				dq	0

ntdll_name			db	'NTDLL.DLL',0
kernel_name			db	'KERNEL32.DLL',0
user_name			db	'USER32.DLL',0

; ntdll.dll:
_RtlAddVectoredExceptionHandler	dw	0
				db	'RtlAddVectoredExceptionHandler',0

; kernel32.dll:
_ExitProcess			dw	0
				db	'ExitProcess',0

; user32.dll:
_MessageBoxA			dw	0
				db	'MessageBoxA',0
