; psquery.c
;
; NTSTATUS
; NtQueryInformationProcess(
;     __in HANDLE ProcessHandle,
;     __in PROCESSINFOCLASS ProcessInformationClass,
;     __out_bcount(ProcessInformationLength) PVOID ProcessInformation,
;     __in ULONG ProcessInformationLength,
;     __out_opt PULONG ReturnLength
;     )
;
; ...
;
;    //
;    // Check argument validity.
;    //
;
;    switch ( ProcessInformationClass ) {
;
;    case ProcessImageFileName:
;        {
;            ULONG LengthNeeded = 0;
;
;            st = ObReferenceObjectByHandle (ProcessHandle,
;                                            PROCESS_QUERY_INFORMATION,
;                                            PsProcessType,
;                                            PreviousMode,
;                                            &Process,
;                                            NULL);
;
;            if (!NT_SUCCESS (st)) {
;                return st;
;            }
;
;            //
;            // SeLocateProcessImageName will allocate space for a UNICODE_STRING and point pTempNameInfo
;            // at that string.  This memory will be freed later in the routine.
;            //
;
;            st = SeLocateProcessImageName (Process, &pTempNameInfo);
;
;            if (!NT_SUCCESS(st)) {
;                ObDereferenceObject(Process);
;                return st;
;            }
;
;            LengthNeeded = sizeof(UNICODE_STRING) + pTempNameInfo->MaximumLength;
;
;            //
;            // Either of these may cause an access violation. The
;            // exception handler will return access violation as
;            // status code. No further cleanup needs to be done.
;            //
;
;            try {
;
;                if (ARGUMENT_PRESENT(ReturnLength) ) {
;                    *ReturnLength = LengthNeeded;
;                }
;
;                if (ProcessInformationLength >= LengthNeeded) {
;                    RtlCopyMemory(
;                        ProcessInformation,
;                        pTempNameInfo,
;                        sizeof(UNICODE_STRING) + pTempNameInfo->MaximumLength
;                        );
;                    ((PUNICODE_STRING) ProcessInformation)->Buffer = (PWSTR)((PUCHAR) ProcessInformation + sizeof(UNICODE_STRING));
;
;                } else {
;                    st = STATUS_INFO_LENGTH_MISMATCH;
;                }
;
;            } except(EXCEPTION_EXECUTE_HANDLER) {
;                st = GetExceptionCode ();
;            }
;
;            ObDereferenceObject(Process);
;            ExFreePool( pTempNameInfo );
;
;            return st;
;
;        }


; ntpsapi.h
;
; //
; // Process Information Classes
; //
; 
; typedef enum _PROCESSINFOCLASS {
;     ProcessBasicInformation,
;     ProcessQuotaLimits,
;     ProcessIoCounters,
;     ProcessVmCounters,
;     ProcessTimes,
;     ProcessBasePriority,
;     ProcessRaisePriority,
;     ProcessDebugPort,
;     ProcessExceptionPort,
;     ProcessAccessToken,
;     ProcessLdtInformation,
;     ProcessLdtSize,
;     ProcessDefaultHardErrorMode,
;     ProcessIoPortHandlers,          // Note: this is kernel mode only
;     ProcessPooledUsageAndLimits,
;     ProcessWorkingSetWatch,
;     ProcessUserModeIOPL,
;     ProcessEnableAlignmentFaultFixup,
;     ProcessPriorityClass,
;     ProcessWx86Information,
;     ProcessHandleCount,
;     ProcessAffinityMask,
;     ProcessPriorityBoost,
;     ProcessDeviceMap,
;     ProcessSessionInformation,
;     ProcessForegroundInformation,
;     ProcessWow64Information,
;     ProcessImageFileName,
;     ProcessLUIDDeviceMapsEnabled,
;     ProcessBreakOnTermination,
;     ProcessDebugObjectHandle,
;     ProcessDebugFlags,
;     ProcessHandleTracing,
;     ProcessIoPriority,
;     ProcessExecuteFlags,
;     ProcessResourceManagement,
;     ProcessCookie,
;     ProcessImageInformation,
;     MaxProcessInfoClass             // MaxProcessInfoClass should always be the last enum
; } PROCESSINFOCLASS;
;
; ...
; //
; // Basic Process Information
; //  NtQueryInformationProcess using ProcessBasicInfo
; //
; 
; typedef struct _PROCESS_BASIC_INFORMATION64 {
;     NTSTATUS ExitStatus;
;     ULONG32 Pad1;
;     ULONG64 PebBaseAddress;
;     ULONG64 AffinityMask;
;     KPRIORITY BasePriority;
;     ULONG32 Pad2;
;     ULONG64 UniqueProcessId;
;     ULONG64 InheritedFromUniqueProcessId;
; } PROCESS_BASIC_INFORMATION64;
; typedef PROCESS_BASIC_INFORMATION64 *PPROCESS_BASIC_INFORMATION64;


struc	PROCESS_BASIC_INFORMATION64
{
.ExitStatus				dd	?
.Pad1					dd	?
.PebBaseAddress				dq	?
.AffinityMask				dq	?
.BasePriority				dd	?
.Pad2					dd	?
.UniqueProcessId			dq	?
.InheritedFromUniqueProcessId		dq	?
}

virtual at 0
vpbi		PROCESS_BASIC_INFORMATION64
sizeof.PROCESS_BASIC_INFORMATION64	=	$
end virtual



format PE64 GUI at (1 shl 32) on 'nul'
entry start

include	'%fasminc%\win64a.inc'


section '.code' code readable executable writeable

start:

a = 1			; return address from procedure
b = (a+c+d+e) and 1	; align stack at 16
c = (sizeof.PROCESS_BASIC_INFORMATION64 + (8-1)) / 8
d = 2			; 1 qword for 5th API param and qword 1 for pointer
e = 4			; 4 qwords reserved for API

	sub	rsp,8*(e+d+c+b)

virtual at rsp+8*(e+d)
proc_basic_info	PROCESS_BASIC_INFORMATION64
end virtual

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax			; __out_opt PULONG ReturnLength
	mov	r9d,sizeof.PROCESS_BASIC_INFORMATION64	; __in ULONG ProcessInformationLength
	lea	r8,[proc_basic_info]			; __out_bcount(ProcessInformationLength) PVOID ProcessInformation
	xor	edx,edx					; __in PROCESSINFOCLASS ProcessInformationClass
	or	rcx,-1					; __in HANDLE ProcessHandle
							; hCurrentProcess = FFFFFFFFFFFFFFFF
	call	[NtQueryInformationProcess]
	or	eax,eax
	js	exit

; PEB base address
	mov	rax,[proc_basic_info.PebBaseAddress]

	bswap	rax
	movdqa	xmm3,dqword [Sum1]
	movdqa	xmm4,dqword [Comp1]
	movdqa	xmm2,dqword [Mask1]
	movdqa	xmm5,dqword [Num1]
	movq	xmm0,rax
	movdqa	xmm1,xmm0
	psrlq	xmm0,4
	pand	xmm0,xmm2
	pand	xmm1,xmm2
	punpcklbw	xmm0,xmm1
	movdqa	xmm1,xmm0
	pcmpgtb	xmm0,xmm4
	pand	xmm0,xmm5
	paddb	xmm1,xmm3
	paddb	xmm1,xmm0

	xor	r9,r9
	lea	r8,[title]
	lea	rdx,[msg]
	xor	ecx,ecx
	movdqa	[rdx],xmm1
	call	[MessageBoxA]

exit:	xor	eax,eax
	add	rsp,8*(e+d+c+b)
	ret


align 10h
title			db	'PebBaseAddress',0

align 10h
msg			db	'                ','h',0

align 10h
Sum1			dq	3030303030303030h, 3030303030303030h
Mask1			dq	0f0f0f0f0f0f0f0fh, 0f0f0f0f0f0f0f0fh
Comp1			dq	0909090909090909h, 0909090909090909h
Num1			dq	0707070707070707h, 0707070707070707h



section '.idata' import data readable writeable

				dd	0,0,0,	RVA ntdll_name,		RVA ntdll_table
				dd	0,0,0,	RVA user_name,		RVA user_table
				dd	0,0,0,	0,			0

align 8
ntdll_table:
NtQueryInformationProcess	dq	RVA _NtQueryInformationProcess
				dq	0

user_table:
MessageBoxA			dq	RVA _MessageBoxA
				dq	0

ntdll_name			db	'NTDLL.DLL',0
user_name			db	'USER32.DLL',0

; ntdll.dll:
_NtQueryInformationProcess	db	0,0,'NtQueryInformationProcess',0

; user32.dll
_MessageBoxA			db	0,0,'MessageBoxA',0
