; psquery.c
;
; NTSTATUS
; NtQueryInformationProcess(
;     __in HANDLE ProcessHandle,
;     __in PROCESSINFOCLASS ProcessInformationClass,
;     __out_bcount(ProcessInformationLength) PVOID ProcessInformation,
;     __in ULONG ProcessInformationLength,
;     __out_opt PULONG ReturnLength
;     )
;
; ...
;
;    case ProcessDebugPort :
;
;        //
;        if (ProcessInformationLength != (ULONG) sizeof (HANDLE)) {
;            return STATUS_INFO_LENGTH_MISMATCH;
;        }
;
;        st = ObReferenceObjectByHandle (ProcessHandle,
;                                        PROCESS_QUERY_INFORMATION,
;                                        PsProcessType,
;                                        PreviousMode,
;                                        &Process,
;                                        NULL);
;
;        if (!NT_SUCCESS (st)) {
;            return st;
;        }
;
;        if (Process->DebugPort == NULL) {
;
;            DebugPort = NULL;
;
;        } else {
;
;            DebugPort = (HANDLE)-1;
;
;        }
;
;        ObDereferenceObject (Process);
;
;        //
;        // Either of these may cause an access violation. The
;        // exception handler will return access violation as
;        // status code. No further cleanup needs to be done.
;        //
;
;        try {
;            *(PHANDLE) ProcessInformation = DebugPort;
;
;            if (ARGUMENT_PRESENT (ReturnLength) ) {
;                *ReturnLength = sizeof(HANDLE);
;            }
;        } except (EXCEPTION_EXECUTE_HANDLER) {
;            return GetExceptionCode ();
;        }


; ntpsapi.h
;
; //
; // Process Information Classes
; //
; 
; typedef enum _PROCESSINFOCLASS {
;     ProcessBasicInformation,
;     ProcessQuotaLimits,
;     ProcessIoCounters,
;     ProcessVmCounters,
;     ProcessTimes,
;     ProcessBasePriority,
;     ProcessRaisePriority,
;     ProcessDebugPort,
;     ProcessExceptionPort,
;     ProcessAccessToken,
;     ProcessLdtInformation,
;     ProcessLdtSize,
;     ProcessDefaultHardErrorMode,
;     ProcessIoPortHandlers,          // Note: this is kernel mode only
;     ProcessPooledUsageAndLimits,
;     ProcessWorkingSetWatch,
;     ProcessUserModeIOPL,
;     ProcessEnableAlignmentFaultFixup,
;     ProcessPriorityClass,
;     ProcessWx86Information,
;     ProcessHandleCount,
;     ProcessAffinityMask,
;     ProcessPriorityBoost,
;     ProcessDeviceMap,
;     ProcessSessionInformation,
;     ProcessForegroundInformation,
;     ProcessWow64Information,
;     ProcessImageFileName,
;     ProcessLUIDDeviceMapsEnabled,
;     ProcessBreakOnTermination,
;     ProcessDebugObjectHandle,
;     ProcessDebugFlags,
;     ProcessHandleTracing,
;     ProcessIoPriority,
;     ProcessExecuteFlags,
;     ProcessResourceManagement,
;     ProcessCookie,
;     ProcessImageInformation,
;     MaxProcessInfoClass             // MaxProcessInfoClass should always be the last enum
; } PROCESSINFOCLASS;



format PE64 GUI at (1 shl 32) on 'nul'
entry start

include	'%fasminc%\win64a.inc'


section '.code' code readable executable writeable

start:

a = 1			; return address from procedure
b = (a+c+d) and 1	; align stack at 16
c = 3			; 1 qword for 5th API param, qword 1 for pointer, 1 qword for obtaining handle
d = 4			; 4 qwords reserved for API

	sub	rsp,8*(d+c+b)

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax			; __out_opt PULONG ReturnLength
;	mov	r9d,8					; __in ULONG ProcessInformationLength
	lea	r8,[rsp+8*(4+2)]			; __out_bcount(ProcessInformationLength) PVOID ProcessInformation
	mov	edx,7					; __in PROCESSINFOCLASS ProcessInformationClass
	or	rcx,-1					; __in HANDLE ProcessHandle
							; hCurrentProcess = FFFFFFFFFFFFFFFF
	lea	r9d,[rdx+1]
	call	[NtQueryInformationProcess]
	or	eax,eax
	js	exit

	mov	rcx,[rsp+8*(4+2)]

	bswap	rcx
	movdqa	xmm3,dqword [Sum1]
	movdqa	xmm4,dqword [Comp1]
	movdqa	xmm2,dqword [Mask1]
	movdqa	xmm5,dqword [Num1]
	movq	xmm0,rcx
	movdqa	xmm1,xmm0
	psrlq	xmm0,4
	pand	xmm0,xmm2
	pand	xmm1,xmm2
	punpcklbw	xmm0,xmm1
	movdqa	xmm1,xmm0
	pcmpgtb	xmm0,xmm4
	pand	xmm0,xmm5
	paddb	xmm1,xmm3
	paddb	xmm1,xmm0

	jrcxz	show_msg
; debugger detected
	mov	byte [msg_debugger_detected],0Dh	; change 0 to new line char so the string will continue from the previous one

show_msg:
	xor	r9,r9
	lea	r8,[title]
	lea	rdx,[msg]
	xor	ecx,ecx
	movdqa	[rdx],xmm1
	call	[MessageBoxA]

exit:	xor	eax,eax
	add	rsp,8*(d+c+b)
	ret


align 10h
title			db	'ProcessDebugPort',0

align 10h
msg			db	'                ','h'

msg_debugger_detected	db	0
			db	0Ah,'Debugger detected !!!',0


align 10h
Sum1			dq	3030303030303030h, 3030303030303030h
Mask1			dq	0f0f0f0f0f0f0f0fh, 0f0f0f0f0f0f0f0fh
Comp1			dq	0909090909090909h, 0909090909090909h
Num1			dq	0707070707070707h, 0707070707070707h



section '.idata' import data readable writeable

				dd	0,0,0,	RVA ntdll_name,		RVA ntdll_table
				dd	0,0,0,	RVA user_name,		RVA user_table
				dd	0,0,0,	0,			0

align 8
ntdll_table:
NtQueryInformationProcess	dq	RVA _NtQueryInformationProcess
				dq	0

user_table:
MessageBoxA			dq	RVA _MessageBoxA
				dq	0

ntdll_name			db	'NTDLL.DLL',0
user_name			db	'USER32.DLL',0

; ntdll.dll:
_NtQueryInformationProcess	db	0,0,'NtQueryInformationProcess',0

; user32.dll
_MessageBoxA			db	0,0,'MessageBoxA',0
