; psquery.c
;
; NTSTATUS
; NtQueryInformationProcess(
;     __in HANDLE ProcessHandle,
;     __in PROCESSINFOCLASS ProcessInformationClass,
;     __out_bcount(ProcessInformationLength) PVOID ProcessInformation,
;     __in ULONG ProcessInformationLength,
;     __out_opt PULONG ReturnLength
;     )
;
; ...
;
;    //
;    // Check argument validity.
;    //
;
;    switch ( ProcessInformationClass ) {
;
;    case ProcessImageFileName:
;        {
;            ULONG LengthNeeded = 0;
;
;            st = ObReferenceObjectByHandle (ProcessHandle,
;                                            PROCESS_QUERY_INFORMATION,
;                                            PsProcessType,
;                                            PreviousMode,
;                                            &Process,
;                                            NULL);
;
;            if (!NT_SUCCESS (st)) {
;                return st;
;            }
;
;            //
;            // SeLocateProcessImageName will allocate space for a UNICODE_STRING and point pTempNameInfo
;            // at that string.  This memory will be freed later in the routine.
;            //
;
;            st = SeLocateProcessImageName (Process, &pTempNameInfo);
;
;            if (!NT_SUCCESS(st)) {
;                ObDereferenceObject(Process);
;                return st;
;            }
;
;            LengthNeeded = sizeof(UNICODE_STRING) + pTempNameInfo->MaximumLength;
;
;            //
;            // Either of these may cause an access violation. The
;            // exception handler will return access violation as
;            // status code. No further cleanup needs to be done.
;            //
;
;            try {
;
;                if (ARGUMENT_PRESENT(ReturnLength) ) {
;                    *ReturnLength = LengthNeeded;
;                }
;
;                if (ProcessInformationLength >= LengthNeeded) {
;                    RtlCopyMemory(
;                        ProcessInformation,
;                        pTempNameInfo,
;                        sizeof(UNICODE_STRING) + pTempNameInfo->MaximumLength
;                        );
;                    ((PUNICODE_STRING) ProcessInformation)->Buffer = (PWSTR)((PUCHAR) ProcessInformation + sizeof(UNICODE_STRING));
;
;                } else {
;                    st = STATUS_INFO_LENGTH_MISMATCH;
;                }
;
;            } except(EXCEPTION_EXECUTE_HANDLER) {
;                st = GetExceptionCode ();
;            }
;
;            ObDereferenceObject(Process);
;            ExFreePool( pTempNameInfo );
;
;            return st;
;
;        }


; ntpsapi.h
;
; //
; // Process Information Classes
; //
; 
; typedef enum _PROCESSINFOCLASS {
;     ProcessBasicInformation,
;     ProcessQuotaLimits,
;     ProcessIoCounters,
;     ProcessVmCounters,
;     ProcessTimes,
;     ProcessBasePriority,
;     ProcessRaisePriority,
;     ProcessDebugPort,
;     ProcessExceptionPort,
;     ProcessAccessToken,
;     ProcessLdtInformation,
;     ProcessLdtSize,
;     ProcessDefaultHardErrorMode,
;     ProcessIoPortHandlers,          // Note: this is kernel mode only
;     ProcessPooledUsageAndLimits,
;     ProcessWorkingSetWatch,
;     ProcessUserModeIOPL,
;     ProcessEnableAlignmentFaultFixup,
;     ProcessPriorityClass,
;     ProcessWx86Information,
;     ProcessHandleCount,
;     ProcessAffinityMask,
;     ProcessPriorityBoost,
;     ProcessDeviceMap,
;     ProcessSessionInformation,
;     ProcessForegroundInformation,
;     ProcessWow64Information,
;     ProcessImageFileName,
;     ProcessLUIDDeviceMapsEnabled,
;     ProcessBreakOnTermination,
;     ProcessDebugObjectHandle,
;     ProcessDebugFlags,
;     ProcessHandleTracing,
;     ProcessIoPriority,
;     ProcessExecuteFlags,
;     ProcessResourceManagement,
;     ProcessCookie,
;     ProcessImageInformation,
;     MaxProcessInfoClass             // MaxProcessInfoClass should always be the last enum
; } PROCESSINFOCLASS;




format PE64 GUI at (1 shl 32) on 'nul'
entry start

include	'%fasminc%\win64a.inc'


section '.code' code readable executable

start:
	sub	rsp,8*(4+3)

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax	; __out_opt PULONG ReturnLength
	mov	r9d,1000h		; __in ULONG ProcessInformationLength
	lea	r8,[unicode_string]	; __out_bcount(ProcessInformationLength) PVOID ProcessInformation
	mov	edx,27			; __in PROCESSINFOCLASS ProcessInformationClass
	or	rcx,-1			; __in HANDLE ProcessHandle
					; hCurrentProcess = FFFFFFFFFFFFFFFF
	call	[NtQueryInformationProcess]
	or	eax,eax
	js	exit

	xor	r9,r9
	lea	r8,[us_title]
	mov	rdx,[unicode_string.pointer]
	xor	ecx,ecx
	call	[MessageBoxW]

exit:	xor	eax,eax
	add	rsp,8*(4+3)
	ret

align 10h
us_title	du	'NtQueryInformationProcess ProcessImageFileName',0


section '.data' code readable executable writeable

unicode_string:
		rw	1			; size of string without 0-terminator
		rw	1			; size of string with 0-terminator
align 8
.pointer	rq	1			; pointer to the string
string	rb	1000h


section '.idata' import data readable writeable

				dd	0,0,0,	RVA ntdll_name,		RVA ntdll_table
				dd	0,0,0,	RVA user_name,		RVA user_table
				dd	0,0,0,	0,			0

align 8
ntdll_table:
NtQueryInformationProcess	dq	RVA _NtQueryInformationProcess
				dq	0

user_table:
MessageBoxW			dq	RVA _MessageBoxW
				dq	0

ntdll_name			db	'NTDLL.DLL',0
user_name			db	'USER32.DLL',0

; ntdll.dll:
_NtQueryInformationProcess	db	0,0,'NtQueryInformationProcess',0

; user32.dll
_MessageBoxW			db	0,0,'MessageBoxW',0
