; w2k8 server (vista) or higher required
; HideFromDebugger is not implemented in w2k3 server (XP)

; psquery.c
;
; NTSTATUS
; NtQueryInformationThread(
;     __in HANDLE ThreadHandle,
;     __in THREADINFOCLASS ThreadInformationClass,
;     __out_bcount(ThreadInformationLength) PVOID ThreadInformation,
;     __in ULONG ThreadInformationLength,
;     __out_opt PULONG ReturnLength
;     )
;
; /*++
;
; Routine Description:
;
;     This function queries the state of a thread object and returns the
;     requested information in the specified record structure.
;
; Arguments:
;
;     ThreadHandle - Supplies a handle to a thread object.
;
;     ThreadInformationClass - Supplies the class of information being
;         requested.
;
;     ThreadInformation - Supplies a pointer to a record that is to
;         receive the requested information.
;
;     ThreadInformationLength - Supplies the length of the record that is
;         to receive the requested information.
;
;     ReturnLength - Supplies an optional pointer to a variable that is to
;         receive the actual length of information that is returned.
;
; --*/
;
; ...
; ...
; NTSTATUS
; NtSetInformationThread(
; ...
; ...
;
;    case ThreadHideFromDebugger:
;        if (ThreadInformationLength != 0) {
;            return STATUS_INFO_LENGTH_MISMATCH;
;        }
;
;        st = ObReferenceObjectByHandle (ThreadHandle,
;                                        THREAD_SET_INFORMATION,
;                                        PsThreadType,
;                                        PreviousMode,
;                                        &Thread,
;                                        NULL);
;
;        if (!NT_SUCCESS (st)) {
;            return st;
;        }
;
;        PS_SET_BITS (&Thread->CrossThreadFlags, PS_CROSS_THREAD_FLAGS_HIDEFROMDBG);
;
;        ObDereferenceObject (Thread);
;
;        return st;
;        break;



; ntpsapi.h
;
; //
; // Thread Information Classes
; //
;
; typedef enum _THREADINFOCLASS {
;     ThreadBasicInformation,
;     ThreadTimes,
;     ThreadPriority,
;     ThreadBasePriority,
;     ThreadAffinityMask,
;     ThreadImpersonationToken,
;     ThreadDescriptorTableEntry,
;     ThreadEnableAlignmentFaultFixup,
;     ThreadEventPair_Reusable,
;     ThreadQuerySetWin32StartAddress,
;     ThreadZeroTlsCell,
;     ThreadPerformanceCount,
;     ThreadAmILastThread,
;     ThreadIdealProcessor,
;     ThreadPriorityBoost,
;     ThreadSetTlsArrayAddress,
;     ThreadIsIoPending,
;     ThreadHideFromDebugger,
;     ThreadBreakOnTermination,
;     ThreadSwitchLegacyState,
;     ThreadIsTerminated,
;     MaxThreadInfoClass
;     } THREADINFOCLASS;


;    union {
;
;        ULONG CrossThreadFlags;
;
;        //
;        // The following fields are for the debugger only. Do not use.
;        // Use the bit definitions instead.
;        //
;
;        struct {
;            ULONG Terminated              : 1;
;            ULONG DeadThread              : 1;
;            ULONG HideFromDebugger        : 1;
;            ULONG ActiveImpersonationInfo : 1;
;            ULONG SystemThread            : 1;
;            ULONG HardErrorsAreDisabled   : 1;
;            ULONG BreakOnTermination      : 1;
;            ULONG SkipCreationMsg         : 1;
;            ULONG SkipTerminationMsg      : 1;
;        };
;    };




format PE64 GUI at (1 shl 32) on 'nul'
entry start

include	'%fasminc%\win64a.inc'


section '.code' code readable executable writeable

start:

a = 1			; return address from procedure
b = (a+c+d+e) and 1	; align stack at 16
c = (sizeof.OSVERSIONINFO + 7)/8
d = 3			; 1 qword for 5th API param, qword 1 for pointer, 1 qword for obtaining handle
e = 4			; 4 qwords reserved for API


virtual at rsp+8*(e+d)
osvi	OSVERSIONINFO
end virtual

	sub	rsp,8*(e+d+c+b)

	lea	rcx,[osvi]
	mov	[rcx + OSVERSIONINFO.dwOSVersionInfoSize],sizeof.OSVERSIONINFO
	call	[GetVersionExA]
	cmp	[osvi.dwMajorVersion],6
	jc	exit

; windows 2008 server (vista) or higher is required, HideFromDebugger is not implemented in windows 2003 server (XP)

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax			; __out_opt PULONG ReturnLength
;	mov	r9d,1					; __in ULONG ThreadInformationLength
	lea	r8,[rsp+8*(4+2)]			; __out_bcount(ProcessInformationLength) PVOID 			; __out_bcount(ThreadInformationLength) PVOID ThreadInformation
	mov	edx,17					; __in THREADINFOCLASS ThreadInformationClass
;	mov	rcx,-2					; __in HANDLE ThreadHandle
							; hCurrentThread = FFFFFFFFFFFFFFFE
	lea	rcx,[rdx-17 -2]
	lea	r9d,[rdx-17 +1]
	call	[NtQueryInformationThread]
	or	eax,eax
	js	exit

; HideFromDebugger
	mov	al,[rsp+8*(4+2)]
	add	al,'0'

	xor	r9,r9
	lea	r8,[title]
	lea	rdx,[msg]
	xor	ecx,ecx
	mov	[rdx],al
	call	[MessageBoxA]



	xor	r9,r9
	lea	r8,[title2]
	lea	rdx,[msg2]
	xor	ecx,ecx
	call	[MessageBoxA]


; NTSTATUS
; NtSetInformationThread(
;     __in HANDLE ThreadHandle,
;     __in THREADINFOCLASS ThreadInformationClass,
;     __in_bcount(ThreadInformationLength) PVOID ThreadInformation,
;     __in ULONG ThreadInformationLength
;     )
;
; /*++
;
; Routine Description:
;
;     This function sets the state of a thread object.
;
; Arguments:
;
;     ThreadHandle - Supplies a handle to a thread object.
;
;     ThreadInformationClass - Supplies the class of information being
;         set.
;
;     ThreadInformation - Supplies a pointer to a record that contains the
;         information to set.
;
;     ThreadInformationLength - Supplies the length of the record that contains
;         the information to set.
;
; --*/

	xor	r9,r9					; __in ULONG ThreadInformationLength
	lea	r8,[rsp+8*(4+0)]			; __out_bcount(ThreadInformationLength) PVOID ThreadInformation
	mov	edx,17					; __in_bcount(ThreadInformationLength) PVOID ThreadInformation,
;	mov	rcx,-2					; __in HANDLE ThreadHandle
							; hCurrentThread = FFFFFFFFFFFFFFFE
	lea	rcx,[rdx-17 -2]
	mov	byte [r8],1				; enable HideFromDebugger
	call	[NtSetInformationThread]

; the process starts to run outside of debugger if the call succeeded (typically the process starts to run after return from the SYSCALL instruction in the ntdll.dll)
; if you stepped over (F8) over the call [NtSetInformationThread] then the process hit breakpoint after the call and terminates because of exception, the same would happen if you single stepped (F7) over the SYSCALL instruction in ntdll.dll

	or	eax,eax
	js	exit




	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax			; __out_opt PULONG ReturnLength
;	mov	r9d,1					; __in ULONG ThreadInformationLength
	lea	r8,[rsp+8*(4+2)]			; __out_bcount(ThreadInformationLength) PVOID ThreadInformation
	mov	edx,17					; __in THREADINFOCLASS ThreadInformationClass
;	mov	rcx,-2					; __in HANDLE ThreadHandle
							; hCurrentThread = FFFFFFFFFFFFFFFE
	lea	rcx,[rdx-17 -2]
	lea	r9d,[rdx-17 +1]
	call	[NtQueryInformationThread]
	or	eax,eax
	js	exit

; HideFromDebugger
	mov	al,[rsp+8*(4+2)]
	add	al,'0'

	xor	r9,r9
	lea	r8,[title]
	lea	rdx,[msg]
	xor	ecx,ecx
	mov	[rdx],al
	call	[MessageBoxA]



exit:	xor	eax,eax
	add	rsp,8*(e+d+c+b)
	ret


align 10h
title			db	'HideFromDebugger',0

align 10h
msg			db	' ',0


align 10h
title2			db	'no worry...',0

align 10h
msg2			db	'trying to enable HideFromDebugger',0


section '.idata' import data readable writeable

				dd	0,0,0,	RVA ntdll_name,		RVA ntdll_table
				dd	0,0,0,	RVA kernel_name,	RVA kernel_table
				dd	0,0,0,	RVA user_name,		RVA user_table
				dd	0,0,0,	0,			0

align 8
ntdll_table:
NtQueryInformationThread	dq	RVA _NtQueryInformationThread
NtSetInformationThread		dq	RVA _NtSetInformationThread
				dq	0

kernel_table:
GetVersionExA			dq	RVA _GetVersionExA
				dq	0

user_table:
MessageBoxA			dq	RVA _MessageBoxA
				dq	0

ntdll_name			db	'NTDLL.DLL',0
kernel_name			db	'KERNEL32.DLL',0
user_name			db	'USER32.DLL',0

; ntdll.dll:
_NtQueryInformationThread	db	0,0,'NtQueryInformationThread',0
_NtSetInformationThread		db	0,0,'NtSetInformationThread',0

; kernel32.dll:
_GetVersionExA			db	0,0,'GetVersionExA',0

; user32.dll
_MessageBoxA			db	0,0,'MessageBoxA',0
