; run fdbg
;
; load a00.exe, N.B. Debug only this process must NOT be set
;
; Face -> Various settings -> break on create process
;
; F9 (Action -> Run)
;
; now Log shows you something like
; Process created. ProcessId=00000C34h ThreadId=00000D78h BaseOfImage=0000000100000000-0000000100003000h ThreadLocalBase=000007FFFFFDE000h ThreadStartAddress=0000000100001000h
; grab the ThreadStartAddress, it is 100001000 in this sample
;
; the code 1st shows you something like:
; 0000000078D59630	?		?
; don't be afraid of that... the process memory is not yet fully mapped, it will be soon
;
; F9 (Action -> Run)
;
; the code 1st shows you something like under w2k3 server = win XP:
; 0000000078EF3320	CC		ntdll.DbgBreakPoint: int3
; 0000000078EF3321	C3		ret
; under w2k8 R2 win 7 it looks like:
; 00000000773B1220	CC		int3
; 00000000773B1221	EB00		jmp 00000000773B1223
; 00000000773B1223	4883C438	add rsp,38
; 00000000773B1227	C3		ret
;
; Alt-F9 (Action -> Execute to)
; put the address of ThreadStartAddress there, it is 100001000 in this sample and press Enter
;
; now you are at the entrypoint of the new process and code 1st shows you:
; 0000000100001000	4883EC28	sub rsp,28
; 0000000100001004	B9A00F0000	mov ecx,00000FA0
; 0000000100001009	FF1519100000	call qword [0000000100002028] ; []=0000000078D705C0=KERNEL32.Sleep
; 000000010000100F	4883C428	add rsp,28
; 0000000100001013	31C0		xor eax,eax
; 0000000100001015	C3		ret
;
; uncheck the checkbox in Face -> Various settings -> break on create process


include '%fasminc%/win64a.inc'


format PE64 GUI at 100000000h on 'nul'
entry start

section '.text' code readable executable writeable	; must be writeable for modify decompress_exe routine

start:

a	=	0			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	6			; number of qwords for API params (CreateProcess uses 10 input params)
d	=	(sizeof.PROCESS_INFORMATION+7)/8	; stack frame in qwords
e	=	(sizeof.STARTUPINFO+7)/8
z	=	(a+b+c+d+e+1) and 1	; align stack 10h
	sub	rsp,8*(b+c+d+e+z)

virtual at rsp+(b+c)*8
ProcessInfo	PROCESS_INFORMATION
end virtual

virtual at rsp+(b+c+d)*8
StartupInfo	STARTUPINFO
end virtual

	lea	rcx,[StartupInfo]
	mov	[rcx + STARTUPINFO.cb],sizeof.STARTUPINFO
	call	[GetStartupInfoA]

	lea	rax,[ProcessInfo]
	lea	rcx,[StartupInfo]
	mov	[rsp+8*(4+5)],rax	; lpProcessInformation 10th argument
	mov	[rsp+8*(4+4)],rcx	; lpStartupInfo 9th argument
	xor	r9,r9			; lpThreadAttributes 4th arg
	xor	ecx,ecx			; lpApplicationName 1st arg
	mov	[rsp+8*(4+3)],r9	; lpCurrentDirectory 8th arg
	mov	[rsp+8*(4+2)],r9	; lpEnvironment 7th arg
	mov	[rsp+8*(4+1)],ecx	; dwCreationFlags 6th arg
	mov	[rsp+8*(4+0)],cl	; bInheritHandles 5th arg
	xor	r8,r8			; lpProcessAttributes 3rd arg
	lea	rdx,[process_name]	; lpCommandLine 2nd arg
	call	[CreateProcessA]
	or	eax,eax
	jz	egzyd

INFINITE = -1

	mov	edx,INFINITE
	mov	rcx,[ProcessInfo.hProcess]
	call	[WaitForSingleObject]

L0:	lea	rdx,[rsp+8*(4+0)]
	mov	rcx,[ProcessInfo.hProcess]
	call	[GetExitCodeProcess]

STATUS_PENDING = 00000103h

STILL_ACTIVE = STATUS_PENDING

	cmp	dword [rsp+8*(4+0)],STILL_ACTIVE
	jnz	egzyd

	mov	ecx,100
	call	[Sleep]
	jmp	L0

egzyd:	mov	ecx,4000
	call	[Sleep]

	xor	eax,eax
	add	rsp,8*(b+c+d+e+z)
	ret


process_name	db	'a01.exe',0


section '.idata' import data readable writeable

				dd	0,0,0,RVA kernel_name,RVA kernel_table
				dd	0,0,0,0,0

align 8

kernel_table:
CreateProcessA			dq	RVA _CreateProcessA
GetExitCodeProcess		dq	RVA _GetExitCodeProcess
GetStartupInfoA			dq	RVA _GetStartupInfoA
Sleep				dq	RVA _Sleep
WaitForSingleObject		dq	RVA _WaitForSingleObject
				dq	0

kernel_name			db	'KERNEL32.DLL',0

; kernel32.dll:
_CreateProcessA			db	0,0,'CreateProcessA',0
_GetExitCodeProcess		db	0,0,'GetExitCodeProcess',0
_GetStartupInfoA		db	0,0,'GetStartupInfoA',0
_Sleep				db	0,0,'Sleep',0
_WaitForSingleObject		db	0,0,'WaitForSingleObject',0
