; howto debug this using fdbg:
; if you intercept the EXCEPTION_INT_DIVIDE_BY_ZERO exception by debugger, place a breakpoint at expt_handler (that is at instruction sub rsp,28h) and pass exception back to application by Action -> Run unhandled Ctrl-F12

format PE64 GUI at (1 shl 32) on 'nul'
entry start

include	'%fasminc%\win64a.inc'
include	'exception.inc'
IMAGE_DIRECTORY_ENTRY_EXCEPTION		=  3	; Exception Directory
IMAGE_DIRECTORY_ENTRY_TLS		=  9	; TLS Directory 
IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG	= 10	; Load Configuration Directory


section '.code' code readable executable

ex_handl_start:

start:
	push	rbx
	sub	rsp,8*(4+0)

	xor	ebx,ebx
buggy_instruction:
	div	ebx
sizeof_buggy_instruction	=	$ - buggy_instruction

; I'm king if I go here:
	xor	r9,r9
	lea	r8,[msg_empty]
	lea	rdx,[msg_recovered]
	xor	ecx,ecx
	call	[MessageBoxA]


exit:	;xor	eax,eax
	;add	rsp,8*(4+0)
	;pop	rbx
	;ret
	xor	ecx,ecx
	call	[ExitProcess]


ex_handl_end:

align 10h
expt_handler:

; _CRTIMP EXCEPTION_DISPOSITION __C_specific_handler (
;     __in struct _EXCEPTION_RECORD * ExceptionRecord,
;     __in void * EstablisherFrame,
;     __inout struct _CONTEXT * ContextRecord,
;     __inout struct _DISPATCHER_CONTEXT * DispatcherContext
; );

; typedef EXCEPTION_DISPOSITION (*PEXCEPTION_ROUTINE) ( 
;     IN PEXCEPTION_RECORD ExceptionRecord, 
;     IN ULONG64 EstablisherFrame, 
;     IN OUT PCONTEXT ContextRecord, 
;     IN OUT PDISPATCHER_CONTEXT DispatcherContext 
; );  

; RCX = ExceptionRecord
; RDX = EstablisherFrame
;  R8 = ContextRecord
;  R9 = DispatcherContext

	sub	rsp,8*(4+1)

virtual at r8
context	CONTEXT64
end virtual

; Necessary to skip instruction causing exception. NTDLL.RtlRestoreContext will restore context after return from the exception handler.
; Opcode size is hardcoded here, but we can use routines from fdbg disasm engine to determine opcode size.
	add	[context.Rip],sizeof_buggy_instruction

	xor	r9,r9
	xor	r8,r8
	lea	rdx,[msg]
	xor	ecx,ecx
	call	[MessageBoxA]

if EXCEPTION_CONTINUE_SEARCH = 0
	xor	eax,eax
else
	mov	eax,EXCEPTION_CONTINUE_SEARCH
end if

	add	rsp,8*(4+1)
	ret


msg		db	'An exception occured in the main application, trying to continue over it thanks to Exception Directory Entry.',0
msg_recovered	db	'The main application recovered from the exception successfully by skipping the instruction causing the exception.'
msg_empty	db	0


section '.pdata' readable writeable

data IMAGE_DIRECTORY_ENTRY_EXCEPTION
; typedef struct _RUNTIME_FUNCTION {
;     DWORD BeginAddress;
;     DWORD EndAddress;
;     DWORD UnwindData;
; } RUNTIME_FUNCTION, *PRUNTIME_FUNCTION;
; All three fields are RVAs (otherwise there wouldn't be dwords).
; BeginAddress Points to the start address of the involved part of code.  
; EndAddress   Points to the end address of the same part of code.  
; UnwindData   Points to an UNWIND_INFO structure.   
	dd	RVA ex_handl_start
	dd	RVA ex_handl_end
	dd	RVA ex_handl_unwind
end data

ex_handl_unwind:
; The UNWIND_INFO structure tells how the portion of code should be handled. Here's the declaration I found on MSDN:
; typedef union _UNWIND_CODE {
;     struct {
;         UBYTE CodeOffset;
;         UBYTE UnwindOp : 4;
;         UBYTE OpInfo   : 4;
;     };
;     USHORT FrameOffset;
; } UNWIND_CODE, *PUNWIND_CODE;
;
; typedef struct _UNWIND_INFO {
;     UBYTE Version       : 3;
;     UBYTE Flags         : 5;
;     UBYTE SizeOfProlog;
;     UBYTE CountOfCodes;
;     UBYTE FrameRegister : 4;
;     UBYTE FrameOffset   : 4;
;     UNWIND_CODE UnwindCode[1];
; /*  UNWIND_CODE MoreUnwindCode[((CountOfCodes + 1) & ~1) - 1];
; *   union {
; *       OPTIONAL ULONG ExceptionHandler;
; *       OPTIONAL ULONG FunctionEntry;
; *   };
; *   OPTIONAL ULONG ExceptionData[]; */
; } UNWIND_INFO, *PUNWIND_INFO;
; Here's the description of the UNWIND_INFO structure members taken directly from the MSDN:
; Version             Version number of the unwind data, currently 1.  
; Flags               Three flags are currently defined: 
; UNW_FLAG_EHANDLER   The function has an exception handler that should be called when looking for functions that need to examine exceptions. 
; UNW_FLAG_UHANDLER   The function has a termination handler that should be called when unwinding an exception. 
; UNW_FLAG_CHAININFO  This unwind info structure is not the primary one for the procedure. Instead, the chained unwind info entry is the contents of a previous RUNTIME_FUNCTION entry. See the following text for an explanation of chained unwind info structures. If this flag is set, then the UNW_FLAG_EHANDLER and UNW_FLAG_UHANDLER flags must be cleared. Also, the frame register and fixed-stack allocation fields must have the same values as in the primary unwind info. 
; SizeOfProlog        Length of the function prolog in bytes.  
; CountOfCodes        This is the number of slots in the unwind codes array. Note that some unwind codes (for example, UWOP_SAVE_NONVOL) require more than one slot in the array.  
; FrameRegister       If nonzero, then the function uses a frame pointer, and this field is the number of the nonvolatile register used as the frame pointer, using the same encoding for the operation info field of UNWIND_CODE nodes.  
; FrameOffset         If the frame register field is nonzero, then this is the scaled offset from RSP that is applied to the FP reg when it is established. The actual FP reg is set to RSP + 16 * this number, allowing offsets from 0 to 240. This permits pointing the FP reg into the middle of the local stack allocation for dynamic stack frames, allowing better code density through shorter instructions (more instructions can use the 8-bit signed offset form).  
; UnwindCode          This is an array of items that explains the effect of the prolog on the nonvolatile registers and RSP. See the section on UNWIND_CODE for the meanings of individual items. For alignment purposes, this array will always have an even number of entries, with the final entry potentially unused (in which case the array will be one longer than indicated by the count of unwind codes field).  
; ExceptionHandler    This is an image-relative pointer to either the function's language-specific exception/termination handler (if flag UNW_FLAG_CHAININFO is clear and one of the flags UNW_FLAG_EHANDLER or UNW_FLAG_UHANDLER is set).  
; Language-specific   handler data (ExceptionData)   This is the function's language-specific exception handler data. The format of this data is unspecified and completely determined by the specific exception handler in use.  
; Chained Unwind Info (ExceptionData)   If flag UNW_FLAG_CHAININFO is set then the UNWIND_INFO structure ends with three UWORDs. These UWORDs represent the RUNTIME_FUNCTION information for the function of the chained unwind.
; The possible values of the Flags field are:
; #define UNW_FLAG_EHANDLER  0x01
; #define UNW_FLAG_UHANDLER  0x02
; #define UNW_FLAG_CHAININFO 0x04
	db	19h,0,0,0
	dd	RVA expt_handler
	dd	0


section '.idata' import data readable writeable
library	kernel32,	'KERNEL32.DLL',\
	user32,		'USER32.DLL'
include	'%fasminc%\api\kernel32.inc'
include	'%fasminc%\api\user32.inc'
