format PE64 at 100000000h
;entry start

section '.code' code readable executable writeable

  start:

	pop	r8
	sub	rsp,8*(4+4)

;page_size_for_AMD64		= 1000h
;	and	rax,-1 xor (page_size_for_AMD64 - 1)
;
;find_kernel32_base:
;IMAGE_DOS_SIGNATURE		= 'MZ'
;	cmp	word [rax],IMAGE_DOS_SIGNATURE
;	jz	have_kernel32_base
;	sub	rax,page_size_for_AMD64
;	jmp	find_kernel32_base
;
;have_kernel32_base:

find_kernel32_base:
	dec	r8
	xor	r8w,r8w
IMAGE_DOS_SIGNATURE		= 'MZ'
	cmp	word [r8],IMAGE_DOS_SIGNATURE	;  IMAGE_DOS_HEADER.e_magic = IMAGE_DOS_SIGNATURE
	jnz	find_kernel32_base
have_kernel32_base:
	mov	eax,[r8+3Ch]		; IMAGE_DOS_HEADER.e_lfanew
IMAGE_NT_SIGNATURE		= 'PE'
	cmp	word [r8+rax],IMAGE_NT_SIGNATURE
	jnz	exit_short_jump
PROCESSOR_AMD_X8664		= 8664h
	cmp	word [r8+rax+4],PROCESSOR_AMD_X8664
exit_short_jump:
	jnz	exit
; note, for i386 dll export RVA is at 78h, instead of 88h for AMD64
	mov	r9d,[r8+rax+88h]	; export RVA = IMAGE_NT_HEADERS.OptionalHeader64.DataDirectory.VirtualAddress
	lea	r9,[r8+r9]

	lea	rbp,[GetStdHandle]
	call	get_API_address
	jc	exit

	lea	rbp,[rbp+8]
	call	get_API_address
	jc	exit

	lea	rbp,[rbp+8]
	call	get_API_address
	jc	exit

;	lea	rbp,[rbp+8]
;	call	get_API_address
;	jc	exit

	call	crypt_decrypt

STD_OUTPUT_HANDLE		= -11
INVALID_HANDLE_VALUE		= -1
	mov	rcx,STD_OUTPUT_HANDLE
	call	[GetStdHandle]
	cmp	rax,INVALID_HANDLE_VALUE
	jz	exit

	mov	qword [rsp + 8*(4+0)],0
	lea	r9,[rsp + 8*(4+1)]
	mov	r8d,msgsize
	lea	rdx,[msg]
	xchg	rcx,rax
	call	[WriteFile]

	call	crypt_decrypt

	mov	ecx,2000
	call	[Sleep]

exit:	add	rsp,8*(4+3)			; restore stack position
	xor	eax,eax
	ret

;	xor	ecx,ecx
;	call	[ExitProcess]

get_API_address:
        mov     edx,[r9 + 4*8]		; AddressOfNames
        mov     edi,[r9 + 4*9]		; AddressOfNameOrdinal
	mov	ecx,[r9 + 4*6]		; NumberOfNames = number of exported functions
	lea	rdi,[r8+rdi]
checksum_L1:
	mov	esi,[r8+rdx]
	lea	rsi,[r8+rsi]
	xor	r15,r15
	lodsb
checksum_L2:
	xor	r15b,al
	ror	r15,7
	lodsb
	or	al,al
	jnz	checksum_L2
	cmp	r15,[rbp]
	jz	have_API_address
	lea	rdx,[rdx+4]
	lea	rdi,[rdi+2]
	loop	checksum_L1
	stc
	ret

have_API_address:
	movzx	eax,word [rdi]
        mov     esi,[r9 + 4*7]	; AddressOfFunctions
	lea	rsi,[r8+rsi]
	mov	eax,[rsi+rax*4]
	lea	rax,[r8+rax]
	mov	[rbp],rax
	clc
	ret

crypt_decrypt:
	lea	rax,[msg]
	mov	ecx,msgsize
crypt_decrypt_L0:
	rol	byte [rax],4
	inc	rax
	loop	crypt_decrypt_L0
	ret

msg	db	(('D' shl 4) mod 100h) + 'D' shr 4
	db	(('e' shl 4) mod 100h) + 'e' shr 4
	db	(('m' shl 4) mod 100h) + 'm' shr 4
	db	(('o' shl 4) mod 100h) + 'o' shr 4
	db	(('n' shl 4) mod 100h) + 'n' shr 4
	db	(('s' shl 4) mod 100h) + 's' shr 4
	db	(('t' shl 4) mod 100h) + 't' shr 4
	db	(('r' shl 4) mod 100h) + 'r' shr 4
	db	(('a' shl 4) mod 100h) + 'a' shr 4
	db	(('t' shl 4) mod 100h) + 't' shr 4
	db	(('i' shl 4) mod 100h) + 'i' shr 4
	db	(('o' shl 4) mod 100h) + 'o' shr 4
	db	(('n' shl 4) mod 100h) + 'n' shr 4
	db	((' ' shl 4) mod 100h) + ' ' shr 4
	db	(('o' shl 4) mod 100h) + 'o' shr 4
	db	(('f' shl 4) mod 100h) + 'f' shr 4
	db	((' ' shl 4) mod 100h) + ' ' shr 4
	db	(('v' shl 4) mod 100h) + 'v' shr 4
	db	(('i' shl 4) mod 100h) + 'i' shr 4
	db	(('r' shl 4) mod 100h) + 'r' shr 4
	db	(('i' shl 4) mod 100h) + 'i' shr 4
	db	(('i' shl 4) mod 100h) + 'i' shr 4
	db	((' ' shl 4) mod 100h) + ' ' shr 4
	db	(('m' shl 4) mod 100h) + 'm' shr 4
	db	(('e' shl 4) mod 100h) + 'e' shr 4
	db	(('t' shl 4) mod 100h) + 't' shr 4
	db	(('h' shl 4) mod 100h) + 'h' shr 4
	db	(('o' shl 4) mod 100h) + 'o' shr 4
	db	(('d' shl 4) mod 100h) + 'd' shr 4
	db	(('s' shl 4) mod 100h) + 's' shr 4
	db	((0Dh shl 4) mod 100h) + 0Dh shr 4
	db	((0Ah shl 4) mod 100h) + 0Ah shr 4
msgsize	= $ - msg

;GetProcAddress_crc	= 2D48639D5920E3DFh
GetStdHandle_crc	= 189F56EC323274A7h
WriteFile_crc		=0CBB34C6CBD34F2AEh
Sleep_crc		=0E1972ECA60000000h
ExitProcess_crc		= 05E72E3DFCA874D3h

GetStdHandle	dq	GetStdHandle_crc
WriteFile	dq	WriteFile_crc
Sleep		dq	Sleep_crc
;ExitProcess	dq	ExitProcess_crc


;section '.data' data readable writeable

;title0	db	'Nothing to do...',0
;text0	db	'Test program for debugger.',0Dh,0Ah
;
;
;section '.idata' import data readable writeable
;
;  dd 0,0,0,RVA kernel_name,RVA kernel_table
;  dd 0,0,0,RVA user_name,RVA user_table
;  dd 0,0,0,0,0
;
;  kernel_table:
;    ExitProcess dq RVA _ExitProcess
;    dq 0
;  user_table:
;    MessageBoxA dq RVA _MessageBoxA
;    dq 0
;
;  kernel_name db 'KERNEL32.DLL',0
;  user_name db 'USER32.DLL',0
;
;; kernel32.dll:
;  _ExitProcess dw 0
;    db 'ExitProcess',0
;; user32.dll:
;  _MessageBoxA dw 0
;    db 'MessageBoxA',0
