; howto debug this using fdbg:
; use Action -> Run unhandled (Ctrl-F12) when intercepting exception shown in Log with ExceptionCode=80000001h=EXCEPTION_GUARD_PAGE

format PE64 GUI at (1 shl 32) on 'nul'
entry start

include	'%fasminc%\win64a.inc'
include	'exception.inc'


section '.code' code readable executable

ex_handl_start:

start:
	push	rbx
	sub	rsp,8*(4+2)

	lea	rdx,[exception_handler_proc]
	mov	ecx,1				; FirstHandler. Order in which the handler should be called. If the parameter is nonzero, the handler is the first handler to be called. If the parameter is zero, the handler is the last handler to be called
	call	[RtlAddVectoredExceptionHandler]
; If the function succeeds, the return value is a pointer to the exception handler.
; If the function fails, the return value is NULL.
	or	rax,rax
	jz	exit

	mov	r9d,PAGE_EXECUTE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	edx,1
	xor	ecx,ecx
	call	[VirtualAlloc]
	or	rax,rax
	jz	exit
	mov	rbx,rax

	mov	byte [rax],0C3h			; the RET instruction

	lea	r9,[rsp+8*(4+0)]
	mov	r8d,PAGE_EXECUTE_READ or PAGE_GUARD
	mov	edx,1
	lea	rcx,[rax]
	call	[VirtualProtect]

	call	rbx
	db	0E4h			; opcode for the IN instruction, crash the application (ring0 privileged instruction)

	xor	r9,r9
	xor	r8,r8
	lea	rdx,[msg]
	xor	ecx,ecx
	call	[MessageBoxA]

exit:	xor	eax,eax
	add	rsp,8*(4+2)
	pop	rbx
	ret

msg	db	'passed',0


align 10h
exception_handler_proc:
; in:	RCX	EXCEPTION_POINTERS
; does:		decrypts string for MessageBox
; out:	RAX	EXCEPTION_CONTINUE_EXECUTION
;		EXCEPTION_CONTINUE_SEARCH

virtual at rcx
except_point	EXCEPTION_POINTERS
end virtual
	mov	rax,[except_point.PEXCEPTION_RECORD]

virtual at rax
except_record	EXCEPTION_RECORD64
end virtual
	cmp	[except_record.ExceptionCode],EXCEPTION_GUARD_PAGE
	jnz	exception_handler_proc_end

	mov	rax,[except_point.PCONTEXT]

virtual at rax
context	CONTEXT64
end virtual
	mov	rax,[context.Rsp]
	inc	qword [rax]		; skip the opcode for the IN instruction by adding 1 to return address from procedure

exception_handler_proc_end:
if EXCEPTION_CONTINUE_EXECUTION = -1
	or	rax,-1
else
	mov	rax,EXCEPTION_CONTINUE_EXECUTION
end if
	ret



section '.idata' import data readable writeable

				dd	0,0,0,RVA ntdll_name,RVA ntdll_table
				dd	0,0,0,RVA kernel_name,RVA kernel_table
				dd	0,0,0,RVA user_name,RVA user_table
				dd	0,0,0,0,0

ntdll_table:
RtlAddVectoredExceptionHandler	dq	RVA _RtlAddVectoredExceptionHandler
				dq	0
kernel_table:
VirtualAlloc			dq	RVA _VirtualAlloc
VirtualProtect			dq	RVA _VirtualProtect
				dq	0
user_table:
MessageBoxA			dq	RVA _MessageBoxA
				dq	0

ntdll_name			db	'NTDLL.DLL',0
kernel_name			db	'KERNEL32.DLL',0
user_name			db	'USER32.DLL',0

; ntdll.dll:
_RtlAddVectoredExceptionHandler	db	0,0,'RtlAddVectoredExceptionHandler',0

; kernel32.dll:
_VirtualAlloc			db	0,0,'VirtualAlloc',0
_VirtualProtect			db	0,0,'VirtualProtect',0

; user32.dll:
_MessageBoxA			db	0,0,'MessageBoxA',0
