IMAGE_DOS_SIGNATURE			=	'MZ'
IMAGE_NT_SIGNATURE			=	'PE'

struct	IMAGE_DOS_HEADER
	e_magic				rw	1	; Magic number
	e_cblp				rw	1	; Bytes on last page of file
	e_cp				rw	1	; Pages in file
	e_crlc				rw	1	; Relocations
	e_cparhdr			rw	1	; Size of header in paragraphs
	e_minalloc			rw	1	; Minimum extra paragraphs needed
	e_maxalloc			rw	1	; Maximum extra paragraphs needed
	e_ss				rw	1	; Initial (relative) SS value
	e_sp				rw	1	; Initial SP value
	e_csum				rw	1	; Checksum
	e_ip				rw	1	; Initial IP value
	e_cs				rw	1	; Initial (relative) CS value
	e_lfarlc			rw	1	; File address of relocation table
	e_ovno				rw	1	; Overlay number
	e_res				rw	4	; Reserved words
	e_oemid				rw	1	; OEM identifier (for e_oeminfo)
	e_oeminfo			rw	1	; OEM information; e_oemid specific
	e_res2				rw	10	; Reserved words
	e_lfanew			rd	1	; File address of new exe header
ends


struct	IMAGE_FILE_HEADER
	Machine				rw	1
	NumberOfSections		rw	1
	TimeDateStamp			rd	1
	PointerToSymbolTable		rd	1
	NumberOfSymbols			rd	1
	SizeOfOptionalHeader		rw	1
	Characteristics			rw	1
ends
IMAGE_SIZEOF_FILE_HEADER		=	sizeof.IMAGE_FILE_HEADER	; = 20


IMAGE_FILE_RELOCS_STRIPPED		=	0001h	; Relocation info stripped from file.
IMAGE_FILE_EXECUTABLE_IMAGE		=	0002h	; File is executable (i.e. no unresolved externel references).
IMAGE_FILE_LINE_NUMS_STRIPPED		=	0004h	; Line nunbers stripped from file.
IMAGE_FILE_LOCAL_SYMS_STRIPPED		=	0008h	; Local symbols stripped from file.
IMAGE_FILE_AGGRESIVE_WS_TRIM		=	0010h	; Agressively trim working set
IMAGE_FILE_LARGE_ADDRESS_AWARE		=	0020h	; App can handle >2gb addresses
IMAGE_FILE_BYTES_REVERSED_LO		=	0080h	; Bytes of machine word are reversed.
IMAGE_FILE_32BIT_MACHINE		=	0100h	; 32 bit word machine.
IMAGE_FILE_DEBUG_STRIPPED		=	0200h	; Debugging info stripped from file in .DBG file
IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP	=	0400h	; If Image is on removable media, copy and run from the swap file.
IMAGE_FILE_NET_RUN_FROM_SWAP		=	0800h	; If Image is on Net, copy and run from the swap file.
IMAGE_FILE_SYSTEM			=	1000h	; System File.
IMAGE_FILE_DLL				=	2000h	; File is a DLL.
IMAGE_FILE_UP_SYSTEM_ONLY		=	4000h	; File should only be run on a UP machine
IMAGE_FILE_BYTES_REVERSED_HI		=	8000h	; Bytes of machine word are reversed.

IMAGE_FILE_MACHINE_UNKNOWN		=	0
IMAGE_FILE_MACHINE_I386			=	014Ch	; Intel 386.
IMAGE_FILE_MACHINE_R3000		=	0162h	; MIPS little-endian, 0x160 big-endian
IMAGE_FILE_MACHINE_R4000		=	0166h	; MIPS little-endian
IMAGE_FILE_MACHINE_R1000		=	0168h	; MIPS little-endian
IMAGE_FILE_MACHINE_WCEMIPSV2		=	0169h	; MIPS little-endian WCE v2
IMAGE_FILE_MACHINE_ALPHA		=	0184h	; Alpha_AXP
IMAGE_FILE_MACHINE_SH3			=	01A2h	; SH3 little-endian
IMAGE_FILE_MACHINE_SH3DSP		=	01A3h
IMAGE_FILE_MACHINE_SH3E			=	01A4h	; SH3E little-endian
IMAGE_FILE_MACHINE_SH4			=	01A6h	; SH4 little-endian
IMAGE_FILE_MACHINE_SH5			=	01A8h	; SH5
IMAGE_FILE_MACHINE_ARM			=	01C0h	; ARM Little-Endian
IMAGE_FILE_MACHINE_THUMB		=	01C2h
IMAGE_FILE_MACHINE_AM33			=	01D3h
IMAGE_FILE_MACHINE_POWERPC		=	01F0h	; IBM PowerPC Little-Endian
IMAGE_FILE_MACHINE_POWERPCFP		=	01F1h
IMAGE_FILE_MACHINE_IA64			=	0200h	; Intel 64
IMAGE_FILE_MACHINE_MIPS16		=	0266h	; MIPS
IMAGE_FILE_MACHINE_ALPHA64		=	0284h	; ALPHA64
IMAGE_FILE_MACHINE_MIPSFPU		=	0366h	; MIPS
IMAGE_FILE_MACHINE_MIPSFPU16		=	0466h	; MIPS
IMAGE_FILE_MACHINE_AXP64		=	IMAGE_FILE_MACHINE_ALPHA64
IMAGE_FILE_MACHINE_TRICORE		=	0520h	; Infineon
IMAGE_FILE_MACHINE_CEF			=	0CEFh
IMAGE_FILE_MACHINE_EBC			=	0EBCh	; EFI Byte Code
IMAGE_FILE_MACHINE_AMD64		=	8664h	; AMD64 (K8)
IMAGE_FILE_MACHINE_M32R			=	9041h	; M32R little-endian
IMAGE_FILE_MACHINE_CEE			=	0C0EEh


struct	IMAGE_DATA_DIRECTORY
	VirtualAddress			rd	1
	Size				rd	1
ends
IMAGE_NUMBEROF_DIRECTORY_ENTRIES	=	16


struct	IMAGE_OPTIONAL_HEADER64
; Standard fields.
	Magic				rw	1
	MajorLinkerVersion		rb	1
	MinorLinkerVersion		rb	1
	SizeOfCode			rd	1
	SizeOfInitializedData		rd	1
	SizeOfUninitializedData		rd	1
	AddressOfEntryPoint		rd	1
	BaseOfCode			rd	1
; NT additional fields.
	ImageBase			rq	1
	SectionAlignment		rd	1
	FileAlignment			rd	1
	MajorOperatingSystemVersion	rw	1
	MinorOperatingSystemVersion	rw	1
	MajorImageVersion		rw	1
	MinorImageVersion		rw	1
	MajorSubsystemVersion		rw	1
	MinorSubsystemVersion		rw	1
	Win32VersionValue		rd	1
	SizeOfImage			rd	1
	SizeOfHeaders			rd	1
	CheckSum			rd	1
	Subsystem			rw	1
	DllCharacteristics		rw	1
	SizeOfStackReserve		rq	1
	SizeOfStackCommit		rq	1
	SizeOfHeapReserve		rq	1
	SizeOfHeapCommit		rq	1
	LoaderFlags			rd	1
	NumberOfRvaAndSizes		rd	1
;	IMAGE_DATA_DIRECTORY	DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
	DataDirectory			IMAGE_DATA_DIRECTORY
					rb	(IMAGE_NUMBEROF_DIRECTORY_ENTRIES-1)*(sizeof.IMAGE_DATA_DIRECTORY)
ends
IMAGE_SIZEOF_NT_OPTIONAL64_HEADER	=	240
IMAGE_NT_OPTIONAL_HDR64_MAGIC		=	020Bh


struct	IMAGE_NT_HEADERS64
	Signature			rd	1
	FileHeader			IMAGE_FILE_HEADER
	OptionalHeader			IMAGE_OPTIONAL_HEADER64
ends


; Section characteristics.
IMAGE_SCN_TYPE_REG			=	00000000h
IMAGE_SCN_TYPE_DSECT			=	00000001h
IMAGE_SCN_TYPE_NOLOAD			=	00000002h
IMAGE_SCN_TYPE_GROUP			=	00000004h
IMAGE_SCN_TYPE_NO_PAD			=	00000008h
IMAGE_SCN_TYPE_COPY			=	00000010h
IMAGE_SCN_CNT_CODE			=	00000020h	; Section contains code.
IMAGE_SCN_CNT_INITIALIZED_DATA		=	00000040h	; Section contains initialized data.
IMAGE_SCN_CNT_UNINITIALIZED_DATA	=	00000080h	; Section contains uninitialized data.
IMAGE_SCN_LNK_OTHER			=	00000100h	; Reserved.
IMAGE_SCN_LNK_INFO			=	00000200h	; Section contains comments or some other type of information.
IMAGE_SCN_TYPE_OVER			=	00000400h	; Reserved.
IMAGE_SCN_LNK_REMOVE			=	00000800h	; Section contents will not become part of image.
IMAGE_SCN_LNK_COMDAT			=	00001000h	; Section contents comdat.
;						00002000h	; Reserved.
;IMAGE_SCN_MEM_PROTECTED - Obsolete		00004000h
IMAGE_SCN_NO_DEFER_SPEC_EXC		=	00004000h	; Reset speculative exceptions handling bits in the TLB entries for this section.
IMAGE_SCN_GPREL				=	00008000h	; Section content can be accessed relative to GP
IMAGE_SCN_MEM_FARDATA			=	00008000h
;IMAGE_SCN_MEM_SYSHEAP - Obsolete		00010000h
IMAGE_SCN_MEM_PURGEABLE			=	00020000h
IMAGE_SCN_MEM_16BIT			=	00020000h
IMAGE_SCN_MEM_LOCKED			=	00040000h
IMAGE_SCN_MEM_PRELOAD			=	00080000h
IMAGE_SCN_ALIGN_1BYTES			=	00100000h
IMAGE_SCN_ALIGN_2BYTES			=	00200000h
IMAGE_SCN_ALIGN_4BYTES			=	00300000h
IMAGE_SCN_ALIGN_8BYTES			=	00400000h
IMAGE_SCN_ALIGN_16BYTES			=	00500000h	; Default alignment if no others are specified.
IMAGE_SCN_ALIGN_32BYTES			=	00600000h
IMAGE_SCN_ALIGN_64BYTES			=	00700000h
IMAGE_SCN_ALIGN_128BYTES		=	00800000h
IMAGE_SCN_ALIGN_256BYTES		=	00900000h
IMAGE_SCN_ALIGN_512BYTES		=	00A00000h
IMAGE_SCN_ALIGN_1024BYTES		=	00B00000h
IMAGE_SCN_ALIGN_2048BYTES		=	00C00000h
IMAGE_SCN_ALIGN_4096BYTES		=	00D00000h
IMAGE_SCN_ALIGN_8192BYTES		=	00E00000h
IMAGE_SCN_ALIGN_MASK			=	00F00000h
IMAGE_SCN_LNK_NRELOC_OVFL		=	01000000h	; Section contains extended relocations.
IMAGE_SCN_MEM_DISCARDABLE		=	02000000h	; Section can be discarded.
IMAGE_SCN_MEM_NOT_CACHED		=	04000000h	; Section is not cachable.
IMAGE_SCN_MEM_NOT_PAGED			=	08000000h	; Section is not pageable.
IMAGE_SCN_MEM_SHARED			=	10000000h	; Section is shareable.
IMAGE_SCN_MEM_EXECUTE			=	20000000h	; Section is executable.
IMAGE_SCN_MEM_READ			=	40000000h	; Section is readable.
IMAGE_SCN_MEM_WRITE			=	80000000h	; Section is writeable.

; Directory Entries
IMAGE_DIRECTORY_ENTRY_EXPORT		=	0		; Export Directory
IMAGE_DIRECTORY_ENTRY_IMPORT		=	1		; Import Directory
IMAGE_DIRECTORY_ENTRY_RESOURCE		=	2		; Resource Directory
IMAGE_DIRECTORY_ENTRY_EXCEPTION		=	3		; Exception Directory
IMAGE_DIRECTORY_ENTRY_SECURITY		=	4		; Security Directory
IMAGE_DIRECTORY_ENTRY_BASERELOC		=	5		; Base Relocation Table
IMAGE_DIRECTORY_ENTRY_DEBUG		=	6		; Debug Directory
; IMAGE_DIRECTORY_ENTRY_COPYRIGHT	=	7		; (X86 usage)
IMAGE_DIRECTORY_ENTRY_ARCHITECTURE	=	7		; Architecture Specific Data
IMAGE_DIRECTORY_ENTRY_GLOBALPTR		=	8		; RVA of GP
IMAGE_DIRECTORY_ENTRY_TLS		=	9		; TLS Directory
IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG	=	10		; Load Configuration Directory
IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT	=	11		; Bound Import Directory in headers
IMAGE_DIRECTORY_ENTRY_IAT		=	12		; Import Address Table
IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT	=	13		; Delay Load Import Descriptors
IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR	=	14		; COM Runtime descriptor


; Section header format.
IMAGE_SIZEOF_SHORT_NAME			=	8

struct	IMAGE_SECTION_HEADER
	Name				rb	IMAGE_SIZEOF_SHORT_NAME
	union
		PhysicalAddress		rd	1
		VirtualSize		rd	1
	ends
	VirtualAddress			rd	1
	SizeOfRawData			rd	1
	PointerToRawData		rd	1
	PointerToRelocations		rd	1
	PointerToLinenumbers		rd	1
	NumberOfRelocations		rw	1
	NumberOfLinenumbers		rw	1
	Characteristics			rd	1
ends
IMAGE_SIZEOF_SECTION_HEADER		=	sizeof.IMAGE_SECTION_HEADER	; = 40


struct	IMAGE_EXPORT_DIRECTORY
	Characteristics			rd	1
	TimeDateStamp			rd	1
	MajorVersion			rw	1
	MinorVersion			rw	1
	Name				rd	1
	Base				rd	1
	NumberOfFunctions		rd	1
	NumberOfNames			rd	1
	AddressOfFunctions		rd	1	; RVA from base of image
	AddressOfNames			rd	1	; RVA from base of image
	AddressOfNameOrdinals		rd	1	; RVA from base of image
ends


; Resource Format.
; Resource directory consists of two counts, following by a variable length
; array of directory entries. The first count is the number of entries at
; beginning of the array that have actual names associated with each entry.
; The entries are in ascending order, case insensitive strings. The second
; count is the number of entries that immediately follow the named entries.
; This second count identifies the number of entries that have 16-bit integer
; Ids as their name. These entries are also sorted in ascending order.
; This structure allows fast lookup by either name or number, but for any
; given resource entry only one form of lookup is supported, not both.
; This is consistant with the syntax of the .RC file and the .RES file.
struct	IMAGE_RESOURCE_DIRECTORY
	Characteristics			rd	1
	TimeDateStamp			rd	1
	MajorVersion			rw	1
	MinorVersion			rw	1
	NumberOfNamedEntries		rw	1
	NumberOfIdEntries		rw	1
ends


IMAGE_RESOURCE_NAME_IS_STRING		=	80000000h
IMAGE_RESOURCE_DATA_IS_DIRECTORY	=	80000000h


; Each directory contains the 32-bit Name of the entry and an offset,
; relative to the beginning of the resource directory of the data associated
; with this directory entry. If the name of the entry is an actual text
; string instead of an integer Id, then the high order bit of the name field
; is set to one and the low order 31-bits are an offset, relative to the
; beginning of the resource directory of the string, which is of type
; IMAGE_RESOURCE_DIRECTORY_STRING. Otherwise the high bit is clear and the
; low-order 16-bits are the integer Id that identify this resource directory
; entry. If the directory entry is yet another resource directory (i.e. a
; subdirectory), then the high order bit of the offset field will be
; set to indicate this. Otherwise the high bit is clear and the offset
; field points to a resource data entry.
struct	IMAGE_RESOURCE_DIRECTORY_ENTRY
	union
		NameOffset		rd	1	; bits 0-30
		NameIsString		rd	1	; bit 31
		Name			rd	1
		Id			rw	1
	ends
	union
		OffsetToData		rd	1
		OffsetToDirectory	rd	1	; bits 0-30
		DataIsDirectory		rd	1	; bit 31
	ends
ends


; For resource directory entries that have actual string names, the Name
; field of the directory entry points to an object of the following type.
; All of these string objects are stored together after the last resource
; directory entry and before the first resource data object. This minimizes
; the impact of these variable length objects on the alignment of the fixed
; size directory entry objects.
struct	IMAGE_RESOURCE_DIRECTORY_STRING
	Length				rw	1
	NameString			rb	1	; usually more than 1...
ends


struct	IMAGE_RESOURCE_DIR_STRING_U
	Length				rw	1
	NameString			rw	1	; usually more than 1...
ends


; Each resource data entry describes a leaf node in the resource directory
; tree. It contains an offset, relative to the beginning of the resource
; directory of the data for the resource, a size field that gives the number
; of bytes of data at that offset, a CodePage that should be used when
; decoding code point values within the resource data. Typically for new
; applications the code page would be the unicode code page.
struct	IMAGE_RESOURCE_DATA_ENTRY
	OffsetToData			rd	1
	Size				rd	1
	CodePage			rd	1
	Reserved			rd	1
ends

