; compiled with FASM 1.70.03

format PE64 GUI at 100000000h on 'nul'
entry start


include '%fasminc%/win64a.inc'
include 'win64struc.inc'			; win64 structures
include 'WinNT.h.inc'				; PE32+ header structures
include 'win64const.inc'			; various constants which aren't in the FASM includes
include 'macro_align.inc'			; macros for AMDPad16, padding with zeros
include 'macro_copy_repz_movs.inc'		; macros for copy by repz movsd, repz movsq
include 'fdbg_constants.inc'			; FDBG windows sizes and constants
include 'fdbg_structures.inc'


section '.text' code readable executable

start:
	sub	rsp,8*(4+11)			; reserve stack space for API, biggest space needed for WindowsClassEx
						; 4 qwords may be used and destroyed by API
						; 11 qwords usable for us
						; subtracting nonparity power of 8 make rsp align 16
						; allways keep RSP aligned 16 when you call API !!!
						; this is because win64 uses movdqa xmm...,[rsp+...]

	call	check_lahf_sahf

	lea	rdx,[old_dir]
	mov	ecx,Directory_max_size-2
	call	[GetCurrentDirectoryA]

	xor	ecx,ecx
	call	[GetModuleHandleA]
	mov	[hInstance],rax

	lea	rsi,[ini_file]
	lea	rdi,[help_file]

	mov	r8d,Directory_max_size
;       lea     rdx,[rsi]
	push	rsi
	pop	rdx
;       mov     rcx,rax
	push	rax
	pop	rcx
	call	[GetModuleFileNameA]
	or	eax,eax
	jz	fdbg_path_done
;       mov     edx,eax
	xchg	edx,eax

	push	rdi
	lea	rdi,[rsi+rdx*1]
	or	ecx,-1
	mov	al,'\'
	std
	repnz scasb
	cld
	pop	rdi

	lea	ecx,[rdx+rcx*1+3]
	repz movsb

fdbg_path_done:
	movdqu	xmm0,dqword [face_file_name]
	movdqu	xmm1,dqword [help_file_name]
	movdqu	[rsi],xmm0
	movdqu	[rdi],xmm1

	xor	r9,r9
	lea	r8,[screen_client_area]
	xor	edx,edx
;       mov     ecx,SPI_GETWORKAREA
	lea	ecx,[rdx+SPI_GETWORKAREA]	; smaller opcode than above commented
	call	[SystemParametersInfoA]

; recalculate bottom right corner coordinates to relative size
	mov	ecx,[screen_client_area+4*1]
	mov	eax,[screen_client_area+4*0]
	sub	[screen_client_area+4*3],ecx
	sub	[screen_client_area+4*2],eax

	call	[GetCommandLineA]

; find the first separator or zero-terminator
scan_init_L0:
	inc	rax
	cmp	byte [rax],0
	jz	init_from_file		; if zero-terminator then finish scanning
	cmp	byte [rax],20h		; separator of strings, usually the TAB character (09h) or SPACE character (20h)
	jnbe	scan_init_L0

scan_init_L1:
	inc	rax
	cmp	byte [rax],0
	jz	init_from_file
	cmp	byte [rax],20h
	jbe	scan_init_L1

	cmp	byte [rax],'-'		; switch ?
	jnz	init_from_file

	mov	cl,byte [rax+1]
	and	cl,not ('D' xor 'd')	; convert uppercase and lowercase to the same letters
	cmp	cl,'d' and (not ('D' xor 'd'))
	jz	init_done

scan_init_next:
	jmp	scan_init_L0

init_from_file:
	call	load_ini_file

init_done:

; obtain_AVX_APIs
	and	[AVX_enabled],0 		; prepare to failure

	lea	rcx,[a_kernel32]
	call	[LoadLibraryA]
	or	rax,rax
	jz	after_AVX_APIs
	mov	rsi,rax
	mov	rdi,[GetProcAddress]

	lea	rdx,[a_GetEnabledXStateFeatures]
	mov	rcx,rsi
	call	rdi
	or	rax,rax
	jz	after_AVX_APIs
	call	rax
	mov	ecx,XSTATE_MASK_LEGACY_FLOATING_POINT or XSTATE_MASK_LEGACY_SSE or XSTATE_MASK_GSSE
	and	eax,ecx
	cmp	eax,ecx
	jnz	after_AVX_APIs

	lea	rdx,[a_InitializeContext]
	mov	rcx,rsi
	call	rdi
	mov	[InitializeContext],rax

	lea	rdx,[a_SetXStateFeaturesMask]
	mov	rcx,rsi
	call	rdi
	mov	[SetXStateFeaturesMask],rax

	lea	rdx,[a_GetXStateFeaturesMask]
	mov	rcx,rsi
	call	rdi
	mov	[GetXStateFeaturesMask],rax

	lea	rdx,[a_LocateXStateFeature]
	mov	rcx,rsi
	call	rdi
	mov	[LocateXStateFeature],rax

	or	[AVX_enabled],1 		; success
;SLV08cn                         db      0
;    .1                          db      'hexa (128 bit)',0
;    .2                          db      'packed doubles (2x 64 bit)',0
;    .3                          db      'packed singles (4x 32 bit)',0,0
;title_child08                   db      'XMM',0
	      mov  dword[SLV08cn.1+6],'256 '
	      mov  byte[SLV08cn.2+16],'4'
	      mov  byte[SLV08cn.3+16],'8'
	      mov  byte[title_child08],'Y'

after_AVX_APIs:



	bt	dword [face.Rambo],IDM_RAMBO_FWW - IDM_RAMBO
	jnc	WindowName_ClassName_done
Rambo_WindowName_ClassName:
	rdtsc
	and	dl,11b
	add	dl,5
	lea	rdi,[AppName]
	call	rambo_generate_string
	rdtsc
	mov	edx,eax
	bswap	eax
	and	dl,11b
	add	dl,4
	lea	rdi,[ClassName]
	call	rambo_generate_string
WindowName_ClassName_done:

	lea	rdi,[exceptions_to_ignore]
;       mov     ecx,number_of_exception         ; instruction has 5 bytes, too much for assembler coder...
	xor	eax,eax
	lea	ecx,[rax+number_of_exception]	; rax=0, instruction has 3 bytes only for number_of_exception=<7Fh
	cld
	repz stosd

	call	prepare_floating_tables

	lea	rcx,[face.font_default]
	call	[CreateFontIndirectA]
	mov	[hFont],rax

	mov	ebx,num_of_colors-1		; -1 because zero indexed (0=1st, 1=2nd...)
create_brushes:
	lea	rdx,[slv32_colors]
	mov	ecx,[rdx+rbx*8] 		; background color
	call	qword [CreateSolidBrush]
	lea	rdx,[hBrushes]
	mov	[rdx+rbx*8],rax
	dec	ebx
	jns	create_brushes

;       mov     r9d,PAGE_READWRITE
;       mov     r8d,MEM_COMMIT
;       mov     edx,LogEdit_buffer_size
;       xor     ecx,ecx
; smaller:
	xor	ecx,ecx
	lea	r9d,[rcx+PAGE_READWRITE]
	mov	r8d,MEM_COMMIT
	mov	edx,LogEdit_buffer_size
	call	[VirtualAlloc]
	mov	ecx,eax 			; exit code = 0 if failure
	or	rax,rax
	jz	exit
	mov	[LogEdit_buffer],rax
	mov	[LogEdit_end],rax

; create popup menu (another choice is not to create it but load it from res user32.LoadMenuA)
	call	[CreatePopupMenu]
	mov	[hPopupMenu],rax
	lea	r9,[aCopyContent]
	mov	r8d,IDM_COPY_CONTENT
if MF_STRING=0
	xor	edx,edx
else
	mov	edx,MF_STRING
end if
	mov	rcx,rax
	call	[AppendMenuA]

	xor	ecx,ecx 			; AMD64 zero extends 32-bit operation to 64-bit
						; so xor reg32,reg32 is enougn to zero the whole
						; 64-bit reg + has the benefit of saving REX prefix
;       mov     [rsp+8*4 + WNDCLASSEX64.cbClsExtra],ecx
;       mov     [rsp+8*4 + WNDCLASSEX64.cbWndExtra],ecx
	mov	qword [rsp+8*4 + WNDCLASSEX64.cbClsExtra],rcx

	lea	rdx,[WndProc]
	mov	rax,[hInstance]
	mov	[rsp+8*4 + WNDCLASSEX64.cbSize],sizeof.WNDCLASSEX64
	mov	[rsp+8*4 + WNDCLASSEX64.style],CS_HREDRAW + CS_VREDRAW
	mov	[rsp+8*4 + WNDCLASSEX64.lpfnWndProc],rdx
	mov	[rsp+8*4 + WNDCLASSEX64.hInstance],rax
	mov	[rsp+8*4 + WNDCLASSEX64.hbrBackground],COLOR_APPWORKSPACE
	lea	rax,[ClassName]
	mov	[rsp+8*4 + WNDCLASSEX64.lpszMenuName],ID_Menu01 
	mov	[rsp+8*4 + WNDCLASSEX64.lpszClassName],rax

	mov	edx,IDI_APPLICATION
;       xor     ecx,ecx                         ; ecx is already 0
	call	[LoadIconA]
	mov	[rsp+8*4 + WNDCLASSEX64.hIcon],rax
	mov	[rsp+8*4 + WNDCLASSEX64.hIconSm],rax	; use handle of big icon (32x32) like handle of small icon (16x16)

	mov	edx,IDC_ARROW
	xor	ecx,ecx
	call	[LoadCursorA]
	mov	[rsp+8*4 + WNDCLASSEX64.hCursor],rax

	lea	rcx,[rsp+8*(4+0)]
	call	[RegisterClassExA]

; Register the MDI child window class
	lea	rdx,[ChildProc]
	lea	rax,[MDIChildClassName]
	mov	[rsp+8*4 + WNDCLASSEX64.hbrBackground],COLOR_WINDOW
	mov	[rsp+8*4 + WNDCLASSEX64.lpfnWndProc],rdx
	mov	[rsp+8*4 + WNDCLASSEX64.lpszClassName],rax
	lea	rcx,[rsp+8*(4+0)]
	call	[RegisterClassExA]

	mov	rdx,qword [face.parent.x]
;       or      rdx,qword [face.parent.cx]      ; try if x, y, cx, cy are zeros = empty datas = necessity to calculate and store new
	and	rdx,qword [face.parent.cx]	; we can't create a win with any zero size parameter
	jnz	create_parent_win		; face.parent.cx <> 0 and face.parent.cy <> 0
						; any of window sizes shouldn't be zero
new_parent_size:
	movdqa	xmm0,dqword [screen_client_area]; grab x, y, cx, cy of the client area for a full-screen window
	psubd	xmm0,dqword [main_win_scr_minus]
	movdqa	dqword [face.parent],xmm0	; store x, y, cx, cy

create_parent_win:
	xor	ecx,ecx
	mov	rax,[hInstance]
	mov	[rsp+8*(4+7)],rcx		; pointer to window-creation data
	mov	[rsp+8*(4+6)],rax		; handle to application instance
	mov	[rsp+8*(4+5)],rcx		; resource name of the class menu,
						; or an integer to identify the menu
	mov	[rsp+8*(4+4)],rcx		; handle to parent or owner window
;       mov     edx,[face.parent.cy]
;       mov     eax,[face.parent.cx]
;       mov     dword [rsp+8*(4+3)],edx         ; height
;       mov     dword [rsp+8*(4+2)],eax         ; width
;       mov     edx,[face.parent.y]
;       mov     eax,[face.parent.x]
;       mov     dword [rsp+8*(4+1)],edx         ; vertical position of window
;       mov     dword [rsp+8*(4+0)],eax         ; horizontal position of window
	movdqa	xmm1,dqword [face.parent.x]
;       pxor    xmm2,xmm2
	movdqa	xmm0,xmm1
;       punpckhdq       xmm1,xmm2
	punpckhdq	xmm1,xmm1		; I don't worry about 2 unused duplicited dwords
;       punpckldq       xmm0,xmm2               ; if you worry, just uncomment instructions using xmm2
	punpckldq	xmm0,xmm0
	movdqa	[rsp+8*(4+2)],xmm1
	movdqa	[rsp+8*(4+0)],xmm0
	mov	r9d,WS_OVERLAPPEDWINDOW + WS_CLIPCHILDREN
; WS_OVERLAPPED + WS_CAPTION + WS_SYSMENU + WS_THICKFRAME + WS_MINIMIZEBOX      ; window style
	lea	r8,[AppName]
	lea	rdx,[ClassName]
;       xor     ecx,ecx                         ; ecx has been zeroed already
	call	[CreateWindowExA]
	mov	[hWndParent],rax

	mov	edx,GWL_STYLE
	mov	rcx,rax
	call	[GetWindowLongPtrA]
; we want everything except WS_MAXIMIZEBOX
	and	eax,not WS_MAXIMIZEBOX
	mov	r8d,eax
	mov	edx,GWL_STYLE
	mov	rcx,[hWndParent]
	call	[SetWindowLongPtrA]

	call	update_Rambo_MainMenu

	mov	edx,SW_SHOWDEFAULT
	mov	rcx,qword [hWndParent]		; hWnd
	call	[ShowWindow]

	mov	rcx,[hWndParent]		; hWnd
	call	[UpdateWindow]

	call	create_MDIChildren_and_its_controls

	mov	edx,ID_Accelerators02
	mov	rcx,[hInstance]
	call	[LoadAcceleratorsA]
	mov	[hAccelerators01],rax

AMDPad16
MsgLoop:
	xor	r9,r9
	xor	r8,r8
	xor	edx,edx 			; hWnd - handle of window
						; Identifies the window whose messages are to be retrieved. One value has a special meaning: 
						; Value 0 Meaning GetMessage retrieves messages for any window that belongs to the calling thread and thread messages posted to the calling thread via PostThreadMessage.
	lea	rcx,[rsp+8*4]
	call	[GetMessageA]
;If the function retrieves a message other than WM_QUIT, the return value is nonzero.
;If the function retrieves the WM_QUIT message, the return value is zero. 
;If there is an error, the return value is -1. For example, the function fails if hWnd is an invalid window handle.
	or	eax,eax
	jz	ExitMsgLoop

	lea	r8,[rsp+8*4]			; lpMsg - address of structure with message
	mov	rdx,[hAccelerators01]		; hAccTable - handle of accelerator table
	mov	rcx,[hWndParent]		; hWnd - handle of destination window
	call	[TranslateAcceleratorA]
; When TranslateAccelerator returns a nonzero value and the message is translated, the
; application should not use the TranslateMessage function to process the message again.
	or	eax,eax
	jnz	MsgLoop

	lea	rdx,[rsp+8*4]
	mov	rcx,[hWndClient]
	call	[TranslateMDISysAccel]
; If the message is translated into a system command, the return value is nonzero.
; If the message is not translated into a system command, the return value is zero.
	or	eax,eax
	jnz	MsgLoop

	lea	rcx,[rsp+8*4]
	call	[TranslateMessage]		; translates raw keyboard input into a WM_CHAR message

	lea	rcx,[rsp+8*4]
	call	[DispatchMessageA]		; Sends the message data to the window proc
	jmp	MsgLoop

ExitMsgLoop:
	mov	rcx,[hMenu01]
	call	[DestroyMenu]

	mov	rcx,[hPopupMenu]
	call	[DestroyMenu]

; Decommit LogEdit buffer
	mov	r8d,MEM_DECOMMIT
	mov	edx,LogEdit_buffer_size
	mov	rcx,[LogEdit_buffer]
	call	[VirtualFree]

	mov	ebx,num_of_colors-1
delete_brushes:
	lea	rdx,[hBrushes]
	mov	rcx,[rdx+rbx*8] 		; hBrush
	call	[DeleteObject]
	dec	ebx
	jns	delete_brushes

	mov	rcx,[hFont]
	call	[DeleteObject]

; restore directory
	lea	rcx,[old_dir]
	cmp	byte [rcx],0
	jz	restore_old_dir_done
	call	[SetCurrentDirectoryA]
restore_old_dir_done:

	call	save_ini_file

	mov	ecx,dword [rsp+8*4 + MSG64.wParam]
exit:
	call	[ExitProcess]			; no, Vista replaces ExitProcess with ntdll.RtlExitUserProcess
;       xor     eax,eax
;       add     rsp,8*(4+11)
;       ret

align 16
WndProc:
; RCX=hWnd, EDX=uMsg, R8=wParam, R9=lParam
	cmp	edx,WM_CREATE
	jz	WndProc_CREATE
	cmp	edx,WM_COMMAND
	jz	WndProc_COMMAND
	cmp	edx,WM_SIZE
	jz	WndProc_SIZE
	cmp	edx,WM_WINDOWPOSCHANGED
	jz	WndProc_WINDOWPOSCHANGED
	cmp	edx,WM_CLOSE
	jz	WndProc_CLOSE
	cmp	edx,WM_DESTROY
	jz	WndProc_DESTROY

align 16
; next routine is called very frequently, we should increase it's speed a bit by align 16
; routine common for both WndProc_DefFrameProcA as well WndProc_Def
WndProc_DefFrameProcA:
WndProc_Def:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	mov	[rsp+8*4],r9			; lParam
	mov	r9,r8				; wParam
	mov	r8d,edx 			; uMsg
	mov	rdx,[hWndClient]		; hWndMDIClient
;       mov     rcx,[rsp+8*(4+1+3)]             ; rcx=hWnd now
	call	[DefFrameProcA]
WndProc_COMMAND_end:
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
WndProc_CREATE:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+11)

; create status window:
	xor	r9,r9
	mov	r8,rcx				; = qword [rsp+8*(4+11+3)]
	xor	edx,edx
	mov	ecx,WS_CHILD or WS_VISIBLE or SBS_SIZEGRIP
	call	[CreateStatusWindowA]
	mov	[hWndStatus],rax

;       lea     rdx,[rsp+8*4]
;       mov     rcx,rax
;       call    [GetWindowRect]

	mov	dword [rsp+8*4	 ],128
	mov	dword [rsp+8*4 +4],256
	or	dword [rsp+8*4 +8],-1
	lea	r9,[rsp+8*4]
	mov	r8d,3
	mov	edx,SB_SETPARTS
	mov	rcx,rax
	call	[SendMessageA]

	call	update_status_window_PID_TID_empty

; create MDI Client window:

virtual at rsp+8*(4+8)
ccs	CLIENTCREATESTRUCT64
end virtual

	mov	rcx,[rsp+8*(4+11+3)]
	call	[GetMenu]
	mov	[hMenu01],rax

	mov	edx,MDI_CHILD_SUBMENU
	mov	rcx,rax
	call	[GetSubMenu]

	mov	[rsp+8*(4+8) + CLIENTCREATESTRUCT64.hWindowMenu],rax
	mov	[rsp+8*(4+8) + CLIENTCREATESTRUCT64.idFirstChild],ID_FirstChild

	lea	rcx,[rsp+8*(4+8)]
	mov	rax,[hInstance]
	mov	[rsp+8*(4+7)],rcx		; pointer to CLIENTCREATESTRUCT64
	mov	[rsp+8*(4+6)],rax		; handle to application instance
	mov	edx,CW_USEDEFAULT
	xor	ecx,ecx
	mov	rax,[rsp+8*(4+11+3)]		; grab hWnd from the stack
	mov	[rsp+8*(4+5)],rcx		; resource name of the class menu,
						; or an integer to identify the menu
	mov	[rsp+8*(4+4)],rax		; handle to parent or owner window
	mov	[rsp+8*(4+3)],edx		; height
	mov	[rsp+8*(4+2)],edx		; width
	mov	[rsp+8*(4+1)],edx		; y
	mov	[rsp+8*(4+0)],edx		; x

	mov	r9d,WS_CHILD + WS_VISIBLE + WS_CLIPCHILDREN
;       mov     r9d,WS_CHILD + WS_VISIBLE + WS_CLIPCHILDREN + WS_HSCROLL + WS_VSCROLL
	xor	r8,r8
	lea	rdx,[MDIClientName]
;       xor     ecx,ecx                         ; ecx has been zeroed already
	call	[CreateWindowExA]
	mov	[hWndClient],rax

; necessary only when we use SendMessageA hwnd, WM_MDICREATE, 0, mdicreate
; we needn't it because we use CreateWindowExA to create children
;       lea     rdx,[MDIChildClassName]
;       lea     rcx,[MDIChildTitle]
;       mov     rax,qword [hInstance]
;       mov     [mdicreate.szClass],rdx
;       mov     [mdicreate.szTitle],rcx
;       mov     [mdicreate.hOwner],rax
;       mov     [mdicreate.x],CW_USEDEFAULT
;       mov     [mdicreate.y],CW_USEDEFAULT
;       mov     [mdicreate.cx],CW_USEDEFAULT
;       mov     [mdicreate.cy],CW_USEDEFAULT
;       mov     [mdicreate.style],WS_MINIMIZE

	call	[GetCommandLineA]

cmd_params_L0:
	inc	rax
	mov	cl,[rax-1]
	cmp	cl,0
	jz	cmd_line_done
	cmp	cl,20h
	jnbe	cmd_params_L0

cmd_params_L1:
	inc	rax
	mov	cl,[rax-1]
	cmp	cl,0
	jz	cmd_line_done
	cmp	cl,20h
	jbe	cmd_params_L1

	cmp	cl,'-'				; param ?
	jnz	cmd_params_L5

	mov	cl,[rax]			; grab letter after param switch
	inc	rax
	cmp	cl,0
	jz	cmd_line_done
	and	cl,not ('A' xor 'a')		; conver uppercase and lowercase to the same letters

	cmp	cl,'n' and (not ('N' xor 'n'))
	jnz	cmd_params_L2
; halt in ntdll.DbgBreakPoing
	mov	byte [HaltOnChoice],HaltOn_ntdll_DbgBreakPoint
	jmp	cmd_params_L1

cmd_params_L2:
	cmp	cl,'t' and (not ('T' xor 't'))
	jnz	cmd_params_L1
	mov	[DebugOnlyThisProcess],1
	jmp	cmd_params_L1

cmd_params_L5:
; executable name and params
	lea	rdx,[FileNameBuffer_tmp]
	lea	r8,[shell_line]
cmd_params_copy_exe_name:
	mov	[rdx],cl
	mov	[r8],cl
	mov	cl,[rax]
	inc	rdx
	inc	r8
	inc	rax
	cmp	cl,0
	jz	check_input_debuggee
	cmp	cl,20h
	jnbe	cmd_params_copy_exe_name

	mov	cl,[rax]
	lea	r9,[arguments]
	cmp	cl,0
	jz	check_input_debuggee
	mov	byte [r8],' '
	inc	r8

; params
check_input_shell_line:
	mov	[r8],cl
	mov	[r9],cl
	inc	rax
	inc	r8
	inc	r9
	mov	cl,[rax]
	cmp	cl,0
	jnz	check_input_shell_line

; OK all params processed
check_input_debuggee:
	lea	r9,[rsp+8*(4+0)]
	lea	r8,[FileNameBuffer]
	mov	edx,Directory_max_size
	lea	rcx,[FileNameBuffer_tmp]
	call	[GetFullPathNameA]

	lea	rcx,[FileNameBuffer]
	call	check_PE32Plus
	jc	cmd_line_done

; for CMD_OPEN, so OpenFileDialog knows the last Directory...
	lea	rdx,[ofn_initdir]
	mov	ecx,Directory_max_size-2
	call	[GetCurrentDirectoryA]

; create debug thread
	lea	rdx,[DbgThreadId]
	mov	[rsp+8*(4+1)],rdx	; lpThreadId
;       mov     dword [rsp+8*(4+0)],0;NORMAL_PRIORITY_CLASS     ; dwCreationFlags
	xor	r9,r9			; lpParameter
	lea	r8,[DbgThreadStartAddr] ; lpStartAddress
	xor	edx,edx 		; dwStackSize
	xor	ecx,ecx 		; lpThreadAttributes
	mov	[rsp+8*(4+0)],edx	; edx=0 now
	call	[CreateThread]
; If the function succeeds, the return value is a handle to the new thread.
; If the function fails, the return value is NULL.
	mov	[hDbgThread],rax

cmd_line_done:

	xor	eax,eax
	add	rsp,8*(4+11)
	pop	r9 r8 rdx rcx
	ret

align 10h
WndProc_COMMAND:
; note, IDs must follow each other by +1 for this routine to work
; Kommandz_jump_table has array of offsets of routines terminated by offset of WndProc_Def
	push	rax
	push	rcx
	push	rdx

; try to destroy SysListView32 EDIT
	call	ListView_Edit_destroy

	lea	rax,[Kommandz_jump_table]
	movzx	ecx,r8w
	sub	ecx,ID_First
	mov	edx,ID_FirstFree - ID_First
	cmp	ecx,edx
	cmovnbe ecx,edx
	mov	rax,qword [rax+rcx*8]		; grab address of procedure
	pop	rdx
	pop	rcx
	xchg	[rsp],rax			; restore rax from the stack and store address
						; of procedure there for next ret
	ret

; commented, routine is the same like WndProc_DefFrameProcA
;align 16
;; next routine is called very frequently, we should increase it's speed a bit by align 16
;WndProc_Def:
;       push    rcx rdx r8 r9
;       sub     rsp,8*(4+1)
;       mov     [rsp+8*4],r9                    ; lParam
;       mov     r9,r8                           ; wParam
;       mov     r8d,edx                         ; uMsg
;       mov     rdx,[hWndClient]
;;      mov     rcx,[rsp+8*(4+1+3)]             ; not necessary, RCX=hWnd now
;       call    [DefFrameProcA]
;WndProc_COMMAND_end:
;       add     rsp,8*(4+1)
;       pop     r9 r8 rdx rcx
;       ret

CMD_EXIT:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)

	xor	r9,r9
	xor	r8,r8
	mov	edx,WM_CLOSE
;       mov     rcx,qword [rsp+8*(4+1+3)]
	call	qword [SendMessageA]

WndProc_COMMAND_end_zero:
	xor	eax,eax
;       add     rsp,8*(4+1)
;       pop     r9 r8 rdx rcx
;       ret
	jmp	WndProc_COMMAND_end

CMD_HELP:
	push	rcx rdx r8 r9 rsi rdi
	sub	rsp,8*(4+3)

;       lea     rcx,[old_dir]
;       mov     dword [rsp+8*(4+1)],SW_SHOWNORMAL
;       mov     qword [rsp+8*(4+0)],rcx
;       xor     r9,r9
;       lea     r8,[HelpFileName]
;       lea     rdx,[aopen]
;;      mov     rcx,qword [hWndParent]
;       xor     ecx,ecx                 ; rcx=0 else fdbg hang up when asking help debugging attached process
;       call    qword [ShellExecuteA]

; win2003 SP2 requires it in this way (full path with the file must be prepared)
	xor	ecx,ecx
	mov	dword [rsp+8*(4+1)],SW_SHOWNORMAL
	mov	qword [rsp+8*(4+0)],rcx
	xor	r9,r9
	lea	r8,[help_file]		; win2003 SP2 necessity to have full path before the file name
	xor	edx,edx
	call	qword [ShellExecuteA]

	xor	eax,eax
	add	rsp,8*(4+3)
	pop	rdi rsi r9 r8 rdx rcx
	ret


CMD_OPEN:
	push	rcx rdx rsi rdi r8 r9
a	=	4		; number of pushed registers
b	=	4		; number of qwords reserved for API
c	=	sizeof.OFN64	; stack frame in bytes
d	=	(c+7)/8 	; stack frame in qwords
e	=	(a+b+d+1) and 1 ; alignin stack 16
	sub	rsp,8*(b+d+e)

virtual at rsp+8*4
ofn	OFN64
end virtual

	pxor	xmm0,xmm0
	mov	rax,qword [hInstance]
	mov	[ofn.lStructSize],sizeof.OFN64
	mov	[ofn.hwndOwner],rcx
	mov	[ofn.hInstance],rax
	lea	rdx,[FilterString]
	lea	rax,[FileNameBuffer]
	movdqa	dqword [ofn+8*4],xmm0
	movdqa	dqword [ofn+8*8],xmm0

if d>=12
	movdqa	dqword [ofn+8*10],xmm0
end if

if d>=14
	movdqa	dqword [ofn+8*12],xmm0
end if

if d>=16
	movdqa	dqword [ofn+8*14],xmm0
end if

	mov	[ofn.lpstrFilter],rdx
	mov	[ofn.lpstrFile],rax
; Pointer to a buffer that contains a filename used to initialize the File Name edit control.
; The first character of this buffer must be NULL if initialization is not necessary.
; For our first time, this byte is 0 because is in unitialized data.
; At the second, this string is initialized by previous
; selection

	mov	[ofn.nMaxFile],OFNMaxFileNameSize
	lea	rdx,[OFNTitle]
	lea	rax,[OFNHookProc]
	mov	[ofn.lpstrTitle],rdx
	mov	qword [ofn.Flags],OFN_ENABLEHOOK or OFN_ENABLETEMPLATE or OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_EXPLORER or OFN_HIDEREADONLY or OFN_NOCHANGEDIR
	mov	[ofn.lpfnHook],rax
	lea	rdx,[ofn_initdir]
	cmp	byte [rdx],0
	jz	CMD_OPEN_initdir_done
	mov	[ofn.lpstrInitialDir],rdx
CMD_OPEN_initdir_done:
	mov	[ofn.lpTemplateName],ID_OFNDialog
	lea	rcx,[ofn]
	call	qword [GetOpenFileNameA]
	or	rax,rax
	jz	CMD_OPEN_epilogue		; we leave procedure with eax=0 too

	lea	rdi,[FileNameBuffer]

	push	rdi
	pop	rcx
	call	check_PE32Plus
	jc	CMD_OPEN_bad_input_file

;       lea     rax,[tmp_buf]
;       mov     dword [rax],'0' shl 16 + 0A0Dh
;       call    msg_to_LogEdit

;       lea     rdi,[FileNameBuffer]
	or	ecx,-1
	xor	eax,eax
	lea	rsi,[rdi]
	cld
	repnz scasb
	not	ecx
	lea	rdi,[rdi-1]
	mov	r8,rcx
	mov	al,'\'
	std
	repnz scasb
	cld
	lea	ecx,[rcx+1]
	sub	r8,rcx
	lea	rdi,[Directory]
	repz movsb
	mov	byte [rdi],cl		; 0-terminated string

	lea	rdi,[shell_line]
	mov	rcx,r8
	repz movsb

	mov	ecx,dword [arguments_size]
	jrcxz	no_arguments
	mov	byte [rdi-1],' '
	lea	rsi,[arguments]
	repz movsb
no_arguments:
	mov	byte [rdi],cl		; zero terminator

	lea	rdx,[DbgThreadId]
	mov	qword [rsp+8*(4+1)],rdx ; lpThreadId
;       mov     dword [rsp+8*(4+0)],0;NORMAL_PRIORITY_CLASS     ; dwCreationFlags
	xor	r9,r9			; lpParameter
	lea	r8,[DbgThreadStartAddr] ; lpStartAddress
	xor	edx,edx 		; dwStackSize
	xor	ecx,ecx 		; lpThreadAttributes
	mov	dword [rsp+8*(4+0)],edx ; edx=0 now
	call	qword [CreateThread]
; If the function succeeds, the return value is a handle to the new thread.
; If the function fails, the return value is NULL.
	mov	qword [hDbgThread],rax

CMD_OPEN_zeroexit_epilogue:
	xor	eax,eax
CMD_OPEN_epilogue:
	add	rsp,8*(b+d+e)
	pop	r9 r8 rdi rsi rdx rcx
	ret

check_PE32Plus:
; in:   RCX points to path+filename+zeroterminator
; out:  CF=0 PE32+, CF=1 not PE32+
	push	rbx rbp rdi
	sub	rsp,8*(4+4)

	xor	ebp,ebp 					; ebp=0 failure, ebp=1 success

	and	qword [rsp+8*(4+2)],0				; hTemplateFile
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL	; dwFlagsAndAttributes
	mov	dword [rsp+8*(4+0)],OPEN_EXISTING		; dwCreationDistribution
	xor	r9,r9						; lpSecurityAttributes
	mov	r8d,FILE_SHARE_READ				; dwShareMode
	mov	edx,GENERIC_READ				; dwDesiredAccess
;       lea     rcx,[rcx]                                       ; lpFileName
	call	qword [CreateFileA]

	push	rax
	pop	rbx						; save file handle

if INVALID_HANDLE_VALUE = -1
	inc	rax
else
	cmp	rax,INVALID_HANDLE_VALUE
end if

	jz	check_PE32Plus_epi

	lea	rdi,[tmp_buf]

	and	qword [rsp + 8*(4+0)],0 	; lpOverlapped
	lea	r9,[rsp + 8*(4+2)]		; lpNumberOfBytesWritten
	mov	r8d,sizeof.IMAGE_DOS_HEADER	; nNumberOfBytesToWrite
	push	rdi
	pop	rdx				; lpBuffer
	push	rbx
	pop	rcx				; hFile
	call	qword [ReadFile]
	or	eax,eax
	jz	check_PE32Plus_close_epi
	cmp	dword [rsp + 8*(4+2)],sizeof.IMAGE_DOS_HEADER
	jnz	check_PE32Plus_close_epi

	cmp	[rdi+IMAGE_DOS_HEADER.e_magic],IMAGE_DOS_SIGNATURE
	jnz	check_PE32Plus_close_epi

if FILE_BEGIN = 0
	xor	r9,r9
else
	mov	r9d,FILE_BEGIN
end if

	xor	r8,r8
	mov	edx,[rdi+IMAGE_DOS_HEADER.e_lfanew]
	push	rbx
	pop	rcx
	call	qword [SetFilePointer]
	cmp	[rdi+IMAGE_DOS_HEADER.e_lfanew],eax
	jnz	check_PE32Plus_close_epi

	and	qword [rsp + 8*(4+0)],0 	; lpOverlapped
	lea	r9,[rsp + 8*(4+2)]		; lpNumberOfBytesWritten
	mov	r8d,4 + IMAGE_SIZEOF_FILE_HEADER +  2	; nNumberOfBytesToRead
	push	rdi
	pop	rdx				; lpBuffer
	push	rbx
	pop	rcx				; hFile
	call	qword [ReadFile]
	or	eax,eax
	jz	check_PE32Plus_close_epi
	cmp	dword [rsp + 8*(4+2)],4 + IMAGE_SIZEOF_FILE_HEADER + 2	; 2 for IMAGE_OPTIONAL_HEADER64.Magic
	jnz	check_PE32Plus_close_epi

	cmp	[rdi+IMAGE_NT_HEADERS64.Signature],IMAGE_NT_SIGNATURE
	jnz	check_PE32Plus_close_epi
	cmp	[rdi+IMAGE_NT_HEADERS64.FileHeader.Machine],IMAGE_FILE_MACHINE_AMD64
	jnz	check_PE32Plus_close_epi
	cmp	[rdi+IMAGE_NT_HEADERS64.FileHeader.SizeOfOptionalHeader],IMAGE_SIZEOF_NT_OPTIONAL64_HEADER
	jnz	check_PE32Plus_close_epi
	cmp	[rdi+IMAGE_NT_HEADERS64.OptionalHeader.Magic],IMAGE_NT_OPTIONAL_HDR64_MAGIC
;       jnz     check_PE32Plus_close_epi        ; not necessary, following setz bl does the job

	setz	bpl				; yes, it is PE32+

check_PE32Plus_close_epi:
	push	rbx
	pop	rcx
	call	qword [CloseHandle]

check_PE32Plus_epi:
	add	rsp,8*(4+4)
	sub	bpl,1				; set or clear Carry Flag
	pop	rdi rbp rbx
	ret

CMD_OPEN_bad_input_file:
	lea	rax,[msg_bad_input_file]
	call	msg_to_LogEdit
; prepare log view to be cleared at begin of next job
	mov	rax,qword [LogEdit_buffer]
	mov	qword [LogEdit_end],rax
	mov	byte [rax],0		; make 0-terminated string
	jmp	CMD_OPEN_zeroexit_epilogue

align 16
OFNHookProc:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	cmp	edx,WM_INITDIALOG
	jz	OFNHookProc_InitDialog
	cmp	edx,WM_NOTIFY
	jz	OFNHookProc_Notify
	xor	eax,eax 			; If the hook procedure returns zero,
						; the default dialog box procedure processes
						; the message.

AMDPad16
OFNHookProc_end:
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
OFNHookProc_InitDialog:
	mov	edx,ID_OFNDialogEditText0
	mov	rcx,qword [rsp + 8*(4+1+3)]
	call	qword [GetDlgItem]

	xor	r9,r9
	mov	r8d,arguments_max_size
	mov	edx,EM_SETLIMITTEXT
	mov	rcx,rax
	call	qword [SendMessageA]

	lea	r8,[arguments]
	mov	edx,ID_OFNDialogEditText0
	mov	rcx,qword [rsp + 8*(4+1+3)]
	call	qword [SetDlgItemTextA]

	movzx	r8d,byte [DebugOnlyThisProcess]
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	mov	edx,ID_OFNDialogAutoCheckBox0
	mov	rcx,qword [rsp + 8*(4+1+3)]
	call	qword [CheckDlgButton]

	movzx	r8d,byte [HaltOnChoice]
;HaltOn_ntdll_DbgBreakPoint     =       0
;HaltOn_ntdll_ExeEntryPoint     =       1
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	mov	edx,ID_OFNDialogAutoCheckBox1
	mov	rcx,qword [rsp + 8*(4+1+3)]
	call	qword [CheckDlgButton]

	mov	eax,1				; If the hook procedure returns a nonzero
						; value, the default dialog box procedure
						; ignores the message.
	jmp	OFNHookProc_end

align 16
OFNHookProc_Notify:
	mov	r9d,arguments_max_size
	lea	r8,[arguments]
	mov	edx,ID_OFNDialogEditText0
	mov	rcx,qword [rsp + 8*(4+1+3)]
	call	qword [GetDlgItemTextA]
;       or      eax,eax                         ; API returns eax=0 if nothing in OFNDialogEditText0
	mov	dword [arguments_size],eax

	mov	edx,ID_OFNDialogAutoCheckBox0
	mov	rcx,qword [rsp + 8*(4+1+3)]
	call	qword [IsDlgButtonChecked]
;BST_UNCHECKED          = 0
;BST_CHECKED            = 1
	mov	byte [DebugOnlyThisProcess],al

	mov	edx,ID_OFNDialogAutoCheckBox1
	mov	rcx,qword [rsp + 8*(4+1+3)]
	call	qword [IsDlgButtonChecked]
	mov	byte [HaltOnChoice],al
;       mov     byte [put_BP_at_exe_entry_and_run],al   ; not necessary, will be set later

	mov	eax,1
	jmp	OFNHookProc_end

align 16
DbgThreadStartAddr:
	push	rcx rdx rbx rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15

a	=	14			; number of pushed registers
b	=	4			; number of qwords reserved for API
c	=	0;sizeof.PROCESS_INFORMATION64  ; stack frame in bytes
d	=	(c+7)/8 		; stack frame in qwords
e	=	0;sizeof.STARTUPINFO64
f	=	(e+7)/8
g	=	(a+b+d+f+1) and 1	; aligning stack 16
	sub	rsp,8*(b+d+f+g)

;       lea     rax,[tmp_buf]
;       mov     dword [rax],'1' shl 16 + 0A0Dh
;       call    msg_to_LogEdit

DbgThread_L0:
; clear debug registers image for all threads
	lea	rdi,[HW_BP_permanent]
	mov	ecx,1+6
	xor	eax,eax
	cld
	repz stosq

	mov	dl,byte [HaltOnChoice]
	mov	byte [restarting_debuggee],al	; al=0
	mov	byte [put_BP_at_exe_entry_and_run],dl

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT

a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
;       mov     edx,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2
;                               ; store PID...hProcess, TID...hThread, PID...TID, TID...ThreadLocalBase=GS_segment_register=TEB
	mov	edx,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2 + MaxProcesses*8*2
				; store PID...hProcess, TID...hThread, PID...TID, TID...ThreadLocalBase=GS_segment_register=TEB, PID...PEB
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	DbgThread_L8
	mov	qword [multiprocess_multithread_support_address],rax

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	edx,MaxNumberOfBreakpoints * (8+4+1+1)	; every bp use 1 qword address, 1 dword process Id, 1 byte save byte before put db 0CC on it, 1 byte flag if clear bp after triggered
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	DbgThread_L7
	mov	qword [breakpoints_space_address],rax

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	edx,MaxNumberOfModulesInfo * 8 * 4
; every entry has 4 qwords: begin, end, size of info, (dword PID, dword flag_module_...)
; first slot is occupied by image = loaded executable process
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	DbgThread_L6
	mov	qword [module_info_address],rax
 
;       lea     rax,[tmp_buf]
;       mov     dword [rax],'2' shl 16 + 0A0Dh
;       call    msg_to_LogEdit

; set new working directory for ability to find debug .pdb files
	lea	rdx,[Directory]
	cmp	byte [rdx],0
	jnz	we_have_orig_dir
	mov	ecx,Directory_max_size-2
	call	qword [GetCurrentDirectoryA]
we_have_orig_dir:
	lea	rcx,[Directory]
	call	qword [SetCurrentDirectoryA]

	lea	rcx,[StartupInfo]
	mov	dword [rcx + STARTUPINFO64.cb],sizeof.STARTUPINFO64
	call	qword [GetStartupInfoA]

	mov	edx,DEBUG_PROCESS
	mov	ecx,DEBUG_PROCESS or DEBUG_ONLY_THIS_PROCESS
	cmp	byte [DebugOnlyThisProcess],1
	cmovz	edx,ecx 		; dwCreationFlags 6th arg
	lea	rax,[ProcessInfo]
	lea	rcx,[StartupInfo]
	mov	qword [rsp+8*(4+5)],rax ; store 10th argument
	mov	qword [rsp+8*(4+4)],rcx ; store 9th argument
	lea	rax,[Directory]
	xor	r9,r9			; lpThreadAttributes 4th arg
	mov	qword [rsp+8*(4+3)],rax ; lpCurrentDirectory 8th arg
	mov	qword [rsp+8*(4+2)],r9	; lpEnvironment 7th arg
	mov	dword [rsp+8*(4+1)],edx ; dwCreationFlags 6th arg
	mov	qword [rsp+8*(4+0)],r9	; bInheritHandles 5th arg
	xor	r8,r8			; lpProcessAttributes 3rd arg
	lea	rdx,[shell_line]	; lpCommandLine 2nd arg
	lea	rcx,[FileNameBuffer]	; lpApplicationName 1st arg
	call	qword [CreateProcessA]
	or	eax,eax
	jz	DbgThread_L5

;       lea     rax,[tmp_buf]
;       mov     dword [rax],'3' shl 16 + 0A0Dh
;       call    msg_to_LogEdit

	mov	byte [WeAreDebugging],1
	mov	byte [program_reset_disabled],0 ; reset program allowed

	call	update_main_menu

	mov	eax,[ProcessInfo.dwProcessId]
	mov	edx,[ProcessInfo.dwThreadId]
	call	update_status_window_PID_TID

	call	erase_comments
	test	[face.reload_comments_sw_bps],reload_comments_soft_breakpoints
	jz	DbgThread_L1
	mov	rdx,[ProcessInfo.hProcess]
	mov	ecx,[ProcessInfo.dwProcessId]
	call	load_comments_breakpoints
DbgThread_L1:

	call	DebugLoop

	test	[face.reload_comments_sw_bps],reload_comments_soft_breakpoints
	jz	DbgThread_L2
	call	save_comments_breakpoints
DbgThread_L2:

	mov	byte [WeAreDebugging],0

	call	update_main_menu

	call	update_status_window_PID_TID_empty

	mov	rcx,[ProcessInfo.hThread]
	call	qword [CloseHandle]
	mov	rcx,[ProcessInfo.hProcess]
	call	qword [CloseHandle]

	call	clear_all_listviews

; prepare log view to be cleared at begin of next job
	mov	rax,qword [LogEdit_buffer]
	mov	qword [LogEdit_end],rax
	mov	byte [rax],0		; make 0-terminated string

	mov	rax,qword [module_info_address] ; data of executable process image is everytime 1st
	lea	rsi,[rax+16*MaxNumberOfModulesInfo] ; point to size info about module
	mov	ebx,MaxNumberOfModulesInfo
DbgThread_L3:
	cld
	lodsq				; empty ? no info about module ?
	or	rax,rax
	jz	DbgThread_L4
	mov	r8d,MEM_DECOMMIT
	mov	edx,dword [rax] 	; grab size
	mov	rcx,rax 		; memory offset
	call	qword [VirtualFree]
DbgThread_L4:
	dec	ebx
	jnz	DbgThread_L3

DbgThread_L5:
; restore directory
	lea	rcx,[old_dir]
	call	qword [SetCurrentDirectoryA]

	mov	r8d,MEM_DECOMMIT
	mov	edx,MaxNumberOfModulesInfo * 8 * 4
	mov	rcx,qword [module_info_address]
	call	qword [VirtualFree]

DbgThread_L6:
	mov	r8d,MEM_DECOMMIT	; MEM_RELEASE
	mov	edx,MaxNumberOfBreakpoints * (8+4+1+1)
	mov	rcx,qword [breakpoints_space_address]
	call	qword [VirtualFree]

DbgThread_L7:
	mov	r8d,MEM_DECOMMIT

a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
;       mov     edx,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2
	mov	edx,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2 + MaxProcesses*8*2
	mov	rcx,qword [multiprocess_multithread_support_address]
	call	qword [VirtualFree]
	and	qword [multiprocess_multithread_support_address],0
DbgThread_L8:

	cmp	byte [restarting_debuggee],1
	jz	DbgThread_L0

DbgThread_epilogue:
	add	rsp,8*(b+d+f+g)
	pop	r15 r14 r13 r12 r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx
	xor	eax,eax
	ret

CMD_TERMINATE:
	push	rcx				; only for align stack
	call	close_debuggee_procedure
	pop	rcx
	ret

CMD_PROGRAMRESET:
	push	rcx
	cmp	qword [program_reset_disabled],0
	jnz	CMD_PROGRAMRESET_not_possible
CMD_PROGRAMRESET_possible:
	mov	qword [restarting_debuggee],1
	call	close_debuggee_procedure
CMD_PROGRAMRESET_common_end:
	pop	rcx
	ret
CMD_PROGRAMRESET_not_possible:
	lea	rax,[msg_PROGRAMRESET_not_possible]
	call	msg_to_LogEdit
	jmp	CMD_PROGRAMRESET_common_end

CMD_ATTACH:
	sub	rsp,8*(4+7)

	or	dword [attached_PID],-1

	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc08]
	mov	r8,[hWndParent]
	mov	edx,ID_Dialog08
	mov	rcx,qword [hInstance]
	call	[DialogBoxParamA]

	mov	r9d,dword [attached_PID]
	cmp	r9d,-1
	jz	CMD_ATTACH_epi

	lea	rdx,[DbgThreadId]
	mov	qword [rsp+8*(4+1)],rdx ; lpThreadId
;       mov     dword [rsp+8*(4+0)],0;NORMAL_PRIORITY_CLASS     ; dwCreationFlags
;       mov     r9d,dword [attached_PID]; lpParameter
	lea	r8,[ThreadDbgAttach]	; lpStartAddress
	xor	edx,edx 		; dwStackSize
	xor	ecx,ecx 		; lpThreadAttributes
	mov	dword [rsp+8*(4+0)],edx ; edx=0 now
	call	qword [CreateThread]
	mov	qword [hDbgThread],rax

CMD_ATTACH_epi:
	add	rsp,8*(4+7)
	ret

align 16
DlgProc08:
	push	rsi rdi rcx rdx r8 r9
	sub	rsp,8*(4+9)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc08_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc08_ReturnFalse
	cmp	r8d,LBN_DBLCLK*10000h + ID_Dialog08ListBox0
	jz	Dialog08ListBox0_Proc_DBLCLK
	cmp	r8w,ID_Dialog08Button0
	jz	DlgProc08_Done
DlgProc08_ReturnFalse:
	xor	eax, eax
DlgProc08_Return:
	add	rsp,8*(4+9)
	pop	r9 r8 rdx rcx rdi rsi
	ret

DlgProc08_InitDialog:
; create List Box
	and	qword [rsp + 8*(4+7)],0 	; pointer to window-creation data
	mov	rax,qword [hInstance]		; raw encoded this may be 400000h or 100000000h
	mov	qword [rsp + 8*(4+6)],rax	; hInst  handle to application instance
	mov	dword [rsp + 8*(4+5)],ID_Dialog08ListBox0	; handle to menu, or child-window identifier
;       mov     rcx,qword [rsp + 8*(4+9+3)]
	mov	qword [rsp+8*(4+4)],rcx
	mov	dword [rsp + 8*(4+3)],450
	mov	dword [rsp + 8*(4+2)],284
	mov	dword [rsp + 8*(4+1)],24
	mov	dword [rsp + 8*(4+0)],8
	mov	r9d,WS_VSCROLL or WS_VISIBLE or WS_BORDER or WS_CHILD or LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or LBS_NOTIFY or WS_TABSTOP	; window style
	xor	r8,r8			; pointer to window name
	lea	rdx,[ListBoxClassName]	; pointer to registered class name
	mov	ecx,WS_EX_CLIENTEDGE	; extended window style
	call	qword [CreateWindowExA]
	mov	qword [Dialog08ListBox0_handle],rax

; check the checkbox
	movzx	r8d,byte [Dialog08AutoCheckBox0_checked]
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	mov	edx,ID_Dialog08AutoCheckBox0
	mov	rcx,qword [rsp + 8*(4+9+3)]
	call	qword [CheckDlgButton]

	lea	rcx,[imports_ListView_font]
	call	qword [CreateFontIndirectA]
	mov	qword [imports_hFont],rax

	mov	r9,1				; lParam redraw flag
	mov	r8,rax				; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,qword [Dialog08ListBox0_handle]
	call	qword [SendMessageA]

;An application sends the LBN_DBLCLK notification message when the user double-clicks a string in a list box. The parent window of the list box receives this notification message through the WM_COMMAND message.
;
;LBN_DBLCLK
;idListBox = (int) LOWORD(wParam);  // identifier of list box
;hwndListBox = (HWND) lParam;       // handle of list box
;
;
;Remarks
;
;Only a list box that has the LBS_NOTIFY style will send this notification message.

DlgProc08_ReturnTrue_fill_ListBox_L2:
	xor	edx,edx
	mov	ecx,TH32CS_SNAPALL
	call	qword [CreateToolhelp32Snapshot]
	cmp	rax,INVALID_HANDLE_VALUE
	jz	DlgProc08_ReturnTrue_fill_ListBox_L8
	mov	qword [rsp + 8*(4+8)],rax

	lea	rax,[PIDs_buffer]
	mov	qword [rsp + 8*(4+7)],rax

	lea	rdx,[process_list_buffer]
	mov	dword [rdx],process_list_buffer_size
	mov	rcx,qword [rsp + 8*(4+8)]
	call	qword [Process32First]
	or	eax,eax
	jz	DlgProc08_ReturnTrue_fill_ListBox_L7
	jmp	DlgProc08_ReturnTrue_fill_ListBox_L4

DlgProc08_ReturnTrue_fill_ListBox_L3:
	lea	rdx,[process_list_buffer]
	mov	dword [rdx],process_list_buffer_size
	mov	rcx,qword [rsp + 8*(4+8)]
	call	qword [Process32Next]
	or	eax,eax
	jz	DlgProc08_ReturnTrue_fill_ListBox_L7

DlgProc08_ReturnTrue_fill_ListBox_L4:
	mov	byte [rsp + 8*(4+4)],2			; flag for 32 bit process 1=32 0=64 2=unknown
	mov	r8d,dword [process_list_buffer + 4*2]	; grab Process ID from structure
	xor	edx,edx
	mov	ecx,PROCESS_QUERY_INFORMATION	;PROCESS_ALL_ACCESS
	call	qword [OpenProcess]
	or	eax,eax
	jz	DlgProc08_ReturnTrue_fill_ListBox_L5
	mov	qword [rsp + 8*(4+6)],rax

	lea	rdx,[rsp + 8*(4+4)]
	mov	rcx,rax
	call	qword [IsWow64Process]
	mov	qword [rsp + 8*(4+1)],rax

	mov	rcx,qword [rsp + 8*(4+6)]
	call	qword [CloseHandle]

;       cmp     dword [rsp + 8*(4+1)],0
;       setz    al
;       add     eax,eax
;       or      byte [rsp + 8*(4+4)],al

DlgProc08_ReturnTrue_fill_ListBox_L5:
	emms
	fild	dword [process_list_buffer + 4*2]
	fbstp	[rsp + 8*(4+2)]

; we process only dword value, so we grab value at offset -4 for dword becomes high dword of 64 bit register
	mov	rdx,[rsp + 8*(4+2) -4]
	mov	ecx,8
	lea	rdi,[rsp + 8*(4+0)]
	cld
move_what_we_want_L0:
	rol	rdx,4
	mov	al,dl
	and	al,00001111b
	add	al,'0'
	stosb
	loop	move_what_we_want_L0

	mov	ecx,7+1
	lea	rdi,[rsp + 8*(4+0)]
move_what_we_want_L1:
	mov	al,'0'
	repz	scasb
	not	ecx
	add	ecx,7+1
	mov	al,' '
	lea	rdi,[rsp + 8*(4+0)]
	repz stosb
	lea	rdi,[rsp + 8*(4+1)]

	mov	rax,' 64-bit '
	mov	rcx,' 32-bit '
	mov	rdx,' ??-bit '
	bt	dword [rsp + 8*(4+4)],0
	cmovc	rax,rcx
	bt	dword [rsp + 8*(4+4)],1
	cmovc	rax,rdx
	stosq

	lea	rsi,[process_list_buffer + 11*4]
move_what_we_want_L3:
	movsb
	cmp	byte [rsi],0
	jnz	move_what_we_want_L3
;       xor     eax,eax
;       stosb
movsb

	lea	r9,[rsp + 8*(4+0)]
	xor	r8,r8
	mov	edx,LB_ADDSTRING
	mov	rcx,qword [Dialog08ListBox0_handle]
	call	qword [SendMessageA]

	mov	eax,dword [process_list_buffer + 4*2]
	mov	rdx,qword [rsp + 8*(4+7)]
	mov	dword [rdx],eax 		; store Process ID
	add	rdx,4
	mov	qword [rsp + 8*(4+7)],rdx

	lea	rax,[PIDs_buffer + 4*PIDs_max_number]
	cmp	rdx,rax 		; check if we aren't on the end of PIDs_buffer
	jc	DlgProc08_ReturnTrue_fill_ListBox_L3

DlgProc08_ReturnTrue_fill_ListBox_L7:
; destroy the snapshot
	mov	rcx,qword [rsp + 8*(4+8)]
	call	qword [CloseHandle]

DlgProc08_ReturnTrue_fill_ListBox_L8:

DlgProc08_ReturnTrue:
	mov	eax,1
	jmp	DlgProc08_Return

DlgProc08_Done:
	mov	rcx,qword [imports_hFont]
	call	qword [DeleteObject]

; close dialog
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+9+3)]
	call	qword [EndDialog]
	jmp	DlgProc08_ReturnTrue

Dialog08ListBox0_Proc_DBLCLK:
	mov	edx,ID_Dialog08ListBox0
	mov	rcx,qword [rsp + 8*(4+9+3)]
	call	qword [GetDlgItem]
	mov	rbx,rax

	xor	r9,r9
	xor	r8,r8
	mov	edx,LB_GETCURSEL
	mov	rcx,rbx
	call	qword [SendMessageA]
; eax=selected index of ListBox
	lea	rbx,[PIDs_buffer]
	mov	eax,dword [rbx+rax*4]
; EAX = Process ID

	mov	dword [attached_PID],eax

	mov	edx,ID_Dialog08AutoCheckBox0
	mov	rcx,qword [rsp + 8*(4+9+3)]
	call	qword [IsDlgButtonChecked]
;BST_UNCHECKED          = 0
;BST_CHECKED            = 1
	mov	byte [Dialog08AutoCheckBox0_checked],al

	jmp	DlgProc08_Done

ThreadDbgAttach:
; ECX=PID to attach
	push	rcx rdx rbx rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
	sub	rsp,8*(4+7)

;       xor     eax,eax
;       mov     [ProcessInfo.hProcess],rax
;       mov     [ProcessInfo.hThread],rax
;       mov     [ProcessInfo.dwProcessId],ecx
;       mov     [ProcessInfo.dwThreadId],eax

; ecx=PID now
	call	qword [DebugActiveProcess]
	or	eax,eax
	jz	ThreadDbgAttach_epi

;BST_UNCHECKED          = 0
;BST_CHECKED            = 1
	movzx	ecx,byte [Dialog08AutoCheckBox0_checked]
	call	qword [DebugSetProcessKillOnExit]

; clear debug registers image for all threads
	lea	rdi,[HW_BP_permanent]
	mov	ecx,1+6
	xor	eax,eax
	cld
	repz stosq

	mov	byte [restarting_debuggee],al
	mov	byte [put_BP_at_exe_entry_and_run],al

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT

a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
;       mov     edx,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2
;                               ; store PID...hProcess, TID...hThread, PID...TID, TID...ThreadLocalBase=GS_segment_register=TEB
	mov	edx,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2 + MaxProcesses*8*2
				; store PID...hProcess, TID...hThread, PID...TID, TID...ThreadLocalBase=GS_segment_register=TEB, PID...PEB
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	ThreadDbgAttach_L8
	mov	qword [multiprocess_multithread_support_address],rax

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	edx,MaxNumberOfBreakpoints * (8+4+1+1)	; every bp use 1 qword address, 1 dword process Id, 1 byte save byte before put db 0CC on it, 1 byte flag if clear bp after triggered
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	ThreadDbgAttach_L7
	mov	qword [breakpoints_space_address],rax

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	edx,MaxNumberOfModulesInfo * 8 * 4
; every entry has 4 qwords: begin, end, size of info, (dword PID, dword flag_module_...)
			; first slot is occupied by image = attached process
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	ThreadDbgAttach_L6
	mov	qword [module_info_address],rax

	mov	byte [WeAreDebugging],1
	mov	byte [program_reset_disabled],1 ; reset program disabled
;       mov     qword [debugging_attached_debuggee],1

	call	update_main_menu

	call	erase_comments
	test	[face.reload_comments_sw_bps],reload_comments_soft_breakpoints
	jz	ThreadDbgAttach_L1
	mov	rdx,[ProcessInfo.hProcess]
	mov	ecx,[ProcessInfo.dwProcessId]
	call	load_comments_breakpoints
ThreadDbgAttach_L1:

	call	DebugLoop

	test	[face.reload_comments_sw_bps],reload_comments_soft_breakpoints
	jz	ThreadDbgAttach_L2
	call	save_comments_breakpoints
ThreadDbgAttach_L2:

	mov	byte [WeAreDebugging],0

	call	update_main_menu

	call	clear_all_listviews

; prepare log view to be cleared at begin of next job
	mov	rax,qword [LogEdit_buffer]
	mov	qword [LogEdit_end],rax
	mov	byte [rax],0		; make 0-terminated string

	mov	rax,qword [module_info_address] ; data of executable process image is everytime 1st
	lea	rsi,[rax+16*MaxNumberOfModulesInfo] ; point to size info about module
	mov	ebx,MaxNumberOfModulesInfo
ThreadDbgAttach_L3:
	cld
	lodsq
	or	rax,rax 		; empty ? no info about module ?
	jz	ThreadDbgAttach_L4
	mov	r8d,MEM_DECOMMIT
	mov	edx,dword [rax] 	; grab size
	mov	rcx,rax 		; memory offset
	call	qword [VirtualFree]
ThreadDbgAttach_L4:
	dec	ebx
	jnz	ThreadDbgAttach_L3

ThreadDbgAttach_L5:
	mov	r8d,MEM_DECOMMIT
	mov	edx,MaxNumberOfModulesInfo * 8 * 4
	mov	rcx,qword [module_info_address]
	call	qword [VirtualFree]

ThreadDbgAttach_L6:
	mov	r8d,MEM_DECOMMIT	; MEM_RELEASE
	mov	edx,MaxNumberOfBreakpoints * (8+4+1+1)
	mov	rcx,qword [breakpoints_space_address]
	call	qword [VirtualFree]

ThreadDbgAttach_L7:
	mov	r8d,MEM_DECOMMIT

a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
;       mov     edx,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2
	mov	edx,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2 + MaxProcesses*8*2
	mov	rcx,qword [multiprocess_multithread_support_address]
	call	qword [VirtualFree]
	and	qword [multiprocess_multithread_support_address],0
ThreadDbgAttach_L8:

ThreadDbgAttach_epi:
	add	rsp,8*(4+7)
	pop	r15 r14 r13 r12 r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx
	xor	eax,eax
	ret

CMD_DETACH:
	sub	rsp,8*(4+1)
;db 0cch
;       xor     ecx,ecx
;       call    qword [DebugSetProcessKillOnExit]
;
;       mov     ecx,dword [attached_PID]
;       call    qword [DebugActiveProcessStop]
;; If the function succeeds, the return value is nonzero.
; ERROR_ACCESS_DENIED=5

	add	rsp,8*(4+1)
	ret

CMD_FONT:
; destroys nothing
	push	rax rcx rdx rsi rdi r8 r9 r10 r11
	sub	rsp,8*(4+0)

; Initialize the Font common dialog box with the last font selection.
	lea	rdi,[LogFont]
	lea	rsi,[face.font_default]
	lea	rax,[rdi]
	CopyQwords sizeof.LOGFONTA64

	mov	rdx,qword [hWndParent]
	lea	rcx,[lpcf]
;       lea     rax,[face.font_default]         ; rax is pointing to it after above lea rax,[rdi]
	mov	[rcx + CHOOSEFONT64.lStructSize],sizeof.CHOOSEFONT64
	mov	[rcx + CHOOSEFONT64.hwndOwner],rdx
	mov	[rcx + CHOOSEFONT64.lpLogFont],rax
	mov	[rcx + CHOOSEFONT64.Flags],CF_SCREENFONTS + CF_INITTOLOGFONTSTRUCT	; + CF_NOSIZESEL
	call	qword [ChooseFontA]
; If the user clicks the OK button of the dialog box, the return value is nonzero. The members of the CHOOSEFONT structure indicate the user's selections.
; If the user cancels or closes the Font dialog box or an error occurs, the return value is zero.
	or	rax,rax
	jz	CMD_FONT_epi

	lea	rcx,[LogFont]
	call	qword [CreateFontIndirectA]
; If the function succeeds, the return value is a handle to a logical font.
; If the function fails, the return value is NULL.
	or	rax,rax
	jz	CMD_FONT_epi

	xchg	qword [hFont],rax		; store new font handle and grab the old
	xchg	rcx,rax
	call	qword [DeleteObject]		; delete old font object

	CopyMovsq_unsafe face.font_default, LogFont, sizeof.LOGFONTA64

; send the new font to every MDI child window primary control (SysListView32, EDIT)
	mov	esi,NumberOfMDIChildren-1	; counter, -1 because jns at the end of loop
CMD_FONT_setfont_to_children_loop:
	lea	rax,[hChildren]
	mov	r9,1				; lParam redraw flag
	mov	r8,qword [hFont]		; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,qword [rax+rsi*8]		; handle of Control (SysListView32, EDIT)
	call	qword [SendMessageA]
	dec	esi
	jns	CMD_FONT_setfont_to_children_loop

	lea	rax,[msg_restart_fdbg]
	call	msg_to_LogEdit

CMD_FONT_epi:
	add	rsp,8*(4+0)
	pop	r11 r10 r9 r8 rdi rsi rdx rcx rax
	ret

CMD_VAR:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[proc_DlgVAR]
	mov	r8,qword [hWndParent]
	mov	edx,ID_DialogVar
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

proc_DlgVAR:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+7)
	cmp	edx,WM_INITDIALOG
	jz	proc_DlgVAR_InitDialog
	cmp	edx,WM_COMMAND
	jnz	proc_DlgVAR_ReturnFalse
	cmp	r8w,ID_DialogVarAutoRadioButton0	; The BN_CLICKED notification message is sent when the user clicks a button. The parent window of the button receives this notification message through the WM_COMMAND message.
	jz	proc_DlgVAR_RadioButtonChange
	cmp	r8w,ID_DialogVarButton0
	jz	proc_DlgVAR_SetIt
	cmp	r8w,ID_DialogVarButton1
	jz	proc_DlgVAR_Abandon

proc_DlgVAR_ReturnFalse:
	xor	eax, eax
proc_DlgVAR_Return:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx
	ret

proc_DlgVAR_InitDialog:
	mov	qword [rsp+8*(4+6)],rsi 	; save rsi

	mov	edx,ID_DialogVarEditText0
;       mov     rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]
	mov	rsi,rax

	xor	r9,r9
	mov	r8d,3
	mov	edx,EM_SETLIMITTEXT
	mov	rcx,rax
	call	qword [SendMessageA]

; rsi = hBuddy (usually handle of an Edit Control)
	mov	rcx,qword [rsp + 8*(4+7+3)]	; hParent
	mov	edx,ID_DialogVarUpDown0 	; nID
	mov	r8d,-64 			; nLower
	mov	r9d,64				; nUpper
	mov	eax,[face.font_default.lfWidth]
; rsi=handle, input param for the next call
	call	KreateUpDown

;       mov     r9b,TRUE
;       mov     r8d,dword [face.font_default.lfWidth]
;       mov     edx,ID_DialogVarEditText0
;       mov     rcx,qword [rsp + 8*(4+7+3)]
;       call    qword [SetDlgItemInt]

; autocheckboxes
	mov	dword [rsp + 8*(4+0)],8-1	; counter, -1 because zero-based, counting end at 0, not at 1
proc_DlgVAR_InitDialog_L0:
	mov	eax,dword [rsp + 8*(4+0)]

	xor	r8d,r8d
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	bt	dword [face.var_settings],eax	; we really check only byte, but BT instruction doesn't support byte operations
	setc	r8b				; rcl r8d,1 may be used to put 1 into r8d too
	lea	edx,[rax+ID_DialogVarAutoCheckBox0]
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [CheckDlgButton]
	dec	dword [rsp + 8*(4+0)]
	jns	proc_DlgVAR_InitDialog_L0	; jns must be used, not jnz because counter is 0-based, it means that last processed is 0 and when we dec 0 we got SIGN flag

	mov	edx,ID_DialogVarEditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]
	mov	rsi,rax

	xor	r9,r9
	mov	r8d,3
	mov	edx,EM_SETLIMITTEXT
	mov	rcx,rax
	call	qword [SendMessageA]

; rsi = hBuddy (usually handle of an Edit Control)
	mov	rcx,qword [rsp + 8*(4+7+3)]	; hParent
	mov	edx,ID_DialogVarUpDown1 	; nID
	xor	r8,r8				; nLower
	mov	r9d,64				; nUpper
	movzx	eax,[face.code1stdisasmback]	; nPos
; rsi=handle, input param for the next call
	call	KreateUpDown

	mov	rsi,qword [rsp+8*(4+6)] 	; restore rsi

; autoradiobuttons
	mov	dword [rsp + 8*(4+0)],3-1	; counter, -1 because zero-based, counting end at 0, not at 1
proc_DlgVAR_InitDialog_L5:
	mov	eax,dword [rsp + 8*(4+0)]
	xor	r8d,r8d
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	cmp	byte [face.goto_edit_style],al
	setz	r8b
	lea	edx,[rax+ID_DialogVarAutoRadioButton0]
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [CheckDlgButton]
	dec	dword [rsp + 8*(4+0)]
	jns	proc_DlgVAR_InitDialog_L5	; jns must be used, not jnz because counter is 0-based, it means that last processed is 0 and when we dec 0 we got SIGN flag

; double click on item selects the item also (auto selection, double click is enough instead of 4-click):
	xor	r8d,r8d
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	test	[face.auto_selection],1
	setnz	r8b				; rcl r8d,1 may be used to put 1 into r8d too
	mov	edx,ID_DialogVarAutoCheckBox8
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [CheckDlgButton]

; allow microsoft symbols
	xor	r8d,r8d
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	test	[face.display_symbols],display_allow_microsoft_symbols
	setnz	r8b				; rcl r8d,1 may be used to put 1 into r8d too
	mov	edx,ID_DialogVarAutoCheckBox9
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [CheckDlgButton]

; reload comments and software breakpoints between 2 sessions
	xor	r8d,r8d
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	test	[face.reload_comments_sw_bps],reload_comments_soft_breakpoints
	setnz	r8b				; rcl r8d,1 may be used to put 1 into r8d too
	mov	edx,ID_DialogVarAutoCheckBoxA
	mov	rcx,[rsp + 8*(4+7+3)]
	call	[CheckDlgButton]

; break on:
	mov	dword [rsp + 8*(4+0)],8-1	; counter, -1 because zero-based, counting end at 0, not at 1
proc_DlgVAR_InitDialog_L6:
	mov	eax,dword [rsp + 8*(4+0)]
	xor	r8d,r8d
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	bt	dword [face.break_on],eax
	setc	r8b
	lea	edx,[rax+ID_DialogVarAutoCheckBox10]
	mov	rcx,[rsp + 8*(4+7+3)]
	call	[CheckDlgButton]
	dec	dword [rsp + 8*(4+0)]
	jns	proc_DlgVAR_InitDialog_L6	; jns must be used, not jnz because counter is 0-based, it means that last processed is 0 and when we dec 0 we got SIGN flag

proc_DlgVAR_ReturnTrue:
	mov	eax,1
	jmp	proc_DlgVAR_Return

proc_DlgVAR_RadioButtonChange:
	mov	dword [rsp + 8*(4+0)],3-1	; counter, -1 because zero-based, counting end at 0, not at 1
proc_DlgVAR_RadioButtonChange_L0:
	mov	eax,dword [rsp + 8*(4+0)]
	lea	edx,[rax+ID_DialogVarAutoRadioButton0]
	xor	r8d,r8d
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	cmp	[rsp+8*(4+7+1)],dx		; does the ID_DialogVarAutoRadioButtonX match the checked radiobutton
	setz	r8b				; if it matches then change the rediobutton state into CHECKED, if mismatch, then UNCHECKED
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [CheckDlgButton]
	dec	dword [rsp + 8*(4+0)]
	jns	proc_DlgVAR_RadioButtonChange_L0	; jns must be used, not jnz because counter is 0-based, it means that last processed is 0 and when we dec 0 we got SIGN flag
	jmp	proc_DlgVAR_ReturnTrue

proc_DlgVAR_SetIt:

; SysListView sizes change indicator
;       mov     dword [rsp + 8*(4+6)],8-1       ; counter, -1 because zero-based, counting end at 0, not at 1
; we can zero byte [rsp + 8*(4+6) + 5] also, so we do it in 1 step:
	mov	qword [rsp + 8*(4+6)],8-1	; counter, -1 because zero-based, counting end at 0, not at 1

	mov	al,[face.var_settings]
	and	al,ListEditMask
	mov	[rsp + 8*(4+6) + 4],al

; [rsp + 8*(4+6) + 5] is font width change indicator

; allow microsoft symbols change indicator
	mov	al,[face.display_symbols]
	and	al,ListEditMaskSymbols
	mov	[rsp + 8*(4+6) + 6],al

; TextEdit
	mov	r9b,TRUE
	lea	r8,[rsp+8*4]
	mov	edx,ID_DialogVarEditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemInt]
	cmp	byte [rsp+8*4],FALSE
	jz	proc_DlgVAR_SetIt_L0
	cmp	dword [face.font_default.lfWidth],eax
	mov	dword [face.font_default.lfWidth],eax
	setnz	byte [rsp + 8*(4+6) + 5]
proc_DlgVAR_SetIt_L0:

; autocheckboxes
proc_DlgVAR_SetIt_L1:
	mov	eax,dword [rsp + 8*(4+6)]
	lea	edx,[rax+ID_DialogVarAutoCheckBox0]
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]
	mov	ecx,dword [rsp + 8*(4+6)]
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	btr	dword [face.var_settings],ecx	; bit test and reset, we do only byte [face..]
	shl	al,cl
	or	byte [face.var_settings],al
	dec	dword [rsp + 8*(4+6)]
	jns	proc_DlgVAR_SetIt_L1

; code 1st disassemble back
;       mov     r9b,TRUE
	xor	r9,r9
	lea	r8,[rsp+8*4]
	mov	edx,ID_DialogVarEditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemInt]
	cmp	byte [rsp+8*4],FALSE
	jz	proc_DlgVAR_SetIt_L4
	mov	[face.code1stdisasmback],al
proc_DlgVAR_SetIt_L4:

; autoradiobuttons
	mov	dword [rsp + 8*(4+6)],3-1	; counter, -1 because zero-based, counting end at 0, not at 1
proc_DlgVAR_SetIt_L5:
	mov	eax,dword [rsp + 8*(4+6)]
	lea	edx,[rax+ID_DialogVarAutoRadioButton0]
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	or	eax,eax
	jnz	proc_DlgVAR_SetIt_L6
	dec	dword [rsp + 8*(4+6)]
	jns	proc_DlgVAR_SetIt_L5
proc_DlgVAR_SetIt_L6:
	mov	eax,dword [rsp + 8*(4+6)]
	lea	ecx,[rax+1]
	jrcxz	proc_DlgVAR_SetIt_L7
	mov	[face.goto_edit_style],al
proc_DlgVAR_SetIt_L7:

; double click on item selects the item also (auto selection, double click is enough instead of 4-click):
	mov	edx,ID_DialogVarAutoCheckBox8
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	and	[face.auto_selection],not 1
	or	[face.auto_selection],al

; allow microsoft symbols
	mov	edx,ID_DialogVarAutoCheckBox9
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	and	[face.display_symbols],not display_allow_microsoft_symbols
	shl	al,display_allow_microsoft_symbols_offset_bit
	or	[face.display_symbols],al

; reload comments and software breakpoints between 2 sessions
	mov	edx,ID_DialogVarAutoCheckBoxA
	mov	rcx,[rsp + 8*(4+7+3)]
	call	[IsDlgButtonChecked]
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	and	[face.reload_comments_sw_bps],not reload_comments_soft_breakpoints
	or	[face.reload_comments_sw_bps],al

; break on:
	mov	dword [rsp + 8*(4+0)],8-1	; counter, -1 because zero-based, counting end at 0, not at 1
proc_DlgVAR_SetIt_L8:
	mov	edx,[rsp + 8*(4+0)]
	add	edx,ID_DialogVarAutoCheckBox10
	mov	rcx,[rsp + 8*(4+7+3)]
	call	[IsDlgButtonChecked]
;BST_UNCHECKED                  =       0
;BST_CHECKED                    =       1
	mov	dl,not 1
	mov	cl,[rsp + 8*(4+0)]
	shl	dl,cl
	shl	al,cl
	and	[face.break_on],dl
	or	[face.break_on],al
	dec	dword [rsp + 8*(4+0)]
	jns	proc_DlgVAR_SetIt_L8	; jns must be used, not jnz because counter is 0-based, it means that last processed is 0 and when we dec 0 we got SIGN flag

	movzx	eax,byte [face.var_settings]
	and	al,ListEditMask
	xor	ax,word [rsp + 8*(4+6) + 4]
	jz	proc_DlgVAR_Abandon_s

	lea	rax,[msg_restart_fdbg]
	call	msg_to_LogEdit

proc_DlgVAR_Abandon_s:
	mov	al,[face.display_symbols]
	and	al,ListEditMaskSymbols
;       xor     al,[rsp + 8*(4+6) + 6]
	cmp	[rsp + 8*(4+6) + 6],al
	jz	proc_DlgVAR_Abandon

	lea	rax,[msg_restart_debuggee]
	call	msg_to_LogEdit

proc_DlgVAR_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [EndDialog]
	jmp	proc_DlgVAR_ReturnTrue

KreateUpDown:
; in:   eax nPos
;       rcx hWnd handle of Parent window
;       edx nID
;       rsi hBuddy (usually handle of a Edit Control)
;       r8d nLower
;       r9d nUpper
	sub	rsp,8*(4+9)
	mov	dword [rsp+8*(4+7)],eax 	; nPos
	mov	dword [rsp+8*(4+6)],r8d 	; nLower
	mov	dword [rsp+8*(4+5)],r9d 	; nUpper
	mov	qword [rsp+8*(4+4)],rsi 	; hBuddy
	mov	dword [rsp+8*(4+2)],edx 	; nID
	mov	qword [rsp+8*(4+1)],rcx 	; hParent
	xor	edx,edx 			; x
	mov	rax,qword [hInstance]
	mov	qword [rsp+8*(4+3)],rax 	; hInstance
	mov	dword [rsp+8*(4+0)],edx 	; cy
	xor	r9,r9				; cx
	mov	r8,r8				; y
	mov	ecx,WS_CHILD or WS_BORDER or WS_VISIBLE or UDS_ALIGNRIGHT or \
		UDS_SETBUDDYINT or UDS_ARROWKEYS or UDS_SETBUDDYINT	; style
	call	qword [CreateUpDownControl]
	add	rsp,8*(4+9)
	ret

align 16
CMD_COPY_CONTENT:
	push	rcx rdx rbx rsi rdi r8 r9 r10 r11
a=1	; return address
b=9	; number of pushed registers
d=(sizeof.LV_ITEM64+7)/8
e=4	; number of qwords reserved for API
c=(a+b+d+e) and 1	; alignment at dqword
	sub	rsp,8*(c+d+e)

virtual at rsp+8*e
lvi_ccc LV_ITEM64
end virtual

; release memory from old clipboard operations:
	mov	rcx,qword [mem_glob_alloc_handle_old]
	jrcxz	CMD_COPY_CONTENT_L0
	call	qword [GlobalUnlock]
	mov	rcx,qword [mem_glob_alloc_handle_old]
	call	qword [GlobalFree]
CMD_COPY_CONTENT_L0:

; allocate memory for clipboard
	mov	edx,64 * 1024			; memory size
	mov	ecx,GMEM_MOVEABLE or GMEM_DDESHARE
	call	qword [GlobalAlloc]
	movdqa	xmm0,dqword [mem_glob_alloc_handle]	; grab handle as well pointer
	movdqa	dqword [mem_glob_alloc_handle_old],xmm0 ; store handle as well pointer
	mov	qword [mem_glob_alloc_handle],rax
; To translate the handle into a pointer, use the GlobalLock function.
	mov	rcx,rax
	call	qword [GlobalLock]
	mov	qword [mem_glob_alloc_pointer],rax

	mov	rdi,rax

	xor	r9,r9
	xor	r8,r8
	mov	edx,LVM_GETITEMCOUNT
	mov	rcx,qword [hSysListView32RMenu]
	call	qword [SendMessageA]
	or	eax,eax 			; check if empty
	jz	CMD_COPY_CONTENT_epi
	mov	ebx,eax 			; number of items in a list view control

;       mov     dword [lvi_ccc.mask],LVIF_TEXT
;       mov     dword [lvi_ccc.iItem],0
; above 2 in 1:
	mov	qword [lvi_ccc.mask],LVIF_TEXT

CMD_COPY_CONTENT_L1:
; process 1 row
	mov	[lvi_ccc.iSubItem],0
CMD_COPY_CONTENT_L2:
; process 1 column
	lea	r9,[lvi_ccc]
	mov	[lvi_ccc.pszText],rdi	; buffer for get text
	mov	[lvi_ccc.cchTextMax],SysListView_cchTextMax
	mov	r8d,dword [lvi_ccc.iItem]
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,qword [hSysListView32RMenu]
	call	qword [SendMessageA]
	or	eax,eax
	jz	CMD_COPY_CONTENT_L3
	lea	rdi,[rdi+rax*1] 		; add string size to begin of its position
	mov	al,09h				; tab character
	cld
	stosb
	stosb
	stosb
	inc	[lvi_ccc.iSubItem]
	jmp	CMD_COPY_CONTENT_L2

CMD_COPY_CONTENT_L3:
; last column done
; remove last 3 tab chars and put new line
	dec	rdi
	mov	word [rdi-2],0A0Dh
	inc	[lvi_ccc.iItem] ; iItem
	dec	ebx
	jnz	CMD_COPY_CONTENT_L1

	mov	byte [rdi],bl			; make 0-terminator

	xor	ecx,ecx
	call	qword [OpenClipboard]
	call	qword [EmptyClipboard]
	mov	rdx,qword [mem_glob_alloc_handle]
	mov	ecx,CF_TEXT			; Text format. Each line ends with a carriage return/linefeed (CR-LF) combination. A null character signals the end of the data. Use this format for ANSI text.
	call	qword [SetClipboardData]
; Once SetClipboardData is called, the system owns the object identified by the hMem parameter.
; The application can read the data, but must not free the handle or leave it locked.
; If the hMem parameter identifies a memory object, the object must have been allocated using the GlobalAlloc function
; with the GMEM_MOVEABLE and GMEM_DDESHARE flags.
	call	qword [CloseClipboard]

CMD_COPY_CONTENT_epi0:
	xor	eax,eax
CMD_COPY_CONTENT_epi:
	add	rsp,8*(c+d+e)
	pop	r11 r10 r9 r8 rdi rsi rbx rdx rcx
	ret


; hmmm, ms seems to enable DebugCtlMSR.LBR in int01 handler when DR7.LE (Local Enable, bit 8.) is set and DebugCtlMSR.BTF when DR7.GE (Global Enable, bit 9.) is set...
; this is part of OS kernel (ntoskrnl.exe/ntkrnlmp.exe) remapped into user mode address space and its dump:
;
;0000000100042B20       488B01                  mov rax,[rcx]
;0000000100042B23       0F22C0                  mov cr0,rax
;0000000100042B26       488B4110                mov rax,[rcx+10]
;0000000100042B2A       0F22D8                  mov cr3,rax
;0000000100042B2D       488B4118                mov rax,[rcx+18]
;0000000100042B31       0F22E0                  mov cr4,rax
;0000000100042B34       488B81A0000000          mov rax,[rcx+000000A0]
;0000000100042B3B       440F22C0                mov cr8,rax
;0000000100042B3F       0F015156                lgdt [rcx+56]
;0000000100042B43       0F015966                lidt [rcx+66]
;0000000100042B47       0FB74170                movzx eax,word [rcx+70]
;0000000100042B4B       48034158                add rax,[rcx+58]
;0000000100042B4F       806005FD                and byte [rax+05],FD
;0000000100042B53       0F005970                ltr word [rcx+70]
;0000000100042B57       33C0                    xor eax,eax
;0000000100042B59       0F00D0                  lldt word eax
;0000000100042B5C       0FAE5174                ldmxcsr dword [rcx+74]
;0000000100042B60       33D2                    xor edx,edx
;0000000100042B62       0F23FA                  mov dr7,rdx
;0000000100042B65       488B4120                mov rax,[rcx+20]
;0000000100042B69       488B5128                mov rdx,[rcx+28]
;0000000100042B6D       0F23C0                  mov dr0,rax
;0000000100042B70       0F23CA                  mov dr1,rdx
;0000000100042B73       488B4130                mov rax,[rcx+30]
;0000000100042B77       488B5138                mov rdx,[rcx+38]
;0000000100042B7B       0F23D0                  mov dr2,rax
;0000000100042B7E       0F23DA                  mov dr3,rdx
;0000000100042B81       488B5148                mov rdx,[rcx+48]
;0000000100042B85       33C0                    xor eax,eax
;0000000100042B87       0F23F0                  mov dr6,rax
;0000000100042B8A       0F23FA                  mov dr7,rdx
;0000000100042B8D       65803C25BD07000001      GS cmp byte [000007BD],01
;0000000100042B96       752A                    jnz 0000000100042BC2
;0000000100042B98       66F7C20002              test dx,0200            ; DR7.GE (bit 9.)
;0000000100042B9D       7403                    jz 0000000100042BA2
;0000000100042B9F       83C802                  or eax,02
;0000000100042BA2       66F7C20001              test dx,0100            ; DR7.LE (bit 8.)
;0000000100042BA7       7403                    jz 0000000100042BAC
;0000000100042BA9       83C801                  or eax,01
;0000000100042BAC       85C0                    test eax,eax
;0000000100042BAE       7412                    jz 0000000100042BC2
;0000000100042BB0       448BC0                  mov r8d,eax
;0000000100042BB3       B9D9010000              mov ecx,000001D9        ; DebugCtlMSR
;0000000100042BB8       0F32                    rdmsr
;0000000100042BBA       83E0FC                  and eax,FFFFFFFC        ; mask off LBR, BTF (bits 0., 1.)
;0000000100042BBD       410BC0                  or eax,r8d              ; and set these bits according settings of DR7.LE DR7.GE (bits 8., 9.)
;0000000100042BC0       0F30                    wrmsr
;0000000100042BC2       C3                      ret 

align 16
CMD_CONTROL_LBR:
	mov	al,1	; DebugCtlMSR.LBR (bit 0.)
	jmp	CMD_CONTROL_common_begin

align 16
CMD_CONTROL_BTF:
	mov	al,10b	; DebugCtlMSR.BTF (bit 1.)

CMD_CONTROL_common_begin:
	push	rax	; only for aligning stack at dqword
	xor	byte [all_thread_dr7+1],al		; bits 8. and 9. are ms backdoors into setting DebugCtlMSR.LBR DebugCtlMSR.BTF
	call	set_debug_registers_in_all_threads
	pop	rax
	ret


include 'fdbg_debuggee_actions.inc'

align 16
WndProc_SIZE:
a=(sizeof.RECT64+7) / 8
	push	rcx rdx r8 r9 r10 r11
	sub	rsp,8*(4 + 2*a + 1)

	mov	dword [rsp+8*(4+1)],TRUE
	and	dword [rsp+8*(4+0)],0
	xor	r9,r9
	xor	r8,r8
	xor	edx,edx
	mov	rcx,qword [hWndStatus]
	call	qword [MoveWindow]

	lea	rdx,[rsp+8*(4+0)]
	mov	rcx,qword [hWndStatus]
	call	qword [GetClientRect]

	lea	rdx,[rsp+8*(4+a)]
	mov	rcx,qword [rsp+8*(4+2*a+1+5)]	;=[hWndParent]
	call	qword [GetClientRect]

	mov	eax,[rsp+8*(4+a)+RECT64.bottom]
	mov	r9d,[rsp+8*(4+a)+RECT64.right]
	sub	eax,[rsp+8*4+RECT64.bottom]
	add	eax,[rsp+8*4+RECT64.top]
	mov	dword [rsp+8*(4+1)],TRUE
	mov	dword [rsp+8*(4+0)],eax
	xor	r8,r8
	xor	edx,edx
	mov	rcx,qword [hWndClient]
	call	qword [MoveWindow]

	add	rsp,8*(4 + 2*a + 1)
	pop	r11 r10 r9 r8 rdx rcx
	xor	eax,eax
	ret

align 16
WndProc_WINDOWPOSCHANGED:
; we only update our datas of parent position and then we let the OS to continue
; lpwp = (LPWINDOWPOS) lParam; // points to size and position data
	cmp	rcx,qword [hWndParent]
	jnz	WndProc_WINDOWPOSCHANGED_end

virtual at r9
lpwp	WINDOWPOS64
end virtual
	cmp	[lpwp.hwnd],rcx
	jnz	WndProc_WINDOWPOSCHANGED_end

; check if restoring window from iconized state
	cmp	[lpwp.flags],8124h	; 8000h+SWP_NOCOPYBITS+SWP_FRAMECHANGED+SWP_NOZORDER
	jz	WndProc_WINDOWPOSCHANGED_L0

; check if iconizing window
	cmp	[lpwp.flags],8130h	; 8000h+SWP_NOCOPYBITS+SWP_FRAMECHANGED+SWP_NOACTIVATE
	jnz	WndProc_WINDOWPOSCHANGED_L1
	mov	byte [parent_iconized],1
	jmp	WndProc_WINDOWPOSCHANGED_end

WndProc_WINDOWPOSCHANGED_L0:
	mov	byte [parent_iconized],0

WndProc_WINDOWPOSCHANGED_L1:
; check if window is iconized
	cmp	byte [parent_iconized],0
	jnz	WndProc_WINDOWPOSCHANGED_end

; we won't use API, so we needn't to align stack 16, either to reserve 4 qwords of stack
	push	rax
	mov	rax,qword [lpwp.cx]		; grab cx as well cy
	mov	qword [face.parent.cx],rax
	mov	rax,qword [lpwp.x]		; grab x as well y
	mov	qword [face.parent.x],rax
	pop	rax

WndProc_WINDOWPOSCHANGED_end:
	jmp	WndProc_DefFrameProcA

WndProc_CLOSE:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)

; save_column_sizes_of_SysListView32s
	and	dword [rsp+8*4],0		; counter of SysListView32
scsoslv_L0:
	and	dword [rsp+8*4+4],0		; counter of column
scsoslv_L1:
	lea	rdx,[hChildren]
	mov	eax,dword [rsp+8*4]
	xor	r9,r9
	mov	rcx,qword [rdx+rax*8]		; handle of SysListView32
	mov	r8d,dword [rsp+8*4+4]
	mov	edx,LVM_GETCOLUMNWIDTH
	call	qword [SendMessageA]

	lea	rdx,[addr_SLV_column_sizes]
	mov	ecx,dword [rsp+8*4]		; SysListView32
	mov	r8,qword [rdx+rcx*8]		; address of the first column of the SysListView32
	mov	r9,qword [rdx+(rcx+1)*8]	; address of the first column of the next SysListView32
	mov	ecx,dword [rsp+8*4+4]		; column
	mov	dword [r8+rcx*4],eax		; store column size
	lea	rdx,[r8+(rcx+1)*4]		; pointer to next colum size
	inc	dword [rsp+8*4+4]		; counter of column
	cmp	rdx,r9
	jc	scsoslv_L1

	inc	dword [rsp+8*4] 		; counter of SysListView32
	cmp	dword [rsp+8*4],NumberOfSysListView32
	jc	scsoslv_L0

; data0, data1, data2 must be handled more complicately...
	and	dword [rsp+8*4],0		; counter of data SysListView32
scsoslv_L2:
	and	dword [rsp+8*4+4],0		; counter of column
scsoslv_L3:
	lea	rdx,[hChildren+8*2]		; handle for data0 starts here
	mov	eax,dword [rsp+8*4]

	xor	r9,r9
	mov	rcx,qword [rdx+rax*8]		; handle of SysListView32
	mov	r8d,dword [rsp+8*4+4]
	mov	edx,LVM_GETCOLUMNWIDTH
	call	qword [SendMessageA]

; store column width
	mov	ecx,dword [rsp+8*4]
	lea	rdx,[face.SLV02cs_type]
	mov	dl,[rdx+rcx*1]
	and	dl,not data_column_type_reversed	; remove reverse flag
	xor	ecx,ecx

	lea	r8,[face.data_column_type_data_qword]
	mov	cl,1+2+1				; 1=address, 2=number_of_qwords, 1=ascii
	dec	dl
	js	scsoslv_L4
	lea	r8,[face.data_column_type_data_dword]
	mov	cl,1+4+1
	dec	dl
	js	scsoslv_L4
	lea	r8,[face.data_column_type_data_word]
	mov	cl,1+8+1
	dec	dl
	js	scsoslv_L4
	lea	r8,[face.data_column_type_data_byte]
	mov	cl,1+16+1
scsoslv_L4:
	imul	ecx,dword [rsp+8*4]
	lea	r9,[r8+rcx*4]			; every size uses dword
; now r9 points to dwords containing sizes of columns
	mov	ecx,dword [rsp+8*4+4]		; column counter
	mov	[r9+rcx*4],eax			; store the size of column

	inc	dword [rsp+8*4+4]		; column counter + 1
	lea	rdx,[face.SLV02cs_type]
	mov	eax,dword [rsp+8*4]
	mov	cl,byte [rdx+rax*1]		; get type of data (qword/dword/word/byte displaying type)
	mov	eax,2
	shl	eax,cl
	add	eax,2
	cmp	dword [rsp+8*4+4],eax
	jc	scsoslv_L3

	inc	dword [rsp+8*4] 		; SysListView32 counter + 1
	cmp	dword [rsp+8*4],3
	jc	scsoslv_L2

	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
;The DefWindowProc function calls the DestroyWindow function to destroy the window.
	jmp	WndProc_DefFrameProcA

WndProc_DESTROY:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)

	xor	ecx,ecx
	call	qword [PostQuitMessage]

	jmp	WndProc_COMMAND_end_zero

align 16
create_MDIChildren_and_its_controls:
; warning, routine destroys every nonvolatile reg (rax,rcx,rdx,r8,r9,r10,r11)
	push	rbx rbp rsi rdi r12 r13 r14
	sub	rsp,8*(4+10)

; this is the way by SendMessage
;       lea     r9,[mdicreate]
;       xor     r8,r8
;       mov     edx,WM_MDICREATE
;       mov     rcx,qword [hWndClient]
;       call    qword [SendMessageA]

; but we use CreateWindowEx
	and	qword [rsp+8*(4+8) + CLIENTCREATESTRUCT64.hWindowMenu],0
	mov	dword [rsp+8*(4+8) + CLIENTCREATESTRUCT64.idFirstChild],ID_FirstChild 

; vvv Log Edit Window and LogEdit Control start vvv
; create LogEdit Window:
virtual at rsp+8*4
rectClient	RECT64				; Because client coordinates are relative to
						; the upper-left corner of a window's client
						; area, the coordinates of the upper-left
						; corner are (0,0).
rectWin 	RECT64
end virtual

	lea	rdx,[rectClient]
	mov	rcx,qword [hWndClient]
	call	qword [GetClientRect]
	movdqa	xmm0,[rectClient]		; grab the whole structure for once
	movdqa	[face.logw],xmm0		; put it there
	cmp	[face.logw.cy],LogW_y
	jbe	FaceLogW_done
	mov	[face.logw.cy],LogW_y		; only this parameter will be smaller that
						; the whole client area
FaceLogW_done:

	lea	rdx,[rsp+8*(4+8)]
	mov	rax,qword [hInstance]
	mov	qword [rsp+8*(4+7)],rdx 	; pointer to CLIENTCREATESTRUCT64
	mov	qword [rsp+8*(4+6)],rax 	; handle to application instance
	xor	ecx,ecx
	mov	rax,qword [hWndClient]
	mov	qword [rsp+8*(4+5)],rcx 	; resource name of the class menu,
						; or an integer to identify the menu
	mov	qword [rsp+8*(4+4)],rax 	; handle to parent or owner window
	mov	edx,[face.logw.cy]
	mov	eax,[face.logw.cx]
	mov	dword [rsp+8*(4+3)],edx 	; height
	mov	dword [rsp+8*(4+2)],eax 	; width
	mov	dword [rsp+8*(4+1)],ecx 	; y
	mov	dword [rsp+8*(4+0)],ecx 	; x
	mov	r9d,WS_CHILD + WS_VISIBLE + WS_CLIPCHILDREN
	lea	r8,[title_child_Edit]
	lea	rdx,[MDIChildClassName]
	mov	ecx,WS_EX_MDICHILD + WS_EX_CONTROLPARENT; + WS_EX_TOOLWINDOW
; WS_EX_TOOLWINDOW Creates a tool window; that is, a window intended to be used as a floating
; toolbar. A tool window has a title bar that is shorter than a normal title bar, and the
; window title is drawn using a smaller font. A tool window does not appear in the taskbar
; or in the dialog that appears when the user presses ALT+TAB.
	call	qword [CreateWindowExA]
	mov	qword [hWndLogEdit],rax
	mov	rbx,rax

; obtain Window rectangle
	lea	rdx,[face.logw]
	mov	rcx,rbx
	call	qword [GetWindowRect]
	mov	ecx,[face.logw.y]
	mov	eax,[face.logw.x]
	add	ecx,LogE_border_y
	add	eax,LogE_border_x
	sub	[face.logw.cy],ecx
	sub	[face.logw.cx],eax
	and	qword [face.logw.x],0

	mov	edx,GWL_STYLE
	mov	rcx,rbx
	call	qword [GetWindowLongPtrA]
; we want everything except WS_MAXIMIZEBOX
	and	eax,not WS_MAXIMIZEBOX
;       or      eax,WS_MINIMIZEBOX + WS_SYSMENU + WS_CAPTION
	mov	r8d,eax
	mov	edx,GWL_STYLE
	mov	rcx,rbx
	call	qword [SetWindowLongPtrA]

; create EDIT Control on LogEdit window
; at first, grab size of client area of parent
	lea	rdx,[rectClient]
	mov	rcx,rbx
	call	qword [GetClientRect]

	xor	edx,edx
	mov	rcx,qword [hInstance]
	mov	qword [rsp+8*(4+7)],rdx
	mov	qword [rsp+8*(4+6)],rcx
	mov	qword [rsp+8*(4+5)],ID_Edit_00	; handle to menu, or child-window identifier
	mov	qword [rsp+8*(4+4)],rbx 	; parent

	mov	edx,[rectClient.bottom]
	mov	ecx,[rectClient.right]
	
if LogE_border_y <> 0
	sub	edx,LogE_border_y*2
end if

if LogE_border_x <> 0
	sub	ecx,LogE_border_x*2
end if

	mov	dword [rsp+8*(4+3)],edx 	; bottom
	mov	dword [rsp+8*(4+2)],ecx 	; right

; prepare to calculate real Edit control size
	mov	[face.edit+4],edx
	mov	[face.edit],ecx

	mov	edx,[rectClient.top]
	mov	ecx,[rectClient.left]

if LogE_border_y <> 0
	add	edx,LogE_border_y
end if

if LogE_border_x <> 0
	add	ecx,LogE_border_x
end if

	mov	dword [rsp+8*(4+1)],edx 	; top
	mov	dword [rsp+8*(4+0)],ecx 	; left

	sub	[face.edit+4],edx
	sub	[face.edit],ecx
; now we have Edit control size in face.edit

	mov	r9d,WS_VISIBLE + WS_CHILD + WS_HSCROLL + WS_VSCROLL + ES_AUTOHSCROLL + ES_AUTOVSCROLL + ES_MULTILINE	; + ES_READONLY
	xor	r8,r8
	lea	rdx,[EditClassName]
	mov	ecx,WS_EX_CLIENTEDGE
	call	qword [CreateWindowExA]
	mov	qword [hLogEdit],rax
	mov	rbp,rax

	mov	r9,1				; lParam redraw flag
	mov	r8,qword [hFont]		; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,rbp
	call	qword [SendMessageA]

	mov	r9d,LogEdit_buffer_size 	; lParam text limit
	xor	r8,r8
	mov	edx,EM_LIMITTEXT
	mov	rcx,rbp
	call	qword [SendMessageA]

	lea	rax,[msg_fdbg_version]
	call	msg_to_LogEdit

	call	detect_AMD
	lea	rax,[msg_fdbg_CPU_AMD]
	jnc	branching_feature_msg

	call	detect_intel
	lea	rax,[msg_fdbg_DebugCtlUnknownCPU]
	jc	branching_feature_msg

	call	detect_version_windows_2008_server_x64_R2_or_higher
	lea	rax,[msg_fdbg_CPU_Intel]
	lea	rcx,[msg_fdbg_DebugCtlIntelWarning]
	cmovc	rax,rcx

branching_feature_msg:
	call	msg_to_LogEdit

	cmp	byte [face.childwiconized + NumberOfSysListView32],0
	jz	CreateChildrenEditWin_iconize_it
; minimize MDIChildWindow holding Edit control
	mov	edx,SW_MINIMIZE
	mov	rcx,rbx
	call	qword [ShowWindow]
CreateChildrenEditWin_iconize_it:

; ^^^ Log Edit Window and Control done ^^^

; vvv Create SysListView32 windows and controls vvv
; create NumberOfSysListView32 windows, parents of SysListView32
	xor	esi,esi 			; counter
CreateChildrenLoop:

	mov	rcx,qword [hWndClient]
	lea	rdx,[rsp+8*(4+8)]
	mov	rax,qword [hInstance]
	mov	qword [rsp+8*(4+7)],rdx 	; pointer to CLIENTCREATESTRUCT64
	mov	qword [rsp+8*(4+6)],rax 	; handle to application instance
	and	qword [rsp+8*(4+5)],0		; resource name of the class menu,
						; or an integer to identify the menu
	mov	qword [rsp+8*(4+4)],rcx 	; handle to parent or owner window

if SysListView_border_x or SysListView_border_y = 0	; both SysListView_border_x SysListView_border_y are 0
	lea	rax,[face.SysListView32Sizes]
	lea	rcx,[rectClient]		; lpRect, pointer to client-rectangle structure
	mov	rdx,qword [rax+rsi*8]		; grab size of client area
	xor	r8,r8				; bMenu, menu-present flag
	mov	qword [rectClient.right],rdx	; store right and bottom in once
else
	lea	r8,[face.SysListView32Sizes]
	lea	rcx,[rectClient]
	mov	edx,[r8+rsi*8 + 4]		; grab vertical size of client area
	mov	eax,[r8+rsi*8]			; grab horizontal size of client area
	add	edx,SysListView_border_y * 2	; *2 because border is from both sides
	add	eax,SysListView_border_x * 2
	xor	r8,r8				; bMenu, menu-present flag
	mov	[rectClient.bottom],edx
	mov	[rectClient.right],eax
end if
	mov	qword [rcx],r8			; zeroing rectClient.left rectClient.top
; Because client coordinates are relative to the upper-left corner of a window's client area,
; the coordinates of the upper-left corner are (0,0).

	mov	edx,WS_VISIBLE + WS_CAPTION + WS_SYSMENU + WS_THICKFRAME	; dwStyle, window styles
	call	qword [AdjustWindowRect]
; subtract [x,y] to make left up corner [0,0] and right bottom to [cx,cy]
	mov	ecx,[rectClient.top]
	mov	eax,[rectClient.left]	
	sub	[rectClient.bottom],ecx
	sub	[rectClient.right],eax

; save window rectangle
	lea	rdx,[face.childrenw]
	lea	rcx,[rsi+rsi*1]
	lea	r9,[rdx+rcx*8]			; face_save_size.childrenw + rsi*16
if sizeof.win_origin_size <> 16
Above instructions require changes
end if

virtual at r9
wossw	win_origin_size
end virtual
	lea	r10,[face.childwstart]
	mov	eax,[r10+rsi*8+4]
	mov	r8d,[r10+rsi*8]
	cmp	qword [r10+rsi*8],0
	jnz	we_have_values
; calculate new position of left top MDI window corner
	lea	edi,[rsi+rsi*8] 		; esi*9
	lea	eax,[SLVW_y+rdi*2]		; SLVW_y + rsi*18
	lea	r8,[rdi+rdi*1+SLVW_x]		; SLVW_x + rsi*18
	add	eax,[rectClient.top]
	add	r8d,[rectClient.left]
	mov	[wossw.x],r8d
	mov	[wossw.y],eax
we_have_values:

	mov	edx,[rectClient.bottom]
	mov	ecx,[rectClient.right]

	mov	[wossw.cx],ecx
	mov	[wossw.cy],edx

	cmp	[face.parent.cy],ecx
	jnc	child_fits_fine
	xor	r8,r8
	mov	[wossw.x],r8d
child_fits_fine:

	mov	dword [rsp+8*(4+3)],edx 	; height
	mov	dword [rsp+8*(4+2)],ecx 	; width
	mov	dword [rsp+8*(4+1)],eax 	; y
	mov	dword [rsp+8*(4+0)],r8d 	; x

; save window rectangle
	movdqa	xmm0,dqword [wossw]
	lea	rcx,[face.childrenw]
	lea	rax,[rsi+rsi*1] 		; rsi*2
	movdqa	dqword [rcx+rax*8],xmm0

	lea	rax,[addr_child_title]
	mov	r9d,WS_CHILD + WS_VISIBLE + WS_CLIPCHILDREN
	mov	r8,qword [rax+rsi*8]		; Title
	lea	rdx,[MDIChildClassName]
	mov	ecx,WS_EX_MDICHILD + WS_EX_CONTROLPARENT
	call	qword [CreateWindowExA]
	lea	rcx,[hWndChildren]
	mov	qword [rcx+rsi*8],rax
	mov	rbx,rax 			; save handle

	mov	edx,GWL_STYLE
	mov	rcx,rbx
	call	qword [GetWindowLongPtrA]

; we want everything except WS_MAXIMIZEBOX
	and	eax,not WS_MAXIMIZEBOX
	mov	r8d,eax
	mov	edx,GWL_STYLE
	mov	rcx,rbx
	call	qword [SetWindowLongPtrA]

; Create SysListView32 control
; at first, grab size of client area of parent
	lea	rdx,[rectClient]
	mov	rcx,rbx
	call	qword [GetClientRect]

	xor	edx,edx
	mov	rcx,qword [hInstance]
	lea	eax,[rsi+ID_SysListView32_00]
	mov	qword [rsp+8*(4+7)],rdx
	mov	qword [rsp+8*(4+6)],rcx
	mov	qword [rsp+8*(4+5)],rax 	; handle to menu, or child-window identifier
	mov	qword [rsp+8*(4+4)],rbx 	; parent

	mov	edx,[rectClient.bottom]
	mov	ecx,[rectClient.right]

if SysListView_border_y <> 0
	sub	edx,SysListView_border_y*2
end if

if SysListView_border_x <> 0
	sub	ecx,SysListView_border_x*2
end if

	mov	dword [rsp+8*(4+3)],edx 	; bottom
	mov	dword [rsp+8*(4+2)],ecx 	; right

	mov	edx,[rectClient.top]
	mov	ecx,[rectClient.left]

if SysListView_border_y <> 0
	add	edx,SysListView_border_y
end if

if SysListView_border_x <> 0
	add	ecx,SysListView_border_x
end if

	mov	dword [rsp+8*(4+1)],edx 	; top
	mov	dword [rsp+8*(4+0)],ecx 	; left

;       mov     r9d,WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SHAREIMAGELISTS ; window style
;       mov     r9d,WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SINGLESEL       ; window style
;       mov     r9d,WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SINGLESEL or LVS_OWNERDRAWFIXED or LVS_SHAREIMAGELISTS; window style
;       mov     r9d,WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SINGLESEL or LVS_OWNERDRAWFIXED or LVS_SHAREIMAGELISTS or LVS_SHOWSELALWAYS     ; window style
	mov	r9d,WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SINGLESEL or LVS_OWNERDRAWFIXED or LVS_SHAREIMAGELISTS or LVS_SHOWSELALWAYS or WS_CLIPCHILDREN	; window style
;       mov     r9d,WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SINGLESEL or LVS_OWNERDRAWFIXED or LVS_SHAREIMAGELISTS or LVS_SHOWSELALWAYS or WS_TABSTOP       ; window style
; OWNERDRAWFIXED allows us to catch WM_MEASUREITEM and WM_DRAWITEM
; MEASUREITEM is necessary to adjust cell hight in SysListView32
; OWNERDRAWFIXED is necessary to draw background color in SysListView32

; ??? LVS_NOSCROLL ???
;       mov     r9d,LVS_NOSCROLL or WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SINGLESEL or LVS_OWNERDRAWFIXED or LVS_SHAREIMAGELISTS; window style
; Bad idea for Code 1st and Code 2nd. Disables HSCROLL VSCROLL. We need horizontal scroll bar.
; We do it by GetWindowLongPtrA GWL_STYLE / style not WS_VSCROLL / SetWindowLongPtrA GWL_STYLE.
; Whoops, not WS_VSCROLL doesn't work...

	xor	r8,r8
	lea	rdx,[SysListView32ClassName]
	mov	ecx,WS_EX_CLIENTEDGE
	call	qword [CreateWindowExA]
	lea	rcx,[hListView]
	mov	qword [rcx+rsi*8],rax
	mov	rbp,rax

; unfortunately, this doesn't work:
;       mov     edx,GWL_STYLE
;       mov     rcx,rbp
;       call    qword [GetWindowLongPtrA]
;
;       mov     r8d,eax
;; we don't want vertical scroll bar for Code 1st, ... Stack (=0,1,2,...5)
;       and     eax,not WS_VSCROLL
;       cmp     esi,num_of_LV_supporting_proc_List_KEYDOWN
;       cmovc   r8d,eax
;       mov     edx,GWL_STYLE
;       mov     rcx,rbp
;       call    qword [SetWindowLongPtrA]

; create structures on SysListView32
	mov	r9,LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_GRIDLINES	; lParam
	xor	r8,r8
	mov	edx,LVM_SETEXTENDEDLISTVIEWSTYLE
	mov	rcx,rbp
	call	qword [SendMessageA]

	mov	r9,1				; lParam redraw flag
	mov	r8,qword [hFont]		; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,rbp
	call	qword [SendMessageA]

; create columns
	xor	r12,r12 			; column counter

	lea	rdx,[addr_SLV_column_sizes]
	lea	rax,[addr_SLV_column_names]
	mov	r13,qword [rdx+rsi*8]
	mov	rdi,qword [rax+rsi*8]

virtual at rsp+8*(4+0)
lv_col	LV_COLUMN64
end virtual

	xor	ecx,ecx
	mov	[lv_col.iSubItem],ecx
	mov	qword [lv_col.iImage],rcx

if LVCFMT_LEFT = 0
	mov	qword [lv_col.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
;       mov     qword [lv_col.mask],LVCF_FMT or LVCF_TEXT or LVCF_WIDTH ; index of the column is specified in r8 wParam
else
	mov	[lv_col.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
;       mov     [lv_col.mask],LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
	mov	[lv_col.fmt],LVCFMT_LEFT
end if

; data0, data1, data2 must be handled differently, call update_data_column_names at the end of procedure
	mov	eax,esi
	sub	al,2
	cmp	al,2
	jbe	create_SysListView32_done

create_SysListView32_Columns_L0:
	mov	eax,dword [r13] 		; grab column size
	lea	r13,[r13+4]
	mov	[lv_col.cx],eax
	mov	[lv_col.pszText],rdi
	mov	[lv_col.iSubItem],r12d

	lea	r9,[lv_col]
	mov	r8,r12				; iCol
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rbp
	call	qword [SendMessageA]

	inc	r12				; increase column number
	xor	eax,eax
	or	ecx,-1
	cld
	repnz scasb				; point to next column size

	lea	rdx,[addr_SLV_column_sizes]
	cmp	r13,qword [rdx+8*(rsi+1)]	; are we on next SysListView32 column ?
	jc	create_SysListView32_Columns_L0

	cmp	esi,6
	jc	create_SysListView32_Columns_L1 ; nothing to fill for Code 1st 2nd, Data 1st 2nd 3rd, Stack SysListView32
; fill SysListView32s 0st column with registers names

	lea	rax,[addr_SLV_fillregs - 8*6]	; first 6 SysListView32 don't have anything to fill
	call	qword [rax+rsi*8]
create_SysListView32_Columns_L1:

create_SysListView32_done:
	lea	rcx,[face.childwiconized]
	cmp	byte [rcx+rsi*1],0
	jz	CreateChildrenLoop_dont_iconize_it
; minimize MDIChildWindow holding SysListView32
	mov	edx,SW_MINIMIZE
	mov	rcx,rbx
	call	qword [ShowWindow]

	mov	rcx,qword [hWndParent]		; hWnd
	call	qword [UpdateWindow]

CreateChildrenLoop_dont_iconize_it:

	lea	r8,[List_NewProc]
	mov	rdx,GWLP_WNDPROC
	mov	rcx,rbp
	call	qword [SetWindowLongPtrA]
; after setting the first List_NewProc, every next call returns rax=List_NewProc, so we must
; avoid to overwrite first real [lpfnListProc] with List_NewProc
	lea	rdx,[List_NewProc]
	cmp	rdx,rax
	jz	CreateChildrenLoop_OldProcDone
	mov	qword [lpfnListProc],rax
CreateChildrenLoop_OldProcDone:

	inc	esi
	cmp	esi,NumberOfSysListView32
	jc	CreateChildrenLoop

	xor	r9,r9
	mov	r8,qword [hWndLogEdit]		; hwndChildAct child to activate ;restore
	mov	edx,WM_MDIACTIVATE		; WM_MDIRESTORE
	mov	rcx,qword [hWndClient]
	call	qword [SendMessageA]

;       call    update_XMM_STMM_column_names

	call	update_data_column_names	; we do it now, SysListViews for Data weren't created yet, they were skipped

	add	rsp,8*(4+10)
	pop	r14 r13 r12 rdi rsi rbp rbx
	ret

FillGPRNames:
	push	rbx
a	=	1			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8 		; stack frame in qwords
e	=	(a+b+d+1) and 1 	; align stack 16
	sub	rsp,8*(b+d+e)

virtual at rsp+8*b
lvit	LV_ITEM64
end virtual


	xor	ebx,ebx 		; counter, we have 16 GPRs
	mov	[lvit.mask],LVIF_TEXT
	and	dword [lvit.iSubItem],0 ; update subitems 0

FillGPRNames_L0:
	lea	rax,[GPR_alphabetical_0_terminated]
	lea	rcx,[rax+rbx*4]
	mov	[lvit.iItem],ebx	; update item
	mov	[lvit.pszText],rcx

	lea	r9,[lvit]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp 		; GPR SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,16			; 16 GPRS
	jc	FillGPRNames_L0

	add	rsp,8*(b+d+e)
	pop	rbx
	ret

FillIPName:
a	=	4			; number of qwords reserved for API
b	=	sizeof.LV_ITEM64	; stack frame in bytes
c	=	(b+7)/8 		; stack frame in qwords
d	=	(a+c+1) and 1		; align stack 16
	sub	rsp,8*(a+c+d)
	lea	rax,[RIP_0_terminated]
	mov	[lvit.mask],LVIF_TEXT
	and	qword [lvit.iItem],0	; update item and subitem
	mov	[lvit.pszText],rax
	lea	r9,[lvit]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp
	call	qword [SendMessageA]
	add	rsp,8*(a+c+d)
	ret

FillXMMNumbers:
	push	rbx
a	=	1			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	sizeof.LV_ITEM64	; stack frame in bytes
d	=	(c+7)/8 		; stack frame in qwords
e	=	(a+b+d+1) and 1 	; align stack 16
	sub	rsp,8*(b+d+e)

	xor	ebx,ebx 		; counter, we have 16 xmm registers
	mov	[lvit.mask],LVIF_TEXT
	and	dword [lvit.iSubItem],0 ; update subitems 0

FillXMMNumbers_L0:
	lea	rax,[XMM_0_terminated]
	lea	rcx,[rax+rbx*4]
	mov	[lvit.iItem],ebx	; update item
	mov	[lvit.pszText],rcx

	lea	r9,[lvit]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp 		; GPR SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,16			; 16 xmm registers
	jc	FillXMMNumbers_L0

	add	rsp,8*(b+d+e)
	pop	rbx
	ret

FillMMNumbers:
	push	rbx
	sub	rsp,8*(b+d+e)

	xor	ebx,ebx 		; counter, we have 8 mm/st registers
	mov	[lvit.mask],LVIF_TEXT
	and	dword [lvit.iSubItem],0 ; update subitems 0

FillMMNumbers_L0:
	lea	rax,[XMM_0_terminated]
	lea	rcx,[rax+rbx*4]
	mov	[lvit.iItem],ebx	; update item
	mov	[lvit.pszText],rcx

	lea	r9,[lvit]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp 		; GPR SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,8			; 8 mm / st registers
	jc	FillMMNumbers_L0

	add	rsp,8*(b+d+e)
	pop	rbx
	ret

FillFlagNames:
	push	rbx
	sub	rsp,8*(b+d+e)

	xor	ebx,ebx
	mov	[lvit.mask],LVIF_TEXT
	and	dword [lvit.iSubItem],0 ; update subitems 0

FillFlagNames_L0:
	lea	rax,[Flag_0_terminated]
	lea	rcx,[rax+rbx*2]
	mov	[lvit.iItem],ebx	; update item
	mov	[lvit.pszText],rcx

	lea	r9,[lvit]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp 		; GPR SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,8			; we display 7 Flags of the RFlag (EFlag) register and hexa EFlag
	jc	FillFlagNames_L0

	add	rsp,8*(b+d+e)
	pop	rbx
	ret

FillSegRegNames:
	push	rbx
	sub	rsp,8*(b+d+e)

	xor	ebx,ebx
	mov	[lvit.mask],LVIF_TEXT
	and	dword [lvit.iSubItem],0 ; update subitems 0

FillSegRegNames_L0:
	lea	rax,[SegReg_0_terminated]
	lea	rcx,[rax+rbx*4]
	mov	[lvit.iItem],ebx	; update item
	mov	[lvit.pszText],rcx

	lea	r9,[lvit]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp 		; GPR SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,6			; 6 segment registers
	jc	FillSegRegNames_L0

	add	rsp,8*(b+d+e)
	pop	rbx
	ret

FillDebugRegNames:
	push	rbx
	sub	rsp,8*(b+d+e)

	xor	ebx,ebx
	mov	[lvit.mask],LVIF_TEXT
	and	dword [lvit.iSubItem],0 ; update subitems 0

FillDebugRegNames_L0:
	lea	rax,[DebugReg_0_terminated]
	lea	rcx,[rax+rbx*4]
	mov	[lvit.iItem],ebx	; update item
	mov	[lvit.pszText],rcx

	lea	r9,[lvit]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp 		; GPR SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,6			; 6 debug registers (DR0, DR1, DR2, DR3, DR6, DR7)
	jc	FillDebugRegNames_L0

	add	rsp,8*(b+d+e)
	pop	rbx
	ret

FillFloatingControlRegNames:
	push	rbx
	sub	rsp,8*(b+d+e)

	xor	ebx,ebx
	mov	[lvit.mask],LVIF_TEXT
	and	dword [lvit.iSubItem],0 ; update subitems 0

FillFloatingControlRegNames_L0:
	lea	rcx,[FloatingControl_0_terminated]
	lea	rax,[rcx+rbx*8]
	lea	rcx,[rax+rbx*8] 	; *16, every string has 16 chars including 0-terminator and padding bytes
	mov	[lvit.iItem],ebx	; update item
	mov	[lvit.pszText],rcx

	lea	r9,[lvit]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp 		; GPR SysListView32 handle
	call	qword [SendMessageA]

	inc	ebx			; next line
	cmp	bl,5			; 5 Floating Control registers
	jc	FillFloatingControlRegNames_L0

	add	rsp,8*(b+d+e)
	pop	rbx
	ret

align 16
ChildProc:
	cmp	edx,WM_CLOSE
	jz	ChildProc_CLOSE

	cmp	edx,WM_NOTIFY
	jz	ChildProc_NOTIFY

	cmp	edx,WM_WINDOWPOSCHANGED
	jz	ChildProc_WINDOWPOSCHANGED

	cmp	edx,WM_DRAWITEM
	jz	ChildProc_DRAWITEM

	cmp	edx,WM_MEASUREITEM
	jz	ChildProc_MEASUREITEM

;       cmp     edx,WM_KEYDOWN
;       jz      ChildProc_KEYDOWN_KEYUP
;
;       cmp     edx,WM_KEYUP
;       jz      ChildProc_KEYDOWN_KEYUP

	cmp	edx,WM_KEYDOWN
	jz	ChildProc_KEYDOWN

ChildProc_DefMDIChildProcA:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
; r9=lParam
; r8=wParam
; edx=uMsg
; rcx=hWnd
	call	qword [DefMDIChildProcA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

ChildProc_CLOSE:
; closing isn't allowed
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)

; closing isn't allowed, but we minimize window
	mov	edx,SW_MINIMIZE
; rcx=hwnd now
;       mov     rcx,...                         ; hWnd
	call	qword [ShowWindow]

	lea	rax,[msg_CloseChildIsntAllowed]
	call	msg_to_LogEdit

	xor	eax,eax 			; 0 for MDI client rearrange menu
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

ChildProc_NOTIFY:
	cmp	[r9 + NM_LISTVIEW64.hdr.code],LVN_COLUMNCLICK
	jnz	ChildProc_NOTIFY_end
	push	rax rcx rdx r8 r9
	mov	rax,[r9 + NM_LISTVIEW64.hdr.idFrom]
	sub	eax,ID_SysListView32_02
	cmp	eax,2				; only ID_SysListView32_02 and ID_SysListView32_03 and ID_SysListView32_04 (=data0, data1, data2)
	jnbe	ChildProc_NOTIFY_epi

	lea	rdx,[face.SLV02cs_type]
	mov	r8b,byte [rdx+rax*1]
	inc	r8b
	xor	r9,r9
	cmp	r8b,data_column_type_byte
	cmovnbe r8d,r9d
	mov	byte [rdx+rax*1],r8b
	call	update_data_column_names
	cmp	byte [WeAreDebugging],0
	jz	ChildProc_NOTIFY_epi
	mov	ecx,dword [last_TID]		; thread Id
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	ChildProc_NOTIFY_epi

	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory

ChildProc_NOTIFY_epi:
	pop	r9 r8 rdx rcx rax
ChildProc_NOTIFY_end:
	jmp	ChildProc_DefMDIChildProcA

ChildProc_WINDOWPOSCHANGED:
; lParam points to size and position data
virtual at r9		; lParam is in R9
WinPos	WINDOWPOS64
end virtual
	cmp	[WinPos.hwnd],rcx		; only for sure, mismatch shouldn't happen
	jnz	ChildProc_WINDOWPOSCHANGED_end

	push	rax rcx rdx rsi rdi r8 r9 r10 r11
	sub	rsp,8*(4+2)

	lea	rdi,[hWndChildren]
	mov	rax,rcx
	mov	ecx,NumberOfMDIChildren
	cld
	lea	esi,[rcx-1]			; this is the smalles possibility, 3 bytes
						; lea rsi,[rcx-1] lea esi,[ecx-1] have 4 bytes
	repnz scasq
	jnz	ChildProc_WINDOWPOSCHANGED_epilogue
	sub	esi,ecx 			; ESI = index of Child, the first is window
						; holding SysListView with Code 1st,
						; the last EDIT with Log

if sizeof.win_origin_size = 8
	lea	edi,[rsi]			; 1 = sizeof.win_origin_size/8
end if

if sizeof.win_origin_size = 16
	lea	edi,[rsi+rsi*1] 		; 2 = sizeof.win_origin_size/8
end if

if sizeof.win_origin_size = 32
	lea	edi,[00000000h+rsi*4]		; 4 = sizeof.win_origin_size/8
end if

	lea	rcx,[face.childwiconized]
; check if restoring child MDI window from iconized state
	cmp	[WinPos.flags],8124h	; 8000h+SWP_NOCOPYBITS+SWP_FRAMECHANGED+SWP_NOZORDER
	jz	ChildProc_WINDOWPOSCHANGED_L0

;       cmp     [WinPos.flags],8120h    ; 8000h+SWP_NOCOPYBITS+SWP_FRAMECHANGED ; when every MDI child is iconized
;       jz      ChildProc_WINDOWPOSCHANGED_L0

; check if iconizing window
	cmp	[WinPos.flags],8130h	; 8000h+SWP_NOCOPYBITS+SWP_FRAMECHANGED+SWP_NOACTIVATE
	jnz	ChildProc_WINDOWPOSCHANGED_L1

	mov	byte [rcx+rsi*1],1
	jmp	ChildProc_WINDOWPOSCHANGED_update_children

ChildProc_WINDOWPOSCHANGED_L0:
	mov	byte [rcx+rsi*1],0

ChildProc_WINDOWPOSCHANGED_L1:
; check if window is iconized
	cmp	byte [rcx+rsi*1],0
	jnz	ChildProc_WINDOWPOSCHANGED_update_children

	lea	rax,[face.childrenw]

virtual at rax+rdi*8
wos	win_origin_size
end virtual

if sizeof.win_origin_size = 16
	cmp	qword [wos.cx],0		; cx, cy are still empty ? Window shouldn't have zero size !
	jz	ChildProc_WINDOWPOSCHANGED_epilogue
else
	Another size of win_origin_size structure requires to rewrite some work !!!
end if

; recalculate new sizes and update them to our store
	lea	rdx,[face.SysListView32Sizes]
	movq	xmm0,qword [rdx+rsi*8]		; old size of Control (SysListView or Edit), both x as well y dword + dword = qword
	movq	xmm2,qword [WinPos.cx]		; new size of MDI window after resizing/moving
	movq	xmm1,qword [WinPos.x]		; new position of left up corner of MDI child window after resizing/moving
	paddd	xmm0,xmm2			; add new size of MDI child window
	lea	rcx,[face.childwstart]
	movq	xmm3,qword [wos.cx]
	psubd	xmm0,xmm3			; subtract old size of MDI child window
	movq	qword [rcx+rsi*8],xmm1		; save left up corner position of MDI window
	movq	qword [wos.cx],xmm2		; store new size of MDI window holding SysListView32 or Edit
	movq	qword [rdx+rsi*8],xmm0		; update size of SysListView32 or Edit

; resize Control
	mov	ecx,[rdx+rsi*8 + 4]
	mov	r9d,[rdx+rsi*8] 		; right
	mov	r8d,SysListView_border_y	; top
	mov	edx,SysListView_border_x	; left
	mov	qword [rsp+8*(4+1)],1		; 6th API param - bRepaint
	mov	dword [rsp+8*(4+0)],ecx 	; bottom
	lea	rax,[hChildren]
	mov	rcx,qword [rax+rsi*8]
	call	qword [MoveWindow]

ChildProc_WINDOWPOSCHANGED_update_children:
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory

ChildProc_WINDOWPOSCHANGED_epilogue:
	add	rsp,8*(4+2)
	pop	r11 r10 r9 r8 rdi rsi rdx rcx rax
ChildProc_WINDOWPOSCHANGED_end:
;       ret
; no, we let OS resize client windows
	jmp	ChildProc_DefMDIChildProcA

ChildProc_DRAWITEM:
	push	rcx rdx rbx rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15

a	=	14			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	1			; number of qwords for API params
d	=	(sizeof.LV_ITEM64+7)/8	; stack frame in qwords
e	=	(sizeof.RECT64+7)/8
f	=	(sizeof.LV_COLUMN64+7)/8
g	=	SysListView_cchTextMax/8; buffer for string
z	=	(a+b+c+d+e+f+g+1) and 1 ; align stack 16
	sub	rsp,8*(b+c+d+e+f+g+z)

virtual at r9
drwitstrc	DRAWITEMSTRUCT64
end virtual

virtual at rsp+8*(b+c)
lvy	LV_ITEM64
end virtual

virtual at rsp+8*(b+c+d)
rcLabel RECT64
end virtual

virtual at rsp+8*(b+c+d+e)
lvk01um LV_COLUMN64
end virtual

	cmp	[drwitstrc.CtlType],ODT_LISTVIEW
	jnz	ChildProc_DRAWITEM_epi

	cmp	[drwitstrc.itemAction],ODA_DRAWENTIRE
	jnz	ChildProc_DRAWITEM_epi

	mov	esi,[drwitstrc.itemID]
	mov	rbx,[drwitstrc.hwndItem]
	mov	rbp,[drwitstrc.hDC]

; iSubItem=0 (Label),
; It is before the whole item only for obtain lParamof iItem holding color scheme and state,
; and when we do it, we do LVIF_TEXT for not to need to do it later.
	lea	rdx,[rsp + 8*(b+c+d+e+f)]	; buffer for string
	mov	[lvy.mask],LVIF_TEXT or LVIF_STATE or LVIF_PARAM
;       mov     [lvy.iItem],esi
;       mov     [lvy.iSubItem],0
	mov	qword [lvy.iItem],rsi	; above 2 in 1 instruction, upper dword of RAX = 0
	mov	[lvy.pszText],rdx
	mov	[lvy.cchTextMax],SysListView_cchTextMax
	mov	[lvy.stateMask],0FFFFh
	lea	r9,[lvy]
	xor	r8,r8
	mov	edx,LVM_GETITEM
	mov	rcx,rbx
	call	qword [SendMessageA]

	mov	[rcLabel.left],LVIR_LABEL
	lea	r9,[rcLabel]
	mov	r8d,esi
	mov	edx,LVM_GETITEMRECT
	mov	rcx,rbx
	call	qword [SendMessageA] 

; the whole iItem (Label + subitems)
	mov	eax,dword [lvy.lParam]
	lea	rcx,[slv32_colors]
	mov	edx,dword [rcx+rax*8]		; background color
	mov	rcx,rbp
	call	qword [SetBkColor]

	mov	eax,dword [lvy.lParam]
	lea	rcx,[slv32_colors]
	mov	edx,dword [rcx+rax*8+4] 	; foreground color
	mov	rcx,rbp
	call	qword [SetTextColor]

; fill background color
	lea	rcx,[hBrushes]
	mov	eax,dword [lvy.lParam]
	mov	r9,qword [rsp + 8*(b+c+d+e+f+g+z+6)]	; not API param, just restore R9 for access drwitstrc.rcItem
	mov	r8,qword [rcx+rax*8]		; hBrush, handle of brush, 3rd API param
	lea	rdx,[drwitstrc.rcItem]		; rect, rectangle, 2nd API param
	mov	rcx,rbp 			; hDC, handle to device context, 1st API param
	call	qword [FillRect]

; draw selection rectangle
;       mov     rcx,rbx
;       call    hList2iList
;       jc      ChildProc_DRAWITEM_DrawFocusRect_end
;; edx= index of SysListView32
;       cmp     edx,num_of_LV_supporting_proc_List_KEYDOWN
;       jnc     ChildProc_DRAWITEM_DrawFocusRect_end
;       lea     rax,[ListView_selected_iItem]
;       bt      qword [rax+rdx*8],rsi           ; check whether iItem=rsi is selected in our record at ListView_selected_iItem+8*iList
;       jnc     ChildProc_DRAWITEM_DrawFocusRect_end
; no, no, no, we draw it according item state

	mov	r9,qword [rsp + 8*(b+c+d+e+f+g+z+6)]	; get lost point to drwitstrc
	test	[drwitstrc.itemState],ODS_SELECTED
	jz	ChildProc_DRAWITEM_DrawFocusRect_end
	lea	rdx,[drwitstrc.rcItem]
; necesary to rectangle fit into item, else the bottom is overdrawn with next item:
	sub	dword [rdx + RECT64.bottom],1
	mov	rcx,rbp
	call	qword [DrawFocusRect]
ChildProc_DRAWITEM_DrawFocusRect_end:

; subItems iSubItem=0 (Label), iSubitem>0 subitems

	xor	r12,r12 			; counter
ChildProc_DRAWITEM_L0:
; draw text
	lea	rdi,[rsp + 8*(b+c+d+e+f)]	; buffer holding string
	mov	ecx,SysListView_cchTextMax
	xor	eax,eax
	lea	r8,[rcx-1]
	lea	rdx,[rdi]			; 2nd API param, pointer to the string
	cld
	repnz scasb
	mov	dword [rsp+8*(4+0)],DT_END_ELLIPSIS or DT_EXTERNALLEADING or DT_LEFT or DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER	; 5th API param
	lea	r9,[rcLabel]			; 4th API param
	sub	r8,rcx				; 3rd API param, string size
	mov	rcx,rbp 			; 1st API param
	call	qword [DrawTextA]

	inc	r12

ChildProc_DRAWITEM_subitems_L0:
	mov	[rcLabel.left],LVIR_LABEL
	mov	[rcLabel.top],r12d		; iSubItem
	lea	r9,[rcLabel]
	mov	r8d,esi 			; iItem
	mov	edx,LVM_GETSUBITEMRECT
	mov	rcx,rbx
	call	qword [SendMessageA] 
	or	rax,rax
	jz	ChildProc_DRAWITEM_L1
	add	dword [rcLabel.left],3		; for text doesn't start directly from left size

	lea	rdx,[rsp + 8*(b+c+d+e+f)]	; buffer for string
	mov	[lvy.mask],LVIF_TEXT
	mov	[lvy.iItem],esi
	mov	[lvy.iSubItem],r12d
	mov	[lvy.pszText],rdx
	mov	[lvy.cchTextMax],SysListView_cchTextMax

; other lvy params are set, like pszText, cchTextMax
	lea	r9,[lvy]
	mov	r8d,esi
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,rbx
	call	qword [SendMessageA]
	or	rax,rax
	jnz	ChildProc_DRAWITEM_L0
ChildProc_DRAWITEM_L1:

ChildProc_DRAWITEM_epi:
	add	rsp,8*(b+c+d+e+f+g+z)
	xor	eax,eax
	pop	r15 r14 r13 r12 r11 r10 r9 r8 rdi rsi rbp rbx rdx rcx
	ret

ChildProc_MEASUREITEM:

virtual at R9
msrits	MEASUREITEMSTRUCT64
end virtual

	mov	eax,[face.font_default.lfHeight]

; calculate absolute value
; 4 byte code, the smallest, the slowest because the conditional jump (2 jumps for possitive value)
	neg	eax
	jl	$-2		; The JS has the problem that it goes into an infinite loop if EAX=80000000h.

; the biggest, the fastest (+ we have to PUSH/POP RCX)
;       mov     ecx, eax        ; Duplicate value
;       shr     ecx, 31         ; Fill ecx with its sign
;       xor     eax, ecx        ; Do 'not eax' if negative
;       sub     eax, ecx        ; Do 'inc eax' if negative

; the standard way
;       or      eax, eax
;       js      abs_done
;       neg     eax
;abs_done:

; This is necessary for font: lfHeight=-8 lfWidth=5 lfFaceName='Terminal'
; Without this characters 'gjpqy' are displayed without the most bottom parts
; because grid line overcovers them.
;       test    byte [face.var_settings],ListEditExtra1Pixel
;       jz      ChildProc_MEASUREITEM_L0
;       add     eax,1
;ChildProc_MEASUREITEM_L0:
;
;       test    byte [face.var_settings],ListEditExtra2Pixels
;       jz      ChildProc_MEASUREITEM_L1
;       add     eax,2           ; +1 upper +1 lower line for DrawFocusRect
;ChildProc_MEASUREITEM_L1:
;
;       test    byte [face.var_settings],ListEditExtra4Pixels
;       jz      ChildProc_MEASUREITEM_L2
;       add     eax,4           ; +2 upper +2 lower lines for Clientedge
;ChildProc_MEASUREITEM_L2:

; this is faster than commented above:
	push	rcx
	movzx	ecx,byte [face.var_settings]
	shr	cl,bListEditExtra1Pixel
	add	eax,ecx
	pop	rcx

	mov	[msrits.itemHeight],eax
	xor	eax,eax
	ret

;ChildProc_KEYDOWN_KEYUP:
;; post message about keydown/keyup to the Control in the window
;       push    rax rcx rdx r8 r9
;       sub     rsp,8*4
;; rcx=handle of hWnd owning SysListView32
;       call    hWndList2iList
;       jc      List_NewProc_KEYDOWN_epi
;; edx=index of SysListView32
;       lea     rax,[hWndChildren]
;       mov     rcx,[rax+rdx*8]                 ; get handle of the window owning the control
;       mov     edx,dword [rsp+8*(4+2)]         ; grab original WM_ message
;; r8=wParam r9=lParam
;       call    qword [PostMessageA]            ; we won't wait until done, so we post, not send
;List_NewProc_KEYDOWN_epi:
;       add     rsp,8*4
;       pop     r9 r8 rdx rcx rax
;       jmp     ChildProc_DefMDIChildProcA

ChildProc_KEYDOWN:
	push	rax rcx rdx r8 r9 r10 r11
	call	hWndList2iList
;       jc      ...                             ; unnecessary, next call allows only EDX=0,1,...5
	call	proc_List_KEYDOWN
	cmp	edx,num_of_LV_supporting_proc_List_KEYDOWN
	pop	r11 r10 r9 r8 rdx rcx rax
	jnc	ChildProc_DefMDIChildProcA	; for GPR,... Floating Control

; for code 1st, ... stack
	xor	eax,eax
	ret

List_NewProc:
;       cmp     edx,WM_ERASEBKGND       ; these 4 instructions
;       jnz     List_NewProc_L0         ; suggested
;       xor     eax,eax                 ; to prevent boring flickering
;       ret                             ; but then SysListView32s don't update correctly

List_NewProc_L0:
	cmp	edx,WM_LBUTTONDOWN
	jz	List_NewProc_LBUTTONDOWN
	cmp	edx,WM_RBUTTONDOWN
	jz	List_NewProc_RBUTTONDOWN

	cmp	edx,WM_LBUTTONDBLCLK
	jz	List_NewProc_LBUTTONDBLCLK

; What is better ? Catch 1. WM_KEYDOWN or 2. LVN_KEYDOWN in WM_NOTIFY ? 1. works well.
	cmp	edx,WM_KEYDOWN
	jz	List_NewProc_KEYDOWN

	cmp	edx,WM_HSCROLL
	jz	List_NewProc_HSCROLL

	cmp	edx,WM_COMMAND
	jnz	List_NewProc_CallWindowProc

	cmp	r8w,ID_ListViewEditBox
	jz	List_NewProc_WM_COMMAND_ListViewEditBox

;       movzx   r11d,r8w
;       sub     r11d,ID_ListViewMenu_CMD00
;       lea     r10,[IDM_ListViewMenu_Commands]
;       jmp     qword [r10+r11*8]

List_NewProc_CallWindowProc:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	mov	[rsp + 8*(4+0)],r9	; 5th API param
	mov	r9,r8
	mov	r8d,edx
	mov	rdx,rcx
	mov	rcx,[lpfnListProc]
	call	[CallWindowProcA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

List_NewProc_LBUTTONDOWN:
	push	rdx
	call	hList2iList
	jc	List_NewProc_LBUTTONDOWN_epi
	call	select_iItem

List_NewProc_LBUTTONDOWN_epi:
	pop	rdx
;       jmp     List_NewProc_CallWindowProc
; we did everything, we don't want to OS select iItem in SysListView32
	xor	eax,eax
	ret

List_NewProc_RBUTTONDOWN:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+3)

	cmp	[WeAreDebugging],0
	jz	List_NewProc_RBUTTONDOWN_epi

;       cmp     [DebuggeeResumed],0
;       jnz     List_NewProc_RBUTTONDOWN_epi
; no, we allow copying of the content even debuggee is in resumed state... content of the
; SysListView32 may change between RBUTTONDOWN and selecting COPY from menu, but we don't
; worry about it since we will copy updated content at the time of selecting COPY from menu

	call	get_iList
	jc	List_NewProc_RBUTTONDOWN_epi
	lea	rdx,[hListView]
	mov	rcx,qword [rdx+rax*8]
	mov	qword [hSysListView32RMenu],rcx ; save handle for CMD_COPY_CONTENT

	lea	rcx,[rsp+8*4]			; POINT structure has 2 dwords = 1 qword
	call	qword [GetCursorPos]
	or	rax,rax
	jz	List_NewProc_RBUTTONDOWN_epi

	xor	eax,eax
	mov	rcx,qword [hWndParent]
	mov	r9d,[rsp+8*4 + POINT64.y]
	mov	r8d,[rsp+8*4 + POINT64.x]	; get it before mov dword [rsp+8*(4+0)],eax
	mov	qword [rsp+8*(4+2)],rax
	mov	qword [rsp+8*(4+1)],rcx
	mov	dword [rsp+8*(4+0)],eax
if TPM_LEFTALIGN=0
	xor	edx,edx
else
	mov	edx,TPM_LEFTALIGN
end if
	mov	rcx,qword [hPopupMenu]
	call	qword [TrackPopupMenu]
List_NewProc_RBUTTONDOWN_epi:
	add	rsp,8*(4+3)
	pop	r9 r8 rdx rcx
; we don't want for OS to select item in this control
;       jmp     List_NewProc_CallWindowProc
	xor	eax,eax
	ret

List_NewProc_LBUTTONDBLCLK:
	push	rcx rdx rbx r8 r9 r12 r13 r14 r15

a = (sizeof.LV_ITEM64+15)/16
	sub	rsp,8*(4+a)

	cmp	[WeAreDebugging],0
	jz	List_NewProc_LBUTTONDBLCLK_done

;       cmp     [DebuggeeResumed],0
;       jnz     List_NewProc_LBUTTONDBLCLK_done
; we allow it even result should be unpredicable when thread is in resumed state

; try to destroy previous Edit
	call	ListView_Edit_destroy

	mov	qword [EditedListView_handle],rcx

	call	hList2iList			; return EDX index from RCX handle
	jc	List_NewProc_LBUTTONDBLCLK_epi
	mov	qword [ListView_edit_Listview_index],rdx

	call	ListView_get_item_and_subitem	; return RAX item and subitem from RCX handle and cursor position
	jc	List_NewProc_LBUTTONDBLCLK_epi
	mov	qword [ListView_edit_last_item_and_subitem],rax

	call	ListView_edit_allowed_index_item_subitem
	jc	List_NewProc_LBUTTONDBLCLK_epi

; get text iItem iSubItem
	lea	r9,[rsp + 8*(4+0)]		; point to LV_ITEM64 in the stack
	lea	rcx,[tmp_buf]			; point to buffer
	mov	byte [r9 + LV_ITEM64.mask],LVIF_TEXT
	mov	qword [r9 + LV_ITEM64.iItem],rax	; item and subitem
	mov	qword [r9 + LV_ITEM64.pszText],rcx
	mov	dword [r9 + LV_ITEM64.cchTextMax],tmp_buf_size
	xor	r8,r8
	mov	edx,LVM_GETITEM
	mov	rcx,qword [rsp + 8*(4+a+8)]
	call	qword [SendMessageA]
; get 0-terminated string, return in RAX its size without 0-terminator
	or	rax,rax
	jz	List_NewProc_LBUTTONDBLCLK_epi

; get rectangles of iItem iSubItem
	lea	r9,[rsp + 8*(4+0)]
	mov	eax,dword [ListView_edit_last_item_and_subitem + 4]	; subitem
	mov	[r9 + RECT.left],LVIR_LABEL	; code          Portion of the list view item for which to retrieve the bounding rectangle.
						; LVIR_BOUNDS   Returns the bounding rectangle of the entire item, including the icon and label.
						; LVIR_ICON     Returns the bounding rectangle of the icon or small icon.
						; LVIR_LABEL    Returns the bounding rectangle of the item text.
						; LVIR_SELECTBOUNDS     Returns the union of the LVIR_ICON and LVIR_LABEL rectangles, but excludes columns in details view.
	mov	[r9 + RECT.top],eax		; subitem
	mov	r8d,dword [ListView_edit_last_item_and_subitem] ; item
	mov	edx,LVM_GETSUBITEMRECT
	mov	rcx,qword [rsp + 8*(4+a+8)]
	call	qword [SendMessageA]
	or	rax,rax
	jz	List_NewProc_LBUTTONDBLCLK_epi

	movdqa	xmm0,dqword [rsp + 8*(4+0)]
	movdqa	dqword [ListView_item_and_subitem_rect],xmm0

; create List Edit
	mov	rcx,qword [rsp + 8*(4+a+8)]
	call	Kreate_ListView_Edit
; set text in List Edit
	lea	r9,[tmp_buf]
	xor	r8,r8
	mov	edx,WM_SETTEXT
	mov	rcx,qword [ListView_Edit_handle]
	call	qword [SendMessageA]

; limit text size there
	mov	r9d,tmp_buf_size		; lParam text limit
	xor	r8,r8
	mov	edx,EM_LIMITTEXT
	mov	rcx,qword [ListView_Edit_handle]
	call	qword [SendMessageA]

;; this will select the whole text like Select All or pressing of CTRL+A
;; works well, but has the risk that user destroys the whole text by pressing most of keys
;; we allow it only for subitem=3 = ascii strings in Data 1st, Data 2nd, Data 3rd
;       cmp     dword [ListView_edit_Listview_index],2
;       jc      List_NewProc_LBUTTONDBLCLK_done         ; Code 1st, Code 2nd
;       cmp     dword [ListView_edit_Listview_index],5  ; Stack, GPR, IP, XMM, MM/ST, ...
;       jnc     List_NewProc_LBUTTONDBLCLK_done
;       cmp     dword [ListView_edit_last_item_and_subitem + 4],3       ; check subitem 3
;       jnz     List_NewProc_LBUTTONDBLCLK_done
;
;       mov     r9d,tmp_buf_size
;       xor     r8,r8
;       mov     edx,EM_SETSEL
;       mov     rcx,qword [ListView_Edit_handle]
;       call    qword [SendMessageA]

; this will select the whole text like Select All or pressing of CTRL+A
; works well, but has the risk that user destroys the whole text by pressing most of keys
	test	[face.auto_selection],1
	jz	List_NewProc_LBUTTONDBLCLK_after_selecting_content
; An application sends an EM_SETSEL message to select a range of characters in an edit control
; If the nStart parameter is 0 and the nEnd parameter is -1, all the text in the edit control is selected.
	or	r9d,-1				; end
	xor	r8,r8				; start
	mov	edx,EM_SETSEL
	mov	rcx,[ListView_Edit_handle]
	call	[SendMessageA]
List_NewProc_LBUTTONDBLCLK_after_selecting_content:

List_NewProc_LBUTTONDBLCLK_done:
	xor	eax,eax
List_NewProc_LBUTTONDBLCLK_epi:
	add	rsp,8*(4+a)
	pop	r15 r14 r13 r12 r9 r8 rbx rdx rcx
	ret

List_NewProc_KEYDOWN:
	push	rax rcx rdx r8 r9 r10 r11
	call	hList2iList
;       jc      ...                             ; unnecessary, next call allows only EDX=0,1,...5
	call	proc_List_KEYDOWN
	cmp	edx,num_of_LV_supporting_proc_List_KEYDOWN
	pop	r11 r10 r9 r8 rdx rcx rax

; this make default handler to update selected item in ListView
	jnc	List_NewProc_CallWindowProc

; we did it ourselves already for code 1st, ... stack and we don't want for OS to do it
	xor	eax,eax
	ret

List_NewProc_WM_COMMAND_ListViewEditBox:

	cmp	r8d,EN_KILLFOCUS shl 16 + ID_ListViewEditBox
; the above instruction destroys high dword of R8 but the destroyed dword doesn't contain anything
	jnz	ListView_Edit_NewProc

List_NewProc_WM_COMMAND_ListViewEditBox_destroy:
	push	rcx				; just align stack at dqword
	call	ListView_Edit_destroy
	pop	rcx
	xor	eax,eax
	ret




List_NewProc_HSCROLL:
;       cmp     r8w,SB_ENDSCROLL

; is there ListEdit?
	cmp	[ListView_Edit_exist],0
	jz	List_NewProc_HSCROLL_end

;; valid handle?
;       mov     rax,[ListView_Edit_handle]
;       or      rax,rax
;       jz      List_NewProc_HSCROLL_end
;       cmp     rax,INVALID_HANDLE_VALUE
;       jz      List_NewProc_HSCROLL_end

	push	rax rcx rdx r8 r9

a = (sizeof.LV_ITEM64+15)/16
	sub	rsp,8*(4+a)


; get rectangles of iItem iSubItem
	lea	r9,[rsp + 8*(4+0)]
	mov	eax,dword [ListView_edit_last_item_and_subitem + 4]	; subitem
	mov	[r9 + RECT.left],LVIR_LABEL	; code          Portion of the list view item for which to retrieve the bounding rectangle.
						; LVIR_BOUNDS   Returns the bounding rectangle of the entire item, including the icon and label.
						; LVIR_ICON     Returns the bounding rectangle of the icon or small icon.
						; LVIR_LABEL    Returns the bounding rectangle of the item text.
						; LVIR_SELECTBOUNDS     Returns the union of the LVIR_ICON and LVIR_LABEL rectangles, but excludes columns in details view.
	mov	[r9 + RECT.top],eax		; subitem
	mov	r8d,dword [ListView_edit_last_item_and_subitem] ; item
	mov	edx,LVM_GETSUBITEMRECT
	mov	rcx,[EditedListView_handle]
	call	[SendMessageA]
	or	eax,eax
	jz	List_NewProc_HSCROLL_epi

	movdqa	xmm0,dqword [rsp + 8*(4+0)]
	movdqa	dqword [ListView_item_and_subitem_rect],xmm0

	mov	eax,dword [ListView_item_and_subitem_rect + RECT64.bottom]
	mov	byte [rsp+8*(4+1)],1						; 6th API param - bRepaint
	mov	r9d,dword [ListView_item_and_subitem_rect + RECT64.right]
	mov	r8d,dword [ListView_item_and_subitem_rect + RECT64.top] 	; Y
	mov	edx,dword [ListView_item_and_subitem_rect + RECT64.left]	; X
	sub	eax,r8d
	sub	r9d,edx 							; width
	mov	[rsp+8*(4+0)],eax						; height
	mov	rcx,[ListView_Edit_handle]
	call	[MoveWindow]

List_NewProc_HSCROLL_epi:
	add	rsp,8*(4+a)
	pop	r9 r8 rdx rcx rax

List_NewProc_HSCROLL_end:
	jmp	List_NewProc_CallWindowProc



ListView_Edit_NewProc:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+7)

	cmp	edx,WM_KEYDOWN
	jz	ListView_Edit_keydown

ListView_Edit_NewProc_end_0:

	mov	rax,qword [rsp + 8*(4+7+0)]	; grab saved r9
	mov	r9,qword [rsp + 8*(4+7+1)]	; grab saved r8
	mov	r8,qword [rsp + 8*(4+7+2)]	; grab saved rdx
	mov	rdx,qword [rsp + 8*(4+7+3)]	; grab saved rcx
	mov	rcx,qword [ListView_Edit_OldProc]
	mov	qword [rsp + 8*(4+0)],rax	; 5th API param
	call	qword [CallWindowProcA]

ListView_Edit_NewProc_end:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx
	ret

ListView_Edit_keydown:
	cmp	r8d,VK_RETURN
	jz	ListView_Edit_keydown_enter
	cmp	r8d,VK_ESCAPE
	jnz	ListView_Edit_NewProc_end_0

; ESCAPE pressed
	call	ListView_Edit_destroy
;       jmp     ListView_Edit_NewProc_end_0
	xor	eax,eax
	jmp	ListView_Edit_NewProc_end

ListView_Edit_keydown_enter:
	lea	r9,[tmp_buf]
	mov	r8d,tmp_buf_size
	mov	edx,WM_GETTEXT
	mov	rcx,[ListView_Edit_handle]
	call	[SendMessageA]
;       or      rax,rax
;       jz      ListView_Edit_NewProc_end       ; nothing in edit
; wrong, somebody may want to erase comment

ListView_Edit_do_main_action:
; eax                                   text size
; tmp_buf                               buffer holding string from Edit Control
; [ListView_edit_last_item_and_subitem] item and subitem holding Edit control
; [ListView_edit_Listview_index]        ListView index (0=code 1st, 1=code 2nd, 13=floating control)
; [EditedListView_handle]               ListView handle
	mov	rdx,qword [ListView_edit_Listview_index]
	lea	rcx,[addr_proc_ListView_Edit_do_main_action]
	call	qword [rcx + rdx*8]	; do main action and modify string in buffer if necessary

	call	ListView_Edit_destroy

	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory

	xor	eax,eax
	jmp	ListView_Edit_NewProc_end

; --- procedure begin ---
align 16
msg_to_LogEdit:
; input string at rax
; destroys nothing
; Initialize the Font common dialog box with the last font selection.
; If the user clicks the OK button of the dialog box, the return value is nonzero. The members of the CHOOSEFONT structure indicate the user's selections.
; If the user cancels or closes the Font dialog box or an error occurs, the return value is zero.
	push	rax rcx rdx rsi rdi r8 r9 r10 r11
	sub	rsp,8*(4+0)
	lea	rsi,[rax]
	lea	rdi,[rax]
	or	ecx,-1
	xor	eax,eax
	cld
	repnz scasb
	not	ecx
	mov	rdi,qword [LogEdit_end]
	repz movsb
	dec	rdi				; back before 0-terminator
	mov	qword [LogEdit_end],rdi

	mov	r9,qword [LogEdit_buffer]
	xor	r8,r8
	mov	edx,WM_SETTEXT
	mov	rcx,qword [hLogEdit]
	call	qword [SendMessageA]

	xor	r9,r9
	mov	r8d,SB_BOTTOM
	mov	edx,WM_VSCROLL
	mov	rcx,qword [hLogEdit]
	call	qword [SendMessageA]

msg_to_LogEdit_epilogue:
	add	rsp,8*(4+0)
	pop	r11 r10 r9 r8 rdi rsi rdx rcx rax
	ret
; ++++ procedure end ++++

; --- procedure begin ---
clear_all_listviews:
; clear all ListView (ListView00 - ListView0D)
	push	rcx
	push	rdx
	push	rbx
	push	rbp
	push	r8
	push	r9
	sub	rsp,8*(4+1)
	mov	ebx,NumberOfSysListView32 - 1	; -1 make it zero-based

clear_all_ListView_L3:
	lea	rdx,[hListView]
	xor	r9,r9
	xor	r8,r8
	mov	rbp,qword [rdx+rbx*8]	; handle of SysListView32
	mov	edx,LVM_DELETEALLITEMS
	mov	rcx,rbp
	call	qword [SendMessageA]
clear_all_ListView_L4:
	cmp	ebx,6
	jc	clear_all_listviews_L5	; nothing to fill for Code 1st 2nd, Data 1st 2nd 3rd, Stack SysListView32
; fill SysListView32s 0st column with registers names
	lea	rax,[addr_SLV_fillregs - 8*6]	; first 6 SysListView32 don't have anything to fill
	call	qword [rax+rbx*8]
clear_all_listviews_L5:

	dec	ebx
	jns	clear_all_ListView_L3

	add	rsp,8*(4+1)
	pop	r9
	pop	r8
	pop	rbp
	pop	rbx
	pop	rdx
	pop	rcx
	ret
; ++++ procedure end ++++

;; --- procedure begin ---
;align 16
;get_child_index:
;; output eax index of the child or control, CarryFlag set if no such control handle found
;; index means Code 1st, the last index means EDIT with Log
;       push    rcx rdx rdi r8 r9 r10 r11
;       sub     rsp,8*(4+0)
;
;       call    qword [GetFocus]
;
;       lea     rdi,[hWndChildren]
;       mov     ecx,NumberOfMDIChildren
;       cld
;       repnz scasq
;       jz      get_child_index_L0
;
;if (hChildren-hWndChildren) <> (NumberOfMDIChildren*8)
;       lea     rdi,[hChildren]
;end if
;       mov     cl,NumberOfMDIChildren
;       repnz scasq
;get_child_index_L0:
;       setnz   al                              ; AL=1 if no such handle found
;       movzx   eax,al
;       add     eax,NumberOfMDIChildren - 1
;       sub     eax,ecx                         ; EAX = index of Child, the first is Code 1st SysListView32, the last is EDIT holding Log
;       add     rsp,8*(4+0)
;       cmp     eax,NumberOfMDIChildren         ; real index is in range from 0 to (NumberOfMDIChildren-1)
;                                               ; so for real index cmp sets carry everytime
;                                               ; for nonexisting clears carry everytime
;       cmc                                     ; complement carry flag
;       pop     r11 r10 r9 r8 rdi rdx rcx
;       ret
;; ++++ procedure end ++++

; --- procedures begin ---
align 16
get_iList:
; in:   rcx handle of hWndList or hList
; out:  eax index of the child or control, CarryFlag set if no such control handle found
; index means Code 1st, the last index means Floating Control
	push	rdx
	call	hWndList2iList
	mov	eax,edx
	jnc	get_iList_epi
	call	hList2iList
	mov	eax,edx
get_iList_epi:
	pop	rdx
	ret

align 16
hWndList2iList:
; input RCX handle of the Window owning control:
; output EDX index of the control, CarryFlag set if no such control handle found
	push	rax rcx rdi
	mov	rax,rcx
	lea	rdi,[hWndListView]
	mov	ecx,NumberOfSysListView32
	lea	edx,[rcx-1]			; -1 because index is 0-based (0 for 1st, 1 for 2nd, ...)
	cld
	repnz scasq
	stc
	jnz	hWndList2iList_epi
	sub	edx,ecx 			; this clears Carry flag everytime in our proc
hWndList2iList_epi:
	pop	rdi rcx rax
	ret

align 16
hList2iList:
; input RCX Control handle:
; output EDX index of the control, CarryFlag set if no such control handle found
	push	rax rcx rdi
	mov	rax,rcx
	lea	rdi,[hListView]
	mov	ecx,NumberOfSysListView32
	lea	edx,[rcx-1]			; -1 because index is 0-based (0 for 1st, 1 for 2nd, ...)
	cld
	repnz scasq
	stc
	jnz	hList2iList_epi
	sub	edx,ecx 			; this clears Carry flag everytime in our proc
hList2iList_epi:
	pop	rdi rcx rax
	ret
; ++++ procedures end ++++

; --- procedures begin ---
update_status_window_PID_TID:
	push	rax rcx rdx rdi r8 r9 r10 r11
	sub	rsp,8*(4+5)
	mov	rdi,'ProcId='
	mov	rcx,'ThrdId='
	mov	qword [rsp+8*4 + 0],rdi
	mov	qword [rsp+8*4 +17],rcx
	lea	rdi,[rsp+8*4 + 7]
	call	hexa_32_eax
	mov	eax,edx
	lea	rdi,[rsp+8*4 +24]
	call	hexa_32_eax
	mov	word [rsp+8*4 +15],'h'		; h for hexa and terminator
	mov	word [rsp+8*4 +32],'h'
	lea	r9,[rsp+8*4 + 0]
	xor	r8,r8
	mov	edx,SB_SETTEXT
	mov	rcx,qword [hWndStatus]
	call	qword [SendMessageA]
	lea	r9,[rsp+8*4 +17]
	mov	r8d,1
	mov	edx,SB_SETTEXT
	mov	rcx,qword [hWndStatus]
	call	qword [SendMessageA]
	add	rsp,8*(4+5)
	pop	r11 r10 r9 r8 rdi rdx rcx rax
	ret

update_status_window_PID_TID_empty:
	push	rax rcx rdx r8 r9 r10 r11
	sub	rsp,8*(4+2)
	mov	rdx,'none>'
	mov	rax,'ProcID=<'
	lea	r9,[rsp+8*4]
	xor	r8,r8
	mov	qword [r9+8],rdx
	mov	qword [r9],rax
	mov	edx,SB_SETTEXT
	mov	rcx,qword [hWndStatus]
	call	qword [SendMessageA]
	lea	r9,[rsp+8*4]
	mov	r8d,1
	mov	dword [r9],'Thrd'
	mov	edx,SB_SETTEXT
	mov	rcx,qword [hWndStatus]
	call	qword [SendMessageA]
	lea	r9,[rsp+8*4]
	mov	r8d,2
	mov	byte [r9],0
	mov	edx,SB_SETTEXT
	mov	rcx,qword [hWndStatus]
	call	qword [SendMessageA]
	add	rsp,8*(4+2)
	pop	r11 r10 r9 r8 rdx rcx rax
	ret

update_status_window_running:
	push	rax rcx rdx r8 r9 r10 r11
	sub	rsp,8*(4+2)
	mov	rax,'running'
	lea	r9,[rsp+8*4]
	mov	r8d,2
	mov	[r9],rax
	mov	edx,SB_SETTEXT
	mov	rcx,qword [hWndStatus]
	call	qword [SendMessageA]
	add	rsp,8*(4+2)
	pop	r11 r10 r9 r8 rdx rcx rax
	ret

update_status_window_stopped:
	push	rax rcx rdx r8 r9 r10 r11
	sub	rsp,8*(4+2)
	mov	rax,'stopped'
	lea	r9,[rsp+8*4]
	mov	r8d,2
	mov	[r9],rax
	mov	edx,SB_SETTEXT
	mov	rcx,qword [hWndStatus]
	call	qword [SendMessageA]
	add	rsp,8*(4+2)
	pop	r11 r10 r9 r8 rdx rcx rax
	ret
; ++++ procedures end ++++

; procedures from include files:
align 16
include 'fdbg_DebugLoop.inc'
include 'fdbg_procs.inc'
include 'ini_file.inc'				; load/save params from/to the fdbg ini file
include 'hexa_proc.inc'
include 'floating_proc.inc'
include 'syslistview32s.inc'
include 'fdbg_ListView_Edit_proc.inc'
include 'fdisasm64_proc.inc'


section '.data' data readable writeable

padnum16zero
include 'imports.inc'

; uncomment next if you compress fdbg with noimports version of compressor
;RtlExitUserProcess     db      'RtlExitUserProcess',0

padnum16zero
include 'hexa_data.inc'
include 'fdisasm64_data.inc'

padnum16zero
post_disasm_action_proc_addr:
	dq	post_disasm_action_proc_0
	dq	post_disasm_action_proc_1
	dq	post_disasm_action_proc_2
	dq	post_disasm_action_proc_3
	dq	post_disasm_action_proc_4
	dq	post_disasm_action_proc_5
	dq	post_disasm_action_proc_6
	dq	post_disasm_action_proc_7
	dq	post_disasm_action_proc_8
	dq	post_disasm_action_proc_9
	dq	post_disasm_action_proc_A
	dq	post_disasm_action_proc_B
	dq	post_disasm_action_proc_C
	dq	post_disasm_action_proc_D
	dq	post_disasm_action_proc_E
	dq	post_disasm_action_proc_F
	dq	post_disasm_action_proc_G
	dq	post_disasm_action_proc_H
	dq	post_disasm_action_proc_I


padnum16zero
post_disasm_cond_jump_proc_addr:
	dq	post_disasm_cond_jump_proc_JO
	dq	post_disasm_cond_jump_proc_JNO
	dq	post_disasm_cond_jump_proc_JC
	dq	post_disasm_cond_jump_proc_JNC
	dq	post_disasm_cond_jump_proc_JZ
	dq	post_disasm_cond_jump_proc_JNZ
	dq	post_disasm_cond_jump_proc_JBE
	dq	post_disasm_cond_jump_proc_JNBE
	dq	post_disasm_cond_jump_proc_JS
	dq	post_disasm_cond_jump_proc_JNS
	dq	post_disasm_cond_jump_proc_JP
	dq	post_disasm_cond_jump_proc_JNP
	dq	post_disasm_cond_jump_proc_JL
	dq	post_disasm_cond_jump_proc_JNL
	dq	post_disasm_cond_jump_proc_JLE
	dq	post_disasm_cond_jump_proc_JNLE


padnum16zero
Kommandz_jump_table:
; build this table according members folling ID_First in the resource
; procedures handling main menu01 and righlt mouse click menu:
				dq	CMD_EXIT
				dq	CMD_OPEN
				dq	CMD_ATTACH
				dq	CMD_TERMINATE
				dq	CMD_PROGRAMRESET
				dq	CMD_DETACH
				dq	CMD_GOTO
				dq	CMD_PROC_THRD
				dq	CMD_STACK
				dq	CMD_IMPORTS
				dq	CMD_SYMBOLS
				dq	CMD_TRACEINTO
				dq	CMD_STEPOVER
				dq	CMD_RUN
				dq	CMD_RUN_UNHANDLED
				dq	CMD_RETURN_FROM_PROCEDURE
				dq	CMD_EXECUTE_TO
				dq	CMD_RUN_HERE
				dq	CMD_SW_BP_TOGGLE
				dq	CMD_SW_BP_SET
				dq	CMD_HW_BP_SET
				dq	CMD_BP_AT_SYMBOL
				dq	CMD_BP_DELETE
				dq	CMD_FIND
				dq	CMD_MEM_PAGES
				dq	CMD_MEM_SAVE
				dq	CMD_MEM_LOAD
				dq	CMD_CONTROL_LBR
				dq	CMD_CONTROL_BTF
				dq	CMD_RAMBO_RD
				dq	CMD_RAMBO_PBDE
				dq	CMD_PAUSE
				dq	CMD_COPY_CONTENT
				dq	CMD_RAMBO_IDPF
				dq	CMD_RAMBO_FWW
				dq	CMD_RAMBO_TFATT
				dq	CMD_RAMBO_CCCD
				dq	CMD_RAMBO_FB
				dq	CMD_RAMBO_TLSC
				dq	CMD_RAMBO_EHP
				dq	CMD_RAMBO_DTPA
				dq	CMD_RAMBO_IE
				dq	CMD_FONT
				dq	CMD_VAR
				dq	CMD_HELP
; the terminator must be:
				dq	WndProc_Def

padnum16zero
include 'fdbg_DebugLoop_jmp_tbl.inc'

padnum16zero
display_symbols_procedures	dq	display_symbols_procedure00
				dq	display_symbols_procedure01

;padnum16zero
;post_disasm_procedures         dq      post_disasm_proc_00
;;                              dq      post_disasm_proc_01

align 16
Rambo_procedures:	dq	Rambo_IsDebuggerPresent
			dq	Rambo_FindWindow
			dq	Rambo_dummy
			dq	Rambo_dummy
			dq	Rambo_dummy
			dq	Rambo_ExecutableHeaderPredator
			dq	Rambo_dummy

padnum16zero
addr_ListView_edit_allowed_index_item_subitem:
	dq	proc_LVeaiis00
	dq	proc_LVeaiis01
	dq	proc_LVeaiis02
	dq	proc_LVeaiis03
	dq	proc_LVeaiis04
	dq	proc_LVeaiis05
	dq	proc_LVeaiis06
	dq	proc_LVeaiis07
	dq	proc_LVeaiis08
	dq	proc_LVeaiis09
	dq	proc_LVeaiis0A
	dq	proc_LVeaiis0B
	dq	proc_LVeaiis0C
	dq	proc_LVeaiis0D

padnum16zero
addr_proc_ListView_Edit_do_main_action:
	dq	proc_LV_edma00
	dq	proc_LV_edma01
	dq	proc_LV_edma02
	dq	proc_LV_edma03
	dq	proc_LV_edma04
	dq	proc_LV_edma05
	dq	proc_LV_edma06
	dq	proc_LV_edma07
	dq	proc_LV_edma08
	dq	proc_LV_edma09
	dq	proc_LV_edma0A
	dq	proc_LV_edma0B
	dq	proc_LV_edma0C
	dq	proc_LV_edma0D


padnum16zero
addr_SLV_fillregs		dq	FillGPRNames
				dq	FillIPName
				dq	FillXMMNumbers
				dq	FillMMNumbers
				dq	FillFlagNames
				dq	FillSegRegNames
				dq	FillDebugRegNames
				dq	FillFloatingControlRegNames

padnum16zero
; must hold NumberOfSysListView32 addresses
addr_child_title		dq	title_child00
				dq	title_child01
				dq	title_child02
				dq	title_child03
				dq	title_child04
				dq	title_child05
				dq	title_child06
				dq	title_child07
				dq	title_child08
				dq	title_child09
				dq	title_child0A
				dq	title_child0B
				dq	title_child0C
				dq	title_child0D
a = ($ - addr_child_title) / 8
if a <> NumberOfSysListView32
Mismatch of entries in addr_child_title, correct it !!!
end if

addr_SLV_column_names		dq	SLV00cn
				dq	SLV01cn
				dq	SLV02cn
				dq	SLV03cn
				dq	SLV04cn
				dq	SLV05cn
				dq	SLV06cn
				dq	SLV07cn
				dq	SLV08cn
				dq	SLV09cn
				dq	SLV0Acn
				dq	SLV0Bcn
				dq	SLV0Ccn
				dq	SLV0Dcn
a = ($ - addr_SLV_column_names) / 8
if a <> NumberOfSysListView32
Mismatch of entries in addr_SLV_column_sizes, correct it !!!
end if

;addr_XMM_col_name              dq      SLV08cn0
;                               dq      SLV08cn1
;                               dq      SLV08cn2
;
;addr_STMM_col_name             dq      SLV09cn0
;                               dq      SLV09cn1
;                               dq      SLV09cn2

padnum16zero
addr_SLV_column_sizes		dq	face.SLV00cs
				dq	face.SLV01cs
				dq	face.SLV02cs
				dq	face.SLV03cs
				dq	face.SLV04cs
				dq	face.SLV05cs
				dq	face.SLV06cs
				dq	face.SLV07cs
				dq	face.SLV08cs
				dq	face.SLV09cs
				dq	face.SLV0Acs
				dq	face.SLV0Bcs
				dq	face.SLV0Ccs
				dq	face.SLV0Dcs
a = ($ - addr_SLV_column_sizes) / 8
if a <> NumberOfSysListView32
Mismatch of entries in addr_SLV_column_sizes, correct it !!!
end if
				dq	face.SysListView32Sizes ; must be here for save columns at WM_CLOSE

SLV00cn 			db	'address',0
				db	'raw opcode',0
				db	'disassembled instruction',0
				db	'comments',0,0
SLV01cn 			db	'address',0
				db	'raw opcode',0
				db	'disassembled instruction',0
				db	'comments',0,0
SLV02cn 			db	'address',0
				db	'+0  +2  +4  +6',0
				db	'+8  +A  +C  +E',0
SLV02cn_ascii			db	'ASCII',0,0
SLV03cn 			db	'address',0
				db	'+0  +2  +4  +6',0
				db	'+8  +A  +C  +E',0
				db	'ASCII',0,0
SLV04cn 			db	'address',0
				db	'+0  +2  +4  +6',0
				db	'+8  +A  +C  +E',0
				db	'ASCII',0,0
SLV05cn 			db	'address',0
				db	'  +6  +4  +2  +0',0,0
SLV06cn 			db	0
				db	'|q     |d  |w|b',0,0
SLV07cn 			db	'IP',0
				db	'qword (64 bit)',0,0
SLV08cn 			db	0	;'xmm',0
    .1				db	'hexa (128 bit)',0
    .2				db	'packed doubles (2x 64 bit)',0
    .3				db	'packed singles (4x 32 bit)',0,0
SLV09cn 			db	0	;'mm/st',0
				db	'fpu (80 bit)',0
				db	'hexa (64 bit)',0
				db	'packed singles (2x 32 bit)',0,0
SLV0Acn 			db	0,0
SLV0Bcn 			db	'S',0
				db	0,0
SLV0Ccn 			db	'DR',0
				db	0,0
SLV0Dcn 			db	'Floating',0
				db	0,0

dq 0, 0

;SLV08cn0                       db      'high<  ><  ><  >low <  ><  ><  > XMM 128 bit hexa',0
;SLV08cn1                       db      '<high...>      2x  XMM double precision      <...low>',0
;SLV08cn2                       db      '<high...>               4x  XMM single precision               <...low>',0

;SLV09cn0                       db      'ST 80 bit (hexa for denormal)',0
;SLV09cn1                       db      'high<  >low <  > MM 64 bit hexa',0
;SLV09cn2                       db      '<high> 2x MM single precision <low>',0

SLV0204cn			db	'+0  +2  +4  +6  +8  +A  +C  +E'


padnum16zero
include 'floating_data.inc'
post_disasm_sizes		db	1,2,4,8,4,8,10,2,4,8,10,8,8,16,16,16,8,16	; see fdbg_constants.inc -> post_disasm_byte

padnum16zero
reg64scan			db	'axcxdxbxspbpsidi8 9 101112131415ip'

padnum16zero
GPR_alphabetical_0_terminated	db	'rax',0
				db	'rbx',0
				db	'rcx',0
				db	'rdx',0
				db	'rsp',0
				db	'rbp',0
				db	'rsi',0
				db	'rdi',0
				db	' r8',0
				db	' r9',0
				db	'r10',0
				db	'r11',0
				db	'r12',0
				db	'r13',0
				db	'r14',0
				db	'r15',0

Flag_0_terminated		db	'C',0
				db	'P',0
				db	'A',0
				db	'Z',0
				db	'S',0
				db	'D',0
				db	'O',0
				db	'hexa',0,0

RIP_0_terminated		db	'rip',0

SegReg_0_terminated		db	'CS',0,0
				db	'DS',0,0
				db	'ES',0,0
				db	'FS',0,0
				db	'GS',0,0
				db	'SS',0,0

DebugReg_0_terminated		db	' 0',0,0
				db	' 1',0,0
				db	' 2',0,0
				db	' 3',0,0
				db	' 6',0,0
				db	' 7',0,0
				db	0,0,0,0,0,0,0

				db	0		; ' '
XMM_0_terminated		db	' 0',0,0	; ' '
				db	' 1',0,0	; ' '
				db	' 2',0,0	; ' '
				db	' 3',0,0	; ' '
				db	' 4',0,0	; ' '
				db	' 5',0,0	; ' '
				db	' 6',0,0	; ' '
				db	' 7',0,0	; ' '
				db	' 8',0,0	; ' '
				db	' 9',0,0	; ' '
				db	'10',0,0	; ' '
				db	'11',0,0	; ' '
				db	'12',0,0	; ' '
				db	'13',0,0	; ' '
				db	'14',0,0	; ' '
				db	'15',0,0

FloatingControl_0_terminated	db	'ControlWord',0,0,0,0,0
				db	'StatusWord',0,0,0,0,0,0
				db	'Tag"Word"',0,0,0,0,0,0,0
				db	'MxCsr',0,0,0,0,0,0,0,0,0,0,0
				db	'MxCsr_Mask',0,0,0,0,0,0

; we are displaying GPRs in order rax rbx rcx rdx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
; but they are in Context in order rax rcx rdx rbx rsp rbp rsi rdi r8 r9 r10 r11 r12 r13 r14 r15
GPR_order			db	0,3,1,2,4,5,6,7,8,9,10,11,12,13,14,15

flag_bits			db	0	; carry
				db	2	; parity
				db	4	; auxiliary carry 
				db	6	; zero
				db	7	; sign
				db	10	; direction
				db	11	; overflow
; we display only 7 flags, without these 2 extras which are not much usefull:
;                               db      8       ; trap
;                               db      9       ; interrupt

padnum16zero
mem_glob_alloc_handle		dq	0
mem_glob_alloc_pointer		dq	0
mem_glob_alloc_handle_old	dq	0
mem_glob_alloc_pointer_old	dq	0


slv32_colors:			;      background, foreground
				dd	00FFFFFFh, 00000000h	; white, black - default, 0
				dd	00FFBFBFh, 00000000h	; blue, black - RIP, 1
				dd	00BFBFFFh, 00000000h	; red, black - SW_BP, 2
				dd	00DFBFDFh, 00000000h	; cyan, black - RIP+SW_BP, 3
				dd	00BFFFBFh, 00000000h	; green, black - HW_BP, 4
				dd	00DFDFBFh, 00000000h	; magenta, black - RIP+HW_BP, 5
				dd	00BFDFDFh, 00000000h	; yellow, black - SW_BP+HW_BP, 6
				dd	00D4D4D4h, 00000000h	; gray, black - RIP+SW_BP+HW_BP, 7
num_of_colors			=	($-slv32_colors)/8

padnum16zero
imports_ListView_font		DefaultLOGFONTA64

AppName 			db	'FDBG - Win64 AMD64 Debugger written in FASM',0
ClassName			db	'fasm_win64_AMD64_debugger',0
MDIClientName			db	'MDICLIENT',0
MDIChildClassName		db	'MDICHILD',0
EditClassName			db	'EDIT',0
SysListView32ClassName		db	'SysListView32',0
ListBoxClassName		db	'LISTBOX',0

title_child00			db	'Code 1st',0
title_child01			db	'Code 2nd',0
title_child02			db	'Data 1st',0
title_child03			db	'Data 2nd',0
title_child04			db	'Data 3rd',0
title_child05			db	'Stack',0
title_child06			db	'GPR',0
title_child07			db	'IP',0
title_child08			db	'XMM',0
title_child09			db	'MM/ST',0
title_child0A			db	'Flags',0 
title_child0B			db	'Seg',0
title_child0C			db	'DR',0
title_child0D			db	'Floating Control',0
title_child_Edit		db	'Log',0

msg_fdbg_version		db	'fdbg'
				include 'verzy0n_tyme_(te-ygz-te).inc'
				db	0Dh,0Ah
				db	0

msg_fdbg_CPU_AMD		db	'For AMD CPUs, DebugControl (SingleStepOnBranches, LastBranchesRecording) worked at all x64 versions of windows at the time of the fdbg'
				include 'verzy0n_tyme_(te-ygz-te).inc'
				db	' release. Let you have a fun with this great feature.',0Dh,0Ah,0
msg_fdbg_CPU_Intel		db	'For Intel CPUs, DebugControl (SingleStepOnBranches, LastBranchesRecording) feature was firstly implemented in windows 2008 server x64 R2 (the same kernel as windows 7 x64). Let you have a fun with this great feature.',0Dh,0Ah,0
msg_fdbg_DebugCtlIntelWarning	db	'WARNING! DebugControl (SingleStepOnBranches, LastBranchesRecording) feature may not be supported. For GenuineIntel CPUs, the support was implemented since windows 2008 server x64 R2 (the same kernel as windows 7 x64).',0Dh,0Ah,0
msg_fdbg_DebugCtlUnknownCPU	db	"WARNING! This CPU is not AuthenticAMD either GenuineIntel, so fdbg doesn't know whether DebugControl (SingleStepOnBranches, LastBranchesRecording) feature is supported.",0Dh,0Ah,0



face_file_name			db	'fdbg'
				include 'verzy0n_tyme_(te-ygz-te).inc'
				db	'.ini'
help_file_name			db	'help.html',0

msg_CloseChildIsntAllowed	db	0Dh,0Ah,"Closing any child window isn't allowed. "
				db	"I'am minimizing it.",0

msg_PROGRAMRESET_not_possible	db	0Dh,0Ah,'Program reset is now denied. Use Terminate (Ctrl-T).',0

msg_restart_fdbg		db	0Dh,0Ah,0Dh,0Ah,'Please restart fdbg to take the effect '
				db	'(catching WM_MEASUREITEM when create all '
				db	'SysListView32 with LVS_OWNERDRAWFIXED style).',0

msg_restart_debuggee		db	0Dh,0Ah,0Dh,0Ah,'To take the effect please restart debuggee: '
				db	'Debuggee -> Program reset (Ctrl-R)',0

msg_branches			db	0Dh,0Ah,'Branches:'
				db	0Dh,0Ah,'LastBranchFromIP='
msg_LastBranchFromIP		db	'                h'
				db	0Dh,0Ah,'LastBranchToIP='
msg_LastBranchToIP		db	'                h'
				db	0Dh,0Ah,'LastExceptionFromIP='
msg_LastExceptionFromIP 	db	'                h'
				db	0Dh,0Ah,'LastExceptionToIP='
msg_LastExceptionToIP		db	'                h',0

aCopyContent			db	'Copy Content',0

;HelpFileName                   db      'help.html',0
;aopen                          db      'open',0

;e_title                                db      'Exception, please report it.',0

msg_bad_input_file		db	0Dh,0Ah,'Not PE32+ executable !',0

OFNTitle			db	'Select the executable',0
FilterString			db	'Executable Files',0,'*.exe',0 
				db	'All Files',0,'*.*',0,0

FilterString_cmd_mem_save:
				db	'Binary Files',0,'*.bin',0
				db	'All Files',0,'*.*',0,0

padnum16zero
include 'fdbg_DebugLoop_strings.inc'
include 'fdbg_debuggee_actions_data.inc'

padnum16zero
int03_opcode			db	0CCh

Dialog08AutoCheckBox0_checked	db	1
Dialog0FAutoCheckBox0_checked	db	1

parent_iconized 		db	0
HaltOnChoice			db	HaltOn_ntdll_ExeEntryPoint
DebugOnlyThisProcess		db	0
WeAreDebugging			db	0
program_reset_disabled		db	0
restarting_debuggee		db	0

padnum16zero
main_win_scr_minus		dd	0, 0, main_win_scr_x_minus, main_win_scr_y_minus

padnum16zero					; must be aligned 16 for use movdqa
screen_client_area:
.x				dd	0	; x
.y				dd	0	; y
.size_CXFULLSCREEN		rd	1	; cx
.size_CYFULLSCREEN		rd	1	; cy

padnum16zero
Dialog0CSysListView0_data	db	'BaseAddress',0
				dd	address_column_size
				db	'AllocationBase',0
				dd	data_column_size;address_column_size
				db	'AllocationProtect',0
				dd	60
				db	'Size',0
				dd	data_column_size
				db	'State',0
				dd	54
				db	'Protect',0
				dd	60
				db	'Type',0
				dd	54
				db	'dezkrypt',0
				dd	84
				db	0

padnum16zero
page_access_flags		db	'noaccess'
				db	'r       '
				db	'rw      '
				db	' w c    '
				db	'  e     '
				db	'r e     '
				db	'rwe     '
				db	' wec    '
				db	'    g   '
				db	'     n  '
page_state			db	'commit',0,0
				db	'reserve',0
				db	'free',0,0,0,0
page_type			db	'private',0
				db	'mapped',0,0
				db	'image',0,0,0

padnum16zero
Dialog0DSysListView0_data	db	'address',0
				dd	address_column_size
				db	'value',0
				dd	data_column_size;address_column_size
				db	'dezkrypt',0
				dd	600
				db	0

a_kernel32			db	'KERNEL32.DLL',0
a_GetEnabledXStateFeatures	db	'GetEnabledXStateFeatures',0
a_InitializeContext		db	'InitializeContext',0
a_SetXStateFeaturesMask 	db	'SetXStateFeaturesMask',0
a_GetXStateFeaturesMask 	db	'GetXStateFeaturesMask',0
a_LocateXStateFeature		db	'LocateXStateFeature',0


;padnum16zero                                   ; must be aligned 16 for use movdqa
;; Note, every 4 members must follow immediately each other in this order !
;EditedListView_handle          dq      INVALID_HANDLE_VALUE    ; handle of window owning List EDIT and SysListView32
;ListView_Edit_handle           dq      INVALID_HANDLE_VALUE    ; handle of List EDIT control
;ListView_edit_last_item_and_subitem    dq      -1
;ListView_edit_Listview_index           dq      -1

;padnum16zero
;SysListView32_paramz_big:
;address_column_size_big                =       150
;data_column_size_big           =       160
;data_column_ascii_size_big     =       data_column_size_big
;reg_column_size_big            =       50
;reg_mm_st_column_size_big      =       60
;xmm_column_size_big            =       700
;mm_st_column_size_big          =       300
;       .SLV00cs                dd      address_column_size_big, 100, 800
;       .SLV01cs                dd      address_column_size_big, 100, 800
;       .SLV02cs                dd      address_column_size_big, data_column_size_big, data_column_size_big, data_column_ascii_size_big
;       .SLV03cs                dd      address_column_size_big, data_column_size_big, data_column_size_big, data_column_ascii_size_big
;       .SLV04cs                dd      address_column_size_big, data_column_size_big, data_column_size_big, data_column_ascii_size_big
;       .SLV05cs                dd      address_column_size_big, data_column_size_big
;       .SLV06cs                dd      reg_column_size_big, data_column_size_big
;       .SLV07cs                dd      reg_column_size_big, data_column_size_big
;       .SLV08cs                dd      reg_column_size_big, xmm_column_size_big, xmm_column_size_big, xmm_column_size_big
;       .SLV09cs                dd      reg_mm_st_column_size_big, mm_st_column_size_big, mm_st_column_size_big, mm_st_column_size_big
;       .SLV0Acs                dd      32,32
;       .SLV0Bcs                dd      32,54
;       .SLV0Ccs                dd      32,data_column_size_big
;       .SLV0Dcs                dd      100,80
;       .SysListView32Sizes     SysListView32Sizes_Font_Terminal_19
;SysListView32_paramz_big_size  =       $ - SysListView32_paramz_big

padnum16zero
face:
	.font_default		DefaultLOGFONTA64
	.childwiconized 	rb	NumberOfMDIChildren
	.var_settings		db	var_set_default
	.display_symbols	db	display_symbols_flag_default
	.code1stdisasmback	db	0
	.Rambo			db	0	; fdbg anti-antidebugs' weapons, upto 8 weapons...
	.goto_edit_style	db	0
	.auto_selection 	db	0
	.reload_comments_sw_bps db	0	; reload_comments_soft_breakpoints
	.break_on		db	0	; break on process/thread creation/termination, DLL load/unload, OUTPUT_DEBUG_STRING, RIP event
				db	0
				dd	0
				dq	0
	padnum16zero
	.parent 		win_origin_size
	.childwstart		rd	2*NumberOfMDIChildren
	.SysListView32_paramz:
address_column_size		=	102
data_column_size		=	108
data_column_ascii_size		=	data_column_size
reg_column_size 		=	30
reg_mm_st_column_size		=	42
xmm_column_size 		=	438
mm_st_column_size		=	222
	.SLV00cs		dd	address_column_size, 78, 500, 300
	.SLV01cs		dd	address_column_size, 78, 500, 300
	.SLV02cs		dd	address_column_size, data_column_size, data_column_size, data_column_size, data_column_size, data_column_ascii_size
	.SLV03cs		dd	address_column_size, data_column_size, data_column_size, data_column_size, data_column_size, data_column_ascii_size
	.SLV04cs		dd	address_column_size, data_column_size, data_column_size, data_column_size, data_column_size, data_column_ascii_size
	.SLV05cs		dd	address_column_size, data_column_size
	.SLV06cs		dd	reg_column_size, data_column_size
	.SLV07cs		dd	reg_column_size, data_column_size
	.SLV08cs		dd	18, 204+204, 330, xmm_column_size
	.SLV09cs		dd	18, 186, 108, mm_st_column_size
	.SLV0Acs		dd	30,60
	.SLV0Bcs		dd	18,36
	.SLV0Ccs		dd	24,data_column_size
	.SLV0Dcs		dd	72,60
	.SysListView32Sizes	SysListView32Sizes_Font_Terminal_8	; must be here for save columns at WM_CLOSE
	.edit			rd	2	; cx , cy for Edit control,
						; must follow SysListViews sizes
						; these values aren't used for create Edit
						; they are for handling WM_WINDOWPOSCHANGED
	padnum16dummy
; data_column_types:
data_column_type_qword		=	0
data_column_type_dword		=	1
data_column_type_word		=	2
data_column_type_byte		=	3
data_column_type_reversed	=	80h
	.SLV02cs_type		db	data_column_type_qword
	.SLV03cs_type		db	data_column_type_word
	.SLV04cs_type		db	data_column_type_byte
				db	0		; unused
	.data_column_type_data:
	.data_column_type_data_qword:
	.SLV02csq		dd	address_column_size, data_column_size, data_column_size, data_column_ascii_size
	.SLV03csq		dd	address_column_size, data_column_size, data_column_size, data_column_ascii_size
	.SLV04csq		dd	address_column_size, data_column_size, data_column_size, data_column_ascii_size
	.data_column_type_data_dword:
	.SLV02csd		dd	address_column_size, 60, 60, 60, 60, data_column_ascii_size
	.SLV03csd		dd	address_column_size, 60, 60, 60, 60, data_column_ascii_size
	.SLV04csd		dd	address_column_size, 60, 60, 60, 60, data_column_ascii_size
	.data_column_type_data_word:
	.SLV02csw		dd	address_column_size, 40, 40, 40, 40, 40, 40, 40, 40, data_column_ascii_size
	.SLV03csw		dd	address_column_size, 40, 40, 40, 40, 40, 40, 40, 40, data_column_ascii_size
	.SLV04csw		dd	address_column_size, 40, 40, 40, 40, 40, 40, 40, 40, data_column_ascii_size
	.data_column_type_data_byte:
	.SLV02csb		dd	address_column_size, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, data_column_ascii_size
	.SLV03csb		dd	address_column_size, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, data_column_ascii_size
	.SLV04csb		dd	address_column_size, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, data_column_ascii_size

face_save_size			=	$ - face
	padnum16dummy
	.childrenw		rb	sizeof.win_origin_size * NumberOfSysListView32
	.logw			win_origin_size

;padnum16dummy
;mdicreate                      MDICREATESTRUCT64

padnum16zero
hInstance			dq	?
hFont				dq	?
hBrushes			rq	num_of_colors
hMenu01 			dq	?
hAccelerators01 		dq	?
hWndParent			dq	?
hWndStatus			dq	?
hWndClient			dq	?
LogEdit_buffer			dq	?
LogEdit_end			dq	?
lpfnListProc			dq	?
module_info_address		dq	?
ListView_Edit_OldProc		dq	?

breakpoints_space_address	dq	?	; the store is: rq MaxNumberOfBreakpoints       ; addresses
						;               rd MaxNumberOfBreakpoints       ; PIDs
						;               rb MaxNumberOfBreakpoints       ; original bytes at SW BP positions
						;               rb MaxNumberOfBreakpoints       ; SW BP flags (temporary/permanent)
hPopupMenu			dq	?
Dialog08ListBox0_handle 	dq	?
Dialog09ListBox0_handle 	dq	?

multiprocess_multithread_support_address	dq	?
arguments_size			dd	?
DbgThreadId			dd	?
hDbgThread			dq	?
imports_hFont			dq	?

align 16
Code_listview_dump_start_address	dq	?
					dq	?
Data_listview_dump_start_address	dq	?
					dq	?
					dq	?
Stack_listview_dump_start_address	dq	?
disassemble_prefix			dq	?
absolute_RIP_addressing_value		dq	?
absolute_RIP_addressing_disassembled_position	dq	?
;post_disasm_address                    dq      ?
;post_disasm_buffer                     dq      ?
rip_before_bp				dq	?
rip_after_bp				dq	?
rip_at_bp				dq	?
hSysListView32RMenu			dq	?
hSysListView32Dlg04			dq	?
symbols_buf_end_pointer 		dq	?
addr_ehp				dq	?

align 16
ListView_selected_iItem 		rq	num_of_LV_supporting_proc_List_KEYDOWN
;if MaxLinesInSysListView32 > 64
;Above structure isn't big enough for handle selecting more than 64th iItem in SysListView32
;You have to change some procedures too !
;end if
; it is good to have 1 empty qword here for nonparity num_of_LV_supporting_proc_List_KEYDOWN
; in this case we can safely use xmm operations without worry to overwrite something from next
; so next align 16 is necessary for nonparity num_of_LV_sup... and doesn't matter for parity

align 16
ListView_item_and_subitem_rect		dq	?, ?

; Note, every 4 members must follow immediately each other in this order !
EditedListView_handle			dq	?	; handle of window owning List EDIT and SysListView32
ListView_Edit_handle			dq	?	; handle of List EDIT control
ListView_edit_last_item_and_subitem	dq	?
ListView_edit_Listview_index		dq	?

align 16	; the whole structure must be aligned 16 and must have 16 bytes size because
		; we use movdqa to zero it
addr_write_bp_after_first_step		dq	?
PID_write_sw_bp_after_first_step	dd	?
TID_write_hw_bp_after_first_step	dd	?	; structure has size = 16 bytes
rest_from_previous_flag 		db	?	; 0 for SW BP, 1 for HW BP
run_after_first_step_when_write_bp	db	?
hw_bp_No_after_first_step		db	?
hw_bp_GL_after_first_step		db	?

align 10h
supported_lahf_sahf			db	?
					rb	15	; padding

align 16
post_disasm_addr0			dq	?
post_disasm_addr1			dq	?
post_disasm_reg0			dd	?
post_disasm_reg1			dd	?
; these 5 must follow each other in this exact order and the whole size must be 1 qword:
post_disasm_flag			db	?
post_disasm_action			db	?
post_disasm_mul 			db	?
post_disasm_prefix			db	?
seg_prefix_not_flushed			db	?
post_disasm_cond_jump_type		db	?	; valid if post_disasm_flag_cond_jump is set in [post_disasm_flag]
					db	?,?

align 16
hung_PID_TID:
hung_PID				dd	?
hung_TID				dd	?
last_PID_TID:
exception_PID_TID:				; both 2 members must follow immediately in this order
last_PID:
exception_PID				dd	?
last_TID:
exception_TID				dd	?
continue_flag_after_resume		dd	?
					dd	?	;post_disasm_mode       dd      ?
attached_PID				dd	?

put_BP_at_exe_entry_and_run		db	?
DlgProc01_ComboBox0Changed_first_time	db	?
ListView_Edit_exist			db	?
DbgThrdResumed				db	?

align 16
lbfi					dq	?
lbti					dq	?
lefi					dq	?
leti					dq	?
;fdbg_driver_handle                     dq      ?
;auto_branches_after_every_exception    db      ?
branches_after_every_exception_read_OK	db	?

padnum16dummy	; this is because HW_BP_permanent must be 1 qword before all_thread_dr0
		; when zeroing them by:
		;       lea     rdi,[HW_BP_permanent]
		;       mov     ecx,1+6
		;       xor     eax,eax
		;       cld
		;       repz stosq
				dq	?
HW_BP_permanent 		dq	?	; only low 4 bytes are used
align 16					; for transfer with movdqa xmm...
all_thread_dr0			dq	?
all_thread_dr1			dq	?
all_thread_dr2			dq	?
all_thread_dr3			dq	?
all_thread_dr6			dq	?
all_thread_dr7			dq	?

padnum16dummy
hWndChildren:
; handles of child windows holding SysListView32s
hWndListView			rq	NumberOfSysListView32
; handle of child window holding EditLog
hWndLogEdit			dq	?

; no align, this must follow previous data immediately without interruption
hChildren:
; handles of SysListView32s
hListView			rq	NumberOfSysListView32
; handle of LogEdit
hLogEdit			dq	?

padnum16dummy
lpcf				CHOOSEFONT64
padnum16dummy
LogFont 			LOGFONTA64

padnum16dummy
DlgProc0E_value 		rq	1
DlgProc0E_result		rb	1
skip_processing_DlgProc0F_EditText0_changed	rb	1

padnum16dummy
ProcessInfo	PROCESS_INFORMATION64
padnum16dummy
StartupInfo	STARTUPINFO64

padnum16dummy
OFNMaxFileNameSize	=	400h
FileNameBuffer		rb	OFNMaxFileNameSize
shell_line		rb	OFNMaxFileNameSize + arguments_max_size
arguments_max_size	=	400h
arguments		rb	arguments_max_size
Directory_max_size	=	OFNMaxFileNameSize
Directory		rb	Directory_max_size
FileNameBuffer_tmp	rb	Directory_max_size

ofn_initdir		rb	Directory_max_size
old_dir 		rb	Directory_max_size
ini_file		rb	Directory_max_size + 16
help_file		rb	Directory_max_size + 16

MemFileNameBuffer	rb	OFNMaxFileNameSize

;padnum16dummy
;ThreadContext          CONTEXT64
padnum40hdummy
ThreadContext		CONTEXT64EXT

padnum16dummy
tmp_buf 		rb	10000h
tmp_buf_size		=	$ - tmp_buf
tmp_buf2		rb	1000h
tmp_buf_for_opcode	rb	InstructionMaxSize * 2 

comments		rq	max_comments			; PID
			rq	max_comments			; address of comment
			rb	comment_max_size * max_comments ; string of comment

padnum16dummy
circular_buf		rq	MaxLinesInSysListView32
circular_buf_qwords	=	($ - circular_buf) / 8

align 16
process_list_buffer	rb	1024
process_list_buffer_size	= $ - process_list_buffer

align 16
PIDs_max_number 	= 1000h
PIDs_buffer		rd	PIDs_max_number

sym_buf 		SYMBOL_INFO64
			rb	MAX_SYM_NAME

align 16
sym_line_buf		IMAGEHLP_LINE64

align 16
sym_name_buf		rb	MAX_SYM_NAME
			rb	1			; for 0-terminator

align 16
symbols_buf		rb	symbols_buf_size


align 16
sysinfo 		SYSTEM_INFO64

align 16
Rambo_buf		rb	100h

align 16
exceptions_to_ignore	rd	number_of_exception

align 16
sma1		rq	2*4070h 	; enough upto 2^(-3FFFh-20h)
byg		rq	2*4160h 	; enough upto 2^(3FFFh+20h)
expsma1 	rd	4070h
expbyg		rd	4160h


align 10h
InitializeContext	dq	?
SetXStateFeaturesMask	dq	?
GetXStateFeaturesMask	dq	?
LocateXStateFeature	dq	?
AVX_enabled		dd	?
size_of_AVX		dd	?
pointer_to_AVX		dq	?


section '.rsrc' resource data readable

include 'resource.inc'


section '.idata' import data readable

;                       dd      0,0,0,  RVA ntdll_name,         RVA ntdll_table
			dd	0,0,0,	RVA kernel_name,	RVA kernel_table
			dd	0,0,0,	RVA user_name,		RVA user_table
			dd	0,0,0,	RVA comdlg_name,	RVA comdlg_table
			dd	0,0,0,	RVA comctl_name,	RVA comctl_table
			dd	0,0,0,	RVA gdi_name,		RVA gdi_table
			dd	0,0,0,	RVA shell_name, 	RVA shell_table
			dd	0,0,0,	RVA dbghelp_name,	RVA dbghelp_table
			dd	0,0,0,	0,			0

; the main part of imports is moved into data section - they are in imports.inc
			