; various commands from clicks in fdbg menu or by pressing key shortcuts

;align 16
;CMD_TRACEINTO:
;	push	rcx rdx r8 r9
;	sub	rsp,8*(4+1)
;
;	mov	ecx,dword [last_TID]
;	call	set_trap_flag		; set Trap Flag in thread with ThreadID
;	jc	CMD_TRACEINTO_L0
;
;	call	CMD_RUN
;
;CMD_TRACEINTO_epilogue:
;	add	rsp,8*(4+1)
;	pop	r9 r8 rdx rcx
;	ret
;
CMD_TRACEINTO_L0:
;	mov	qword [rsp+8*(4+0)],rdi
	mov	eax,ecx
	lea	rdi,[msg_error_set_trap_flag_TID]
	call	hexa_32_eax
	lea	rax,[msg_error_set_trap_flag]
	call	msg_to_LogEdit
;	mov	rdi,qword [rsp+8*(4+0)]
;	jmp	CMD_TRACEINTO_epilogue
	jmp	CMD_STEPOVER_epilogue

align 16
CMD_TRACEINTO:
CMD_STEPOVER:

	push	rcx rdx rbx rsi rdi r8 r9
a=1				; return address from procedure
b=7				; number of pushed registers
e=4				; 4 qwords reserved for API
d=(2*InstructionMaxSize+7)/8	; our local buffer for read process memory
c=(a+b+e+d) and 1		; align stack at dqword
	sub	rsp,8*(c+d+e)
; the stack looks now like:
; a <- the top
; b
; c
; d
; e <- current RSP

; DbgThrdResumed=1 and hung_PID_TID=0 -> PAUSE allowed, everything other disallowed
; DbgThrdResumed=1 and hung_PID_TID<>0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID=0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID<>0 -> impossible choice
	movzx	ecx,[DbgThrdResumed]
	dec	ecx
	or	rcx,[hung_PID_TID]
	jz	CMD_STEPOVER_epilogue

	mov	ecx,dword [last_TID]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	CMD_TRACEINTO_L0

	cmp	word [rsp+8*(e+d+c+1)],IDM_TRACEINTO	; R8 in the stack
	jz	CMD_STEPOVER_singlestep

CMD_STEPOVER_start:
; we read 2*InstructionMaxSize bytes from Process at its instruction pointer
	lea	rsi,[ThreadContext.Rip]
	lea	rdi,[rsp+8*e]
	mov	ebx,2*InstructionMaxSize	; 2x because we must read 1 instruction
						; and 1 next instruction to search whether
						; SW BP wasn't set there
	mov	ecx,dword [last_PID]
	call	read_debuggee_memory
	jc	CMD_STEPOVER_L1

	mov	rax,qword [rsi]			; grab RIP
	lea	rsi,[rdi]

; patch software breakpoint if any
	cmp	byte [rsi],0CCh
	jnz	CMD_STEPOVER_L2

	mov	ecx,[last_PID]
;	mov	rax,rax
	call	scan_sw_bp_addr_pid
	jnz	CMD_STEPOVER_L2
; returns EDX=index of SW BP
; patch it !
	mov	rdi,qword [breakpoints_space_address]
	mov	cl,byte [rdi + (8+4)*MaxNumberOfBreakpoints + rdx*1]
	mov	byte [rsi],cl
CMD_STEPOVER_L2:

	lea	rdi,[tmp_buf]		; buffer must be big enough
; RIP when disasm doesn't matter here, we want only opcode, not operands
	call	disassemble_one_instruction
; eax = opcode size, don't touch it !!!
	mov	edx,[rdi]
	cmp	edx,'push'
	jnz	CMD_STEPOVER_after_pushf
	cmp	byte [rdi+4],'f'
	jz	CMD_STEPOVER_L3		; do step over for pushf
CMD_STEPOVER_after_pushf:
	cmp	edx,'call'
	jz	CMD_STEPOVER_L3
	cmp	edx,'loop'
	jz	CMD_STEPOVER_L3
	and	edx,00FFFFFFh
	cmp	edx,'rep'
	jnz	CMD_STEPOVER_singlestep

; stronger checking of REP prefix instructions, Peter Ferrie reported fdbg weakness and general weakness
; no necessity to do that if Rambo -> CC Collateral damage is on
	bt	dword [face.Rambo],IDM_RAMBO_CCCD - IDM_RAMBO
	jc	CMD_STEPOVER_L3
	mov	rdx,[rdi+4]
	cmp	byte [rdi+3],'z'	; REPZ prefix
	jz	CMD_STEPOVER_prefix_passed
	cmp	word [rdi+3],'nz'
	jnz	CMD_STEPOVER_singlestep	; strange abnormality
	mov	rdx,[rdi+5]		; REPNZ prefix
CMD_STEPOVER_prefix_passed:
	cmp	dl,' '
	jnz	CMD_STEPOVER_singlestep	; strange abnormality
	shr	rdx,8
	mov	ecx,edx
	cmp	ecx,'cmps'
	jz	CMD_STEPOVER_L3
	cmp	ecx,'lods'
	jz	CMD_STEPOVER_L3
	cmp	ecx,'scas'
	jz	CMD_STEPOVER_L3
	cmp	ecx,'movs'
	jz	CMD_STEPOVER_check_soft_bp_overwriting
	cmp	ecx,'stos'
;	jz	CMD_STEPOVER_check_soft_bp_overwriting
	jnz	CMD_STEPOVER_singlestep	; abnormal usage of REX prefix (e.g. with mov instruction)
CMD_STEPOVER_check_soft_bp_overwriting:
	shr	rdx,32
; dl may be 'q', 'd', 'w', 'b'
	xor	ecx,ecx
	cmp	dl,'b'
	jz	CMD_STEPOVER_check_soft_bp_overwriting_have_power
	inc	ecx
	cmp	dl,'w'
	jz	CMD_STEPOVER_check_soft_bp_overwriting_have_power
	inc	ecx
	cmp	dl,'d'
	jz	CMD_STEPOVER_check_soft_bp_overwriting_have_power
	inc	ecx
	cmp	dl,'q'
	jnz	CMD_STEPOVER_singlestep	; abnormal instruction

CMD_STEPOVER_check_soft_bp_overwriting_have_power:
; rcx = power (0 for byte, 1 for word, 2 for dword, 3 for qword)
	mov	r8,[ThreadContext.Rdi]
	mov	r9,[ThreadContext.Rcx]
	mov	r10,[ThreadContext.Rip]
	add	r10,rax			; add instruction size = address where the breakpoint would be set

; 67h prefix forces to use 32 bit pointer (esi, edi) instead of 64 bit pointer (rsi, rdi) - instructions like stosb32, movsw32
	cmp	dh,'3'
	jnz	CMD_STEPOVER_check_soft_bp_overwriting_after_67_prefix
; extract only low 32 bits of 64 bit register
	mov	r8d,r8d
CMD_STEPOVER_check_soft_bp_overwriting_after_67_prefix:

	test	[ThreadContext.EFlags],1 shl 10	; DF (direction flag)
	jnz	CMD_STEPOVER_check_soft_bp_std

CMD_STEPOVER_check_soft_bp_cld:
; the interval of writing is from rdi to rdi + (rcx shl power) - 1
; r8
; r8 + (r9 shl cl) - 1
	cmp	r10,r8
	jc	CMD_STEPOVER_L3	; address of breakpoint is below RDI, so it is safe to do step over
	shl	r9,cl
	add	r9,r8
	cmp	r9,r10
	jbe	CMD_STEPOVER_L3	; address of breakpoint is after the tail when the instruction completes, so it is safe to do step over
	jmp	CMD_STEPOVER_prompt_user

CMD_STEPOVER_check_soft_bp_std:
; the highest byte written is rdi + (1 shl power) - 1
; the lowest byte written is rdi - ((rcx-1) shl power)
	mov	edx,1
	shl	edx,cl
	add	rdx,r8
	cmp	rdx,r10
	jbe	CMD_STEPOVER_L3	; address of breakpoint is higher than the address written at the first iteration of the REP instruction
;	or	r9,r9
;	jz	CMD_STEPOVER_singlestep
;	dec	r9		; the dec instruction doesn't touch Carry Flag
; this requires only 2 instructions:
	sub	r9,1		; the sub instruction is capable to set Carry Flag
	jc	CMD_STEPOVER_singlestep
	shl	r9,cl
	sub	r8,r9
	cmp	r10,r8
	jc	CMD_STEPOVER_L3	; address of breakpoint is below the address where writing finishes

CMD_STEPOVER_prompt_user:
	mov	edi,eax		; save instruction size

;	lea	rax,[msg_danger]
;	call	msg_to_LogEdit
	mov	r9d,MB_YESNO
	lea	r8,[msg_danger]
	lea	rdx,[msg_REP_antidebug]
	mov	rcx,[hWndParent]
	call	[MessageBoxA]
	cmp	eax,IDNO
	jz	CMD_STEPOVER_prompt_user_end
	cmp	eax,IDYES
	jnz	CMD_STEPOVER_prompt_user_end

	mov	rax,[ThreadContext.Rip]
	add	rax,rdi		; add instruction size so then RAX points to the following instruction
	call	find_first_empty_put_HW_BP_temporary_flag
	jc	CMD_STEPOVER_epilogue
	jmp	CMD_STEPOVER_end

CMD_STEPOVER_prompt_user_end:
	mov	eax,edi		; restore instruction size

CMD_STEPOVER_L3:
; check if SW_BP wasn't already set there
	cmp	byte [rsp+8*e + rax*1],0CCh
	jz	CMD_STEPOVER_end	; yes, was set, just resume thread to let it run

	add	rax,qword [ThreadContext.Rip]	; point the next opcode after opcode on RIP
	mov	ecx,dword [last_PID]		; process Id
	call	put_temporary_hw_or_sw_bp
	jnc	CMD_STEPOVER_end
; fall back to single step in case of put_temporary_hw_or_sw_bp failure

CMD_STEPOVER_singlestep:
	bt	dword [face.Rambo],IDM_RAMBO_TFATT - IDM_RAMBO
	jnc	CMD_STEPOVER_singlestep_do_it

; we read 2xInstructionMaxSize bytes from Process at its instruction pointer
	lea	rsi,[ThreadContext.Rip]
	lea	rdi,[rsp+8*e]
	mov	ebx,2*InstructionMaxSize	; 2x because we must read 1 instruction
						; and 1 next instruction to search whether
						; SW BP wasn't set there
	mov	ecx,dword [last_PID]
	call	read_debuggee_memory
	jc	CMD_STEPOVER_L1

	mov	rax,qword [rsi]			; grab RIP
	lea	rsi,[rdi]

; patch software breakpoint if any
	cmp	byte [rsi],0CCh
	jnz	CMD_STEPOVER_singlestep_L2

	mov	ecx,[last_PID]
;	mov	rax,rax
	call	scan_sw_bp_addr_pid
	jnz	CMD_STEPOVER_singlestep_L2
; returns EDX=index of SW BP
; patch it !
	mov	rdi,qword [breakpoints_space_address]
	mov	cl,byte [rdi + (8+4)*MaxNumberOfBreakpoints + rdx*1]
	mov	byte [rsi],cl
CMD_STEPOVER_singlestep_L2:

	lea	rdi,[tmp_buf]		; buffer must be big enough
; RIP when disasm doesn't matter here, we want only opcode, not operands
	call	disassemble_one_instruction
; eax = opcode size, don't touch it !!!
	mov	edx,dword [rdi]
	cmp	edx,'push'
	jnz	CMD_STEPOVER_singlestep_do_it
	cmp	byte [rdi+4],'f'
	jz	CMD_STEPOVER_L3		; do step over for pushf

CMD_STEPOVER_singlestep_do_it:
	mov	ecx,dword [last_TID]
	call	set_trap_flag		; set Trap Flag in thread with ThreadID
	jc	CMD_STEPOVER_L0

CMD_STEPOVER_end:
	call	CMD_RUN

CMD_STEPOVER_epilogue:
	add	rsp,8*(c+d+e)
	pop	r9 r8 rdi rsi rbx rdx rcx
	ret

CMD_STEPOVER_L0:
	xchg	eax,ecx
	lea	rdi,[msg_error_read_thread_context_TID]
	call	hexa_32_eax
	lea	rax,[msg_error_read_thread_context]
	call	msg_to_LogEdit
	jmp	CMD_STEPOVER_epilogue

CMD_STEPOVER_L1:
	mov	eax,dword [last_PID]
	lea	rdi,[msg_error_read_process_memory_PID]
	call	hexa_32_eax
	mov	eax,dword [rsi]
	lea	rdi,[msg_error_read_process_memory_addr]
	call	hexa_64_rax
	xchg	eax,ebx
	lea	rdi,[msg_error_read_process_memory_num_of_bytes]
	call	hexa_32_eax
	lea	rax,[msg_error_read_process_memory]
	call	msg_to_LogEdit
	jmp	CMD_STEPOVER_epilogue

align 16
CMD_RUN:
; the easiest to do, just order DBG_CONTINUE to debug loop and resume thread owning debug loop
	mov	eax,DBG_CONTINUE
CMD_RUN_common_begin:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)

; DbgThrdResumed=1 and hung_PID_TID=0 -> PAUSE allowed, everything other disallowed
; DbgThrdResumed=1 and hung_PID_TID<>0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID=0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID<>0 -> impossible choice
	movzx	ecx,[DbgThrdResumed]
	dec	ecx
	or	rcx,[hung_PID_TID]
	jz	CMD_RUN_epi

	mov	dword [continue_flag_after_resume],eax

; thread may be suspended after PAUSE (F11), we have to resume it
	mov	eax,dword [last_TID]
	call	TID2hThread		; in eax=TID, out rdx=hThread
	jc	CMD_RUN_epi
	mov	rcx,rdx
	call	ResumeThreadSafe

	mov	rcx,qword [hDbgThread]
	call	ResumeThreadSafe

	mov	byte [DbgThrdResumed],1	; necessary thing here, since we can pause
					; debuggee without going through debug loop
					; run, pause, run - at the second run we aren't in
					; debug loop !!!
	call	update_menus_hang_suspend_changed
	mov	eax,[last_PID]
	mov	edx,[last_TID]
	call	update_status_window_PID_TID
	call	update_status_window_running

CMD_RUN_epi:
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
CMD_RUN_UNHANDLED:
; trigger app exception handler
; note that when app hasn't installed exception handler, this typically doesn't disturb handler
; (because there isn't any handler) but disturbs OS and leads into application termination
; so use this carefully, usefull only for debugging exception handler or special antidebugs
; based on exceptions
; order DBG_EXCEPTION_NOT_HANDLED to debug loop, resume thread holding loop
	mov	eax,DBG_EXCEPTION_NOT_HANDLED
	jmp	CMD_RUN_common_begin


align 10h
CMD_RETURN_FROM_PROCEDURE:

	push	rbx rbp rsi rdi

a=1				; return address from procedure
b=4				; number of pushed registers
d=(sizeof.MEMORY_BASIC_INFORMATION64+7)/8
e=4				; 4 qwords reserved for API
c=(a+b+d+e) and 1		; align stack at dqword
	sub	rsp,8*(c+d+e)
; the stack looks now like:
; a <- the top, return address from procedure
; b number of pushed registers
; c aligning stack at dqword (c is 0 or 1)
; d MEMORY_BASIC_INFORMATION64
; e 4 qwords reserved for API
;   <- current RSP

	mov	eax,[last_PID]
	call	PID2hProcess
	jc	CMD_RETURN_FROM_PROCEDURE_epi

; note that ThreadContext is already read, all MDI children windows where updated according registers from the thread context
	mov	rcx,rdx				; handle of process
	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[rsp+8*e]
	mov	rdx,[ThreadContext.Rsp]
	call	[VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	jnz	CMD_RETURN_FROM_PROCEDURE_epi

	mov	rbx,[rsp+8*e+MEMORY_BASIC_INFORMATION64.RegionSize]	; stack size from the bottom to the top

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
;	mov	rdx,[rsp+8*e+MEMORY_BASIC_INFORMATION64.RegionSize]	; stack size from the bottom to the top
	mov	rdx,rbx				; stack size from the bottom to the top
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	CMD_RETURN_FROM_PROCEDURE_epi

	mov	rbp,rax

	lea	rsi,[rsp+8*e+MEMORY_BASIC_INFORMATION64.BaseAddress]; stack bottom
	mov	rdi,rax
	mov	ecx,[last_PID]
	call	read_debuggee_memory
	jc	CMD_RETURN_FROM_PROCEDURE_release_mem_epi

	mov	rax,[ThreadContext.Rsp]
	sub	rax,[rsi]

	lea	rsi,[rdi+rax*1]
	sub	rbx,rax

; rsi points to bottom of data obtained from thread RSP
; rbx = size from thread RSP to the top of thread stack

AMDPad16
CMD_RETURN_FROM_PROCEDURE_L0:
	mov	rdx,[rsi]			; get qword from thread stack
	or	rdx,rdx
	jz	CMD_RETURN_FROM_PROCEDURE_L4	; no need to try disassemble back from address at virtual memory 0
	mov	eax,[last_PID]			; PID
	mov	ecx,1				; number of instructions backward rdx
	call	painful_reverze			; try to disassemble back instructions
	jc	CMD_RETURN_FROM_PROCEDURE_L4

	cmp	dword [tmp_buf2],'call'		; is the instruction call ? (e.g. call address, call rax, call qword [...], etc...)
	jz	CMD_RETURN_FROM_PROCEDURE_L8

CMD_RETURN_FROM_PROCEDURE_L4:
	mov	eax,8
	add	rsi,rax				; go to next qword of stack
	sub	rbx,rax
	cmp	rbx,rax
	jnc	CMD_RETURN_FROM_PROCEDURE_L0

	lea	rax,[msg_unable_to_find_return_address_from_procedure]
	call	msg_to_LogEdit

	jmp	CMD_RETURN_FROM_PROCEDURE_release_mem_epi

CMD_RETURN_FROM_PROCEDURE_L8:
; put breakpoint there
	mov	rax,[rsi]			; return address
	mov	ecx,dword [last_PID]
	call	put_temporary_hw_or_sw_bp
	jc	CMD_RETURN_FROM_PROCEDURE_release_mem_epi

	call	CMD_RUN

CMD_RETURN_FROM_PROCEDURE_release_mem_epi:
	mov	r8d,MEM_DECOMMIT
	mov	rdx,[rsp+8*e+MEMORY_BASIC_INFORMATION64.RegionSize]
	mov	rcx,rbp
	call	[VirtualFree]
 
CMD_RETURN_FROM_PROCEDURE_epi:
	add	rsp,8*(c+d+e)
	pop	rdi rsi rbp rbx
	ret

align 16
CMD_EXECUTE_TO:
	push	rcx
	push	rdx
	push	r8
	push	r9
	sub	rsp,8*(4+1)

; DbgThrdResumed=1 and hung_PID_TID=0 -> PAUSE allowed, everything other disallowed
; DbgThrdResumed=1 and hung_PID_TID<>0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID=0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID<>0 -> impossible choice
	movzx	ecx,[DbgThrdResumed]
	dec	ecx
	or	rcx,[hung_PID_TID]
	jz	CMD_EXECUTE_TO_epi

	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc03]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog03
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]

CMD_EXECUTE_TO_epi:
	add	rsp,8*(4+1)
	pop	r9
	pop	r8
	pop	rdx
	pop	rcx
	ret

align 16
DlgProc03:
	push	rbx rsi rcx rdx r8 r9
	sub	rsp,8*(4+7)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc03_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc03_ReturnFalse
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog03EditText0
	jz	DlgProc03_EditText0Change
	cmp	r8w,ID_Dialog03Button0
	jz	DlgProc03_SetIt
	cmp	r8w,ID_Dialog03Button1
	jz	DlgProc03_Abandon
	cmp	r8w,ID_Dialog03Button2
	jz	DlgProc03_AddressFromSymbol

DlgProc03_ReturnFalse:
	xor	eax,eax
DlgProc03_Return:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx rsi rbx
	ret

DlgProc03_InitDialog:
	mov	edx,ID_Dialog03EditText0
;	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]
	xor	r9,r9
	mov	r8d,16			; text limited to 16 chars
	mov	edx,EM_SETLIMITTEXT
	mov	rcx,rax
	call	qword[SendMessageA]
	jmp	DlgProc03_ReturnTrue

DlgProc03_EditText0Change:
; we check if ID_Dialog03EditText0 has a data - if has, we enable 'Done' ID_Dialog03Button0
	mov	ebx,1			; enable window
;	xor	ebx,ebx			; 0 = disable window
; check if there is something in ID_Dialog03EditText0
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog03EditText0
;	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog03EditText0
	cmovz	ebx,eax

	mov	edx,ID_Dialog03Button0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

DlgProc03_ReturnTrue:
	mov	eax,1
	jmp	DlgProc03_Return

DlgProc03_SetIt:
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog03EditText0
;	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	jc	DlgProc03_Abandon

;	mov	rax,rdx
;	mov	ecx,dword [last_PID]
;	call	find_first_empty_slot_put_SW_BP_temporary_flag
;	jc	DlgProc03_Abandon

	mov	rax,rdx				; address
DlgProc03_SetIt_commond_end:
	mov	ecx,dword [last_PID]		; process Id
	call	put_temporary_hw_or_sw_bp
	jc	DlgProc03_Abandon

	call	CMD_RUN

DlgProc03_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [EndDialog]

	mov	eax,dword [last_PID]
	mov	edx,dword [last_TID]
	call	display_regs_memory
	jmp	DlgProc03_ReturnTrue

DlgProc03_AddressFromSymbol:
; rcx = handle of parent
	call	symbol2address
; CF=0, rax = address
	jc	DlgProc03_Abandon
	jmp	DlgProc03_SetIt_commond_end


align 16
CMD_RUN_HERE:
	push	rsi

a=1	; return address
b=1	; number of pushed registers
d=(sizeof.LV_ITEM64+7)/8
e=4	; number of qwords reserved for API
c=(a+b+d+e) and 1	; alignment at dqword

	sub	rsp,8*(c+d+e)

; DbgThrdResumed=1 and hung_PID_TID=0 -> PAUSE allowed, everything other disallowed
; DbgThrdResumed=1 and hung_PID_TID<>0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID=0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID<>0 -> impossible choice
	movzx	ecx,[DbgThrdResumed]
	dec	ecx
	or	rcx,[hung_PID_TID]
	jz	CMD_RUN_HERE_epi

	xor	r9,r9
	xor	r8,r8
	mov	edx,WM_MDIGETACTIVE
	mov	rcx,qword [hWndClient]
	call	qword [SendMessageA]
	mov	rcx,rax
	call	hWndList2iList
	jc	CMD_RUN_HERE_L0
	cmp	edx,1
	jbe	CMD_RUN_HERE_L1
CMD_RUN_HERE_L0:
	lea	rax,[msg_activate_code_slv]
	call	msg_to_LogEdit
	jmp	CMD_RUN_HERE_epi
CMD_RUN_HERE_L1:
;	lea	rcx,[ListView_selected_iItem]
;	lea	rsi,[hListView]
;	bsf	rax,qword [rcx+rdx*8]		; get selected iItem
;	mov	rcx,qword [rsi+rdx*8]		; get handle of the SysListView32
;	lea	rdx,[tmp_buf]
;	mov	[rsp+8*e + LV_ITEM64.mask],LVIF_TEXT
;	mov	qword [rsp+8*e + LV_ITEM64.iItem],rax	; set iItem=eax and iSubItem=0 (upper dword of RAX)
;	mov	[rsp+8*e + LV_ITEM64.pszText],rdx
;	mov	[rsp+8*e + LV_ITEM64.cchTextMax],SysListView_cchTextMax
;	lea	r9,[rsp+8*e]
;	xor	r8,r8
;	mov	edx,LVM_GETITEM
;	call	qword [SendMessageA]
; getitemtext is better, it returns text size
	lea	rcx,[ListView_selected_iItem]
	lea	rax,[hListView]
	bsf	r8,qword [rcx+rdx*8]		; get selected iItem
	mov	rcx,qword [rax+rdx*8]		; get handle of the SysListView32
	lea	rdx,[tmp_buf]
	and	[rsp+8*e + LV_ITEM64.iSubItem],0
	mov	[rsp+8*e + LV_ITEM64.pszText],rdx
	mov	[rsp+8*e + LV_ITEM64.cchTextMax],SysListView_cchTextMax
	lea	r9,[rsp+8*e]
	mov	edx,LVM_GETITEMTEXT
	call	qword [SendMessageA]
	lea	rsi,[tmp_buf]
	call	ascii2hexa_qword
	jc	CMD_RUN_HERE_epi
; rdx = address

; check whether we aren't on RIP
	mov	ecx,dword [last_TID]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	CMD_RUN_HERE_epi
	cmp	[ThreadContext.Rip],rdx
	jnz	CMD_RUN_HERE_L2

; we are on RIP, so we have to do single step, then put SW BP at RDX, then execute run
	mov	qword [addr_write_bp_after_first_step],rdx
	mov	eax,dword [last_PID]
	mov	byte [rest_from_previous_flag],rest_from_run_here
	mov	byte [run_after_first_step_when_write_bp],1
	mov	dword [PID_write_sw_bp_after_first_step],eax
	mov	ecx,dword [last_TID]
	call	set_trap_flag
	jc	CMD_RUN_HERE_epi
	jmp	CMD_RUN_HERE_L3

CMD_RUN_HERE_L2:
; check whether there isn't any SW BP at that address
;	mov	rax,rdx
;	mov	ecx,dword [last_PID]
;	call	scan_sw_bp_addr_pid
;	jz	CMD_RUN_HERE_L3
; not necessary, find_first_empty_slot_put_SW_BP_temporary_flag does the check

	mov	rax,rdx				; address
	mov	ecx,dword [last_PID]		; process Id
	call	put_temporary_hw_or_sw_bp
	jc	CMD_RUN_HERE_epi

CMD_RUN_HERE_L3:
	call	CMD_RUN

CMD_RUN_HERE_epi:
	add	rsp,8*(c+d+e)
	pop	rsi
	ret

CMD_PAUSE:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)

; DbgThrdResumed=1 and hung_PID_TID=0 -> PAUSE allowed, everything other disallowed
; DbgThrdResumed=1 and hung_PID_TID<>0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID=0 -> allowed everything except PAUSE
; DbgThrdResumed=0 and hung_PID_TID<>0 -> impossible choice
	movzx	ecx,[DbgThrdResumed]
	dec	ecx
	or	rcx,[hung_PID_TID]
	jnz	CMD_PAUSE_epi

	mov	eax,dword [last_TID]
	call	TID2hThread
	jc	CMD_PAUSE_epi		; in eax=TID, out rdx=hThread

	mov	rcx,rdx
	call	SuspendThreadSafe
; Each thread has a suspend count (with a maximum value of MAXIMUM_SUSPEND_COUNT).
; If the suspend count is greater than zero, the thread is suspended; otherwise,
; the thread is not suspended and is eligible for execution. Calling SuspendThread
; causes the target thread's suspend count to be incremented. Attempting to increment
; past the maximum suspend count causes an error without incrementing the count.

; returned eax=0 means thread was in the resumed state.
; but for debuggee threads, 0 is returned even they are hung between WaitForDebugEvent and ContinueDebugEvent

	mov	rcx,qword [hDbgThread]
	call	SuspendThreadSafe

	mov	ecx,dword [last_TID]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	mov	rax,qword [ThreadContext.Rip]
	mov	rcx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax
	mov	qword [Stack_listview_dump_start_address],rcx

	call	code_1st_disassemble_back

	mov	eax,dword [last_PID]
	mov	edx,dword [last_TID]
	call	display_regs_memory

	mov	byte [DbgThrdResumed],0
	call	update_menus_hang_suspend_changed
	mov	eax,[last_PID]
	mov	edx,[last_TID]
	call	update_status_window_PID_TID
	call	update_status_window_stopped

CMD_PAUSE_epi:
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
CMD_SW_BP_TOGGLE:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)

; get active window
	xor	r9,r9
	xor	r8,r8
	mov	edx,WM_MDIGETACTIVE
	mov	rcx,qword [hWndClient]
	call	qword [SendMessageA]

; get index of active window
	mov	rcx,rax
	call	hWndList2iList
	jc	CMD_SW_BP_TOGGLE_L0
	cmp	edx,1
	jbe	CMD_SW_BP_TOGGLE_L1
CMD_SW_BP_TOGGLE_L0:
	lea	rax,[msg_activate_code_slv]
	call	msg_to_LogEdit
	jmp	CMD_SW_BP_TOGGLE_epi

CMD_SW_BP_TOGGLE_L1:
	lea	rcx,[ListView_selected_iItem]
	lea	rax,[hListView]
	bsf	r8,qword [rcx+rdx*8]		; get selected iItem
	mov	rcx,qword [rax+rdx*8]		; get handle of the SysListView32
	lea	rdx,[tmp_buf]
	and	[rsp+8*e + LV_ITEM64.iSubItem],0
	mov	[rsp+8*e + LV_ITEM64.pszText],rdx
	mov	[rsp+8*e + LV_ITEM64.cchTextMax],SysListView_cchTextMax
	lea	r9,[rsp+8*e]
	mov	edx,LVM_GETITEMTEXT
	call	qword [SendMessageA]
	lea	rsi,[tmp_buf]
	call	ascii2hexa_qword
	jc	CMD_SW_BP_TOGGLE_epi
; rdx = address

; check whether there isn't any SW BP at that address
	mov	rax,rdx
	mov	ecx,dword [last_PID]
	call	scan_sw_bp_addr_pid
	jnz	CMD_SW_BP_TOGGLE_L2

; sw bp is there, so remove it
	mov	eax,edx				; index of SW BP
	call	remove_SW_BP_from_iBP_and_clear_its_dbg_store
	jmp	CMD_SW_BP_TOGGLE_L3

CMD_SW_BP_TOGGLE_L2:
; There isn't any sw breakpoint at this address. Put one there !
; rax=addr , ecx=PID
	call	find_first_empty_slot_put_SW_BP_temporary_flag

CMD_SW_BP_TOGGLE_L3:
	mov	eax,dword [last_PID]
	mov	edx,dword [last_TID]
	call	display_regs_memory

CMD_SW_BP_TOGGLE_epi:
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
CMD_SW_BP_SET:
	push	rcx
	push	rdx
	push	r8
	push	r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc00]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog00
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9
	pop	r8
	pop	rdx
	pop	rcx
	ret

align 16
DlgProc00:
	push	rbx rsi rcx rdx r8 r9
	sub	rsp,8*(4+7)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc00_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc00_ReturnFalse
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog00EditText0
	jz	DlgProc00_EditText0Change
	cmp	r8w,ID_Dialog00Button0
	jz	DlgProc00_SetIt
	cmp	r8w,ID_Dialog00Button1
	jz	DlgProc00_Abandon
	cmp	r8w,ID_Dialog00Button2
	jz	DlgProc00_AddressFromSymbol

DlgProc00_ReturnFalse:
	xor	eax,eax
DlgProc00_Return:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx rsi rbx
	ret

DlgProc00_InitDialog:
	mov	edx,ID_Dialog00EditText0
;	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]
	xor	r9,r9
	mov	r8d,16			; text limited to 16 chars
	mov	edx,EM_SETLIMITTEXT
	mov	rcx,rax
	call	qword[SendMessageA]

	mov	edx,ID_Dialog00AutoCheckBox0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [CheckDlgButton]

	jmp	DlgProc00_ReturnTrue

DlgProc00_EditText0Change:
; we check if ID_Dialog00EditText0 has a data - if has, we enable 'Done' ID_Dialog00Button0
	mov	ebx,1			; enable window
;	xor	ebx,ebx			; 0 = disable window
; check if there is something in ID_Dialog00EditText0
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog00EditText0
;	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog00EditText0
	cmovz	ebx,eax

	mov	edx,ID_Dialog00Button0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

DlgProc00_ReturnTrue:
	mov	eax,1
	jmp	DlgProc00_Return

DlgProc00_SetIt:
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog00EditText0
;	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	jc	DlgProc00_Abandon

	mov	rbx,rdx			; save result

DlgProc00_SetIt_commond_end:
	mov	edx,ID_Dialog00AutoCheckBox0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]

if BST_UNCHECKED = 0
	or	eax,eax
else
	cmp	eax,BST_UNCHECKED
end if
	mov	rax,rbx
	mov	ecx,dword [last_PID]
	jz	DlgProc00_SetIt_temporary

DlgProc00_SetIt_permanent:
	call	find_first_empty_slot_put_SW_BP_permanent_flag
	jmp	DlgProc00_Abandon

DlgProc00_SetIt_temporary:
	call	find_first_empty_slot_put_SW_BP_temporary_flag
;	jc	DlgProc00_Abandon

DlgProc00_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [EndDialog]

	mov	eax,dword [last_PID]
	mov	edx,dword [last_TID]
	call	display_regs_memory
	jmp	DlgProc00_ReturnTrue

DlgProc00_AddressFromSymbol:
; rcx = handle of parent
	call	symbol2address
; CF=0, rax = address
	jc	DlgProc00_Abandon
	mov	rbx,rax			; save result
	jmp	DlgProc00_SetIt_commond_end


align 16
CMD_HW_BP_SET:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	mov	byte [DlgProc01_ComboBox0Changed_first_time],1
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc01]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog01
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

DlgProc01:
	push	rbx rdi rcx rdx r8 r9
	sub	rsp,8*(4+7)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc01_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc01_ReturnFalse
	cmp	r8d,CBN_SELCHANGE*10000h + ID_Dialog01ComboBox0
	jz	DlgProc01_ComboBox0Change
	cmp	r8d,CBN_SELCHANGE*10000h + ID_Dialog01ComboBox1
	jz	DlgProc01_ComboBox1Change
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog01EditText0
	jz	DlgProc01_EditText0Change
	cmp	r8w,ID_Dialog01Button0
	jz	DlgProc01_SetIt
	cmp	r8w,ID_Dialog01Button1
	jz	DlgProc01_Abandon
	cmp	r8w,ID_Dialog01Button2
	jz	DlgProc01_AddressFromSymbol

DlgProc01_ReturnFalse:
	xor	eax,eax
DlgProc01_Return:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx rdi rbx
	ret

DlgProc01_InitDialog:
	xor	ebx,ebx			; counter

DlgProc01_Fill_ComboBox0:
	lea	rcx,[rsp+8*(4+2)]
	lea	eax,[rbx+'0']
	mov	qword [rsp + 8*(4+0)],rcx
	mov	dword [rcx],eax		; store with 0-terminator too
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_Dialog01ComboBox0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
	inc	ebx
	cmp	bl,4
	jc	DlgProc01_Fill_ComboBox0

; limit ID_Dialog01EditText0 text to 16 hexa chars
	mov	edx,ID_Dialog01EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]
	xor	r9,r9
	mov	r8d,16
	mov	edx,EM_SETLIMITTEXT
	mov	rcx,rax
	call	qword [SendMessageA]

; Set ID_Dialog01AutoCheckBox0 checked and disabled. It is allways checked and disabled,
; because we must allways set L bit for HW BP to work
	and	qword [rsp + 8*(4+0)],0
	mov	r9d,BST_INDETERMINATE
	mov	r8d,BM_SETCHECK
	mov	edx,ID_Dialog01AutoCheckBox0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

; LE and GE bits
	lea	rdi,[all_thread_dr0]

; LE bit

if BST_UNCHECKED = 0
	mov	r9d,[rdi + 8*5 + 1]
	and	r9d,1
 if BST_CHECKED = 1
; nothing to improve...
 else
	mov	eax,BST_CHECKED
	cmovnz	r9d,eax
 end if
else
	mov	r9d,BST_UNCHECKED
	mov	eax,BST_CHECKED
	test	byte [rdi + 8*5 + 1],1
	cmovnz	r9d,eax
end if
	and	qword [rsp + 8*(4+0)],0
	mov	r8d,BM_SETCHECK
	mov	edx,ID_Dialog01AutoCheckBox3
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

; GE bit

if BST_UNCHECKED = 0
	mov	r9d,[rdi + 8*5 + 1]
	shr	r9d,1
	and	r9d,1
 if BST_CHECKED = 1
; nothing to improve...
 else
	mov	eax,BST_CHECKED
	cmovnz	r9d,eax
 end if
else
	mov	r9d,BST_UNCHECKED
	mov	eax,BST_CHECKED
	test	byte [rdi + 8*5 + 1],10b
	cmovnz	r9d,eax
end if
	and	qword [rsp + 8*(4+0)],0
	mov	r8d,BM_SETCHECK
	mov	edx,ID_Dialog01AutoCheckBox4
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

DlgProc01_ReturnTrue:
	mov	eax,1
	jmp	DlgProc01_Return 

DlgProc01_ComboBox0Change:
;	mov	rcx,[rsp + 8*(4+7+3)]
; rcx = hWnd now, we needn't set it again

	call	Dialog01Button0_enable

	btr	dword [DlgProc01_ComboBox0Changed_first_time],0	; test only once byte at [...]
	jnc	DlgProc01_ComboBox0Change_common_end

	xor	ebx,ebx
	lea	rdi,[DlgProc01_ComboBox1_strings]
DlgProc01_Fill_ComboBox1:
	movzx	ecx,byte [rdi+DlgProc01_ComboBox1_strings_pos-DlgProc01_ComboBox1_strings+rbx*1]
	lea	rax,[rdi+rcx*1]
	mov	qword [rsp + 8*(4+0)],rax
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_Dialog01ComboBox1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
	inc	ebx
	cmp	bl,3
	jc	DlgProc01_Fill_ComboBox1

	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9			; show first
	mov	r8d,CB_SETCURSEL
	mov	edx,ID_Dialog01ComboBox1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	lea	rdi,[DlgProc01_ComboBox2_strings]
	mov	qword [rsp + 8*(4+0)],rdi
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_Dialog01ComboBox2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9			; show first
	mov	r8d,CB_SETCURSEL
	mov	edx,ID_Dialog01ComboBox2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

DlgProc01_ComboBox0Change_common_end:
	jmp	DlgProc01_ReturnTrue

DlgProc01_ComboBox1Change:
	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9
	mov	r8d,CB_GETCOUNT
	mov	edx,ID_Dialog01ComboBox2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
	or	eax,eax
	jz	DlgProc01_ComboBox2_nothing_to_delete
	mov	ebx,eax			; save count

DlgProc01_ComboBox2_delete_string:
;	mov	qword [rsp + 8*(4+0)],0	; unnecessary to do it again
	lea	r9,[rbx-1]
	mov	r8d,CB_DELETESTRING
	mov	edx,ID_Dialog01ComboBox2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
	dec	ebx
	jnz	DlgProc01_ComboBox2_delete_string
DlgProc01_ComboBox2_nothing_to_delete:

;	mov	qword [rsp + 8*(4+0)],0	; unnecessary to do it again
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog01ComboBox1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
; Execute rax=0   Read rax=1   Read/Write rax=2
; ebx=0 now
;	mov	edi,3
	lea	edi,[rbx+3]		; smaller opcode than above
	or	eax,eax
	cmovz	edi,eax	; transform 0->0 1->3 2->3 3->3
; for Execute we allow only 'byte' = 1 item in combobox
; for Write and Read/Write we allow 'byte' 'word' 'dword' 'qword' = 4 items in combobox
;	xor	ebx,ebx			; counter
; ebx=0 now after previous dec ebx / jnz
DlgProc01_Fill_ComboBox2:
	lea	rdx,[DlgProc01_ComboBox2_strings]
	movzx	ecx,byte [rdx+DlgProc01_ComboBox2_strings_pos-DlgProc01_ComboBox2_strings+rbx*1]
	lea	rax,[rdx+rcx*1]
	mov	qword [rsp + 8*(4+0)],rax
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_Dialog01ComboBox2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
	inc	ebx
	dec	edi
	jns	DlgProc01_Fill_ComboBox2

; is this necessary ?????
;	mov	qword [rsp + 8*(4+0)],0
;	xor	r9,r9			; the show/hide flag 0=show 1=hide
;	mov	r8d,CB_SHOWDROPDOWN
;	mov	edx,ID_Dialog01ComboBox2
;	mov	rcx,qword [rsp + 8*(4+7+3)]
;	call	qword [SendDlgItemMessageA]
; no, isn't

	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9			; show first
	mov	r8d,CB_SETCURSEL
	mov	edx,ID_Dialog01ComboBox2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	jmp	DlgProc01_ReturnTrue

DlgProc01_EditText0Change:
	call	Dialog01Button0_enable
	jmp	DlgProc01_ReturnTrue

DlgProc01_SetIt:
	mov	r9d,40			; must be the first, we use 5 qwords !!! of the stack
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog01EditText0
;	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; rsi ascii string, rax string size, out: rdx
	jc	DlgProc01_Abandon
	mov	qword [rsp + 8*(4+4)],rdx

	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog01ComboBox0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
	cmp	eax,-1			; nothing selected
	jz	DlgProc01_Abandon
	mov	dword [rsp + 8*(4+3)],eax
	add	al,'0'
	mov	byte [msg_HW_BP_No_ascii],al

;	mov	qword [rsp + 8*(4+0)],0	; unnecessary to do it again
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog01ComboBox1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
	cmp	eax,-1
	jz	DlgProc01_Abandon
	mov	dword [rsp + 8*(4+5)],eax

;	mov	qword [rsp + 8*(4+0)],0	; unnecessary to do it again
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog01ComboBox2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
	cmp	eax,-1
	jz	DlgProc01_Abandon
	mov	dword [rsp + 8*(4+5) + 4],eax
; we need to align address of HW BP according its size
	mov	cl,al				; 0=byte, 1=word, 2=dword 3=qword
	mov	al,11111111b
	shl	al,cl
	and	byte [rsp + 8*(4+4)],al
; done, aligned

	mov	edx,ID_Dialog01AutoCheckBox2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]
	mov	dword [rsp + 8*(4+6)],eax

	mov	edx,ID_Dialog01AutoCheckBox1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]
	mov	dword [rsp + 8*(4+6)+4],eax

; ID_Dialog01AutoCheckBox0 is allways checked and disabled

	lea	rdi,[all_thread_dr0]

	mov	edx,dword [rsp + 8*(4+5)]	; BP trigger (exec write read/write)
; we need transform:
; 0=00 ->   00 -- Break on instruction execution only
; 1=01 ->   01 -- Break on data writes only
; 3=11 ->   10 -- undefined
; 2=10 ->   11 -- Break on data reads or writes but not instruction fetches
; input in edx
; routine is reversible = transforms equally by both directions, called twice reverses back to the input value
	mov	ecx,edx
	shr	edx,1
	xor	edx,ecx
; transformations done, result is in edx

	mov	ebx,dword [rsp + 8*(4+5) + 4]	; BP size
; we have:
; 0=00 byte
; 1=01 word
; 2=10 dword
; 3=11 qword
; and we need to transform to:
; 00 -> 00 one-byte length
; 01 -> 01 two-byte length
; 11 -> 10 eight-byte lenght
; 10 -> 11 four-byte length
	mov	ecx,ebx
	shr	ebx,1
	xor	ebx,ecx

	mov	ecx,dword [rsp + 8*(4+3)]	; BP No

	mov	rax,qword [rsp + 8*(4+4)]	; BP address
	mov	[rdi + 8*rcx],rax		; put linear address to Debug Register DRx (x=RCX)

	mov	eax,dword [rsp + 8*(4+6)]	; flag (temporary/permanent)
	mov	byte [rdi-8 + rcx*1],al		; = [HW_BP_permanent + rcx*1]

	mov	al,byte [rsp + 8*(4+6) + 4]
;	and	al,00000001b			; leave only bit 0 and mask off all other bits
						; not necessary, only 0 or 1 is there
;	shl	al,1				; shift bit 0 to bit 1 (prepare G bit)
;	or	al,1				; prepare to set bit 0 (L bit)
; this is 1 byte smaller than above 2 instructions:
	stc
	rcl	al,1

	shl	ecx,1				; BP No. * 2
	shl	al,cl
	or	byte [rdi + 8*5],al		; L bit and G bit in DR7 for DRx register

; put size and trigger bits together
	shl	bl,2
	or	dl,bl
	shl	edx,cl				; edx=...*2*No. 
	shl	edx,cl				; edx=...*4*No.
	or	word [rdi + 8*5 + 2],dx

	mov	edx,ID_Dialog01AutoCheckBox3
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]	
;	and	al,00000001b
	or	byte [rdi + 8*5 + 1],al		; LE bit

	mov	edx,ID_Dialog01AutoCheckBox4
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [IsDlgButtonChecked]	
;	and	al,00000001b
	shl	al,1
	or	byte [rdi + 8*5 + 1],al		; GE bit

	or	byte [rdi + 8*5 + 1],00000100b	; bit 10. is default 1

	call	set_debug_registers_in_all_threads
	jc	DlgProc01_Abandon

;	mov	eax,dword [last_TID]
;	lea	rdi,[msg_HW_BP_thrd]
;	call	hexa_32_eax
;	mov	byte [rdi+8],'h'
	mov	rax,'EveryThr'
	mov	qword [msg_HW_BP_thrd],rax
	mov	byte [msg_HW_BP_thrd+8],'d'

	mov	rax,qword [rsp + 8*(4+4)]
	lea	rdi,[msg_HW_BP_addr]
	call	hexa_64_rax
	mov	byte [rdi+16],'h'

	lea	rdx,[msg_HW_BP_trigger]
	mov	ebx,dword [rsp + 8*(4+5)]
	lea	rdi,[DlgProc01_ComboBox1_strings]
	movzx	eax,byte [rdi+DlgProc01_ComboBox1_strings_pos-DlgProc01_ComboBox1_strings+rbx*1]
	movdqu	xmm0,dqword [rdi+rax*1]
	movzx	ecx,byte [rdi+DlgProc01_ComboBox1_strings_pos-DlgProc01_ComboBox1_strings+3+rbx*1]
	movdqu	dqword [rdx],xmm0
	mov	rax,' size='
	lea	rdi,[rdx+rcx*1+5]
	mov	qword [rdi-6],rax

	mov	ebx,dword [rsp + 8*(4+5) + 4]
	lea	rdx,[DlgProc01_ComboBox2_strings]
	movzx	ecx,byte [rdx+DlgProc01_ComboBox2_strings_pos-DlgProc01_ComboBox2_strings+rbx*1]
	mov	rax,qword [rdx+rcx*1]
	movzx	ecx,byte [rdx+DlgProc01_ComboBox2_strings_pos-DlgProc01_ComboBox2_strings+4+rbx*1]
	mov	qword [rdi],rax

	mov	eax,dword [rsp + 8*(4+6)]
	lea	rdx,[DlgProc01_msg_flag]
	shl	eax,1				; eax*2
	movdqu	xmm0,dqword [rdx+rax*8]
	movdqu	dqword [rdi+rcx*1-1],xmm0

	lea	rax,[msg_HW_BP_text]
	call	msg_to_LogEdit

DlgProc01_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [EndDialog]

	mov	eax,dword [last_PID]
	mov	edx,dword [last_TID]
	call	display_regs_memory
	jmp	DlgProc01_ReturnTrue

DlgProc01_AddressFromSymbol:
; rcx = handle of parent
	call	symbol2address
; CF=0, rax = address
	jc	DlgProc01_Abandon

	lea	rdi,[rsp+8*4]
	call	hexa_64_rax
	mov	byte [rdi+16],0

	lea	r8,[rdi]
	mov	edx,ID_Dialog01EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SetDlgItemTextA]

	jmp	DlgProc01_ReturnTrue

Dialog01Button0_enable:
	push	rbx rdi rcx rdx r8 r9
	sub	rsp,8*(4+7)

	mov	ebx,1			; enable window
;	xor	ebx,ebx			; 0 = disable window

; check if there is something in ID_Dialog01EditText0
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog01EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns rax=0 if nothing in ID_Dialog01EditText0
	cmovz	ebx,eax

; check if there is anything selected in ID_Dialog01ComboBox0
	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog01ComboBox0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]
;	cmp	rax,-1			; nothing selected
	inc	eax
	cmovz	ebx,eax

	mov	edx,ID_Dialog01Button0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx rdi rbx
	ret


align 10h
CMD_BP_AT_SYMBOL:
	sub	rsp,8*(4+1)
	and	[skip_processing_DlgProc0F_EditText0_changed],0
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc0F]
	mov	r8,[hWndParent]
	mov	edx,ID_Dialog0F
	mov	rcx,[hInstance]
	call	[DialogBoxParamA]
	add	rsp,8*(4+1)
	ret

align 10h
DlgProc0F:
	push	rbx rbp rsi rdi
	sub	rsp,8*(4+1)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc0F_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc0F_ReturnFalse
	cmp	[skip_processing_DlgProc0F_EditText0_changed],0
	jnz	DlgProc0F_L0
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog0FEditText0
	jz	DlgProc0F_EditText0_changed
DlgProc0F_L0:
	cmp	r8d,BN_CLICKED*10000h + ID_Dialog0FAutoCheckBox0
	jz	DlgProc0F_AutoCheckBox0Clicked
	cmp	r8w,ID_Dialog0FButton0
	jz	DlgProc0F_BP_AT_SYMBOL
	cmp	r8w,ID_Dialog0FButton1
	jz	DlgProc0F_Done
DlgProc0F_ReturnFalse:
	xor	eax,eax
DlgProc0F_Return:
	add	rsp,8*(4+1)
	pop	rdi rsi rbp rbx
	ret

DlgProc0F_InitDialog:
; check the checkbox
	movzx	r8d,byte [Dialog0FAutoCheckBox0_checked]
;BST_UNCHECKED			=	0
;BST_CHECKED			=	1
	mov	edx,ID_Dialog0FAutoCheckBox0
;	mov	rcx,rcx		; hWnd
	call	[CheckDlgButton]
DlgProc0F_ReturnTrue:
	mov	eax,1
	jmp	DlgProc0F_Return


DlgProc0F_AutoCheckBox0Clicked:
	xor	[Dialog0FAutoCheckBox0_checked],1
	jmp	DlgProc0F_ReturnTrue


DlgProc0F_EditText0_changed:
	mov	rbx,rcx			; save hWnd

	mov	edx,ID_Dialog0FEditText0
;	mov	rcx,rcx
	call	[GetDlgItem]
	or	rax,rax
	jz	DlgProc0F_ReturnTrue

	mov	rsi,rax

	xor	r9,r9
	xor	r8,r8
	mov	edx,WM_GETTEXTLENGTH
	mov	rcx,rax
	call	[SendMessageA]
; eax = size
	mov	ebp,eax

	mov	edx,ID_Dialog0FButton0
	mov	rcx,rbx
	call	[GetDlgItem]
	or	rax,rax
	jz	DlgProc0F_ReturnTrue

; if ebp=0 then disable Dialog0FButton0
; if ebp>0 then enable Dialog0FButton0
	mov	edx,1			; enable window
	or	ebp,ebp
	cmovz	edx,ebp			; disable/enable window = button
	mov	rcx,rax
	call	[EnableWindow]

	mov	edx,ID_Dialog0FStaticText0
	mov	rcx,rbx
	call	[GetDlgItem]
	or	rax,rax
	jz	DlgProc0F_ReturnTrue

	lea	r9,[tmp_buf]
	and	byte [r9],0		; empty string, only 0-terminator
	xor	r8,r8
	mov	edx,WM_SETTEXT
	mov	rcx,rax
	call	[SendMessageA]

; trying to fill the name til its end:
	or	ebp,ebp
	jz	DlgProc0F_ReturnTrue	; nothing to fill if Dialog0FEditText0 is empty

	cmp	[Dialog0FAutoCheckBox0_checked],0
	jz	DlgProc0F_ReturnTrue

	mov	edx,ID_Dialog0FEditText0
	mov	rcx,rbx
	call	[GetDlgItem]
	or	rax,rax
	jz	DlgProc0F_ReturnTrue

	lea	r9,[tmp_buf]
	lea	r8d,[rbp+1]			; size of string, +1 include 0-terminator
	mov	edx,WM_GETTEXT
	mov	rcx,rax
	call	[SendMessageA]
; eax = size (without 0-teminator)

; trying to find the first matching export
	mov	r11,[module_info_address]
	mov	r10d,MaxNumberOfModulesInfo

AMDPad16
DlgProc0F_EditText0_changed_L2:
	mov	eax,[last_PID]
	cmp	[r11+24*MaxNumberOfModulesInfo],eax	; check matching PID (whether the DLL doesn't belong to different process when we are debugging more than 1 process)
	jnz	DlgProc0F_EditText0_changed_L6

	mov	r8,[r11 + 16*MaxNumberOfModulesInfo]	; module info
	or	r8,r8					; isn't it empty ?
	jz	DlgProc0F_EditText0_changed_L6		; if empty then go to next module

; r8 points now to the module_info structure
; 0*4	dword size of allocated memory
; 1*4	dword NumberOfFunctions=NumberOfNames
; NumberOfFunctions*4 RVA of Functions
; NumberOfNames*4 RVA of Names
; ModuleName
; NumberOfFunctions times FunctionName

	mov	ecx,[r8+1*4]		; number of functions
	xor	eax,eax			; counter starts from 0
	lea	rdx,[r8+rcx*4 + 2*4]	; +2*4 skip dword size of allocated memory + dword NumberOfFunctions
; rdx now points to RVA of Names

AMDPad16
DlgProc0F_EditText0_changed_L4:
	mov	esi,[rdx+rax*4]		; RVA of name
	add	rsi,r8
	lea	rdi,[tmp_buf]
	mov	ecx,ebp			; string size
	cld
	repz cmpsb
	jz	DlgProc0F_EditText0_changed_L8

	inc	eax
	cmp	[r8+1*4],eax		; NumberOfFunctions
	jnbe	DlgProc0F_EditText0_changed_L4

DlgProc0F_EditText0_changed_L6:
	add	r11,8
	dec	r10
	jnz	DlgProc0F_EditText0_changed_L2

	jmp	DlgProc0F_ReturnTrue

DlgProc0F_EditText0_changed_L8:
	mov	esi,[rdx+rax*4]		; RVA of name
	add	rsi,r8

	mov	[rsp+8*4],r8

	mov	edx,ID_Dialog0FEditText0
	mov	rcx,rbx
	call	[GetDlgItem]
	or	rax,rax
	jz	DlgProc0F_ReturnTrue

	mov	rdi,rax

	or	[skip_processing_DlgProc0F_EditText0_changed],1

	lea	r9,[rsi]
	xor	r8,r8
	mov	edx,WM_SETTEXT
	mov	rcx,rax
	call	[SendMessageA]

	and	[skip_processing_DlgProc0F_EditText0_changed],0

	or	eax,eax
	jz	DlgProc0F_ReturnTrue

	xor	r9,r9
	xor	r8,r8
	mov	edx,WM_GETTEXTLENGTH
	mov	rcx,rdi
	call	[SendMessageA]
; eax = text lenght (without 0-teminator)

	mov	r9d,eax			; end of selection
	mov	r8d,ebp			; begin of selection
	mov	edx,EM_SETSEL
	mov	rcx,rdi
	call	[SendMessageA]

	mov	rax,[rsp+8*4]
; rax points now to the module_info structure
; 0*4	dword size of allocated memory
; 1*4	dword NumberOfFunctions=NumberOfNames
; NumberOfFunctions*4 RVA of Functions
; NumberOfNames*4 RVA of Names
; ModuleName
; NumberOfFunctions times FunctionName
	mov	ecx,[rax+4]		; get NumberOfFunctions=NumberOfNames
	jrcxz	DlgProc0F_EditText0_changed_end
	lea	rsi,[rax+2*4+rcx*(4+4)]	; point rsi to module name
	lea	rdi,[tmp_buf]
	cld
AMDPad16
DlgProc0F_EditText0_changed_L9:
	movsb
	cmp	byte [rsi-1],0
	jnz	DlgProc0F_EditText0_changed_L9

	mov	edx,ID_Dialog0FStaticText0
	mov	rcx,rbx
	call	[GetDlgItem]
	or	rax,rax
	jz	DlgProc0F_ReturnTrue

	lea	r9,[tmp_buf]
	xor	r8,r8
	mov	edx,WM_SETTEXT
	mov	rcx,rax
	call	[SendMessageA]

DlgProc0F_EditText0_changed_end:
	jmp	DlgProc0F_ReturnTrue


DlgProc0F_BP_AT_SYMBOL:
	mov	rbx,rcx			; save hWnd

	mov	edx,ID_Dialog0FEditText0
;	mov	rcx,rcx
	call	[GetDlgItem]
	or	rax,rax
	jz	DlgProc0F_end
	mov	rbp,rax

	xor	r9,r9
	xor	r8,r8
	mov	edx,WM_GETTEXTLENGTH
	mov	rcx,rbp
	call	[SendMessageA]
	or	rax,rax
	jz	DlgProc0F_end		; zero size?
; eax = size without 0-terminator

	lea	r9,[tmp_buf]
	lea	r8d,[rax+1]		; Specifies the maximum number of characters to be copied, including the terminating null character
	mov	edx,WM_GETTEXT
	mov	rcx,rbp			; hWnd
	call	[SendMessageA]
; The return value is the number of characters copied.
	or	eax,eax
	jz	DlgProc0F_end		; nothing in edit

	mov	r11,[module_info_address]
	mov	r10d,MaxNumberOfModulesInfo
	lea	r9d,[rax+1]		; size of text, +1 include 0-terminator

AMDPad16
DlgProc0F_BP_AT_SYMBOL_L2:
	mov	eax,[last_PID]
	cmp	[r11+24*MaxNumberOfModulesInfo],eax	; check matching PID (whether the DLL doesn't belong to different process when we are debugging more than 1 process)
	jnz	DlgProc0F_BP_AT_SYMBOL_L6

	mov	r8,[r11 + 16*MaxNumberOfModulesInfo]	; module info
	or	r8,r8					; isn't it empty ?
	jz	DlgProc0F_BP_AT_SYMBOL_L6		; if empty then go to next module

; r8 points now to the module_info structure
; 0*4	dword size of allocated memory
; 1*4	dword NumberOfFunctions=NumberOfNames
; NumberOfFunctions*4 RVA of Functions
; NumberOfNames*4 RVA of Names
; ModuleName
; NumberOfFunctions times FunctionName

	mov	ecx,[r8+1*4]		; number of functions
	xor	eax,eax			; counter starts from 0
	lea	rdx,[r8+rcx*4 + 2*4]	; +2*4 skip dword size of allocated memory + dword NumberOfFunctions
; rdx now points to RVA of Names

AMDPad16
DlgProc0F_BP_AT_SYMBOL_L4:
	mov	esi,[rdx+rax*4]		; RVA of name
	add	rsi,r8
	lea	rdi,[tmp_buf]
	mov	ecx,r9d			; string size
	cld
	repz cmpsb
	jz	DlgProc0F_BP_AT_SYMBOL_L8

	inc	eax
	cmp	[r8+1*4],eax		; NumberOfFunctions
	jnbe	DlgProc0F_BP_AT_SYMBOL_L4

DlgProc0F_BP_AT_SYMBOL_L6:
	add	r11,8
	dec	r10
	jnz	DlgProc0F_BP_AT_SYMBOL_L2

	lea	rax,[msg_symbol_not_found_]
	call	msg_to_LogEdit

	lea	rax,[tmp_buf]
	call	msg_to_LogEdit

	jmp	DlgProc0F_end		; nothing matching found

DlgProc0F_BP_AT_SYMBOL_L8:

;put bp there
	mov	eax,[r8+4+4+rax*4]	; RVA of function
	add	rax,[r11]		; add module base
	mov	ecx,dword [last_PID]		; process Id
	call	put_temporary_hw_or_sw_bp
	jc	DlgProc0F_end

	mov	eax,dword [last_PID]
	mov	edx,dword [last_TID]
	call	display_regs_memory

DlgProc0F_end:
	mov	rcx,rbx			; restore hWnd

DlgProc0F_Done:
; close dialog
	xor	edx,edx
;	mov	rcx,rcx			; hWnd
	call	[EndDialog]
	jmp	DlgProc0F_ReturnTrue


align 16
CMD_BP_DELETE:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc02]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog02
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
DlgProc02:
	push	rcx rdx rbx rsi rdi r8 r9
	sub	rsp,8*(4+8)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc02_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc02_ReturnFalse
	cmp	r8d,LBN_DBLCLK*10000h + ID_Dialog02ListBox0
	jz	Dialog02ListBox0_Proc_DBLCLK
	cmp	r8d,LBN_DBLCLK*10000h + ID_Dialog02ListBox1
	jz	Dialog02ListBox1_Proc_DBLCLK
	cmp	r8w,ID_Dialog02Button0
	jz	DlgProc02_Done
	cmp	r8w,ID_Dialog02Button1
	jz	DlgProc02_WipeOutAll

DlgProc02_ReturnFalse:
	xor	eax,eax
DlgProc02_Return:
	add	rsp,8*(4+8)
	pop	r9 r8 rdi rsi rbx rdx rcx
	ret

DlgProc02_InitDialog:
; create ListView for SW BP
	mov	rax,qword [hInstance]
;	mov	rcx,qword [rsp+8*(4+8+6)]
	and	qword [rsp+8*(4+7)],0	; pointer to window-creation data
	mov	[rsp+8*(4+6)],rax	; hInst  handle to application instance
	mov	qword [rsp+8*(4+5)],ID_Dialog02ListBox0	; handle to menu, or child-window identifier
	mov	qword [rsp+8*(4+4)],rcx
	mov	dword [rsp+8*(4+3)],260
	mov	dword [rsp+8*(4+2)],400
	mov	dword [rsp+8*(4+1)],24
	mov	dword [rsp+8*(4+0)],4
	mov	r9d,WS_VSCROLL or WS_VISIBLE or WS_BORDER or WS_CHILD or LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or LBS_DISABLENOSCROLL or LBS_NOTIFY	; window style
	xor	r8,r8			; pointer to window name
	lea	rdx,[ListBoxClassName]	; pointer to registered class name
	mov	ecx,WS_EX_CLIENTEDGE	; extended window style
	call	[CreateWindowExA]
	mov	qword [rsp+8*(4+7)],rax	; save handle of ListView

	xor	ebx,ebx			; counter
DlgProc02_InitDialog_L0:
	mov	rdx,qword [breakpoints_space_address]
	lea	rdi,[rsp+8*4]
	mov	rcx,qword [rdx+rbx*8]
	or	rcx,rcx
	jz	DlgProc02_InitDialog_L1
	mov	eax,ebx			; SW BP index
	call	hexa_32_eax
	mov	byte [rdi+8],' '
	mov	rax,rcx			; SW BP address
	lea	rdi,[rdi+9]
	call	hexa_64_rax
	mov	byte [rdi+16],' '
	mov	eax,dword [rdx+MaxNumberOfBreakpoints*8 + rbx*4]
	lea	rdi,[rdi+17]
	call	hexa_32_eax		; PID
	mov	byte [rdi+8],' '
	lea	rsi,[msg_permanent]
	lea	rax,[msg_temporary]
	lea	rdi,[rdi+9]
	cmp	byte [rdx+MaxNumberOfBreakpoints*(8+4+1) + rbx*1],SW_BP_flag_temporary
	cmovz	rsi,rax
	CopyQwords msg_permanent_size

	lea	r9,[rsp+8*4]
	xor	r8,r8
	mov	edx,LB_ADDSTRING
	mov	rcx,qword [rsp+8*(4+7)]
	call	qword [SendMessageA]

DlgProc02_InitDialog_L1:
	inc	ebx
	cmp	ebx,MaxNumberOfBreakpoints
	jc	DlgProc02_InitDialog_L0

; create ListView for HW BP
	mov	rax,qword [hInstance]
	mov	rcx,qword [rsp+8*(4+8+6)]	; handle of window to own newly created ListView
	and	qword [rsp+8*(4+7)],0		; pointer to window-creation data
	mov	[rsp+8*(4+6)],rax		; hInst  handle to application instance
	mov	qword [rsp+8*(4+5)],ID_Dialog02ListBox1	; handle to menu, or child-window identifier
	mov	qword [rsp+8*(4+4)],rcx
	mov	dword [rsp+8*(4+3)],74
	mov	dword [rsp+8*(4+2)],400
	mov	dword [rsp+8*(4+1)],313
	mov	dword [rsp+8*(4+0)],4
	mov	r9d,WS_VSCROLL or WS_VISIBLE or WS_BORDER or WS_CHILD or LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or LBS_DISABLENOSCROLL or LBS_NOTIFY	; window style
	xor	r8,r8			; pointer to window name
	lea	rdx,[ListBoxClassName]	; pointer to registered class name
	mov	ecx,WS_EX_CLIENTEDGE	; extended window style
	call	[CreateWindowExA]
	mov	qword [rsp+8*(4+7)],rax	; save handle of ListView

DlgProc02_InitDialog_L2:
	xor	ebx,ebx			; counter
DlgProc02_InitDialog_L3:
	lea	rdi,[rsp+8*4]
	lea	eax,[rbx+'0']		; No.
	cld
	stosb
	mov	al,' '
	stosb
	mov	rax,'<empty>'
	mov	qword [rdi],rax		; create 0-terminated string too
	lea	ecx,[rbx+rbx*1]
	mov	al,11b
	shl	al,cl
	test	byte [all_thread_dr7],al
	jz	DlgProc02_InitDialog_L4

	lea	rdx,[all_thread_dr0]
	mov	rax,qword [rdx+rbx*8]	; get address
	call	hexa_64_rax
	lea	rdi,[rdi+17]
	mov	byte [rdi-1],' '

; e/r/w
	lea	ecx,[rbx*4+16]
	mov	edx,dword [all_thread_dr7]
	shr	edx,cl
	and	edx,1111b

	mov	cl,dl
	and	cl,11b
; transform 0->0 1->1 3->2
	mov	eax,2
	cmp	cl,3
	cmovz	ecx,eax

	lea	r8,[DlgProc01_ComboBox1_strings]
	movzx	eax,byte [r8+DlgProc01_ComboBox1_strings_pos-DlgProc01_ComboBox1_strings+rcx*1]
	movdqu	xmm0,dqword [r8+rax*1]
	movzx	ecx,byte [r8+DlgProc01_ComboBox1_strings_pos-DlgProc01_ComboBox1_strings+3+rcx*1]
	movdqu	dqword [rdi],xmm0
	add	rdi,rcx
	mov	byte [rdi-1],' '

; size
	shr	dl,2
	mov	ecx,edx
	shr	edx,1
	xor	edx,ecx

	lea	r8,[DlgProc01_ComboBox2_strings]
	movzx	eax,byte [r8+DlgProc01_ComboBox2_strings_pos-DlgProc01_ComboBox2_strings+rdx*1]
	mov	rax,qword [r8+rax*1]
	movzx	ecx,byte [r8+DlgProc01_ComboBox2_strings_pos-DlgProc01_ComboBox2_strings+4+rdx*1]
	mov	qword [rdi],rax
	add	rdi,rcx
	mov	byte [rdi-1],' '

; flag
	lea	rcx,[HW_BP_permanent]
	lea	rdx,[msg_permanent]
	lea	rax,[msg_temporary]
	cmp	byte [rcx+rbx*1],0
	cmovnz	rax,rdx
	movdqu	xmm0,dqword [rax]
	movdqu	dqword [rdi],xmm0

DlgProc02_InitDialog_L4:
	lea	r9,[rsp+8*4]
	xor	r8,r8
	mov	edx,LB_ADDSTRING
	mov	rcx,qword [rsp+8*(4+7)]
	call	qword [SendMessageA]

	inc	ebx
	cmp	bl,4
	jc	DlgProc02_InitDialog_L3

DlgProc02_ReturnTrue:
	mov	eax,1
	jmp	DlgProc02_Return

DlgProc02_WipeOutAll:
	mov	eax,MaxNumberOfBreakpoints-1	; counter, -1 because zero based
DlgProc02_WipeOutAll_L0:
	call	remove_SW_BP_from_iBP_and_clear_its_dbg_store
	dec	eax
	jns	DlgProc02_WipeOutAll_L0

DlgProc02_Done:
; close dialog
	xor	edx,edx
;	mov	rcx,qword [rsp+8*(4+8+6)]	; we needn't to do it since DlgProc02_WipeOutAll doesn't touch RCX
	call	qword [EndDialog]
DlgProc02_Update:
	mov	eax,dword [last_PID]
	mov	edx,dword [last_TID]
	call	display_regs_memory
	jmp	DlgProc02_ReturnTrue

Dialog02ListBox0_Proc_DBLCLK:
	mov	edx,ID_Dialog02ListBox0
;	mov	rcx,qword [rsp+8*(4+8+6)]
	call	qword [GetDlgItem]
	xchg	rbx,rax

	xor	r9,r9
	xor	r8,r8
	mov	edx,LB_GETCURSEL
	mov	rcx,rbx
	call	qword [SendMessageA]
; eax=selected index of ListBox
	mov	esi,eax

	xor	r9,r9
	mov	r8d,eax
	mov	edx,LB_DELETESTRING
	mov	rcx,rbx
	call	qword [SendMessageA]

	mov	rdi,qword [breakpoints_space_address]
	mov	ecx,MaxNumberOfBreakpoints
	xor	eax,eax
	cld
Dialog02ListBox0_Proc_DBLCLK_L0:
	repz scasq
;	jz	DlgProc02_ReturnTrue	; in case of zero qword at the last scasq
					; not necessary, remove_SW_BP_from_iBP_and_clear_its_dbg_store checks it
	dec	esi
	jns	Dialog02ListBox0_Proc_DBLCLK_L0

	mov	eax,MaxNumberOfBreakpoints-1
	sub	eax,ecx
	call	remove_SW_BP_from_iBP_and_clear_its_dbg_store

	jmp	DlgProc02_Update

Dialog02ListBox1_Proc_DBLCLK:
	mov	edx,ID_Dialog02ListBox1
;	mov	rcx,qword [rsp+8*(4+8+6)]
	call	qword [GetDlgItem]
	xchg	rbx,rax

	xor	r9,r9
	xor	r8,r8
	mov	edx,LB_GETCURSEL
	mov	rcx,rbx
	call	qword [SendMessageA]
; eax=selected index of ListBox

	lea	ecx,[rax+rax*1]			; cl=2*al
	mov	edx,not (1111b shl 16)
	rol	edx,cl
	rol	edx,cl
	mov	dl,11111100b
	rol	dl,cl
	and	dword [all_thread_dr7],edx	; clear G, L bits , LEN , R/W of DR7

	lea	rcx,[all_thread_dr0]
	and	qword [rcx+rax*8],0		; clear address in DR0 or DR1 or DR2 or DR3

	call	set_debug_registers_in_all_threads

	xor	r9,r9
	xor	r8,r8
	mov	edx,LB_RESETCONTENT
	mov	rcx,rbx
	call	qword [SendMessageA]

	mov	eax,dword [last_PID]
	mov	edx,dword [last_TID]
	call	display_regs_memory

	mov	qword [rsp+8*(4+7)],rbx	; save handle of ListView
	jmp	DlgProc02_InitDialog_L2

align 16
CMD_GOTO:
	cmp	byte [WeAreDebugging],0
	jz	CMD_GOTO_ret

; does an Edit already exist?
	cmp	byte [ListView_Edit_exist],0
	jnz	CMD_GOTO_ret

	sub	rsp,8*(4+11)

; determine foreground MDI child window
	xor	r9,r9
	xor	r8,r8
	mov	edx,WM_MDIGETACTIVE
	mov	rcx,qword [hWndClient]
	call	qword [SendMessageA]

	mov	rcx,rax
	call	hWndList2iList
	jc	CMD_GOTO_msg		; Log window active?
	cmp	edx,6			; only indices 0-5 (0=Code_1st, 1=Code_2nd, 2=Data_1st, ..., 5=Stack) allowed
	jnc	CMD_GOTO_msg

	lea	rax,[hListView]
	mov	rcx,qword [rax+rdx*8]	; get handle of the SysListView32

	mov	qword [EditedListView_handle],rcx
	mov	qword [ListView_edit_Listview_index],rdx
	and	qword [ListView_edit_last_item_and_subitem],0	; both iItem=0, iSubItem=0

	lea	rdx,[tmp_buf]
;	mov	[rsp+8*4 + LV_ITEM64.iSubItem],0
	and	[rsp+8*4 + LV_ITEM64.iSubItem],0
	mov	[rsp+8*4 + LV_ITEM64.pszText],rdx
	mov	[rsp+8*4 + LV_ITEM64.cchTextMax],SysListView_cchTextMax
	lea	r9,[rsp+8*4]
	xor	r8,r8			; iItem=0
	mov	edx,LVM_GETITEMTEXT
;	mov	rcx,rcx
	call	qword [SendMessageA]

	cmp	eax,16
	jnz	CMD_GOTO_epi		; abnormal size, every address is 64 bit wide and thus has 16 ascii characters

; OK, create Edit control at iItem=0, iSubItem=0

; get rectangles of iItem iSubItem
	lea	r9,[rsp + 8*(4+0)]
	mov	[r9 + RECT.left],LVIR_LABEL	; code		Portion of the list view item for which to retrieve the bounding rectangle.
						; LVIR_BOUNDS	Returns the bounding rectangle of the entire item, including the icon and label.
						; LVIR_ICON	Returns the bounding rectangle of the icon or small icon.
						; LVIR_LABEL	Returns the bounding rectangle of the item text.
						; LVIR_SELECTBOUNDS	Returns the union of the LVIR_ICON and LVIR_LABEL rectangles, but excludes columns in details view.
;	mov	[r9 + RECT.top],0		; iSubItem=0
	and	[r9 + RECT.top],0		; iSubItem=0
	xor	r8,r8				; iItem=0
	mov	edx,LVM_GETSUBITEMRECT
	mov	rcx,qword [EditedListView_handle]
	call	qword [SendMessageA]
	or	eax,eax
	jz	CMD_GOTO_epi

	movdqa	xmm0,dqword [rsp + 8*(4+0)]
	movdqa	dqword [ListView_item_and_subitem_rect],xmm0

; create List Edit
	mov	rcx,qword [EditedListView_handle]
	call	Kreate_ListView_Edit
; set text in List Edit
	lea	r9,[tmp_buf]
	xor	r8,r8
	mov	edx,WM_SETTEXT
	mov	rcx,qword [ListView_Edit_handle]
	call	qword [SendMessageA]

; limit text size there
	mov	r9d,tmp_buf_size		; lParam text limit
	xor	r8,r8
	mov	edx,EM_LIMITTEXT
	mov	rcx,qword [ListView_Edit_handle]
	call	qword [SendMessageA]

; begin / end / select_all
; cursor positions:
; 0=begin:	start=0,	end=0
; 1=end:	start=16,	end=16
; 2=select_all:	start=0,	end=16
	movzx	r9d,byte [face.goto_edit_style]
	mov	r8,r9
	and	r9b,1 shl 1
	and	r8b,1 shl 0
	shl	r8d,4		; (1 shl 0) shl 4) = 16
	lea	r9,[r8+r9*8]
	mov	edx,EM_SETSEL
	mov	rcx,qword [ListView_Edit_handle]
	call	qword [SendMessageA]

CMD_GOTO_epi:
	add	rsp,8*(4+11)
CMD_GOTO_ret:
	ret

CMD_GOTO_msg:
	lea	rax,[msg_activate_cds]
	call	msg_to_LogEdit
	jmp	CMD_GOTO_epi

align 16
CMD_PROC_THRD:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc09]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog09
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
DlgProc09:
	push	rsi rdi rbp rbx rcx rdx r8 r9
	sub	rsp,8*(4+9)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc09_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc09_ReturnFalse
	cmp	r8d,LBN_DBLCLK*10000h + ID_Dialog09ListBox0
	jz	Dialog09ListBox0_Proc_DBLCLK
	cmp	r8w,ID_Dialog09Button0
	jz	DlgProc09_Done
DlgProc09_ReturnFalse:
	xor	eax, eax
DlgProc09_Return:
	add	rsp,8*(4+9)
	pop	r9 r8 rdx rcx rbx rbp rdi rsi
	ret

DlgProc09_InitDialog:
; create List Box
	and	qword [rsp + 8*(4+7)],0		; pointer to window-creation data
	mov	rax,qword [hInstance]		; raw encoded this may be 400000h or 100000000h
	mov	qword [rsp + 8*(4+6)],rax	; hInst  handle to application instance
	mov	dword [rsp + 8*(4+5)],ID_Dialog09ListBox0	; handle to menu, or child-window identifier
;	mov	rcx,qword [rsp + 8*(4+9+3)]
	mov	qword [rsp+8*(4+4)],rcx
	mov	dword [rsp + 8*(4+3)],450
	mov	dword [rsp + 8*(4+2)],284
	mov	dword [rsp + 8*(4+1)],24
	mov	dword [rsp + 8*(4+0)],8
	mov	r9d,WS_VSCROLL or WS_VISIBLE or WS_BORDER or WS_CHILD or LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or LBS_NOTIFY or WS_TABSTOP	; window style
	xor	r8,r8			; pointer to window name
	lea	rdx,[ListBoxClassName]	; pointer to registered class name
	mov	ecx,WS_EX_CLIENTEDGE	; extended window style
	call	qword [CreateWindowExA]
	mov	qword [Dialog09ListBox0_handle],rax

;An application sends the LBN_DBLCLK notification message when the user double-clicks a string in a list box. The parent window of the list box receives this notification message through the WM_COMMAND message.
;
;LBN_DBLCLK
;idListBox = (int) LOWORD(wParam);  // identifier of list box
;hwndListBox = (HWND) lParam;       // handle of list box
;
;
;Remarks
;
;Only a list box that has the LBS_NOTIFY style will send this notification message.

	lea	rcx,[imports_ListView_font]
	call	qword [CreateFontIndirectA]
	mov	qword [imports_hFont],rax

	mov	r9,1				; lParam redraw flag
	mov	r8,rax				; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,qword [Dialog09ListBox0_handle]
	call	qword [SendMessageA]

	lea	rdi,[tmp_buf]
	mov	dword [rdi],'PID='
	mov	rax,'h TID='
	mov	qword [rdi+4+8],rax
	mov	eax,'h '
	mov	dword [rdi+4+8+2+4+8],eax

	and	dword [rsp+8*(4+8)],0		; counter for selected string

DlgProc09_ReturnTrue_fill_ListBox_L2:
	mov	rdi,qword [multiprocess_multithread_support_address]
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2	; skip store of PID...hProcess and TID...hThread
a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
	mov	ecx,a
DlgProc09_InitDialog_L0:
	xor	eax,eax
	cld
	repz scasd
	jz	DlgProc09_finito
	mov	eax,dword [rdi-4]		; grab PID
	mov	ebx,dword [rdi-4 + a*4]		; grab TID
	mov	ebp,ecx				; save remaining count to scan
	lea	rsi,[rdi]			; save the position of next scan

	cmp	dword [last_PID],eax
	jnz	DlgProc09_InitDialog_selected_string_done
	cmp	dword [last_TID],ebx
	jnz	DlgProc09_InitDialog_selected_string_done
	shl	qword [rsp+8*(4+8)],32		; put current count from low dword to high
DlgProc09_InitDialog_selected_string_done:
	inc	dword [rsp+8*(4+8)]

	lea	rdi,[tmp_buf+4]
	call	hexa_32_eax
	xchg	eax,ebx
	lea	rdi,[rdi+8+2+4]
	call	hexa_32_eax
	lea	rdi,[rdi+8+2]
	xchg	eax,ebx

	cmp	dword [hung_TID],ebx
	jnz	DlgProc09_InitDialog_L5
	cmp	dword [hung_PID],eax
	jnz	DlgProc09_InitDialog_L5
	mov	eax,'hung'
	stosd
	mov	al,' '
	stosb

DlgProc09_InitDialog_L5:
	mov	byte [rdi],0		; prepare 0-terminator for case when next call fail

	mov	edx,ebx				; TID
	call	determine_thread_state
	jc	DlgProc09_InitDialog_L1
	
	lea	rdx,[msg_resumed]
	lea	rcx,[msg_suspended]
	or	eax,eax				; 0=resumed, 1=suspended
	cmovz	rcx,rdx
	movdqu	xmm0,dqword [rcx]
	movdqu	dqword [rdi],xmm0

DlgProc09_InitDialog_L1:
	lea	r9,[tmp_buf]
	xor	r8,r8
	mov	edx,LB_ADDSTRING
	mov	rcx,qword [Dialog09ListBox0_handle]
	call	qword [SendMessageA]

	mov	ecx,ebp
	lea	rdi,[rsi]
	jmp	DlgProc09_InitDialog_L0

DlgProc09_finito:
; select string in ListView
	xor	r9,r9
	mov	r8d,dword [rsp+8*(4+8)+4]
	mov	edx,LB_SETCURSEL
	mov	rcx,qword [Dialog09ListBox0_handle]
	call	qword [SendMessageA]

DlgProc09_ReturnTrue:
	mov	eax,1
	jmp	DlgProc09_Return

DlgProc09_Done:
	mov	rcx,qword [imports_hFont]
	call	qword [DeleteObject]

; close dialog
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+9+3)]
	call	qword [EndDialog]
	jmp	DlgProc09_ReturnTrue

Dialog09ListBox0_Proc_DBLCLK:
	mov	edx,ID_Dialog09ListBox0
	mov	rcx,qword [rsp + 8*(4+9+3)]
	call	qword [GetDlgItem]
	mov	rbx,rax

	xor	r9,r9
	xor	r8,r8
	mov	edx,LB_GETCURSEL
	mov	rcx,rbx
	call	qword [SendMessageA]
; eax=selected index of ListBox

	lea	r9,[rsp+8*(4+0)]
	mov	r8d,eax
	mov	edx,LB_GETTEXT
	mov	rcx,rbx
	call	qword [SendMessageA]
	or	eax,eax
	jz	Dialog09ListBox0_Proc_DBLCLK_done

	lea	rsi,[rsp+8*(4+0)+4]	; +4 skip PID=
	mov	eax,8			; size
	call	ascii2hexa_qword
	jc	Dialog09ListBox0_Proc_DBLCLK_done
	mov	edi,edx

	lea	rsi,[rsp+8*(4+0)+4+8+6]	; skip 'PID=', ascii hexa dword, 'h TID='
	mov	eax,8			; size
	call	ascii2hexa_qword
	jc	Dialog09ListBox0_Proc_DBLCLK_done
	mov	dword [last_TID],edx
	mov	dword [last_PID],edi

	xor	eax,eax				; eax=0 resumed, eax=1 suspended if we do jz Dialog09ListBox0_Proc_DBLCLK_L4
	mov	rdi,qword [last_PID_TID]	; get last_PID and last_TID in once
	cmp	qword [hung_PID_TID],rdi
	lea	rdi,[update_status_window_stopped]
	jz	Dialog09ListBox0_Proc_DBLCLK_L4

	call	determine_thread_state	; in EDX=TID
	jc	Dialog09ListBox0_Proc_DBLCLK_L5
; eax=0 resumed, eax=1 suspended
	lea	rdx,[update_status_window_running]
	or	eax,eax
	cmovz	rdi,rdx

Dialog09ListBox0_Proc_DBLCLK_L4:
	call	update_menus_proc_thrd_switched
	mov	eax,[last_PID]
	mov	edx,[last_TID]
	call	update_status_window_PID_TID
	call	rdi				; update running/stopped

Dialog09ListBox0_Proc_DBLCLK_L5:
	mov	ecx,dword [last_TID]
	call	GetThreadContext_debuggee_CONTEXT_ALL
	jc	Dialog09ListBox0_Proc_DBLCLK_done

; update code 1st and stack start display position
	mov	rax,qword [ThreadContext.Rip]
	mov	rcx,qword [ThreadContext.Rsp]
	mov	qword [Code_listview_dump_start_address],rax
	mov	qword [Stack_listview_dump_start_address],rcx

	call	code_1st_disassemble_back

	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]	; input param for display_regs_memory
	call	display_regs_memory

Dialog09ListBox0_Proc_DBLCLK_done:
	jmp	DlgProc09_Done

align 16
CMD_STACK:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc0D]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog0D
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
DlgProc0D:
	push	rbx rbp rsi rdi r12

a=1				; return address from procedure
b=5				; number of pushed registers
d=(sizeof.MEMORY_BASIC_INFORMATION64+7)/8
e=(sizeof.LV_ITEM64+7)/8
f=4				; 4 qwords reserved for API
c=(a+b+d+e+f) and 1		; align stack at dqword
	sub	rsp,8*(c+d+e+f)
; the stack looks now like:
; a <- the top, return address from procedure
; b number of pushed registers
; c aligning stack at dqword (c is 0 or 1)
; d MEMORY_BASIC_INFORMATION64
; e LV_ITEM64
; f 4 qwords reserved for API
;   <- current RSP
	cmp	edx,WM_INITDIALOG
	jz	DlgProc0D_InitDialog
	cmp	edx,WM_NOTIFY
	jz	DlgProc0D_NOTIFY
	cmp	edx,WM_COMMAND
	jnz	DlgProc0D_ReturnFalse
	cmp	r8w,ID_Dialog0DButton0
	jz	DlgProc0D_Done
DlgProc0D_ReturnFalse:
	xor	eax,eax
DlgProc0D_Return:
	add	rsp,8*(c+d+e+f)
	pop	r12 rdi rsi rbp rbx
	ret

DlgProc0D_InitDialog:
	mov	rax,qword [hInstance]
	and	qword [rsp + 8*(4+7)],0		; pointer to window-creation data
	mov	qword [rsp + 8*(4+6)],rax	; hInst  handle to application instance
	mov	qword [rsp + 8*(4+5)],ID_Dialog0DSysListView0	; handle to menu, or child-window identifier
	mov	qword [rsp + 8*(4+4)],rcx	; hWnd
	mov	dword [rsp + 8*(4+3)],450	; height
	mov	dword [rsp + 8*(4+2)],650	; width
	mov	dword [rsp + 8*(4+1)],32	; vertical position of window
	mov	dword [rsp + 8*(4+0)],3		; horizontal position of window
	mov	r9d,WS_CHILD or WS_VISIBLE or WS_TABSTOP or LVS_REPORT or LVS_SHAREIMAGELISTS	; window style
	xor	r8,r8				; pointer to window name
	lea	rdx,[SysListView32ClassName]	; pointer to registered class name
	mov	ecx,WS_EX_CLIENTEDGE		; extended window style
	call	qword [CreateWindowExA]
	mov	rsi,rax

	mov	r9,LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_GRIDLINES; or LVS_EX_SUBITEMIMAGES		; lParam
	xor	r8,r8
	mov	edx,LVM_SETEXTENDEDLISTVIEWSTYLE
	mov	rcx,rsi
	call	qword [SendMessageA]

	lea	rcx,[imports_ListView_font]
	call	qword [CreateFontIndirectA]
	mov	qword [imports_hFont],rax

	mov	r9,1				; lParam redraw flag
	mov	r8,rax				; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,rsi
	call	qword [SendMessageA]

if LVCFMT_LEFT = 0
  if (LV_COLUMN64.fmt - LV_COLUMN64.mask) = 4
	mov	qword [rsp+8*f + LV_COLUMN64.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
  else
	mov	dword [rsp+8*f + LV_COLUMN64.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH	; fmt, iSubItem, pszText, cx member are valid.
	mov	dword [rsp+8*f + LV_COLUMN64.fmt],LVCFMT_LEFT
  end if
end if
	mov	[rsp+8*f + LV_COLUMN64.iSubItem],1;0
	lea	rdi,[Dialog0DSysListView0_data]

DlgProc0D_InitDialog_columns_L0:
	lea	r9,[rsp+8*f]
	mov	[r9 + LV_COLUMN64.pszText],rdi
	or	ecx,-1
	xor	eax,eax
	cld
	repnz scasb
	mov	eax,dword [rdi]
	scasd
	mov	[r9 + LV_COLUMN64.cx],eax	; Specifies the width, in pixels, of the column.
	mov	r8d,[r9 + LV_COLUMN64.iSubItem]	; column number
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rsi
	call	qword [SendMessageA]
	inc	[rsp+8*f + LV_COLUMN64.iSubItem]
	cmp	byte [rdi],0
	jnz	DlgProc0D_InitDialog_columns_L0

	mov	rbp,rsi				; save handle of Dialog0DSysListView0

	mov	eax,[last_PID]
	call	PID2hProcess
	jc	DlgProc0D_ReturnTrue

; note that ThreadContext is already read, all MDI children windows where updated according registers from the thread context
	mov	rcx,rdx				; handle of process
	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[rsp+8*(f+e)]
	mov	rdx,[ThreadContext.Rsp]
	call	qword [VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	jnz	DlgProc0D_ReturnTrue

;	xor	rbx,rbx				; stack bottom
;	xor	rbp,rbp				; counter of stack size from the bottom to the top
;	mov	rdi,[ThreadContext.Rsp]
;
;DlgProc0D_InitDialog_stack_query:
;	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
;	lea	r8,[rsp+8*(f+e)]
;	mov	rdx,rdi
;	mov	rcx,rsi
;	call	qword [VirtualQueryEx]
;	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
;	jnz	DlgProc0D_ReturnTrue
;
;	test	[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.Protect],PAGE_READWRITE
;; PAGE_EXECUTE_READWRITE
;	jz	DlgProc0D_InitDialog_stack_queried_done
;	or	rbx,rbx
;	mov	rax,[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.AllocationBase]
;	mov	rcx,[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.RegionSize]
;	cmovz	rbx,rax
;	add	rbp,rcx
;	add	rdi,rcx
;	jmp	DlgProc0D_InitDialog_stack_query
;DlgProc0D_InitDialog_stack_queried_done:

	mov	rbx,[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.RegionSize]	; stack size from the bottom to the top

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	rdx,rbx				; = [rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.RegionSize]
	xor	ecx,ecx
	call	[VirtualAlloc]
	or	rax,rax
	jz	DlgProc0D_ReturnTrue
	mov	r12,rax

	lea	rsi,[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.BaseAddress]; stack bottom
	mov	rdi,rax
	mov	ecx,[last_PID]
	call	read_debuggee_memory
	mov	rsi,rdi
	jc	DlgProc0D_MemDecommit_ReturnTrue

; rbp=handle of Dialog0DSysListView0, rsi pointer to buffer with data read from stack, rbx size of data read from stack
;	xor	eax,eax
;;	mov	[rsp+8*f + LV_ITEM64.iItem],eax
;;	mov	[rsp+8*f + LV_ITEM64.iSubItem],eax
;	mov	qword [rsp+8*f + LV_ITEM64.iItem],rax	; instead of above 2 instructions

	xor	ebx,ebx
	mov	qword [rsp+8*f + LV_ITEM64.iItem],rbx

DlgProc0D_show_stack_info_L0:
; skip empty stack (zero qwords)
	cld
	lodsq
	or	rax,rax
	jz	DlgProc0D_show_stack_info_L9

	lea	rdi,[tmp_buf]
	mov	qword [rsp+8*f + LV_ITEM64.pszText],rdi
	mov	byte [rdi+16],0			; 0-terminator

	mov	eax,[rsp+8*f + LV_ITEM64.iItem]	; index of displayed item in SysListView32, will be updated at end
	mov	[rsp+8*f + LV_ITEM64.lParam],rax
	mov	rax,[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.BaseAddress]
	add	rax,rbx
	call	hexa_64_rax
	lea	r9,[rsp+8*f]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT or LVIF_PARAM
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbp
	call	qword [SendMessageA]

	mov	rax,[rsi-8]			; -8 because we loaded the qword at lodsq
	call	hexa_64_rax
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,rbp
	call	qword [SendMessageA]

	mov	rax,[rsi-8]			; -8 because we loaded the qword at lodsq
	mov	ecx,[last_PID]
;	lea	rdi,[tmp_buf]			; rdi is already set there
	call	address2symbol_proximus
;	jc	DlgProc0D_show_stack_info_L5

	mov	rdx,rax				; address where to end
	mov	eax,ecx				; PID
	mov	ecx,1				; number of instructions backward rdx
	call	painful_reverze
;	jc	DlgProc0D_show_stack_info_stack_backtrace_done
	mov	byte [rdi],0
	jc	DlgProc0D_show_stack_info_stack_backtrace_done

	mov	ecx,eax				; number of bytes to seek back

	cmp	dword [tmp_buf2],'call'
	jnz	DlgProc0D_show_stack_info_stack_backtrace_done

	mov	byte [rdi],' '
	lea	rax,[tmp_buf]
	cmp	rax,rdi
	adc	rdi,0
	mov	rax,'called f'
	stosq
	mov	eax,'rom '
	stosd
	mov	rax,[rsi-8]
	sub	rax,rcx
	call	hexa_64_rax
	add	rdi,16
	mov	byte [rdi],0
DlgProc0D_show_stack_info_stack_backtrace_done:

DlgProc0D_show_stack_info_L7:
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,rbp
	call	qword [SendMessageA]

DlgProc0D_show_stack_info_L8:
	mov	eax,[rsp+8*4 + LV_ITEM64.iItem]
	inc	eax
if (LV_ITEM64.iSubItem - LV_ITEM64.iItem) = 4
; high dword of rax=0 now, so we set both dwords by 1 instruction
	mov	qword [rsp+8*4 + LV_ITEM64.iItem],rax
else
	mov	[rsp+8*4 + LV_ITEM64.iItem],eax
	and	[rsp+8*4 + LV_ITEM64.iSubItem],0
end if

DlgProc0D_show_stack_info_L9:
	add	rbx,8
	cmp	[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.RegionSize],rbx
	jnbe	DlgProc0D_show_stack_info_L0

DlgProc0D_MemDecommit_ReturnTrue:
	mov	r8d,MEM_DECOMMIT
	mov	rdx,[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.RegionSize]
	mov	rcx,r12
	call	[VirtualFree]

DlgProc0D_ReturnTrue:
	mov	eax,1
	jmp	DlgProc0D_Return

DlgProc0D_Done:
	mov	r12,rcx			; save hWnd
	mov	rcx,qword [imports_hFont]
	call	[DeleteObject]

	xor	edx,edx
	mov	rcx,r12			; hWnd
	call	[EndDialog]
	jmp	DlgProc0D_ReturnTrue

DlgProc0D_NOTIFY:
	cmp	[r9 + NM_LISTVIEW64.hdr.code],NM_DBLCLK
	jnz	DlgProc0D_ReturnFalse
	mov	r15d,[r9 + NM_ITEMACTIVATE64.iItem]

; RCX handle of window owning SysListView32
	lea	rdi,[tmp_buf]
	cld
	mov	al,0Dh
	stosb
	mov	al,0Ah
	stosb
	mov	al,'['
	stosb

	mov	edx,ID_Dialog0DSysListView0
;	mov	rcx,qword [rsp + 8*(4+8+6)]	; not necessary, RCX wasn't destroyed yet
	call	qword [GetDlgItem]
	mov	rbx,rax				; handle of SysListView32

	and	[rsp+8*4 + LV_ITEM64.iSubItem],0
	mov	[rsp+8*4 + LV_ITEM64.cchTextMax],SysListView_cchTextMax
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.pszText],rdi
	mov	r8d,r15d			;iItem
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,rbx
	call	qword [SendMessageA]
	inc	[rsp+8*4 + LV_ITEM64.iSubItem]
	add	rdi,rax				; point to 0-terminator of the received string

	cld
	mov	al,']'
	stosb
	mov	al,'='
	stosb

;	mov	[rsp+8*4 + LV_ITEM64.iSubItem],0
;	mov	[rsp+8*4 + LV_ITEM64.cchTextMax],SysListView_cchTextMax
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.pszText],rdi
	mov	r8d,r15d			;iItem
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,rbx
	call	qword [SendMessageA]
	inc	[rsp+8*4 + LV_ITEM64.iSubItem]
	add	rdi,rax				; point to 0-terminator of the received string

	mov	al,0				; 0-terminator, may be overwritten to '='
	cld
	stosb

	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.pszText],rdi
	mov	r8d,r15d			;iItem
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,rbx
	call	qword [SendMessageA]
	mov	byte [rdi+rax*1],0		; 0-terminator
	or	eax,eax
	mov	cl,'='
	cmovnz	eax,ecx
	mov	[rdi-1],al

	lea	rax,[tmp_buf]
	call	msg_to_LogEdit

	jmp	DlgProc0D_ReturnTrue


align 16
CMD_IMPORTS:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc04]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog04
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
DlgProc04:
	push	rcx rdx rbx rsi rdi r8 r9
	sub	rsp,8*(4+8)
if sizeof.LV_ITEM64 > 8*8
Increase stack frame size of DlgProc04
end if
	cmp	edx,WM_INITDIALOG
	jz	DlgProc04_InitDialog
	cmp	edx,WM_NOTIFY
	jz	DlgProc04_NOTIFY
	cmp	edx,WM_COMMAND
	jnz	DlgProc04_ReturnFalse
	cmp	r8d,CBN_SELCHANGE*10000h + ID_Dialog04ComboBox0
	jz	DlgProc04_ComboBox0Change
	cmp	r8w,ID_Dialog04Button0
	jz	DlgProc04_Done
DlgProc04_ReturnFalse:
	xor	eax,eax
DlgProc04_Return:
	add	rsp,8*(4+8)
	pop	r9 r8 rdi rsi rbx rdx rcx
	ret

DlgProc04_InitDialog:
	mov	ebx,MaxNumberOfModulesInfo
	mov	rdi,qword [module_info_address]	; data of executable process image is everytime 1st
DlgProc04_start_scan_module_names:
	mov	ecx,ebx
	xor	eax,eax
	repz scasq
	jnz	DlgProc04_start_scan_module_names_L3
	jrcxz	DlgProc04_start_scan_module_names_done
DlgProc04_start_scan_module_names_L3:
	mov	ebx,ecx
	cmp	dword [rdi-8 + 24*MaxNumberOfModulesInfo + 4],flag_module_DLL
	jnz	DlgProc04_start_scan_module_names	; we are interested in DLL only
	mov	r8,qword [rdi-8 + 16*MaxNumberOfModulesInfo]	; module info
	or	r8,r8					; isn't it empty ?
	jz	DlgProc04_start_scan_module_names

	mov	eax,dword [r8+1*4]			; NumberOfFunctions
	lea	rcx,[r8+rax*8 + 2*4]			; 2*4 info header size

DlgProc04_InitDialog_fill_combo_box:
	mov	qword [rsp + 8*(4+0)],rcx
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_Dialog04ComboBox0
	mov	rcx,[rsp + 8*(4+8+6)]
	call	qword [SendDlgItemMessageA]

DlgProc04_skip_ComboBox0_add_string:
	jmp	DlgProc04_start_scan_module_names

DlgProc04_start_scan_module_names_done:
	mov	rax,qword [hInstance]		; raw encoded this may be 400000h or 100000000h
	mov	rcx,qword [rsp + 8*(4+8+6)]	; hWnd
	and	qword [rsp + 8*(4+7)],0		; pointer to window-creation data
	mov	qword [rsp + 8*(4+6)],rax	; hInst  handle to application instance
	mov	qword [rsp + 8*(4+5)],ID_Dialog04SysListView0	; handle to menu, or child-window identifier
	mov	qword [rsp + 8*(4+4)],rcx
	mov	dword [rsp + 8*(4+3)],450	; height
	mov	dword [rsp + 8*(4+2)],418	; width
	mov	dword [rsp + 8*(4+1)],32	; vertical position of window
	mov	dword [rsp + 8*(4+0)],3		; horizontal position of window
	mov	r9d,WS_CHILD or WS_VISIBLE or WS_TABSTOP or LVS_REPORT or LVS_SHAREIMAGELISTS	; window style
	xor	r8,r8				; pointer to window name
	lea	rdx,[SysListView32ClassName]	; pointer to registered class name
	mov	ecx,WS_EX_CLIENTEDGE		; extended window style
	call	qword [CreateWindowExA]
	mov	rsi,rax

	mov	r9,LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_GRIDLINES; or LVS_EX_SUBITEMIMAGES		; lParam
	xor	r8,r8
	mov	edx,LVM_SETEXTENDEDLISTVIEWSTYLE
	mov	rcx,rsi
	call	qword [SendMessageA]

	lea	rcx,[imports_ListView_font]
	call	qword [CreateFontIndirectA]
	mov	qword [imports_hFont],rax

	mov	r9,1				; lParam redraw flag
	mov	r8,rax				; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,rsi
	call	qword [SendMessageA]

DlgProc04_InitDialog_columns_L0:
if LVCFMT_LEFT = 0
  if (LV_COLUMN64.fmt - LV_COLUMN64.mask) = 4
	mov	qword [rsp+8*4 + LV_COLUMN64.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
  else
	mov	dword [rsp+8*4 + LV_COLUMN64.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH	; fmt, iSubItem, pszText, cx member are valid.
	mov	dword [rsp+8*4 + LV_COLUMN64.fmt],LVCFMT_LEFT
  end if
end if
	lea	rcx,[rsp+8*(4+6)]
	mov	rax,'API name'
	mov	byte [rcx+8],0
	mov	qword [rcx],rax

	lea	r9,[rsp + 8*(4+0)]
	mov	[r9 + LV_COLUMN64.cx],290	; Specifies the width, in pixels, of the column.
	mov	[r9 + LV_COLUMN64.pszText],rcx
	and	[r9 + LV_COLUMN64.iSubItem],0
	xor	r8,r8				; column number
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rsi
	call	qword [SendMessageA]

	mov	rax,'address'
	mov	qword [rsp+8*(4+6)],rax
	lea	r9,[rsp + 8*(4+0)]
	mov	[r9 + LV_COLUMN64.cx],data_column_size
	mov	[r9 + LV_COLUMN64.iSubItem],1
	mov	r8d,1				; column number
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rsi
	call	qword [SendMessageA]

	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9				; show first
	mov	r8d,CB_SETCURSEL
	mov	edx,ID_Dialog04ComboBox0
	mov	rcx,qword [rsp + 8*(4+8+6)]	; hWnd
	call	qword [SendDlgItemMessageA]

	xor	r9,r9
	mov	r8,CBN_SELCHANGE*10000h + ID_Dialog04ComboBox0
	mov	edx,WM_COMMAND
	mov	rcx,qword [rsp + 8*(4+8+6)]	; hWnd
	call	qword [PostMessageA]		; we can't use SendMessage because initdialog isn't finished - we can only PostMessage

DlgProc04_ReturnTrue:
	mov	eax,1
	jmp	DlgProc04_Return

DlgProc04_Done:
	mov	rcx,qword [imports_hFont]
	call	qword [DeleteObject]

	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+8+6)]	; hWnd
	call	qword [EndDialog]
	jmp	DlgProc04_ReturnTrue

DlgProc04_NOTIFY:
;pnmv	Pointer to an NM_LISTVIEW structure. The iItem member is  - 1, and the iSubItem member identifies the column. All other members are zero.
	cmp	[r9 + NM_LISTVIEW64.hdr.code],NM_DBLCLK
	jz	Dialog04SysListView0_DBLCLK
	cmp	[r9 + NM_LISTVIEW64.hdr.code],LVN_COLUMNCLICK
	jnz	DlgProc04_ReturnFalse
	cmp	[r9 + NM_LISTVIEW64.iItem],-1
	jnz	DlgProc04_ReturnFalse

	mov	r8d,dword [r9+NM_LISTVIEW64.iSubItem]	; which collumn was clicked ? 0='API name' , 1='address'
						; this value is sent to the ListViewSort_proc like lParamSort
	mov	rcx,[r9+NM_LISTVIEW64.hdr.hwndFrom]	; Dialog04SysListView handle
	mov	edx,LVM_SORTITEMS
	lea	r9,[ListViewSort_proc]
	mov	qword [hSysListView32Dlg04],rcx
	call	qword [SendMessageA]
	jmp	DlgProc04_ReturnTrue

ListViewSort_proc:
; RCX=lParam1 RDX=lParam2 R8=lParamSort
a=1	; return address

	push	rcx rdx rbx rsi rdi r8 r9 r10 r11
b=9	; number of pushed registers

d=(SysListView_cchTextMax+15)/16
e=(SysListView_cchTextMax+15)/16

if sizeof.LV_FINDINFO64 < sizeof.LV_ITEM64
f=(sizeof.LV_ITEM64+7)/8
else
f=(sizeof.LV_FINDINFO64+7)/8
end if

g=4	; number of qwords reserved for API

c=(a+b+d+e+f+g) and 1	; alignment at dqword

	sub	rsp,8*(g+f+e+d+c)

	lea	r9,[rsp+8*g]
	mov	rcx,qword [rsp+8*(g+f+e+d+c+8)]	; grab lParam1 from the stack
	mov	[r9+LV_FINDINFO64.flags],LVFI_PARAM
	mov	[r9+LV_FINDINFO64.lParam],rcx
	or	r8d,-1
	mov	edx,LVM_FINDITEM
	mov	rcx,qword [hSysListView32Dlg04]
	call	qword [SendMessageA]

	mov	r8,qword [rsp+8*(g+f+e+d+c+3)]	; grab lParamSort from the stack
	lea	r9,[rsp + 8*g]			; point to LV_ITEM64 in the stack
	lea	rdx,[rsp + 8*(g+f)]		; point to Buff0
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	mov	[r9 + LV_ITEM64.iSubItem],r8d	; we will get subitems from collumn No.
	mov	[r9 + LV_ITEM64.pszText],rdx
	mov	[r9 + LV_ITEM64.cchTextMax],SysListView_cchTextMax
	mov	r8d,eax				; iItem
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,qword [hSysListView32Dlg04]
	call	qword [SendMessageA]
; get 0-terminated string, return in RAX its size without 0-terminator
	mov	ebx,eax

	lea	r9,[rsp+8*g]
	mov	rcx,qword [rsp+8*(g+f+e+d+c+7)]	; grab lParam2 from the stack
	mov	[r9+LV_FINDINFO64.flags],LVFI_PARAM
	mov	[r9+LV_FINDINFO64.lParam],rcx
	or	r8d,-1
	mov	edx,LVM_FINDITEM
	mov	rcx,qword [hSysListView32Dlg04]
	call	qword [SendMessageA]

	mov	r8,qword [rsp+8*(g+f+e+d+c+3)]	; grab lParamSort from the stack
	lea	r9,[rsp + 8*g]			; point to LV_ITEM64 in the stack
	lea	rdx,[rsp + 8*(g+f+e)]		; point to Buff1
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	mov	[r9 + LV_ITEM64.iSubItem],r8d	; we will get subitems from collumn No.
	mov	[r9 + LV_ITEM64.pszText],rdx
	mov	[r9 + LV_ITEM64.cchTextMax],SysListView_cchTextMax
	mov	r8d,eax				; lParam2 = iItem
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,qword [hSysListView32Dlg04]
	call	qword [SendMessageA]
; get 0-terminated string, return in RAX its size without 0-terminator
	mov	ecx,eax

; compare strings' sizes, get smaller of them
	cmp	ebx,ecx
	cmovc	ecx,ebx
	mov	eax,SysListView_cchTextMax
	inc	ecx				; include zero-terminator in string
	cmp	eax,ecx
	cmovc	ecx,eax				; but don't exceed string size limit after inc ecx

	lea	rsi,[rsp+8*(g+f+e)]
	lea	rdi,[rsp+8*(g+f)]
	cld
	repz cmpsb

	setz	bl
	setc	dl
	lea	ecx,[rbx+rdx*2]			; cl = bl + dl*2
	movzx	eax,cl
	dec	eax
;	movsxd	rax,eax				; seems not necessary
; eax=0 if strings equal
; eax=-1 if ... string less than ...
; eax=+1 if ... string greather than ...

	add	rsp,8*(g+f+e+d+c)
	pop	r11 r10 r9 r8 rdi rsi rbx rdx rcx
	ret

DlgProc04_ComboBox0Change:
	and	qword [rsp+8*4],0
	xor	r9,r9
	mov	r8d,LVM_DELETEALLITEMS
	mov	edx,ID_Dialog04SysListView0
	mov	rcx,qword [rsp + 8*(4+8+6)]	; hWnd
	call	qword [SendDlgItemMessageA]

;	mov	qword [rsp+8*4],0		; unnecessary to do it again
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog04ComboBox0
	mov	rcx,qword [rsp + 8*(4+8+6)]	; hWnd
	call	qword [SendDlgItemMessageA]

	mov	edx,eax				; save zero-based index of selected (0=first, 1=second, ...)

	mov	ecx,MaxNumberOfModulesInfo
	mov	rdi,qword [module_info_address]	; data of executable process image is everytime 1st
	xor	eax,eax
	cld
DlgProc04_ComboBox0Change_start_scan_module_names:
	repz scasq
	cmp	dword [rdi-8 + 24*MaxNumberOfModulesInfo + 4],flag_module_DLL
	jnz	DlgProc04_ComboBox0Change_start_scan_module_names	; we are interested in DLL only
	dec	edx
	jns	DlgProc04_ComboBox0Change_start_scan_module_names	; jns because zero-based index

	lea	rsi,[rdi-8]			; point to begin of last scasq

; this is unnecessary since mov qword [rsp+8*4],0 iItem=dword [rsp+8*4 + 4]
;	mov	[rsp+8*4 + LV_ITEM64.iItem],0	; index of displayed item in SysListView32, will be updated at end

DlgProc04_listview_fill_L3:
	mov	r8,qword [rsi]			; module base
	mov	r9,qword [rsi + 16*MaxNumberOfModulesInfo]	; module info
	or	r9,r9
	jz	DlgProc04_ReturnTrue		; Empty ? Then we don't display anything.

; r9 points now to the module_info structure
; 0*4	dword size of allocated memory
; 1*4	dword NumberOfFunctions=NumberOfNames
; NumberOfFunctions*4 RVA of Functions
; NumberOfNames*4 RVA of Names
; ModuleName
; NumberOfFunctions times FunctionName
	mov	r10d,dword [r9+1*4]		; NumberOfFunctions
	or	r10,r10
	jz	DlgProc04_ComboBox0Change_done	; windows 2008 server R2 x64 PROFAPI.DLL
	lea	r11,[r9+8+r10*4]		; point to RVA of Names

	mov	eax,[rsp+8*4 + LV_ITEM64.iItem]	; index of displayed item in SysListView32, will be updated at end
	mov	[rsp+8*4 + LV_ITEM64.lParam],rax
	mov	ecx,dword [r9+8+rax*4]		; grab RVA address
	mov	edx,dword [r11+rax*4]		; grab RVA name
	lea	rax,[r8 + rcx]			; add it to module base
	lea	rdi,[tmp_buf]
	call	hexa_64_rax
	mov	byte [rdi+16],0

	lea	rax,[r9 + rdx*1]
	mov	qword [rsp+8*4 + LV_ITEM64.pszText],rax	; 0-terminated string of API name

	mov	edx,ID_Dialog04SysListView0
	mov	rcx,qword [rsp + 8*(4+8+6)]
	call	qword [GetDlgItem]
	mov	rbx,rax

	mov	[rsp+8*4 + LV_ITEM64.mask],LVIF_TEXT or LVIF_PARAM
	and	[rsp+8*4 + LV_ITEM64.iSubItem],0
	lea	r9,[rsp+8*4]
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,rbx
	call	qword [SendMessageA]

	mov	[rsp+8*4 + LV_ITEM64.mask],LVIF_TEXT
	lea	r9,[rsp+8*4]
	lea	rax,[tmp_buf]
	inc	dword [r9 + LV_ITEM64.iSubItem]
	mov	qword [r9 + LV_ITEM64.pszText],rax
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,rbx
	call	qword [SendMessageA]

	mov	eax,[rsp+8*4 + LV_ITEM64.iItem]
	inc	eax
if (LV_ITEM64.iSubItem - LV_ITEM64.iItem) = 4
; high dword of rax=0 now, so we set both dwords by 1 instruction
	mov	qword [rsp+8*4 + LV_ITEM64.iItem],rax
else
	mov	[rsp+8*4 + LV_ITEM64.iItem],eax
	and	[rsp+8*4 + LV_ITEM64.iSubItem],0
end if
	mov	rcx,qword [rsi+16*MaxNumberOfModulesInfo]	; module info
	cmp	dword [rcx+1*4],eax		; NumberOfFunctions
	jnbe	DlgProc04_listview_fill_L3

DlgProc04_ComboBox0Change_done:
; LVM_SORTITEMS isn't necessary, because DLL has to have API names sorted alphabeticaly

	jmp	DlgProc04_ReturnTrue

Dialog04SysListView0_DBLCLK:
; RCX handle of window owning SysListView32
	lea	rdi,[tmp_buf+2]
	mov	esi,[r9 + NM_ITEMACTIVATE64.iItem]
	mov	word [rdi-2],0A0Dh

	mov	edx,ID_Dialog04SysListView0
;	mov	rcx,qword [rsp + 8*(4+8+6)]	; not necessary, RCX wasn't destroyed yet
	call	qword [GetDlgItem]
	mov	rbx,rax				; handle of SysListView32

	and	[rsp+8*4 + LV_ITEM64.iSubItem],0
	mov	[rsp+8*4 + LV_ITEM64.pszText],rdi
	mov	[rsp+8*4 + LV_ITEM64.cchTextMax],SysListView_cchTextMax
	lea	r9,[rsp+8*4]
	mov	r8d,esi				;iItem
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,rbx
	call	qword [SendMessageA]
	lea	rdi,[rdi+rax*1+1]		; point after received 0-terminated string

	mov	byte [rdi-1],' '		; change 0-terminator to the space between 2 texts

	mov	[rsp+8*4 + LV_ITEM64.iSubItem],1
	mov	[rsp+8*4 + LV_ITEM64.pszText],rdi
	mov	[rsp+8*4 + LV_ITEM64.cchTextMax],16+1	; ascii address has 16 bytes, +1 for 0-terminator
	lea	r9,[rsp+8*4]
	mov	r8d,esi				;iItem
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,rbx
	call	qword [SendMessageA]
;	mov	byte [rdi+rax*1],0	; 0-terminator, not necessary, API does it allways

	lea	rax,[tmp_buf]
	call	msg_to_LogEdit
	jmp	DlgProc04_ReturnTrue

align 16
CMD_SYMBOLS:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc0A]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog0A
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
DlgProc0A:
	push	rbx rbp rsi rdi rcx rdx r8 r9
	sub	rsp,8*(4+7)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc0A_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc0A_ReturnFalse
;	cmp	r8d,BN_CLICKED*10000h + ID_Dialog0AAutoCheckBox0
;	jz	DlgProc0A_AutoCheckBox0Clicked
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog0AEditText0
	jz	DlgProc0A_EditText0Change
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog0AEditText1
	jz	DlgProc0A_EditText1Change
	cmp	r8w,ID_Dialog0AButton0
	jz	DlgProc0A_Search
	cmp	r8w,ID_Dialog0AButton1
	jz	DlgProc0A_Abandon
DlgProc0A_ReturnFalse:
	xor	eax,eax
DlgProc0A_Return:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx rdi rsi rbp rbx
	ret

DlgProc0A_InitDialog:
	and	qword [rsp + 8*(4+0)],0
	mov	r9d,BST_CHECKED
	mov	r8d,BM_SETCHECK
	mov	edx,ID_Dialog0AAutoCheckBox0
;	mov	rcx,qword [rsp + 8*(4+7+3)]		; RCX=hWnd, wasn destroyed yet
	call	qword [SendDlgItemMessageA]
	jmp	DlgProc0A_ReturnTrue

DlgProc0A_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [EndDialog]

DlgProc0A_ReturnTrue:
	mov	eax,1
	jmp	DlgProc0A_Return

DlgProc0A_EditText0Change:
	call	DlgProc0A_invert_Edits
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	DlgProc0A_change_Button0_state
	jmp	DlgProc0A_ReturnTrue

DlgProc0A_EditText1Change:
	call	DlgProc0A_invert_Edits
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	DlgProc0A_change_Button0_state
	jmp	DlgProc0A_ReturnTrue

DlgProc0A_Search:
	mov	rbx,rcx

; prepare clean buffer
	lea	rax,[symbols_buf]
	mov	qword [symbols_buf_end_pointer],rax
	mov	byte [rax],0

; try to get something from ID_Dialog0AEditText0 or ID_Dialog0AEditText1
	xor	esi,esi			; no ID_Dialog0AEditText0
	lea	rdi,[sym_name_buf]
	mov	r9d,MAX_SYM_NAME+1	; get MAX_SYM_NAME chars from Edit control + 1 for 0-terminator
	lea	r8,[rdi]
	mov	edx,ID_Dialog0AEditText1
;	mov	rcx,rbx
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog0AEditText0
	cmovz	rdi,rax
	jnz	DlgProc0A_Search_L0

	xor	edi,edi			; no ID_Dialog0AEditText1
	lea	rsi,[rsp+8*(4+0)]
	mov	r9d,40			; enough for 16 chars of ascii hexa qword + 1 for 0-terminator
	lea	r8,[rsi]
	mov	edx,ID_Dialog0AEditText0
	mov	rcx,rbx
	call	qword [GetDlgItemTextA]
	or	eax,eax
	jz	DlgProc0A_ReturnTrue
	call	ascii2hexa_qword
	jc	DlgProc0A_ReturnTrue
	mov	qword [rsi],rdx		; store result

DlgProc0A_Search_L0:
; check if ID_Dialog0AAutoCheckBox0 checked
	mov	edx,ID_Dialog0AAutoCheckBox0
	mov	rcx,rbx
	call	qword [IsDlgButtonChecked]
	or	eax,eax
	jz	DlgProc0A_Search_specific

DlgProc0A_Search_everything:
	xor	edx,edx				; counter
DlgProc0A_Search_everything_L0:
	lea	ecx,[rdx+SymbolIndexFirst]
	call	search_ms_symbol_index
	jc	DlgProc0A_Search_everything_L1
	call	append_symbol_buf
DlgProc0A_Search_everything_L1:
	inc	edx
	cmp	edx,MaxNumberOfModulesInfo
	jc	DlgProc0A_Search_everything_L0
	lea	r8,[symbols_buf]
	mov	edx,ID_Dialog0AEditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SetDlgItemTextA]
	jmp	DlgProc0A_ReturnTrue

DlgProc0A_Search_specific:
	mov	rbx,qword [module_info_address]
	xor	edx,edx				; counter
	mov	eax,dword [last_PID]
DlgProc0A_Search_specific_L0:
	cmp	dword [rbx+24*MaxNumberOfModulesInfo+rdx*8],eax
	jnz	DlgProc0A_Search_specific_L1
	lea	ecx,[rdx+SymbolIndexFirst]
	call	search_ms_symbol_index
	jc	DlgProc0A_Search_specific_L1
	call	append_symbol_buf
DlgProc0A_Search_specific_L1:
	inc	edx
	cmp	edx,MaxNumberOfModulesInfo
	jc	DlgProc0A_Search_specific_L0
	lea	r8,[symbols_buf]
	mov	edx,ID_Dialog0AEditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SetDlgItemTextA]
	jmp	DlgProc0A_ReturnTrue

search_ms_symbol_index:
; in:	ECX index
;	RSI pointer to qword holding address or NULL if nothing
;	RDI pointer to symbol name or NULL if nothing
; out:	CF=0 if success, CF=1 if failure
;	R8D=displacement for Name if CF=0
;	R9D=displacement for Line if CF=0
	push	rax rcx rdx rsi rdi r8 r9 r10 r11
	sub	rsp,8*(4+4)

;	mov	rax,rsi
;	or	rax,rdi
;	jz	search_ms_symbol_index_fail

	lea	r9,[sym_buf]
	mov	[r9+SYMBOL_INFO64.SizeOfStruct],sizeof.SYMBOL_INFO64
	mov	[r9+SYMBOL_INFO64.MaxNameLen],MAX_SYM_NAME
	and	[r9+SYMBOL_INFO64.Address],0
	and	[r9+SYMBOL_INFO64.Name],0
	and	[sym_buf.NameLen],0
	or	rsi,rsi
	jz	search_ms_symbol_index_L0
	mov	rdx,qword [rsi]		; address
	lea	r8,[rsp+8*(4+0)]	; displacement, the difference from real address
	call	qword [SymFromAddr]
	or	eax,eax
	stc				; failure
	jz	search_ms_symbol_index_epi
	mov	esi,dword [rsp+8*(4+0)]
	jmp	search_ms_symbol_index_success

search_ms_symbol_index_L0:
; rsi=0
;	xor	esi,esi			; displacement for address = 0
	or	rdi,rdi
	stc
	jz	search_ms_symbol_index_epi
	lea	r8,[sym_buf]
	lea	rdx,[rdi]		; pointer to the string
	call	qword [SymFromName]
	xor	edi,edi			; displacement for line = 0
	or	eax,eax
	stc				; failure
	jz	search_ms_symbol_index_epi

search_ms_symbol_index_success:
	lea	r9,[sym_line_buf]
	lea	r8,[rsp+8*(4+0)]			; displacement
	mov	rdx,[sym_buf.Address]			; get pure address (without displacement)
	mov	[r9+IMAGEHLP_LINE64.SizeOfStruct],sizeof.IMAGEHLP_LINE64
	and	[r9+IMAGEHLP_LINE64.FileName],0
	mov	[r9+IMAGEHLP_LINE64.Address],rdx
	and	dword [r8],0
	mov	ecx,dword [rsp+8*(4+4+7)]		; grab ECX from the stack
	call	qword [SymGetLineFromAddr64]
;	or	eax,eax
	mov	edi,dword [rsp+8*(4+0)]	; displacement

	mov	qword [rsp+8*(4+4+3)],rsi; put displacement into the stack into R8 register
	mov	qword [rsp+8*(4+4+2)],rdi; put displacement into the stack into R9 register
	clc				; success

search_ms_symbol_index_epi:
	lea	rsp,[rsp+8*(4+4)]	; this doesn't touch carry flag instead of add rsp,...
	pop	r11 r10 r9 r8 rdi rsi rdx rcx rax
	ret

align 16
append_symbol_buf:
; in:	EDX index
;	sym_buf
;	sym_line_buf
;	r8d displacement for address
;	r9d displacement for line
	push	rax rcx rdx rsi rdi r8 r9 r10 r11
	sub	rsp,8*(4+0)

	mov	rdi,qword [symbols_buf_end_pointer]
	cld

;	lea	rax,[sym_buf]
;	lea	rsi,[rax+SYMBOL_INFO64.Name]
;	mov	ecx,[rax+SYMBOL_INFO64.NameLen]	; older versions of dbghelp.dll don't fill NameLen
;	repz movsb
	lea	rsi,[sym_buf.Name]
	call	fast_move_0_terminated_string

; displacement
	mov	ecx,dword [rsp+8*(4+0+3)]	; displacement
	jrcxz	append_symbol_buf_L0
	mov	al,'+'
	stosb
	mov	eax,ecx
	call	hexa_32_eax
	lea	rdi,[rdi+9]
	mov	byte [rdi-1],'h'
append_symbol_buf_L0:

	mov	al,' '
	stosb

	lea	rsi,[sym_buf]

	mov	rax,'Address='
	stosq

	mov	rax,[rsi+SYMBOL_INFO64.Address]
	add	rax,rcx			; add displacement
	call	hexa_64_rax
	lea	rdi,[rdi+18]
	mov	word [rdi-2],'h '

	mov	eax,'PID='
	stosd
	mov	rcx,qword [module_info_address]
	mov	eax,dword [rcx+24*MaxNumberOfModulesInfo+rdx*8]
	call	hexa_32_eax
	lea	rdi,[rdi+10]
	mov	word [rdi-2],'h '

	lea	rsi,[sym_buf]

	mov	rax,'ModBase='
	stosq
	mov	rax,[rsi+SYMBOL_INFO64.ModBase]
	call	hexa_64_rax
	lea	rdi,[rdi+16]

	mov	rax,'h Flags='
	stosq
	mov	eax,[rsi+SYMBOL_INFO64.Flags]
	call	hexa_32_eax
	lea	rdi,[rdi+8]

	mov	rax,'h Value='
	stosq
	mov	rax,[rsi+SYMBOL_INFO64.Value]
	call	hexa_64_rax
	lea	rdi,[rdi+16]

	mov	rax,'h Regist'
	stosq
	mov	eax,'er='
	stosd
	dec	rdi
	mov	eax,[rsi+SYMBOL_INFO64.Register]
	call	hexa_32_eax
	lea	rdi,[rdi+11]
	mov	dword [rdi-3],'h'+0A0D00h		; make 0-terminator too

; Line info:
	mov	rsi,[sym_line_buf.FileName]
	or	rsi,rsi
	jz	append_symbol_buf_L9
	call	fast_move_0_terminated_string

	mov	rax,' LineNum'
	stosq
	mov	eax,'ber='
	stosd

	mov	eax,[sym_line_buf.LineNumber]
	call	dword_decimal_ascii

	or	ecx,-1
	xor	eax,eax
	repnz scasb
;	mov	byte [rdi-1],'d'	; decimal symbol
;	mov	al,' '
;	stosb
	mov	byte [rdi-1],' '

	mov	rax,'FirstIns'
	stosq
	mov	rax,'truction'
	stosq
	mov	rax,'Address='
	stosq

	mov	rax,[sym_line_buf.Address]
	call	hexa_64_rax
	lea	rdi,[rdi+16]

	mov	eax,'h'+0A0D00h		; make 0-terminator too
	stosd
	dec	rdi

;	mov	byte [rdi],0		; 0-terminator, done since last stosd

append_symbol_buf_L9:
	mov	qword [symbols_buf_end_pointer],rdi

	add	rsp,8*(4+0)
	pop	r11 r10 r9 r8 rdi rsi rdx rcx rax
	ret

align 16
DlgProc0A_change_Button0_state:
	push	rbx rsi
	sub	rsp,8*(4+1)
	mov	rbx,rcx			; handle of window owning controls

	mov	r9d,2			; get 1 char from Edit control + 1 for 0-terminator
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog0AEditText0
	mov	rcx,rbx
	call	qword [GetDlgItemTextA]
	mov	esi,eax			; API returns eax=0 if nothing in ID_Dialog0AEditText0
; disable window	= 0
; enable window		= 1

	mov	r9d,2
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog0AEditText1
	mov	rcx,rbx
	call	qword [GetDlgItemTextA]
	or	esi,eax

	mov	edx,ID_Dialog0AButton0
	mov	rcx,rbx
	call	qword [GetDlgItem]
	mov	edx,esi			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

	add	rsp,8*(4+1)
	pop	rsi rbx
	ret

DlgProc0A_invert_Edits:
; in:	RCX hWnd handle of window owning controls
;	R8W ID_Dialog0AEditText0 (1A10h) or ID_Dialog0AEditText1 (1A11h)
	push	rbx rsi
	sub	rsp,8*(4+1)

	mov	rbx,rcx
	movzx	esi,r8w

	mov	r9d,2			; get 1 char from Edit control + 1 for 0-terminator
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,esi
	call	qword [GetDlgItemTextA]

	mov	edx,esi
	xor	dl,1			; switch to the other Edit
	mov	esi,eax			; result of previous check it there is anything in first Edit
	mov	rcx,rbx
	call	qword [GetDlgItem]
	mov	edx,esi			; disable/enable window = Edit
	xor	dl,1
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

	add	rsp,8*(4+1)
	pop	rsi rbx
	ret

align 16
CMD_FIND:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc05]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog05
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
DlgProc05:
	push	rbx rbp rsi rdi rcx rdx r8 r9
	sub	rsp,8*(4+7)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc05_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc05_ReturnFalse
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog05EditText0
	jz	DlgProc05_EditTextChange
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog05EditText1
	jz	DlgProc05_EditTextChange
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog05EditText2
	jz	DlgProc05_EditTextChange
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog05EditText3
	jz	DlgProc05_EditTextChange
	cmp	r8w,ID_Dialog05Button0
	jz	DlgProc05_string_search
	cmp	r8w,ID_Dialog05Button1
	jz	DlgProc05_hexa_search
	cmp	r8w,ID_Dialog05Button2
	jz	DlgProc05_Abandon
DlgProc05_ReturnFalse:
	xor	eax,eax
DlgProc05_Return:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx rdi rsi rbp rbx
	ret

DlgProc05_InitDialog:
	mov	rbx,qword [module_info_address]
	mov	rax,qword [rbx]
	lea	rdi,[rsp + 8*(4+0)]
	call	hexa_64_rax
	mov	byte [rdi+16],0
	lea	r8,[rdi]
	mov	edx,ID_Dialog05EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SetDlgItemTextA]

	mov	rax,qword [rbx+8*MaxNumberOfModulesInfo]
	lea	rdi,[rsp + 8*(4+0)]
	call	hexa_64_rax
	mov	byte [rdi+16],0
	lea	r8,[rdi]
	mov	edx,ID_Dialog05EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SetDlgItemTextA]

	and	qword [rsp+8*4],0
	mov	r9d,16			; text limited to 16 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog05EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	and	qword [rsp+8*4],0
	mov	r9d,16			; text limited to 16 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog05EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	and	qword [rsp+8*4],0
	mov	r9d,8			; text limited to 8 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog05EditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	and	qword [rsp+8*4],0
	mov	r9d,16			; text limited to 16 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog05EditText3
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

DlgProc05_ReturnTrue:
	mov	eax,1
	jmp	DlgProc05_Return

DlgProc05_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [EndDialog]
	jmp	DlgProc05_ReturnTrue

DlgProc05_EditTextChange:
	mov	ebx,1			; 1 = enable window
;	xor	ebx,ebx			; 0 = disable window

; check if there is something in ID_Dialog05EditText0
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog05EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog05EditText0
	cmovz	ebx,eax

; check if there is something in ID_Dialog05EditText1
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog05EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog05EditText1
	cmovz	ebx,eax

; check if there is something in ID_Dialog05EditText2
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog05EditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog05EditText2
	cmovz	ebx,eax

	mov	edx,ID_Dialog05Button0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]	; enable/disable ID_Dialog05Button0

	mov	ebx,1			; 1 = enable window
;	xor	ebx,ebx			; 0 = disable window

; check if there is something in ID_Dialog05EditText0
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog05EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog05EditText0
	cmovz	ebx,eax

; check if there is something in ID_Dialog05EditText1
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog05EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog05EditText1
	cmovz	ebx,eax

; check if there is something in ID_Dialog05EditText3
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog05EditText3
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog05EditText3
	cmovz	ebx,eax

	mov	edx,ID_Dialog05Button1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]	; enable/disable ID_Dialog05Button1

	jmp	DlgProc05_ReturnTrue

DlgProc05_string_search:
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog05EditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
;	or	rax,rax			; API returns eax=0 if nothing in ID_Dialog05EditText2
	mov	ebp,eax			; string size
	lea	rbx,[rsp + 8*(4+0)]	; pointer to string
	jmp	DlgProc05_search

DlgProc05_hexa_search:
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog05EditText3
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
;	or	eax,eax			; API returns eax=0 if nothing in ID_Dialog05EditText3
	and	al,11111110b		; truncate last exceeded char if there is any
	jz	DlgProc05_search_end
	mov	ebp,16			; we grab maximal 16 chars for 8 byte value
	cmp	ebp,eax
	cmovc	eax,ebp
	mov	ebp,eax
	shr	ebp,1			; /2 because we need 2 input chars for every byte
	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	lea	rbx,[rsp + 8*(4+0)]
	bswap	rdx
	mov	cl,8
;	sub	cl,bpl
	sub	ecx,ebp			; smaller opcode than above one
	shl	cl,3			; ecx*8
	shr	rdx,cl
	mov	qword [rbx],rdx		; store result

DlgProc05_search:
	mov	r9d,40
	lea	r8,[rsp + 8*(4+2)]
	mov	edx,ID_Dialog05EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
;	or	rax,rax			; API returns eax=0 if nothing in ID_Dialog05EditText1
	lea	rsi,[rsp + 8*(4+2)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	mov	rdi,rdx

	mov	r9d,40
	lea	r8,[rsp + 8*(4+2)]
	mov	edx,ID_Dialog05EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
;	or	rax,rax			; API returns eax=0 if nothing in ID_Dialog05EditText0
	lea	rsi,[rsp + 8*(4+2)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	mov	rsi,rdx

	call	DlgProc05_search_engine

DlgProc05_search_end:
	jmp	DlgProc05_Abandon

DlgProc05_search_engine:
; input:	rbx	string address
;		rbp	string size
;		rsi	debuggee memory to start search
;		rdi	debuggee memory to end search
	lea	rcx,[rsi+rbp*1]
	cmp	rdi,rcx			; search begin + string size is after search end ?
	jc	DlgProc05_search_engine_ret

	push	rbx rbp rsi rdi
	sub	rsp,8*(4+1)

	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	rdx,rdi
	sub	rdx,rsi			; size
	xor	ecx,ecx
	mov	rbx,rdx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	DlgProc05_search_engine_end_9
	mov	qword [rsp + 8*(4+0)],rax

; read debuggee memory
; rbx=size
	lea	rsi,[rsp + 8*(4+1+1)]
	lea	rdi,[rax]
	mov	ecx,dword [last_PID]
	call	read_debuggee_memory
	jc	DlgProc05_search_engine_end_8
	call	check_sw_bp_patch_when_necessary_after_read_memory

	sub	ebx,ebp

DlgProc05_search_engine_L0:
	mov	rsi,qword [rsp + 8*(4+1+3)]	; address with string to search
	lea	rax,[rdi]			; save rdi
	mov	ecx,ebp
	cld
	repz cmpsb
	jz	DlgProc05_search_engine_L1
	lea	rdi,[rax+1]			; rdi+1
	dec	ebx
	jnz	DlgProc05_search_engine_L0
	mov	rcx,'nothing'
	mov	qword [msg_search_result],rcx
	jmp	DlgProc05_search_engine_end_7

DlgProc05_search_engine_L1:
	sub	rax,qword [rsp + 8*(4+0)]
	add	rax,qword [rsp + 8*(4+1+1)]
	mov	qword [Data_listview_dump_start_address + 8*2],rax
	lea	rdi,[msg_search_result]
	call	hexa_64_rax
DlgProc05_search_engine_end_7:
	lea	rax,[msg_search]
	call	msg_to_LogEdit

	mov	rax,qword [Data_listview_dump_start_address + 8*2]
	mov	rcx,qword [hChildren+8*4]	; data 3rd SysListView32 handle
	mov	edx,dword [last_PID]	; process Id
	mov	r8b,byte [face.SLV04cs_type]
	call	update_data_SysListView32

DlgProc05_search_engine_end_8:
	mov	r8d,MEM_DECOMMIT
	mov	rdx,[rsp + 8*(4+1+0)]
	sub	rdx,[rsp + 8*(4+1+1)]	; size
	mov	rcx,[rsp + 8*(4+0)]	; address
	call	qword [VirtualFree]

DlgProc05_search_engine_end_9:
	add	rsp,8*(4+1)
	pop	rdi rsi rbp rbx
DlgProc05_search_engine_ret:
	ret

align 16
CMD_MEM_PAGES:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc0C]
	mov	r8,[hWndParent]
	mov	edx,ID_Dialog0C
	mov	rcx,[hInstance]
	call	[DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
DlgProc0C:
	push	rcx rdx rbx rsi rdi r8 r9 r12 r13 r14 r15

a=1				; return address from procedure
b=11				; number of pushed registers
d=(sizeof.MEMORY_BASIC_INFORMATION64+7)/8
e=(sizeof.LV_ITEM64+7)/8
f=4				; 4 qwords reserved for API
c=(a+b+d+e+f) and 1		; align stack at dqword
	sub	rsp,8*(c+d+e+f)
; the stack looks now like:
; a <- the top, return address from procedure
; b number of pushed registers
; c aligning stack at dqword (c is 0 or 1)
; d MEMORY_BASIC_INFORMATION64
; e LV_ITEM64
; f 4 qwords reserved for API
;   <- current RSP

	cmp	edx,WM_INITDIALOG
	jz	DlgProc0C_InitDialog
	cmp	edx,WM_NOTIFY
	jz	DlgProc0C_NOTIFY
	cmp	edx,WM_COMMAND
	jnz	DlgProc0C_ReturnFalse
	cmp	r8d,CBN_SELCHANGE*10000h + ID_Dialog0CComboBox0
	jz	DlgProc0C_ComboBox0Change
	cmp	r8w,ID_Dialog0CButton0
	jz	DlgProc0C_Done
DlgProc0C_ReturnFalse:
	xor	eax,eax
DlgProc0C_Return:
	add	rsp,8*(c+d+e+f)
	pop	r15 r14 r13 r12 r9 r8 rdi rsi rbx rdx rcx
	ret

DlgProc0C_InitDialog:
	xor	ebx,ebx			; processes counter
	lea	rdi,[rsp+8*(4+2)]
	mov	rsi,qword [multiprocess_multithread_support_address]
	mov	qword [rsp+8*(4+0)],rdi
	mov	eax,'PID='
	cld
	stosd
	mov	word [rdi+8],'h'	; 0-terminator too

DlgProc0C_InitDialog_fill_combo_box:
	mov	eax,dword [rsi+rbx*8]	; PID
	or	eax,eax
	jz	DlgProc0C_skip_ComboBox0_add_string
	call	hexa_32_eax
;	lea	rcx,[rdi-4]
;	mov	qword [rsp + 8*(4+0)],rcx; is done already
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_Dialog0CComboBox0
	mov	rcx,[rsp + 8*(c+d+e+f+10)]
	call	qword [SendDlgItemMessageA]

DlgProc0C_skip_ComboBox0_add_string:
	inc	ebx
	cmp	ebx,MaxProcesses
	jc	DlgProc0C_InitDialog_fill_combo_box

	mov	rax,qword [hInstance]
	mov	rcx,qword [rsp + 8*(c+d+e+f+10)]	; hWnd
	and	qword [rsp + 8*(4+7)],0		; pointer to window-creation data
	mov	qword [rsp + 8*(4+6)],rax	; hInst  handle to application instance
	mov	qword [rsp + 8*(4+5)],ID_Dialog0CSysListView0	; handle to menu, or child-window identifier
	mov	qword [rsp + 8*(4+4)],rcx
	mov	dword [rsp + 8*(4+3)],450	; height
	mov	dword [rsp + 8*(4+2)],650	; width
	mov	dword [rsp + 8*(4+1)],32	; vertical position of window
	mov	dword [rsp + 8*(4+0)],3		; horizontal position of window
	mov	r9d,WS_CHILD or WS_VISIBLE or WS_TABSTOP or LVS_REPORT or LVS_SHAREIMAGELISTS	; window style
	xor	r8,r8				; pointer to window name
	lea	rdx,[SysListView32ClassName]	; pointer to registered class name
	mov	ecx,WS_EX_CLIENTEDGE		; extended window style
	call	qword [CreateWindowExA]
	mov	rsi,rax

	mov	r9,LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_GRIDLINES; or LVS_EX_SUBITEMIMAGES		; lParam
	xor	r8,r8
	mov	edx,LVM_SETEXTENDEDLISTVIEWSTYLE
	mov	rcx,rsi
	call	qword [SendMessageA]

	lea	rcx,[imports_ListView_font]
	call	qword [CreateFontIndirectA]
	mov	qword [imports_hFont],rax

	mov	r9,1				; lParam redraw flag
	mov	r8,rax				; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,rsi
	call	qword [SendMessageA]

if LVCFMT_LEFT = 0
  if (LV_COLUMN64.fmt - LV_COLUMN64.mask) = 4
	mov	qword [rsp+8*f + LV_COLUMN64.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
  else
	mov	dword [rsp+8*f + LV_COLUMN64.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH	; fmt, iSubItem, pszText, cx member are valid.
	mov	dword [rsp+8*f + LV_COLUMN64.fmt],LVCFMT_LEFT
  end if
end if
	mov	[rsp+8*f + LV_COLUMN64.iSubItem],1;0
	lea	rdi,[Dialog0CSysListView0_data]

DlgProc0C_InitDialog_columns_L0:
	lea	r9,[rsp+8*f]
	mov	[r9 + LV_COLUMN64.pszText],rdi
	or	ecx,-1
	xor	eax,eax
	cld
	repnz scasb
	mov	eax,dword [rdi]
	scasd
	mov	[r9 + LV_COLUMN64.cx],eax	; Specifies the width, in pixels, of the column.
	mov	r8d,[r9 + LV_COLUMN64.iSubItem]	; column number
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rsi
	call	qword [SendMessageA]
	inc	[rsp+8*f + LV_COLUMN64.iSubItem]
	cmp	byte [rdi],0
	jnz	DlgProc0C_InitDialog_columns_L0

	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9				; show first
	mov	r8d,CB_SETCURSEL
	mov	edx,ID_Dialog0CComboBox0
	mov	rcx,qword [rsp + 8*(c+d+e+f+10)]	; hWnd
	call	qword [SendDlgItemMessageA]

	xor	r9,r9
	mov	r8,CBN_SELCHANGE*10000h + ID_Dialog0CComboBox0
	mov	edx,WM_COMMAND
	mov	rcx,qword [rsp + 8*(c+d+e+f+10)]	; hWnd
	call	qword [PostMessageA]		; we can't use SendMessage because initdialog isn't finished - we can only PostMessage

DlgProc0C_ReturnTrue:
	mov	eax,1
	jmp	DlgProc0C_Return

DlgProc0C_Done:
	mov	rcx,qword [imports_hFont]
	call	qword [DeleteObject]

	xor	edx,edx
	mov	rcx,qword [rsp + 8*(c+d+e+f+10)]	; hWnd
	call	qword [EndDialog]
	jmp	DlgProc0C_ReturnTrue

DlgProc0C_NOTIFY:
	cmp	[r9 + NM_LISTVIEW64.hdr.code],NM_DBLCLK
	jnz	DlgProc0C_ReturnFalse
	mov	r15d,[r9 + NM_ITEMACTIVATE64.iItem]

; RCX handle of window owning SysListView32
	lea	rdi,[tmp_buf]
	cld
	mov	al,0Dh
	stosb
	mov	al,0Ah
	stosb

	mov	edx,ID_Dialog0CSysListView0
;	mov	rcx,qword [rsp + 8*(4+8+6)]	; not necessary, RCX wasn't destroyed yet
	call	qword [GetDlgItem]
	mov	rbx,rax				; handle of SysListView32

	lea	rsi,[Dialog0CSysListView0_data]
	and	[rsp+8*4 + LV_ITEM64.iSubItem],0
	mov	[rsp+8*4 + LV_ITEM64.cchTextMax],SysListView_cchTextMax

DlgProc0C_ColumnName_L0:
	cld
	lodsb
DlgProc0C_ColumnName_L1:
	stosb
	lodsb
	cmp	al,0
	jnz	DlgProc0C_ColumnName_L1

	mov	al,'='
	stosb

	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.pszText],rdi
	mov	r8d,r15d			;iItem
	mov	edx,LVM_GETITEMTEXT
	mov	rcx,rbx
	call	qword [SendMessageA]
	inc	[rsp+8*4 + LV_ITEM64.iSubItem]
	add	rdi,rax				; point to 0-terminator of the received string
	cld
	cmp	eax,16				; returned hexa ascii qword ?
	jnz	DlgProc0C_ColumnName_L2
	mov	al,'h'
	stosb

DlgProc0C_ColumnName_L2:
	mov	al,','
	stosb

	lodsd					; skip column size
	cmp	byte [rsi],0
	jnz	DlgProc0C_ColumnName_L0

	mov	byte [rdi-1],0			; clear last ',' and make 0-terminator

	lea	rax,[tmp_buf]
	call	msg_to_LogEdit

	jmp	DlgProc0C_ReturnTrue


DlgProc0C_ComboBox0Change:
	and	qword [rsp+8*4],0
	xor	r9,r9
	mov	r8d,LVM_DELETEALLITEMS
	mov	edx,ID_Dialog0CSysListView0
	mov	rcx,qword [rsp + 8*(c+d+e+f+10)]
	call	qword [SendDlgItemMessageA]

;	mov	qword [rsp+8*4],0	; unnecessary to do it again
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog0CComboBox0
	mov	rcx,qword [rsp + 8*(c+d+e+f+10)]
	call	qword [SendDlgItemMessageA]
	cmp	eax,CB_ERR
	jz	DlgProc0C_ComboBox0Change_end

;	lea	rcx,[rsp+8*(4+2)]
;	mov	r9d,eax
;	mov	[rsp+8*(4+0)],rcx
;	mov	r8d,CB_GETLBTEXT
;	mov	edx,ID_Dialog0CComboBox0
;	mov	rcx,qword [rsp + 8*(c+d+e+f+10)]
;	call	qword [SendDlgItemMessageA]
;	cmp	eax,13			; 'PID=xxxxxxxxh'
;	jnz	DlgProc0C_ComboBox0Change_end

	lea	ecx,[rax+1]
	mov	rdi,[multiprocess_multithread_support_address]
	cld
	xor	eax,eax
DlgProc0C_ComboBox0Change_L0:
	scasq					; scan nonempty PIDs
	jz	DlgProc0C_ComboBox0Change_L0
	loop	DlgProc0C_ComboBox0Change_L0

	mov	edx,ID_Dialog0CSysListView0
	mov	rcx,[rsp + 8*(c+d+e+f+10)]
	call	[GetDlgItem]

	mov	edx,[rdi-8]			; grab the PID
	mov	rcx,rax				; handle of ID_DialogRDSysListView0
	call	disp_pages_and_attributes

DlgProc0C_ComboBox0Change_end:
	jmp	DlgProc0C_ReturnTrue


align 16
CMD_MEM_SAVE:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc06]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog06
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

align 16
DlgProc06:
	push	rbx rbp rsi rdi rcx rdx r8 r9
	sub	rsp,8*(4+7)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc06_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc06_ReturnFalse
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog06EditText0
	jz	DlgProc06_EditTextChange
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog06EditText1
	jz	DlgProc06_EditTextChange
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog06EditText2
	jz	DlgProc06_EditTextChange
	cmp	r8w,ID_Dialog06Button0
	jz	DlgProc06_SetIt
	cmp	r8w,ID_Dialog06Button1
	jz	DlgProc06_Abandon
DlgProc06_ReturnFalse:
	xor	eax,eax
DlgProc06_Return:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx rdi rsi rbp rbx
	ret

DlgProc06_InitDialog:
	and	qword [rsp+8*4],0
	mov	r9d,OFNMaxFileNameSize	; text size limit
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog06EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	and	qword [rsp+8*4],0
	mov	r9d,16			; text limited to 16 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog06EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	and	qword [rsp+8*4],0
	mov	r9d,16			; text limited to 16 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog06EditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

 	lea	rcx,[tmp_buf]
	pxor	xmm0,xmm0
	mov	rdx,qword [rsp + 8*(4+7+3)]
	mov	rax,qword [hInstance]
	mov	[rcx+OFN64.lStructSize],sizeof.OFN64
	mov	[rcx+OFN64.hwndOwner],rdx
	mov	[rcx+OFN64.hInstance],rax
	movdqa	dqword [rcx+8*4],xmm0
	movdqa	dqword [rcx+8*8],xmm0
	movdqa	dqword [rcx+8*10],xmm0
	movdqa	dqword [rcx+8*12],xmm0
	movdqa	dqword [rcx+8*14],xmm0
	lea	rdx,[FilterString_cmd_mem_save]
	lea	rax,[MemFileNameBuffer]
	mov	[rcx+OFN64.lpstrFilter],rdx
	mov	[rcx+OFN64.lpstrFile],rax
; Pointer to a buffer that contains a filename used to initialize the File Name edit control.
; The first character of this buffer must be NULL if initialization is not necessary.
	mov	byte [rax],0
	mov	[rcx+OFN64.nMaxFile],OFNMaxFileNameSize
	mov	[rcx+OFN64.Flags],OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY or OFN_DONTADDTORECENT
	call	qword [GetSaveFileNameA]
	or	eax,eax
	jz	DlgProc06_SkipSetFileName

; we set ID_Dialog06EditText0 to filename obtained by GetSaveFileName API
	lea	r8,[MemFileNameBuffer]
	mov	edx,ID_Dialog06EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SetDlgItemTextA]
DlgProc06_SkipSetFileName:
	jmp	DlgProc06_ReturnTrue

DlgProc06_EditTextChange:
; we check if ID_Dialog06EditText0 ID_Dialog06EditText1 ID_Dialog06EditText2 have a data - if they have, we enable 'Done' ID_Dialog06Button0
	mov	ebx,1			; enable window
;	xor	ebx,ebx			; 0 = disable window

	mov	esi,2			; counter, zero based, we check ID_Dialog06EditText0 - ID_Dialog06EditText2
DlgProc06_EditTextXChange_L0:
; check if it is something in ID_Dialog06EditTextX (X=0,1,2)
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	lea	edx,[rsi+ID_Dialog06EditText0]
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	rax,rax			; API returns eax=0 if nothing in Dialog16EditText0
	cmovz	rbx,rax
	dec	esi
	jns	DlgProc06_EditTextXChange_L0

	mov	edx,ID_Dialog06Button0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

DlgProc06_ReturnTrue:
	mov	eax,1
	jmp	DlgProc06_Return

DlgProc06_SetIt:
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog06EditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	jc	DlgProc06_Abandon
	mov	qword [rsp + 8*(4+5)],rdx	; size

	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog06EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	jc	DlgProc06_Abandon
	mov	qword [rsp + 8*(4+4)],rdx	; address

	mov	r9d,OFNMaxFileNameSize
	lea	r8,[MemFileNameBuffer]
	mov	edx,ID_Dialog06EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax
	jz	DlgProc06_Abandon
	lea	rcx,[MemFileNameBuffer]
;	mov	byte [rcx+rax*1],0	; make 0-terminated string, not necessary, string is 0-terminated

	and	qword [rsp+8*(4+2)],0				; hTemplateFile
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL	; dwFlagsAndAttributes
	mov	dword [rsp+8*(4+0)],CREATE_ALWAYS		; dwCreationDistribution
	xor	r9,r9						; lpSecurityAttributes
	xor	r8,r8						; dwShareMode
	mov	edx,GENERIC_WRITE				; dwDesiredAccess
	lea	rcx,[MemFileNameBuffer]				; lpFileName
	call	qword [CreateFileA]
	mov	qword [rsp + 8*(4+6)],rax	; file handle

if INVALID_HANDLE_VALUE = -1
	inc	rax
else
	cmp	rax,INVALID_HANDLE_VALUE
end if
	jz	DlgProc06_Abandon

; allocate memory
	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	rdx,qword [rsp + 8*(4+5)]	; size
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	DlgProc06_CloseHandle_Abandon
	mov	qword [rsp + 8*(4+3)],rax	; save address

; read debuggee memory
	lea	rsi,[rsp + 8*(4+4)]		; source address in debuggee = [rsi]
	mov	rdi,[rsp + 8*(4+3)]		; destination address in debugger
	mov	rbx,[rsp + 8*(4+5)]		; size of bytes
	mov	ecx,dword [last_PID]
	call	read_debuggee_memory
	jc	DlgProc06_ReleaseMemory_CloseHandle_Abandon
	call	check_sw_bp_patch_when_necessary_after_read_memory	; too slow for big MaxNumberOfBreakpoints, fast enough for big memory block over megabytes

; save
	and	qword [rsp + 8*(4+0)],0		; lpOverlapped
	lea	r9,[rsp + 8*(4+2)]		; lpNumberOfBytesWritten
	mov	r8,[rsp + 8*(4+5)]		; nNumberOfBytesToWrite
	mov	rdx,qword [rsp + 8*(4+3)]	; lpBuffer
	mov	rcx,qword [rsp + 8*(4+6)]	; hFile
	call	qword [WriteFile]
	or	eax,eax
	jz	DlgProc06_ReleaseMemory_CloseHandle_Abandon
	mov	rax,qword [rsp + 8*(4+2)]
	cmp	qword [rsp + 8*(4+5)],rax
	jnz	DlgProc06_ReleaseMemory_CloseHandle_Abandon

; inform about success...

DlgProc06_ReleaseMemory_CloseHandle_Abandon:
; release memory
	mov	r8d,MEM_DECOMMIT
	mov	rdx,qword [rsp + 8*(4+5)]	; size
	mov	rcx,qword [rsp + 8*(4+3)]	; save address
	call	qword [VirtualFree]

DlgProc06_CloseHandle_Abandon:
	mov	rcx,qword [rsp + 8*(4+6)]	; hFile
	call	qword [CloseHandle]

DlgProc06_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [EndDialog]
	jmp	DlgProc06_ReturnTrue

CMD_MEM_LOAD:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc07]
	mov	r8,qword [hWndParent]
	mov	edx,ID_Dialog07
	mov	rcx,qword [hInstance]
	call	[DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

DlgProc07:
	push	rbx rbp rsi rdi rcx rdx r8 r9
	sub	rsp,8*(4+7)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc07_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc07_ReturnFalse
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog07EditText0
	jz	DlgProc07_EditTextChange
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog07EditText1
	jz	DlgProc07_EditTextChange
	cmp	r8d,EN_CHANGE*10000h + ID_Dialog07EditText2
	jz	DlgProc07_EditTextChange
	cmp	r8w,ID_Dialog07Button0
	jz	DlgProc07_SetIt
	cmp	r8w,ID_Dialog07Button1
	jz	DlgProc07_Abandon

DlgProc07_ReturnFalse:
	xor	eax, eax
DlgProc07_Return:
	add	rsp,8*(4+7)
	pop	r9 r8 rdx rcx rdi rsi rbp rbx
	ret

DlgProc07_InitDialog:
	and	qword [rsp+8*4],0
	mov	r9d,OFNMaxFileNameSize	; text size limit
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog07EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	and	qword [rsp+8*4],0
	mov	r9d,16			; text limited to 16 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog07EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

	and	qword [rsp+8*4],0
	mov	r9d,16			; text limited to 16 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_Dialog07EditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SendDlgItemMessageA]

 	lea	rcx,[tmp_buf]
	pxor	xmm0,xmm0
	mov	rdx,qword [rsp + 8*(4+7+3)]
	mov	rax,qword [hInstance]
	mov	[rcx+OFN64.lStructSize],sizeof.OFN64
	mov	[rcx+OFN64.hwndOwner],rdx
	mov	[rcx+OFN64.hInstance],rax
	movdqa	dqword [rcx+8*4],xmm0
	movdqa	dqword [rcx+8*8],xmm0
	movdqa	dqword [rcx+8*10],xmm0
	movdqa	dqword [rcx+8*12],xmm0
	movdqa	dqword [rcx+8*14],xmm0
	lea	rdx,[FilterString_cmd_mem_save]
	lea	rax,[MemFileNameBuffer]
	mov	[rcx+OFN64.lpstrFilter],rdx
	mov	[rcx+OFN64.lpstrFile],rax
	mov	[rcx+OFN64.nMaxFile],OFNMaxFileNameSize
	mov	[rcx+OFN64.Flags],OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY or OFN_DONTADDTORECENT
	call	qword [GetOpenFileNameA]
	or	eax,eax
	jz	DlgProc07_SkipSetFileName

; we set ID_Dialog07EditText0 to filename obtained by GetOpenFileName API
	lea	r8,[MemFileNameBuffer]
	mov	edx,ID_Dialog07EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SetDlgItemTextA]

; file size:
	and	qword [rsp+8*(4+2)],0				; hTemplateFile
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL	; dwFlagsAndAttributes
	mov	dword [rsp+8*(4+0)],OPEN_EXISTING		; dwCreationDistribution
	xor	r9,r9						; lpSecurityAttributes
	xor	r8,r8						; dwShareMode
	mov	edx,GENERIC_READ				; dwDesiredAccess
	lea	rcx,[MemFileNameBuffer]				; lpFileName
	call	qword [CreateFileA]
	push	rax
	pop	rbx						; save file handle

if INVALID_HANDLE_VALUE = -1
	inc	rax
else
	cmp	rax,INVALID_HANDLE_VALUE
end if

	jz	DlgProc07_SkipSetFileSize

	xor	edx,edx
	push	rbx
	pop	rcx
	call	qword [GetFileSize]
	cmp	eax,-1
	jz	DlgProc07_SkipSetFileSize
	mov	esi,eax

	push	rbx
	pop	rcx
	call	qword [CloseHandle]

	mov	eax,esi
	lea	rdi,[rsp+8*(4+0)]
	call	hexa_32_eax
	mov	byte [rdi+8],0

	lea	r8,[rdi]
	mov	edx,ID_Dialog07EditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [SetDlgItemTextA]
DlgProc07_SkipSetFileSize:

DlgProc07_SkipSetFileName:
	jmp	DlgProc07_ReturnTrue

DlgProc07_EditTextChange:
; we check if ID_Dialog07EditText0 ID_Dialog07EditText1 ID_Dialog07EditText2 have a data - if they have, we enable 'Done' ID_Dialog07Button0
	mov	ebx,1			; enable window
;	xor	ebx,ebx			; 0 = disable window

	mov	esi,2			; counter, zero based, we check ID_Dialog07EditText0 - ID_Dialog07EditText2
DlgProc07_EditTextXChange_L0:
; check if it is something in ID_Dialog07EditTextX (X=0,1,2)
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	lea	edx,[rsi+ID_Dialog07EditText0]
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	rax,rax			; API returns eax=0 if nothing in Dialog16EditText0
	cmovz	rbx,rax
	dec	esi
	jns	DlgProc07_EditTextXChange_L0

	mov	edx,ID_Dialog07Button0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

DlgProc07_ReturnTrue:
	mov	eax,1
	jmp	DlgProc07_Return

DlgProc07_SetIt:
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog07EditText2
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	jc	DlgProc07_Abandon
	mov	qword [rsp + 8*(4+5)],rdx	; size

	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog07EditText1
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	jc	DlgProc07_Abandon
	mov	qword [rsp + 8*(4+4)],rdx	; address

	mov	r9d,OFNMaxFileNameSize
	lea	r8,[MemFileNameBuffer]
	mov	edx,ID_Dialog07EditText0
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [GetDlgItemTextA]
	or	eax,eax
	jz	DlgProc07_Abandon
	lea	rcx,[MemFileNameBuffer]
;	mov	byte [rcx+rax*1],0	; make 0-terminated string, not necessary, string is 0-terminated

	and	qword [rsp+8*(4+2)],0				; hTemplateFile
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL	; dwFlagsAndAttributes
	mov	dword [rsp+8*(4+0)],OPEN_EXISTING		; dwCreationDistribution
	xor	r9,r9						; lpSecurityAttributes
	xor	r8,r8						; dwShareMode
	mov	edx,GENERIC_READ				; dwDesiredAccess
	lea	rcx,[MemFileNameBuffer]				; lpFileName
	call	qword [CreateFileA]
	mov	qword [rsp + 8*(4+6)],rax	; file handle

if INVALID_HANDLE_VALUE = -1
	inc	rax
else
	cmp	rax,INVALID_HANDLE_VALUE
end if
	jz	DlgProc07_Abandon

; allocate memory
	mov	r9d,PAGE_READWRITE
	mov	r8d,MEM_COMMIT
	mov	rdx,qword [rsp + 8*(4+5)]	; size
	xor	ecx,ecx
	call	qword [VirtualAlloc]
	or	rax,rax
	jz	DlgProc07_CloseHandle_Abandon
	mov	qword [rsp + 8*(4+3)],rax	; save address

; read file
	and	qword [rsp+8*(4+0)],0		; lpOverlapped
	lea	r9,[rsp + 8*(4+2)]		; lpNumberOfBytesWritten
	mov	r8,qword [rsp + 8*(4+5)]	; nNumberOfBytesToWrite
	mov	rdx,qword [rsp + 8*(4+3)]	; lpBuffer
	mov	rcx,qword [rsp + 8*(4+6)]	; hFile
	call	qword [ReadFile]
	or	eax,eax
	jz	DlgProc07_ReleaseMemory_CloseHandle_Abandon
	mov	rax,qword [rsp+8*(4+2)]
	cmp	qword [rsp+8*(4+5)],rax
	jnz	DlgProc07_ReleaseMemory_CloseHandle_Abandon

	lea	rsi,[rsp + 8*(4+4)]		; destination address in debuggee = [rsi]
	mov	rdi,qword [rsp + 8*(4+3)]	; source address in debugger
	mov	rbx,qword [rsp + 8*(4+5)]	; size of bytes
	mov	ecx,dword [last_PID]

; set breakpoints
	call	check_sw_bp_patch_when_necessary_before_write_memory
 
; write debuggee memory
	call	write_debuggee_memory_big_area_without_verification
	jc	DlgProc07_ReleaseMemory_CloseHandle_Abandon

; inform about success...

;	mov	edx,dword [last_TID]
;	mov	eax,dword [last_PID]
;	call	display_regs_memory

DlgProc07_ReleaseMemory_CloseHandle_Abandon:
; release memory
	mov	r8d,MEM_DECOMMIT
	mov	rdx,qword [rsp + 8*(4+5)]	; size
	mov	rcx,qword [rsp + 8*(4+3)]	; save address
	call	qword [VirtualFree]

DlgProc07_CloseHandle_Abandon:
	mov	rcx,qword [rsp + 8*(4+6)]	; hFile
	call	qword [CloseHandle]

DlgProc07_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+7+3)]
	call	qword [EndDialog]

; this must be after [EndDialog], it doesn't work before [EndDialog] - it is commented above with ;
	mov	edx,dword [last_TID]
	mov	eax,dword [last_PID]
	call	display_regs_memory

	jmp	DlgProc07_ReturnTrue

; -------- RAMBO subroutines begin ----------
CMD_RAMBO_IDPF:
CMD_RAMBO_FWW:
CMD_RAMBO_TFATT:
CMD_RAMBO_CCCD:
CMD_RAMBO_FB:
CMD_RAMBO_TLSC:
CMD_RAMBO_EHP:
CMD_RAMBO_DTPA:
; note, there is a space for only 8 weapons allocated now, if you add more rambo weapons, change face.Rambo db 0, ? to dw 0
; in: RCX handle of process, or 0 for every process in IDPF, EHP
	push	rbx			; only for align stack
	movzx	ebx,r8w			; get IDM from lParam
	sub	ebx,IDM_RAMBO		; make index from IDM (0=first, 1=second, ...)
	btc	dword [face.Rambo],ebx	; only byte is used, but we must test dword
					; we have enough space reserved for 16 rambo weapons (1 byte in face.Rambo, 1 following byte is free)
					; this only changes bit (enable/disable function)
	call	update_Rambo_MainMenu	; this only changes state of menu item
	lea	rax,[Rambo_procedures]
	xor	ecx,ecx			; input param for Rambo_IsDebuggerPresent and Rambo_ExecutableHeaderPredator
	call	qword [rax+rbx*8]	; this may realy do some fight
	pop	rbx
	ret

update_Rambo_MainMenu:
	push	rbx
	sub	rsp,8*(4+10)
	mov	ebx,IDM_RAMBO_last - IDM_RAMBO
update_Rambo_MainMenu_L0:
	mov	eax,MF_ENABLED
	mov	r9d,MF_ENABLED or MF_CHECKED
	bt	dword [face.Rambo],ebx	; only byte is used, but we must test dword
	cmovc	eax,r9d
	lea	r9,[rsp + 8*(4+0)]
	mov	dword [r9 + MENUITEMINFOA64.cbSize],sizeof.MENUITEMINFOA64
	mov	dword [r9 + MENUITEMINFOA64.fMask],MIIM_STATE
	mov	dword [r9 + MENUITEMINFOA64.fState],eax
	xor	r8,r8
	lea	edx,[ebx + IDM_RAMBO]
	mov	rcx,qword [hMenu01]
	call	qword [SetMenuItemInfoA]
	dec	ebx
	jns	update_Rambo_MainMenu_L0
	add	rsp,8*(4+10)
	pop	rbx
	ret

Rambo_IsDebuggerPresent:
; in:	RCX handle of process, or 0 for every process
	cmp	qword [WeAreDebugging],0
	jz	Rambo_IsDebuggerPresent_done
	push	rcx				; only for align stack
	bt	dword [face.Rambo],IDM_RAMBO_IDPF - IDM_RAMBO
	setnc	dl
	call	FuckOff_IsDebuggerPresent
	pop	rcx
Rambo_IsDebuggerPresent_done:
	ret

Rambo_FindWindow:
	sub	rsp,8*(4+1)
	lea	rax,[msg_Rambo_FindWindow]
	call	msg_to_LogEdit
	add	rsp,8*(4+1)
	ret

Rambo_FirstBlood_find_entrypoint:
; in:	rcx handle to exe file (for reading the header and calculate entrypoint manually)
;	rdx image base to compare with data in exe header
; out:	success CF=0 rax=AddressOfEntryPoint (+rdx)
;	failure CF=1 rax unchanged (failure or input rdx match OptionalHeader.ImageBase)
	push	rcx rdx rbx rdi r8 r9 r10 r11 rax
	sub	rsp,8*(4+4)

	push	rcx
	pop	rbx				; file handle

if FILE_BEGIN = 0
	xor	r9,r9
else
	mov	r9d,FILE_BEGIN
end if

	xor	r8,r8
	xor	edx,edx
	push	rbx
	pop	rcx
	call	qword [SetFilePointer]

	lea	rdi,[tmp_buf]

	and	qword [rsp + 8*(4+0)],0		; lpOverlapped
	lea	r9,[rsp + 8*(4+2)]		; lpNumberOfBytesWritten
	mov	r8d,sizeof.IMAGE_DOS_HEADER	; nNumberOfBytesToWrite
	push	rdi
	pop	rdx				; lpBuffer
	push	rbx
	pop	rcx				; hFile
	call	qword [ReadFile]
	or	eax,eax
	jz	Rambo_FirstBlood_find_entrypoint_fail
	cmp	dword [rsp + 8*(4+2)],sizeof.IMAGE_DOS_HEADER
	jnz	Rambo_FirstBlood_find_entrypoint_fail

	cmp	[rdi+IMAGE_DOS_HEADER.e_magic],IMAGE_DOS_SIGNATURE
	jnz	Rambo_FirstBlood_find_entrypoint_fail

if FILE_BEGIN = 0
	xor	r9,r9
else
	mov	r9d,FILE_BEGIN
end if

	xor	r8,r8
	mov	edx,[rdi+IMAGE_DOS_HEADER.e_lfanew]
	push	rbx
	pop	rcx
	call	qword [SetFilePointer]
	cmp	[rdi+IMAGE_DOS_HEADER.e_lfanew],eax
	jnz	Rambo_FirstBlood_find_entrypoint_fail

	and	qword [rsp + 8*(4+0)],0		; lpOverlapped
	lea	r9,[rsp + 8*(4+2)]		; lpNumberOfBytesWritten
	mov	r8d,4 + IMAGE_SIZEOF_FILE_HEADER + 32	; nNumberOfBytesToRead
						; +4 is for IMAGE_NT_HEADERS64.Signature
						; +32 for read part of IMAGE_OPTIONAL_HEADER64 to have IMAGE_OPTIONAL_HEADER64.AddressOfEntryPoint and IMAGE_OPTIONAL_HEADER64.ImageBase
						; perhaps we can check whether IMAGE_OPTIONAL_HEADER64.ImageBase < 10000h - the main trick to defeat by this procedure
	push	rdi
	pop	rdx				; lpBuffer
	push	rbx
	pop	rcx				; hFile
	call	qword [ReadFile]
	or	eax,eax
	jz	Rambo_FirstBlood_find_entrypoint_fail
	cmp	dword [rsp + 8*(4+2)],4 + IMAGE_SIZEOF_FILE_HEADER + 32
	jnz	Rambo_FirstBlood_find_entrypoint_fail

	mov	rdx,qword [rsp+8*(4+4+7)]		; get RDX from stack
	cmp	[rdi+IMAGE_NT_HEADERS64.Signature],IMAGE_NT_SIGNATURE
	jnz	Rambo_FirstBlood_find_entrypoint_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.FileHeader.Machine],IMAGE_FILE_MACHINE_AMD64
	jnz	Rambo_FirstBlood_find_entrypoint_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.FileHeader.SizeOfOptionalHeader],IMAGE_SIZEOF_NT_OPTIONAL64_HEADER
	jnz	Rambo_FirstBlood_find_entrypoint_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.OptionalHeader.Magic],IMAGE_NT_OPTIONAL_HDR64_MAGIC
	jnz	Rambo_FirstBlood_find_entrypoint_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.OptionalHeader.ImageBase],rdx
	jnz	Rambo_FirstBlood_find_entrypoint_manually

Rambo_FirstBlood_find_entrypoint_fail:
	add	rsp,8*(4+4)
	stc
	pop	rax r11 r10 r9 r8 rdi rbx rdx rcx
	ret

Rambo_FirstBlood_find_entrypoint_manually:
	mov	eax,[rdi+IMAGE_NT_HEADERS64.OptionalHeader.AddressOfEntryPoint]
	add	rax,rdx

Rambo_FirstBlood_find_entrypoint_epi:
	add	rsp,8*(4+5)
	clc
	pop	r11 r10 r9 r8 rdi rbx rdx rcx
	ret


find_dll_entrypoint:
; in:  RCX handle to the DLL file
; out: CF=0 success, RAX=IMAGE_NT_HEADERS64.OptionalHeader.AddressOfEntryPoint, N.B. you must add the base of DLL to obtain real DLL entry point
	push	rcx rdx rbx rdi r8 r9 r10 r11 rax
	sub	rsp,8*(4+4)

	push	rcx
	pop	rbx				; file handle

if FILE_BEGIN = 0
	xor	r9,r9
else
	mov	r9d,FILE_BEGIN
end if

	xor	r8,r8
	xor	edx,edx
	push	rbx
	pop	rcx
	call	[SetFilePointer]

	lea	rdi,[tmp_buf]

	and	qword [rsp + 8*(4+0)],0		; lpOverlapped
	lea	r9,[rsp + 8*(4+2)]		; lpNumberOfBytesWritten
	mov	r8d,sizeof.IMAGE_DOS_HEADER	; nNumberOfBytesToWrite
	push	rdi
	pop	rdx				; lpBuffer
	push	rbx
	pop	rcx				; hFile
	call	[ReadFile]
	or	eax,eax
	jz	find_dll_entrypoint_fail
	cmp	dword [rsp + 8*(4+2)],sizeof.IMAGE_DOS_HEADER
	jnz	find_dll_entrypoint_fail

	cmp	[rdi+IMAGE_DOS_HEADER.e_magic],IMAGE_DOS_SIGNATURE
	jnz	find_dll_entrypoint_fail

if FILE_BEGIN = 0
	xor	r9,r9
else
	mov	r9d,FILE_BEGIN
end if

	xor	r8,r8
	mov	edx,[rdi+IMAGE_DOS_HEADER.e_lfanew]
	push	rbx
	pop	rcx
	call	[SetFilePointer]
	cmp	[rdi+IMAGE_DOS_HEADER.e_lfanew],eax
	jnz	find_dll_entrypoint_fail

	and	qword [rsp + 8*(4+0)],0		; lpOverlapped
	lea	r9,[rsp + 8*(4+2)]		; lpNumberOfBytesWritten
	mov	r8d,4 + IMAGE_SIZEOF_FILE_HEADER + 32	; nNumberOfBytesToRead
						; +4 is for IMAGE_NT_HEADERS64.Signature
						; +32 for read part of IMAGE_OPTIONAL_HEADER64 to have IMAGE_OPTIONAL_HEADER64.AddressOfEntryPoint and IMAGE_OPTIONAL_HEADER64.ImageBase
						; perhaps we can check whether IMAGE_OPTIONAL_HEADER64.ImageBase < 10000h - the main trick to defeat by this procedure
	push	rdi
	pop	rdx				; lpBuffer
	push	rbx
	pop	rcx				; hFile
	call	[ReadFile]
	or	eax,eax
	jz	find_dll_entrypoint_fail
	cmp	dword [rsp + 8*(4+2)],4 + IMAGE_SIZEOF_FILE_HEADER + 32
	jnz	find_dll_entrypoint_fail

	cmp	[rdi+IMAGE_NT_HEADERS64.Signature],IMAGE_NT_SIGNATURE
	jnz	find_dll_entrypoint_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.FileHeader.Machine],IMAGE_FILE_MACHINE_AMD64
	jnz	find_dll_entrypoint_fail
	test	[rdi+IMAGE_NT_HEADERS64.FileHeader.Characteristics],IMAGE_FILE_DLL
	jz	find_dll_entrypoint_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.FileHeader.SizeOfOptionalHeader],IMAGE_SIZEOF_NT_OPTIONAL64_HEADER
	jnz	find_dll_entrypoint_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.OptionalHeader.Magic],IMAGE_NT_OPTIONAL_HDR64_MAGIC
	jnz	find_dll_entrypoint_fail

	mov	eax,[rdi+IMAGE_NT_HEADERS64.OptionalHeader.AddressOfEntryPoint]

find_dll_entrypoint_epi:
	add	rsp,8*(4+5)
	clc
	pop	r11 r10 r9 r8 rdi rbx rdx rcx
	ret

find_dll_entrypoint_fail:
	add	rsp,8*(4+4)
	stc
	pop	rax r11 r10 r9 r8 rdi rbx rdx rcx
	ret




Rambo_TLSC:

a = 1	; return address

; rcx handle of process
; rdx module begin
;; r8 handle of thread ! no, changed, now it isn't param anymore
; NOTE !!! Procedure sets HW BP for DR2 and it overwrites DR2 if it was set before !
	push	rbx rbp rsi rdi

b = 4 ; number of pushed qwords
; c = 0 or 1 for align stack at dqword
d = (sizeof.IMAGE_DOS_HEADER + 7) / 8	; number of qwords required by local variable to allocate the structure
x = (sizeof.IMAGE_NT_HEADERS64 + 7) / 8
if x > d
d = x
end if
x = (sizeof.IMAGE_DIRECTORY_ENTRY_TLS + 7) / 8
if x > d
d = x
end if
e = 2 ; for API params
f = 4 ; reserved for API at qword [rsp+8*0]... qword [rps+8*3]
c = (a+b+d+e+f) and 1	; alignment at dqword 

	sub	rsp,8*(f+e+d+c)

	mov	rbx,rcx
;	mov	rbp,r8
	mov	rsi,rdx
	lea	rdi,[rsp+8*(f+e)]

	lea	rax,[rsp+8*(4+1)]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,sizeof.IMAGE_DOS_HEADER	; nSize
	lea	r8,[rdi]		; lpBuffer
;	mov	rdx,rdx			; lpBaseAddress
;	mov	rcx,rcx			; hProcess
	call	qword [ReadProcessMemory]
	or	eax,eax
	jz	Rambo_TLSC_fail
	cmp	dword [rsp+8*(4+1)],sizeof.IMAGE_DOS_HEADER
	jnz	Rambo_TLSC_fail

	cmp	[rdi+IMAGE_DOS_HEADER.e_magic],IMAGE_DOS_SIGNATURE
	mov	ecx,[rdi+IMAGE_DOS_HEADER.e_lfanew]
	jnz	Rambo_TLSC_fail

	lea	rax,[rsp+8*(4+1)]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	mov	r9d,sizeof.IMAGE_NT_HEADERS64	; nSize
	lea	r8,[rdi]		; lpBuffer
	lea	rdx,[rsi+rcx*1]		; lpBaseAddress
	mov	rcx,rbx			; hProcess
	call	qword [ReadProcessMemory]
	or	eax,eax
	jz	Rambo_TLSC_fail
	cmp	dword [rsp+8*(4+1)],sizeof.IMAGE_NT_HEADERS64
	jnz	Rambo_TLSC_fail

	cmp	[rdi+IMAGE_NT_HEADERS64.Signature],IMAGE_NT_SIGNATURE
	jnz	Rambo_TLSC_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.FileHeader.Machine],IMAGE_FILE_MACHINE_AMD64
	jnz	Rambo_TLSC_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.FileHeader.SizeOfOptionalHeader],IMAGE_SIZEOF_NT_OPTIONAL64_HEADER
	jnz	Rambo_TLSC_fail
	cmp	[rdi+IMAGE_NT_HEADERS64.OptionalHeader.Magic],IMAGE_NT_OPTIONAL_HDR64_MAGIC
	jnz	Rambo_TLSC_fail

	mov	r9d,[rdi+IMAGE_NT_HEADERS64.OptionalHeader.DataDirectory + (IMAGE_DIRECTORY_ENTRY_TLS * (sizeof.IMAGE_DATA_DIRECTORY)) + IMAGE_DATA_DIRECTORY.Size]
	mov	eax,(d+c)*8
	cmp	eax,ebp
	mov	ecx,[rdi+IMAGE_NT_HEADERS64.OptionalHeader.DataDirectory + (IMAGE_DIRECTORY_ENTRY_TLS * (sizeof.IMAGE_DATA_DIRECTORY)) + IMAGE_DATA_DIRECTORY.VirtualAddress]
	cmovc	r9d,eax

	lea	rax,[rsp+8*(4+1)]
	mov	qword [rsp+8*(4+0)],rax	; lpNumberOfBytesRead
	lea	r8,[rdi]		; lpBuffer
	lea	rdx,[rsi+rcx*1]		; lpBaseAddress
	mov	rcx,rbx			; hProcess
	mov	esi,r9d
	call	qword [ReadProcessMemory]
	or	eax,eax
	jz	Rambo_TLSC_fail
	cmp	dword [rsp+8*(4+1)],esi
	jnz	Rambo_TLSC_fail

;	lea	rsi,[ThreadContext]
;
;	lea	rdx,[rsi]
;	mov	dword [rdx + CONTEXT64.ContextFlags],CONTEXT_ALL
;	mov	rcx,rbp				; hThread
;	call	qword [GetThreadContext]
;	or	eax,eax
;	jz	Rambo_TLSC_fail
;
;	lea	rdx,[rsi]
;	mov	r8,[rdi+IMAGE_DIRECTORY_ENTRY_TLS.TlsCallbacks]
;	mov	eax,dword [rdx + CONTEXT64.Dr7]
;
;	mov	bl,al
;	mov	ecx,3
;Rambo_TLSC_L0:
;	test	bl,11000000b
;	jz	Rambo_TLSC_L1
;	dec	ecx
;	jns	Rambo_TLSC_L0
;	js	Rambo_TLSC_fail
;Rambo_TLSC_L1:
;
;	mov	[rdx + CONTEXT64.Dr0 + rcx*8],r8
;	mov	ebx,0FFF0FFFFh
;	shl	cl,1
;	rol	ebx,cl
;	rol	ebx,cl
;	mov	bl,11111100b
;	rol	bl,cl
;	and	eax,ebx
;;	mov	bl,1
;;	shl	bl,cl
;;	or	al,bl
;; this is faster:
;	bts	eax,ecx
;
;	mov	dword [rdx + CONTEXT64.Dr7],eax
;	mov	rcx,rbp				; hThread
;	call	qword [GetThreadContext]
;	or	eax,eax
;	jz	Rambo_TLSC_fail
;	clc
;	sub	eax,1
;
;Rambo_TLSC_epi:
;	lea	rsp,[rsp+8*(f+e+d+c)]
;	pop	rdi rsi rbp rbx
;	ret

; it is better to set it in only one thread... fdbg uses worse method in this case and usually sets the same HW BP in all threads...
	mov	r8,[rdi+IMAGE_DIRECTORY_ENTRY_TLS.TlsCallbacks]	; BP address
	mov	ecx,3
	lea	rdi,[all_thread_dr0]
	mov	eax,dword [rdi + 8*5]		; = DR7
Rambo_TLSC_L0:
	test	al,11000000b
	jz	Rambo_TLSC_L1
	dec	ecx
	jns	Rambo_TLSC_L0
	js	Rambo_TLSC_fail
Rambo_TLSC_L1:

	mov	byte [rdi-8 + rcx*1],0		; = [HW_BP_permanent + rcx*1] flag (temporary/permanent)
	mov	[rdi+rcx*8],r8			; put linear address to Debug Register DRx (x=RCX)

	lea	eax,[rcx+'0']
	mov	byte [msg_HW_BP_No_ascii],al

	mov	eax,0FFF0FFFFh
	shl	cl,1
	rol	eax,cl
	rol	eax,cl
	mov	al,11111100b
	rol	al,cl
	and	eax,dword [rdi + 8*5]
;	mov	dl,1
;	shl	dl,cl
;	or	al,dl
; this is faster:
	bts	eax,ecx
	mov	dword [rdi + 8*5],eax

	mov	rax,r8
	lea	rdi,[msg_HW_BP_addr]
	call	hexa_64_rax
	mov	byte [rdi+16],'h'

	call	set_debug_registers_in_all_threads
	jc	Rambo_TLSC_epi

	CopyMovsq_unsafe msg_HW_BP_trigger, msg_HW_BP_te_sb_ft, msg_HW_BP_te_sb_ft_size

	lea	rax,[msg_HW_BP_text]
	call	msg_to_LogEdit

	clc

Rambo_TLSC_epi:
	lea	rsp,[rsp+8*(f+e+d+c)]
	pop	rdi rsi rbp rbx
	ret

Rambo_TLSC_fail:
	stc
	jmp	Rambo_TLSC_epi

Rambo_ExecutableHeaderPredator:
; in:	RCX handle of process, or 0 for every process
	cmp	qword [WeAreDebugging],0
	jz	Rambo_ExecutableHeaderPredator_done

	bt	dword [face.Rambo],IDM_RAMBO_EHP - IDM_RAMBO
	jnc	Rambo_ExecutableHeaderPredator_done

	push	rcx
	call	proc_set_executable_headers
	pop	rcx
Rambo_ExecutableHeaderPredator_done:

Rambo_dummy:
	ret

FuckOff_IsDebuggerPresent:
; in:	RCX	hProcess, or 0 for all processes
;	DL	0 for clear IsDebuggerPresent flag
;		1 for set IsDebuggerPresent flag
	push	rcx rdx rbx rbp rsi rdi
	sub	rsp,8*(4+7)


	mov	rbp,rcx			; handle of the process or 0
	mov	rsi,rcx

	lea	rcx,[sysinfo]		; word ProcessorArchitecture -> PROCESSOR_ARCHITECTURE_AMD64 = 9
					; word reserved
					; dword PageSize
					; qword MinimumApplicationAddress
					; qword MaximumApplicationAddress
					; ...
	call	qword [GetSystemInfo]

FuckOff_IsDebuggerPresent_L0:
	or	rbp,rbp
	jnz	FuckOff_IsDebuggerPresent_L5	; we want to do it only for 1 process

; do it for every process (=every handle of process stored in our store):
	mov	rdi,qword [multiprocess_multithread_support_address]
	add	rdi,MaxProcesses*8	; point to handles of processes
	mov	ebx,MaxProcesses

FuckOff_IsDebuggerPresent_L2:
	mov	ecx,ebx
	xor	eax,eax
	cld
	repz scasq
	jz	FuckOff_IsDebuggerPresent_L8
	mov	rsi,[rdi-8]		; grab handle of process
	mov	ebx,ecx			; and save remaining count for repz scasq

FuckOff_IsDebuggerPresent_L5:
	mov	rcx,[sysinfo.lpMaximumApplicationAddress]
MemSize_for_random_store_fuck	=	10000h		; must be power of 2 !!!
	sub	rcx,MemSize_for_random_store_fuck * 2

	rdtsc						; grab some random number
	mov	dword [rsp + 8*(4+5)],eax
	mov	dword [rsp + 8*(4+5) + 4],edx
	mov	rdx,qword [rsp + 8*(4+5)]
	bswap	rdx
	and	rdx,rcx				; mask it to fit into MaximumApplicationAddress
	mov	dword [rsp + 8*(4+0)],PAGE_EXECUTE_READWRITE
	mov	r9d,MEM_COMMIT or MEM_RESERVE		; or MEM_TOP_DOWN
; must be MEM_RESERVE, doesn't work with COMMIT only without RESERVE
	mov	r8d,MemSize_for_random_store_fuck	;1000h	; FuckOff_IsDebuggerPresent_proc_size
	mov	rcx,rsi
	call	qword [VirtualAllocEx]
	or	rax,rax
	jz	skip_fucking
	mov	qword [rsp + 8*(4+4)],rax

	rdtsc				; some random number
	and	eax,MemSize_for_random_store_fuck - 1 - ((FuckOff_IsDebuggerPresent_proc_size+0Fh)/10h)*10h
					; less than (1000h - FuckOff_IsDebuggerPresent_proc_size)

	lea	rcx,[rsp + 8*(4+2)]
	mov	rdx,qword [rsp + 8*(4+4)]
	and	qword [rcx],0
	add	rdx,rax
	mov	qword [rsp + 8*(4+5)],rdx	; save ThreadStartAddress
	mov	qword [rsp + 8*(4+0)],rcx
	mov	r9d,FuckOff_IsDebuggerPresent_proc_size
	lea	r8,[FuckOff_IsDebuggerPresent_proc]
	mov	rcx,rsi
	call	qword [WriteProcessMemory]
	or	rax,rax
	jz	skip_fucking
	cmp	qword [rsp + 8*(4+2)],FuckOff_IsDebuggerPresent_proc_size
	jnz	skip_fucking

	cmp	word [crucial],0AAF3h		; REPZ STOSB opcode
	jz	crucial_must_be_executereadwrite
	cmp	byte [crucial],0C3h		; RET opcode
	jnz	skip_fucking
	lea	rax,[rsp + 8*(4+1)]
	mov	qword [rsp + 8*(4+0)],rax
	mov	r9d,PAGE_EXECUTE_READ
	mov	r8d,MemSize_for_random_store_fuck	;1000h	; FuckOff_IsDebuggerPresent_proc_size
	mov	rdx,qword [rsp + 8*(4+4)]
	mov	rcx,rsi
	call	qword [VirtualProtectEx]
	or	eax,eax
	jz	skip_fucking
; unnecessary paranoid checking:
;	cmp	dword [rsp + 8*(4+1)],PAGE_EXECUTE_READWRITE	; old protect flag
;	jnz	skip_fucking

crucial_must_be_executereadwrite:

	lea	rdx,[rsp + 8*(4+3)]
	mov	rax,qword [rsp + 8*(4+7+4)]	; grab parameter saved by push RDX in prologue
	mov	qword [rsp + 8*(4+2)],rdx
	and	dword [rsp + 8*(4+1)],0
	mov	qword [rsp + 8*(4+0)],rax
	mov	r9,qword [rsp + 8*(4+5)]	; saved ThreadStartAddress
	xor	r8,r8
	xor	edx,edx
	mov	rcx,rsi
	call	qword [CreateRemoteThread]
	or	rax,rax
	jz	FuckOff_IsDebuggerPresent_L7
	mov	rsi,rax

;	mov	rax,qword [multiprocess_multithread_support_address]
;	mov	rcx,qword [rax + MaxProcesses*8*2 + MaxThreads*8*1]	; skip store of PID...hProcess and TID and get the first hThread
;	call	SuspendThreadSafe

	mov	edx,100
	mov	rcx,rsi
	call	qword [WaitForSingleObject]

;	mov	rax,qword [multiprocess_multithread_support_address]
;	mov	rcx,qword [rax + MaxProcesses*8*2 + MaxThreads*8*1]	; skip store of PID...hProcess and TID and get the first hThread
;	call	ResumeThreadSafe

FuckOff_IsDebuggerPresent_L7:
	or	rbp,rbp
	jz	FuckOff_IsDebuggerPresent_L2

FuckOff_IsDebuggerPresent_L8:
;; this must be here for remote thread has some CPU time to 
;	mov	eax,[last_TID]
;	call	TID2hThread
;	jc	skip_fucking
;	mov	rbx,rdx
;	mov	rcx,rdx
;	call	SuspendThreadSafe
;	mov	ecx,100
;	call	qword [Sleep]
;	mov	rcx,rbx
;	call	ResumeThreadSafe

skip_fucking:
	add	rsp,8*(4+7)
	pop	rdi rsi rbp rbx rdx rcx
	ret

FuckOff_IsDebuggerPresent_proc:
; Thread is created with param in RCX (0 hide debugger against IsDebuggerPresent, 1 show it)
;	gs mov	rax,[dword 30h]
;	mov	rdx,qword [rax+60h]	; Peb
;	mov	byte [rdx+2],cl		; fuck off IsDebuggerPresent if CL=0
; this is smaller:
; no need to execute mov gpr64,[gs:30h] because it is a pointer to itself, it gives result pointing to gs:0
	push	60h
	pop	rax
	gs mov	rdx,[rax]		; Peb
	mov	[rdx+2],cl		; IsDebuggerPresent

	xor	eax,eax				; exit code
;	lea	rdi,[FuckOff_IsDebuggerPresent_proc]
;	lea	ecx,[eax + FuckOff_IsDebuggerPresent_proc_size - 1]	; -1 leave last RET 1 byte opcode
;	cld
; Searching for memory page would be easier if it have PAGE_EXECUTE_READWRITE rare flag
; instead of having very common PAGE_EXECUTE_READ flag.
; So if you notice that some new antidebug routine fuck off this anti-antidebug,
; just uncomment repz stosb at label crucial and 3 above instructions (lea, lea, cld
; There can be only one possibility of both -
; PAGE_EXECUTE_READ without repz stosb (unable to find by scan page with PAGE_EXECUTE_READWRITE)
; or
; PAGE_EXECUTE_READWRITE with repz stosb (advantage is self modifying code - so only RET will stay
;                                        but easy scan for page with PAGE_EXECUTE_READWRITE)
crucial:
;	repz stosb
	ret
FuckOff_IsDebuggerPresent_proc_size	=	$ - FuckOff_IsDebuggerPresent_proc




CMD_RAMBO_PBDE:
; this doesn't work immediatelly after intercepting CREATE_PROCESS_DEBUG_EVENT, must be executed delayed, else the process refuses to load under debugger and the process exits
	push	rcx
	mov	ecx,[last_PID]
	call	RAMBO_PBDE_proc
	pop	rcx
	ret

RAMBO_PBDE_proc:
; in:	ECX	PID, or 0 for all processes
	push	rcx rdx rbx rbp rsi rdi
	sub	rsp,8*(4+7)

	mov	ebp,ecx				; ebp = PID, 0 for all processes
	mov	ebx,MaxProcesses

	or	ecx,ecx
	jz	RAMBO_PBDE_proc_L1

a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
; we want to do it only for 1 process
	mov	rdi,qword [multiprocess_multithread_support_address]
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2	; point to handles of processes

	mov	ecx,ebx				; MaxProcesses
	mov	eax,ebp				; PID
	cld
	repnz scasq
	jnz	RAMBO_PBDE_proc_L9		; no such PID
	jmp	RAMBO_PBDE_proc_L5		; go on

RAMBO_PBDE_proc_L1:
; do it for every process (=every handle of process stored in our store):
	mov	rdi,qword [multiprocess_multithread_support_address]
	add	rdi,MaxProcesses*8*2 + MaxThreads*8*2 + a*4*2 + (MaxProcesses+MaxThreads)*8*2	; point to PID - PEB pairs

RAMBO_PBDE_proc_L2:
; we want to do it for all processes
	mov	ecx,ebx
	xor	eax,eax
	cld
	repz scasq
	jz	RAMBO_PBDE_proc_L9
	mov	ebx,ecx			; and save remaining count for repz scasq

RAMBO_PBDE_proc_L5:
	mov	rax,[rdi-8]		; PID
	call	PID2hProcess
	jc	RAMBO_PBDE_proc_L9

	mov	rsi,rdx			; hProcess
	mov	rcx,rdx			; hProcess
	mov	[rsp + 8*(4+4)],rdx	; save hProcess
	lea	rax,[rsp + 8*(4+1)]	; address for count of read bytes
	mov	[rsp + 8*(4+0)],rax	; 5th param, pointer to address for count of read bytes
	mov	r9d,4			; size
	lea	r8,[rsp+8*(4+2)]	; destination address
	mov	rdx,[rdi-8 + MaxProcesses*8]	; source address, PEB
;	mov	rcx,rcx
	call	[ReadProcessMemory]
	or	eax,eax
	jz	RAMBO_PBDE_proc_L9
	cmp	dword [rsp + 8*(4+1)],4
	jnz	RAMBO_PBDE_proc_L9

	and	byte [rsp+8*(4+2) + 2],not 1	; clear PEB.BeingDebugged bit

	lea	rax,[rsp + 8*(4+1)]	; address for count of read bytes
	mov	[rsp + 8*(4+0)],rax	; 5th param, pointer to address for count of read bytes
	mov	r9d,4			; size
	lea	r8,[rsp+8*(4+2)]	; buffer
	mov	rdx,[rdi-8 + MaxProcesses*8]	; source address, PEB
	mov	rcx,rsi			; hProcess
	call	[WriteProcessMemory]
;	or	eax,eax
;	jz	RAMBO_PBDE_proc_L9
;	cmp	dword [rsp + 8*(4+1)],4
;	jnz	RAMBO_PBDE_proc_L9

	or	ebp,ebp
	jz	RAMBO_PBDE_proc_L2	; repeat for all processes


RAMBO_PBDE_proc_L9:
	add	rsp,8*(4+7)
	pop	rdi rsi rbp rbx rdx rcx
	ret






proc_set_executable_headers:
; in:	RCX	hProcess, or 0 for all processes
;	RDX	address of module begin
	push	rcx rdx rbx rbp rsi rdi
	sub	rsp,8*(4+3)

	mov	rbp,rcx			; handle of the process or 0
	mov	rsi,rcx

proc_set_executable_headers_L0:
	or	rbp,rbp
	jnz	proc_set_executable_headers_L5	; we want to do it only for 1 process

; do it for every process (=every handle of process stored in our store):
	mov	rdi,qword [module_info_address]
	add	rdi,24*MaxNumberOfModulesInfo	; point to PIDs
	mov	ebx,MaxNumberOfModulesInfo

proc_set_executable_headers_L2:
	mov	ecx,ebx
	xor	eax,eax
	cld
proc_set_executable_headers_L3:
	repz scasq
	jz	proc_set_executable_headers_epi
;	cmp	dword [rdi-4],flag_module_process
;	jnz	proc_set_executable_headers_L3
; since we have 2 flags only, we can do it smaller:
if flag_module_DLL=0
	cmp	dword [rdi-4],eax
	jz	proc_set_executable_headers_L3
else
	cmp	dword [rdi-4],flag_module_process
	jnz	proc_set_executable_headers_L3
end if
	mov	eax,dword [rdi-8]	; grab PID
	call	PID2hProcess
	jc	proc_set_executable_headers_L3
	mov	rsi,rdx			; save handle of the process
	mov	ebx,ecx			; and save remaining count for repz scasq
	mov	rdx,qword [rdi-8-24*MaxNumberOfModulesInfo]; get module begin

proc_set_executable_headers_L5:
	mov	qword [rsp+8*(4+2)],rdx	; save RDX

	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[Rambo_buf]
	mov	rcx,rsi
	call	qword [VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	jnz	proc_set_executable_headers_L7

	lea	rax,[rsp + 8*(4+1)]
	lea	rcx,[Rambo_buf]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect 5th param to API
;	mov	r9d,[rcx + MEMORY_BASIC_INFORMATION64.AllocationProtect]
;	test	r9d,PAGE_EXECUTE
;	jnz	proc_set_executable_headers_L7
;	or	r9d,PAGE_EXECUTE
	mov	r9d,PAGE_EXECUTE_READWRITE
	mov	r8,[rcx + MEMORY_BASIC_INFORMATION64.RegionSize]
	mov	rdx,qword [rsp+8*(4+2)]	; lpAddress
	cmp	[rcx + MEMORY_BASIC_INFORMATION64.AllocationBase],rdx
	mov	rcx,rsi
	jnz	proc_set_executable_headers_L7
	call	qword [VirtualProtectEx]

proc_set_executable_headers_L7:
	or	rbp,rbp
	jz	proc_set_executable_headers_L2

proc_set_executable_headers_epi:
	add	rsp,8*(4+3)
	pop	rdi rsi rbp rbx rdx rcx
	ret

align 10h
CMD_RAMBO_RD:
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProcRD]
	mov	r8,[hWndParent]
	mov	edx,ID_DialogRD
	mov	rcx,[hInstance]
	call	[DialogBoxParamA]
	add	rsp,8*(4+1)
	ret

align 10h
DlgProcRD:
	push	rcx rdx rbx rsi rdi r8 r9

a=1				; return address from procedure
b=7				; number of pushed registers
d=(sizeof.MEMORY_BASIC_INFORMATION64+7)/8
e=(sizeof.LV_ITEM64+7)/8
f=4				; 4 qwords reserved for API
c=(a+b+d+e+f) and 1		; align stack at dqword
	sub	rsp,8*(c+d+e+f)
; the stack looks now like:
; a <- the top, return address from procedure
; b number of pushed registers
; c aligning stack at dqword (c is 0 or 1)
; d MEMORY_BASIC_INFORMATION64
; e LV_ITEM64
; f 4 qwords reserved for API
;   <- current RSP
	
	cmp	edx,WM_INITDIALOG
	jz	DlgProcRD_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProcRD_ReturnFalse
	cmp	r8d,CBN_SELCHANGE*10000h + ID_DialogRDComboBox0
	jz	DlgProcRD_ComboBox0Change
	cmp	r8d,EN_CHANGE*10000h + ID_DialogRDEditText0
	jz	DlgProcRD_Edit0Change
	cmp	r8w,ID_DialogRDButton0
	jz	DlgProcRD_Change_Protect_Attributes
	cmp	r8w,ID_DialogRDButton1
	jz	DlgProcRD_Abandon

DlgProcRD_ReturnFalse:
	xor	eax, eax
DlgProcRD_Return:
	add	rsp,8*(c+d+e+f)
	pop	r9 r8 rdi rsi rbx rdx rcx
	ret

DlgProcRD_InitDialog:
; fill combobox with all available PIDs, then select the current one
	xor	ebx,ebx			; processes counter
	lea	rdi,[rsp+8*(4+2)]
	mov	rsi,[multiprocess_multithread_support_address]
	mov	[rsp+8*(4+0)],rdi
	mov	eax,'PID='
	cld
	stosd
	mov	word [rdi+8],'h'	; 0-terminator too

DlgProcRD_InitDialog_fill_combo_box:
	mov	eax,[rsi+rbx*8]		; PID
	or	eax,eax
	jz	DlgProcRD_skip_ComboBox0_add_string
	call	hexa_32_eax
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_DialogRDComboBox0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd pushed in the stack
	call	[SendDlgItemMessageA]

DlgProcRD_skip_ComboBox0_add_string:
	inc	ebx
	cmp	ebx,MaxProcesses
	jc	DlgProcRD_InitDialog_fill_combo_box

	mov	rax,[hInstance]
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	and	qword [rsp + 8*(4+7)],0		; pointer to window-creation data
	mov	[rsp + 8*(4+6)],rax		; hInst  handle to application instance
	mov	qword [rsp + 8*(4+5)],ID_DialogRDSysListView0	; handle to menu, or child-window identifier
	mov	[rsp + 8*(4+4)],rcx
	mov	dword [rsp + 8*(4+3)],450	; height
	mov	dword [rsp + 8*(4+2)],650	; width
	mov	dword [rsp + 8*(4+1)],214	; vertical position of window
	mov	dword [rsp + 8*(4+0)],3		; horizontal position of window
	mov	r9d,WS_CHILD or WS_VISIBLE or WS_TABSTOP or LVS_REPORT or LVS_SHAREIMAGELISTS	; window style
	xor	r8,r8				; pointer to window name
	lea	rdx,[SysListView32ClassName]	; pointer to registered class name
	mov	ecx,WS_EX_CLIENTEDGE		; extended window style
	call	[CreateWindowExA]
	mov	rsi,rax

	mov	r9,LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or LVS_EX_GRIDLINES; or LVS_EX_SUBITEMIMAGES		; lParam
	xor	r8,r8
	mov	edx,LVM_SETEXTENDEDLISTVIEWSTYLE
	mov	rcx,rsi
	call	[SendMessageA]

	lea	rcx,[imports_ListView_font]
	call	[CreateFontIndirectA]
	mov	[imports_hFont],rax

	mov	r9,1				; lParam redraw flag
	mov	r8,rax				; wParam font handle
	mov	edx,WM_SETFONT
	mov	rcx,rsi
	call	[SendMessageA]

if LVCFMT_LEFT = 0
  if (LV_COLUMN64.fmt - LV_COLUMN64.mask) = 4
	mov	qword [rsp+8*f + LV_COLUMN64.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH
  else
	mov	dword [rsp+8*f + LV_COLUMN64.mask],LVCF_FMT or LVCF_SUBITEM or LVCF_TEXT or LVCF_WIDTH	; fmt, iSubItem, pszText, cx member are valid.
	mov	dword [rsp+8*f + LV_COLUMN64.fmt],LVCFMT_LEFT
  end if
end if
	mov	[rsp+8*f + LV_COLUMN64.iSubItem],1;0
;	lea	rdi,[DialogRDSysListView0_data]



lea	rdi,[Dialog0CSysListView0_data]





DlgProcRD_InitDialog_columns_L0:
	lea	r9,[rsp+8*f]
	mov	[r9 + LV_COLUMN64.pszText],rdi
	or	ecx,-1
	xor	eax,eax
	cld
	repnz scasb
	mov	eax,[rdi]
	scasd
	mov	[r9 + LV_COLUMN64.cx],eax	; Specifies the width, in pixels, of the column
	mov	r8d,[r9 + LV_COLUMN64.iSubItem]	; column number
	mov	edx,LVM_INSERTCOLUMN
	mov	rcx,rsi
	call	[SendMessageA]
	inc	[rsp+8*f + LV_COLUMN64.iSubItem]
	cmp	byte [rdi],0
	jnz	DlgProcRD_InitDialog_columns_L0

	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9				; show first
	mov	r8d,CB_SETCURSEL
	mov	edx,ID_DialogRDComboBox0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	call	[SendDlgItemMessageA]

	and	qword [rsp + 8*(4+0)],0
	mov	r9d,16				; limit text to 16 chars
	mov	r8d,EM_SETLIMITTEXT
	mov	edx,ID_DialogRDEditText0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	call	[SendDlgItemMessageA]

	mov	rdi,[multiprocess_multithread_support_address]
; the first PID is always selected
	mov	ecx,MaxProcesses
	xor	eax,eax
	cld
	repnz scasq

	mov	edx,[rdi-8]			; grab the PID
	mov	rcx,rsi
	call	disp_pages_and_attributes

	xor	r9,r9
	mov	r8,CBN_SELCHANGE*10000h + ID_DialogRDComboBox0
	mov	edx,WM_COMMAND
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	call	[PostMessageA]			; we can't use SendMessage because initdialog isn't finished - we can only PostMessage

DlgProcRD_ReturnTrue:
	mov	eax,1
	jmp	DlgProcRD_Return



DlgProcRD_Change_Protect_Attributes:

	xor	ebx,ebx				; desired Access protection

; get desired Access protection
	mov	esi,10-1

AMDPad16
DlgProcRD_Change_Protect_Attributes_L1:
	lea	edx,[rsi + ID_DialogRDAutoCheckBox00]
	mov	rcx,[rsp + 8*(c+d+e+f+6)]
	call	[IsDlgButtonChecked]
;BST_UNCHECKED			=	0
;BST_CHECKED			=	1
	shr	al,1
	rcl	ebx,1

	dec	esi
	jns	DlgProcRD_Change_Protect_Attributes_L1

; ebx = protect attributes

; check if there is something in ID_DialogRDEditText0
	mov	r9d,16			; maximal lenght
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_DialogRDEditText0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]
	call	[GetDlgItemTextA]
;	or	eax,eax			; API returns eax=0 if nothing in ID_DialogRDEditText0
;	jz	DlgProcRD_Abandon
; the above is not necessary, the following ascii2hexa_qword is going to check the string lenght also

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	jc	DlgProcRD_Abandon
	mov	rsi,rdx
; rsi = address

; get hProcess for the selected PID
	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_DialogRDComboBox0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	call	[SendDlgItemMessageA]
	cmp	eax,CB_ERR
	jz	DlgProcRD_Abandon
	cmp	eax,MaxProcesses
	jnc	DlgProcRD_Abandon

	lea	ecx,[rax+1]
	mov	rdi,[multiprocess_multithread_support_address]
	cld
	xor	eax,eax
DlgProcRD_Change_Protect_Attributes_L0:
	scasq					; scan nonempty PIDs
	jz	DlgProcRD_Change_Protect_Attributes_L0
	loop	DlgProcRD_Change_Protect_Attributes_L0

; change Access protection
	lea	rax,[rsp+8*(4+1)]
	mov	qword [rsp+8*(4+0)],rax	; lpflOldProtect 5th param to API
	mov	r9d,ebx			; flNewProtect
	mov	r8d,1			; dwSize (1 byte is enough and everytime fits to only 1 page, never wraps into 2 pages)
	mov	rdx,rsi			; lpAddress
	mov	rcx,[rdi-8 + MaxProcesses*8*1]	; hProcess
	call	[VirtualProtectEx]
	or	eax,eax
	jz	DlgProcRD_Abandon

DlgProcRD_Done:
	mov	rcx,[imports_hFont]
	call	[DeleteObject]

	xor	edx,edx
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	call	[EndDialog]
	jmp	DlgProcRD_ReturnTrue



DlgProcRD_ComboBox0Change:
	and	qword [rsp+8*4],0
	xor	r9,r9
	mov	r8d,LVM_DELETEALLITEMS
	mov	edx,ID_DialogRDSysListView0
;	mov	rcx,rcx
	call	[SendDlgItemMessageA]

	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_DialogRDComboBox0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	call	[SendDlgItemMessageA]
	cmp	eax,CB_ERR
	jz	DlgProcRD_Abandon
	cmp	eax,MaxProcesses
	jnc	DlgProcRD_Abandon

	lea	ecx,[rax+1]
	mov	rdi,[multiprocess_multithread_support_address]
	cld
	xor	eax,eax
DlgProcRD_ComboBox0Change_L0:
	scasq					; scan nonempty PIDs
	jz	DlgProcRD_ComboBox0Change_L0
	loop	DlgProcRD_ComboBox0Change_L0

	mov	edx,ID_DialogRDSysListView0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	call	[GetDlgItem]
	or	rax,rax
	jz	DlgProcRD_Abandon

	mov	edx,[rdi-8]			; grab the PID
	mov	rcx,rax				; handle of ID_DialogRDSysListView0
	call	disp_pages_and_attributes

	jmp	DlgProcRD_ReturnTrue

DlgProcRD_Abandon:
	jmp	DlgProcRD_Done


align 10h
DlgProcRD_Edit0Change:
; check whether entered input is valid
; we check if ID_DialogRDEditText0 has a data - if has, we enable 'Done' ID_DialogRDButton0
	mov	ebx,1			; enable window
;	xor	ebx,ebx			; 0 = disable window
; check if there is something in ID_DialogRDEditText0
	mov	r9d,16			; maximal lenght
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_DialogRDEditText0
;	mov	rcx,[rsp + 8*(c+d+e+f+6)
	call	[GetDlgItemTextA]
;	or	eax,eax			; API returns eax=0 if nothing in ID_DialogRDEditText0
;	cmovz	ebx,eax
;	jz	DlgProcRD_Edit0Change_L5
; the above is not necessary, the following ascii2hexa_qword is going to check the string lenght also

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	setnc	bl
	jc	DlgProcRD_Edit0Change_L5

; rdx = address
	mov	rsi,rdx

; does the address really exist?
	and	qword [rsp + 8*(4+0)],0
	xor	r9,r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_DialogRDComboBox0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]	; hWnd
	call	[SendDlgItemMessageA]
	cmp	eax,CB_ERR
	setnz	cl
	and	bl,cl
	jz	DlgProcRD_Edit0Change_L5
	cmp	eax,MaxProcesses
	setc	cl
	and	bl,cl
	jz	DlgProcRD_Edit0Change_L5

	lea	ecx,[rax+1]
	mov	rdi,[multiprocess_multithread_support_address]
	cld
	xor	eax,eax
DlgProcRD_Edit0Change_L2:
	scasq					; scan nonempty PIDs
	jz	DlgProcRD_Edit0Change_L2
	loop	DlgProcRD_Edit0Change_L2

	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[rsp + 8*(4+0)]
	mov	rdx,rsi
	mov	rcx,[rdi-8 + MaxProcesses*8*1]	; hProcess
	call	[VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	setz	cl
	and	bl,cl
	jz	DlgProcRD_Edit0Change_L5

; The access protection value can be set only on committed pages. If the state of any page in the specified region is not committed, the function fails and returns without modifying the access protection of any pages in the specified region.
	test	[rsp+8*(4+0) + MEMORY_BASIC_INFORMATION64.State],MEM_COMMIT
	setnz	al
	and	bl,al
	jz	DlgProcRD_Edit0Change_L5

	mov	esi,10-1

AMDPad16
DlgProcRD_Edit0Change_L4:
	bt	[rsp+8*(4+0) + MEMORY_BASIC_INFORMATION64.Protect],esi
;BST_UNCHECKED			=	0
;BST_CHECKED			=	1
	setc	al
	movzx	r8d,al
	lea	edx,[rsi + ID_DialogRDAutoCheckBox00]
	mov	rcx,[rsp + 8*(c+d+e+f+6)]
	call	[CheckDlgButton]

	dec	esi
	jns	DlgProcRD_Edit0Change_L4


DlgProcRD_Edit0Change_L5:
	mov	esi,10-1
AMDPad16
DlgProcRD_Edit0Change_L6:
	lea	edx,[rsi + ID_DialogRDAutoCheckBox00]
	mov	rcx,[rsp + 8*(c+d+e+f+6)]
	call	[GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	[EnableWindow]

	dec	esi
	jns	DlgProcRD_Edit0Change_L6

; Done button also
	mov	edx,ID_DialogRDButton0
	mov	rcx,[rsp + 8*(c+d+e+f+6)]
	call	[GetDlgItem]

	mov	edx,ebx			; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	[EnableWindow]

	jmp	DlgProcRD_ReturnTrue


align 10h
disp_pages_and_attributes:
; rcx handle of ID_DialogRDSysListView0
; edx PID

	push	rbx rsi rdi r12 r13 r14 r15

a=1				; return address from procedure
b=7				; number of pushed registers
d=(sizeof.MEMORY_BASIC_INFORMATION64+7)/8
e=(sizeof.LV_ITEM64+7)/8
f=4				; 4 qwords reserved for API
c=(a+b+d+e+f) and 1		; align stack at dqword
	sub	rsp,8*(c+d+e+f)
; the stack looks now like:
; a <- the top, return address from procedure
; b number of pushed registers
; c aligning stack at dqword (c is 0 or 1)
; d MEMORY_BASIC_INFORMATION64
; e LV_ITEM64
; f 4 qwords reserved for API
;   <- current RSP

	mov	r13,rcx
	mov	r15d,edx			; PID

	mov	eax,edx
	call	PID2hProcess
	jc	disp_pages_and_attributes_epi
	mov	r14,rdx				; hProcess

	xor	eax,eax
;	mov	[rsp+8*f + LV_ITEM64.iItem],eax
;	mov	[rsp+8*f + LV_ITEM64.iSubItem],eax
	mov	qword [rsp+8*f + LV_ITEM64.iItem],rax	; instead of above 2 instructions

	mov	[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.BaseAddress],rax

	lea	rdi,[tmp_buf]
	mov	[rsp+8*f + LV_ITEM64.pszText],rdi


AMDPad16
disp_pages_and_attributes_L1:
	mov	r9d,sizeof.MEMORY_BASIC_INFORMATION64
	lea	r8,[rsp+8*(f+e)]
	mov	rdx,[r8+MEMORY_BASIC_INFORMATION64.BaseAddress]
	mov	rcx,r14
	call	[VirtualQueryEx]
	cmp	eax,sizeof.MEMORY_BASIC_INFORMATION64
	jnz	disp_pages_and_attributes_epi

	mov	byte [rdi+16],0			; 0-terminator

	mov	eax,[rsp+8*f + LV_ITEM64.iItem]	; index of displayed item in SysListView32, will be updated at end
	mov	[rsp+8*f + LV_ITEM64.lParam],rax
	mov	rax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.BaseAddress]
	call	hexa_64_rax
	lea	r9,[rsp+8*f]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT or LVIF_PARAM
	xor	r8,r8
	mov	edx,LVM_INSERTITEM
	mov	rcx,r13
	call	[SendMessageA]

	and	byte [rdi],0
	cmp	[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.State],MEM_FREE		; .State=MEM_FREE
	jz	disp_pages_and_attributes_AllocationBase_done				; For free pages, the information in the AllocationBase, AllocationProtect, Protect, and Type members is undefined.
	mov	rax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.AllocationBase]
	call	hexa_64_rax
disp_pages_and_attributes_AllocationBase_done:
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,r13
	call	[SendMessageA]

	and	byte [rdi],0
	cmp	[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.State],MEM_FREE		; .State=MEM_FREE
	jz	disp_pages_and_attributes_AllocationProtect_done			; For free pages, the information in the AllocationBase, AllocationProtect, Protect, and Type members is undefined.
	mov	eax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.AllocationProtect]
	call	eax2protect
disp_pages_and_attributes_AllocationProtect_done:
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,r13
	call	[SendMessageA]

	mov	rax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.RegionSize]
	call	hexa_64_rax
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,r13
	call	[SendMessageA]

	mov	eax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.State]
	call	eax2state
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,r13
	call	[SendMessageA]

	and	byte [rdi],0
	cmp	[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.State],MEM_RESERVE		; .State=MEM_RESERVE
	jz	disp_pages_and_attributes_Protect_done					; For reserved pages, the information in the Protect member is undefined.
	cmp	[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.State],MEM_FREE		; .State=MEM_FREE
	jz	disp_pages_and_attributes_Protect_done					; For free pages, the information in the AllocationBase, AllocationProtect, Protect, and Type members is undefined.
	mov	eax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.Protect]
	call	eax2protect
disp_pages_and_attributes_Protect_done:
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,r13
	call	[SendMessageA]

	and	byte [rdi],0
	cmp	[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.State],MEM_FREE		; .State=MEM_FREE
	jz	disp_pages_and_attributes_Type_done					; For free pages, the information in the AllocationBase, AllocationProtect, Protect, and Type members is undefined.
	mov	eax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.Type]
	call	eax2type
disp_pages_and_attributes_Type_done:
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,r13
	call	[SendMessageA]

	cmp	[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.Type],MEM_IMAGE
	jnz	disp_pages_and_attributes_L5
	mov	rax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.AllocationBase]
	or	rax,rax
	jz	disp_pages_and_attributes_L5
	cmp	[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.BaseAddress],rax
	jnz	disp_pages_and_attributes_L3
; this is PE header
	mov	r12,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.RegionSize]	; region size of the header
;	lea	rdi,[tmp_buf]		; not necessary, rdi points there now
; we use the same buffer for store input param as well for return data of procedure
	cmp	r12,tmp_buf_size
	jnbe	disp_pages_and_attributes_L5	; too big header
	mov	[rdi],rax
	lea	rsi,[rdi]
	mov	rbx,r12
	mov	ecx,r15d		; PID
	call	read_debuggee_memory
	jc	disp_pages_and_attributes_L5
	call	validate_PE32plus
	jc	disp_pages_and_attributes_L5
	mov	rdx,'PE32+ he'
	mov	[rdi],rdx
	mov	edx,'ader'
	mov	[rdi+8],rdx		; make 0-terminator too
	jmp	disp_pages_and_attributes_L4
; this may be a section
disp_pages_and_attributes_L3:
;	lea	rdi,[tmp_buf]		; not necessary, rdi points there now
; we use the same buffer for store input param as well for return data of procedure
	mov	[rdi],rax
	lea	rsi,[rdi]
	mov	rbx,r12
	mov	ecx,r15d		; PID
	call	read_debuggee_memory
	jc	disp_pages_and_attributes_L5
	call	validate_PE32plus
	jc	disp_pages_and_attributes_L5
	movzx	ecx,[rdx+IMAGE_NT_HEADERS64.FileHeader.NumberOfSections]
	jrcxz	disp_pages_and_attributes_L5
	add	rdx,IMAGE_NT_HEADERS64.OptionalHeader+IMAGE_SIZEOF_NT_OPTIONAL64_HEADER-IMAGE_SIZEOF_SECTION_HEADER
; rdx=Sections
;	mov	rax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.BaseAddress]
;	sub	rax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.AllocationBase]
; this is smaller, we need only EAX;	mov	rax,[rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.BaseAddress]
	mov	eax,dword [rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.BaseAddress]
	sub	eax,dword [rsp+8*(f+e) + MEMORY_BASIC_INFORMATION64.AllocationBase]
disp_pages_and_attributes_L3_try_next:
	add	rdx,IMAGE_SIZEOF_SECTION_HEADER
	cmp	[rdx+IMAGE_SECTION_HEADER.VirtualAddress],eax
	loopnz	disp_pages_and_attributes_L3_try_next
	jnz	disp_pages_and_attributes_L5
disp_pages_and_attributes_L3_section_match:
	mov	rax,[rdx]
	mov	[rdi],rax
	mov	byte [rdi+8],0
disp_pages_and_attributes_L4:
	lea	r9,[rsp+8*4]
	mov	[r9 + LV_ITEM64.mask],LVIF_TEXT
	inc	dword [r9 + LV_ITEM64.iSubItem]
	xor	r8,r8
	mov	edx,LVM_SETITEM
	mov	rcx,r13
	call	[SendMessageA]

disp_pages_and_attributes_L5:

	mov	eax,[rsp+8*4 + LV_ITEM64.iItem]
	inc	eax
if (LV_ITEM64.iSubItem - LV_ITEM64.iItem) = 4
; high dword of rax=0 now, so we set both dwords by 1 instruction
	mov	qword [rsp+8*4 + LV_ITEM64.iItem],rax
else
	mov	[rsp+8*4 + LV_ITEM64.iItem],eax
	and	[rsp+8*4 + LV_ITEM64.iSubItem],0
end if

	mov	rax,[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.RegionSize]
	add	[rsp+8*(f+e)+MEMORY_BASIC_INFORMATION64.BaseAddress],rax
	jmp	disp_pages_and_attributes_L1

disp_pages_and_attributes_end:

disp_pages_and_attributes_epi:
	add	rsp,8*(c+d+e+f)
	pop	r15 r14 r13 r12 rdi rsi rbx
	ret


validate_PE32plus:
; in:	rdi pointer to the buffer holding data
; out:	rdx pointer to IMAGE_NT_HEADERS64
	cmp	[rdi+IMAGE_DOS_HEADER.e_magic],IMAGE_DOS_SIGNATURE
	jnz	validate_PE32plus_wrong
	mov	eax,[rdi+IMAGE_DOS_HEADER.e_lfanew]
	lea	rdx,[rdi+rax*1]
	cmp	[rdx+IMAGE_NT_HEADERS64.Signature],IMAGE_NT_SIGNATURE
	jnz	validate_PE32plus_wrong
	cmp	[rdx+IMAGE_NT_HEADERS64.FileHeader.Machine],IMAGE_FILE_MACHINE_AMD64
	jnz	validate_PE32plus_wrong
	test	[rdx+IMAGE_NT_HEADERS64.FileHeader.Characteristics],IMAGE_FILE_EXECUTABLE_IMAGE
	jz	validate_PE32plus_wrong
	cmp	[rdx+IMAGE_NT_HEADERS64.OptionalHeader.Magic],IMAGE_NT_OPTIONAL_HDR64_MAGIC
	jnz	validate_PE32plus_wrong
	clc
	ret
validate_PE32plus_wrong:
	stc
	ret



; -------------------------------




CMD_RAMBO_IE:
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc0B]
	mov	r8,[hWndParent]
	mov	edx,ID_Dialog0B
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	ret

DlgProc0B:
	push	rcx rdx rbx r8 r9
	sub	rsp,8*(4+0)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc0B_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc0B_ReturnFalse
	cmp	r8w,ID_Dialog0BButton0
	jz	DlgProc0B_Done
	cmp	r8w,ID_Dialog0BButton1
	jz	DlgProc0B_Abandon

DlgProc0B_ReturnFalse:
	xor	eax, eax
DlgProc0B_Return:
	add	rsp,8*(4+0)
	pop	r9 r8 rbx rdx rcx
	ret

DlgProc0B_InitDialog:
	mov	ebx,number_of_exception - 1	; -1 zero based index, we use jns at the end
DlgProc0B_InitDialog_L0:
;BST_UNCHECKED		= 0
;BST_CHECKED		= 1
	lea	rdx,[exceptions_to_ignore]
	mov	r8d,dword [rdx+rbx*4]
	mov	eax,1
	or	r8d,r8d
	cmovnz	r8d,eax
	lea	edx,[rbx + ID_Dialog0BAutoCheckBox00]
	mov	rcx,qword [rsp + 8*(4+0+4)]
	call	qword [CheckDlgButton]
	dec	ebx
	jns	DlgProc0B_InitDialog_L0

DlgProc0B_ReturnTrue:
	mov	eax,1
	jmp	DlgProc0B_Return

DlgProc0B_Done:
	mov	ebx,number_of_exception - 1	; -1 zero based index, we use jns at the end
DlgProc0B_Done_L0:
	lea	edx,[rbx + ID_Dialog0BAutoCheckBox00]
	mov	rcx,qword [rsp + 8*(4+0+4)]
	call	qword [IsDlgButtonChecked]	; The IsDlgButtonChecked function sends a BM_GETCHECK message to the specified button control.
;BST_UNCHECKED		= 0
;BST_CHECKED		= 1
	lea	rdx,[exception_data_hexa]
	mov	ecx,dword [rdx+rbx*4]
	or	eax,eax
	cmovnz	eax,ecx
	lea	rdx,[exceptions_to_ignore]
	mov	dword [rdx+rbx*4],eax
	dec	ebx
	jns	DlgProc0B_Done_L0

DlgProc0B_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+0+4)]
	call	qword [EndDialog]
	jmp	DlgProc0B_ReturnTrue

align 16
check_exception_in_ignore_list:
; input:	RAX	exception
; output:	ZF	ZF=0 if exception isn't in the list, ZF=1 if it is
	push	rdi rcx
	lea	rdi,[exceptions_to_ignore]
	mov	ecx,number_of_exception
	cld
	repnz scasd
	pop	rcx rdi
	ret

; -------- RAMBO subroutines end ----------

symbol2address:
; in:	rcx handle of window
; out:	success CF=0, rax=address
;	failure CF=1
	push	rcx rdx r8 r9
	sub	rsp,8*(4+1)
	and	[DlgProc0E_result],0
	and	qword [rsp+8*(4+0)],0
	lea	r9,[DlgProc0E]
	mov	r8,rcx			; hWndParent
	mov	edx,ID_Dialog0E
	mov	rcx,qword [hInstance]
	call	qword [DialogBoxParamA]
	add	rsp,8*(4+1)
	pop	r9 r8 rdx rcx
	mov	cl,[DlgProc0E_result]
	mov	rax,[DlgProc0E_value]	
	sub	cl,1
	ret

DlgProc0E:
	push	rcx rdx rbx rsi rdi r8 r9
	sub	rsp,8*(4+8)
	cmp	edx,WM_INITDIALOG
	jz	DlgProc0E_InitDialog
	cmp	edx,WM_COMMAND
	jnz	DlgProc0E_ReturnFalse
	cmp	r8d,CBN_SELCHANGE*10000h + ID_Dialog0EComboBox0
	jz	DlgProc0E_ComboBox0Change
	cmp	r8w,ID_Dialog0EButton0
	jz	DlgProc0E_Done
	cmp	r8w,ID_Dialog0EButton1
	jz	DlgProc0E_Abandon

DlgProc0E_ReturnFalse:
	xor	eax, eax
DlgProc0E_Return:
	add	rsp,8*(4+8)
	pop	r9 r8 rdi rsi rbx rdx rcx
	ret

DlgProc0E_InitDialog:
	mov	ebx,MaxNumberOfModulesInfo
	mov	rdi,qword [module_info_address]	; data of executable process image is everytime 1st
DlgProc0E_start_scan_module_names:
	mov	ecx,ebx
	xor	eax,eax
	repz scasq
	jnz	DlgProc0E_start_scan_module_names_L3
	jrcxz	DlgProc0E_start_scan_module_names_done
DlgProc0E_start_scan_module_names_L3:
	mov	ebx,ecx
;	cmp	dword [rdi-8 + 24*MaxNumberOfModulesInfo + 4],flag_module_DLL
;	jnz	DlgProc0E_start_scan_module_names	; we are interested in DLL only
; no, we are interested in exes and dlls
	mov	r8,qword [rdi-8 + 16*MaxNumberOfModulesInfo]	; module info
	or	r8,r8					; isn't it empty ?
	jz	DlgProc0E_start_scan_module_names

	mov	eax,dword [r8+1*4]			; NumberOfFunctions
	lea	rcx,[r8+rax*8 + 2*4]			; 2*4 info header size

	lea	rdx,[rsp+8*(4+2)]
	mov	rax,'<noname>'
	cmp	byte [rcx],0
	mov	qword [rdx],rax
	mov	byte [rdx+8],0
	cmovz	rcx,rdx

DlgProc0E_InitDialog_fill_combo_box:
	mov	qword [rsp + 8*(4+0)],rcx
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_Dialog0EComboBox0
	mov	rcx,[rsp + 8*(4+8+6)]
	call	qword [SendDlgItemMessageA]

DlgProc0E_skip_ComboBox0_add_string:
	jmp	DlgProc0E_start_scan_module_names

DlgProc0E_start_scan_module_names_done:
DlgProc0E_ReturnTrue:
	mov	eax,1
	jmp	DlgProc0E_Return

DlgProc0E_ComboBox0Change:
	call	DlgProc0E_enable

	xor	r9,r9
	mov	qword [rsp + 8*(4+0)],r9
	mov	r8d,CB_RESETCONTENT
	mov	edx,ID_Dialog0EComboBox1
	mov	rcx,[rsp + 8*(4+8+6)]
	call	qword [SendDlgItemMessageA]

;	mov	qword [rsp + 8*(4+0)],0
	xor	r9,r9
;	mov	qword [rsp + 8*(4+0)],r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog0EComboBox0
	mov	rcx,qword [rsp + 8*(4+8+6)]
	call	qword [SendDlgItemMessageA]
	cmp	eax,CB_ERR
	jz	DlgProc0E_Abandon		; error
	mov	edx,eax				; save zero-based index of selected (0=first, 1=second, ...)

	mov	ebx,MaxNumberOfModulesInfo
	mov	rdi,qword [module_info_address]	; data of executable process image is everytime 1st
DlgProc0E_ComboBox0Change_scan_module_names:
	mov	ecx,ebx
	xor	eax,eax
	repz scasq
	jnz	DlgProc0E_ComboBox0Change_scan_module_names_L3
	jrcxz	DlgProc0E_start_scan_module_names_done
DlgProc0E_ComboBox0Change_scan_module_names_L3:
	mov	ebx,ecx
;	cmp	dword [rdi-8 + 24*MaxNumberOfModulesInfo + 4],flag_module_DLL
;	jnz	DlgProc0E_ComboBox0Change_scan_module_names	; we are interested in DLL only
; no, we are interested in exes and dlls
	mov	r8,qword [rdi-8 + 16*MaxNumberOfModulesInfo]	; module info
	or	r8,r8					; isn't it empty ?
	jz	DlgProc0E_ComboBox0Change_scan_module_names
	dec	edx
	jns	DlgProc0E_ComboBox0Change_scan_module_names	; jns because zero-based index

	mov	rbx,r8
	mov	edi,dword [r8+1*4]			; NumberOfFunctions
	lea	rsi,[r8+rdi*4 + 2*4]			; 2*4 info header size, RVA of names

	lea	rcx,[rsp+8*(4+2)]
	mov	rax,'<base>'
	mov	qword [rcx],rax

DlgProc0E_ComboBox0Change_fill_combo_box:
	mov	qword [rsp + 8*(4+0)],rcx
	xor	r9,r9
	mov	r8d,CB_ADDSTRING
	mov	edx,ID_Dialog0EComboBox1
	mov	rcx,[rsp + 8*(4+8+6)]
	call	qword [SendDlgItemMessageA]

	cld
	lodsd
	lea	rcx,[rbx+rax*1]
	dec	edi
	jns	DlgProc0E_ComboBox0Change_fill_combo_box

	mov	qword [rsp + 8*(4+0)],rcx
	xor	r9,r9
	mov	r8d,CB_SETCURSEL
	mov	edx,ID_Dialog0EComboBox1
	mov	rcx,[rsp + 8*(4+8+6)]
	call	qword [SendDlgItemMessageA]
	jmp	DlgProc0E_ReturnTrue

DlgProc0E_Done:
	xor	r9,r9
	mov	qword [rsp + 8*(4+0)],r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog0EComboBox1
;	mov	rcx,qword [rsp + 8*(4+8+6)]
	call	qword [SendDlgItemMessageA]
	mov	esi,eax

;	mov	qword [rsp + 8*(4+0)],0
	xor	r9,r9
	mov	qword [rsp + 8*(4+0)],r9
	mov	r8d,CB_GETCURSEL
	mov	edx,ID_Dialog0EComboBox0
	mov	rcx,qword [rsp + 8*(4+8+6)]
	call	qword [SendDlgItemMessageA]
	cmp	eax,CB_ERR
	jz	DlgProc0E_Abandon		; error
	mov	edx,eax				; save zero-based index of selected (0=first, 1=second, ...)

	mov	ebx,MaxNumberOfModulesInfo
	mov	rdi,qword [module_info_address]	; data of executable process image is everytime 1st
DlgProc0E_Done_scan_module_names:
	mov	ecx,ebx
	xor	eax,eax
	repz scasq
	jnz	DlgProc0E_Done_scan_module_names_L3
	jrcxz	DlgProc0E_Abandon

DlgProc0E_Done_scan_module_names_L3:
	mov	ebx,ecx
;	cmp	dword [rdi-8 + 24*MaxNumberOfModulesInfo + 4],flag_module_DLL
;	jnz	DlgProc0E_Done_scan_module_names	; we are interested in DLL only
; no, we are interested in exes and dlls
	mov	r8,qword [rdi-8 + 16*MaxNumberOfModulesInfo]	; module info
	or	r8,r8					; isn't it empty ?
	jz	DlgProc0E_Done_scan_module_names
	dec	edx
	jns	DlgProc0E_Done_scan_module_names	; jns because zero-based index

	mov	rbx,qword [rdi-8]		; module base
	cmp	esi,CB_ERR
	jz	DlgProc0E_Done_L2		; error
	dec	esi				; the first symbol is allways <base> which means no symbol is used, just pure base of module
	js	DlgProc0E_Done_L2		; address at module base, skip the symbol itself

	mov	rcx,qword [rdi-8 + 16*MaxNumberOfModulesInfo]	; module info

; rcx points now to the module_info structure
; 0*4	dword size of allocated memory
; 1*4	dword NumberOfFunctions=NumberOfNames
; NumberOfFunctions*4 RVA of Functions
; NumberOfNames*4 RVA of Names
; ModuleName
; NumberOfFunctions times FunctionName
;	mov	r10d,dword [rcx+1*4]		; NumberOfFunctions
;	lea	r11,[rcx+8+r10*4]		; point to RVA of Names

	mov	edx,dword [rcx+8+rsi*4]		; grab RVA address
	add	rbx,rdx

DlgProc0E_Done_L2:

; edit control
; enough stack space must be reserved at DlgProc0E prologue, we reserved 8 qwords which is more than 40 bytes
	mov	r9d,40
	lea	r8,[rsp + 8*(4+0)]
	mov	edx,ID_Dialog0EEditText0
	mov	rcx,qword [rsp + 8*(4+8+6)]
	call	qword [GetDlgItemTextA]

	lea	rsi,[rsp + 8*(4+0)]
	call	ascii2hexa_qword	; input: rsi ascii string, rax string size
					; output: rdx hexa number
	jc	DlgProc0E_Done_L3
	add	rbx,rdx
DlgProc0E_Done_L3:

	mov	[DlgProc0E_value],rbx
	mov	[DlgProc0E_result],1

DlgProc0E_Abandon:
	xor	edx,edx
	mov	rcx,qword [rsp + 8*(4+8+6)]
	call	qword [EndDialog]
	jmp	DlgProc0E_ReturnTrue

DlgProc0E_enable:
	push	rbx
	sub	rsp,8*4
	mov	rbx,rcx

; enable Done button
	mov	edx,ID_Dialog0EButton0
;	mov	rcx,rcx
	call	qword [GetDlgItem]

	mov	edx,TRUE		; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

; enable ComboBox1
	mov	edx,ID_Dialog0EComboBox1
	mov	rcx,rbx
	call	qword [GetDlgItem]

	mov	edx,TRUE		; disable/enable window = button
	mov	rcx,rax			; hWnd
	call	qword [EnableWindow]

	add	rsp,8*4
	pop	rbx
	ret

;scan_ntdll_DbgBreakPoint:
;; in: ECX=PID
;	push	rcx rbx rbx rsi rdi r8 r9 r10 r11
;
;	mov	ebx,ecx					; save PID
;
;; trying to find the first matching export
;	mov	r11,[module_info_address]
;	mov	r10d,MaxNumberOfModulesInfo
;
;AMDPad16
;scan_ntdll_DbgBreakPoint_L2:
;	cmp	[r11+24*MaxNumberOfModulesInfo],ebx	; check matching PID (whether the DLL doesn't belong to different process when we are debugging more than 1 process)
;	jnz	scan_ntdll_DbgBreakPoint_L6
;
;	mov	r8,[r11 + 16*MaxNumberOfModulesInfo]	; module info
;	or	r8,r8					; isn't it empty ?
;	jz	scan_ntdll_DbgBreakPoint_L6		; if empty then go to next module
;
;; r8 points now to the module_info structure
;; 0*4	dword size of allocated memory
;; 1*4	dword NumberOfFunctions=NumberOfNames
;; NumberOfFunctions*4 RVA of Functions
;; NumberOfNames*4 RVA of Names
;; ModuleName
;; NumberOfFunctions times FunctionName
;
;	mov	ecx,[r8+1*4]		; number of functions
;	mov	r9,2020202020202020h	; mask to convert capitals to lowercase, doesn't hurt the dot character '.'
;	mov	rdi,[r8+rcx*8 + 2*4]
;	mov	esi,[r8+rcx*8 + 2*4 +8]
;	or	rdi,r9
;	or	sil,r9b
;	cmp	qword [string_ntdll_dll],rdi
;	jnz	scan_ntdll_DbgBreakPoint_L6	; if not ntdll.dll then go to next module
;	cmp	word [string_ntdll_dll+8],si	; check the last 'l' and the zero terminator
;	jnz	scan_ntdll_DbgBreakPoint_L6	; if not ntdll.dll then go to next module
;
;	mov	ecx,[r8+1*4]		; number of functions
;	xor	eax,eax			; counter starts from 0
;	lea	rdx,[r8+rcx*4 + 2*4]	; +2*4 skip dword size of allocated memory + dword NumberOfFunctions
;; rdx now points to RVA of Names
;
;AMDPad16
;scan_ntdll_DbgBreakPoint_L4:
;	mov	esi,[rdx+rax*4]		; RVA of name
;	add	rsi,r8
;	lea	rdi,[string_DbgBreakPoint]
;	mov	ecx,string_DbgBreakPoint_size
;	cld
;	repz cmpsb
;	jz	scan_ntdll_DbgBreakPoint_L8
;
;	inc	eax
;	cmp	[r8+1*4],eax		; NumberOfFunctions
;	jnbe	scan_ntdll_DbgBreakPoint_L4
;
;scan_ntdll_DbgBreakPoint_L6:
;	add	r11,8
;	dec	r10
;	jnz	scan_ntdll_DbgBreakPoint_L2
;
;	stc
;	jmp	scan_ntdll_DbgBreakPoint_L9
;
;scan_ntdll_DbgBreakPoint_L8:
;	mov	eax,[r8+4+4+rax*4]	; RVA of function
;	add	rax,[r11]		; add module base
;	clc
;scan_ntdll_DbgBreakPoint_L9:
;	pop	r11 r10 r9 r8 rdi rsi rbx rdx rcx
;	ret

;is_it_ntdll_dll:
;; in:  ECX = PID
;;      RDX = address
;; out: CF=0 the address belongs to the ntdll.dll (no check whether it belongs to code section, data, exports..., only check of the image memory)
;;      CF=1 address outside of ntdll.dll or even no such PID or such PID didn't load ntdll.dll yet (the last situation may happen only at very early during process creation)
;	push	rax rbx rbp rsi rdi r8 r9
;
;	mov	ebp,MaxNumberOfModulesInfo
;	mov	rsi,[module_info_address]
;	mov	r9,2020202020202020h		; mask to convert CAPITALS to lowercase, doesn't hurt the dot character '.'
;
;; module begin is qword [rsi]
;; module end is qword [rsi+8*MaxNumberOfModulesInfo], N.B. the last byte belonging to module is this value-1 (this value is the first byte after the last byte of module, e.g. the module is at 0000000200000000-0000000200003FFF and this value is 0000000200004000
;; pointer to module info is qword [rsi+16*MaxNumberOfModulesInfo]
;; PID is dword [rsi+24*MaxNumberOfModulesInfo]
;; flags is dword [rsi+24*MaxNumberOfModulesInfo + 4]
;
;AMDPad16
;is_it_ntdll_dll_L2:
;	cmp	[rsi+24*MaxNumberOfModulesInfo],ecx	; check matching PID (whether the DLL doesn't belong to different process when we are debugging more than 1 process)
;	jnz	is_it_ntdll_dll_L6
;; module belongs to PID
;
;	mov	rax,[rsi+16*MaxNumberOfModulesInfo]
;; module info, isn't it empty?
;	or	rax,rax
;	jz	is_it_ntdll_dll_L6			; if empty then go to next module
;
;; rax points now to the module_info structure
;; 0*4	dword size of allocated memory
;; 1*4	dword NumberOfFunctions=NumberOfNames
;; NumberOfFunctions*4 RVA of Functions
;; NumberOfNames*4 RVA of Names
;; ModuleName
;; NumberOfFunctions times FunctionName
;
;	mov	ebx,[rax+1*4]			; number of functions
;	mov	r8,[rax+rbx*8 + 2*4]		; grab first 8 bytes of module name
;	mov	edi,[rax+rbx*8 + 2*4 +8]	; graf bytes 9-10 of module name
;	or	r8,r9				; convert CAPITALS to lowercase, don't touch the dot character '.'
;	or	dil,r9b				; convert 9th char of name from CAPITAL to lowercase
;	cmp	qword [string_ntdll_dll],r8
;	jnz	is_it_ntdll_dll_L6	; if not ntdll.dll then go to next module
;	cmp	word [string_ntdll_dll+8],di	; check the last 'l' and the zero terminator
;	jnz	is_it_ntdll_dll_L6	; if not ntdll.dll then go to next module
;; it is ntdll.dll
;; N.B. the ntdll.dll is usually the second module (the first one is the executable image *.exe, then OS loads ntdll.dll so it is the second module belonging to PID
;
;; now we check whether the address is not outside of module memory
;
;	cmp	[rsi],rdx
;	jnbe	is_it_ntdll_dll_L6			; address below the module begin
;
;	cmp	[rsi+8*MaxNumberOfModulesInfo],rdx
;	jnbe	is_it_ntdll_dll_L8			; N.B. JNBE must be used, not JC because the value is 1 byte after the last byte of module, if the checked RDX value is the same as the value stored in module info then the RDX is after the module end
;
;is_it_ntdll_dll_L6:
;	add	rsi,8
;	dec	ebp
;	jnz	is_it_ntdll_dll_L2
;	stc
;
;is_it_ntdll_dll_L8:
;	pop	r9 r8 rdi rsi rbp rbx rax
;	ret
