; this antidebug is painful for reverser - it decrypts only one instruction to be executed and immediatelly after executing it it encrypts it back (this is done using single stepping = debug exceptions)
; debug exception #DB is trap type of exception so it is generated after any instruction execution while rflags.TF=1
; N.B. that #DB is not generated immediatelly after setting TF=1, the first one #DB is generated after the first instruction execution (not before the first instruction execution but after the first instruction execution)
; the instruction erasing trap flag causes the last #DB because TF was 1 before executing it
; this protection was very easy under 16-bit DOS and a lot of virii / kryptors use it widely
; it becomes more complicated to implement it under protected mode (primary process must run as a debugger, protected process doing single steps (#DB) runs as its child, debugger must emulate correct trap flag bit as ms win doesn't worry about it, accessing memory of child is not so easy as under DOS)
; in this sample only few instructions are encrypted so going throug this sample lasts only few minutes for skilled reverser
; you may encrypt several thousands of instructions which will cause headache for anybody reversing it
; if you have any idea (macro) how to generate labels for every instruction generating #DB let me know

; antidebug sample:
; the process runs itself for the second instance so 2 identical processes run
; the parent process becomes the debugger of the child process
; proof of concept of debug exception protection by single step

; what can we do with that?
; 1. Rambo -> IsDebuggerPresent fight must be set ON
; 2. it is possible to debug only parent process, the child process cannot be correctly debugged, because parent debug loop is responsible for decrypting child

; don't be worried, it is possible to debug both parent and child using HDBG which is a project where FDBG is ported to cooperate with hypervisor instead of calling operating system so HDBG is capable to debug simultaneously both parent and child.
; This is because HDBG driver has its own (its own = OS independent)
; - exception interception / handling (before OS is notified about exceptions) / injecting on demand
; - debug handlers (no need to call OS debug APIs, hdbg talks directly with hypervisor)
; - thread_context recording/modifying
; - process memory reading/writing
; - halting thread causing exception
; the above HDBG features allow to debug both parent and child simultaneously, so you are able to see the memory of the child process while parent is decrypting it


MaxProcesses			=	1000h
MaxThreads			=	1000h
if MaxProcesses > MaxThreads
it may work even it is impossible to have more processes than threads
redundant space MaxProcesses-MaxThreads won't be usefull
end if


include	'%fasminc%\win64a.inc'
include	'win64.inc'

format PE64 GUI at (1 shl 32) on 'nul'
entry start


section '.code' code readable executable writeable	; writeable for enabling self-modifying code

start:

a	=	0			; number of pushed qwords
b	=	4			; number of qwords reserved for API
c	=	6			; number of qwords for API params (CreateProcess uses 10 input params)
d	=	(sizeof.PROCESS_INFORMATION64+7)/8	; stack frame in qwords
e	=	(sizeof.STARTUPINFO64+7)/8
z	=	(a+b+c+d+e+1) and 1	; align stack 10h
	sub	rsp,8*(b+c+d+e+z)

virtual at rsp+(b+c)*8
ProcessInfo64	PROCESS_INFORMATION64
end virtual

virtual at rsp+(b+c+d)*8
StartupInfo64	STARTUPINFO64
end virtual

; We are going to create one new identical process.
; Both parent and child processes start at the same entrypoint.
; Parent will become the debugger of the child.
; We can differentiate between parent and child by a few methods:
; 1. Run the parent without any command line parameter and then run the child with some command line parameter and differentiate both after processing command line returned by GetCommandLineA.
; 2. Check IsDebuggerPresent API. If the return value=0 then it is the parent, if nonzero then it is the child.
; 3. Enumerating processes (the hardest way).
; 4. If every process owes its window, then we can use FindWindow (very easy to do). None of our processes have any windows, so we can't use this method.

; We use the choice No. 2.

	call	[IsDebuggerPresent]
; Return Value
; If the current process is running in the context of a debugger, the return value is nonzero.
; If the current process is not running in the context of a debugger, the return value is zero.
	or	eax,eax
	jnz	child

; hardcoded in win64:
; db 65h,48h,8Bh,04h,25h,30h,00h,00h,00h	gs mov	rax,[dword 30h]
; db 48h,8Bh,48h,60h				mov	rcx,[rax+60h]
; db 0Fh,0B6h,41h,02h				movzx eax,byte [rcx+02]

;	push	60h
;	pop	rax
;	mov	rax,[gs:rax]
;	cmp	byte [rax+2],0
;	jnz	child

; Even harder and less transparent way, we use a trick - pages are aligned at 1000h, so AL after mov eax,[fs:18h] is 0
;	push	60h
;	pop	rax
;	mov	rcx,[gs:rax]		; AL will be 0 after completing the instruction
;	cmp	[rcx+2],al
;	jnz	child

parent:
; Launch a second copy of the process (= the child), the parent will become the debugger of the child.

	lea	rcx,[StartupInfo64]
	mov	[rcx + STARTUPINFO64.cb],sizeof.STARTUPINFO64
	call	[GetStartupInfoA]

; Obtain our command line so we can launch ourselves again.
	call	[GetCommandLineA]
	push	rax
	pop	rdx

	lea	rax,[ProcessInfo64]
	lea	rcx,[StartupInfo64]
	mov	[rsp+8*(4+5)],rax	; lpProcessInformation 10th argument
	mov	[rsp+8*(4+4)],rcx	; lpStartupInfo 9th argument
	xor	r9,r9			; lpThreadAttributes 4th arg
	xor	ecx,ecx			; lpApplicationName 1st arg
	mov	[rsp+8*(4+3)],r9	; lpCurrentDirectory 8th arg
	mov	[rsp+8*(4+2)],r9	; lpEnvironment 7th arg
	mov	dword [rsp+8*(4+1)],DEBUG_PROCESS; or DEBUG_ONLY_THIS_PROCESS	; dwCreationFlags 6th arg
; DEBUG_ONLY_THIS_PROCESS If not set and the calling process is being debugged, the new process becomes another process being debugged by the calling process's debugger. If the calling process is not a process being debugged, no debugging-related actions occur.
	mov	[rsp+8*(4+0)],cl	; bInheritHandles 5th arg
	xor	r8,r8			; lpProcessAttributes 3rd arg
;	lea	rdx,[rdx]		; lpCommandLine 2nd arg
	call	[CreateProcessA]
	or	eax,eax
	jz	parent_epi		; We don't want to notify hackers about anything... so we just finish without any message.
					; Or is it better to say anything? The above API may fail in normal circumstances too (but extremely rarely).

	call	debug_loop

	mov	rcx,[ProcessInfo64.hThread]
	call	[CloseHandle]
	mov	rcx,[ProcessInfo64.hProcess]
	call	[CloseHandle]

parent_epi:
	add	rsp,8*(b+c+d+e+z)
	ret


align 10h
debug_loop:

a	=	1			; return address from procedure is currently qword [rsp]
	push	rbx rbp 0 0 1		; 1 is emulated trap flag falue, 0 is the last address used by single step protection, another 0 is counter for number of processes and threads
b	=	5			; number of pushed qwords

c	=	4			; number of qwords reserved for API
d	=	6			; space to call API with 10 input params
e	=	sizeof.DEBUG_EVENT64	; stack frame in bytes
f	=	(e+7)/8			; stack frame in qwords
g	=	(c+d+f) and 1		; align stack 10h, the CONTEXT64 requires to be aligned at dqword
h	=	sizeof.CONTEXT64
i	=	(h+7)/8
z	=	(a+b+c+d+f+g+i) and 1	; align stack 16
	sub	rsp,8*(c+d+f+g+i+z)

virtual at rsp+8*(c+d)
dbg_event	DEBUG_EVENT64
end virtual

virtual at rsp+8*(c+d+f+g)
Context64	CONTEXT64
end virtual

virtual at rsp+8*(c+d+f+g+i+z)
emulated_TF	db	?
		rb	7
last_DB		dq	?	; address of the last #DB (to encrypt back the instruction decrypted by the previous #DB, in the first run where the address is 0 nothing is encrypted back, at the last #DB the last instruction stays decrypted)
processes_count	dd	?	; it is already 0 thanks to push 0 there
threads_count	dd	?	; it is already 0 thanks to push 0 there
end virtual


align 10h
debug_loop_L0:

if INFINITE = -1
	or	edx,-1
else
	mov	edx,INFINITE
end if
	lea	rcx,[dbg_event]
	call	[WaitForDebugEvent]
; If the function succeeds, the return value is nonzero.
	or	eax,eax
	jz	debug_loop_epi

	mov	eax,[dbg_event.dwDebugEventCode]
	cmp	eax,number_of_DebugEvents
	jnc	debug_loop_epi		; latest RIP_EVENT = 9, but we are counting from 0
					; so we have 10 events, event No. 0 is undefined
	lea	rcx,[DebugEventProceduresTables]
	jmp	qword [rcx+rax*8]

ContinueDebug_DBG_CONTINUE:
	mov	r8d,DBG_CONTINUE
ContinueDebug_ContinueStatus:
	mov	edx,[dbg_event.dwThreadId]
	mov	ecx,[dbg_event.dwProcessId]
	call	[ContinueDebugEvent]
	or	eax,eax
	jz	debug_loop_epi

; Exit if there is no one process or no one thread left
	mov	eax,[processes_count]
	or	eax,eax
	jz	debug_loop_epi		; No one process? Then exit debug loop.
	mov	eax,[threads_count]
	or	eax,eax
	jnz	debug_loop_L0
; No one thread? Then exit debug loop.

;	xor	eax,eax			; exit code = 0 not necessary, eax=0 every time at this address

debug_loop_epi:
	add	rsp,8*(c+d+f+g+i+z+3)	; +3 for remove the push 0 0 1 at the prologue
	pop	rbp rbx
	ret

align 10h
Procedure_EXCEPTION_DEBUG_EVENT:
	cmp	[dbg_event.Exception.ExceptionRecord.ExceptionCode],EXCEPTION_SINGLE_STEP
;	jz	Procedure_EXCEPTION_SINGLE_STEP
;	jmp	ContinueDebug_DBG_CONTINUE
	jnz	ContinueDebug_DBG_CONTINUE

;align 10h
;Procedure_EXCEPTION_SINGLE_STEP:

; single step occured (as a result of trap_flag=1 or as a result of hitting debug register(s) breakpoint(s) or as a result of icebp instruction (int01)
; we can determine what happened by examining the DR6 (N.B. more than 1 of the 3 above ways may occure at the same time)

; see documentation about PID2hProcess, nonstandard input and output parameters
	mov	eax,[dbg_event.dwProcessId]
	call	PID2hProcess
	jc	Procedure_EXCEPTION_SINGLE_STEP_epi
	push	rdx
	pop	rbx
; rbx = hProcess

; see documentation about TID2hThread, nonstandard input and output parameters
	mov	eax,[dbg_event.dwThreadId]
	call	TID2hThread
	jc	Procedure_EXCEPTION_SINGLE_STEP_epi
	push	rdx
	pop	rbp
; rbp = hThread

	lea	rdx,[Context64]
	mov	[rdx+CONTEXT64.ContextFlags],CONTEXT_DEBUG_REGISTERS or CONTEXT_CONTROL
; N.B. while on windows 2008 server R2 x64 there is enough to read CONTEXT_DEBUG_REGISTERS, under windows 2003 server x64 both CONTEXT_DEBUG_REGISTERS + CONTEXT_CONTROL must be used to obtain debug registers correctly
	push	rbp
	pop	rcx
	call	[GetThreadContext]
; If the function succeeds, the return value is nonzero.
	or	eax,eax
	jz	Procedure_EXCEPTION_SINGLE_STEP_epi

;; check whether single step occured as a result of enabled flags.TF (Trap Flag)
;if DR6_BS > 7
;	test	byte [Context64.Dr6+1],1 shl (DR6_BS-8)
;	jz	Procedure_EXCEPTION_SINGLE_STEP_epi
;else
;	bt	[Context64.Dr6],DR6_BS
;	jnc	Procedure_EXCEPTION_SINGLE_STEP_epi
;end if
; we can't perform the above check because win64 (?for performance reason?) doesn't save debug registers if DR7 has empty some bits...
; lkd> u KiSaveDebugRegisterState
; nt!KiSaveDebugRegisterState:
; fffff800`0102ee00 654c8b0c2518000000 mov   r9,qword ptr gs:[18h]
; fffff800`0102ee09 0f21c0          mov     rax,dr0
; fffff800`0102ee0c 0f21ca          mov     rdx,dr1
; fffff800`0102ee0f 48894558        mov     qword ptr [rbp+58h],rax
; fffff800`0102ee13 48895560        mov     qword ptr [rbp+60h],rdx
; fffff800`0102ee17 0f21d0          mov     rax,dr2
; fffff800`0102ee1a 0f21da          mov     rdx,dr3
; fffff800`0102ee1d 48894568        mov     qword ptr [rbp+68h],rax
; lkd> u
; nt!KiSaveDebugRegisterState+0x21:
; fffff800`0102ee21 48895570        mov     qword ptr [rbp+70h],rdx
; fffff800`0102ee25 0f21f0          mov     rax,dr6
; fffff800`0102ee28 0f21fa          mov     rdx,dr7
; fffff800`0102ee2b 48894578        mov     qword ptr [rbp+78h],rax
; fffff800`0102ee2f 48899580000000  mov     qword ptr [rbp+80h],rdx
; fffff800`0102ee36 33c0            xor     eax,eax
; fffff800`0102ee38 0f23f8          mov     dr7,rax
; ...
; fffff800`0102eea5 6641f781080200005503 test word ptr [r9+208h],355h
; lkd> 
; nt!KiSaveDebugRegisterState+0xaf:
; fffff800`0102eeaf 746c            je      nt!KiSaveDebugRegisterState+0x11d (fffff800`0102ef1d)
; fffff800`0102eeb1 498b81e0010000  mov     rax,qword ptr [r9+1E0h]
; fffff800`0102eeb8 498b91e8010000  mov     rdx,qword ptr [r9+1E8h]
; fffff800`0102eebf 0f23c0          mov     dr0,rax
; fffff800`0102eec2 0f23ca          mov     dr1,rdx
; fffff800`0102eec5 498b81f0010000  mov     rax,qword ptr [r9+1F0h]
; fffff800`0102eecc 498b91f8010000  mov     rdx,qword ptr [r9+1F8h]
; fffff800`0102eed3 0f23d0          mov     dr2,rax
; lkd> u
; nt!KiSaveDebugRegisterState+0xd6:
; fffff800`0102eed6 0f23da          mov     dr3,rdx
; fffff800`0102eed9 498b9108020000  mov     rdx,qword ptr [r9+208h]
; fffff800`0102eee0 33c0            xor     eax,eax
; fffff800`0102eee2 0f23f0          mov     dr6,rax
; fffff800`0102eee5 0f23fa          mov     dr7,rdx
; ...
; fffff800`0102ef1d c3              ret


; encrypt back the instruction which already executed
	mov	rdx,[last_DB]
	or	rdx,rdx
	jz	Procedure_EXCEPTION_SINGLE_STEP_L3	; do not enctypt back nothing at the first round (nothing to encrypt back because nothing was decrypted yet)

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax	; lpNumberOfBytesRead	address of number of bytes read
	mov	r9d,1			; nSize			number of bytes to read
	lea	r8,[rsp+8*(4+2)]	; lpBuffer		address of buffer to place read data
;	mov	rdx,rdx			; lpBaseAddress		address to start reading
	push	rbx
	pop	rcx			; hProcess		handle of the process whose memory is read
	call	[ReadProcessMemory]
; If the function succeeds, the return value is nonzero.
; If the function fails, the return value is zero.
	or	eax,eax
	jz	Procedure_EXCEPTION_SINGLE_STEP_L3
; second check, 1 byte had to be read
	cmp	dword [rsp+8*(4+1)],1
	jnz	Procedure_EXCEPTION_SINGLE_STEP_L3

; simple encryptor - encrypt the byte by the XOR it with its offset (low 8 bits of its offset)
	mov	al,byte [last_DB]
	xor	[rsp+8*(4+2)],al

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax	; lpNumberOfBytesWritten actual number of bytes written
	mov	r9d,1			; nSize			number of bytes to write
	lea	r8,[rsp+8*(4+2)]	; lpBuffer		pointer to buffer to write data to (address of buffer for writing a memory of the child, it holds the new dword to be replaced at the old value of the dword)
	mov	rdx,[last_DB]		; lpBaseAddress		address to start writing to
	push	rbx
	pop	rcx			; hProcess		handle to process whose memory is written to
	call	[WriteProcessMemory]
; If the function succeeds, the return value is nonzero.
; If the function fails, the return value is zero.
	or	eax,eax
	jz	Procedure_EXCEPTION_SINGLE_STEP_L3
; second check, 1 byte had to be written
	cmp	dword [rsp+8*(4+1)],1
	jnz	Procedure_EXCEPTION_SINGLE_STEP_L3

; check whether the instruction which caused current #DB was the POPF instruction trying to erase trap flag (popf instruction with bit 8. at RSP set to 0)
	mov	al,byte [last_DB]
	xor	al,[rsp+8*(4+2)]
	rol	al,1
	cmp	al,((9Dh shl 1) and 0FFh) or (9Dh shr (8-1))	; 9Dh rol 1		; popf instruction ?
	jnz	Procedure_EXCEPTION_SINGLE_STEP_L3

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax	; lpNumberOfBytesRead	address of number of bytes read
	mov	r9d,8			; nSize			number of bytes to read
	lea	r8,[rsp+8*(4+2)]	; lpBuffer		address of buffer to place read data
	mov	rdx,[Context64.Rsp]	; lpBaseAddress		address to start reading
	push	rbx
	pop	rcx			; hProcess		handle of the process whose memory is read
	call	[ReadProcessMemory]
; If the function succeeds, the return value is nonzero.
; If the function fails, the return value is zero.
	or	eax,eax
	jz	Procedure_EXCEPTION_SINGLE_STEP_L3
; second check, 8 bytes had to be read
	cmp	dword [rsp+8*(4+1)],8
	jnz	Procedure_EXCEPTION_SINGLE_STEP_L3

; bit 8. of [rsp+8*(4+2)] holds now the TF bit going to be poped into rflags
; [emulated_TF] contains only values 0, 1 so we can do everything using simple AND operation
	mov	al,byte [rsp+8*(4+2)+1]
	and	[emulated_TF],al
; the new [emulated_TF] will be used at the instruction beeing to execute
; this enables execution of the last single step exception on popf instruction itself

Procedure_EXCEPTION_SINGLE_STEP_L3:

	lea	rdx,[Context64]
;	mov	[rdx+CONTEXT64.ContextFlags],CONTEXT_DEBUG_REGISTERS or CONTEXT_CONTROL
	mov	[rdx+CONTEXT64.ContextFlags],CONTEXT_CONTROL
;; clear DR6 register
;	and	[rdx+CONTEXT64.Dr6],not ( (1 shl DR6_BS) + (1 shl DR6_BD) + (1 shl DR6_B3) + (1 shl DR6_B2) + (1 shl DR6_B1) + (1 shl DR6_B0) )
; N.B. the trap flag was erased by CPU when transfering the execution from program causing #DB to #DB exception handler
; the trap flag had to be erased at the time to prevent #DB exception handler from generating #DB every instruction it executes
; so we must enable trap flag and let single stepping continue
	mov	al,[emulated_TF]
	or	byte [rdx+CONTEXT64.EFlags+1],al
	push	rbp
	pop	rcx
	call	[SetThreadContext]
; If the function succeeds, the return value is nonzero.
	or	eax,eax
	jz	Procedure_EXCEPTION_SINGLE_STEP_epi


	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax	; lpNumberOfBytesRead	address of number of bytes read
	mov	r9d,1			; nSize			number of bytes to read
	lea	r8,[rsp+8*(4+2)]	; lpBuffer		address of buffer to place read data
	mov	rdx,[dbg_event.Exception.ExceptionRecord.ExceptionAddress]; lpBaseAddress		address to start reading
	push	rbx
	pop	rcx			; hProcess		handle of the process whose memory is read
	call	[ReadProcessMemory]
; If the function succeeds, the return value is nonzero.
; If the function fails, the return value is zero.
	or	eax,eax
	jz	Procedure_EXCEPTION_SINGLE_STEP_epi
; second check, 1 byte had to be read
	cmp	dword [rsp+8*(4+1)],1
	jnz	Procedure_EXCEPTION_SINGLE_STEP_epi

; simple decryptor - decrypt the byte by the XOR it with its offset (low 8 bits of its offset)
	mov	al,byte [dbg_event.Exception.ExceptionRecord.ExceptionAddress]
	xor	[rsp+8*(4+2)],al

	lea	rax,[rsp+8*(4+1)]
	mov	[rsp+8*(4+0)],rax	; lpNumberOfBytesWritten actual number of bytes written
	mov	r9d,1			; nSize			number of bytes to write
	lea	r8,[rsp+8*(4+2)]	; lpBuffer		pointer to buffer to write data to (address of buffer for writing a memory of the child, it holds the new dword to be replaced at the old value of the dword)
	mov	rdx,[dbg_event.Exception.ExceptionRecord.ExceptionAddress] ; lpBaseAddress		address to start writing to

	mov	[last_DB],rdx		; this instruction will be encoded back at the next #DB

	push	rbx
	pop	rcx			; hProcess		handle to process whose memory is written to
	call	[WriteProcessMemory]
; If the function succeeds, the return value is nonzero.
; If the function fails, the return value is zero.
	or	eax,eax
	jz	Procedure_EXCEPTION_SINGLE_STEP_epi
; second check, 1 byte had to be written
	cmp	dword [rsp+8*(4+1)],1
	jnz	Procedure_EXCEPTION_SINGLE_STEP_epi

Procedure_EXCEPTION_SINGLE_STEP_epi:
	jmp	ContinueDebug_DBG_CONTINUE


align 10h
Procedure_CREATE_THREAD_DEBUG_EVENT:
	inc	[threads_count]
	mov	eax,[dbg_event.dwThreadId]
	mov	rdx,[dbg_event.CreateThread.hThread]
	call	store_TID_handle
	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	store_PID_TID_pair
	jmp	ContinueDebug_DBG_CONTINUE

align 10h
Procedure_CREATE_PROCESS_DEBUG_EVENT:
	inc	[processes_count]
	inc	[threads_count]
	mov	eax,[dbg_event.dwProcessId]
	mov	rdx,[dbg_event.CreateProcess.hProcess]
	call	store_PID_handle
	mov	eax,[dbg_event.dwThreadId]
	mov	rdx,[dbg_event.CreateProcess.hThread]
	call	store_TID_handle
	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	store_PID_TID_pair
; hFile When the debugger is finished with this file, it should close the handle using the CloseHandle function.
	mov	rcx,[dbg_event.CreateProcess.hFile]
	jrcxz	Procedure_CREATE_PROCESS_DEBUG_EVENT_end
	call	[CloseHandle]
Procedure_CREATE_PROCESS_DEBUG_EVENT_end:
	jmp	ContinueDebug_DBG_CONTINUE

align 10h
Procedure_EXIT_THREAD_DEBUG_EVENT:
	dec	[threads_count]
	mov	eax,[dbg_event.dwThreadId]
	call	remove_TID_handle
	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	remove_PID_TID_pair
	jmp	ContinueDebug_DBG_CONTINUE

align 10h
Procedure_EXIT_PROCESS_DEBUG_EVENT:
	dec	[processes_count]
	dec	[threads_count]
	mov	eax,[dbg_event.dwProcessId]
	call	remove_PID_handle
	mov	eax,[dbg_event.dwThreadId]
	call	remove_TID_handle
	mov	eax,[dbg_event.dwProcessId]
	mov	edx,[dbg_event.dwThreadId]
	call	remove_PID_TID_pair
	jmp	ContinueDebug_DBG_CONTINUE

align 10h
Procedure_LOAD_DLL_DEBUG_EVENT:
; hFile When the debugger is finished with this file, it should close the handle using the CloseHandle function.
	mov	rcx,[dbg_event.LoadDll.hFile]
	jrcxz	Procedure_LOAD_DLL_DEBUG_EVENT_end
	call	[CloseHandle]
Procedure_LOAD_DLL_DEBUG_EVENT_end:


;	jmp	ContinueDebug_DBG_CONTINUE

align 10h
Procedure_UNLOAD_DLL_DEBUG_EVENT:
;	jmp	ContinueDebug_DBG_CONTINUE

align 10h
Procedure_OUTPUT_DEBUG_STRING_EVENT:
;	jmp	ContinueDebug_DBG_CONTINUE

align 10h
Procedure_RIP_EVENT:
;	jmp	ContinueDebug_DBG_CONTINUE

align 10h
Procedure_none:
	jmp	ContinueDebug_DBG_CONTINUE

align 10h
store_PID_handle:
; input: RAX ProcessID RDX ProcessHandle
	push	rdi rcx rax
	lea	rdi,[proc_thrd_data.proc_handle]
	xor	eax,eax
	mov	ecx,MaxProcesses
	cld
	repnz scasq
	stc
	jnz	store_PID_handle_end
	mov	rax,[rsp+8*0]
	mov	[rdi-8],rax
	mov	[rdi-8 + MaxProcesses*8],rdx
	clc
store_PID_handle_end:
	pop	rax rcx rdi
	ret

align 10h
remove_PID_handle:
	push	rdi rcx
	lea	rdi,[proc_thrd_data.proc_handle]
	mov	ecx,MaxProcesses
	cld
	repnz scasq
	stc
	jnz	remove_PID_handle_end
	xor	ecx,ecx
	mov	[rdi-8],rcx
	mov	[rdi-8 + MaxProcesses*8],rcx
	clc
remove_PID_handle_end:
	pop	rcx rdi
	ret

align 10h
store_TID_handle:
; in:	RAX ThreadID
;	RDX ThreadHandle
	push	rdi rcx rax
	lea	rdi,[proc_thrd_data.thrd_handle]
	xor	eax,eax
	mov	ecx,MaxThreads
	cld
	repnz scasq
	stc
	jnz	store_TID_handle_end
	mov	rax,[rsp+8*0]
	mov	[rdi-8],rax
	mov	[rdi-8 + MaxThreads*8],rdx
	clc
store_TID_handle_end:
	pop	rax rcx rdi
	ret

align 10h
remove_TID_handle:
	push	rdi rcx
	lea	rdi,[proc_thrd_data.thrd_handle]
	mov	ecx,MaxThreads
	cld
	repnz scasq
	stc
	jnz	remove_TID_handle_end
	xor	ecx,ecx
	mov	[rdi-8],rcx
	mov	[rdi-8 + MaxThreads*8],rcx
	clc
remove_TID_handle_end:
	pop	rcx rdi
	ret

align 10h
store_PID_TID_pair:
; in:	EAX ProcessID
;	EDX ThreadId
	push	rdi rcx rax
	lea	rdi,[proc_thrd_data.pid_tid]
	xor	eax,eax
a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
	mov	ecx,a
	cld
	repnz scasd
	stc
	jnz	store_PID_TID_pair_end
	mov	eax,[rsp+8*0]
	mov	[rdi-4],eax
	mov	[rdi-4 + a*4],edx
	clc
store_PID_TID_pair_end:
	pop	rax rcx rdi
	ret

align 10h
remove_PID_TID_pair:
; in:	EAX ProcessID
;	EDX ThreadId
; it is easier to scan TIDs because the same PID should have more TIDs, but every TID is unique
	push	rdi rcx
	lea	rdi,[proc_thrd_data.pid_tid + a*4]
	xchg	edx,eax
	mov	ecx,MaxThreads
	cld
	repnz scasd
	stc
	jnz	remove_PID_TID_pair_end
	cmp	[rdi-4 - a*4],edx
	stc
	jnz	remove_PID_TID_pair_end
	xor	ecx,ecx
	mov	[rdi-4],ecx
	mov	[rdi-4 - a*4],ecx
	clc
remove_PID_TID_pair_end:
	xchg	edx,eax
	pop	rcx rdi
	ret

align 4
PID2hProcess:
; in:	EAX ProcessId
; out:	RDX hProcess
; note, this can be done by kernel32.OpenProcess, but then we need extra CloseHandle...
; note, invert operation is kernel32.GetProcessId
	push	rdi rcx
	lea	rdi,[proc_thrd_data.proc_handle]
	mov	ecx,MaxProcesses
	cld
	repnz scasq
	stc
	jnz	PID2hProcess_end
	mov	rdx,[rdi-8 + MaxProcesses*8]
	clc
PID2hProcess_end:
	pop	rcx rdi
	ret

align 4
TID2hThread:
; in:	EAX ThreadId
; out:	RDX hThread
; note, this can be done by kernel32.OpenThread, but then we need extra CloseHandle...
; note, invert operation is kernel32.GetThreadId
; The GetThreadId function retrieves the thread identifier of the specified thread.
;
; DWORD GetThreadId(
;   HANDLE Thread
; );
;
; Parameters:
; Thread 
; [in] Handle to the thread. The handle must have the THREAD_QUERY_INFORMATION access right. For more ; information about access rights, see Thread Security and Access Rights. 
; Return Values:
; If the function succeeds, the return value is the thread identifier of the specified thread.
; If the function fails, the return value is zero. To get extended error information, call GetLastError.

	push	rdi rcx
	lea	rdi,[proc_thrd_data.thrd_handle]
	mov	ecx,MaxThreads
	cld
	repnz scasq
	stc
	jnz	TID2hThread_end
	mov	rdx,[rdi-8 + MaxThreads*8]
	clc
TID2hThread_end:
	pop	rcx rdi
	ret

; +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

align 10h
child:
	mov	dword [rsp+8*(4+1)],FILE_ATTRIBUTE_NORMAL
	mov	dword [rsp+8*(4+0)],CREATE_ALWAYS
	xor	r9,r9
	xor	r8,r8
	mov	edx,GENERIC_WRITE
	lea	rcx,[filename]
	mov	[rsp+8*(4+2)],r9	;	and	qword [rsp+8*(4+2)],0
	call	[CreateFileA]
	mov	[rsp+8*(4+3)],rax

if INVALID_HANDLE_VALUE = -1
	inc	rax
else
	cmp	rax,INVALID_HANDLE_VALUE
end if
	jz	child_epi

; unlike the previous version a0C.asm where we needed to create new thread to modify its debug registers (the thread had not to run at the time of modifying its registers !!!), now we can modify trap flag quite easily on the fly (without any necessity of creating new not running thread)

	pushf
	or	byte [rsp+1],1
	popf
; now rflags.TF=1 and executing every instruction leads into #DB
; so the first #DB is generated after the following instruction executes (so the address is the begin of the second following instruction = debug1)
; ...
; the last #DB is generated after the instruction which erases trap flag completes (after the popf instruction completes, so the address is at debug8)


	and	qword [rsp+8*(4+0)],0
debug1:

	lea	r9,[rsp+8*(4+1)]
debug2:

	mov	r8d,filesize
debug3:

	lea	rdx,[filecontent]
debug4:

	mov	rcx,[rsp+8*(4+3)]
debug5:

	pushf
debug6:

	and	byte [rsp+1],not 1
debug7:

	popf
debug8:

	call	[WriteFile]
;	or	eax,eax
;	jz	child_close
;	cmp	dword [rsp+8*(4+1)],filesize
;	jnz	child_close

; xor r9,r9
; xor r8,r8
; lea rdx,[msg_success]
; xor ecx,ecx
; call [MessageBoxA]

child_close:
	mov	rcx,[rsp+8*(4+3)]
	call	[CloseHandle]

child_epi:
	jmp	parent_epi


filename	db	'dement.txt',0

filecontent	db	'you were too slow, some files could alredy be infected'
filesize	=	$ - filecontent




; simple cryptor which does the XOR of the byte with its offset (N.B. the offset must be truncated to 8 bit value by the AND 0FFh)
rept 8 n
{
load a byte from debug#n
store byte (a xor (debug#n and 0FFh)) at debug#n
}
; you may also encrypt e.g. dword by:
; load a dword .....
; store dword (a xor .....


section '.data' readable writeable
DebugEventProceduresTables:
			dq	Procedure_none
			dq	Procedure_EXCEPTION_DEBUG_EVENT
			dq	Procedure_CREATE_THREAD_DEBUG_EVENT
			dq	Procedure_CREATE_PROCESS_DEBUG_EVENT
			dq	Procedure_EXIT_THREAD_DEBUG_EVENT
			dq	Procedure_EXIT_PROCESS_DEBUG_EVENT
			dq	Procedure_LOAD_DLL_DEBUG_EVENT
			dq	Procedure_UNLOAD_DLL_DEBUG_EVENT
			dq	Procedure_OUTPUT_DEBUG_STRING_EVENT
			dq	Procedure_RIP_EVENT
number_of_DebugEvents	=	($ - DebugEventProceduresTables)/8
times (EXCEPTION_MAXIMUM_PARAMETERS - RIP_EVENT) dq Procedure_none


a = MaxThreads
if a < MaxProcesses
a = MaxProcesses
end if
proc_thrd_data:
.proc_handle		rq	MaxProcesses*2	; store PID...hProcess
.thrd_handle		rq	MaxThreads*2	; TID...hThread
.pid_tid		rd	a*2		; PID...TID


section '.idata' import data readable writeable
			dd	0,0,0,	RVA kernel_name,	RVA kernel_table
;			dd	0,0,0,	RVA user_name,		RVA user_table
			dd	0,0,0,	0,			0

align 8		; to keep import addresses aligned at 8 (may improve performance a bit)
kernel_table:
CloseHandle		dq	RVA _CloseHandle
ContinueDebugEvent	dq	RVA _ContinueDebugEvent
CreateFileA		dq	RVA _CreateFileA
CreateProcessA		dq	RVA _CreateProcessA
GetCommandLineA		dq	RVA _GetCommandLineA
GetStartupInfoA		dq	RVA _GetStartupInfoA
GetThreadContext	dq	RVA _GetThreadContext
IsDebuggerPresent	dq	RVA _IsDebuggerPresent
ReadProcessMemory	dq	RVA _ReadProcessMemory
SetThreadContext	dq	RVA _SetThreadContext
WaitForDebugEvent	dq	RVA _WaitForDebugEvent
WaitForSingleObject	dq	RVA _WaitForSingleObject
WriteFile		dq	RVA _WriteFile
WriteProcessMemory	dq	RVA _WriteProcessMemory
			dq	0

;user_table:
;MessageBoxA		dq	RVA _MessageBoxA
;			dq	0

; kernel32.dll
_CloseHandle		db	0,0,'CloseHandle',0
_ContinueDebugEvent	db	0,0,'ContinueDebugEvent',0
_CreateFileA		db	0,0,'CreateFileA',0
_CreateProcessA		db	0,0,'CreateProcessA',0
_GetCommandLineA	db	0,0,'GetCommandLineA',0
_GetStartupInfoA	db	0,0,'GetStartupInfoA',0
_GetThreadContext	db	0,0,'GetThreadContext',0
_IsDebuggerPresent	db	0,0,'IsDebuggerPresent',0
_ReadProcessMemory	db	0,0,'ReadProcessMemory',0
_SetThreadContext	db	0,0,'SetThreadContext',0
_WaitForDebugEvent	db	0,0,'WaitForDebugEvent',0
_WaitForSingleObject	db	0,0,'WaitForSingleObject',0
_WriteFile		db	0,0,'WriteFile',0
_WriteProcessMemory	db	0,0,'WriteProcessMemory',0
;; user32.dll
;_MessageBoxA		db	0,0,'MessageBoxA',0

kernel_name		db	'KERNEL32.DLL',0
;user_name		db	'USER32.DLL',0
